﻿(function(window, document){
	
	window.webAppCore = new webAppCore();
	
	window.addEventListener("load",notifyURL,false);
	window.addEventListener("unload",function() {
        resetMenu();
        resetToolbar();
        parent.clearTitleOptions();
        parent.setTitleVisible(false);
    },false);
	window.addEventListener("load",setBaseURL,false);
	
	var themeColor = "#5599ee";
	var themeFore = "#ffffff";

	var facebookStatusListener = null;

	var titleOptionListener = null;
    var nativeListListener = null;
    var premiumUpgradedListener = null;

    var newMenuHolder = {};
    var newToolbarHolder = {};

    var socket;
	
	function webAppCore() {

	    // Web App Core v3.5.0 Links
	    this.getWacVersion = getWacVersion;
	    this.playMidi = playMidi;
        this.stopMidi = stopMidi;
        this.midiCallbackListener = midiCallbackListener;
        this.setRelaunchListener = setRelaunchListener;
        this.setMenuPressedListener = setMenuPressedListener;
        this.revieveMenuPress = revieveMenuPress;
        this.supportsShortcut = supportsShortcut;
        this.createShortcut = createShortcut;
        this.supportsRingtone = supportsRingtone;
        this.setRingtone = setRingtone;
        this.playAudio = playAudio;
        this.stopAudio = stopAudio;
        this.audioInstanceCallbackListener = audioInstanceCallbackListener;
        this.playRewardedVideo = playRewardedVideo;
        this.rewardedVideoDone = rewardedVideoDone;
        this.nativeGetBack = nativeGetBack;

	    // Web App Core v3.4.0 Links
        this.showDialog = showDialog;
        this.showSplash = showSplash;
        this.toastBack = toastBack;
        this.socketConnect = socketConnect;
        this.addSocketListener = addSocketListener;
        this.getPlatform = getPlatform;
        this.setTitleSubtitle = setTitleSubtitle;
        this.setPremiumOptionText = setPremiumOptionText;
        this.setBrandingLogo = setBrandingLogo;
        this.fadeTitle = fadeTitle;
        this.socketEmit = socketEmit;
        this.getFacebookLoginStatus = getFacebookLoginStatus;
        this.getFacebookCredentials = getFacebookCredentials;
        this.requestFacebookLogin = requestFacebookLogin;
        this.setFacebookStatusListener = setFacebookStatusListener;
        this.onFacebookStatusChanged = onFacebookStatusChanged;
        this.buildCloudSharePathForFile = buildCloudSharePathForFile;
        this.loadSharedCloudFile = loadSharedCloudFile;

	    // Web App Core v3.3 Links
        this.setTitleVisible = parent.setTitleVisible;
        this.setTitleBackground = parent.setTitleBackground;
        this.setTitleLogo = parent.setTitleLogo;
        this.addTitleOption = parent.addTitleOption;
        this.setTitleOptionListener = setTitleOptionListener
        this.titleOptionSelected = titleOptionSelected;
        this.resetTitle = parent.clearTitleOptions;
        this.presentNativeList = presentNativeList;
        this.nativeListOptionSelected = nativeListOptionSelected;
        this.getIsPremium = getIsPremium;
        this.presentPremium = parent.goPremium;
        this.setOnPremiumListener = setOnPremiumListener;
        this.onPremiumUpgraded = onPremiumUpgraded;
        this.getForResult = getForResult;

		// Web App Core v3.2 Links
		this.setOnImageImportListener = handleImageImportFunction;
		this.importImage = importImage;
		this.sendImage = sendImage;
	
		// Web App Core v3.1 Links
		this.addToolbarOption = addToolbarOption;
		this.executeToolbarFunction = executeToolbarFunction;
		this.clearMenu = resetMenu;
		this.clearToolbar = resetToolbar;
		this.toggleToolbar = toggleToolbar;
		this.setTitle = setTitle;
		this.importFile = importFile;
		this.fileImportComplete = null;
		this.exportFile = exportFile;
		this.sendFile = sendFile;
		this.copyToClipboard = copyToClipboard;
		this.getInterface = getInterface;
		this.isTV = isTV;
		this.printText = printText;
		this.printHTML = printHTML;
		this.changeWorkspace = changeWorkspace;
		this.startApp = startApp;
		this.recieveVariablePackage = recieveVariablePackage;
		this.registerForShake = registerForShake;
		this.checkForLaunchFile = checkForLaunchFile;
		this.getLaunchFileName = getLaunchFileName;
		this.getLaunchFileContent = getLaunchFileContent;
		this.saveLaunchFile = saveLaunchFile;

		this.picImportCallbackHook = doImageCallback;
		
		this.say = doTTS;
			
		this.clearSplash = clearSplash;
		this.showAlert = showAlert;
		this.vibrate = vibrate;
		this.endVibrate = endVibrate;
		this.saveScreenshot = saveScreenshot;
		this.showChoice = showChoice;
		this.showToast = showToast;
		this.playSoundEffect = playSoundEffect;
		this.loopAudio = loopAudio;
		this.stopLoop = stopLoop;
		this.storeVar = storeVar;
		this.getVars = getVars;
		this.loadFeature = parent.fetchFeaturedImage;
		this.goBack = goBack;
		this.navigateTo = navigateTo;
		this.externalURL = externalURL;
		this.getVar = getVar;
		this.getString = getString;
		this.nativeShare = nativeShare;
		this.handleBackFunction = handleBackFunction;
		this.handlePauseFunction = handlePauseFunction;
		this.handleResumeFunction = handleResumeFunction;
		this.toggleMenu = toggleMenu;
		this.addMenuOption = addMenuOption;
		this.inputBox = inputBox;
		this.submitHighScore = submitHighScore;
		this.getHighScoresUsername = getHighScoresUsername;

		this.getDailyTopScore = getDailyTopScore;
		this.getNewsHeadline = parent.getNewsfeed;

		this.setGamepadFunctions = setGamepadFunctions;
		this.handleInput = handleInput;
		this.executeMenuFunction = executeMenuFunction;
		this.showInterstitial = showInterstitial;
		this.logEvent = logEvent;
		this.setTheme = setTheme;
		this.getExternalParm = getExternalParm;
		this.setMenuOpen = setMenuOpen;
		this.postForResult = postForResult;
		this.showAlertWithTitle = showAlertWithTitle;
		this.choice1 = null;
		this.choice2 = null;
		this.colorSelected = null;
		this.pickColor = pickColor;
		this.inputReturn = null;
		this.pendingScoreFunction = null;
		this.getDailyTopScore = getDailyTopScore;
		this.setDailyReadout = setDailyReadout;
		this.showScores = showScores;
		this.showAchievements = showAchievements;
		this.reportAchievement = reportAchievement;
		this.onPause = onPause;
		this.onResume = onResume;
		this.onBack = onBack;
		
		this.recieveGamepadDown = recieveGamepadDown;
		this.recieveGamepadUp = recieveGamepadUp;
		
		this.pauseFunction = null;
		this.resumeFunction = null;
		this.externalParm = null;
		this.backFunction = null;
		
		
		this.fileDeleted = null;
		this.listingLoaded = null;
		this.fileLoaded = null;
		this.fileSaveComplete = null;
		this.resultFunction = null;
		this.fileImported = null;
		this.workspaceChanged = null;
		this.appStarted = null;
		this.varPackage = null;
		this.shakeCallback = null;
		this.launchCheckCallback = null;
		this.launchNameCallback = null;
		this.launchContentCallback = null;
		this.imageImportFunction = null;
		
		this.openFile = openFile;
		this.openListing = openListing;
		this.deleteFile = deleteFile;
		this.saveFile = saveFile;
		
		this.placeholder = placeholder;
	}

	function buildCloudSharePathForFile(filename) {
	    var cloudURL = "share/" + Android.getFacebookLoggedId() + "/" + Android.getApeMarketId() + "/" + encodeURIComponent(filename);
        return cloudURL;
    }

    function loadSharedCloudFile(path,callback) {
        var cloudRequestUrl = "https://cloud.ape-apps.com:2728/" + path;
        dataRequest(cloudRequestUrl,callback,null,false);
    }

	function doImageCallback(data) {
	    tmpImageImportCallback(data);
	}

	var tmpImageImportCallback;

	function sendImage(element) {
        // do something else on other platforms perhaps
        parent.shareImage(element);
    }

    function importImage(callback) {
        if(callback) {
            tmpImageImportCallback = callback;
        } else {
            if(imageImportFunction) {
                tmpImageImportCallback = imageImportFunction;
            } else {
                return;
            }
        }

        Android.pickImage();

    }

	function handleImageImportFunction(func) {
        imageImportFunction = func;
    }

	function notifyURL() {
		parent.notifyURL(window.location.href);

		document.body.style.webkitTapHighlightColor = "transparent";

		console.log("notified url");
	}
	
	function closeOrConfirmAlert(button) {
		return parent.closeOrConfirmAlert(button);
	}
	
	function placeholder() {
		//fsdf
	}
	
	var tmpSaveName;
	var tmpSaveContent;

	function openListing(retfun) {
		this.listingLoaded = retfun;
		parent.getFiles();
	}

	function doTTS(text) {
		parent.doTTS(text);
	}
	
	var screenData;
	
	function showAchievements() {
		parent.showAchievements();
	}
	
	function reportAchievement(trophy,increment) {
		parent.reportAchievement(trophy,increment);
	}

	function postForResult(url,data,func) {
		if(func == null) {
		    func = placeholder;
		}

		dataRequest(url,func,data,true);
	}
	
	function setMenuOpen(status) {
		menuOpen = status;
	}
	
	function getExternalParm() {
		return Android.getExternalParameter();
	}
	
	function setTheme(color) {
		parent.setTheme(color);
		themeColor = color;
	}

	function logEvent(category,action,label) {
		parent.logEvent(category,action,label);
	}
	
	function showInterstitial() {
		Android.popInterstitial(false);
	}
	
	var menuNameArray = new Array();
	var menuFunctionArray = new Array();
	var menuTagArray = new Array();
	menuFunctionCount = 0;
	
	function resetMenu() {
		newMenuHolder = {};
		parent.resetCustomMenu();
	}

	var useTagId = 0;
	
	function addMenuOption(name,func,icon,color,tag) {

		useTagId++;

		newMenuHolder[useTagId.toString()] = {
            name: name,
            tag: tag,
            func: func
        };

		parent.addMenuOption(name,icon,color,useTagId.toString());
	}
	
	function executeMenuFunction(name,tag) {

	    if(newMenuHolder == null || newMenuHolder[tag] == null) {
	        return;
	    }

	    var item = newMenuHolder[tag];

	    console.log(item.func);

	    window[item.func](item.name,item.tag);
	}
	
	function toggleMenu() {
		parent.toggleMenu();
	}
	
	var gamepadDownFunction;
	var gamepadUpFunction;
	var menuOpen = false;
	
	function handleInput(object,downFunction,moveFunction,endFunction) {
		
		if (window.PointerEvent) {
            object.touchAction = "none";
            object.contentZooming = "none";
            object.msTouchAction = "none";
            object.msContentZooming = "none";

            object.style.touchAction = "none";

            object.addEventListener("pointerdown", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                var pressure = 1;

                if (event.pressure) {
                    pressure = event.pressure;
                }

                if(pointerType == "touch" || pointerType == "mouse") {
                    pressure = 1;
                }

                downFunction(object, pointerId, event.pageX, event.pageY, pointerType, pressure);
                return false;
            },false);

            object.addEventListener("pointermove", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                var pressure = 1;

                if (event.pressure) {
                    pressure = event.pressure;
                }

                if(pointerType == "touch" || pointerType == "mouse") {
                    pressure = 1;
                }

                moveFunction(object, pointerId, event.pageX, event.pageY, pointerType, pressure);
                return false;
            },false);


            object.addEventListener("pointerout", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                endFunction(object, pointerId, pointerType);
                return false;
            },false);

            object.addEventListener("pointerup", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                endFunction(object, pointerId, pointerType);
                return false;
            },false);
        } else {
            object.addEventListener("touchstart",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    downFunction(object,event.changedTouches[i].identifier,event.changedTouches[i].pageX,event.changedTouches[i].pageY,"touch");
                }
                return false;
            },false);

            object.addEventListener("touchmove",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    moveFunction(object,event.changedTouches[i].identifier,event.changedTouches[i].pageX,event.changedTouches[i].pageY,"touch");
                }

                return false;
            },false);

            object.addEventListener("touchend",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    endFunction(object,event.changedTouches[i].identifier,"touch");
                }

                return false;
            },false);

            object.addEventListener("touchleave",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    endFunction(object,event.changedTouches[i].identifier,"touch");
                }
                return false;
            },false);

            object.addEventListener("touchcancel",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    endFunction(object,event.changedTouches[i].identifier,"touch");
                }
                return false;
            },false);
        }


	}

	function eventCancel(event) {
	    if(!event) {
	        if(window.event) {
	            event = window.event;
	        } else {
	            return false;
	        }
	    }

	    if(event.cancelBubble != null) {
	        event.cancelBubble = true;
	    }

	    if(event.stopPropagation) {
	        event.stopPropagation();
	    }

	    if(event.preventDefault) {
	        event.preventDefault();
	    }

	    if(window.event) {
	        event.returnValue = false;
	    }

	    if(event.cancel != null) {
	        event.cancel = true;
	    }

	    return false;
	}
	
	function setGamepadFunctions(down,up) {
		gamepadDownFunction = down;
		gamepadUpFunction = up;
	}
	
	function recieveGamepadDown(button,id) {
		
		if(!gamepadDownFunction) {
			return;
		}

		gamepadDownFunction(id,button);
	}
	
	function recieveGamepadUp(button,id) {
		
		if(!gamepadUpFunction) {
			return;
		}

		gamepadUpFunction(id,button);
	}
	
	function showScores(mode) {
		parent.toggleScores(mode);
	}


	/*
	function getNewsHeadline(outputDiv) {
		var xmlhttp = new XMLHttpRequest();

		xmlhttp.onreadystatechange=function() {

			if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				var newsfeed = xmlhttp.responseText;
				
				if (newsfeed.indexOf("###") == -1) {
					outputDiv.innerHTML = newsfeed;
				} else {
					var newsParts = new Array();
					newsParts = newsfeed.split("###");
					outputDiv.innerHTML = newsParts[0];
					outputDiv.addEventListener("click",function(event) {
						event.preventDefault();
						externalURL(newsParts[1]);
					},false);
					outputDiv.style.cursor = "pointer";
				}
				
			}
		}
		
		xmlhttp.open("GET","http://www.ape-apps.com/highscores/newsfeed.txt",true);
		xmlhttp.send();
	}
	*/
	
	var dailyOutput = null;
	
	function getDailyTopScore(mode,outputDiv) {
		outputDiv.innerHTML = "";
		dailyOutput = outputDiv;
		parent.getDailyTopScore(mode);
	}
	
	function setDailyReadout(resultReadout) {
		if(dailyOutput) {
			dailyOutput.innerHTML = resultReadout;
		}
	}
	
	function getHighScoresUsername() {
		return parent.getHighScoresUsername();
	}
	
	function setHighScoresUsername() {
		parent.setHighScoresUsername();
	}

	function submitHighScore(modeid,score) {	
		parent.submitHighScore(modeid,score);		
	}
	
	function inputBox(options, func) {

        if (options.message) {
            this.inputReturn = options.func;
            Android.inputBox(options.message, options.title);
        } else {
            this.inputReturn = func;
            Android.inputBox(options,null);
        }
    }
	
	function handlePauseFunction(func) {
		pauseFunction = func;
	}
	
	function handleResumeFunction(func) {
		resumeFunction = func;
	}
	
	function handleBackFunction(func) {
		backFunction = func;
	}
	
	function onResume() {
	
		parent.forceCloseMenu();
		
		if(typeof resumeFunction === 'undefined'){
			return "0";
		}
		
		if(!resumeFunction || resumeFunction == null) {
			return "0";
		}
	
		if(resumeFunction) {
			resumeFunction();
		}
	}
	
	function onPause() {
		if(typeof pauseFunction === 'undefined'){
			return "0";
		}
		
		if(!pauseFunction || pauseFunction == null) {
			return "0";
		}
		
		if(pauseFunction) {
			pauseFunction();
		}
	}
	
	function onBack() {
		if(typeof backFunction === 'undefined'){
			return "0";
		}
		
		if(!backFunction || backFunction == null) {
			return "0";
		}
		
		if(backFunction == "0") {
			return "0";
		}
		
		backFunction();
	}
	
	function clearSplash() {
		parent.clearSplash();
	}
	
	var alertOpen = false;
	
	function showAlert(message) {
		Android.showAlert(message);
	}
	
	function showAlertWithTitle(message,title) {
		Android.showAlertWithTitle(message,title);
	}
	
	function showToast(options) {

	    if(options == null) {
	        return;
	    }

        this.toastFunction = null;

        if (options.message) {

            var sendMessage = options.message;
            var sendAction = null;
            var sendImage = null;

            if (options.action) {
                this.toastFunction = options.action.func;
                sendAction = { title: options.action.title, callback: parent.toastWacBack };
            }

            if(options.image) {
                sendImage = options.image;
            }

            parent.showToast(sendMessage, sendImage, sendAction);
        } else {
            parent.showToast(options);
        }
    }

    function toastBack() {
        if (this.toastFunction != null) {
            this.toastFunction();
        } else {
            console.log("NO TOAST FUNCTION!");
        }
    }

	var choiceOpen = false;

	function pickColor(retFun,def) {
		this.colorSelected = retFun;
		parent.showColorPicker(def);
	}
	
	function showChoice(message,op1,op2,f1,f2) {
		this.choice1 = f1;
		this.choice2 = f2;
		
		Android.showChoice(message,op1,op2);
	}

	function vibrate(length) {
		parent.vibrate(length);
	}
	
	function endVibrate() {
		parent.endVibrate();
	}

	var shareImageData;
	var shareAppId = 0;

	function saveScreenshot(element) {
		parent.saveScreenshot(element);
	}
	
	function playSoundEffect(soundName,volume) {

	    if(volume === undefined) {
	        volume = 1;
	    } else {
	        if(volume > 1) {
	            volume = volume / 100;
	        }
	    }

		Android.playSoundClip(soundName,volume);
		//parent.playAudio(soundName);
	}

	function loopAudio(soundName) {
		Android.loopAudio(soundName);
		//parent.loopAudio(soundName);
	}
	
	function stopLoop() {
		Android.stopLoop();
		//parent.killLoop();
	}
	
	function storeVar(varName,varValue) {
		if(!this.varPackage) {
			this.varPackage = new Object();
		}
		
		this.varPackage[varName] = varValue;

		parent.updateVarPackage(this.varPackage);
	}
	
	function getVars(varArray,backFunction) {
	
		for(var i=0;i<varArray.length;i++) {
			window[varArray[i]] = getVar(varArray[i]);
		}
		
		backFunction();
	}

	function goBack() {
		window.history.back();
	}
	
	function navigateTo(page) {
		window.location = pageBaseURL + page;
		return false;
	}
	
	function externalURL(url) {
		parent.loadURL(url);
	}
	
	function getVar(key,def) {
		
		var retValue = "0";
		
		if(def) {
			retValue = def;
		}
		
		if(this.varPackage && this.varPackage[key]) {
			retValue = this.varPackage[key];
		}
		
		return retValue;
	}
	
	function nativeShare(value) {
		parent.toggleShareBox(value);
	}
	
	function getString(key) {
		if(!appStrings) {
            return null;
        }

        var language = Android.getLanguageCode();

        if(!language) {
            language = "en";
        }

        if(!appStrings[language]) {
            language = "en";
        }

        if(!appStrings[language][key]) {
            language = "en";
        }

        return appStrings[language][key];
	}
	
	function setBaseURL() {
		var url = window.location.href;
		if(url.indexOf('.') > -1){
		   pageBaseURL = url.substring(0, url.lastIndexOf('/') + 1);
		}
	}
	
	// Web App Core v3.1 Functions
	var toolbarNameArray = new Array();
	var toolbarFunctionArray = new Array();
	var toolbarTagArray = new Array();
	toolbarFunctionCount = 0;
	
	function addToolbarOption(name,func,dropdown,icon,tag) {

        if(!tag) {
            tag = "0";
        }

        if(!dropdown) {
            dropdown = false;
        }

        if(!icon) {
            icon = null;
        }

        if(!newToolbarHolder[name]) {
            newToolbarHolder[name] = {};
        }

        newToolbarHolder[name][tag] = func;

        if(!icon && !dropdown) {
            parent.addToolbarItem(name,tag,null,null);
        } else {
            parent.addToolbarItem(name,tag,icon,dropdown);
        }

	}
	
	function resetToolbar() {
		newToolbarHolder = {};
		parent.resetCustomToolbar();
	}
	
	function executeToolbarFunction(name,tag) {
	    window[newToolbarHolder[name][tag]](name,tag);
	}
	
	function toggleToolbar() {
		parent.toggleToolbar();
	}
	
	function setTitle(title) {
		parent.setTitle(title);
	}
	
	function importFile(type,callback) {
		this.fileImportComplete = callback;
		parent.importLocalFile(type);
	}
	
	function exportFile(filename,content,isXML) {
		parent.exportTextFileAsDialog(filename,content,isXML);
	}
	
	function sendFile(filename) {
		parent.sendFile(filename);
	}
	
	function copyToClipboard(text) {
		parent.copyToClipboard(text);
	}
	
	function getInterface() {
		return parent.getInterface();
	}
	
	function isTV() {
		return parent.isTV();
	}

	function printText(text) {
		var html = "<pre>" + text + "</pre>";
		
		parent.printContent(html);
	}
	
	function printHTML(html) {
		parent.printContent(html);
	}
	
	function changeWorkspace(callback) {
		this.workspaceChanged = callback;
		parent.changeWorkingDirectory();
	}
	
	function startApp(callback) {
		this.appStarted = callback;

		console.log("starting app!");

		onFacebookStatusChanged(Android.getFacebookLogged());

		// translate all in-document strings
        var translatables = document.getElementsByClassName("wac-translate");
        for(var i = 0; i < translatables.length; i++) {
            var stringName = translatables[i].innerHTML.trim();
            var stringValue = getString(stringName);

            if(stringValue && stringValue != null) {
                translatables[i].innerHTML = stringValue;
            }
        }

		parent.buildVarPackage();

		if(parent.isTV()) {
		    if(window.innerWidth == 1920) {
		        parent.force720();
		    } else {
		        console.log("tv width is " + window.innerWidth);
		    }

		    document.styleSheets[0].insertRule('*:focus { outline:none; }', 0);
            document.styleSheets[0].cssRules[0].style.outline= 'none';
		}

		Android.aleartAppIsRunning();
	}
	
	function recieveVariablePackage(varPack) {
		this.varPackage = varPack;
		this.appStarted();
	}
	
	function registerForShake(callback,sensitivity) {
		if(!sensitivity) {
			sensitivity = 3;
		}
		
		parent.setShakeSensitivity(sensitivity);
		
		this.shakeCallback = callback;
	}
	
	function checkForLaunchFile(callback) {
		this.launchCheckCallback = callback;
		parent.checkForLaunchFile();
	}
	
	function getLaunchFileName(callback) {
		this.launchNameCallback = callback;
		parent.getLaunchFileName();
	}
	
	function getLaunchFileContent(callback) {
		this.launchContentCallback = callback;
		parent.getLaunchFileContent();
	}
	
	function saveLaunchFile(content) {
		parent.saveLaunchFile(content);
	}

	// WAC 3.3

    function setTitleOptionListener(listener) {
        titleOptionListener = listener;
    }

    function titleOptionSelected(tag) {
        if(titleOptionListener == null) {
            return;
        }

        titleOptionListener(tag);
    }

    var nativeListReference;

    function presentNativeList(title,items,callback,dismiss) {
        nativeListListener = callback;

        nativeListReference = items;

        Android.beginNativeListDump();

        for(var i = 0; i < items.length; i++) {

            if(items[i]["icon"] == undefined) {
                items[i]["icon"] = null;
            }

            if(items[i]["description"] == undefined) {
                items[i]["description"] = null;
            }

            if(items[i]["title"] == undefined) {
                items[i]["title"] = null;
            }

            if(items[i]["title-color"] == undefined) {
                items[i]["title-color"] = null;
            }

            if(items[i]["status"] == undefined) {
                items[i]["status"] = null;
            }

            if(items[i]["status-color"] == undefined) {
                items[i]["status-color"] = null;
            }

            Android.addNativeListItem(items[i]["icon"], items[i]["title"], items[i]["title-color"], items[i]["description"], items[i]["status"], items[i]["status-color"], i.toString())

            if(items[i].overflow != undefined && items[i].overflow != null) {
                for(var j = 0; j < items[i].overflow.length; j++) {

                    if(items[i].overflow[j].pre == undefined) {
                        items[i].overflow[j].pre = null;
                    }

                    if(items[i].overflow[j].post == undefined) {
                        items[i].overflow[j].post = null;
                    }

                    if(items[i].overflow[j].color == undefined) {
                        items[i].overflow[j].color = null;
                    }

                    if(items[i].overflow[j].icon == undefined) {
                        items[i].overflow[j].icon = null;
                    }

                    Android.addOverflowToLastListItem(items[i].overflow[j].pre,items[i].overflow[j].post,items[i].overflow[j].color,items[i].overflow[j].icon);
                }
            }
        }

        Android.showNativeList(title, dismiss);
    }

    function nativeListOptionSelected(tag) {

        if(nativeListListener == null || nativeListReference == null || nativeListReference[tag] == null) {
            return;
        }

        nativeListListener(nativeListReference[tag].tag);
    }

    function setOnPremiumListener(callback) {
        premiumUpgradedListener = callback;
    }

    function onPremiumUpgraded() {
        if(premiumUpgradedListener && premiumUpgradedListener != null) {
            premiumUpgradedListener();
        }
    }

    var nativeGetId = 0;
    var nativeGetHolders = {};

    function nativeGetBack(id,data) {
        nativeGetHolders[id](data);
        nativeGetHolders[id] = null;
    }

    function getForResult(url,data,func,forceProxy) {
        if(func == null) {
            func = placeholder;
        }

        dataRequest(url,func,data,false,forceProxy);
    }

    function getIsPremium() {
        var isPremium = parent.getIsPremium();
        return isPremium;
    }

    // begin WAC 3.4.0 functions

        function showDialog(options) {

            if (options.op1) {
                this.choice1 = options.op1.func;
            } else {
                options.op1 = {
                   text: null
                };
            }

            if (options.op2) {
                this.choice2 = options.op2.func;
            } else {
                 options.op2 = {
                    text: null
                 };
            }

            if(!options.title) {
                options.title = null;
            }

            Android.showDialog(options.message, options.title, options.op1.text, options.op2.text);

        }

        function showSplash(text) {
            Android.showSplash(text);
        }

        function socketConnect(url) {
            console.log(url);


            var connectOptions = {
                rejectUnauthorized: false
            };

            if (url.indexOf("https") == 0 || url.indexOf("wss") == 0) {
                connectOptions.secure = true;
            }

            socket = parent.io(url,connectOptions);
        }

        function addSocketListener(evt, callback) {

            if (!socket || socket == null) {
                return;
            }

            socket.on(evt, callback);
        }

        function socketEmit(evt, data) {

            if (!socket || socket == null) {
                return;
            }

            socket.emit(evt, data);
        }

        function getPlatform() {

            var market = "apemarket";

            var platformCode = Android.getPlatform();

            if(platformCode == "2") {
                market = "gplay";
            }

            if(platformCode == "3") {
                market = "amazon";
            }

            if(platformCode == "7") {
                market = "slideme";
            }

            if(platformCode == "8") {
                market = "opera";
            }

            if(platformCode == "9") {
                market = "anzhi";
            }

            if(platformCode == "11") {
                market = "getjar";
            }

            if(platformCode == "12") {
                market = "aptoide";
            }

            return {
                platform: "android",
                market: market
            };
        }

        function setTitleSubtitle(text) {
            parent.setTitleSubtitle(text);
        }

        function setPremiumOptionText(text) {
            Android.setPremiumText(text);
        }

        function setBrandingLogo(logo) {
            parent.setBrandingLogo(logo);
        }

        this.titleFadeCallback = null;

        function fadeTitle(color, callback) {
            this.titleFadeCallback = callback;
            parent.fadeTitle(color);
        }

        function getFacebookLoginStatus() {
            return Android.getFacebookLogged();
        }

        function getFacebookCredentials() {

            if(!Android.getFacebookLogged()) {
                return null;
            }

            var username = Android.getFacebookLoggedName();
            var userid = Android.getFacebookLoggedId();

            var creds = {
                username:	username,
                userid:		userid
            };

            return creds;
        }

        function requestFacebookLogin() {
            Android.requestFacebookLogin();
        }

        function setFacebookStatusListener(listener) {
            facebookStatusListener = listener;
        }



        function onFacebookStatusChanged(status) {



            if(status) {
                // check if we have files on the cloud
                var cloudRequestUrl = "https://cloud.ape-apps.com:2728/" + Android.getFacebookAccessToken() + "/" + Android.getFacebookLoggedId() + "/" + Android.getApeMarketId();
                console.log(cloudRequestUrl);
                //getForResult(cloudRequestUrl, null, cloudListingBack);


                var xmlhttp = new XMLHttpRequest();

                xmlhttp.addEventListener("load",function(e){
                    cloudListingBack(e.target.responseText);

                    if (facebookStatusListener != null) {
                        facebookStatusListener(true);
                    }
                });

                xmlhttp.addEventListener("error",function() {
                    if (facebookStatusListener != null) {
                        facebookStatusListener(true);
                    }
                });

                xmlhttp.addEventListener("timeout",function() {
                    if (facebookStatusListener != null) {
                        facebookStatusListener(true);
                    }
                });

                xmlhttp.open("get",cloudRequestUrl,true);
                xmlhttp.timeout = 12000;
                //xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

                xmlhttp.send();

            } else {
                if (facebookStatusListener != null) {
                    facebookStatusListener(false);
                }
            }

        }

        var pendingLoadFileName;
        var pendingLoadFileCallback;

        var loadedLocal = false;


        function openFile(name,retfun) {

            pendingLoadFileCallback = retfun;
            pendingLoadFileName = name;

            loadedLocal = false;




            if(getFacebookLoginStatus() && Android.getFacebookAccessToken() != null) {
                var cloudRequestUrl = "https://cloud.ape-apps.com:2728/" + Android.getFacebookAccessToken() + "/" + Android.getFacebookLoggedId() + "/" + Android.getApeMarketId() + "/" + encodeURIComponent(name);

                console.log(cloudRequestUrl);

                var xmlhttp = new XMLHttpRequest();

                var aborter = setTimeout(function(){
                    console.log("abort");
                    loadFileLocalStyle(pendingLoadFileName);
                    xmlhttp.abort();
                }, 6000 );

                xmlhttp.addEventListener("load",function(e){
                    //console.log("cloud back: " + e.target.responseText);

                    //console.log(e.target.responseText);

                    clearTimeout(aborter);

                    cloudFileReturn(e.target.responseText);
                });

                xmlhttp.addEventListener("error",function() {
                    //console.log("cloud error!");
                    clearTimeout(aborter);
                    loadFileLocalStyle(pendingLoadFileName);
                });

                xmlhttp.addEventListener("timeout",function() {
                    //console.log("cloud timeout!");
                    clearTimeout(aborter);
                    loadFileLocalStyle(pendingLoadFileName);
                });

                xmlhttp.open("GET",cloudRequestUrl,true);
                //xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                xmlhttp.timeout = 12000;
                xmlhttp.send();
            } else {
                loadFileLocalStyle(name);
            }
        }

        function cloudFileReturn(data) {
            if (!data || data == null || data.trim() == "fail" || data.trim() == "invalid access token") {
                loadFileLocalStyle(pendingLoadFileName);
            } else {
                console.log("returned data from cloud");
                pendingLoadFileCallback(data);
            }
        }

        function loadFileLocalStyle(filename) {

            if(loadedLocal) {
                return;
            }

            loadedLocal = true;

            try {
                content = Android.openFile(filename);
            } catch(ex) {
                parent.logEvent("Load Error","webappcore.js loadFileLocalStyle",ex.message);
                pendingLoadFileCallback(null);
                return;
            }


            console.log("WAC got content back");
            console.log("length: " + content.length);


            pendingLoadFileCallback(content);
        }

        var pendingWorkspaceMoveAfter = false;

        function cloudListingBack(data) {

            var cloudFiles = data.split("\n");
            var localFiles = Android.getFileListing().split("|");

            for (var i = 0; i < cloudFiles.length; i++) {
                var exists = false;

                for (var j = 0; j < localFiles.length; j++) {
                    if (cloudFiles[i] == localFiles[j]) {
                        exists = true;
                    }
                }

                if (exists) {
                } else {
                    saveFile(cloudFiles[i], "");
                }
            }


            if (pendingWorkspaceMoveAfter) {
                this.workspaceChanged(true);
            }

            pendingWorkspaceMoveAfter = false;

        }

        function saveFile(name,content,callback,blockCloud) {

            parent.saveFile(name,content);

            if(getFacebookLoginStatus() && !blockCloud) {



                var cloudRequestUrl = "https://cloud.ape-apps.com:2728/" + Android.getFacebookAccessToken() + "/" + Android.getFacebookLoggedId() + "/" + Android.getApeMarketId() + "/" + encodeURIComponent(name);
                var xmlhttp = new XMLHttpRequest();

                var aborter = setTimeout(function(){
                    if(callback) {
                        callback();
                    }
                    xmlhttp.abort();
                }, 6000 );

                xmlhttp.addEventListener("load",function(e){
                    if(callback) {
                        callback();
                    }
                    clearTimeout(aborter);
                });

                xmlhttp.addEventListener("error",function() {
                    console.log("cloud save error");
                    if(callback) {
                        callback();
                    }
                    clearTimeout(aborter);
                });

                xmlhttp.addEventListener("timeout",function() {
                    console.log("cloud save timeout");
                    if(callback) {
                        callback();
                    }
                    clearTimeout(aborter);
                });

                xmlhttp.open("post",cloudRequestUrl,true);
                xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                xmlhttp.timeout = 12000;
                xmlhttp.send("filecontent=" + content);
            } else {
                if(callback) {
                    callback();
                }
            }
        }

        function cloudSaveBack(data) {
            console.log(data);
        }

        function deleteFile(name,retfun) {
            this.fileDeleted = retfun;
            parent.deleteFile(name);

            if(getFacebookLoginStatus()) {
                var cloudRequestUrl = "https://cloud.ape-apps.com:2728/" + Android.getFacebookAccessToken() + "/" + Android.getFacebookLoggedId() + "/" + Android.getApeMarketId() + "/" + encodeURIComponent(name);
                var xmlhttp = new XMLHttpRequest();


                xmlhttp.addEventListener("load",function(e){
                    if(retfun) {
                        retfun();
                    }
                });

                xmlhttp.addEventListener("error",function() {
                    if(retfun) {
                        retfun();
                    }
                });

                xmlhttp.addEventListener("timeout",function() {
                    if(retfun) {
                        retfun();
                    }
                });

                xmlhttp.open("post",cloudRequestUrl,true);
                xmlhttp.timeout = 12000;
                xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                xmlhttp.send("doDelete=1");
            } else {
                if(retfun) {
                    retfun();
                }
            }
        }

        function cloudDeleteBack(data) {
            //console.log(data);
        }

        function dataRequest(url,callback,data,post,forceProxy) {
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.callbackFunction = callback;

            var m = "GET";

            if(post) {
                m = "POST";
            }

            var params = "";

            if(data && data != null) {
                if(Array.isArray(data)) {
                    for(var i = 0;i < data.length; i++) {
                        if(i > 0) {
                            params = params + "&";
                        }

                        if(post) {
                            params = params + data[i].key + "=" + data[i].value;
                        } else {
                            params = params + data[i].key + "=" + encodeURIComponent(data[i].value);
                        }
                    }
                } else {
                    if (typeof data === 'string' || data instanceof String) {
                        params = data;
                    } else {
                        if(post) {
                            params = data.key + "=" + data.value;
                        } else {
                            params = data.key + "=" + encodeURIComponent(data.value);
                        }
                    }
                }
            }

            xmlhttp.addEventListener("load",function(e) {
                this.callbackFunction(e.target.responseText);
            });

            xmlhttp.addEventListener("error",function(e) {
                this.callbackFunction(null);
            });

            xmlhttp.addEventListener("timeout",function(e) {
                this.callbackFunction(null);
            });

            if(!post && params.length > 0) {
                url = url + "?" + params;
            }

            var useURL = url;
            var useMethod = m;

            if(forceProxy) {
                useMethod = "POST";
                useURL = "https://www.apewebapps.com/awaproxy.php?m=" + m + "&url=" + encodeURIComponent(url);
            }

            xmlhttp.open(useMethod,useURL,true);


            xmlhttp.timeout = 14000;
            xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");


            if(post) {
                console.log("sending post");
                xmlhttp.send(params);
            } else {
                console.log("sending get");
                xmlhttp.send();
            }
        }

        var appMidiCallback = null;
        var appMidiLooping = false;
        var appMidiFile = null;

        function getWacVersion() {
            return Android.getWacVersion();
        }

        function midiCallbackListener() {
            if(appMidiLooping) {
                Android.playMidi(appMidiFile);
            } else {
                stopMidi(true);
            }
        }

        function playMidi(song,seconds,loop,callback) {
            appMidiCallback = callback;
            appMidiLooping = loop;
            appMidiFile = song;

            Android.playMidi(song);
        }

        function stopMidi(fromCallback) {
            if(!fromCallback) {
                Android.stopMidi();
            }

            var pendingCallback = appMidiCallback;

            appMidiCallback = null;
            appMidiLooping = false;
            appMidiFile = null;

            if(pendingCallback != null) {
                pendingCallback("done");
            }

            pendingCallback = null;
        }

        function setRelaunchListener() {
            // not really needed yet on Android
        }

        var menuPressedListener = null;

        function setMenuPressedListener(listener) {
            menuPressedListener = listener;
        }

        function revieveMenuPress() {
            if(menuPressedListener != null) {
                menuPressedListener();
            }
        }

        function supportsShortcut() {
            return true;
        }

        function createShortcut(title,launchParm,icon) {
            Android.createShortcut(title,launchParm,icon);
        }

        function supportsRingtone() {
            return true;
        }

        function setRingtone(filename) {
            Android.setRingtone(filename);
        }

        var audioInstanceRecords = {};

        function playAudio(soundName,callback) {
            audioInstanceRecords[soundName] = callback;

            Android.playAudio(soundName);
        }

        function stopAudio(soundName) {
            Android.stopAudio(soundName);
        }

        function audioInstanceCallbackListener(soundName) {

            var callbackReference = audioInstanceRecords[soundName];

            audioInstanceRecords[soundName] = null;

            if(callbackReference) {
                callbackReference();
            }
        }

        var rewardedVideoCallback = null;

        function playRewardedVideo(callback) {
            rewardedVideoCallback = callback;
            Android.showRewardedVideo();
        }

        function rewardedVideoDone(status) {
            if(rewardedVideoCallback) {
                rewardedVideoCallback(status);
            }

            rewardedVideoCallback = null;
        }

})(window, document);

