window.ColonyGame = {
    "meta": {
        "name":                 "我的殖民地",
        "titleTheme":           "#000000",
        "theme":                "#000000",
        "buildVersion":         "0.52.0",
        "releaseCode":          52,
        "tmpDefaultMapType":    "Red Planet",
        "tmpDefaultRace":       "Human",
        "tmpDefaultCiv":        "United Earth",
        "gridSize":             64,
        "mapHeight":            100,
        "mapWidth":             100,
        "newGameMessage":       "new-game-message",
        "betaInfo":             "beta-info",
        "feedbackUrl":          null,
        "communityUrl":         "https://www.ape-apps.com/viewpage.php?p=20",
        "colonistIcon":         "ind-colonist.png",
        "touristIcon":          "ind-tourist.png",
        "unemploymentIcon":     "ind-unemployed.png",
        "medicalIcon":          "ind-medical.png",
        "giftIndicator":        "ind-gift.png",
        "jobsIcon":             "ind-jobs.png",
        "earthIcon":            "earth.png",
        "colonistsEat":         "Food",
        "colonistsDrink":       "Water",
        "constructionTile":     "construction",
        "colonistsHarvest":     "Ore",
        "tenderResource":       "Money",
        "findBuilderIcon":      "ind-construction-2.png",
        "techWindowIcon":       "ind-research.png",
        "centerMapIcon":        "lander.png",
        "transModeIcon":        "ind-trans.png",
        "civicsIcon":           "ind-civic.png",
        "zoomInIcon":           "zoom-in.png",
        "zoomOutIcon":          "zoom-out.png",
        "gameStageResource":    "Atmosphere",
        "transactionCostResource":"Civics",
        "gameStages": [
            { "threshold": 0, "message": null },
            { "threshold": 250000, "message": "stage-1-intro" },
            { "threshold": 1000000, "message": "stage-2-intro" },
            { "threshold": 5000000, "message": "stage-3-intro" },
            { "threshold": 15000000, "message": "stage-4-intro" }
        ],
        "setFpsIndicator":      "ind-fps.png",
        "setPopperIndicator":   "ind-popper.png",
        "keyboardIndicator":    "ind-keyboard.png",
        "sidebarIndicator":     "ind-sidebar.png",
        "baseIndependenceCost": { "resource":"Civics","amount":250000 },
        "defaultMotherland":    "general-united-earth",
        "colonyServerBase":     "https://www.my-colony.com/colonies/",
        "colonyServerApi":      "https://www.my-colony.com/api.php",
        "colonyServerGameId":   "1",
        "foundingIndicator":    "ind-founding.png",
        "independenceIndicator":"ind-ind.png",
        "charterIndicator":     "ind-charter.png",
        "empireIndicator":      "ind-empire.png",
        "websiteIndicator":     "ind-website.png",
        "referenceLink":        "https://www.my-colony.com/reference/",
        "renameIndicator":      "ind-rename.png",
        "cloudIndicator":       "ind-cloud.png",
        "mailIndicator":        "ind-mail.png",
        "approvalIndicator":    "ind-approval.png",
        "soundIndicator":       "ind-sound.png",
        "dimensionIndicator":   "ind-dims.png",
        "homelessIndicator":    "ind-homeless.png",
        "housingIndicator":     "brickhouse.png",
        "backIndicator":        "ind-back.png",
        "polLaborInd":          "ind-labor.png",
        "polWorkPolicyInd":     "refinery2.png",
        "polFiredrillInd":      "ind-firedrill.png",
        "podImmigradionInd":    "landingpad.png",
        "wPolLightInd":         "ind-work-light.png",
        "wPolNormalInd":        "ind-labor.png",
        "wPolOTInd":            "ind-work-ot.png",
        "wPolXtremeInd":        "ind-work-xt.png",
        "totalWorkforceInd":    "ind-totalwf.png",
        "indRetired":           "ind-work-light.png",
        "moneyShowerInd":       "ind-moneyshower.png",
        "taxCollectionInd":     "ind-taxcollect.png",
        "ageIndicator":         "ind-cloning.png",
        "privateCharterInd":    "ind-nocharter.png",
        "onlineModeInd":        "ind-onlinemode.png",
        "offlineModeInd":       "ind-noonline.png",
        "resourcesInd":         "ind-resources.png",
        "autosaveInd":          "ind-save.png",
        "compressionInd":       "ind-compression.png",
        "backupOnInd":          "ind-backup-on.png",
        "backupOffInd":         "ind-backup-off.png",
        "rationingInd":         "ind-rations.png",
        "annexInd":             "ind-annex.png",
        "podcastURL":           "https://podcasts.ape-apps.com/my-colony-podcast/",
        "podcastName":          "我的殖民地播客",
        "fileShareUrlPrefix":   "web+my-colony://",
        "nativeClientURL":      "https://market.ape-apps.com/my-colony.html",
        "retirementRequirements": [
            {"resource":"Food","amount":8},
            {"resource":"Water","amount":4},
            {"resource":"Rum","amount":2},
            {"resource":"Cloth","amount":1},
            {"resource":"Toy","amount":1}
        ],
        "annexTileCost": [
            {"resource":"Money","amount":450},
            {"resource":"Civics","amount":200}
        ],
        "showBuildSidebarIcon": "ind-buildmenu.png",
        "fileExtension":        "mcz",
        "backupExtension":      "mcb",
        "socketServer":         "https://www.my-colony.com:2728",
        "lotteryInd":           "ind-lottery.png",
        "rescindInd":           "ind-rescind.png",
        "denounceInd":          "ind-denounce.png",
        "visitInd":             "ind-visitcolony.png",
        "printInd":             "ind-print.png",
        "shortcutInd":          "ind-shortcut.png",
        "pinnedLinkIcon":       "logo_file_type_mcs.preleaseNotesServerng",
        "autobudgetInd":        "ind-autobudget.png",
        "indRRR":               "randium.jpeg",
        "allowConscription":    false,
        "conscriptionOptions":  null,
        "diplomacyIndicator":   "ind-diplomacy.png",
        "embassyCostPerSector": [
            {"resource":"Money","amount":3500},
            {"resource":"Civics","amount":4000}
        ],
        "extraReferenceName": "骑士助手@零壹汉化",
        "extraReferenceUrl": "http://m.vqs.com/",
        "extraReferenceIcon": "logo_sheets_128px.png",
        "extraReferenceDisclaimer": "更多精品汉化游戏，预约汉化游戏请关注零壹汉化公众号lingyigame",
        "graphicsModFileFormat": "mct",
        "bulldozerToolIndicator": "ind-dozer.png",
        "sidebarBackgroundImage": null,
        "moddingCommunityUrl":  "https://www.ape-apps.com/viewpage.php?p=11365",
        "videoTutorialsIndicator": "ind-vidtut.png",
        "videoTutorialSubmissionUrl": "https://www.ape-apps.com/viewpage.php?p=285",
        "indAnimationSetting":  "ind-animation.png",
        "indLightingSetting":   "streetlight.png",
        "indDaynightSetting":   "ind-day-night.png",
        "indParticlesSetting":   "ind-particles.png",
        "releaseNotesServer":   "https://www.my-colony.com/releasenotes/",
        "indChainOn":           "ind-chain-on.png",
        "indChainOff":          "ind-chain-off.png",
        "indShowBuildList":     "ind-showbuildlist.png",
        "indPolicy":            "ind-civic.png",
        "indFlipBuilding":      "ind-rotate.png",
        "indMakeCenter":        "ind-makecenter.png",
        "indExportGoods":       "ind-export.png",
        "indImportGoods":       "ind-import.png",
        "indActivateBld":       "ind-power.png",
        "indDeactivateBld":     "ind-nopower.png",
        "indSell":              "ind-sell.png",
        "indRepair":            "ind-repair.png",
        "indTrade":             "ind-trade.png",
        "indUpgrade":           "ind-upgrade.png",
        "indMove":              "ind-move.png",
        "indHarvest":           "ind-harvest.png",
        "indPark":              "ind-park.png",
        "indDestroy":           "ind-destroy.png",
        "indDestruct":          "ind-destroy.png",
        "indDismiss":           "ind-dismiss.png",
        "indStats":             "ind-stats.png",
        "indDeployLoaded":      "ind-deployloaded.png",
        "customMapExtension":   "mcm",
        "mapEditorStartFlagAsset":"startflag"
    },
    "videoTutorials": [
        {
            "title": "Red Planet Guide",
            "author": "Grind This Game",
            "url": "https://www.youtube.com/watch?v=Tfw_-RB6D-Q&list=PLHw_EJXYsdHgSUAzwqvtfgpoBDm16flcP"
        },
        {
            "title": "Lunar Guide",
            "author": "Grind This Game",
            "url": "https://www.youtube.com/watch?v=B4nUnt795sE&list=PLHw_EJXYsdHiDYmibg7fctgtZITBr7oSR"
        },
        {
            "title": "Forest World Guide",
            "author": "Grind This Game",
            "url": "https://www.youtube.com/watch?v=ucSu_fNNIK0&list=PLHw_EJXYsdHgGDJvDjFp3Y2MmobOJ_6sY"
        },
        {
            "title": "Zolarg Race",
            "author": "Grind This Game",
            "url": "https://www.youtube.com/watch?v=ZUa_m7p9_Rs&list=PLHw_EJXYsdHgOU7pDnWWDxE_0V10d1OtI"
        },
        {
            "title": "Touch Screen Road Building",
            "author": "Ape Apps",
            "url": "https://www.youtube.com/watch?v=AuraLnR7fPU"
        },
        {
            "title": "A My Colony Timelapse",
            "author": "Ruben",
            "url": "https://www.youtube.com/watch?v=2qS-5P_aePk"
        }
    ],
    "messages": {
        "premiumNotice":        "premium-notice"
    },
    "sounds": {
        "defaultSelectSound":   "select",
        "explosion":            "explosion",
        "execution":            "execute",
        "contractBuy":          "snd-drop-coin-1"
    },
    "soundtrack": [],
    "achievements": {
        "gainIndependence":         117,
        "onlineTrade":              118,
        "hundredColonists":         119,
        "thousandColonists":        120,
        "tenthousandColonists":     121,
        "tenthousandTender":        122,
        "hundredThousandTender":    123,
        "millionTender":            124,
        "thousandTourists":         125
    },
    "mapTypes": [
        {
            "name":         "Earthlike",
            "icon":         "earth.png",
            "description":  "earthlike-planet-desc",
            "groundTile":[
                "ground4",
                "ground4",
                "ground4",
                "ground4",
                "ground4"
            ],
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 30 },
                { "name": "Gold Deposit", "abundance": 14 },
                { "name": "Aluminum Deposit", "abundance": 14 },
                { "name": "Uranium Deposit", "abundance": 8 },
                { "name": "Oil Deposit", "abundance": 10 },
                { "name": "Fir Trees", "abundance": 450 }
            ],
            "difficulty":   "Beginner",
            "startingTechs": ["Forest World Base","Red Planet Base","Advanced Microbiology","Low Gravity Husbandry","Clay Production"],
            "startingResourceModifiers": [
                { "name": "Atmosphere", "modifier": 5000000 },
                { "name": "Ore", "modifier": 7500 },
                { "name": "Money", "modifier": 5000 },
                { "name": "Food", "modifier": 2000 },
                { "name": "Water", "modifier": 2000 }
            ],
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": "River",
            "explosionDisasters": null,
            "riverPosition": "bottom"
        },
        {
            "name":         "Red Planet",
            "icon":         "ind-redplanet.png",
            "description":  "red-planet-desc",
            "groundTile":[
                "ground",
                "ground2",
                "ground3",
                "ground4",
                "ground4"
            ],
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 30 },
                { "name": "Gold Deposit", "abundance": 10 },
                { "name": "Aluminum Deposit", "abundance": 8 },
                { "name": "Uranium Deposit", "abundance": 5 },
                { "name": "Ice Deposit", "abundance": 12 }
            ],
            "difficulty":   "Easy",
            "startingTechs": ["Red Planet Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null
        },
        {
            "name":         "Lunar",
            "icon":         "ind-lunar.png",
            "description":  "lunar-planet-desc",
            "groundTile":[
                "ground5",
                "ground5",
                "ground6",
                "ground7",
                "ground7"
            ],
            "difficulty":   "Medium",
            "terrainFeatures": [
                { "name": "Regolith Deposit", "abundance": 50 },
                { "name": "Gold Deposit", "abundance": 3 },
                { "name": "Aluminum Deposit", "abundance": 12 },
                { "name": "Uranium Deposit", "abundance": 18 }
            ],
            "startingTechs": ["Lunar Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": "lunar-welcome-message",
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null
        },
        {
            "name":         "Forest World",
            "icon":         "ind-forest.png",
            "description":  "forest-planet-desc",
            "groundTile":[
                "ground4",
                "ground4",
                "ground4",
                "ground4",
                "ground4"
            ],
            "difficulty":   "Hard",
            "terrainFeatures": [
                { "name": "Gold Deposit", "abundance": 2 },
                { "name": "Aluminum Deposit", "abundance": 3 },
                { "name": "Pond", "abundance": 12 },
                { "name": "Oil Deposit", "abundance": 12 },
                { "name": "Fir Trees", "abundance": 450 }
            ],
            "startingTechs": ["Forest World Base","Advanced Microbiology","Low Gravity Husbandry","Clay Production"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": "forest-welcome-message",
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null
        },
        {
            "name":         "Sugarland",
            "icon":         "ind-sugarland.png",
            "description":  "sugarland-desc",
            "groundTile":[
                "ground8",
                "ground8",
                "ground8",
                "ground8",
                "ground8"
            ],
            "difficulty":   "Medium",
            "terrainFeatures": [
                { "name": "Sugarcane", "abundance": 350 },
                { "name": "Ore Deposit", "abundance": 10 },
                { "name": "Gold Deposit", "abundance": 15 },
                { "name": "Aluminum Deposit", "abundance": 28 },
                { "name": "Pond", "abundance": 25 },
                { "name": "Fir Trees", "abundance": 80 }
            ],
            "startingTechs": ["Sugarland Base"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null
        },
        {
            "name":         "Asteroid",
            "icon":         "ind-asteroid.png",
            "description":  "asteroid-planet-desc",
            "groundTile":[
                "ground9",
                "ground10",
                "ground11",
                "ground12",
                "ground12"
            ],
            "difficulty":   "Hard",
            "terrainFeatures": [
                { "name": "Regolith Deposit", "abundance": 30 },
                { "name": "Gold Deposit", "abundance": 35 },
                { "name": "Ice Deposit", "abundance": 4 },
                { "name": "Diamond Deposit", "abundance": 15 }
            ],
            "startingTechs": ["Asteroid Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null
        },
        {
            "name":         "Abandoned World",
            "icon":         "ind-abandonedworld.png",
            "description":  "abandonedworld-planet-desc",
            "groundTile":[
                "ground8",
                "ground8",
                "ground8",
                "ground8",
                "ground8"
            ],
            "difficulty":   "Hard",
            "terrainFeatures": [
                { "name": "Regolith Deposit", "abundance": 20 },
                { "name": "Gold Deposit", "abundance": 15 },
                { "name": "Aluminum Deposit", "abundance": 5 },
                { "name": "Sugarcane", "abundance": 150 },
                { "name": "Pond", "abundance": 25 },
                { "name": "Fir Trees", "abundance": 350 }
            ],
            "startingTechs": ["Abandoned World Base"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }], // { "name": "Water", "modifier": 30 }
            "startingBuildings": ["Ancient Statue","Ancient Statue","Ancient Statue","Ancient Temple","Ancient Temple"],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null
        },
        {
            "name":         "Ice World",
            "icon":         "ind-iceworld.png",
            "description":  "iceworld-planet-desc",
            "groundTile":[
                "ground14",
                "ground14",
                "ground14",
                "ground14",
                "ground14"
            ],
            "difficulty":   "Brutal",
            "terrainFeatures": [
                { "name": "Gold Deposit", "abundance": 3 },
                { "name": "Ice Deposit", "abundance": 40 },
                { "name": "Diamond Deposit", "abundance": 10 },
                { "name": "Crystalline Deposit", "abundance": 30 },
                { "name": "Uranium Deposit", "abundance": 6 },
                { "name": "Aluminum Deposit", "abundance": 6 }
            ],
            "startingTechs": ["Ice World Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": "snowing",
            "colorEffect": "#050a38",
            "colorStrength": 0.65,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null
        },
        {
            "name":         "Lava World",
            "icon":         "ind-lavaworld.png",
            "description":  "lavaworld-planet-desc",
            "groundTile":[
                "ground10",
                "ground15",
                "ground15",
                "ground16",
                "ground16"
            ],
            "difficulty":   "Death",
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 30 },
                { "name": "Diablo Crystalline", "abundance": 50 }
            ],
            "startingTechs": ["Lava World Base"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 500000000 }],
            "startingBuildings": [],
            "welcomeOverride": "lava-world-intro",
            "weatherEffect": "embers",
            "colorEffect": "#212121",
            "colorStrength":0.75,
            "riverTile": "Lava",
            "explosionDisasters": [
                {
                    "name": "Eruption",
                    "description": null,
                    "tip": "eurption-tip",
                    "vibrates": true,
                    "frequency": 100000,
                    "radius": 20,
                    "elements": [
                        { "terrain": "Lava", "abundance": 300 },
                        { "terrain": "Ore Deposit", "abundance": 5 },
                        { "terrain": "Gold Deposit", "abundance": 3 },
                        { "terrain": "Uranium Deposit", "abundance": 3 },
                        { "terrain": "Diamond Deposit", "abundance": 2 },
                        { "terrain": "Aluminum Deposit", "abundance": 1 }
                    ]
                }
            ],
            "riverPosition": null
        }
    ],
    "races": [
        {
            "name":         "Human",
            "defaultSprites": [
                ["colonist1"],
                ["colonist1"],
                ["colonist2"],
                ["colonist3"],"Compacted Snow Path",
                ["colonist3"]
            ],
            "touristSprites": [
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"]
            ],
            "startingTechs": ["Human Base"],
            "description":  "human-description",
            "narcotics":    ["Ant Paste"],
            "raceColor": "#0288D1"
        },
        {
            "name":         "Insectoids",
            "defaultSprites": [
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"]
            ],
            "touristSprites": [
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"]
            ],
            "startingTechs": ["Insectoid Base"],
            "description":  "insectoid-description",
            "narcotics":    ["Wood"],
            "raceColor": "#424242"
        }
    ],
    "civilizations": [
        {
            "name":                 "United Earth",
            "description":          "ue-description",
            "race":                 "Human",
            "icon":                 "ind-ue.png",
            "startingColonists":    2,
            "startingBuilding":     "Lander",
            "startingVehicles":     ["Rover","Lunar Rover","Forest Rover"],
            "startingTechs":        ["United Earth Base"],
            "welcomeMessage":       "welcome-message",
            "availableMaps":        ["Earthlike","Red Planet","Lunar","Forest World"],
            "serverHomeworld":      "1"
        },
        {
            "name":                 "Zolarg Empire",
            "description":          "zolargprime-description",
            "race":                 "Insectoids",
            "icon":                 "ind-zolarg.png",
            "startingColonists":    2,
            "startingBuilding":     null,
            "startingVehicles":     ["Queen","Worker Drone","Tundrabug","Extremeobug"],
            "startingTechs":        ["Zolarg Base"],
            "welcomeMessage":       "insectoid-welcome-message",
            "availableMaps":        ["Sugarland","Ice World","Lava World"],
            "serverHomeworld":      "2"
        },
        {
            "name":                 "League of Independent States",
            "description":          "lis-description",
            "race":                 "Human",
            "icon":                 "ind-lis.png",
            "startingColonists":    2,
            "startingBuilding":     "LIS Lander",
            "startingVehicles":     ["LIS Rover","LIS Rover","Tundra Rover"],
            "startingTechs":        ["LIS Base"],
            "welcomeMessage":       "lunar-welcome-message",
            "availableMaps":        ["Asteroid","Abandoned World","Ice World"],
            "serverHomeworld":      "3"
        }
    ],
    "tiles": [
        {
            "name":         "ground",
            "image":        "ground.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "startflag",
            "image":        "startflag.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pond",
            "image":        "pond.png",
            "tileWidth":    192,
            "canFlip":      false
            
        },
        {
            "name":         "ground2",
            "image":        "ground2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground3",
            "image":        "ground3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground4",
            "image":        "ground4.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground5",
            "image":        "ground5.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground6",
            "image":        "ground6.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground7",
            "image":        "ground7.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground8",
            "image":        "ground8.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lander",
            "image":        "lander.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "landerairborne",
            "image":        "lander-airborne.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "rover",
            "image":        "rover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "spireknowledge",
            "image":        "spireknowledge.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sphrad",
            "image":        "sphrad.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "mine",
            "image":        "mine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "bloodletting",
            "image":        "bloodletting.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "oildeposit",
            "image":        "oildeposit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "regmine",
            "image":        "regmine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "pavement",
            "image":        "pavement.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "greenhouse",
            "image":        "greenhouse.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "greenhouseworking",
            "image":        "greenhouseworking.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "silo",
            "image":        "silo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmosgen",
            "image":        "atmosgen.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmosgen2",
            "image":        "atmosgen2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "factory",
            "image":        "factory.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "builder",
            "image":        "builder.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "deposit",
            "image":        "deposit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "refinery",
            "image":        "refinery.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "miner",
            "image":        "miner.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "panel1",
            "image":        "panel1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "colonist1",
            "image":        "colonist1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "colonist2",
            "image":        "colonist2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "colonist3",
            "image":        "colonist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "landingpad",
            "image":        "landingpad.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "smallshelter",
            "image":        "smallshelter.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "construction",
            "image":        "construction.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "chopshop",
            "image":        "chopshop.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "golddeposit",
            "image":        "golddeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldminer",
            "image":        "goldminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldrefinery",
            "image":        "goldrefinery.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "goldsmelter",
            "image":        "goldsmelter.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smalllab",
            "image":        "smalllab.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "advancedhydro",
            "image":        "advancedhydro.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "solartower",
            "image":        "solartower.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "builder2",
            "image":        "builder2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement2",
            "image":        "pavement2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "largesilo",
            "image":        "largesilo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "refinery2",
            "image":        "refinery2.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "refinery3",
            "image":        "refinery3.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "conferencehall",
            "image":        "conferencehall.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "goldmine",
            "image":        "goldmine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "rescomplex",
            "image":        "rescomplex.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "greendome",
            "image":        "greendome.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "massdriver",
            "image":        "massdriver.png",
            "tileWidth":    288,
            "canFlip":      false
        },
        {
            "name":         "chipfactory",
            "image":        "chipfactory.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "uecongress",
            "image":        "uecongress.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "bluecollar1",
            "image":        "bluecollar1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bluecollar2",
            "image":        "bluecollar2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bluecollar3",
            "image":        "bluecollar3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "botanist1",
            "image":        "botanist1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "botanist2",
            "image":        "botanist2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "botanist3",
            "image":        "botanist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "civiccenter",
            "image":        "civiccenter.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "politician1",
            "image":        "politician1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "politician2",
            "image":        "politician2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "politician3",
            "image":        "politician3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "statue1",
            "image":        "statue1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "orefracking",
            "image":        "orefracking.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "gldsynth",
            "image":        "gldsynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hatchery",
            "image":        "hatchery.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "icedeposit",
            "image":        "icedeposit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "uraniumdeposit",
            "image":        "uraniumdeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aluminumdeposit",
            "image":        "aluminumdeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "icechipper",
            "image":        "icechipper.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmoscondensor",
            "image":        "atmoscondensor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smalltank",
            "image":        "smalltank.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "waterpump",
            "image":        "waterpump.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aluminumrefinery",
            "image":        "aluminum-refinery.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "aluminumminer",
            "image":        "aluminumminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "watertower",
            "image":        "watertower.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "uraniumminer",
            "image":        "uraniumminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "nuclearplant",
            "image":        "nuclear-plant.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "bacteriafarm",
            "image":        "bacteriafarm.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "greenbot",
            "image":        "greenbot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "firtrees",
            "image":        "firtrees.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "medicalclinic",
            "image":        "medical-clinic.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "lumbermill",
            "image":        "lumbermill.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "wall",
            "image":        "wall.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lumberbot",
            "image":        "lumberbot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "treefarm",
            "image":        "treefarm.png",
            "tileWidth":    320,
            "canFlip":      false
        },
        {
            "name":         "sfhouse",
            "image":        "sfhouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "brickhouse",
            "image":        "brickhouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "megabot",
            "image":        "megabot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lgwatertower",
            "image":        "lgwatertower.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "uraniumenrichment",
            "image":        "uraniumenrichment.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "largeres",
            "image":        "largeres.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "capitol",
            "image":        "capitol.png",
            "tileWidth":    416,
            "canFlip":      false
        },
        {
            "name":         "subtfood",
            "image":        "subtfood.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "bank",
            "image":        "bank.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "boardoftrade",
            "image":        "boardoftrade.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "pyramideye",
            "image":        "pyramideye.png",
            "tileWidth":    384,
            "canFlip":      false
        },
        {
            "name":         "digsite",
            "image":        "digsite.png",
            "tileWidth":    320,
            "canFlip":      false
        },
        {
            "name":         "digsite2",
            "image":        "digsite2.png",
            "tileWidth":    320,
            "canFlip":      true
        },
        {
            "name":         "landfill",
            "image":        "landfill.png",
            "tileWidth":    320,
            "canFlip":      false
        },
        {
            "name":         "aluminumgenerator",
            "image":        "aluminumgenerator.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "etbuilder",
            "image":        "etbuilder.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "giorgioinstitute",
            "image":        "giorgioinstitute.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "consulate",
            "image":        "consulate.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "distillery",
            "image":        "distillery.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "rumcellar",
            "image":        "rumcellar.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "relaybooth",
            "image":        "relaybooth.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pub",
            "image":        "pub.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "decfirtrees",
            "image":        "decfirtrees.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "cloningfacility",
            "image":        "cloningfacility.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "claymine",
            "image":        "claymine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "claybot",
            "image":        "claybot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "potteryworks",
            "image":        "potteryworks.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "warehouse",
            "image":        "warehouse.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "subhousing",
            "image":        "subhousing.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "chipfactory2",
            "image":        "chipfactory2.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "supermarket",
            "image":        "supermarket.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "megamart",
            "image":        "megamart.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "chipfactory3",
            "image":        "chipfactory3.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "brickfactory",
            "image":        "brickfactory.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "pavement3",
            "image":        "pavement3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement4",
            "image":        "pavement4.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "warehouse2",
            "image":        "warehouse2.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "sheepfarm",
            "image":        "sheepfarm.png",
            "tileWidth":    384,
            "canFlip":      true
        },
        {
            "name":         "textilemill",
            "image":        "textilemill.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "sweatshop",
            "image":        "sweatshop.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "luxtower",
            "image":        "luxtower.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "aliencondensor",
            "image":        "aliencondensor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hydropower",
            "image":        "hydropower.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "largepark",
            "image":        "largepark.png",
            "tileWidth":    576,
            "canFlip":      false
        },
        {
            "name":         "water1",
            "image":        "water1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "water1shore",
            "image":        "water1-shore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lava1",
            "image":        "lava1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lava1shore",
            "image":        "lava1-shore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lol",
            "image":        "lol.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "statue2",
            "image":        "statue2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flowersred",
            "image":        "flowers-red.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldenshelter",
            "image":        "goldenshelter.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "largeclinic",
            "image":        "largeclinic.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hipsterbar",
            "image":        "hipsterbar.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "warehouse3",
            "image":        "warehouse3.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "quantumwater",
            "image":        "quantumwater.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "brickwall",
            "image":        "brickwall.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regolith",
            "image":        "regolith.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "lunarrover",
            "image":        "lunarrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "helextractor",
            "image":        "helextractor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "regcompact",
            "image":        "regcompact.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "waterextract",
            "image":        "waterextract.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "regpath",
            "image":        "regpath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "heltank",
            "image":        "heltank.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regminer",
            "image":        "regminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "woodhut",
            "image":        "woodhut.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "forestrover",
            "image":        "forestrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "waterwell",
            "image":        "waterwell.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "potatopatch",
            "image":        "potatopatch.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "charcoalhut",
            "image":        "charcoalhut.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "coalcompact",
            "image":        "coalcompact.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "coalburn",
            "image":        "coalburn.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "charfactory",
            "image":        "charfactory.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "mulchpath",
            "image":        "mulchpath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oiltank",
            "image":        "oiltank.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crudebot",
            "image":        "crudebot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowerspurple",
            "image":        "flowers-purple.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowersblue",
            "image":        "flowers-blue.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowerswhite",
            "image":        "flowers-white.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oilplant",
            "image":        "oilplant.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "grass",
            "image":        "grass.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumfood",
            "image":        "quantumfood.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement5",
            "image":        "pavement5.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oilsynthlab",
            "image":        "oilsynthlab.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "oilsynthlab2",
            "image":        "oilsynthlab2.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "plastfact",
            "image":        "plastfact.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "sweatshop2",
            "image":        "sweatshop2.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "scientist1",
            "image":        "scientist1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "scientist2",
            "image":        "scientist2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "scientist3",
            "image":        "scientist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "whitecollar1",
            "image":        "whitecollar1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "whitecollar2",
            "image":        "whitecollar2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "whitecollar3",
            "image":        "whitecollar3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "spaceport",
            "image":        "spaceport.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "motel",
            "image":        "motel.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "tourist3",
            "image":        "tourist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "hotel",
            "image":        "hotel.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "smcasino",
            "image":        "smcasino.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "giftshop",
            "image":        "giftshop.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "zoo",
            "image":        "zoo.png",
            "tileWidth":    512,
            "canFlip":      false
        },
        {
            "name":         "bluehouse",
            "image":        "bluehouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "pavement6",
            "image":        "pavement6.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowersyellow",
            "image":        "flowers-yellow.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "obeliskindependence",
            "image":        "obeliskindependence.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "restaurant",
            "image":        "restaurant.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "resort",
            "image":        "resort.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "mall",
            "image":        "mall.png",
            "tileWidth":    640,
            "canFlip":      false
        },
        {
            "name":         "museum",
            "image":        "musuem.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "galfreight",
            "image":        "galfreight.png",
            "tileWidth":    288,
            "canFlip":      false
        },
        {
            "name":         "statue3",
            "image":        "statue3.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "charcoalpile",
            "image":        "charcoalpile.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "alienpower",
            "image":        "alienpower.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "pavement7",
            "image":        "pavement7.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "mound",
            "image":        "mound.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "sugarcane",
            "image":        "sugarcane.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "insectoid1",
            "image":        "insectoid1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "insectoid2",
            "image":        "insectoid2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "waterbug",
            "image":        "waterbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lumberbug",
            "image":        "lumberbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "orebug",
            "image":        "orebug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "feastingarea",
            "image":        "feastingarea.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "watervats",
            "image":        "watervats.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "pastetank",
            "image":        "pastetank.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pastepath",
            "image":        "pastepath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "broodcenter",
            "image":        "broodcenter.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldburrow",
            "image":        "goldburrow.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldbug",
            "image":        "goldbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sugarpower",
            "image":        "sugarpower.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "insectoidmint",
            "image":        "insectoidmint.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "antaniumsmelter",
            "image":        "antanium-smelter.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "eldersmound",
            "image":        "eldersmound.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "miningoperation",
            "image":        "miningoperation.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "zolargstatue",
            "image":        "zolargstatue.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "foodfortification",
            "image":        "foodfortification.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "capitol2",
            "image":        "capitol2.png",
            "tileWidth":    416,
            "canFlip":      false
        },
        {
            "name":         "capitol3",
            "image":        "capitol3.png",
            "tileWidth":    416,
            "canFlip":      false
        },
        {
            "name":         "consulate2",
            "image":        "consulate2b.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "consulate3",
            "image":        "consulate3b.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "sand",
            "image":        "sand.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "capitol4",
            "image":        "capitol4.png",
            "tileWidth":    416,
            "canFlip":      false
        },
        {
            "name":         "flag1",
            "image":        "flag1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag2",
            "image":        "flag2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag3",
            "image":        "flag3.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag4",
            "image":        "flag4.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "capitol5",
            "image":        "capitol5.png",
            "tileWidth":    416,
            "canFlip":      false
        },
        {
            "name":         "healingpods",
            "image":        "healingpods.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "sugarfarm",
            "image":        "sugarfarm.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "brewpit",
            "image":        "brewpit.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "unholybrewpit",
            "image":        "unholybrewpit.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "gentelbugsclub",
            "image":        "gentelbugsclub.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "lghe3",
            "image":        "lghe3.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "plaque",
            "image":        "plaque.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "capitol6",
            "image":        "capitol6.png",
            "tileWidth":    416,
            "canFlip":      false
        },
        {
            "name":         "elevator",
            "image":        "elevator.png",
            "tileWidth":    288,
            "canFlip":      false
        },
        {
            "name":         "condrone",
            "image":        "condrone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "turbodrone",
            "image":        "turbodrone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "robofactory",
            "image":        "robofactory.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "restower",
            "image":        "restower.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "restowerblue",
            "image":        "restowerblue.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "consulate4",
            "image":        "consulate4.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "wetmound",
            "image":        "wetmound.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "wetcone",
            "image":        "wetcone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "moneypit",
            "image":        "moneypit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "exportcannon",
            "image":        "exportcannon.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "lumberyard",
            "image":        "lumberyard.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "horrorhouse",
            "image":        "horrorhouse.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "regolithextractor",
            "image":        "regolithextractor.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "bank2",
            "image":        "bank2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "steelyard",
            "image":        "steelyard.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "subtcharcoal",
            "image":        "subtcharcoal.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "altarofcommerce",
            "image":        "altarofcommerce.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "highcommand",
            "image":        "highcommand.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "highercommand",
            "image":        "highercommand.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "unholycommand",
            "image":        "unholycommand.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "supplypile",
            "image":        "supplypile.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "commandpost",
            "image":        "commandpost.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "commandpost2",
            "image":        "commandpost2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "consulate5",
            "image":        "consulate5.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "smstadium",
            "image":        "smstadium.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "synthetictextiles",
            "image":        "synthetictextiles.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "lislander",
            "image":        "lislander.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "ground9",
            "image":        "ground9.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground10",
            "image":        "ground10.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground11",
            "image":        "ground11.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground12",
            "image":        "ground12.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diamonddeposit",
            "image":        "diamonddeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lisrover",
            "image":        "lisrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sugarrover",
            "image":        "sugarrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crystalminer",
            "image":        "crystalminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "statue4",
            "image":        "statue4.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "ancienttemple",
            "image":        "ancienttemple.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "medstadium",
            "image":        "medstadium.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "grass2",
            "image":        "grass2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "hoops",
            "image":        "hoops.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "mailbox",
            "image":        "mailbox.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sand2",
            "image":        "sand2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sand3",
            "image":        "sand3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oiltank2",
            "image":        "oiltank2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "uraniumsilo",
            "image":        "uraniumsilo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flag5",
            "image":        "flag5.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag6",
            "image":        "flag6.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag7",
            "image":        "flag7.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "greenhome",
            "image":        "greenhome.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "sweatshop3",
            "image":        "sweatshop3.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "sweetnerfactory",
            "image":        "sweetnerfactory.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "oreenrichmentfacility",
            "image":        "oreenrichmentfacility.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "goldsign",
            "image":        "goldsign.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "desertskull",
            "image":        "desertskull.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "deckchairs",
            "image":        "deckchairs.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "dune",
            "image":        "dune.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "palm2",
            "image":        "palm2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "palm1",
            "image":        "palm1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "cactus3",
            "image":        "cactus3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "cactus2",
            "image":        "cactus2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "cactus1",
            "image":        "cactus1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "fountain",
            "image":        "fountain.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "vertfarm",
            "image":        "vertfarm.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "lumbercamp",
            "image":        "lumbercamp.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "powerspire",
            "image":        "powerspire.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "unholypowerspire",
            "image":        "unholypowerspire.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "statue5",
            "image":        "statue5.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "diamondrefinery",
            "image":        "diamondrefinery.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "diamondminer",
            "image":        "diamondminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "colonialassembly",
            "image":        "colonialassembly.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "bmbazzar",
            "image":        "bmbazzar.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "aluminumhive",
            "image":        "aluminumhive.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "alumibug",
            "image":        "alumibug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ancientbug",
            "image":        "ancientbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "jewelrystore",
            "image":        "jewelrystore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "independencehall",
            "image":        "independencehall.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "independencehall2",
            "image":        "independencehall2.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "leaguetrade",
            "image":        "leaguetrade.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "antsynth",
            "image":        "antsynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "quantumdistillery",
            "image":        "quantumdistillery.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "yellowhouse",
            "image":        "yellowhouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "centerai",
            "image":        "centerai.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smsugarprocessor",
            "image":        "smsugarprocessor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "triantrefine",
            "image":        "triantrefine.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "theshanty",
            "image":        "theshanty.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thefunctional",
            "image":        "thefunctional.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thegoldman",
            "image":        "thegoldman.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "exomound",
            "image":        "exomound.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thecrystalline",
            "image":        "thecrystalline.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thesunrise",
            "image":        "thesunrise.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "diplomaticoutpost",
            "image":        "diplomaticoutpost.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "shrineoftruth",
            "image":        "shrineoftruth.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "transmissionhub",
            "image":        "transmissionhub.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "robofactory2",
            "image":        "robofactory2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "alummine",
            "image":        "alummine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "megatree",
            "image":        "megatree.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "deeptrans",
            "image":        "deeptrans.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement8",
            "image":        "pavement8.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "plastfact2",
            "image":        "plastfact2.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "diplomat1",
            "image":        "diplomat1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "stargate",
            "image":        "stargate.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "arcology",
            "image":        "arcology.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "shrineofmystics",
            "image":        "shrineofmystics.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "crystaldeposit",
            "image":        "crystaldeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "syncrystaldeposit",
            "image":        "syncrystaldeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diablocrystals",
            "image":        "diablocrystals.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground14",
            "image":        "ground14.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "monumentheroes",
            "image":        "monumentheroes.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "fantasyland",
            "image":        "fantasyland.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "oresynth",
            "image":        "oresynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "rescomplexblue",
            "image":        "rescomplexblue.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "bigplayhouse",
            "image":        "bigplayhouse.png",
            "tileWidth":    194,
            "canFlip":      false
        },
        {
            "name":         "micromine",
            "image":        "micromine.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regfurnace",
            "image":        "regfurnace.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "compactedsnow",
            "image":        "compactedsnow.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diamondcrystalreactor",
            "image":        "diamondcrystalreactor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "alienenrichment",
            "image":        "alienenrichment.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "tundrabug",
            "image":        "snowbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "extremeobug",
            "image":        "extremeobug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumsugarcloner",
            "image":        "quantumsugarcloner.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crystalmound",
            "image":        "crystalmound.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "oretunnel",
            "image":        "oretunnel.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "microincinerator",
            "image":        "microincinerator.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smrecyclingcenter",
            "image":        "smrecyclingcenter.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "medrecyclingcenter",
            "image":        "medrecyclingcenter.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smtrashpit",
            "image":        "smtrashpit.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "advancedmed",
            "image":        "advancedmed.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "incinerator",
            "image":        "incinerator.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "unholypit",
            "image":        "unholypit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "unholymound",
            "image":        "unholymound.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "coremine",
            "image":        "coremine.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smlightpost",
            "image":        "smlightpost.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "smredlightpost",
            "image":        "smredlightpost.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "smgreenlightpost",
            "image":        "smgreenlightpost.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "streetlight",
            "image":        "streetlight.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "glowgoo",
            "image":        "glowgoo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pasteboiler",
            "image":        "pasteboiler.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmosscrubber",
            "image":        "atmosscrubber.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "wall2",
            "image":        "wall2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "wall2light",
            "image":        "wall2light.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diamondsolar",
            "image":        "diamondsolar.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bureaucracy",
            "image":        "bureaucracy.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "clothfarm",
            "image":        "clothfarm.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "cauldron",
            "image":        "cauldron.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pastesynth",
            "image":        "pastesynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "rawmatdepot",
            "image":        "rawmatdepot.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "customsprocessing",
            "image":        "customsprocessing.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "pastespa",
            "image":        "pastespa.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "ground15",
            "image":        "ground15.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground16",
            "image":        "ground16.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "vaporizer",
            "image":        "vaporizer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "queen",
            "image":        "queen.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "obsidiandeposit",
            "image":        "obsidiandeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "rovertransport",
            "image":        "rovertransport.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "obsidiobug",
            "image":        "obsidiobug.png",
            "tileWidth":    64,
            "canFlip":      false
        }
    ],
    "resources": [
        {
            "name":         "Money",
            "color":        "#8BC34A",
            "max":          null,
            "indicator":    "$",
            "starting":     2500,
            "icon":         "ind-coin.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Sugar",
            "color":        "#eeeeff",
            "max":          -1,
            "indicator":    "s",
            "starting":     0,
            "icon":         "ind-sugar.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Food",
            "color":        "#4CAF50",
            "max":          -1,
            "indicator":    "f",
            "starting":     50,
            "icon":         "ind-food.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Water",
            "color":        "#2196F3",
            "max":          -1,
            "indicator":    "w",
            "starting":     350,
            "icon":         "ind-water.png",
            "basePrice":    20,
            "isEssential":  false,
            "catchupAmount":3000000,
            "toxicRate":    0
        },
        {
            "name":         "Ant Paste",
            "color":        "#E6EE9C",
            "max":          -1,
            "indicator":    "ap",
            "starting":     0,
            "icon":         "ind-antpaste.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Helium 3",
            "color":        "#cccccc",
            "max":          -1,
            "indicator":    "he",
            "starting":     0,
            "icon":         "ind-he3.png",
            "basePrice":    400,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Rum",
            "color":        "#b38600",
            "max":          -1,
            "indicator":    "ru",
            "starting":     0,
            "icon":         "ind-rum.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Wood",
            "color":        "#795548",
            "max":          -1,
            "indicator":    "wo",
            "starting":     0,
            "icon":         "ind-wood.png",
            "basePrice":    25,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Charcoal",
            "color":        "#333333",
            "max":          -1,
            "indicator":    "ch",
            "starting":     0,
            "icon":         "ind-charcoal.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Ore",
            "color":        "#b34700",
            "max":          null,
            "indicator":    "o",
            "starting":     0,
            "icon":         "ind-ore.png",
            "basePrice":    150,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Regolith",
            "color":        "#555555",
            "max":          null,
            "indicator":    "re",
            "starting":     0,
            "icon":         "ind-regolith.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Clay",
            "color":        "#deaa87",
            "max":          -1,
            "indicator":    "c",
            "starting":     0,
            "icon":         "ind-clay.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Obsidian",
            "color":        "#1f1c24",
            "max":          -1,
            "indicator":    "ob",
            "starting":     0,
            "icon":         "ind-obsidian.png",
            "basePrice":    1000000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Wool",
            "color":        "#deaa87",
            "max":          -1,
            "indicator":    "wl",
            "starting":     0,
            "icon":         "ind-wool.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Steel",
            "color":        "#cccccc",
            "max":          -1,
            "indicator":    "s",
            "starting":     0,
            "icon":         "ind-steel.png",
            "basePrice":    350,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Antanium",
            "color":        "#844c0a",
            "max":          -1,
            "indicator":    "an",
            "starting":     0,
            "icon":         "ind-antanium.png",
            "basePrice":    350,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Oil",
            "color":        "#222222",
            "max":          -1,
            "indicator":    "oi",
            "starting":     0,
            "icon":         "ind-oil.png",
            "basePrice":    500,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Gold",
            "color":        "#ffcc00",
            "max":          -1,
            "indicator":    "g",
            "starting":     0,
            "icon":         "ind-gold.png",
            "basePrice":    950,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Aluminum",
            "color":        "#CFD8DC",
            "max":          -1,
            "indicator":    "al",
            "starting":     0,
            "icon":         "ind-aluminum.png",
            "basePrice":    1000,
            "isEssential":  false,
            "catchupAmount":3000,
            "toxicRate":    0
        },
        {
            "name":         "Diamond",
            "color":        "#eeeeee",
            "max":          -1,
            "indicator":    "di",
            "starting":     0,
            "icon":         "ind-diamond.png",
            "basePrice":    1000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Uranium",
            "color":        "#8BC34A",
            "max":          -1,
            "indicator":    "u",
            "starting":     0,
            "icon":         "ind-uranium.png",
            "basePrice":    3500,
            "isEssential":  false,
            "catchupAmount":3000,
            "toxicRate":    0
        },
        {
            "name":         "Crystalline",
            "color":        "#0277BD",
            "max":          -1,
            "indicator":    "cr",
            "starting":     0,
            "icon":         "ind-crystal.png",
            "basePrice":    4000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Pottery",
            "color":        "#006064",
            "max":          -1,
            "indicator":    "p",
            "starting":     0,
            "icon":         "ind-pottery.png",
            "basePrice":    300,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Plastic",
            "color":        "#dbe2e3",
            "max":          -1,
            "indicator":    "p",
            "starting":     0,
            "icon":         "ind-plastic.png",
            "basePrice":    5000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Bricks",
            "color":        "#ff3030",
            "max":          -1,
            "indicator":    "b",
            "starting":     0,
            "icon":         "ind-bricks.png",
            "basePrice":    450,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Cloth",
            "color":        "#ffffcc",
            "max":          -1,
            "indicator":    "cl",
            "starting":     0,
            "icon":         "ind-cloth.png",
            "basePrice":    400,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Toy",
            "color":        "#c83737",
            "max":          -1,
            "indicator":    "t",
            "starting":     0,
            "icon":         "ind-toy.png",
            "basePrice":    800,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Microchip",
            "color":        "#558B2F",
            "max":          -1,
            "indicator":    "m",
            "starting":     0,
            "icon":         "ind-microchip.png",
            "basePrice":    4000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Robot",
            "color":        "#999999",
            "max":          -1,
            "indicator":    "ro",
            "starting":     0,
            "icon":         "ind-robot.png",
            "basePrice":    5000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Alien Artifact",
            "color":        "#78909C",
            "max":          -1,
            "indicator":    "ar",
            "starting":     0,
            "icon":         "ind-artifact.png",
            "basePrice":    900000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Alien Relic",
            "color":        "#33691E",
            "max":          -1,
            "indicator":    "rl",
            "starting":     0,
            "icon":         "ind-relic.png",
            "basePrice":    900000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Triantanium",
            "color":        "#bcd35f",
            "max":          -1,
            "indicator":    "ta",
            "starting":     0,
            "icon":         "ind-triantanium.png",
            "basePrice":    2500000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Atmosphere",
            "color":        "#81D4FA",
            "max":          null,
            "indicator":    "a",
            "starting":     0,
            "icon":         "ind-air.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    15000000
        },
        {
            "name":         "Trash",
            "color":        "#827717",
            "max":          null,
            "indicator":    "tr",
            "starting":     0,
            "icon":         "ind-trash.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    5000
        },
        {
            "name":         "Research",
            "color":        "#8d5fd3",
            "max":          null,
            "indicator":    "r",
            "starting":     0,
            "icon":         "ind-research.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0
        },
        {
            "name":         "Antaura",
            "color":        "#E53935",
            "max":          null,
            "indicator":    "aa",
            "starting":     0,
            "icon":         "ind-antaura.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0
        },
        {
            "name":         "Civics",
            "color":        "#dddddd",
            "max":          null,
            "indicator":    "c",
            "starting":     0,
            "icon":         "ind-civic.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0
        }
    ],
    "petitions": {
        "landGrant": {
            "name":         "Purchase Land Grant",
            "description":  "pet-expansion-desc",
            "indicator":    "",
            "cost":         [{"resource":"Money","amount":150000},{"resource":"Civics","amount":1000}]
        },
        "landAnnex": {
            "name":         "Annex Land",
            "description":  "pet-annex-desc",
            "indicator":    "",
            "cost":         [{"resource":"Civics","amount":3000}]
        }
    },
    "utilities": [
        {
            "name":         "Power",
            "color":        "#FFA000",
            "indicator":    "p",
            "icon":         "ind-power.png",
            "isEssential":  false
        }  
    ],
    "occupations": [
        {
            "name":     "Blue Collar",
            "tiles": {
                "Human": [
                    ["bluecollar1"],
                    ["bluecollar1"],
                    ["bluecollar2"],
                    ["bluecollar3"],
                    ["bluecollar3"]
                ]
            },
            "salary":   2,
            "indicator":"ind-labor.png"
        },
        {
            "name":     "Botanist",
            "tiles": {
                "Human": [
                    ["botanist1"],
                    ["botanist1"],
                    ["botanist2"],
                    ["botanist3"],
                    ["botanist3"]
                ]
            },
            "salary":   3,
            "indicator":"ind-botanist.png"
        },
        {
            "name":     "Scientist",
            "tiles": {
                "Human": [
                    ["scientist1"],
                    ["scientist1"],
                    ["scientist2"],
                    ["scientist3"],
                    ["scientist3"]
                ]
            },
            "salary":   4,
            "indicator":"ind-scientist.png"
        },
        {
            "name":     "White Collar",
            "tiles": {
                "Human": [
                    ["whitecollar1"],
                    ["whitecollar1"],
                    ["whitecollar2"],
                    ["whitecollar3"],
                    ["whitecollar3"]
                ]
            },
            "salary":   8,
            "indicator":"ind-whitecollar.png"
        },
        {
            "name":     "Politician",
            "tiles": {
                "Human": [
                    ["politician1"],
                    ["politician1"],
                    ["politician2"],
                    ["politician3"],
                    ["politician3"]
                ]
            },
            "salary":   8,
            "indicator":"ind-politician.png"
        },
        {
            "name":     "Diplomat",
            "tiles": {
                "Human": [
                    ["diplomat1"],
                    ["diplomat1"],
                    ["diplomat1"],
                    ["diplomat1"],
                    ["diplomat1"]
                ]
            },
            "salary":   8,
            "indicator":"ind-politician.png"
        }
    ],
    "demands": [
        {

        }
    ],
    "terrains": [
        {
            "name":             "Water Pool",
            "tile":             ["water1"],
            "provides":         null,
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "water1.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       "water1shore",
            "passableConnectors":["Pavement"],
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "River",
            "tile":             ["water1"],
            "provides":         "Water",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         -1,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "water1.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       "water1shore",
            "passableConnectors":null,
            "indestructable":   true,
            "decaysTo":         null
        },
        {
            "name":             "Lava",
            "tile":             ["lava1"],
            "provides":         null,
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         5000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "lava1.png",
            "spreadRate":       3000,
            "collectOnDestruction": false,
            "decayRate":        1,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFB74D",
                    "i":    0.4,
                    "nightonly": false
                }
            ],
            "shoreSheet":       "lava1shore",
            "passableConnectors":null,
            "indestructable":   true,
            "decaysTo":         { "terrain": "Obsidian Deposit", "chance": 10 }
        },
        {
            "name":             "Ore Deposit",
            "tile":             ["deposit"],
            "provides":         "Ore",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         5000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "deposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Obsidian Deposit",
            "tile":             ["obsidiandeposit"],
            "provides":         "Obsidian",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         8,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "obsidiandeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Diamond Deposit",
            "tile":             ["diamonddeposit"],
            "provides":         "Diamond",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         3500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "diamonddeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "风化层沉积",
            "tile":             ["regolith"],
            "provides":         "Regolith",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         3500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "deposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Oil Deposit",
            "tile":             ["oildeposit"],
            "provides":         "Oil",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         6000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "oildeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Ore Mine",
            "tile":             ["mine"],
            "provides":         "Ore",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         10000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "mine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "矿石隧道",
            "tile":             ["oretunnel"],
            "provides":         "Ore",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         600,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "oretunnel.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Aluminum Mine",
            "tile":             ["alummine"],
            "provides":         "Aluminum",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         4000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "alummine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "露天矿",
            "tile":             ["regmine"],
            "provides":         "Regolith",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         8000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "regmine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "微型矿山",
            "tile":             ["micromine"],
            "provides":         "Regolith",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         600,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "micromine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Gold Deposit",
            "tile":             ["golddeposit"],
            "provides":         "Gold",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         2000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "golddeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "金矿",
            "tile":             ["goldmine"],
            "provides":         "Gold",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         4000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "goldmine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Aluminum Deposit",
            "tile":             ["aluminumdeposit"],
            "provides":         "Aluminum",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         4500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "aluminumdeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Uranium Deposit",
            "tile":             ["uraniumdeposit"],
            "provides":         "Uranium",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         1500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "uraniumdeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "结晶矿床",
            "tile":             ["crystaldeposit"],
            "provides":         "Crystalline",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         1000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "crystaldeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    2,
                    "c":    "#0066ff",
                    "i":    0.1,
                    "nightonly": false
                }
            ],
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "暗黑晶体",
            "tile":             ["diablocrystals"],
            "provides":         "Crystalline",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         5000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "crystaldeposit.png",
            "spreadRate":       20000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    2,
                    "c":    "#e68256",
                    "i":    0.25,
                    "nightonly": false
                }
            ],
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "合成结晶矿床",
            "tile":             ["syncrystaldeposit"],
            "provides":         "Crystalline",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         400,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "syncrystaldeposit.png",
            "spreadRate":       5000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    2,
                    "c":    "#00d40c",
                    "i":    .1,
                    "nightonly": false
                }
            ],
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "冰矿",
            "tile":             ["icedeposit"],
            "provides":         "Water",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         35000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "icedeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "池塘",
            "tile":             ["pond"],
            "provides":         "Water",
            "tileWidth":        3,
            "tileHeight":       3,
            "capacity":         250000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "pond.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "Fir Trees",
            "tile":             ["firtrees"],
            "provides":         "Wood",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         15,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "firtrees.png",
            "spreadRate":       100000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "巨型树",
            "tile":             ["megatree"],
            "provides":         "Wood",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         800,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "megatree.png",
            "spreadRate":       50000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "粘土矿",
            "tile":             ["claymine"],
            "provides":         "Clay",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         1500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "claymine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "甘蔗",
            "tile":             ["sugarcane"],
            "provides":         "Sugar",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         600,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "sugarcane.png",
            "spreadRate":       40000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "小垃圾坑",
            "tile":             ["smtrashpit"],
            "provides":         "Trash",
            "tileWidth":        2,
            "tileHeight":       1,
            "capacity":         10000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "smtrashpit.png",
            "spreadRate":       0,
            "collectOnDestruction": true,
            "decayRate":        20,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        },
        {
            "name":             "垃圾填埋场",
            "tile":             ["landfill"],
            "provides":         "Trash",
            "tileWidth":        5,
            "tileHeight":       5,
            "capacity":         250000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "landfill.png",
            "spreadRate":       0,
            "collectOnDestruction": true,
            "decayRate":        15,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null
        }
    ],
    "technology": [
        {
            "name":             "Red Planet Base",
            "description":      "rpbase-desc",
            "icon":             "ind-redplanet.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Forest World Base",
            "description":      "fwbase-desc",
            "icon":             "ind-forest.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Human Base",
            "description":      "hbase-desc",
            "icon":             "earth.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "United Earth Base",
            "description":      "uebase-desc",
            "icon":             "earth.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "LIS Base",
            "description":      "lisbase-desc",
            "icon":             "ind-lis.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Lunar Base",
            "description":      "lunbase-desc",
            "icon":             "ind-lunar.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Asteroid Base",
            "description":      "asteroidbase-desc",
            "icon":             "ind-asteroid.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Sugarland Base",
            "description":      "sugarlandbase-desc",
            "icon":             "ind-sugarland.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Abandoned World Base",
            "description":      "abandonedbase-desc",
            "icon":             "ind-abandonedworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ice World Base",
            "description":      "iceworldbase-desc",
            "icon":             "ind-iceworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Lava World Base",
            "description":      "lavaworldbase-desc",
            "icon":             "ind-lavaworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Base",
            "description":      "insectoidbase-desc",
            "icon":             "ind-zolarg.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Zolarg Base",
            "description":      "zolargbase-desc",
            "icon":             "ind-zolarg.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "先进的水培",
            "description":      "adv-hydro-desc",
            "icon":             "ind-adv-hydro.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "高密度太阳能电池板",
            "description":      "hd-solar-desc",
            "icon":             "ind-adv-solar.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "微重力酿造",
            "description":      "brewing-desc",
            "icon":             "ind-rum.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "先进的矿石净化",
            "description":      "adv-ore-pur-desc",
            "icon":             "ind-ore.png",
            "cost":             [{"resource":"Research","amount":40}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "先进的木炭生产",
            "description":      "advcp-desc",
            "icon":             "ind-charcoal.png",
            "cost":             [{"resource":"Research","amount":50}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Crystalline Synthesis",
            "description":      "crysynth-desc",
            "icon":             "ind-crystal.png",
            "cost":             [{"resource":"Research","amount":50},{"resource":"Crystalline","amount":100}],
            "requiresTech":     ["Ice World Base","Microgravity Brewing|Insectoid Brewing","Antanium Production|先进的矿石净化"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "先进的小规模建设",
            "description":      "construction-2-desc",
            "icon":             "ind-construction-2.png",
            "cost":             [{"resource":"Research","amount":60}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "殖民金融理论",
            "description":      "finance-theory-desc",
            "icon":             "ind-coin.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Black Markets",
            "description":      "blackmarkets-desc",
            "icon":             "ind-blackmarkets.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["LIS Base","殖民金融理论"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Gold Mining",
            "description":      "adv-gold-desc",
            "icon":             "ind-gold.png",
            "cost":             [{"resource":"Research","amount":200}],
            "requiresTech":     ["先进的小规模建设"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Diamond Mining",
            "description":      "diamondmining-desc",
            "icon":             "ind-diamond.png",
            "cost":             [{"resource":"Research","amount":200}],
            "requiresTech":     ["LIS Base","Asteroid Base","先进的小规模建设","Black Markets"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Manufacturing",
            "description":      "lg-manufacturing-desc",
            "icon":             "ind-microchip.png",
            "cost":             [{"resource":"Research","amount":400}],
            "requiresTech":     ["先进的矿石净化","先进的小规模建设"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Colonial Tourism",
            "description":      "coltour-desc",
            "icon":             "spaceport.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Low Gravity Manufacturing","殖民金融理论","Colonial Civics"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Oil Production",
            "description":      "oilref-desc",
            "icon":             "ind-oil.png",
            "cost":             [{"resource":"Research","amount":400}],
            "requiresTech":     ["Low Gravity Manufacturing"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Colonial Civics",
            "description":      "col-civics-desc",
            "icon":             "civiccenter.png",
            "cost":             [{"resource":"Research","amount":400}],
            "requiresTech":     ["殖民金融理论"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Long Range Communications",
            "description":      "lrc-desc",
            "icon":             "ind-lrc.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Colonial Civics"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Chemistry",
            "description":      "adv-chem-desc",
            "icon":             "ind-adv-chem.png",
            "cost":             [{"resource":"Research","amount":750}],
            "requiresTech":     ["先进的矿石净化","Low Gravity Manufacturing"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Microbiology",
            "description":      "adv-microbio-desc",
            "icon":             "ind-microbio.png",
            "cost":             [{"resource":"Research","amount":900}],
            "requiresTech":     ["Advanced Chemistry","Low Gravity Manufacturing"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Tourist Essentials",
            "description":      "touress-desc",
            "icon":             "hotel.png",
            "cost":             [{"resource":"Research","amount":1000}],
            "requiresTech":     ["Colonial Tourism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Clay Production",
            "description":      "clayprod-desc",
            "icon":             "ind-clay.png",
            "cost":             [{"resource":"Research","amount":1200}],
            "requiresTech":     ["Advanced Chemistry","Advanced Microbiology"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Masonry",
            "description":      "masonry-desc",
            "icon":             "ind-bricks.png",
            "cost":             [{"resource":"Research","amount":1200}],
            "requiresTech":     ["Clay Production"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Atmospheric Zoology",
            "description":      "la-zoology-desc",
            "icon":             "ind-zoology.png",
            "cost":             [{"resource":"Research","amount":1200}],
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Nuclear Physics",
            "description":      "nuke-physics-desc",
            "icon":             "ind-uranium.png",
            "cost":             [{"resource":"Research","amount":1500}],
            "requiresTech":     ["Advanced Chemistry","Low Gravity Manufacturing"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Large Scale Construction",
            "description":      "lgcons-desc",
            "icon":             "ind-megabot.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Low Gravity Manufacturing","Advanced Nuclear Physics","先进的小规模建设"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Self Governance",
            "description":      "selfgov-desc",
            "icon":             "ind-civic.png",
            "cost":             [{"resource":"Research","amount":3000}],
            "requiresTech":     ["Colonial Civics"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Commerce",
            "description":      "galcom-desc",
            "icon":             "ind-galcom.png",
            "cost":             [{"resource":"Research","amount":5000}],
            "requiresTech":     ["Colonial Civics","殖民金融理论"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Chemical Synthesis",
            "description":      "adv-chemsyn-desc",
            "icon":             "ind-adv-chemsyn.png",
            "cost":             [{"resource":"Research","amount":5500}],
            "requiresTech":     ["Advanced Chemistry","Low Gravity Oil Production","Low Gravity Manufacturing"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Human Cloning",
            "description":      "cloning-desc",
            "icon":             "ind-cloning.png",
            "cost":             [{"resource":"Research","amount":6000}],
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Husbandry",
            "description":      "husbandry-desc",
            "icon":             "ind-husbandry.png",
            "cost":             [{"resource":"Research","amount":6000}],
            "requiresTech":     ["Low Atmospheric Zoology"],
            "requiresStage":    3,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Tourist Traps",
            "description":      "tourtrap-desc",
            "icon":             "zoo.png",
            "cost":             [{"resource":"Research","amount":10000}],
            "requiresTech":     ["Low Gravity Husbandry","Low Gravity Masonry","Tourist Essentials"],
            "requiresStage":    3,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Robotics",
            "description":      "advrobo-desc",
            "icon":             "ind-condrone.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Low Gravity Manufacturing","Advanced Chemical Synthesis","Advanced Nuclear Physics"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Tall Construction",
            "description":      "tallconst-desc",
            "icon":             "ind-tallconst.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Low Gravity Manufacturing","Advanced Chemical Synthesis","Large Scale Construction"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Deep Excavation",
            "description":      "deepexc-desc",
            "icon":             "ind-deepexc.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Large Scale Construction"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Solar Governance",
            "description":      "solgov-desc",
            "icon":             "statue2.png",
            "cost":             [{"resource":"Research","amount":20000}],
            "requiresTech":     ["Galactic Commerce"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ancient Alien Language",
            "description":      "aal-desc",
            "icon":             "ind-artifact.png",
            "cost":             [{"resource":"Research","amount":30000},{"resource":"Alien Artifact","amount":200}],
            "requiresTech":     ["Large Scale Construction|Insectoid Governance","Deep Excavation|Advanced Metallurgy"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ancient Alien Manufacturing",
            "description":      "aam-desc",
            "icon":             "chipfactory3.png",
            "cost":             [{"resource":"Research","amount":35000},{"resource":"Alien Artifact","amount":350}],
            "requiresTech":     ["Human Base","Ancient Alien Language"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Xenomaterials Research",
            "description":      "xenomat-desc",
            "icon":             "ind-antpaste.png",
            "cost":             [{"resource":"Research","amount":40000},{"resource":"Alien Artifact","amount":400}],
            "requiresTech":     ["Human Base","Ancient Alien Language"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Climate Science Theory",
            "description":      "cst-desc",
            "icon":             "ind-air.png",
            "cost":             [{"resource":"Research","amount":50000}],
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    4,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Governance",
            "description":      "galgov-desc",
            "icon":             "capitol3.png",
            "cost":             [{"resource":"Research","amount":75000}],
            "requiresTech":     ["Solar Governance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Finance Theory",
            "description":      "galfi-desc",
            "icon":             "ind-galcom.png",
            "cost":             [{"resource":"Research","amount":85000}],
            "requiresTech":     ["Galactic Commerce","Galactic Governance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Alien Quantum Physics",
            "description":      "alienquantum-desc",
            "icon":             "alienquantum.png",
            "cost":             [{"resource":"Research","amount":75000},{"resource":"Alien Artifact","amount":1500}],
            "requiresTech":     ["Ancient Alien Language","Ancient Alien Manufacturing"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Artificial Intelligence",
            "description":      "resai-desc",
            "icon":             "ind-ai.png",
            "cost":             [{"resource":"Research","amount":85000},{"resource":"Alien Artifact","amount":3000}],
            "requiresTech":     ["Alien Quantum Physics","Advanced Robotics"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Next Gen Power Production",
            "description":      "nexgenpow-desc",
            "icon":             "ind-crystal.png",
            "cost":             [{"resource":"Research","amount":50000000},{"resource":"Crystalline","amount":5000}],
            "requiresTech":     ["Artificial Intelligence"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ultra Deep Excavation",
            "description":      "udexc-desc",
            "icon":             "digsite2.png",
            "cost":             [{"resource":"Research","amount":100000},{"resource":"Alien Artifact","amount":3000}],
            "requiresTech":     ["Alien Quantum Physics","Deep Excavation"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Antanium Synthesis",
            "description":      "antsynth-desc",
            "icon":             "ind-antanium.png",
            "cost":             [{"resource":"Research","amount":2000000},{"resource":"Alien Artifact","amount":1500}],
            "requiresTech":     ["Xenomaterials Research","Advanced Robotics"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ant Paste Synthesis",
            "description":      "antpastesynth-desc",
            "icon":             "ind-antpaste.png",
            "cost":             [{"resource":"Research","amount":2000000},{"resource":"Alien Artifact","amount":1500}],
            "requiresTech":     ["Xenomaterials Research","Advanced Robotics"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Antanium Compounds",
            "description":      "antcompound-desc",
            "icon":             "ind-triantanium.png",
            "cost":             [{"resource":"Research","amount":5000000},{"resource":"Alien Artifact","amount":1000}],
            "requiresTech":     ["Antanium Synthesis"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Mega Habitats",
            "description":      "megahab-desc",
            "icon":             "arcology.png",
            "cost":             [{"resource":"Research","amount":20000000}],
            "requiresTech":     ["Artificial Intelligence"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Interdimensional Transportation",
            "description":      "interdimtrav-desc",
            "icon":             "ind-stargate.png",
            "cost":             [{"resource":"Research","amount":40000000},{"resource":"Alien Artifact","amount":15000}],
            "requiresTech":     ["Artificial Intelligence","Antanium Synthesis"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Nationalism",
            "description":      "nationalism-desc",
            "icon":             "flag1.png",
            "cost":             [{"resource":"Research","amount":100000},{"resource":"Civics","amount":25000}],
            "requiresTech":     ["Galactic Governance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Imperialism",
            "description":      "imperialism-desc",
            "icon":             "capitol5.png",
            "cost":             [{"resource":"Research","amount":200000},{"resource":"Civics","amount":50000}],
            "requiresTech":     ["Nationalism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Imperialism",
            "description":      "galimp-desc",
            "icon":             "capitol6.png",
            "cost":             [{"resource":"Research","amount":350000},{"resource":"Civics","amount":150000}],
            "requiresTech":     ["Imperialism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Political Theater",
            "description":      "politheat-desc",
            "icon":             "uecongress.png",
            "cost":             [{"resource":"Research","amount":1000000},{"resource":"Civics","amount":500000}],
            "requiresTech":     ["Galactic Imperialism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Gold Storage",
            "description":      "zgoldstorage-desc",
            "icon":             "goldburrow.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Zolarg Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Sugar Cultivation",
            "description":      "sugarcult-desc",
            "icon":             "ind-sugar.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Zolarg Base"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Brewing",
            "description":      "brewing-desc",
            "icon":             "ind-rum.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Zolarg Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Sugarpower",
            "description":      "sugarpower-res-desc",
            "icon":             "sugarpower.png",
            "cost":             [{"resource":"Research","amount":50}],
            "requiresTech":     ["Zolarg Base","Gold Storage"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Communal Finance",
            "description":      "communialfin-desc",
            "icon":             "ind-insectcoin.png",
            "cost":             [{"resource":"Research","amount":75}],
            "requiresTech":     ["Zolarg Base","Gold Storage","Sugarpower"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Antanium Production",
            "description":      "antanium-prod-desc",
            "icon":             "ind-antanium.png",
            "cost":             [{"resource":"Research","amount":75}],
            "requiresTech":     ["Zolarg Base","Gold Storage"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Regeneration",
            "description":      "insregen-desc",
            "icon":             "healingpods.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["Communal Finance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Digging",
            "description":      "advdig-desc",
            "icon":             "wetmound.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["Antanium Production"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Wood Harvesting",
            "description":      "woodharvesting-desc",
            "icon":             "ind-wood.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Insectoid Regeneration"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Zolarg Communications",
            "description":      "zolargcomm-desc",
            "icon":             "ind-zolargcomm.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Governance",
            "description":      "zolgov-desc",
            "icon":             "zolargstatue.png",
            "cost":             [{"resource":"Research","amount":2000}],
            "requiresTech":     ["Zolarg Communications"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ore Enrichment",
            "description":      "oreenrichtech-desc",
            "icon":             "oreenrichmentfacility.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Advanced Digging"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Metallurgy",
            "description":      "advmetalurgy-desc",
            "icon":             "ind-aluminum.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Advanced Digging"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Plant Genetics",
            "description":      "plantgen-desc",
            "icon":             "megatree.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Wood Harvesting"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Mysticism",
            "description":      "mysticism-desc",
            "icon":             "ind-antaura.png",
            "cost":             [{"resource":"Research","amount":3000}],
            "requiresTech":     ["Insectoid Governance"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Bureaucracy",
            "description":      "insbeu-desc",
            "icon":             "highercommand.png",
            "cost":             [{"resource":"Research","amount":3000}],
            "requiresTech":     ["Insectoid Governance","Advanced Metallurgy"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Open Doors",
            "description":      "opendoors-desc",
            "icon":             "ind-tourist.png",
            "cost":             [{"resource":"Research","amount":10000}],
            "requiresTech":     ["Insectoid Bureaucracy"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        }
    ],
    "buildings": [
        {
            "name":             "Lander",
            "tile":             ["lander"],
            "cost":             null,
            "description":      "lander-description",
            "produces":         ["Rover","Lunar Rover","Forest Rover"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":50},{"resource":"Water","amount":400},{"resource":"Wood","amount":400},{"resource":"Ore","amount":1200},{"resource":"Regolith","amount":1200},{"resource":"Charcoal","amount":1200}],
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Regolith","output":"Regolith"},{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":3}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  2,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lander.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  [],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    3,
                    "c":    "#FFF3E0",
                    "i":    .25,
                    "nightonly": false
                }
            ],
            "packsTo":          "Airborne Lander",
            "canBuildOver":     null
        },
        {
            "name":             "路面",
            "tile":             ["pavement"],
            "cost":             [{"resource":"Ore","amount":1}],
            "description":      "pavement-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"pavement-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Red Planet Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "筒仓",
            "tile":             ["silo"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "silo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":250},{"resource":"Sugar","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "silo.png",
            "canUpgradeTo":     "Large Silo",
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "矿山",
            "tile":             ["mine"],
            "cost":             [{"resource":"Ore","amount":500}],
            "description":      "mine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Ore Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Red Planet Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "mine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "温室",
            "tile":             ["greenhouseworking","greenhouse"],
            "cost":             [{"resource":"Ore","amount":35}],
            "description":      "greenhouse-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     1000,
            "generateAmount":   7,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":50}],
            "sellValue":        [{"resource":"Ore","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"greenhouse-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Botanist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小型大气发生器",
            "tile":             ["atmosgen"],
            "cost":             [{"resource":"Ore","amount":700},{"resource":"Steel","amount":20}],
            "description":      "atmosgen-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     750,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":280}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"atmosgen-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "atmosgen.png",
            "canUpgradeTo":     "Medium Atmosphere Generator",
            "transModeColor":   "#81D4FA",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","地球化"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小型车辆厂",
            "tile":             ["factory"],
            "cost":             [{"resource":"Ore","amount":350}],
            "description":      "factory-description",
            "produces":         ["Rover","Lunar Rover","Sugar Rover","Forest Rover","Waterbot","Builder Bot","Advanced Builder Bot","Greenbot","Megabot","Extraterrestrial Builder","Lumberbot","Claybot","Ore Miner","Regolith Miner","Gold Miner","Diamond Miner","Crudebot","Small Rover Transport","Aluminum Miner","Uranium Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":160}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"smveh-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "factory.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "矿石炼油厂",
            "tile":             ["refinery"],
            "cost":             [{"resource":"Ore","amount":1200}],
            "description":      "refinery-description",
            "produces":         ["Ore Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":8000},{"resource":"Ore","amount":16000}],
            "sellValue":        [{"resource":"Ore","amount":500}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Steel","time":1500,"ratio":5},
            "firstBuildMessage":"orerefinery-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "refinery.png",
            "canUpgradeTo":     "Advanced Ore Refinery",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小太阳能电池板",
            "tile":             ["panel1"],
            "cost":             [{"resource":"Ore","amount":150}],
            "description":      "small-panel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":70}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":8}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"solarpanel-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base|Asteroid Base|Abandoned World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "panel1.png",
            "canUpgradeTo":     "Solar Tower",
            "transModeColor":   "#FFA000",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "着陆台",
            "tile":             ["landingpad"],
            "cost":             [{"resource":"Ore","amount":1000}],
            "description":      "landing-pad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       6000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"landingpad-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "landingpad.png",
            "canUpgradeTo":     "星门",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","移民"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.4,
                    "y":    0.4,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    1.2,
                    "y":    0.1,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    2.18,
                    "y":    0.45,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    0,
                    "y":    1.2,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    2.5,
                    "y":    1.5,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    0.4,
                    "y":    2.2,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    1.5,
                    "y":    2.6,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    2.3,
                    "y":    2.3,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小住房",
            "tile":             ["smallshelter"],
            "cost":             [{"resource":"Ore","amount":200}],
            "description":      "small-shelter-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  3,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "smallshelter.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#E1F5FE",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "印章店",
            "tile":             ["chopshop"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":10}],
            "description":      "chop-shop-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"chopshop-firstbuild-tut",
            "isChopShop":       true,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "chopshop.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "炼油厂",
            "tile":             ["goldrefinery"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":80}],
            "description":      "goldrefinery-description",
            "produces":         ["Gold Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":5000}],
            "sellValue":        [{"resource":"Money","amount":850},{"resource":"Steel","amount":30}],
            "sellWarning":      null,
            "refines":          [{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":"goldrefin-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "goldrefinery.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "金薄荷",
            "tile":             ["goldsmelter"],
            "cost":             [{"resource":"Ore","amount":2200},{"resource":"Steel","amount":100}],
            "description":      "goldsmelter-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Steel","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Money","time":2000,"ratio":14},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "goldsmelter.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小型研究实验室",
            "tile":             ["smalllab"],
            "cost":             [{"resource":"Ore","amount":1800},{"resource":"Steel","amount":80},{"resource":"Gold","amount":25}],
            "description":      "smalllab-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":"smresearch-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "smalllab.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "先进的水培中心",
            "tile":             ["advancedhydro"],
            "cost":              [{"resource":"Ore","amount":2400},{"resource":"Steel","amount":120},{"resource":"Gold","amount":40}],
            "description":      "advancedhydro-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     1000,
            "generateAmount":   75,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":150}],
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":40},{"resource":"Gold","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["先进的水培"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Botanist",
            "indicator":        "advancedhydro.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "太阳能塔",
            "tile":             ["solartower"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Steel","amount":300},{"resource":"Gold","amount":300}],
            "description":      "solar-tower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Steel","amount":100},{"resource":"Gold","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":45}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["高密度太阳能电池板","United Earth Base|Asteroid Base|Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "solartower.png",
            "canUpgradeTo":     "Diamond Solar Tower",
            "transModeColor":   "#FFA000",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "硬化的路面",
            "tile":             ["pavement2"],
            "cost":             [{"resource":"Ore","amount":4},{"resource":"Steel","amount":1}],
            "description":      "pavement2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["先进的小规模建设"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement2.png",
            "canUpgradeTo":     "Dark Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "大筒仓",
            "tile":             ["largesilo"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Steel","amount":35}],
            "description":      "silo2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":1500},{"resource":"Sugar","amount":1500}],
            "sellValue":        [{"resource":"Ore","amount":50},{"resource":"Steel","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "largesilo.png",
            "canUpgradeTo":     "Subterranean Food Storage",
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "绿色圆顶",
            "tile":             ["greendome"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Steel","amount":350}],
            "description":      "greendome-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":275},{"resource":"Steel","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       8,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "greendome.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "先进的矿石精炼厂",
            "tile":             ["refinery2"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":600},{"resource":"Gold","amount":200}],
            "description":      "refinery2-description",
            "produces":         ["Ore Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":50000},{"resource":"Ore","amount":100000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":75}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore","output":"Steel","time":1200,"ratio":28},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["先进的小规模建设","先进的矿石净化"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "refinery2.png",
            "canUpgradeTo":     "古代外星人矿石精炼厂",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "金矿",
            "tile":             ["goldmine"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":150}],
            "description":      "goldmine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "金矿",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["先进的小规模建设","Advanced Gold Mining"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "goldmine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "住宅区",
            "tile":             ["rescomplex"],
            "cost":             [{"resource":"Ore","amount":3200},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":650}],
            "description":      "rescomplex-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   10,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":400},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  26,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "rescomplex.png",
            "canUpgradeTo":     "住宅塔",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "质量司机",
            "tile":             ["massdriver"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2500}],
            "description":      "massdriver-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   5,
            "tileWidth":        7,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":45}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["United Earth Base","先进的小规模建设","殖民金融理论"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Food","Water","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Steel","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "massdriver.png",
            "canUpgradeTo":     "银河货运",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    100,
            "upkeepCost":       0.0,
            "giftCapacity":     100,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "芯片工厂",
            "tile":             ["chipfactory"],
            "cost":             [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "description":      "chipfactory-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   26,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Microchip","time":20000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    85,
            "requiresTech":     ["先进的小规模建设","殖民金融理论","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "chipfactory.png",
            "canUpgradeTo":     "先进的芯片工厂",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "中等大气发生器",
            "tile":             ["atmosgen2"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":2600},{"resource":"Gold","amount":1500}],
            "description":      "atmosgen2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     750,
            "generateAmount":   45,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":1100},{"resource":"Gold","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["先进的小规模建设","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "atmosgen2.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#81D4FA",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","地球化"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "文娱中心",
            "tile":             ["civiccenter"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":5}],
            "description":      "civiccenter-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":15000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["殖民金融理论","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "civiccenter.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "雕像",
            "tile":             ["statue1"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500}],
            "description":      "statue1-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "矿石开采作业",
            "tile":             ["orefracking"],
            "cost":             [{"resource":"Ore","amount":7000},{"resource":"Water","amount":400},{"resource":"Steel","amount":3500},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":25}],
            "description":      "fracking-description",
            "produces":         null,
            "generates":        "Ore",
            "generateTime":     1000,
            "generateAmount":   50,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":1100},{"resource":"Gold","amount":1100},{"resource":"Microchip","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":45}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   14,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Red Planet Base","先进的矿石净化","先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "黄金合成实验室",
            "tile":             ["gldsynth"],
            "cost":             [{"resource":"Ore","amount":4500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":60}],
            "description":      "gldsynth-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":55}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore","output":"Gold","time":1200,"ratio":15},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["先进的矿石净化","先进的小规模建设","Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "gldsynth.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "鱼孵化场",
            "tile":             ["hatchery"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":800},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":250}],
            "description":      "hatchery-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     1400,
            "generateAmount":   400,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":400}],
            "sellValue":        [{"resource":"Ore","amount":1300},{"resource":"Steel","amount":1600},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":36}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   14,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Atmospheric Zoology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "大气冷凝器",
            "tile":             ["atmoscondensor"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":2500},{"resource":"Gold","amount":3000},{"resource":"Microchip","amount":50}],
            "description":      "atmoscondensor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1400},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Atmosphere","output":"Water","time":600,"ratio":60},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["先进的小规模建设","Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "atmoscondensor.png",
            "canUpgradeTo":     "古代外星人凝汽器",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "水箱",
            "tile":             ["smalltank"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "smalltank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":1500}],
            "sellValue":        [{"resource":"Ore","amount":8}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "smalltank.png",
            "canUpgradeTo":     "Water Tower",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小水泵",
            "tile":             ["waterpump"],
            "cost":             [{"resource":"Ore","amount":45}],
            "description":      "waterpump-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     300,
            "generateAmount":   3,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Red Planet Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "waterpump.png",
            "canUpgradeTo":     "Atmosphere Condenser",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "铝精炼厂",
            "tile":             ["aluminumrefinery"],
            "cost":             [{"resource":"Ore","amount":1200},{"resource":"Water","amount":500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":850},{"resource":"Microchip","amount":200}],
            "description":      "aluminumrefinery-description",
            "produces":         ["Aluminum Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":25000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Aluminum","output":"Aluminum"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   13,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "aluminum-refinery.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "水塔",
            "tile":             ["watertower"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Steel","amount":90}],
            "description":      "watertower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":7000}],
            "sellValue":        [{"resource":"Ore","amount":45},{"resource":"Steel","amount":30}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "watertower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "核反应堆",
            "tile":             ["nuclearplant"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Water","amount":2000},{"resource":"Steel","amount":5500},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":450}],
            "description":      "nuclearplant-description",
            "produces":         ["Uranium Miner"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Water","amount":800},{"resource":"Steel","amount":2200},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":300},{"resource":"Microchip","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":4000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   45,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Advanced Nuclear Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Uranium"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "nuclear-plant.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "细菌农场",
            "tile":             ["bacteriafarm"],
            "cost":             [{"resource":"Ore","amount":8500},{"resource":"Water","amount":900},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":45}],
            "description":      "bacteriafarm-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   160,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Water","amount":350},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":800},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":7}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":65}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Advanced Microbiology","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Botanist",
            "indicator":        "bacteriafarm.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#81D4FA",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","地球化","农业"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "冷杉木",
            "tile":             ["firtrees"],
            "cost":             [{"resource":"Water","amount":20}],
            "description":      "firtrees-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Fir Trees",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "firtrees.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "医疗诊所",
            "tile":             ["medicalclinic"],
            "cost":             [{"resource":"Ore","amount":1900},{"resource":"Steel","amount":95},{"resource":"Gold","amount":30},{"resource":"Civics","amount":50}],
            "description":      "medicalclinic-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":550},{"resource":"Steel","amount":35},{"resource":"Gold","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "medical-clinic.png",
            "canUpgradeTo":     "Large Medical Clinic",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            6,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Lumber Mill",
            "tile":             ["lumbermill"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":600},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":5}],
            "description":      "lumbermill-description",
            "produces":         ["Lumberbot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":12500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    6,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "lumbermill.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "墙",
            "tile":             ["wall"],
            "cost":             [{"resource":"Ore","amount":40},{"resource":"Steel","amount":5}],
            "description":      "wall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "wall.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "林场",
            "tile":             ["treefarm"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Water","amount":6000},{"resource":"Wood","amount":850}],
            "description":      "treefarm-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     5000,
            "generateAmount":   1,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":6000}],
            "sellValue":        [{"resource":"Ore","amount":40},{"resource":"Water","amount":50},{"resource":"Wood","amount":400},{"resource":"Steel","amount":150},{"resource":"Gold","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water","output":"Wood","time":1200,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["先进的小规模建设","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Botanist",
            "indicator":        "treefarm.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","农业"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "单亲家庭",
            "tile":             ["sfhouse"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "sfhouse-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  6,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["先进的小规模建设","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "sfhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Water Tower",
            "tile":             ["lgwatertower"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Wood","amount":200},{"resource":"Steel","amount":900},{"resource":"Aluminum","amount":200}],
            "description":      "lgwatertower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":90000}],
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Wood","amount":75},{"resource":"Steel","amount":400},{"resource":"Aluminum","amount":80}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lgwatertower.png",
            "canUpgradeTo":     "Quantum Water Tower",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -2.9,
                    "y":    -2.9,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                },
                {
                    "x":    -2.1,
                    "y":    -2.6,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                },
                {
                    "x":    -2.5,
                    "y":    -2.05,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                },
                {
                    "x":    -3.35,
                    "y":    -2.1,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                },
                {
                    "x":    -3.5,
                    "y":    -2.85,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                },
                {
                    "x":    -3.1,
                    "y":    -3.35,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                },
                {
                    "x":    -2.2,
                    "y":    -3.35,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "铀浓缩设施",
            "tile":             ["uraniumenrichment"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Water","amount":1000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":2000}],
            "description":      "urenrich-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Water","amount":400},{"resource":"Steel","amount":2400},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":80}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   70,
            "requiresWorkers":  true,
            "smelts":           {"input":"Uranium","output":"Uranium","time":12000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["Advanced Nuclear Physics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Aluminum"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "uraniumenrichment.png",
            "canUpgradeTo":     "异形浓缩设施",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Aluminum","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "大型住宅区",
            "tile":             ["largeres"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Water","amount":600},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":320}],
            "description":      "largeres-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   50,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Water","amount":50},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       0,
            "providesShelter":  320,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "largeres.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "国会大厦",
            "tile":             ["capitol"],
            "cost":             [{"resource":"Ore","amount":16000},{"resource":"Water","amount":1200},{"resource":"Wood","amount":1200},{"resource":"Steel","amount":14000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":950},{"resource":"Civics","amount":3000}],
            "description":      "capitol-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Wood","amount":500},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":750},{"resource":"Microchip","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   80,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["United Earth Base","殖民金融理论","Colonial Civics","Large Scale Construction","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol.png",
            "canUpgradeTo":     "国会大厦2级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    1,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Subterranean Food Storage",
            "tile":             ["subtfood"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Clay","amount":800},{"resource":"Wood","amount":200},{"resource":"Steel","amount":900},{"resource":"Aluminum","amount":200}],
            "description":      "subtfood-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":12000},{"resource":"Sugar","amount":12000}],
            "sellValue":        [{"resource":"Ore","amount":250},{"resource":"Wood","amount":80},{"resource":"Steel","amount":350},{"resource":"Aluminum","amount":90}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "subtfood.png",
            "canUpgradeTo":     "Quantum Food Storage",
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "银行",
            "tile":             ["bank"],
            "cost":             [{"resource":"Money","amount":1500},{"resource":"Ore","amount":5500},{"resource":"Steel","amount":2900},{"resource":"Gold","amount":2200},{"resource":"Microchip","amount":15},{"resource":"Civics","amount":200}],
            "description":      "bank-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":40000}],
            "sellValue":        [{"resource":"Money","amount":1600},{"resource":"Ore","amount":2400},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":900},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Money","time":8000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["殖民金融理论","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        "bank.png",
            "canUpgradeTo":     "投资银行",
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "银河贸易委员会",
            "tile":             ["boardoftrade"],
            "cost":             [{"resource":"Money","amount":15000},{"resource":"Ore","amount":10000},{"resource":"Water","amount":900},{"resource":"Wood","amount":400},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":850},{"resource":"Microchip","amount":1400},{"resource":"Civics","amount":2000}],
            "description":      "boardoftrade-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   25,
            "tileWidth":        3,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":10000},{"resource":"Ore","amount":3500},{"resource":"Wood","amount":50},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":90}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   45,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["United Earth Base","Large Scale Construction","Galactic Commerce","Long Range Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        "boardoftrade.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": true,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    500,
            "upkeepCost":       0.0,
            "giftCapacity":     500,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pyramid of the All Seeing Eye",
            "tile":             ["pyramideye"],
            "cost":             [{"resource":"Money","amount":10000},{"resource":"Ore","amount":50000},{"resource":"Water","amount":6000},{"resource":"Clay","amount":1500},{"resource":"Bricks","amount":4000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":15000},{"resource":"Aluminum","amount":1000},{"resource":"Civics","amount":9000}],
            "description":      "pyramideye-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        6,
            "tileHeight":       6,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":       [{"resource":"Ore","amount":8000},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":1000},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    200,
            "requiresTech":     ["Colonial Tourism","Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       600,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pyramideye.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","娱乐","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    25,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "考古挖掘站点",
            "tile":             ["digsite"],
            "cost":             [{"resource":"Money","amount":20000},{"resource":"Ore","amount":95000},{"resource":"Water","amount":10000},{"resource":"Wood","amount":10000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":30000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":1500},{"resource":"Civics","amount":10000}],
            "description":      "digsite-description",
            "produces":         null,
            "generates":        "Alien Artifact",
            "generateTime":     150000,
            "generateAmount":   1,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":215}],
            "sellValue":        [{"resource":"Ore","amount":25000},{"resource":"Wood","amount":3000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   75,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    180,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "digsite.png",
            "canUpgradeTo":     "超深挖掘网站",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "铝发电机",
            "tile":             ["aluminumgenerator"],
            "cost":             [{"resource":"Ore","amount":45000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":80000},{"resource":"Microchip","amount":25000},{"resource":"Alien Artifact","amount":150}],
            "description":      "aluminumgenerator-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":30000}],
            "sellValue":        [{"resource":"Ore","amount":20000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":30000},{"resource":"Microchip","amount":200},{"resource":"Alien Artifact","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":850}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Steel","output":"Aluminum","time":8000,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":450},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "乔治阿尔外研究所",
            "tile":             ["giorgioinstitute"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Wood","amount":1200},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":150},{"resource":"Aluminum","amount":250},{"resource":"Uranium","amount":1},{"resource":"Microchip","amount":2000},{"resource":"Civics","amount":5000}],
            "description":      "giorgioinstitute-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1800,
            "generateAmount":   8,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":750},{"resource":"Alien Relic","amount":750}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Wood","amount":300},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":60},{"resource":"Aluminum","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    350,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Alien Artifact"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Scientist",
            "indicator":        "giorgioinstitute.png",
            "canUpgradeTo":     "人工学习中心",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "领事馆",
            "tile":             ["consulate"],
            "cost":             [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":3500},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":10},{"resource":"Civics","amount":150}],
            "description":      "consulate-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   3,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":1500},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["United Earth Base","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate.png",
            "canUpgradeTo":     "Consulate Level 2",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     300,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    1,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "酒厂",
            "tile":             ["distillery"],
            "cost":             [{"resource":"Water","amount":120},{"resource":"Ore","amount":200},{"resource":"Steel","amount":20}],
            "description":      "distillery-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":50}],
            "sellValue":        [{"resource":"Water","amount":20},{"resource":"Ore","amount":80},{"resource":"Steel","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Rum","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    4,
            "requiresTech":     ["微重力酿造"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "distillery.png",
            "canUpgradeTo":     "Quantum Distillery",
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Water","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "朗姆酒地窖",
            "tile":             ["rumcellar"],
            "cost":             [{"resource":"Ore","amount":30},{"resource":"Steel","amount":5}],
            "description":      "rumcellar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":350}],
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Steel","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Microgravity Brewing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "rumcellar.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "互联网中继摊位",
            "tile":             ["relaybooth"],
            "cost":             [{"resource":"Ore","amount":180}],
            "description":      "relaybooth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"internetbooth-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       2,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "relaybooth.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       85,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "酒吧",
            "tile":             ["pub"],
            "cost":             [{"resource":"Rum","amount":100},{"resource":"Ore","amount":450},{"resource":"Steel","amount":50}],
            "description":      "pub-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":10}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    6,
            "requiresTech":     ["Microgravity Brewing"],
            "canRenderStatic":  false,
            "entertains":       12,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pub.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Decorative Fir Trees",
            "tile":             ["decfirtrees"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":3},{"resource":"Ore","amount":3}],
            "description":      "decfirtrees-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "decfirtrees.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "克隆设施",
            "tile":             ["cloningfacility"],
            "cost":             [{"resource":"Water","amount":5000},{"resource":"Ore","amount":9500},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":4000},{"resource":"Microchip","amount":500}],
            "description":      "cloningfacility-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1200},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       25000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Human Cloning"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "粘土矿",
            "tile":             ["claymine"],
            "cost":             [{"resource":"Water","amount":5000},{"resource":"Ore","amount":2000},{"resource":"Steel","amount":1000}],
            "description":      "claymine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "粘土矿",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["先进的小规模建设","Clay Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "claymine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "陶器工程",
            "tile":             ["potteryworks"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":600},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":5}],
            "description":      "potteryworks-description",
            "produces":         ["Claybot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Clay","amount":2500},{"resource":"Pottery","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Clay","output":"Clay"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Clay","output":"Pottery","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Clay Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "potteryworks.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#deaa87",
            "requiresFuel":     {"resource":"Water","rate":1400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "耐用品仓库",
            "tile":             ["warehouse"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":500},{"resource":"Gold","amount":100}],
            "description":      "warehouse-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":3000},{"resource":"Wool","amount":3000},{"resource":"Diamond","amount":3000},{"resource":"Crystalline","amount":3000},{"resource":"Rum","amount":3000},{"resource":"Pottery","amount":3000},{"resource":"Bricks","amount":3000},{"resource":"Cloth","amount":3000},{"resource":"Plastic","amount":3000},{"resource":"Toy","amount":3000},{"resource":"Microchip","amount":3000},{"resource":"Alien Artifact","amount":3000},{"resource":"Robot","amount":3000},{"resource":"Ant Paste","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "warehouse.png",
            "canUpgradeTo":     ["Tall Brick Warehouse"],
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "地下住房模块",
            "tile":             ["subhousing"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Clay","amount":1500},{"resource":"Water","amount":7000},{"resource":"Steel","amount":14000},{"resource":"Gold","amount":8000},{"resource":"Aluminum","amount":2500},{"resource":"Uranium","amount":500},{"resource":"Pottery","amount":450},{"resource":"Microchip","amount":1200}],
            "description":      "subhousing-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3000,
            "generateAmount":   450,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Water","amount":70},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  1000,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "subhousing.png",
            "canUpgradeTo":     "生态建筑学",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "先进的芯片工厂",
            "tile":             ["chipfactory2"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "description":      "chipfactory2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":2500}],
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":115}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Microchip","time":10000,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Large Scale Construction","殖民金融理论","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "chipfactory2.png",
            "canUpgradeTo":     "古老的外星微芯片工厂",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "古老的外星微芯片工厂",
            "tile":             ["chipfactory3"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Steel","amount":55000},{"resource":"Gold","amount":75000},{"resource":"Aluminum","amount":4500},{"resource":"Uranium","amount":10000},{"resource":"Microchip","amount":18000},{"resource":"Alien Artifact","amount":120}],
            "description":      "chipfactory3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":12000}],
            "sellValue":        [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   45,
            "requiresWorkers":  true,
            "smelts":           {"input":"Alien Artifact","output":"Microchip","time":25000,"ratio":1600},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    240,
            "requiresTech":     ["Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "chipfactory3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":450},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "砖厂",
            "tile":             ["brickfactory"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":600},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":5}],
            "description":      "brickfactory-description",
            "produces":         ["Claybot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Clay","amount":2500},{"resource":"Bricks","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Clay","output":"Clay"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           {"input":"Clay","output":"Bricks","time":2000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["先进的小规模建设","Clay Production","Low Gravity Masonry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "brickfactory.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#deaa87",
            "requiresFuel":     {"resource":"Water","rate":1400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "砖路",
            "tile":             ["pavement3"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Bricks","amount":1}],
            "description":      "brickroad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    4,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Low Gravity Masonry"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "pavement3.png",
            "canUpgradeTo":     ["Yellow Brick Road"],
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "黄砖路",
            "tile":             ["pavement4"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Bricks","amount":2},{"resource":"Gold","amount":2}],
            "description":      "ybrickroad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    10,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Low Gravity Masonry","Advanced Gold Mining"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "pavement4.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Tall Brick Warehouse",
            "tile":             ["warehouse2"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Clay","amount":1500},{"resource":"Bricks","amount":5000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1500}],
            "description":      "warehouse2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":10000},{"resource":"Steel","amount":10000},{"resource":"Wool","amount":10000},{"resource":"Diamond","amount":10000},{"resource":"Crystalline","amount":10000},{"resource":"Rum","amount":10000},{"resource":"Pottery","amount":10000},{"resource":"Bricks","amount":10000},{"resource":"Cloth","amount":10000},{"resource":"Plastic","amount":10000},{"resource":"Toy","amount":10000},{"resource":"Microchip","amount":10000},{"resource":"Alien Artifact","amount":10000},{"resource":"Robot","amount":10000},{"resource":"Ant Paste","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Clay","amount":600},{"resource":"Bricks","amount":2000},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":650}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Low Gravity Masonry","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "warehouse2.png",
            "canUpgradeTo":     "Quantum Warehouse",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "砖房子",
            "tile":             ["brickhouse"],
            "cost":             [{"resource":"Bricks","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "brickhouse-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Bricks","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  6,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["先进的小规模建设","Advanced Microbiology","Low Gravity Masonry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "brickhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "绵羊农场",
            "tile":             ["sheepfarm"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Water","amount":6500},{"resource":"Clay","amount":400},{"resource":"Wood","amount":950},{"resource":"Steel","amount":500},{"resource":"Gold","amount":20},{"resource":"Microchip","amount":6}],
            "description":      "sheepfarm-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        6,
            "tileHeight":       6,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wool","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":40},{"resource":"Water","amount":50},{"resource":"Wood","amount":400},{"resource":"Steel","amount":150},{"resource":"Gold","amount":6},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":5}],
            "colGenRate":       0,
            "providesShelter":  4,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water","output":"Wool","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Gravity Husbandry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "Botanist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","农业"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "纺织厂",
            "tile":             ["textilemill"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Wood","amount":1000},{"resource":"Clay","amount":1000},{"resource":"Bricks","amount":4000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1500},{"resource":"Microchip","amount":60}],
            "description":      "textilemill-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wool","amount":250},{"resource":"Cloth","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Wood","amount":400},{"resource":"Clay","amount":250},{"resource":"Bricks","amount":1000},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":400},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Wool","output":"Cloth","time":7000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    18,
            "requiresTech":     ["Low Gravity Masonry","Low Gravity Husbandry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Synthetic Textile Mill",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "服装血汗工厂",
            "tile":             ["sweatshop"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Cloth","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "description":      "sweatshop-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     25000,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Cloth","amount":300}],
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":160}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   240,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":30000,"ratio":30},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Large Scale Construction","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "sweatshop.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "豪华大厦",
            "tile":             ["luxtower"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Water","amount":600},{"resource":"Wood","amount":6500},{"resource":"Clay","amount":2000},{"resource":"Bricks","amount":2500},{"resource":"Rum","amount":2000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":320},{"resource":"Pottery","amount":1500},{"resource":"Cloth","amount":3000}],
            "description":      "luxtower-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   35,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Water","amount":50},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  200,
            "canChain":         false,
            "acceptsWorkers":   160,
            "requiresWorkers":  false,
            "smelts":           {"input":"Money","output":"Money","time":10000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    240,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       80,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "White Collar",
            "indicator":        "luxtower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     {"resource":"Rum","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "古代外星人凝汽器",
            "tile":             ["aliencondensor"],
            "cost":             [{"resource":"Ore","amount":25000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":17000},{"resource":"Aluminum","amount":1500},{"resource":"Uranium","amount":6500},{"resource":"Microchip","amount":10000},{"resource":"Alien Artifact","amount":40}],
            "description":      "aliencondensor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1400},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":950}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Atmosphere","output":"Water","time":350,"ratio":1200},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    700,
            "requiresTech":     ["Ancient Alien Manufacturing","Climate Science Theory"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    4,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Atmosphere","rate":2},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "氢气反应器",
            "tile":             ["hydropower"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Water","amount":15000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":4000},{"resource":"Aluminum","amount":3500},{"resource":"Microchip","amount":6500}],
            "description":      "hydropower-description",
            "produces":         ["Waterbot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Water","amount":800},{"resource":"Steel","amount":2200},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":300},{"resource":"Microchip","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":5500}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Advanced Nuclear Physics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Water"],
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "hydropower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Water","rate":2},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "大公园",
            "tile":             ["largepark"],
            "cost":             [{"resource":"Water","amount":35000},{"resource":"Wood","amount":12000},{"resource":"Ore","amount":1500},{"resource":"Clay","amount":1600}],
            "description":      "largepark-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       9,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":275}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       350,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "largepark.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Water Pool",
            "tile":             ["water1"],
            "cost":             [{"resource":"Water","amount":60}],
            "description":      "waterpool-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Water Pool",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Lander of Liberty",
            "tile":             ["lol"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1500},{"resource":"Aluminum","amount":500}],
            "description":      "lol-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Tourism"],
            "canRenderStatic":  false,
            "entertains":       40,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lol.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","旅游"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    10,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "统治雕像",
            "tile":             ["statue2"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Steel","amount":300},{"resource":"Gold","amount":600}],
            "description":      "statue2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Red Flower Garden",
            "tile":             ["flowersred"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowersred-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-red.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "金庇护所",
            "tile":             ["goldenshelter"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Gold","amount":150}],
            "description":      "goldenshelter-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":80},{"resource":"Gold","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  4,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "goldenshelter.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#E1F5FE",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Medical Clinic",
            "tile":             ["largeclinic"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":500},{"resource":"Gold","amount":120},{"resource":"Aluminum","amount":120},{"resource":"Civics","amount":100},{"resource":"Microchip","amount":15}],
            "description":      "largeclinic-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":150},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":40},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "largeclinic.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            24,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "时髦酒吧",
            "tile":             ["hipsterbar"],
            "cost":             [{"resource":"Rum","amount":250},{"resource":"Ore","amount":600},{"resource":"Steel","amount":120},{"resource":"Bricks","amount":850}],
            "description":      "hipsterbar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":20}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":7}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    12,
            "requiresTech":     ["Microgravity Brewing","Low Gravity Masonry"],
            "canRenderStatic":  false,
            "entertains":       36,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "hipsterbar.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum","rate":550},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":20,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Warehouse",
            "tile":             ["warehouse3"],
            "cost":             [{"resource":"Ore","amount":30000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":35000},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":9000},{"resource":"Microchip","amount":16000},{"resource":"Alien Artifact","amount":200}],
            "description":      "warehouse3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":150000},{"resource":"Steel","amount":150000},{"resource":"Wool","amount":150000},{"resource":"Diamond","amount":150000},{"resource":"Crystalline","amount":150000},{"resource":"Rum","amount":150000},{"resource":"Pottery","amount":150000},{"resource":"Bricks","amount":150000},{"resource":"Cloth","amount":150000},{"resource":"Plastic","amount":150000},{"resource":"Toy","amount":150000},{"resource":"Microchip","amount":150000},{"resource":"Alien Artifact","amount":150000},{"resource":"Robot","amount":150000},{"resource":"Ant Paste","amount":150000},{"resource":"Gold","amount":150000},{"resource":"Uranium","amount":150000},{"resource":"Aluminum","amount":150000},{"resource":"Clay","amount":150000},{"resource":"Ore","amount":150000},{"resource":"Regolith","amount":150000}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":900}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "warehouse3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":750},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品","存储","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Water Tower",
            "tile":             ["quantumwater"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Steel","amount":1200},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":3000},{"resource":"Microchip","amount":9000},{"resource":"Alien Artifact","amount":100}],
            "description":      "quantumwater-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":650000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Steel","amount":600},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "quantumwater.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     {"resource":"Water","rate":950},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","存储","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "砖墙",
            "tile":             ["brickwall"],
            "cost":             [{"resource":"Ore","amount":35},{"resource":"Steel","amount":10},{"resource":"Bricks","amount":35}],
            "description":      "brickwall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "brickwall.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小氦3提取器",
            "tile":             ["helextractor"],
            "cost":             [{"resource":"Regolith","amount":100}],
            "description":      "helextractor-description",
            "produces":         [],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":150},{"resource":"Regolith","amount":200}],
            "sellValue":        [{"resource":"Regolith","amount":25}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Regolith","output":"Helium 3","time":300,"ratio":2},
            "firstBuildMessage":"he3-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "helextractor.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.1,
                    "y":    0.1,
                    "r":    0.2,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    0.3,
                    "y":    0.1,
                    "r":    0.2,
                    "c":    "#0000ff",
                    "i":    0.3,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "表层压实机",
            "tile":             ["regcompact"],
            "cost":             [{"resource":"Regolith","amount":120},{"resource":"Helium 3","amount":20}],
            "description":      "regcompact-description",
            "produces":         [],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":500},{"resource":"Regolith","amount":500}],
            "sellValue":        [{"resource":"Regolith","amount":50}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Regolith","output":"Ore","time":75,"ratio":1},
            "firstBuildMessage":"reg-compactor-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Ore Synthesis Lab",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "水提取器",
            "tile":             ["waterextract"],
            "cost":             [{"resource":"Regolith","amount":100},{"resource":"Ore","amount":80}],
            "description":      "waterextract-description",
            "produces":         [],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Regolith","amount":200}],
            "sellValue":        [{"resource":"Regolith","amount":30},{"resource":"Ore","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Regolith","output":"Water","time":200,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "waterextract.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Helium 3","rate":700},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "被击碎的果树园路径",
            "tile":             ["regpath"],
            "cost":             [{"resource":"Regolith","amount":1}],
            "description":      "regpath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Lunar Base|Asteroid Base|Abandoned World Base|Ice World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "regpath.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "氦3坦克",
            "tile":             ["heltank"],
            "cost":             [{"resource":"Regolith","amount":60},{"resource":"Helium 3","amount":15}],
            "description":      "heltank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":600}],
            "sellValue":        [{"resource":"Regolith","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "heltank.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#cccccc",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","存储","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Regolith Mine",
            "tile":             ["regmine"],
            "cost":             [{"resource":"Regolith","amount":500}],
            "description":      "regmine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Regolith Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Lunar Base|Asteroid Base|Abandoned World Base|Ice World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "regmine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "木屋",
            "tile":             ["woodhut"],
            "cost":             [{"resource":"Wood","amount":175}],
            "description":      "woodhut-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  2,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "woodhut.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "水井",
            "tile":             ["waterwell"],
            "cost":             [{"resource":"Wood","amount":50}],
            "description":      "waterwell-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     400,
            "generateAmount":   3,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":200}],
            "sellValue":        [{"resource":"Wood","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"waterwell-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "waterwell.png",
            "canUpgradeTo":     "Atmosphere Condenser",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "土豆片",
            "tile":             ["potatopatch"],
            "cost":             [{"resource":"Water","amount":10},{"resource":"Wood","amount":20}],
            "description":      "potatopatch-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     750,
            "generateAmount":   20,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":50}],
            "sellValue":        [{"resource":"Wood","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"potpatch-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "potatopatch.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     {"resource":"Water","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","农业"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "木炭小屋",
            "tile":             ["charcoalhut"],
            "cost":             [{"resource":"Wood","amount":300}],
            "description":      "charcoalhut-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":400},{"resource":"Charcoal","amount":100}],
            "sellValue":        [{"resource":"Wood","amount":120}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Wood","output":"Charcoal","time":800,"ratio":2},
            "firstBuildMessage":"charchut-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "charcoalhut.png",
            "canUpgradeTo":     "Charcoal Factory",
            "transModeColor":   "#333333",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "木炭压实机",
            "tile":             ["coalcompact"],
            "cost":             [{"resource":"Wood","amount":150},{"resource":"Charcoal","amount":5}],
            "description":      "coalcompact-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":300}],
            "sellValue":        [{"resource":"Wood","amount":50}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Charcoal","output":"Ore","time":75,"ratio":1},
            "firstBuildMessage":"charccompact-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "coalcompact.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "木炭燃烧器",
            "tile":             ["coalburn"],
            "cost":             [{"resource":"Wood","amount":150},{"resource":"Ore","amount":80},{"resource":"Charcoal","amount":10}],
            "description":      "coalburn-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Charcoal","amount":250}],
            "sellValue":        [{"resource":"Wood","amount":40},{"resource":"Ore","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":50}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"charcoalburn-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "coalburn.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Charcoal","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "木炭厂",
            "tile":             ["charfactory"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Ore","amount":600},{"resource":"Steel","amount":500}],
            "description":      "charfactory-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":1400},{"resource":"Charcoal","amount":350}],
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Ore","amount":200},{"resource":"Steel","amount":130}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":7}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Wood","output":"Charcoal","time":600,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Charcoal Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "charfactory.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#333333",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "覆盖的木路径",
            "tile":             ["mulchpath"],
            "cost":             [{"resource":"Wood","amount":1}],
            "description":      "mulchpath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Forest World Base|Abandoned World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "mulchpath.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "油箱",
            "tile":             ["oiltank"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Charcoal","amount":40},{"resource":"Steel","amount":60}],
            "description":      "oiltank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":900}],
            "sellValue":        [{"resource":"Ore","amount":6},{"resource":"Charcoal","amount":2},{"resource":"Steel","amount":15}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Low Gravity Manufacturing","Low Gravity Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "oiltank.png",
            "canUpgradeTo":     "Quantum Oil Tank",
            "transModeColor":   "#222222",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Purple Flower Garden",
            "tile":             ["flowerspurple"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowerspurple-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-purple.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Blue Flower Garden",
            "tile":             ["flowersblue"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowersblue-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-blue.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "White Flower Garden",
            "tile":             ["flowerswhite"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowerswhite-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-white.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "油厂",
            "tile":             ["oilplant"],
            "cost":             [{"resource":"Wood","amount":1500},{"resource":"Charcoal","amount":2000},{"resource":"Ore","amount":6000},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2500},{"resource":"Oil","amount":450},{"resource":"Microchip","amount":50}],
            "description":      "oilplant-description",
            "produces":         ["Crudebot"],
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   6,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":2000}],
            "sellValue":        [{"resource":"Wood","amount":40},{"resource":"Ore","amount":1200},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":600},{"resource":"Oil","amount":120},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":700}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   24,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Low Gravity Manufacturing","Low Gravity Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Oil"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "oilplant.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Oil","rate":200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Grass",
            "tile":             ["grass"],
            "cost":             [{"resource":"Water","amount":2}],
            "description":      "grass-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "grass.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Food Storage",
            "tile":             ["quantumfood"],
            "cost":             [{"resource":"Ore","amount":580},{"resource":"Steel","amount":1100},{"resource":"Aluminum","amount":1800},{"resource":"Uranium","amount":2800},{"resource":"Microchip","amount":8000},{"resource":"Alien Artifact","amount":85}],
            "description":      "quantumfood-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":300000},{"resource":"Sugar","amount":300000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Steel","amount":600},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     {"resource":"Water","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物","存储","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "黑暗的路面",
            "tile":             ["pavement5"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Steel","amount":2},{"resource":"Charcoal","amount":2},{"resource":"Regolith","amount":2},{"resource":"Oil","amount":2}],
            "description":      "pavement5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    12,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Advanced Charcoal Production"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "pavement5.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "合成油实验室",
            "tile":             ["oilsynthlab"],
            "cost":             [{"resource":"Wood","amount":1000},{"resource":"Charcoal","amount":2500},{"resource":"Ore","amount":7500},{"resource":"Steel","amount":6500},{"resource":"Gold","amount":4000},{"resource":"Microchip","amount":250}],
            "description":      "oilsynthlab-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":1000}],
            "sellValue":        [{"resource":"Wood","amount":15},{"resource":"Charcoal","amount":50},{"resource":"Ore","amount":3000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1500},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":65}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Charcoal","output":"Oil","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Gravity Manufacturing","Low Gravity Oil Production","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "oilsynthlab.png",
            "canUpgradeTo":     "先进的合成油实验室",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":250},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "塑料厂",
            "tile":             ["plastfact"],
            "cost":             [{"resource":"Ore","amount":14500},{"resource":"Charcoal","amount":2000},{"resource":"Steel","amount":10000},{"resource":"Oil","amount":4000},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":2200},{"resource":"Microchip","amount":1800}],
            "description":      "plastfact-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Oil","output":"Plastic","time":10000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Large Scale Construction","殖民金融理论","Low Gravity Manufacturing","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "plastfact.png",
            "canUpgradeTo":     "先进的塑料厂",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "玩具工厂",
            "tile":             ["sweatshop2"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800},{"resource":"Plastic","amount":250}],
            "description":      "sweatshop2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     25000,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Toy","amount":350}],
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":160}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   240,
            "requiresWorkers":  true,
            "smelts":           {"input":"Plastic","output":"Toy","time":30000,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Large Scale Construction","Low Gravity Manufacturing","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "sweatshop2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "太空港",
            "tile":             ["spaceport"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":750},{"resource":"Gold","amount":750},{"resource":"Microchip","amount":100},{"resource":"Civics","amount":50}],
            "description":      "spaceport-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":300},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       9000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["Colonial Tourism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "spaceport.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Civics","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "汽车旅馆",
            "tile":             ["motel"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Steel","amount":500},{"resource":"Microchip","amount":12}],
            "description":      "motel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    7,
            "requiresTech":     ["Colonial Tourism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "motel.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    12,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -.5,
                    "y":    .15,
                    "r":    .4,
                    "c":    "#FFEE58",
                    "i":    .4,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "旅馆",
            "tile":             ["hotel"],
            "cost":             [{"resource":"Ore","amount":900},{"resource":"Steel","amount":2000},{"resource":"Cloth","amount":120},{"resource":"Microchip","amount":120}],
            "description":      "hotel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":350},{"resource":"Steel","amount":750},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    7,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "hotel.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":3,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    120,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小赌场",
            "tile":             ["smcasino"],
            "cost":             [{"resource":"Money","amount":2000},{"resource":"Steel","amount":1500},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":2000}],
            "description":      "smcasino-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     8000,
            "generateAmount":   8,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":1500},{"resource":"Steel","amount":600},{"resource":"Gold","amount":800},{"resource":"Microchip","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "smcasino.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    100,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "礼品店",
            "tile":             ["giftshop"],
            "cost":             [{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1000},{"resource":"Pottery","amount":100}],
            "description":      "giftshop-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":500},{"resource":"Gold","amount":350},{"resource":"Pottery","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Pottery","output":"Money","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "giftshop.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    5,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Zoo",
            "tile":             ["zoo"],
            "cost":             [{"resource":"Wood","amount":100000},{"resource":"Cloth","amount":25000},{"resource":"Steel","amount":50000},{"resource":"Bricks","amount":100000}],
            "description":      "zoo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        8,
            "tileHeight":       8,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":12000},{"resource":"Cloth","amount":6000},{"resource":"Steel","amount":14000},{"resource":"Bricks","amount":15000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":425}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   70,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Low Gravity Husbandry","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       150,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "zoo.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Pottery","rate":3000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    750,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "蓝色房子",
            "tile":             ["bluehouse"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "bluehouse-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  7,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["先进的小规模建设","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "bluehouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "网纹路面",
            "tile":             ["pavement6"],
            "cost":             [{"resource":"Ore","amount":2}],
            "description":      "pavement6-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement6.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Yellow Flower Garden",
            "tile":             ["flowersyellow"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowersyellow-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-yellow.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Obelisk of Colonial Independence",
            "tile":             ["obeliskindependence"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":2500},{"resource":"Gold","amount":7500},{"resource":"Aluminum","amount":500}],
            "description":      "obelisk-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       50,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "obeliskindependence.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","旅游"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    6,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "餐厅",
            "tile":             ["restaurant"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Steel","amount":500},{"resource":"Cloth","amount":100}],
            "description":      "restaurant-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Cloth","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Money","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "restaurant.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    15,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "大型度假胜地",
            "tile":             ["resort"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":50000},{"resource":"Cloth","amount":2000},{"resource":"Microchip","amount":1200}],
            "description":      "resort-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":10000},{"resource":"Cloth","amount":50},{"resource":"Microchip","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   100,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "resort.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":5,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    1200,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "户外商场",
            "tile":             ["mall"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Steel","amount":100000},{"resource":"Gold","amount":40000},{"resource":"Bricks","amount":75000},{"resource":"Microchip","amount":15000}],
            "description":      "mall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        10,
            "tileHeight":       10,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":35000},{"resource":"Gold","amount":15000},{"resource":"Bricks","amount":10000},{"resource":"Microchip","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   500,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":18000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       100,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "mall.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Toy","rate":750},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    2000,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "博物馆",
            "tile":             ["museum"],
            "cost":             [{"resource":"Steel","amount":10000},{"resource":"Bricks","amount":10000},{"resource":"Aluminum","amount":2500}],
            "description":      "museum-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":3000},{"resource":"Bricks","amount":3000},{"resource":"Aluminum","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":75}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       100,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "musuem.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Pottery","rate":1500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":3,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "银河货运",
            "tile":             ["galfreight"],
            "cost":             [{"resource":"Ore","amount":8000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":5000},{"resource":"Oil","amount":250},{"resource":"Microchip","amount":1000}],
            "description":      "galfreight-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3500,
            "generateAmount":   8,
            "tileWidth":        7,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":2000},{"resource":"Oil","amount":40},{"resource":"Microchip","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":220}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["United Earth Base","Large Scale Construction","Galactic Commerce","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Steel","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "canExport":        ["Food","Water","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Steel","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "galfreight.png",
            "canUpgradeTo":     "太空电梯",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Oil","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    1000,
            "upkeepCost":       0.0,
            "giftCapacity":     1000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue of Unbridled Excess",
            "tile":             ["statue3"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Money","amount":175000000}],
            "description":      "statue3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":50,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    10,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "超深挖掘网站",
            "tile":             ["digsite2"],
            "cost":             [{"resource":"Money","amount":30000},{"resource":"Ore","amount":115000},{"resource":"Water","amount":40000},{"resource":"Wood","amount":20000},{"resource":"Steel","amount":70000},{"resource":"Gold","amount":50000},{"resource":"Aluminum","amount":3000},{"resource":"Microchip","amount":100000},{"resource":"Civics","amount":20000},{"resource":"Alien Artifact","amount":500}],
            "description":      "digsite2-description",
            "produces":         null,
            "generates":        "Alien Artifact",
            "generateTime":     100000,
            "generateAmount":   2,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":25000},{"resource":"Wood","amount":3000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   60,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water","output":"Clay","time":20000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    380,
            "requiresTech":     ["Ultra Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "木炭堆",
            "tile":             ["charcoalpile"],
            "cost":             [{"resource":"Charcoal","amount":200}],
            "description":      "charcoalpile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Charcoal","amount":10000}],
            "sellValue":        [{"resource":"Charcoal","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "charcoalpile.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#333333",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Alien Power Tower",
            "tile":             ["alienpower"],
            "cost":             [{"resource":"Water","amount":25000},{"resource":"Helium 3","amount":650},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":60000},{"resource":"Aluminum","amount":4500},{"resource":"Uranium","amount":4500},{"resource":"Microchip","amount":40000},{"resource":"Alien Artifact","amount":950}],
            "description":      "alienpower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":6000}],
            "sellValue":        [{"resource":"Water","amount":8000},{"resource":"Helium 3","amount":40},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":800},{"resource":"Uranium","amount":100},{"resource":"Microchip","amount":6},{"resource":"Alien Artifact","amount":12}],
            "sellWarning":      null,
            "refines":          [{"input":"Helium 3","output":"Helium 3"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":45000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    250,
            "requiresTech":     ["Alien Quantum Physics","Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Helium 3"],
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "alienpower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Helium 3","rate":200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -4.2,
                    "y":    -4.2,
                    "r":    .6,
                    "c":    "#9C27B0",
                    "i":    .4,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "彩虹路",
            "tile":             ["pavement7"],
            "cost":             [{"resource":"Toy","amount":20}],
            "description":      "pavement7-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    14,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement7.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "丘",
            "tile":             ["mound"],
            "cost":             null,
            "description":      "mound-description",
            "produces":         ["Queen","Worker Drone","Tundrabug","Extremeobug","Obsidiobug","Waterbug","Orebug","Goldbug","Lumberbug","Alumibug","Ancientbug"],
            "generates":        "Food",
            "generateTime":     600,
            "generateAmount":   5,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":200},{"resource":"Sugar","amount":200},{"resource":"Food","amount":200},{"resource":"Water","amount":400},{"resource":"Crystalline","amount":400},{"resource":"Ore","amount":2000},{"resource":"Regolith","amount":2000},{"resource":"Charcoal","amount":2000}],
            "sellValue":        [{"resource":"Money","amount":10}],
            "sellWarning":      null,
            "refines":          [{"input":"Obsidian","output":"Obsidian"},{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Sugar","output":"Sugar"},{"input":"Crystalline","output":"Crystalline"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       4000,
            "providesShelter":  200,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Food","time":300,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "mound.png",
            "canUpgradeTo":     "Unholy Mound of Worship",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          "Queen",
            "canBuildOver":     null
        },
        {
            "name":             "宴席区",
            "tile":             ["feastingarea"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Sugar","amount":200}],
            "description":      "feastingarea-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":400},{"resource":"Food","amount":400}],
            "sellValue":        [{"resource":"Sugar","amount":100}],
            "sellWarning":      null,
            "refines":          [{"input":"Sugar","output":"Sugar"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Food","time":300,"ratio":8},
            "firstBuildMessage":"feastarea-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "feastingarea.png",
            "canUpgradeTo":     "食品强化设施",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Communal Water Vats",
            "tile":             ["watervats"],
            "cost":             [{"resource":"Ore","amount":450},{"resource":"Water","amount":100}],
            "description":      "watervats-description",
            "produces":         ["Waterbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":800}],
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"communalvats-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "watervats.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "浆池",
            "tile":             ["pastetank"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Water","amount":300}],
            "description":      "pastetank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ant Paste","amount":600}],
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Ant Paste","time":500,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pastetank.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Path",
            "tile":             ["pastepath"],
            "cost":             [{"resource":"Ore","amount":1},{"resource":"Ant Paste","amount":1}],
            "description":      "pastepath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    3,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"pavement-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pastepath.png",
            "canUpgradeTo":     "Aluminum Road",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "育雏培训中心",
            "tile":             ["broodcenter"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Sugar","amount":300},{"resource":"Ant Paste","amount":300}],
            "description":      "broodcenter-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":"smresearch-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "broodcenter.png",
            "canUpgradeTo":     "Spire of Knowledge",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gold Burrow",
            "tile":             ["goldburrow"],
            "cost":             [{"resource":"Ore","amount":1200},{"resource":"Ant Paste","amount":700}],
            "description":      "goldburrow-description",
            "produces":         ["Goldbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":4000}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          [{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Gold Storage"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "goldburrow.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "糖燃烧器",
            "tile":             ["sugarpower"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Ant Paste","amount":300},{"resource":"Gold","amount":200}],
            "description":      "sugarpower-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     9000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100},{"resource":"Gold","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":14}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Sugarpower"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "sugarpower.png",
            "canUpgradeTo":     "电源尖顶",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Sugar","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFF3E0",
                    "i":    0.25,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "昆虫薄荷",
            "tile":             ["insectoidmint"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Ant Paste","amount":800},{"resource":"Gold","amount":200}],
            "description":      "insectoidmint-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     9000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Gold","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Money","time":2000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "insectoidmint.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    1,
                    "r":    1.4,
                    "c":    "#FFB300",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sugarcane",
            "tile":             ["sugarcane"],
            "cost":             [{"resource":"Water","amount":30}],
            "description":      "sugarcane-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Sugarcane",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Sugar Cultivation|LIS Base","Sugarland Base|Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "sugarcane.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "钛冶炼厂",
            "tile":             ["antaniumsmelter"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Ant Paste","amount":800},{"resource":"Gold","amount":200}],
            "description":      "antaniumsmelter-description",
            "produces":         ["Orebug","Goldbug"],
            "generates":        "Atmosphere",
            "generateTime":     7500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Antanium","amount":1500},{"resource":"Ore","amount":2000},{"resource":"Gold","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Gold","amount":40}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":7}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore","output":"Antanium","time":1000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Antanium Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "antanium-smelter.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Gold","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    1.8,
                    "r":    0.6,
                    "c":    "#FFB300",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Elders Mound",
            "tile":             ["eldersmound"],
            "cost":             [{"resource":"Ore","amount":800},{"resource":"Gold","amount":800},{"resource":"Antanium","amount":800},{"resource":"Ant Paste","amount":1000}],
            "description":      "eldersmound-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     8500,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Gold","amount":200},{"resource":"Antanium","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  20,
            "canChain":         false,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "eldersmound.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "采矿作业",
            "tile":             ["miningoperation"],
            "cost":             [{"resource":"Water","amount":1500},{"resource":"Antanium","amount":450},{"resource":"Ant Paste","amount":1500},{"resource":"Civics","amount":250}],
            "description":      "miningoperation-description",
            "produces":         null,
            "generates":        "Gold",
            "generateTime":     5000,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":3500},{"resource":"Gold","amount":3500}],
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water","output":"Ore","time":5000,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "miningoperation.png",
            "canUpgradeTo":     "Unholy Core Mine",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue of Emperor Zolarg",
            "tile":             ["zolargstatue"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":500}],
            "description":      "zolargstatue-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "zolargstatue.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "食品强化设施",
            "tile":             ["foodfortification"],
            "cost":             [{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":1800},{"resource":"Civics","amount":400}],
            "description":      "foodfortification-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":1500}],
            "sellValue":        [{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   15,
            "requiresWorkers":  false,
            "smelts":           {"input":"Food","output":"Food","time":500,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Antanium Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "foodfortification.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ant Paste","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "国会大厦2级",
            "tile":             ["capitol2"],
            "cost":             [{"resource":"Ore","amount":30000},{"resource":"Water","amount":2000},{"resource":"Rum","amount":1500},{"resource":"Wood","amount":2000},{"resource":"Cloth","amount":2000},{"resource":"Bricks","amount":6000},{"resource":"Steel","amount":30000},{"resource":"Pottery","amount":2000},{"resource":"Gold","amount":20000},{"resource":"Aluminum","amount":3500},{"resource":"Microchip","amount":3000},{"resource":"Civics","amount":10000}],
            "description":      "capitol2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Wood","amount":300},{"resource":"Cloth","amount":300},{"resource":"Bricks","amount":650},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":750},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   110,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["United Earth Base","Solar Governance","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol2.png",
            "canUpgradeTo":     "国会大厦3级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     5000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "国会大厦3级",
            "tile":             ["capitol3"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Water","amount":4000},{"resource":"Rum","amount":6000},{"resource":"Wood","amount":6000},{"resource":"Cloth","amount":6000},{"resource":"Bricks","amount":12000},{"resource":"Steel","amount":60000},{"resource":"Pottery","amount":6000},{"resource":"Gold","amount":45000},{"resource":"Plastic","amount":8000},{"resource":"Aluminum","amount":7000},{"resource":"Microchip","amount":10000},{"resource":"Civics","amount":20000}],
            "description":      "capitol3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":8000},{"resource":"Wood","amount":260},{"resource":"Cloth","amount":1000},{"resource":"Bricks","amount":900},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":300},{"resource":"Microchip","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":140}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   130,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":85},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["United Earth Base","Galactic Governance","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol3.png",
            "canUpgradeTo":     "国会大厦4级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":350},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     50000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    3,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "领事馆2级",
            "tile":             ["consulate2"],
            "cost":             [{"resource":"Ore","amount":16000},{"resource":"Steel","amount":16000},{"resource":"Gold","amount":6000},{"resource":"Pottery","amount":400},{"resource":"Microchip","amount":100},{"resource":"Civics","amount":400}],
            "description":      "consulate2-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   4,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":2000},{"resource":"Pottery","amount":4},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["United Earth Base","Solar Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate2b.png",
            "canUpgradeTo":     "Consulate Level 3",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     3000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "领事馆3级",
            "tile":             ["consulate3"],
            "cost":             [{"resource":"Ore","amount":25000},{"resource":"Steel","amount":25000},{"resource":"Gold","amount":12000},{"resource":"Pottery","amount":1200},{"resource":"Microchip","amount":500},{"resource":"Civics","amount":1000}],
            "description":      "consulate3-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":3000},{"resource":"Pottery","amount":10},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   7,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["United Earth Base","Galactic Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate3b.png",
            "canUpgradeTo":     "领事馆4级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     30000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    3,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "砂",
            "tile":             ["sand"],
            "cost":             [{"resource":"Ore","amount":1},{"resource":"Clay","amount":1}],
            "description":      "sand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "sand.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "国会大厦4级",
            "tile":             ["capitol4"],
            "cost":             [{"resource":"Money","amount":100000},{"resource":"Ore","amount":90000},{"resource":"Water","amount":8000},{"resource":"Rum","amount":16000},{"resource":"Helium 3","amount":1000},{"resource":"Charcoal","amount":1000},{"resource":"Wood","amount":16000},{"resource":"Cloth","amount":10000},{"resource":"Bricks","amount":20000},{"resource":"Steel","amount":90000},{"resource":"Pottery","amount":14000},{"resource":"Gold","amount":90000},{"resource":"Plastic","amount":20000},{"resource":"Aluminum","amount":16000},{"resource":"Microchip","amount":25000},{"resource":"Civics","amount":40000}],
            "description":      "capitol4-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Water","amount":800},{"resource":"Helium 3","amount":10},{"resource":"Wood","amount":160},{"resource":"Cloth","amount":1000},{"resource":"Bricks","amount":2000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":1600},{"resource":"Microchip","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   160,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":95},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    160,
            "requiresTech":     ["United Earth Base","Nationalism","Large Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol4.png",
            "canUpgradeTo":     "国会大厦5级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":20,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    30,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "红旗",
            "tile":             ["flag1"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "蓝旗",
            "tile":             ["flag2"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "绿旗",
            "tile":             ["flag3"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "紫旗",
            "tile":             ["flag4"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag4.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "国会大厦5级",
            "tile":             ["capitol5"],
            "cost":             [{"resource":"Money","amount":200000},{"resource":"Ore","amount":200000},{"resource":"Water","amount":20000},{"resource":"Rum","amount":25000},{"resource":"Helium 3","amount":5000},{"resource":"Charcoal","amount":10000},{"resource":"Oil","amount":7500},{"resource":"Wood","amount":25000},{"resource":"Cloth","amount":30000},{"resource":"Bricks","amount":60000},{"resource":"Steel","amount":200000},{"resource":"Pottery","amount":30000},{"resource":"Gold","amount":200000},{"resource":"Plastic","amount":50000},{"resource":"Aluminum","amount":30000},{"resource":"Microchip","amount":50000},{"resource":"Civics","amount":100000}],
            "description":      "capitol5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Water","amount":800},{"resource":"Helium 3","amount":10},{"resource":"Wood","amount":160},{"resource":"Cloth","amount":1000},{"resource":"Bricks","amount":2000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":1600},{"resource":"Microchip","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":260}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   200,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":105},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    200,
            "requiresTech":     ["United Earth Base","Imperialism","Large Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol5.png",
            "canUpgradeTo":     "国会大厦6级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":50},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":30,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    40,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     5000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    5,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Healing Pods",
            "tile":             ["healingpods"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":200},{"resource":"Ant Paste","amount":200},{"resource":"Gold","amount":80},{"resource":"Civics","amount":50}],
            "description":      "healingpods-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Antanium","amount":10},{"resource":"Gold","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Insectoid Regeneration"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "healingpods.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            3,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "糖农场",
            "tile":             ["sugarfarm"],
            "cost":             [{"resource":"Water","amount":2500},{"resource":"Ore","amount":1200},{"resource":"Antanium","amount":800},{"resource":"Ant Paste","amount":800},{"resource":"Sugar","amount":800},{"resource":"Civics","amount":15}],
            "description":      "sugarfarm-description",
            "produces":         null,
            "generates":        "Sugar",
            "generateTime":     1500,
            "generateAmount":   15,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":600}],
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Antanium","amount":200},{"resource":"Ant Paste","amount":20},{"resource":"Sugar","amount":700}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Sugar Cultivation","Antanium Production","Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "sugarfarm.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":1500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "酿造坑",
            "tile":             ["brewpit"],
            "cost":             [{"resource":"Water","amount":120},{"resource":"Ore","amount":200},{"resource":"Antanium","amount":20}],
            "description":      "distillery-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":50}],
            "sellValue":        [{"resource":"Water","amount":20},{"resource":"Ore","amount":80},{"resource":"Antanium","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Rum","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    4,
            "requiresTech":     ["Insectoid Brewing","Antanium Production","Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "brewpit.png",
            "canUpgradeTo":     "不洁酿造坑",
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Water","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gentelbugs Club",
            "tile":             ["gentelbugsclub"],
            "cost":             [{"resource":"Rum","amount":100},{"resource":"Ore","amount":450},{"resource":"Ant Paste","amount":250},{"resource":"Antanium","amount":50}],
            "description":      "gentelbugs-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":10}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    6,
            "requiresTech":     ["Insectoid Brewing","Antanium Production","Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       12,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "gentelbugsclub.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.3,
                    "y":    0.1,
                    "r":    0.4,
                    "c":    "#E91E63",
                    "i":    0.35,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Helium 3 Tank",
            "tile":             ["lghe3"],
            "cost":             [{"resource":"Regolith","amount":1000},{"resource":"Ore","amount":500},{"resource":"Steel","amount":900},{"resource":"Aluminum","amount":120}],
            "description":      "lghe3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":6800}],
            "sellValue":        [{"resource":"Regolith","amount":100},{"resource":"Ore","amount":75},{"resource":"Steel","amount":350}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lghe3.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#cccccc",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "纪念匾",
            "tile":             ["plaque"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500}],
            "description":      "plaque-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "plaque.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "国会大厦6级",
            "tile":             ["capitol6"],
            "cost":             [{"resource":"Money","amount":500000},{"resource":"Ore","amount":450000},{"resource":"Water","amount":35000},{"resource":"Rum","amount":40000},{"resource":"Helium 3","amount":9500},{"resource":"Toy","amount":1000},{"resource":"Charcoal","amount":20000},{"resource":"Oil","amount":15000},{"resource":"Wood","amount":40000},{"resource":"Cloth","amount":55000},{"resource":"Bricks","amount":90000},{"resource":"Steel","amount":500000},{"resource":"Pottery","amount":55000},{"resource":"Gold","amount":400000},{"resource":"Plastic","amount":75000},{"resource":"Aluminum","amount":55000},{"resource":"Microchip","amount":80000},{"resource":"Robot","amount":100},{"resource":"Civics","amount":250000}],
            "description":      "capitol6-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":12000},{"resource":"Water","amount":900},{"resource":"Helium 3","amount":20},{"resource":"Wood","amount":200},{"resource":"Cloth","amount":2500},{"resource":"Bricks","amount":3000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":12000},{"resource":"Aluminum","amount":2500},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":300}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   280,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":130},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    280,
            "requiresTech":     ["United Earth Base","Galactic Imperialism","Tall Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       15,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol6.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":30},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":35,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     50000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    6,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "太空电梯",
            "tile":             ["elevator"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":15000},{"resource":"Oil","amount":300},{"resource":"Plastic","amount":9000},{"resource":"Microchip","amount":5000},{"resource":"Robot","amount":50}],
            "description":      "elevator-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   20,
            "tileWidth":        7,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2500},{"resource":"Oil","amount":50},{"resource":"Microchip","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       4000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    200,
            "requiresTech":     ["United Earth Base","Tall Construction","Galactic Commerce","Solar Governance","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "canExport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "elevator.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Oil","rate":6000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济","移民"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    10000,
            "upkeepCost":       0.0,
            "giftCapacity":     10000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "机器人工厂",
            "tile":             ["robofactory"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Water","amount":800},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Plastic","amount":2000},{"resource":"Microchip","amount":9000}],
            "description":      "robofactory-description",
            "produces":         ["Construction Drone","Turbo Drone"],
            "generates":        "Atmosphere",
            "generateTime":     5000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Robot","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":600}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum","output":"Robot","time":9000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    300,
            "requiresTech":     ["Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Scientist",
            "indicator":        "robofactory.png",
            "canUpgradeTo":     "高级机器人公司",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "住宅塔",
            "tile":             ["restower"],
            "cost":             [{"resource":"Ore","amount":18000},{"resource":"Steel","amount":85000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":2500},{"resource":"Pottery","amount":1500},{"resource":"Cloth","amount":1500},{"resource":"Plastic","amount":2500},{"resource":"Toy","amount":1100},{"resource":"Robot","amount":10},{"resource":"Microchip","amount":400}],
            "description":      "restower-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3000,
            "generateAmount":   400,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":       [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":800},{"resource":"Aluminum","amount":40},{"resource":"Pottery","amount":10},{"resource":"Cloth","amount":10},{"resource":"Plastic","amount":5},{"resource":"Toy","amount":6},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":390}],
            "colGenRate":       0,
            "providesShelter":  1100,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    350,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "restower.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "领事馆4级",
            "tile":             ["consulate4"],
            "cost":             [{"resource":"Ore","amount":45000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":20000},{"resource":"Wood","amount":1500},{"resource":"Pottery","amount":1800},{"resource":"Microchip","amount":700},{"resource":"Civics","amount":2500}],
            "description":      "consulate3-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   8,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Steel","amount":450},{"resource":"Gold","amount":200},{"resource":"Wood","amount":15},{"resource":"Pottery","amount":18},{"resource":"Microchip","amount":7}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   9,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    18,
            "requiresTech":     ["United Earth Base","Nationalism","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate4.png",
            "canUpgradeTo":     "领事馆5级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     300000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "湿丘",
            "tile":             ["wetmound"],
            "cost":             [{"resource":"Antanium","amount":45}],
            "description":      "wetmound-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     300,
            "generateAmount":   5,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Digging"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "wetmound.png",
            "canUpgradeTo":     "湿锥",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "钱坑",
            "tile":             ["moneypit"],
            "cost":             [{"resource":"Money","amount":1500},{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":1800},{"resource":"Gold","amount":1800},{"resource":"Civics","amount":250}],
            "description":      "moneypit-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1800,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":5000}],
            "sellValue":        [{"resource":"Money","amount":200},{"resource":"Ore","amount":800},{"resource":"Antanium","amount":800},{"resource":"Gold","amount":900}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Money","time":8000,"ratio":7},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Advanced Digging","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "moneypit.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "出口大炮",
            "tile":             ["exportcannon"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Ant Paste","amount":1500},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":2000}],
            "description":      "exportcannon-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   4,
            "tileWidth":        3,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Antanium","amount":1000},{"resource":"Gold","amount":1100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Food","Water","Sugar","Rum","Ant Paste","Ore","Antanium","Gold"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "exportcannon.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    100,
            "upkeepCost":       0.0,
            "giftCapacity":     100,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "伐木场",
            "tile":             ["lumberyard"],
            "cost":             [{"resource":"Ore","amount":3200},{"resource":"Water","amount":500},{"resource":"Wood","amount":900},{"resource":"Steel","amount":1600},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":8}],
            "description":      "lumberyard-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     4000,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":60000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Wood","amount":800},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":5}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["殖民金融理论"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "lumberyard.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "恐怖之屋",
            "tile":             ["horrorhouse"],
            "cost":             [{"resource":"Steel","amount":1750},{"resource":"Aluminum","amount":150},{"resource":"Ore","amount":4000},{"resource":"Plastic","amount":50},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":50},{"resource":"Toy","amount":50}],
            "description":      "horrorhouse-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":60000}],
            "sellValue":        [{"resource":"Steel","amount":175},{"resource":"Aluminum","amount":15},{"resource":"Ore","amount":400},{"resource":"Plastic","amount":5},{"resource":"Gold","amount":200},{"resource":"Microchip","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "Blue Collar",
            "indicator":        "horrorhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Toy","rate":600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    5,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Regolith萃取公司",
            "tile":             ["regolithextractor"],
            "cost":             [{"resource":"Money","amount":3000},{"resource":"Ore","amount":2500},{"resource":"Steel","amount":4000},{"resource":"Aluminum","amount":2000},{"resource":"Water","amount":5000},{"resource":"Microchip","amount":150}],
            "description":      "regolithextractor-description",
            "produces":         null,
            "generates":        "Regolith",
            "generateTime":     1500,
            "generateAmount":   50,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":1000},{"resource":"Ore","amount":1000},{"resource":"Steel","amount":200},{"resource":"Aluminum","amount":50},{"resource":"Microchip","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   26,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Lunar Base|Abandoned World Base|Asteroid Base","先进的矿石净化","先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "regolithextractor.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "投资银行",
            "tile":             ["bank2"],
            "cost":             [{"resource":"Money","amount":2500000},{"resource":"Water","amount":40000},{"resource":"Ore","amount":300000},{"resource":"Steel","amount":400000},{"resource":"Gold","amount":800000},{"resource":"Oil","amount":12000},{"resource":"Wood","amount":45000},{"resource":"Cloth","amount":32000},{"resource":"Bricks","amount":11000},{"resource":"Pottery","amount":60000},{"resource":"Plastic","amount":50000},{"resource":"Aluminum","amount":25000},{"resource":"Microchip","amount":75000},{"resource":"Civics","amount":10000}],
            "description":      "bank2-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":500000}],
            "sellValue":        [{"resource":"Money","amount":250000},{"resource":"Water","amount":1800},{"resource":"Ore","amount":16000},{"resource":"Steel","amount":12000},{"resource":"Gold","amount":50000},{"resource":"Cloth","amount":1500},{"resource":"Bricks","amount":2000},{"resource":"Aluminum","amount":1800},{"resource":"Microchip","amount":50}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":360}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   500,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Money","time":5000,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Galactic Finance Theory","Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "White Collar",
            "indicator":        "bank2.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "钢铁场",
            "tile":             ["steelyard"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":500}],
            "description":      "steelyard-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     6000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":100000},{"resource":"Antanium","amount":100000},{"resource":"Triantanium","amount":100000},{"resource":"Aluminum","amount":100000}],
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["殖民金融理论","先进的矿石净化","先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "steelyard.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Subterranean Charcoal Cavern",
            "tile":             ["subtcharcoal"],
            "cost":             [{"resource":"Money","amount":20000},{"resource":"Ore","amount":2000},{"resource":"Helium 3","amount":2000},{"resource":"Gold","amount":20000},{"resource":"Wood","amount":2500},{"resource":"Steel","amount":10000},{"resource":"Plastic","amount":500},{"resource":"Microchip","amount":1000},{"resource":"Robot","amount":4}],
            "description":      "subtcharcoal-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Charcoal","amount":25000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Gold","amount":6000},{"resource":"Steel","amount":800},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "subtcharcoal.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#333333",
            "requiresFuel":     {"resource":"Helium 3","rate":5000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "商业坛",
            "tile":             ["altarofcommerce"],
            "cost":             [{"resource":"Money","amount":3000},{"resource":"Ore","amount":4000},{"resource":"Water","amount":2000},{"resource":"Ant Paste","amount":3000},{"resource":"Antanium","amount":8000},{"resource":"Gold","amount":5000},{"resource":"Civics","amount":600}],
            "description":      "altarofcommerce-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     6000,
            "generateAmount":   20,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":45}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Zolarg Communications","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       30,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "altarofcommerce.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": true,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    500,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "高级命令",
            "tile":             ["highcommand"],
            "cost":             [{"resource":"Money","amount":3500},{"resource":"Ore","amount":5000},{"resource":"Water","amount":1800},{"resource":"Ant Paste","amount":1000},{"resource":"Antanium","amount":10000},{"resource":"Gold","amount":7000},{"resource":"Civics","amount":3500}],
            "description":      "highcommand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Ant Paste","amount":40},{"resource":"Antanium","amount":6000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":35}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":16000,"ratio":50},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Insectoid Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "highcommand.png",
            "canUpgradeTo":     "Higher Command",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     4000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Supply Pile",
            "tile":             ["supplypile"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":400},{"resource":"Gold","amount":25}],
            "description":      "supplypile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":800},{"resource":"Sugar","amount":800},{"resource":"Food","amount":800},{"resource":"Water","amount":800},{"resource":"Steel","amount":800},{"resource":"Wool","amount":800},{"resource":"Rum","amount":800},{"resource":"Pottery","amount":800},{"resource":"Bricks","amount":800},{"resource":"Cloth","amount":800},{"resource":"Plastic","amount":800},{"resource":"Toy","amount":800},{"resource":"Microchip","amount":800},{"resource":"Alien Artifact","amount":800},{"resource":"Alien Relic","amount":800},{"resource":"Robot","amount":800},{"resource":"Ant Paste","amount":800},{"resource":"Antanium","amount":800},{"resource":"Wood","amount":800},{"resource":"Crystalline","amount":800},{"resource":"Diamond","amount":800},{"resource":"Triantanium","amount":800},{"resource":"Aluminum","amount":800},{"resource":"Uranium","amount":800},{"resource":"Gold","amount":800},{"resource":"Clay","amount":800},{"resource":"Ore","amount":2000},{"resource":"Regolith","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "supplypile.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "指挥所",
            "tile":             ["commandpost"],
            "cost":             [{"resource":"Money","amount":1000},{"resource":"Ore","amount":3000},{"resource":"Water","amount":1200},{"resource":"Ant Paste","amount":1000},{"resource":"Antanium","amount":3500},{"resource":"Gold","amount":4000},{"resource":"Civics","amount":200}],
            "description":      "commandpost-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   3,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Antanium","amount":800},{"resource":"Gold","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Insectoid Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "commandpost.png",
            "canUpgradeTo":     "高级指挥所",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     2500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "领事馆5级",
            "tile":             ["consulate5"],
            "cost":             [{"resource":"Ore","amount":60000},{"resource":"Rum","amount":6000},{"resource":"Helium 3","amount":1500},{"resource":"Charcoal","amount":5000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":35000},{"resource":"Wood","amount":3000},{"resource":"Pottery","amount":2500},{"resource":"Microchip","amount":900},{"resource":"Civics","amount":3000}],
            "description":      "consulate5-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   10,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":25000},{"resource":"Charcoal","amount":15},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":10000},{"resource":"Pottery","amount":8},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    26,
            "requiresTech":     ["United Earth Base","Imperialism","Large Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate5.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":25,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    15,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     3000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    5,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小体育场",
            "tile":             ["smstadium"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":3500},{"resource":"Food","amount":6000},{"resource":"Money","amount":5000},{"resource":"Water","amount":3000},{"resource":"Plastic","amount":250},{"resource":"Microchip","amount":450}],
            "description":      "smstadium-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":800},{"resource":"Gold","amount":1000},{"resource":"Plastic","amount":6},{"resource":"Microchip","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["先进的小规模建设","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       200,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "smstadium.png",
            "canUpgradeTo":     "中等体育场",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":20,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    25,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "合成纺织厂",
            "tile":             ["synthetictextiles"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Wood","amount":2500},{"resource":"Ant Paste","amount":1000},{"resource":"Clay","amount":2500},{"resource":"Bricks","amount":5000},{"resource":"Steel","amount":400},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":75}],
            "description":      "synthtext-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wool","amount":400},{"resource":"Cloth","amount":400},{"resource":"Ant Paste","amount":400}],
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Bricks","amount":800},{"resource":"Steel","amount":20},{"resource":"Antanium","amount":600},{"resource":"Gold","amount":600},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           {"input":"Wool","output":"Cloth","time":4000,"ratio":18},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Low Gravity Masonry","Low Gravity Husbandry","Xenomaterials Research"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "synthetictextiles.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ant Paste","rate":300},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "LIS Lander",
            "tile":             ["lislander"],
            "cost":             null,
            "description":      "lislander-description",
            "produces":         ["LIS Rover","Tundra Rover"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":40},{"resource":"Water","amount":300},{"resource":"Wood","amount":300},{"resource":"Crystalline","amount":300},{"resource":"Ore","amount":1200},{"resource":"Regolith","amount":1200},{"resource":"Charcoal","amount":1200}],
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "refines":          [{"input":"Crystalline","output":"Crystalline"},{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Regolith","output":"Regolith"},{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":2}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  2,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lislander.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  [],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    3,
                    "c":    "#FFF3E0",
                    "i":    .25,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Statue",
            "tile":             ["statue4"],
            "cost":             [{"resource":"Gold","amount":500},{"resource":"Alien Artifact","amount":1000}],
            "description":      "statue4-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue4.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Temple",
            "tile":             ["ancienttemple"],
            "cost":             [{"resource":"Gold","amount":5000},{"resource":"Alien Artifact","amount":10000}],
            "description":      "ancienttemple-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       20,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "ancienttemple.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    30,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         10,
            "providesIQ":       90,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "中等体育场",
            "tile":             ["medstadium"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Rum","amount":1000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":15000},{"resource":"Food","amount":12000},{"resource":"Money","amount":15000},{"resource":"Water","amount":8000},{"resource":"Plastic","amount":600},{"resource":"Microchip","amount":1000}],
            "description":      "medstadium-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":2000},{"resource":"Rum","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":3000},{"resource":"Plastic","amount":8},{"resource":"Microchip","amount":7}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   125,
            "requiresWorkers":  true,
            "smelts":           {"input":"Rum","output":"Money","time":1600,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Tall Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       1000,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "medstadium.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游","娱乐"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":40,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    500,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -1,
                    "y":    -1,
                    "r":    1.4,
                    "c":    "#FFFDE7",
                    "i":    .5,
                    "nightonly": true
                },
                {
                    "x":    2,
                    "y":    -1,
                    "r":    1.4,
                    "c":    "#FFFDE7",
                    "i":    .5,
                    "nightonly": true
                },
                {
                    "x":    1,
                    "y":    1,
                    "r":    1.6,
                    "c":    "#FFFDE7",
                    "i":    .2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Grass Scrub",
            "tile":             ["grass2"],
            "cost":             [{"resource":"Water","amount":125}],
            "description":      "grass2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "grass2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Yellow Sand",
            "tile":             ["sand2"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Clay","amount":1}],
            "description":      "sand2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "sand2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Orange Sand",
            "tile":             ["sand3"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Clay","amount":1}],
            "description":      "sand3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "sand3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mail Box",
            "tile":             ["mailbox"],
            "cost":             [{"resource":"Water","amount":125},{"resource":"Steel","amount":125}],
            "description":      "mailbox-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "mailbox.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Basket Ball Hoop",
            "tile":             ["hoops"],
            "cost":             [{"resource":"Water","amount":125},{"resource":"Steel","amount":500},{"resource":"Plastic","amount":100}],
            "description":      "hoops-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "hoops.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Oil Tank",
            "tile":             ["oiltank2"],
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Charcoal","amount":80},{"resource":"Steel","amount":90},{"resource":"Aluminum","amount":500},{"resource":"Uranium","amount":800},{"resource":"Microchip","amount":2000},{"resource":"Alien Artifact","amount":70}],
            "description":      "oiltank2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":45000}],
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Charcoal","amount":14},{"resource":"Steel","amount":25},{"resource":"Aluminum","amount":80},{"resource":"Uranium","amount":7},{"resource":"Microchip","amount":5},{"resource":"Alien Artifact","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics","Low Gravity Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "oiltank2.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#222222",
            "requiresFuel":     {"resource":"Water","rate":3000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "独立国家联盟的旗帜",
            "tile":             ["flag5"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["LIS Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag5.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "白旗",
            "tile":             ["flag6"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag6.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "黑旗",
            "tile":             ["flag7"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag7.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "温室",
            "tile":             ["greenhome"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "greenhome-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  7,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["先进的小规模建设","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "greenhome.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "食品加工血汗工厂",
            "tile":             ["sweatshop3"],
            "cost":             [{"resource":"Food","amount":6000},{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Sugar","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "description":      "sweatshop3-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     25000,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":400},{"resource":"Sugar","amount":400}],
            "sellValue":        [{"resource":"Ore","amount":1300},{"resource":"Steel","amount":1600},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":160}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   225,
            "requiresWorkers":  true,
            "smelts":           {"input":"Sugar","output":"Food","time":1400,"ratio":2000},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Large Scale Construction","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "sweatshop3.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "人造甜味剂厂",
            "tile":             ["sweetnerfactory"],
            "cost":             [{"resource":"Ore","amount":14500},{"resource":"Charcoal","amount":2000},{"resource":"Steel","amount":10000},{"resource":"Oil","amount":4000},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":2200},{"resource":"Microchip","amount":1800}],
            "description":      "sweetnerfactory-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Oil","output":"Sugar","time":10000,"ratio":12},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Large Scale Construction","殖民金融理论","Low Gravity Manufacturing","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "sweetnerfactory.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Aluminum","rate":1600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "矿石浓缩设施",
            "tile":             ["oreenrichmentfacility"],
            "cost":             [{"resource":"Water","amount":200},{"resource":"Antanium","amount":900},{"resource":"Ant Paste","amount":1200},{"resource":"Gold","amount":950}],
            "description":      "oreenrichmentfacility-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":300},{"resource":"Gold","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Ore","time":1000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Antanium Production","Ore Enrichment"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "oreenrichmentfacility.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Golden Sign",
            "tile":             ["goldsign"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":500}],
            "description":      "goldsign-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "goldsign.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cactus 1",
            "tile":             ["cactus1"],
            "cost":             [{"resource":"Water","amount":2000}],
            "description":      "cactus-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":2500}],
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "cactus1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cactus 2",
            "tile":             ["cactus2"],
            "cost":             [{"resource":"Water","amount":5000}],
            "description":      "cactus-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":5500}],
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "cactus2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cactus 3",
            "tile":             ["cactus3"],
            "cost":             [{"resource":"Water","amount":500}],
            "description":      "cactus3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "cactus3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "棕榈 1",
            "tile":             ["palm1"],
            "cost":             [{"resource":"Water","amount":75}],
            "description":      "palm-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     7000,
            "generateAmount":   15,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "palm1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "棕榈 2",
            "tile":             ["palm2"],
            "cost":             [{"resource":"Water","amount":100}],
            "description":      "palm-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     7000,
            "generateAmount":   30,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "palm2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sand Dune",
            "tile":             ["dune"],
            "cost":             [{"resource":"Ore","amount":500}],
            "description":      "dune-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "dune.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Deck Chairs",
            "tile":             ["deckchairs"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Wood","amount":500},{"resource":"Plastic","amount":50}],
            "description":      "deckchairs-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "deckchairs.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Desert Skull",
            "tile":             ["desertskull"],
            "cost":             [{"resource":"Ore","amount":1000}],
            "description":      "desertskull-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "desertskull.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "喷泉",
            "tile":             ["fountain"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":2500},{"resource":"Water","amount":1000}],
            "description":      "fountain-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "fountain.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "垂直仓库农场",
            "tile":             ["vertfarm"],
            "cost":             [{"resource":"Money","amount":15000},{"resource":"Water","amount":2800},{"resource":"Ore","amount":6000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":7000},{"resource":"Wood","amount":1000},{"resource":"Microchip","amount":500},{"resource":"Alien Artifact","amount":100}],
            "description":      "vertfarm-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     2500,
            "generateAmount":   500,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource": "Food","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":7000},{"resource":"Wood","amount":200},{"resource":"Microchip","amount":4},{"resource":"Alien Artifact","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "White Collar",
            "indicator":        "vertfarm.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     {"resource":"Water","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Lumber Camp",
            "tile":             ["lumbercamp"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":900},{"resource":"Gold","amount":1000},{"resource":"Ant Paste","amount":1200}],
            "description":      "lumbercamp-description",
            "produces":         ["Lumberbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":400},{"resource":"Gold","amount":400}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":5}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Wood Harvesting"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "lumbercamp.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "电源尖顶",
            "tile":             ["powerspire"],
            "cost":             [{"resource":"Wood","amount":500},{"resource":"Antanium","amount":1000},{"resource":"Ant Paste","amount":400},{"resource":"Gold","amount":250}],
            "description":      "powerspire-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":400},{"resource":"Gold","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":40}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Wood","output":"Atmosphere","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Sugarpower","Wood Harvesting","Antanium Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "powerspire.png",
            "canUpgradeTo":     "Unholy Power Spire",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Sugar","rate":1500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Presidential Statue",
            "tile":             ["statue5"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Steel","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Gold","amount":1800}],
            "description":      "statue5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3,
            "requiresTech":     ["United Earth Base","Nationalism","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       5,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue5.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            1,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    8,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "钻石精炼厂",
            "tile":             ["diamondrefinery"],
            "cost":             [{"resource":"Ore","amount":1200}],
            "description":      "diamondrefinery-description",
            "produces":         ["Diamond Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Diamond","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":500}],
            "sellWarning":      null,
            "refines":          [{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Diamond Mining"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "diamondrefinery.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "殖民地大会",
            "tile":             ["colonialassembly"],
            "cost":             [{"resource":"Ore","amount":12000},{"resource":"Steel","amount":12000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":100},{"resource":"Civics","amount":400}],
            "description":      "colonialassembly-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   4,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["LIS Base","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "colonialassembly.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     2500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "黑市集",
            "tile":             ["bmbazzar"],
            "cost":             [{"resource":"Regolith","amount":6000},{"resource":"Ore","amount":1000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":2500}],
            "description":      "bmbazzar-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3500,
            "generateAmount":   5,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":2600},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Food|Water|Rum|Wool|Wood|Cloth|Clay|Sugar|Ant Paste|Charcoal|Regolith|Ore|Steel|Antanium|Diamond|Gold|Aluminum|Oil|Helium 3|Plastic|Toy|Uranium|Pottery|Bricks|Microchip|Robot|Alien Artifact|Crystalline","time":7000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["LIS Base","先进的小规模建设","Black Markets"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Rum","Wool","Wood","Cloth","Clay","Sugar","Ant Paste","Charcoal","Regolith","Ore","Steel","Antanium","Diamond","Gold","Aluminum","Oil","Helium 3","Plastic","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact","Crystalline"],
            "canExport":        ["Food","Water","Rum","Wool","Wood","Cloth","Clay","Sugar","Ant Paste","Charcoal","Regolith","Ore","Steel","Antanium","Diamond","Gold","Aluminum","Oil","Helium 3","Plastic","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact","Crystalline"],
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "bmbazzar.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    250,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "铝蜂巢",
            "tile":             ["aluminumhive"],
            "cost":             [{"resource":"Ore","amount":1200},{"resource":"Wood","amount":500},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":850},{"resource":"Ant Paste","amount":1200}],
            "description":      "aluminumhive-description",
            "produces":         ["Alumibug"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":1200},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          [{"input":"Aluminum","output":"Aluminum"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   13,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "aluminumhive.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "珠宝店",
            "tile":             ["jewelrystore"],
            "cost":             [{"resource":"Steel","amount":1000},{"resource":"Gold","amount":1000},{"resource":"Diamond","amount":100}],
            "description":      "jewelrystore-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":500},{"resource":"Gold","amount":350},{"resource":"Diamond","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           {"input":"Diamond","output":"Money","time":2500,"ratio":400},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["殖民金融理论"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "jewelrystore.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "独立大厅",
            "tile":             ["independencehall"],
            "cost":             [{"resource":"Ore","amount":35000},{"resource":"Rum","amount":1500},{"resource":"Diamond","amount":1500},{"resource":"Water","amount":3000},{"resource":"Regolith","amount":25000},{"resource":"Steel","amount":16000},{"resource":"Gold","amount":12000},{"resource":"Aluminum","amount":3000},{"resource":"Microchip","amount":1200},{"resource":"Civics","amount":5000}],
            "description":      "independencehall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        5,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":8000},{"resource":"Diamond","amount":1000},{"resource":"Regolith","amount":500},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":55}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   60,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["LIS Base","殖民金融理论","Colonial Civics","Large Scale Construction","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "independencehall.png",
            "canUpgradeTo":     "独立大厅2级",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     15000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    3,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "联盟贸易管理局",
            "tile":             ["leaguetrade"],
            "cost":             [{"resource":"Money","amount":15000},{"resource":"Ore","amount":10000},{"resource":"Water","amount":900},{"resource":"Wood","amount":400},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":850},{"resource":"Microchip","amount":1400},{"resource":"Civics","amount":2000}],
            "description":      "leaguetrade-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   20,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":10000},{"resource":"Ore","amount":3500},{"resource":"Wood","amount":50},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["LIS Base","Large Scale Construction","Galactic Commerce","Long Range Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        "leaguetrade.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": true,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    500,
            "upkeepCost":       0.0,
            "giftCapacity":     500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "安腾合成实验室",
            "tile":             ["antsynth"],
            "cost":             [{"resource":"Ore","amount":4500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":60}],
            "description":      "antsynth-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Antanium","amount":100}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum,Sugar","output":"Antanium","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Antanium Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "antsynth.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "量子酒厂",
            "tile":             ["quantumdistillery"],
            "cost":             [{"resource":"Water","amount":200},{"resource":"Ore","amount":600},{"resource":"Steel","amount":200},{"resource":"Aluminum","amount":500},{"resource":"Uranium","amount":800},{"resource":"Microchip","amount":2000},{"resource":"Alien Artifact","amount":45}],
            "description":      "quantumdistillery-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":500}],
            "sellValue":        [{"resource":"Water","amount":20},{"resource":"Ore","amount":80},{"resource":"Steel","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Rum","time":1000,"ratio":500},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Microgravity Brewing","Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "quantumdistillery.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Water","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "黄色房子",
            "tile":             ["yellowhouse"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "yellowhouse-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  7,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["先进的小规模建设","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "yellowhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "人工学习中心",
            "tile":             ["centerai"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Charcoal","amount":10000},{"resource":"Regolith","amount":10000},{"resource":"Wood","amount":10000},{"resource":"Antanium","amount":2000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":6000},{"resource":"Plastic","amount":15000},{"resource":"Microchip","amount":60000},{"resource":"Robot","amount":10000},{"resource":"Alien Artifact","amount":2000}],
            "description":      "centerai-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":800},{"resource":"Microchip","amount":800},{"resource":"Robot","amount":800},{"resource":"Alien Relic","amount":800}],
            "sellValue":        [{"resource":"Ore","amount":750},{"resource":"Regolith","amount":50},{"resource":"Antanium","amount":100},{"resource":"Steel","amount":600},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Plastic","amount":20},{"resource":"Microchip","amount":600},{"resource":"Alien Artifact","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   250,
            "requiresWorkers":  true,
            "smelts":           {"input":"Robot","output":"Research","time":1800,"ratio":750},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2000,
            "requiresTech":     ["Artificial Intelligence","Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Alien Artifact"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Scientist",
            "indicator":        "centerai.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Triantanium炼油厂",
            "tile":             ["triantrefine"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":6000},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":8000},{"resource":"Plastic","amount":15000},{"resource":"Bricks","amount":1000},{"resource":"Robot","amount":2500},{"resource":"Alien Artifact","amount":2000}],
            "description":      "triantrefine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Triantanium","amount":100}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":600},{"resource":"Antanium","amount":1000},{"resource":"Gold","amount":600},{"resource":"Microchip","amount":8},{"resource":"Plastic","amount":300},{"resource":"Bricks","amount":25},{"resource":"Robot","amount":3},{"resource":"Alien Artifact","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1600}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Antanium,Uranium","output":"Triantanium","time":2000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Antanium Compounds","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Shanty",
            "tile":             ["theshanty"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":50},{"resource":"Gold","amount":20},{"resource":"Wood","amount":1000},{"resource":"Microchip","amount":20},{"resource":"Pottery","amount":20}],
            "description":      "theshanty-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  3,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Functional",
            "tile":             ["thefunctional"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1000},{"resource":"Wood","amount":100},{"resource":"Microchip","amount":80},{"resource":"Pottery","amount":30},{"resource":"Plastic","amount":900},{"resource":"Rum","amount":300}],
            "description":      "thefunctional-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  18,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Goldman",
            "tile":             ["thegoldman"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Charcoal","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Wood","amount":100},{"resource":"Microchip","amount":100},{"resource":"Pottery","amount":50},{"resource":"Plastic","amount":1500},{"resource":"Rum","amount":1000}],
            "description":      "thegoldman-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  25,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Exomound",
            "tile":             ["exomound"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Sugar","amount":300},{"resource":"Food","amount":30},{"resource":"Ant Paste","amount":60},{"resource":"Wood","amount":100}],
            "description":      "exomound-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  25,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Zolarg Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Diplomatic Outpost",
            "tile":             ["diplomaticoutpost"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1000},{"resource":"Wood","amount":100},{"resource":"Microchip","amount":80},{"resource":"Pottery","amount":30},{"resource":"Plastic","amount":900},{"resource":"Rum","amount":300}],
            "description":      "diplomaticoutpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  18,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Crystalline",
            "tile":             ["thecrystalline"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":3500},{"resource":"Gold","amount":5000},{"resource":"Wood","amount":400},{"resource":"Microchip","amount":120},{"resource":"Pottery","amount":60},{"resource":"Plastic","amount":2000},{"resource":"Rum","amount":1200},{"resource":"Triantanium","amount":200}],
            "description":      "thecrystalline-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  40,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base|LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Sunrise",
            "tile":             ["thesunrise"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":9000},{"resource":"Wood","amount":600},{"resource":"Microchip","amount":180},{"resource":"Pottery","amount":100},{"resource":"Plastic","amount":5000},{"resource":"Rum","amount":1800},{"resource":"Antanium","amount":5000}],
            "description":      "thesunrise-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50}],
            "colGenRate":       0,
            "providesShelter":  50,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base|LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Shrine of Truth",
            "tile":             ["shrineoftruth"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Antanium","amount":3500},{"resource":"Gold","amount":5000},{"resource":"Wood","amount":400},{"resource":"Ant Paste","amount":120},{"resource":"Water","amount":60},{"resource":"Sugar","amount":2000},{"resource":"Rum","amount":1200}],
            "description":      "shrineoftruth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  40,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Zolarg Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "传输中心",
            "tile":             ["transmissionhub"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":100},{"resource":"Gold","amount":100},{"resource":"Microchip","amount":3}],
            "description":      "transmissionhub-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":20},{"resource":"Gold","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Long Range Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "高级机器人公司",
            "tile":             ["robofactory2"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Water","amount":8000},{"resource":"Steel","amount":30000},{"resource":"Gold","amount":20000},{"resource":"Aluminum","amount":8000},{"resource":"Plastic","amount":8000},{"resource":"Microchip","amount":45000},{"resource":"Triantanium","amount":3000}],
            "description":      "robofactory2-description",
            "produces":         ["Construction Drone","Turbo Drone"],
            "generates":        "Atmosphere",
            "generateTime":     5000,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Robot","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   700,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum","output":"Robot","time":6000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3000,
            "requiresTech":     ["Advanced Robotics","Antanium Compounds","Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip","rate":20},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aluminum Mine",
            "tile":             ["alummine"],
            "cost":             [{"resource":"Ore","amount":800},{"resource":"Wood","amount":800},{"resource":"Ant Paste","amount":2000},{"resource":"Antanium","amount":2000}],
            "description":      "alummine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Aluminum Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "alummine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "巨型树",
            "tile":             ["megatree"],
            "cost":             [{"resource":"Water","amount":200},{"resource":"Ant Paste","amount":200},{"resource":"Sugar","amount":100}],
            "description":      "megatree-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Megatree",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Plant Genetics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "megatree.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "深空收发器",
            "tile":             ["deeptrans"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":100},{"resource":"Gold","amount":100},{"resource":"Ant Paste","amount":500}],
            "description":      "deeptrans-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":20},{"resource":"Gold","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Zolarg Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "铝路",
            "tile":             ["pavement8"],
            "cost":             [{"resource":"Aluminum","amount":30}],
            "description":      "pavement8-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    15,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement8.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "先进的塑料厂",
            "tile":             ["plastfact2"],
            "cost":             [{"resource":"Ore","amount":25000},{"resource":"Charcoal","amount":5000},{"resource":"Steel","amount":15000},{"resource":"Oil","amount":8000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":3500},{"resource":"Microchip","amount":2500},{"resource":"Robot","amount":250}],
            "description":      "plastfact2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2800,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":8000}],
            "sellValue":        [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":300}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  true,
            "smelts":           {"input":"Oil","output":"Plastic","time":8000,"ratio":9},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Advanced Chemical Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":900},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "先进的合成油实验室",
            "tile":             ["oilsynthlab2"],
            "cost":             [{"resource":"Wood","amount":1800},{"resource":"Charcoal","amount":4000},{"resource":"Ore","amount":20000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":3000},{"resource":"Robot","amount":200}],
            "description":      "oilsynthlab2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":9000},{"resource":"Robot","amount":1000},{"resource":"Food","amount":1000}],
            "sellValue":        [{"resource":"Wood","amount":15},{"resource":"Charcoal","amount":50},{"resource":"Ore","amount":7000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           {"input":"Charcoal,Regolith,Robot","output":"Oil","time":1500,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Advanced Chemical Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "湿锥",
            "tile":             ["wetcone"],
            "cost":             [{"resource":"Antanium","amount":30},{"resource":"Gold","amount":80},{"resource":"Ant Paste","amount":80},{"resource":"Aluminum","amount":300}],
            "description":      "wetcone-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     400,
            "generateAmount":   40,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":            [{"resource":"Water","amount":1500}],
            "sellValue":        [{"resource":"Antanium","amount":10},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "wetcone.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "星门",
            "tile":             ["stargate"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Steel","amount":40000},{"resource":"Gold","amount":20000},{"resource":"Aluminum","amount":12000},{"resource":"Plastic","amount":7000},{"resource":"Microchip","amount":90000},{"resource":"Triantanium","amount":6000},{"resource":"Robot","amount":10000},{"resource":"Alien Artifact","amount":1000}],
            "description":      "stargate-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1800,
            "generateAmount":   20,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":8000},{"resource":"Plastic","amount":100},{"resource":"Microchip","amount":8},{"resource":"Triantanium","amount":2000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20000}],
            "colGenRate":       6000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5000,
            "requiresTech":     ["Interdimensional Transportation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Diamond","Helium 3","Toy","Uranium","Crystalline","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Triantanium","Alien Relic"],
            "canExport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Diamond","Helium 3","Toy","Uranium","Crystalline","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Triantanium","Alien Relic"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济","移民","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    100000,
            "upkeepCost":       0.0,
            "giftCapacity":     100000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       true,
            "lightEffects":     [
                {
                    "x":    -0.2,
                    "y":    -0.2,
                    "r":    1.6,
                    "c":    "#1E88E5",
                    "i":    0.4,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "生态建筑学",
            "tile":             ["arcology"],
            "cost":             [{"resource":"Ore","amount":60000},{"resource":"Clay","amount":8000},{"resource":"Water","amount":40000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":25000},{"resource":"Aluminum","amount":10000},{"resource":"Uranium","amount":4000},{"resource":"Pottery","amount":15000},{"resource":"Toy","amount":20000},{"resource":"Cloth","amount":10000},{"resource":"Microchip","amount":80000},{"resource":"Triantanium","amount":1000},{"resource":"Robot","amount":10000}],
            "description":      "arcology-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     50000,
            "generateAmount":   10,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Clay","amount":800},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":9},{"resource":"Triantanium","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10000}],
            "colGenRate":       0,
            "providesShelter":  10000,
            "canChain":         false,
            "acceptsWorkers":   7000,
            "requiresWorkers":  false,
            "smelts":           {"input":"Food","output":"Trash","time":100000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    900,
            "requiresTech":     ["Mega Habitats"],
            "canRenderStatic":  false,
            "entertains":       2000,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            500,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":4,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    500,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Shrine of Mystics",
            "tile":             ["shrineofmystics"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Ant Paste","amount":3000},{"resource":"Wood","amount":1000},{"resource":"Antanium","amount":3000},{"resource":"Aluminum","amount":3000}],
            "description":      "shrineofmystics-description",
            "produces":         null,
            "generates":        "Antaura",
            "generateTime":     2500,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Antanium","amount":1000},{"resource":"Aluminum","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "shrineofmystics.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "更高的命令",
            "tile":             ["highercommand"],
            "cost":             [{"resource":"Money","amount":4000},{"resource":"Wood","amount":2000},{"resource":"Ore","amount":8000},{"resource":"Water","amount":2000},{"resource":"Ant Paste","amount":2500},{"resource":"Antanium","amount":15000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":4000},{"resource":"Civics","amount":5000}],
            "description":      "highercommand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Antanium","amount":1500},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":2000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":16000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "highercommand.png",
            "canUpgradeTo":     "Unholy Command",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     80000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Power Spire",
            "tile":             ["unholypowerspire"],
            "cost":             [{"resource":"Wood","amount":500},{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":400},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":1000}],
            "description":      "unholypowerspire-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":50},{"resource":"Gold","amount":25},{"resource":"Aluminum","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":350}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "unholypowerspire.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Antaura","rate":400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -.8,
                    "y":    -.8,
                    "r":    .6,
                    "c":    "#E53935",
                    "i":    .2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Monument of Heroes",
            "tile":             ["monumentheroes"],
            "cost":             [{"resource":"Ore","amount":350},{"resource":"Steel","amount":450},{"resource":"Aluminum","amount":150},{"resource":"Gold","amount":900},{"resource":"Civics","amount":500}],
            "description":      "monumentheroes-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["United Earth Base","Nationalism","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       5,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    8,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "幻想的土地生态建筑学",
            "tile":             ["fantasyland"],
            "cost":             [{"resource":"Ore","amount":55000},{"resource":"Clay","amount":7000},{"resource":"Water","amount":45000},{"resource":"Steel","amount":55000},{"resource":"Gold","amount":30000},{"resource":"Aluminum","amount":12000},{"resource":"Uranium","amount":500},{"resource":"Pottery","amount":25000},{"resource":"Toy","amount":40000},{"resource":"Cloth","amount":15000},{"resource":"Microchip","amount":60000},{"resource":"Robot","amount":25000}],
            "description":      "fantasyland-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3500,
            "generateAmount":   2000,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Clay","amount":800},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":9},{"resource":"Triantanium","amount":6000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":9500}],
            "colGenRate":       0,
            "providesShelter":  16000,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Toy,Rum,Cloth","output":"Money","time":100,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    800,
            "requiresTech":     ["Mega Habitats"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "矿石合成实验室",
            "tile":             ["oresynth"],
            "cost":             [{"resource":"Regolith","amount":4500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":60}],
            "description":      "oresynth-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":2200},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":55}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Regolith","output":"Ore","time":80,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["先进的小规模建设","Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "蓝色住宅区",
            "tile":             ["rescomplexblue"],
            "cost":             [{"resource":"Ore","amount":3200},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":650}],
            "description":      "rescomplexblue-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   8,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":400},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  26,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["先进的小规模建设"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "蓝色住宅塔",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "大剧场",
            "tile":             ["bigplayhouse"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":100},{"resource":"Wood","amount":500},{"resource":"Plastic","amount":2000},{"resource":"Cloth","amount":2000},{"resource":"Pottery","amount":2000},{"resource":"Robot","amount":5},{"resource":"Toy","amount":90000}],
            "description":      "bigplayhouse-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     2000,
            "generateAmount":   5,
            "tileWidth":        4,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":10},{"resource":"Wood","amount":2},{"resource":"Plastic","amount":100},{"resource":"Cloth","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   200,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       600,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    500,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Micromine",
            "tile":             ["micromine"],
            "cost":             [{"resource":"Crystalline","amount":200}],
            "description":      "micromine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Micromine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["LIS Base","Ice World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "溢流炉",
            "tile":             ["regfurnace"],
            "cost":             [{"resource":"Regolith","amount":100},{"resource":"Crystalline","amount":100}],
            "description":      "regfurnace-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":150}],
            "sellValue":        [{"resource":"Crystalline","amount":90}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":10}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Diamond Crystal Reactor",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Regolith","rate":400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFA000",
                    "i":    .05,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "压实的雪路",
            "tile":             ["compactedsnow"],
            "cost":             [{"resource":"Water","amount":1}],
            "description":      "compactedsnow-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Ice World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰","道路"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Diamond Crystal Reactor",
            "tile":             ["diamondcrystalreactor"],
            "cost":             [{"resource":"Regolith","amount":70000},{"resource":"Steel","amount":60000},{"resource":"Aluminum","amount":5000},{"resource":"Uranium","amount":2000},{"resource":"Microchip","amount":50000},{"resource":"Diamond","amount":25000},{"resource":"Crystalline","amount":25000},{"resource":"Robot","amount":5000}],
            "description":      "diamondcrystalreactor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":8000},{"resource":"Diamond","amount":8000}],
            "sellValue":        [{"resource":"Regolith","amount":800},{"resource":"Steel","amount":20000},{"resource":"Aluminum","amount":3000},{"resource":"Microchip","amount":20},{"resource":"Diamond","amount":20000},{"resource":"Crystalline","amount":20000}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":275000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Next Gen Power Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Crystalline","Diamond","Uranium"],
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium,Diamond,Crystalline","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0,
                    "y":    0,
                    "r":    3,
                    "c":    "#90CAF9",
                    "i":    .1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "异形浓缩设施",
            "tile":             ["alienenrichment"],
            "cost":             [{"resource":"Ore","amount":7000},{"resource":"Water","amount":1200},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":5000},{"resource":"Microchip","amount":65000},{"resource":"Alien Artifact","amount":20000},{"resource":"Robot","amount":10000}],
            "description":      "alienenrichment-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":50000}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Water","amount":400},{"resource":"Steel","amount":2400},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":80},{"resource":"Alien Artifact","amount":6000}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":15000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Uranium","output":"Uranium","time":10000,"ratio":12},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Aluminum"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Aluminum,Alien Artifact","rate":350},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "水晶丘",
            "tile":             ["crystalmound"],
            "cost":             [{"resource":"Water","amount":300},{"resource":"Crystalline","amount":200}],
            "description":      "crystalmound-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":400},{"resource":"Sugar","amount":400}],
            "sellValue":        [{"resource":"Crystalline","amount":180}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Crystalline","output":"Sugar","time":500,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base","Ice World Base|Lava World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Tunnel",
            "tile":             ["oretunnel"],
            "cost":             [{"resource":"Crystalline","amount":200}],
            "description":      "oretunnel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Ore Tunnel",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base","Ice World Base|Lava World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "合成结晶矿床",
            "tile":             ["syncrystaldeposit"],
            "cost":             [{"resource":"Crystalline","amount":20},{"resource":"Rum","amount":200}],
            "description":      "syncrystaldeposit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Synthetic Crystalline Deposit",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Ice World Base|Lava World Base","Crystalline Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "独立大厅2级",
            "tile":             ["independencehall2"],
            "cost":             [{"resource":"Ore","amount":40000},{"resource":"Rum","amount":3000},{"resource":"Diamond","amount":3000},{"resource":"Water","amount":4000},{"resource":"Regolith","amount":30000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":18000},{"resource":"Aluminum","amount":4000},{"resource":"Microchip","amount":4000},{"resource":"Civics","amount":10000},{"resource":"Pottery","amount":4000}],
            "description":      "independencehall2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        5,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Diamond","amount":1000},{"resource":"Regolith","amount":500},{"resource":"Steel","amount":7500},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":700},{"resource":"Microchip","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":70}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   75,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":13500,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    65,
            "requiresTech":     ["LIS Base","Galactic Governance","Large Scale Construction","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":350},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     150000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "微型焚化炉",
            "tile":             ["microincinerator"],
            "cost":             [{"resource":"Ore","amount":500}],
            "description":      "microincinerator-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":15}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"microincinerator-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Trash","rate":20},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量","废物管理"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFA000",
                    "i":    .1,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小型回收中心",
            "tile":             ["smrecyclingcenter"],
            "cost":             [{"resource":"Ore","amount":9000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":500},{"resource":"Microchip","amount":600}],
            "description":      "smrecyclingcenter-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":1500},{"resource":"Gold","amount":900}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           {"input":"Trash","output":"Plastic","time":12000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     "中等回收中心",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Trash","rate":8},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","废物管理"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小垃圾坑",
            "tile":             ["smtrashpit"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Trash","amount":10000}],
            "description":      "smtrashpit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Small Trash Pit",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","废物管理"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "会议大厅",
            "tile":             ["conferencehall"],
            "cost":             [{"resource":"Food","amount":1500},{"resource":"Rum","amount":1500},{"resource":"Microchip","amount":2500},{"resource":"Aluminum","amount":3000},{"resource":"Gold","amount":10000},{"resource":"Steel","amount":6000},{"resource":"Ore","amount":8000},{"resource":"Plastic","amount":2500}],
            "description":      "conferencehall-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2500,
            "generateAmount":   30,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Microchip","amount":4},{"resource":"Aluminum","amount":2000},{"resource":"Gold","amount":4000},{"resource":"Steel","amount":3000},{"resource":"Ore","amount":1000},{"resource":"Plastic","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Rum","output":"Money","time":2500,"ratio":50},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Solar Governance","Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       100,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip,Food","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "先进的医学研究中心",
            "tile":             ["advancedmed"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Steel","amount":15000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":2500},{"resource":"Civics","amount":5000},{"resource":"Microchip","amount":10000},{"resource":"Uranium","amount":1000},{"resource":"Plastic","amount":2500},{"resource":"Money","amount":10000}],
            "description":      "advancedmed-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2500,
            "generateAmount":   20,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":4000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":6},{"resource":"Uranium","amount":50},{"resource":"Plastic","amount":250}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   100,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Human Cloning","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            100,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "蓝色住宅塔",
            "tile":             ["restowerblue"],
            "cost":             [{"resource":"Ore","amount":18000},{"resource":"Steel","amount":85000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":2500},{"resource":"Pottery","amount":1500},{"resource":"Cloth","amount":1500},{"resource":"Plastic","amount":2500},{"resource":"Toy","amount":1100},{"resource":"Robot","amount":10},{"resource":"Microchip","amount":400}],
            "description":      "restowerblue-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3500,
            "generateAmount":   400,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":       [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":800},{"resource":"Aluminum","amount":40},{"resource":"Pottery","amount":10},{"resource":"Cloth","amount":10},{"resource":"Plastic","amount":5},{"resource":"Toy","amount":6},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":380}],
            "colGenRate":       0,
            "providesShelter":  1150,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    350,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "焚烧炉",
            "tile":             ["incinerator"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":80}],
            "description":      "incinerator-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   30,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":600}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   25,
            "requiresWorkers":  false,
            "smelts":           {"input":"Trash","output":"Atmosphere","time":10,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Trash","rate":1},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量","废物管理"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "中等回收中心",
            "tile":             ["medrecyclingcenter"],
            "cost":             [{"resource":"Ore","amount":14000},{"resource":"Steel","amount":18000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":1200},{"resource":"Microchip","amount":1500},{"resource":"Plastic","amount":1500}],
            "description":      "medrecyclingcenter-description",
            "produces":         null,
            "generates":        "Aluminum",
            "generateTime":     50000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":900},{"resource":"Aluminum","amount":900}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   65,
            "requiresWorkers":  true,
            "smelts":           {"input":"Trash","output":"Plastic","time":6000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    300,
            "requiresTech":     ["Advanced Chemical Synthesis","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Trash","rate":2},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","废物管理"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Landfill",
            "tile":             ["landfill"],
            "cost":             [{"resource":"Ore","amount":70000},{"resource":"Water","amount":8000},{"resource":"Trash","amount":250000}],
            "description":      "landfill-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Landfill",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    180,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","废物管理"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "不洁酿造坑",
            "tile":             ["unholybrewpit"],
            "cost":             [{"resource":"Water","amount":500},{"resource":"Ant Paste","amount":500},{"resource":"Wood","amount":500},{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":1000}],
            "description":      "unholybrewpit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":400}],
            "sellValue":        [{"resource":"Wood","amount":10},{"resource":"Ore","amount":300},{"resource":"Antanium","amount":80},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food,Water","output":"Rum","time":800,"ratio":16},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    4,
            "requiresTech":     ["Insectoid Brewing","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Antaura","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.2,
                    "y":    -0.5,
                    "r":    0.6,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Pit of Stuff",
            "tile":             ["unholypit"],
            "cost":             [{"resource":"Aluminum","amount":3000},{"resource":"Antanium","amount":1200},{"resource":"Gold","amount":300},{"resource":"Antaura","amount":6000}],
            "description":      "unholypit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":15000},{"resource":"Sugar","amount":15000},{"resource":"Food","amount":15000},{"resource":"Water","amount":15000},{"resource":"Steel","amount":15000},{"resource":"Wool","amount":15000},{"resource":"Rum","amount":15000},{"resource":"Pottery","amount":15000},{"resource":"Bricks","amount":15000},{"resource":"Cloth","amount":15000},{"resource":"Plastic","amount":15000},{"resource":"Toy","amount":15000},{"resource":"Microchip","amount":15000},{"resource":"Alien Artifact","amount":15000},{"resource":"Alien Relic","amount":15000},{"resource":"Robot","amount":15000},{"resource":"Ant Paste","amount":15000},{"resource":"Antanium","amount":15000},{"resource":"Wood","amount":15000},{"resource":"Crystalline","amount":15000},{"resource":"Diamond","amount":15000},{"resource":"Triantanium","amount":15000},{"resource":"Aluminum","amount":15000},{"resource":"Uranium","amount":15000},{"resource":"Gold","amount":15000},{"resource":"Clay","amount":15000},{"resource":"Ore","amount":20000},{"resource":"Regolith","amount":20000}],
            "sellValue":        [{"resource":"Aluminum","amount":2000},{"resource":"Antanium","amount":500},{"resource":"Gold","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Communal Finance","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","耐用品","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    1,
                    "y":    1,
                    "r":    2,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Mound of Worship",
            "tile":             ["unholymound"],
            "cost":             [{"resource":"Aluminum","amount":2000},{"resource":"Sugar","amount":1500},{"resource":"Food","amount":2000},{"resource":"Antaura","amount":500}],
            "description":      "unholymound-description",
            "produces":         ["Worker Drone","Tundrabug","Extremeobug","Waterbug","Orebug","Goldbug","Lumberbug","Alumibug","Ancientbug"],
            "generates":        "Antaura",
            "generateTime":     300,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       3800,
            "providesShelter":  600,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           false,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","住房","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Core Mine",
            "tile":             ["coremine"],
            "cost":             [{"resource":"Water","amount":6000},{"resource":"Antanium","amount":3000},{"resource":"Ant Paste","amount":5000},{"resource":"Wood","amount":5000},{"resource":"Aluminum","amount":5000},{"resource":"Antaura","amount":2000},{"resource":"Civics","amount":1000}],
            "description":      "coremine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  true,
            "smelts":           {"input":"Antaura","output":"Ore|Gold|Aluminum|Uranium|Diamond|Alien Relic|Clay","time":5000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Antanium Production","Communal Finance","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -.5,
                    "y":    0,
                    "r":    .6,
                    "c":    "#E53935",
                    "i":    .2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小灯柱",
            "tile":             ["smlightpost"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "smlightpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#E3F2FD",
                    "i":    .35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小红灯岗位",
            "tile":             ["smredlightpost"],
            "cost":             [{"resource":"Ore","amount":25}],
            "description":      "smredlightpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#ff0000",
                    "i":    .35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小绿灯岗位",
            "tile":             ["smgreenlightpost"],
            "cost":             [{"resource":"Ore","amount":25}],
            "description":      "smgreenlightpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#00ff00",
                    "i":    .35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "路灯",
            "tile":             ["streetlight"],
            "cost":             [{"resource":"Ore","amount":30},{"resource":"Steel","amount":5},{"resource":"Gold","amount":1}],
            "description":      "streetlight-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    6,
                    "c":    "#FFF3E0",
                    "i":    .45,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Glow Goo",
            "tile":             ["glowgoo"],
            "cost":             [{"resource":"Food","amount":10},{"resource":"Ant Paste","amount":14}],
            "description":      "glowgoo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Orb of Radiance",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    5,
                    "c":    "#0edeb2",
                    "i":    0.3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "糊锅炉",
            "tile":             ["pasteboiler"],
            "cost":             [{"resource":"Ant Paste","amount":500},{"resource":"Crystalline","amount":800}],
            "description":      "pasteboiler-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     800,
            "generateAmount":   30,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Crystalline","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":15}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#81D4FA",
            "requiresFuel":     {"resource":"Ant Paste","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","地球化"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFF3E0",
                    "i":    .25,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Atmosphere Scrubber",
            "tile":             ["atmosscrubber"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":6000},{"resource":"Uranium","amount":900},{"resource":"Microchip","amount":12000},{"resource":"Robot","amount":1500}],
            "description":      "atmosscrubber-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1400},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Atmosphere","output":null,"time":1,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    750,
            "requiresTech":     ["Artificial Intelligence","Climate Science Theory"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    4,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Atmosphere","rate":1},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0,
                    "y":    -0.15,
                    "r":    0.3,
                    "c":    "#00aa44",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    -0.15,
                    "y":    -0.15,
                    "r":    0.3,
                    "c":    "#0055d4",
                    "i":    0.4,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "安全墙",
            "tile":             ["wall2"],
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":25},{"resource":"Charcoal","amount":25},{"resource":"Regolith","amount":25},{"resource":"Oil","amount":40}],
            "description":      "wall2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "安全壁灯",
            "tile":             ["wall2light"],
            "cost":             [{"resource":"Ore","amount":100},{"resource":"Steel","amount":25},{"resource":"Charcoal","amount":25},{"resource":"Regolith","amount":25},{"resource":"Oil","amount":40}],
            "description":      "wall2light-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#E3F2FD",
                    "i":    .35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "钻石太阳能塔",
            "tile":             ["diamondsolar"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Steel","amount":300},{"resource":"Gold","amount":100},{"resource":"Diamond","amount":200}],
            "description":      "diamondsolar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Steel","amount":100},{"resource":"Gold","amount":20},{"resource":"Diamond","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":70}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["High Density Solar Panels","United Earth Base|Asteroid Base|Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","能量"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -1,
                    "y":    -1,
                    "r":    .15,
                    "c":    "#ff0000",
                    "i":    .3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "官僚机构",
            "tile":             ["bureaucracy"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":5500},{"resource":"Gold","amount":4000},{"resource":"Microchip","amount":60},{"resource":"Wood","amount":800},{"resource":"Bricks","amount":1000}],
            "description":      "bureaucracy-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2800},{"resource":"Steel","amount":1800},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   200,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":20000,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["殖民金融理论","Colonial Civics","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "布料农场",
            "tile":             ["clothfarm"],
            "cost":             [{"resource":"Ore","amount":1600},{"resource":"Antanium","amount":1600},{"resource":"Gold","amount":1000},{"resource":"Aluminum","amount":1000},{"resource":"Wood","amount":400},{"resource":"Ant Paste","amount":950}],
            "description":      "clothfarm-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":700},{"resource":"Antanium","amount":900},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":650}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":35}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum","output":"Cloth","time":1200,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Insectoid Base","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "遗迹大锅",
            "tile":             ["cauldron"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Water","amount":400},{"resource":"Aluminum","amount":300},{"resource":"Ant Paste","amount":1000},{"resource":"Alien Relic","amount":100}],
            "description":      "cauldron-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ant Paste,Alien Relic","output":"Alien Artifact","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Insectoid Base","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    3,
                    "c":    "#C5E1A5",
                    "i":    .3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "超级市场",
            "tile":             ["supermarket"],
            "cost":             [{"resource":"Money","amount":2000},{"resource":"Food","amount":4000},{"resource":"Water","amount":4000},{"resource":"Ore","amount":10000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":8000},{"resource":"Microchip","amount":15}],
            "description":      "supermarket-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":3000},{"resource":"Water","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food,Water","output":"Money","time":16000,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["殖民金融理论","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     "大型集市",
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "大型集市",
            "tile":             ["megamart"],
            "cost":             [{"resource":"Money","amount":10000},{"resource":"Food","amount":15000},{"resource":"Water","amount":15000},{"resource":"Toy","amount":15000},{"resource":"Rum","amount":15000},{"resource":"Pottery","amount":15000},{"resource":"Cloth","amount":15000},{"resource":"Microchip","amount":15000},{"resource":"Ore","amount":30000},{"resource":"Steel","amount":30000},{"resource":"Gold","amount":25000},{"resource":"Bricks","amount":9000},{"resource":"Aluminum","amount":9000},{"resource":"Robot","amount":500}],
            "description":      "megamart-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":10000},{"resource":"Water","amount":10000},{"resource":"Rum","amount":10000},{"resource":"Toy","amount":10000},{"resource":"Pottery","amount":10000},{"resource":"Cloth","amount":10000}],
            "sellValue":        [{"resource":"Toy","amount":500},{"resource":"Pottery","amount":1},{"resource":"Cloth","amount":50},{"resource":"Microchip","amount":30},{"resource":"Ore","amount":10000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":15000},{"resource":"Bricks","amount":600},{"resource":"Aluminum","amount":5000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   180,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food,Water,Rum,Toy,Pottery,Cloth","output":"Money","time":16000,"ratio":50},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","经济"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "国会大厦",
            "tile":             ["uecongress"],
            "cost":             [{"resource":"Money","amount":500000000},{"resource":"Rum","amount":100000},{"resource":"Water","amount":400000},{"resource":"Ore","amount":3000000},{"resource":"Steel","amount":4000000},{"resource":"Gold","amount":8000000},{"resource":"Oil","amount":200000},{"resource":"Wood","amount":120000},{"resource":"Cloth","amount":250000},{"resource":"Bricks","amount":175000},{"resource":"Pottery","amount":450000},{"resource":"Plastic","amount":2500000},{"resource":"Aluminum","amount":1800000},{"resource":"Microchip","amount":750000},{"resource":"Uranium","amount":1500000},{"resource":"Robot","amount":500000},{"resource":"Toy","amount":100000},{"resource":"Triantanium","amount":10000},{"resource":"Civics","amount":1000000}],
            "description":      "uecongress-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200000},{"resource":"Steel","amount":300000},{"resource":"Gold","amount":100000},{"resource":"Wood","amount":600},{"resource":"Cloth","amount":1},{"resource":"Bricks","amount":20000},{"resource":"Plastic","amount":10000},{"resource":"Aluminum","amount":1000000},{"resource":"Microchip","amount":500},{"resource":"Uranium","amount":1000},{"resource":"Toy","amount":1000},{"resource":"Triantanium","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   400,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money,Food","output":"Civics","time":16000,"ratio":250},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["United Earth Base","Tall Construction","Tourist Traps","Political Theater"],
            "canRenderStatic":  false,
            "entertains":       1000,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":20},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    1000,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    7,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "古代外星人矿石精炼厂",
            "tile":             ["refinery3"],
            "cost":             [{"resource":"Ore","amount":35000},{"resource":"Steel","amount":50000},{"resource":"Gold","amount":65000},{"resource":"Aluminum","amount":4000},{"resource":"Uranium","amount":8000},{"resource":"Microchip","amount":17000},{"resource":"Alien Artifact","amount":100}],
            "description":      "refinery3-description",
            "produces":         ["Ore Miner","Uranium Miner"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":250000},{"resource":"Ore","amount":500000}],
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":40000},{"resource":"Gold","amount":30000},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":500},{"resource":"Microchip","amount":20},{"resource":"Alien Artifact","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   20,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore,Uranium,Alien Artifact","output":"Steel","time":15000,"ratio":1000},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "合成器",
            "tile":             ["pastesynth"],
            "cost":             [{"resource":"Trash","amount":1000},{"resource":"Ore","amount":6000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":800},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":500},{"resource":"Plastic","amount":2000}],
            "description":      "pastesynth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ant Paste","amount":500}],
            "sellValue":        [{"resource":"Trash","amount":1000},{"resource":"Ore","amount":2000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":400},{"resource":"Microchip","amount":8},{"resource":"Aluminum","amount":920},{"resource":"Uranium","amount":50},{"resource":"Plastic","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Trash,Atmosphere","output":"Ant Paste","time":40,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Ant Paste Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","废物管理"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0,
                    "y":    0,
                    "r":    2,
                    "c":    "#90CAF9",
                    "i":    .1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "小糖机",
            "tile":             ["smsugarprocessor"],
            "cost":             [{"resource":"Ore","amount":900}],
            "description":      "smsugarprocessor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":1500}],
            "sellValue":        [{"resource":"Ore","amount":300}],
            "sellWarning":      null,
            "refines":          [{"input":"Sugar","output":"Sugar"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Food","time":1500,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Human Base","LIS Base","Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.5,
                    "y":    -0.2,
                    "r":    1,
                    "c":    "#8dd35f",
                    "i":    .15,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Bloodletting Station",
            "tile":             ["bloodletting"],
            "cost":             [{"resource":"Ore","amount":700},{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":500},{"resource":"Gold","amount":600},{"resource":"Civics","amount":100},{"resource":"Cloth","amount":400}],
            "description":      "bloodletting-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":20},{"resource":"Gold","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Insectoid Regeneration","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            20,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":5,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "知识的尖塔",
            "tile":             ["spireknowledge"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Gold","amount":1500},{"resource":"Aluminum","amount":1500},{"resource":"Ant Paste","amount":700},{"resource":"Cloth","amount":400}],
            "description":      "spireknowledge-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1400,
            "generateAmount":   20,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Gold","amount":500},{"resource":"Aluminum","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       8,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":5,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Orb of Radiance",
            "tile":             ["sphrad"],
            "cost":             [{"resource":"Ant Paste","amount":30},{"resource":"Aluminum","amount":250},{"resource":"Gold","amount":800}],
            "description":      "sphrad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":25},{"resource":"Gold","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","装饰"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    8,
                    "c":    "#d5f2ec",
                    "i":    .5,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "铀筒仓",
            "tile":             ["uraniumsilo"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Gold","amount":80},{"resource":"Steel","amount":80},{"resource":"Aluminum","amount":180}],
            "description":      "uraniumsilo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":6},{"resource":"Gold","amount":2},{"resource":"Steel","amount":15}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Nuclear Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#222222",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "量子糖克隆",
            "tile":             ["quantumsugarcloner"],
            "cost":             [{"resource":"Water","amount":4000},{"resource":"Sugar","amount":800},{"resource":"Ant Paste","amount":4000},{"resource":"Wood","amount":1000},{"resource":"Aluminum","amount":6000},{"resource":"Antaura","amount":2000},{"resource":"Gold","amount":4000},{"resource":"Alien Relic","amount":150},{"resource":"Alien Artifact","amount":50}],
            "description":      "quantumsugarcloner-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":50000}],
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           {"input":"Sugar,Water","output":"Sugar","time":2000,"ratio":400},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","异形技术"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    0.6,
                    "c":    "#64B5F6",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "原料仓库",
            "tile":             ["rawmatdepot"],
            "cost":             [{"resource":"Ore","amount":25}],
            "description":      "rawmatdepot-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":5000},{"resource":"Charcoal","amount":5000},{"resource":"Gold","amount":5000},{"resource":"Regolith","amount":5000},{"resource":"Aluminum","amount":5000}],
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Charcoal","output":"Charcoal"},{"input":"Gold","output":"Gold"},{"input":"Regolith","output":"Regolith"},{"input":"Aluminum","output":"Aluminum"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","存储"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.1,
                    "y":    -0.1,
                    "r":    0.4,
                    "c":    "#007bff",
                    "i":    0.2,
                    "nightonly": true
                },
                {
                    "x":    0,
                    "y":    1.8,
                    "r":    .4,
                    "c":    "#007bff",
                    "i":    .2,
                    "nightonly": true
                },
                {
                    "x":    1.8,
                    "y":    0,
                    "r":    .4,
                    "c":    "#007bff",
                    "i":    .2,
                    "nightonly": true
                },
                {
                    "x":    1.6,
                    "y":    1.7,
                    "r":    .4,
                    "c":    "#007bff",
                    "i":    .2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "高级指挥所",
            "tile":             ["commandpost2"],
            "cost":             [{"resource":"Money","amount":2000},{"resource":"Ore","amount":5500},{"resource":"Water","amount":1800},{"resource":"Ant Paste","amount":2000},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":3000},{"resource":"Wood","amount":1000},{"resource":"Civics","amount":400}],
            "description":      "commandpost2-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1300,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1280},{"resource":"Antanium","amount":880},{"resource":"Gold","amount":1800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     25000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "邪恶的命令",
            "tile":             ["unholycommand"],
            "cost":             [{"resource":"Money","amount":20000},{"resource":"Wood","amount":3000},{"resource":"Ore","amount":15000},{"resource":"Water","amount":3000},{"resource":"Ant Paste","amount":4000},{"resource":"Antanium","amount":25000},{"resource":"Gold","amount":15000},{"resource":"Aluminum","amount":16000},{"resource":"Civics","amount":10000},{"resource":"Antaura","amount":6000},{"resource":"Alien Relic","amount":1000}],
            "description":      "unholycommand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":850},{"resource":"Antanium","amount":1550},{"resource":"Gold","amount":950},{"resource":"Aluminum","amount":2500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":100},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Ancient Alien Language","Insectoid Bureaucracy","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Antaura","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","政府"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     1000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    7,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Customs Processing",
            "tile":             ["customsprocessing"],
            "cost":             [{"resource":"Ore","amount":5500},{"resource":"Ant Paste","amount":1500},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":1750},{"resource":"Aluminum","amount":800},{"resource":"Wood","amount":1200},{"resource":"Cloth","amount":800},{"resource":"Civics","amount":50}],
            "description":      "customsprocessing-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":300},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       9000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Open Doors"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Ant Paste","Wool","Wood","Clay","Charcoal","Regolith","Ore","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Relic","Cloth"],
            "canExport":        ["Food","Water","Sugar","Rum","Ant Paste","Wool","Wood","Clay","Charcoal","Regolith","Ore","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Relic","Cloth"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Civics","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    1000,
            "upkeepCost":       0.0,
            "giftCapacity":     1000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    1.3,
                    "y":    0.05,
                    "r":    0.3,
                    "c":    "#9C27B0",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    3.3,
                    "y":    2.0,
                    "r":    0.3,
                    "c":    "#9C27B0",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    3.55,
                    "y":    0.15,
                    "r":    0.3,
                    "c":    "#4CAF50",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    1.3,
                    "y":    1.9,
                    "r":    0.3,
                    "c":    "#4CAF50",
                    "i":    0.4,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Treatment Spa",
            "tile":             ["pastespa"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":1000},{"resource":"Wood","amount":300},{"resource":"Gold","amount":100},{"resource":"Ant Paste","amount":600}],
            "description":      "pastespa-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    7,
            "requiresTech":     ["Open Doors"],
            "canRenderStatic":  false,
            "entertains":       4,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ant Paste","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","旅游"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    12,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "水晶蒸发器",
            "tile":             ["vaporizer"],
            "cost":             [{"resource":"Ore","amount":100},{"resource":"Crystalline","amount":50}],
            "description":      "vaporizer-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":20},{"resource":"Crystalline","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Atmosphere,Crystalline","output":"Water","time":500,"ratio":12},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["所有建筑物","资源","食物"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        }
    ],
    "vehicles": [
        {
            "name":             "Airborne Lander",
            "cost":             null,
            "tile":             "landerairborne",
            "description":      "lander-description",
            "produces":         null,
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "harvests":         null,
            "capacity":         0,
            "requiresTech":     ["United Earth Base"],
            "requiresStage":    0,
            "indicator":        "ind-airbornelander.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        "Lander",
            "isFlying":         true,
            "vehicleCarryCapacity": 1,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Rover",
            "cost":             [{"resource":"Ore","amount":5}],
            "tile":             "rover",
            "description":      "rover-description",
            "produces":         ["Raw Materials Depot","温室","Small Water Pump","小太阳能电池板","小型车辆厂"],
            "sellValue":        [{"resource":"Ore","amount":2}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         10,
            "requiresTech":     ["United Earth Base","Red Planet Base|Sugarland Base|Asteroid Base|Abandoned World Base|Ice World Base|Lava World Base"],
            "requiresStage":    0,
            "indicator":        "ind-rover.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"rover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Lunar Rover",
            "cost":             [{"resource":"Regolith","amount":10}],
            "tile":             "lunarrover",
            "description":      "lunarrover-description",
            "produces":         ["Raw Materials Depot","Small Helium 3 Extractor","Regolith Compactor","温室","Water Extractor","小太阳能电池板","小型车辆厂"],
            "sellValue":        [{"resource":"Regolith","amount":3}],
            "sellWarning":      null,
            "harvests":         "Regolith",
            "capacity":         10,
            "requiresTech":     ["Human Base","Lunar Base"],
            "requiresStage":    0,
            "indicator":        "ind-lunarrover.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"lunar-rover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Forest Rover",
            "cost":             [{"resource":"Wood","amount":40}],
            "tile":             "forestrover",
            "description":      "forestrover-description",
            "produces":         ["冷杉木","原料仓库","土豆片","水井","木屋","木炭小屋","木炭压实机","木炭燃烧器","木炭堆","小型车辆厂","林场"],
            "sellValue":        [{"resource":"Wood","amount":10}],
            "sellWarning":      null,
            "harvests":         "Wood",
            "capacity":         2,
            "requiresTech":     ["Forest World Base"],
            "requiresStage":    2,
            "indicator":        "ind-forestrover.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"forestrover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Builder Bot",
            "cost":             [{"resource":"Ore","amount":15}],
            "tile":             "builder",
            "description":      "builder-description",
            "produces":         ["路面","压实的雪路","被击碎的果树园路径","覆盖的木路径","砂","网纹路面","墙","原料仓库","小氦3提取器","小灯柱","小红灯岗位","小绿灯岗位","表层压实机","木炭压实机","微型焚化炉","木炭燃烧器","筒仓","水箱","氦3坦克","温室","水提取器","小水泵","溢流炉","小太阳能电池板","互联网中继摊位","小住房","金庇护所","酒厂","朗姆酒地窖","酒吧","珠宝店","单亲家庭","砖房子","礼品店","餐厅","小型车辆厂","着陆台","Ore Refinery","印章店","小型大气发生器","炼油厂","金薄荷","木炭厂","雕像","纪念匾","统治雕像","红旗","蓝旗","绿旗","紫旗","白旗","黑旗","独立国家联盟的旗帜","小型研究实验室", "医疗诊所", "先进的水培中心","太阳能塔","钻石太阳能塔"],
            "sellValue":        [{"resource":"Ore","amount":5}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-builder.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"builderbot-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Ore Miner",
            "cost":             [{"resource":"Ore","amount":30}],
            "tile":             "miner",
            "description":      "miner-description",
            "produces":         ["Ore Mine"],
            "sellValue":        [{"resource":"Ore","amount":10}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         30,
            "requiresTech":     ["Red Planet Base"],
            "requiresStage":    0,
            "indicator":        "ind-miner.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Regolith Miner",
            "cost":             [{"resource":"Ore","amount":15},{"resource":"Regolith","amount":20}],
            "tile":             "regminer",
            "description":      "regminer-description",
            "produces":         ["Regolith Mine"],
            "sellValue":        [{"resource":"Ore","amount":2},{"resource":"Regolith","amount":3}],
            "sellWarning":      null,
            "harvests":         "Regolith",
            "capacity":         30,
            "requiresTech":     ["Lunar Base|Asteroid Base|Abandoned World Base"],
            "requiresStage":    0,
            "indicator":        "ind-regminer.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Gold Miner",
            "cost":             [{"resource":"Ore","amount":50},{"resource":"Steel","amount":10}],
            "tile":             "goldminer",
            "description":      "goldminer-description",
            "produces":         ["金矿"],
            "sellValue":        [{"resource":"Ore","amount":20},{"resource":"Steel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Gold",
            "capacity":         6,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-gold-miner.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"goldmienr-firstbuild",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Diamond Miner",
            "cost":             [{"resource":"Steel","amount":30}],
            "tile":             "diamondminer",
            "description":      "diamondminer-description",
            "produces":         ["Diamond Refinery"],
            "sellValue":        [{"resource":"Steel","amount":10}],
            "sellWarning":      null,
            "harvests":         "Diamond",
            "capacity":         15,
            "requiresTech":     ["Diamond Mining"],
            "requiresStage":    0,
            "indicator":        "ind-diamondminer.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Advanced Builder Bot",
            "cost":             [{"resource":"Ore","amount":30},{"resource":"Steel","amount":35},{"resource":"Gold","amount":10}],
            "tile":             "builder2",
            "description":      "builder2-description",
            "produces":         ["砖路","黄砖路","砖墙","硬化的路面","黑暗的路面","彩虹路","铝路","安全墙","安全壁灯","小垃圾坑","路灯","单亲家庭","蓝色房子","温室","黄色房子","Brick House","喷泉","大筒仓","木炭堆","油箱","水塔","绿色圆顶","Statue","统治雕像","传输中心","先进的水培中心","太阳能塔","钻石太阳能塔","钢铁场","钻石精炼厂","铀筒仓","先进的矿石精炼厂","耐用品仓库","住宅区","蓝色住宅区","时髦酒吧","恐怖之屋","大气冷凝器","质量司机","黑市集","太空港","汽车旅馆","中等大气发生器","旅馆","小赌场","芯片工厂","油厂","克隆设施","小型回收中心","文娱中心","领事馆","殖民地大会","领事馆2级","领事馆3级","超级市场","银行","陶器工程","砖厂","纺织厂","合成纺织厂","矿石开采作业","Regolith萃取公司","黄金合成实验室","矿石合成实验室","合成油实验室","铝精炼厂","机器人工厂","博物馆","鱼孵化场","小体育场","官僚机构","核反应堆"],
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Steel","amount":15},{"resource":"Gold","amount":4}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["先进的小规模建设"],
            "requiresStage":    0,
            "indicator":        "ind-construction-2.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Ice Chipper",
            "cost":             [{"resource":"Ore","amount":3}],
            "tile":             "icechipper",
            "description":      "icechipper-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":1}],
            "sellWarning":      null,
            "harvests":         "Water",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-icechipper.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Waterbot",
            "cost":             [{"resource":"Ore","amount":3}],
            "tile":             "icechipper",
            "description":      "waterbot-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":1}],
            "sellWarning":      null,
            "harvests":         "Water",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-icechipper.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Aluminum Miner",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":120},{"resource":"Microchip","amount":12}],
            "tile":             "aluminumminer",
            "description":      "aluminumminer-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":30},{"resource":"Steel","amount":50}],
            "sellWarning":      null,
            "harvests":         "Aluminum",
            "capacity":         8,
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    0,
            "indicator":        "ind-aluminum-miner.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Small Rover Transport",
            "cost":             [{"resource":"Ore","amount":90},{"resource":"Aluminum","amount":120},{"resource":"Gold","amount":100},{"resource":"Oil","amount":60}],
            "tile":             "rovertransport",
            "description":      "rovertransport-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Aluminum","amount":15},{"resource":"Gold","amount":4}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Advanced Chemistry","先进的小规模建设"],
            "requiresStage":    2,
            "indicator":        "ind-rovertransport.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 5,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Crudebot",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":120},{"resource":"Microchip","amount":12}],
            "tile":             "crudebot",
            "description":      "crudebot-description",
            "produces":         ["Oil Tank","Oil Plant"],
            "sellValue":        [{"resource":"Ore","amount":30},{"resource":"Steel","amount":50}],
            "sellWarning":      null,
            "harvests":         "Oil",
            "capacity":         12,
            "requiresTech":     ["Low Gravity Oil Production","Forest World Base"],
            "requiresStage":    2,
            "indicator":        "ind-crudebot.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Uranium Miner",
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Steel","amount":200},{"resource":"Microchip","amount":20},{"resource":"Aluminum","amount":40}],
            "tile":             "uraniumminer",
            "description":      "uraniumminer-description",
            "produces":         ["Uranium Silo"],
            "sellValue":        [{"resource":"Ore","amount":50},{"resource":"Steel","amount":80},{"resource":"Microchip","amount":2},{"resource":"Aluminum","amount":12}],
            "sellWarning":      null,
            "harvests":         "Uranium",
            "capacity":         8,
            "requiresTech":     ["Advanced Nuclear Physics"],
            "requiresStage":    0,
            "indicator":        "ind-uranium-miner.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Greenbot",
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Steel","amount":45},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":5}],
            "tile":             "greenbot",
            "description":      "greenbot-description",
            "produces":         ["Grass","Grass Scrub","Mail Box","Basket Ball Hoop","Fir Trees","Fountain","Red Flower Garden","Purple Flower Garden","Blue Flower Garden","White Flower Garden","Yellow Flower Garden","Cactus 1","Cactus 2","Cactus 3","棕榈 1","棕榈 2","Decorative Fir Trees","Potato Patch","Water Well","Wood Hut","Water Pool","小垃圾坑","Lumber Mill","Lumber Yard","细菌农场","Tree Farm","绵羊农场","大公园"],
            "sellValue":        [{"resource":"Ore","amount":25},{"resource":"Steel","amount":16},{"resource":"Gold","amount":6},{"resource":"Aluminum","amount":8},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Advanced Microbiology"],
            "requiresStage":    1,
            "indicator":        "ind-greenbot.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Lumberbot",
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Steel","amount":45},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":5}],
            "tile":             "lumberbot",
            "description":      "lumberbot-description",
            "produces":         ["Fir Trees","Decorative Fir Trees","Wood Hut","Charcoal Hut","Lumber Yard"],
            "sellValue":        [{"resource":"Ore","amount":25},{"resource":"Steel","amount":16},{"resource":"Gold","amount":6},{"resource":"Aluminum","amount":8},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "harvests":         "Wood",
            "capacity":         6,
            "requiresTech":     ["Advanced Microbiology"],
            "requiresStage":    2,
            "indicator":        "ind-lumberbot.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Claybot",
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Steel","amount":45},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":5}],
            "tile":             "claybot",
            "description":      "claybot-description",
            "produces":         ["Clay Mine","Pottery Works","Brick Factory","Sand","Yellow Sand","Orange Sand","Brick Road","Yellow Brick Road","Brick Wall","Cactus 1","Cactus 2","Cactus 3","Palm 1","Palm 2","Sand Dune","Deck Chairs","Desert Skull"],
            "sellValue":        [{"resource":"Ore","amount":25},{"resource":"Steel","amount":16},{"resource":"Gold","amount":6},{"resource":"Aluminum","amount":8},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "harvests":         "Clay",
            "capacity":         4,
            "requiresTech":     ["Clay Production"],
            "requiresStage":    1,
            "indicator":        "ind-claybot.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Megabot",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":70},{"resource":"Gold","amount":40},{"resource":"Aluminum","amount":40},{"resource":"Microchip","amount":10}],
            "tile":             "megabot",
            "description":      "megabot-description",
            "produces":         ["Large Water Tower","Large Helium 3 Tank","Subterranean Food Storage","Subterranean Charcoal Cavern","Large Medical Clinic","The Lander of Liberty","Obelisk of Colonial Independence","Tall Brick Warehouse","中等回收中心","焚烧炉","Bureau of Bureaucracy","氢气反应器","乔治阿尔外研究所","大型住宅区","铀浓缩设施","银河货运","Advanced Microchip Factory","Plastic Factory","Artificial Sweetner Factory","会议大厅","先进的医学研究中心","服装血汗工厂","玩具工厂","食品加工血汗工厂","豪华大厦","大型度假胜地","银河贸易委员会","联盟贸易管理局","领事馆4级","领事馆5级","Independence Hall","Independence Hall Level 2","Capitol","Capitol Level 2","Capitol Level 3","Capitol Level 4","Capitol Level 5","地下住房模块","Zoo","Pyramid of the All Seeing Eye","户外商场","Presidential Statue","Monument of Heroes","Statue of Unbridled Excess","垃圾填埋场","考古挖掘站点"],
            "sellValue":        [{"resource":"Ore","amount":35},{"resource":"Steel","amount":30},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":15},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Large Scale Construction"],
            "requiresStage":    0,
            "indicator":        "ind-megabot.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Construction Drone",
            "cost":             [{"resource":"Gold","amount":50},{"resource":"Aluminum","amount":400},{"resource":"Uranium","amount":10},{"resource":"Microchip","amount":60},{"resource":"Robot","amount":2}],
            "tile":             "condrone",
            "description":      "condrone-description",
            "produces":         ["安腾合成实验室","Ant Paste Synthesizer","先进的合成油实验室","Advanced Plastic Factory","Megamart","Vertical Warehouse Farm","Space Elevator","住宅塔","Blue Residential Tower","Medium Stadium","Big Playhouse","Capitol Level 6","Investment Bank","Triantanium炼油厂","Center for Artificial Learning","高级机器人公司","Star Gate","Arcology","Fantasy Land Arcology","Diamond Crystal Reactor","Atmosphere Scrubber","Hall of Congress"],
            "sellValue":        [{"resource":"Gold","amount":550},{"resource":"Aluminum","amount":40},{"resource":"Uranium","amount":1},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "requiresStage":    1,
            "indicator":        "ind-condrone.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Turbo Drone",
            "cost":             [{"resource":"Gold","amount":75},{"resource":"Aluminum","amount":600},{"resource":"Uranium","amount":20},{"resource":"Microchip","amount":140},{"resource":"Robot","amount":10},{"resource":"Alien Artifact","amount":100}],
            "tile":             "turbodrone",
            "description":      "turbodrone-description",
            "produces":         ["安腾合成实验室","Ant Paste Synthesizer","先进的合成油实验室","Advanced Plastic Factory","Megamart","Vertical Warehouse Farm","Space Elevator","Residential Tower","Blue Residential Tower","Medium Stadium","Big Playhouse","Capitol Level 6","Investment Bank","Triantanium炼油厂","Center for Artificial Learning","Advanced Robotics Inc.","Star Gate","Arcology","Fantasy Land Arcology","Diamond Crystal Reactor","Atmosphere Scrubber","Hall of Congress","Statue of Unbridled Excess"],
            "sellValue":        [{"resource":"Gold","amount":550},{"resource":"Aluminum","amount":40},{"resource":"Uranium","amount":1},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "requiresStage":    1,
            "indicator":        "ind-turbodrone.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     true,
            "firstBuildMessage":null,
            "buildSpeed":       40,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Extraterrestrial Builder",
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Steel","amount":300},{"resource":"Gold","amount":750},{"resource":"Uranium","amount":200},{"resource":"Microchip","amount":950},{"resource":"Alien Artifact","amount":10}],
            "tile":             "etbuilder",
            "description":      "etbuilder-description",
            "produces":         ["铝发电机","Ancient Alien Condenser","Quantum Warehouse","Quantum Food Storage","Quantum Water Tower","Quantum Oil Tank","Quantum Distillery","古代外星人矿石精炼厂","古老的外星微芯片工厂","超深挖掘网站","Alien Power Tower","异形浓缩设施"],
            "sellValue":        [{"resource":"Ore","amount":120},{"resource":"Steel","amount":120},{"resource":"Gold","amount":300},{"resource":"Uranium","amount":20},{"resource":"Microchip","amount":6},{"resource":"Alien Artifact","amount":1}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Ancient Alien Language"],
            "requiresStage":    2,
            "indicator":        "ind-etbuilder.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Waterbug",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "waterbug",
            "description":      "waterbug-description",
            "produces":         ["Communal Water Vats","Water Pool","Wet Mound","Wet Cone"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Water",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "waterbug-ind.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":"waterbug-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Queen",
            "cost":             [{"resource":"Food","amount":50},{"resource":"Sugar","amount":250}],
            "tile":             "queen",
            "description":      "queen-description",
            "produces":         null,
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-queen.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        "Mound",
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Worker Drone",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "insectoid1",
            "description":      "workerdrone-description",
            "produces":         ["甘蔗","Compacted Snow Path","Paste Path","Glow Goo","糊锅炉","水晶丘","湿丘","湿锥","宴席区","Communal Water Vats","浆池","育雏培训中心","糖燃烧器","Gold Burrow","Statue of Emperor Zolarg","酿造坑","Gentelbugs Club","Golden Sign","深空收发器","昆虫薄荷","钛冶炼厂","电源尖顶","Unholy Power Spire","遗迹大锅","不洁酿造坑","Unholy Mound of Worship","Unholy Core Mine","Unholy Pit of Stuff","Elders Mound","Healing Pods","Supply Pile","采矿作业","食品强化设施","糖农场","钱坑","出口大炮","Customs Processing","商业坛","指挥所","高级指挥所","高级命令","更高的命令","矿石浓缩设施","铝蜂巢","Paste Treatment Spa","Shrine of Mystics","Bloodletting Station","布料农场","邪恶的命令"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Sugar",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-workerdrone.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Orebug",
            "cost":             [{"resource":"Food","amount":30}],
            "tile":             "orebug",
            "description":      "orebug-description",
            "produces":         ["Ore Tunnel","Mining Operation"],
            "sellValue":        [{"resource":"Ore","amount":10}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         30,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-orebug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":"orebug-firstbuilt-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Goldbug",
            "cost":             [{"resource":"Food","amount":80}],
            "tile":             "goldbug",
            "description":      "goldbug-description",
            "produces":         ["Gold Burrow","Mining Operation","Statue of Emperor Zolarg","Spire of Knowledge","Orb of Radiance"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Gold",
            "capacity":         10,
            "requiresTech":     ["Gold Storage"],
            "requiresStage":    0,
            "indicator":        "ind-goldbug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Lumberbug",
            "cost":             [{"resource":"Food","amount":80}],
            "tile":             "lumberbug",
            "description":      "lumberbug-description",
            "produces":         ["Fir Trees","Megatree","Lumber Camp","Power Spire","Unholy Power Spire","Shrine of Mystics"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Wood",
            "capacity":         10,
            "requiresTech":     ["Wood Harvesting"],
            "requiresStage":    0,
            "indicator":        "ind-lumberbug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Alumibug",
            "cost":             [{"resource":"Food","amount":120}],
            "tile":             "alumibug",
            "description":      "alumibug-description",
            "produces":         ["Aluminum Road","Aluminum Mine","Aluminum Hive","Wet Cone","Unholy Power Spire","Relic Cauldron","Unholy Brew Pit","Shrine of Mystics","Unholy Mound of Worship","Unholy Core Mine","Unholy Pit of Stuff","Spire of Knowledge","Orb of Radiance","Advanced Command Post","Unholy Command"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Aluminum",
            "capacity":         8,
            "requiresTech":     ["Advanced Metallurgy"],
            "requiresStage":    0,
            "indicator":        "ind-alumibug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Tundrabug",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "tundrabug",
            "description":      "tundrabug-description",
            "produces":         ["Compacted Snow Path","Ore Tunnel","Paste Boiler","Crystalmound","合成结晶矿床"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     ["Insectoid Base","Ice World Base"],
            "requiresStage":    0,
            "indicator":        "ind-tundrabug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Extremeobug",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "extremeobug",
            "description":      "extremeobug-description",
            "produces":         ["Crystal Vaporizer","Ore Tunnel","Paste Boiler","Crystalmound","Synthetic Crystalline Deposit"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     ["Insectoid Base","Lava World Base"],
            "requiresStage":    0,
            "indicator":        "ind-tundrabug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Obsidiobug",
            "cost":             [{"resource":"Food","amount":25}],
            "tile":             "obsidiobug",
            "description":      "obsidiobug-description",
            "produces":         null,
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Obsidian",
            "capacity":         2,
            "requiresTech":     ["Insectoid Base","Lava World Base"],
            "requiresStage":    0,
            "indicator":        "ind-obsidiobug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Ancientbug",
            "cost":             [{"resource":"Food","amount":200},{"resource":"Alien Relic","amount":5},{"resource":"Alien Artifact","amount":5}],
            "tile":             "ancientbug",
            "description":      "ancientbug-description",
            "produces":         ["量子糖克隆"],
            "sellValue":        [{"resource":"Food","amount":2}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         8,
            "requiresTech":     ["Ancient Alien Language"],
            "requiresStage":    0,
            "indicator":        "ind-ancientbug.png",
            "buildCategories":  ["所有工人"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "LIS Rover",
            "cost":             [{"resource":"Regolith","amount":12}],
            "tile":             "lisrover",
            "description":      "lisrover-description",
            "produces":         ["Compacted Snow Path","Raw Materials Depot","Small Helium 3 Extractor","Regolith Compactor","温室","Water Extractor","Regolith Furnace","Small Solar Panel","小型车辆厂"],
            "sellValue":        [{"resource":"Regolith","amount":3}],
            "sellWarning":      null,
            "harvests":         "Regolith",
            "capacity":         8,
            "requiresTech":     ["Human Base","LIS Base"],
            "requiresStage":    0,
            "indicator":        "ind-lisrover.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"lunar-rover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Sugar Rover",
            "cost":             [{"resource":"Ore","amount":5},{"resource":"Regolith","amount":15}],
            "tile":             "sugarrover",
            "description":      "sugarrover-description",
            "produces":         ["Sugarcane","Small Sugar Processor"],
            "sellValue":        [{"resource":"Regolith","amount":3}],
            "sellWarning":      null,
            "harvests":         "Sugar",
            "capacity":         8,
            "requiresTech":     ["Human Base","LIS Base","Abandoned World Base"],
            "requiresStage":    0,
            "indicator":        "ind-sugarrover.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        },
        {
            "name":             "Tundra Rover",
            "cost":             [{"resource":"Crystalline","amount":20}],
            "tile":             "crystalminer",
            "description":      "crystalminer-description",
            "produces":         ["Compacted Snow Path","Raw Materials Depot","微型矿山","Regolith Furnace","合成结晶矿床"],
            "sellValue":        [{"resource":"Crystalline","amount":6}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     ["Human Base","LIS Base","Ice World Base"],
            "requiresStage":    0,
            "indicator":        "ind-tundrarover.png",
            "buildCategories":  ["所有车辆"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0
        }
    ],
    "names": {
        "Human": {
            "first": [
                "PlatinumOre",
                "Hayenn",
                "Vyryn",
                "Liam",
                "Noah",
                "Ethan",
                "Lucas",
                "Mason",
                "Oliver",
                "Aiden",
                "Elijah",
                "James",
                "Benjamin",
                "Logan",
                "Jacob",
                "Jackson",
                "Alexander",
                "Michael",
                "Jack",
                "Carter",
                "Luke",
                "Owen",
                "William",
                "Gabriel",
                "Daniel",
                "Henry",
                "Matthew",
                "Wyatt",
                "Sebastian",
                "Caleb",
                "Grayson",
                "Ryan",
                "Isaac",
                "Nathan",
                "Dylan",
                "Levi",
                "Jayden",
                "Jaxon",
                "David",
                "Eli",
                "Andrew",
                "Samuel",
                "Joseph",
                "Emma",
                "Olivia",
                "Ava",
                "Sophia",
                "Isabella",
                "Mia",
                "Charlotte",
                "Harper",
                "Amelia",
                "Abigail",
                "Emily",
                "Madison",
                "Lily",
                "Ella",
                "Avery",
                "Aria",
                "Evelyn",
                "Chloe",
                "Scarlett",
                "Ellie",
                "Riley",
                "Addison",
                "Elizabeth",
                "Aubrey",
                "Layla",
                "Zoey",
                "Grace",
                "Hannah",
                "Mila",
                "Victoria",
                "Brooklyn",
                "Lucy"
            ],
            "last": [
                "Smith",
                "Johnson",
                "Williams",
                "Brown",
                "Jones",
                "Miller",
                "Davis",
                "Garcia",
                "Rodriguez",
                "Wilson",
                "Martinez",
                "Anderson",
                "Taylor",
                "Thomas",
                "Moore",
                "Martin",
                "Jackson",
                "Thompson",
                "White",
                "Lopez",
                "Lee",
                "Harris",
                "Clark",
                "Lewis",
                "Robinson",
                "Walker",
                "Perez",
                "Hall",
                "Young",
                "Allen",
                "Sanchez",
                "Wright",
                "King",
                "Scott",
                "Green",
                "Baker",
                "Adams",
                "Nelson",
                "Hill",
                "Ramirez",
                "Campbell",
                "Mitchell",
                "Roberts",
                "Carter",
                "Evans",
                "Stewart",
                "Flores",
                "Nguyen",
                "Jenkins"
            ]
        },
        "Insectoids": {
            "joint": [
                "Aarde",
                "Aardewerk",
                "Aardling",
                "Afschuw",
                "Afstel",
                "Anijs",
                "Apetrots",
                "Bakfiets",
                "Baksteen",
                "Ballon",
                "Belasting",
                "Bloemkool",
                "Boek",
                "Boterham",
                "Brandweer",
                "Broek",
                "Buitenaardse",
                "Bureau",
                "Chagrijn",
                "Dampkring",
                "Dans",
                "Deurwaarder",
                "Dienstklopper",
                "Dochter",
                "Eekhoorn",
                "Erts",
                "Ezel",
                "Fiets",
                "Gabber",
                "Gast",
                "Geld",
                "Gevaarlijk",
                "Goud",
                "Graaf",
                "Graan",
                "Grond",
                "Gruis",
                "Hagel",
                "Handschoen",
                "Heerlijk",
                "Heerser",
                "Hout",
                "Houtskool",
                "Ijsbeer",
                "Ijzer",
                "Kapsalon",
                "Kast",
                "Kikker",
                "Kledij",
                "Klei",
                "Klokhuis",
                "Koning",
                "Kramp",
                "Kroket",
                "Lekker",
                "Lieveheersbeestje",
                "Lucht",
                "Matthijs",
                "Merel",
                "Mier",
                "Moeder",
                "Muildier",
                "Neef",
                "Nicht",
                "Noord",
                "Oliebol",
                "Oma",
                "Onderbroek",
                "Onderzoek",
                "Oneerlijk",
                "Onhandig",
                "Oom",
                "Oorbel",
                "Oorlog",
                "Oost",
                "Opa",
                "Opmerkelijk",
                "Paard",
                "Pannenkoek",
                "Pindakaas",
                "Poppetje",
                "Potjes",
                "Rakelings",
                "Ruimtewezen",
                "Speelgoed",
                "Spiegelei",
                "Spijkerbroek",
                "Steen",
                "Steenkool",
                "Suiker",
                "Tandpasta",
                "Tante",
                "Tarwe",
                "Termiet",
                "Trui",
                "Uitstel",
                "Uitvreter",
                "Uitzicht",
                "Vader",
                "Verhaal",
                "Vierkant",
                "Vies",
                "Vleermuis",
                "Vliegtuig",
                "Vliegtuig",
                "Vlokken",
                "Voedsel",
                "Voorwerp",
                "Vriend",
                "Vriendin",
                "Vrijdag",
                "Vuur",
                "Vuurtoren",
                "Wasbeer",
                "Washandje",
                "Wasmand",
                "Wol",
                "Zakdoek",
                "Zakkenroller",
                "Zaklamp",
                "Zeehond",
                "Zeekoe",
                "Ziekenhuis",
                "Zoon",
                "Zuid"
            ]
        }
    }
};
