"use strict";
/* global webAppCore */
/* global Scroll2d */
/* global ColonyGame */
/* global Checksum */
(function() {
    // Event Listeners
    window.addEventListener("load",startApp,false);
    window.addEventListener("resize",sizeElements,false);
    window.addEventListener("keydown",onKeydown,false);
    window.addEventListener("keyup",onKeyup,false);

    var KEY_DEFAULT_CLEAR = "Escape";
    var KEY_DEFAULT_IDLE = "w";
    var KEY_DEFAULT_SELL_NO_CONFIRM = "alt+s";
    var KEY_DEFAULT_UPGRADE_NO_CONFIRM = "alt+u";
    var KEY_DEFAULT_MOVE = "m";
    var KEY_DEFAULT_HARVEST = "h";
    var KEY_DEFAULT_BUILD = "b";
    var KEY_DEFAULT_EXPORT = "e";
    var KEY_DEFAULT_IMPORT = "i";
    var KEY_DEFAULT_SELL = "s";
    var KEY_DEFAULT_UPGRADE = "u";
    var KEY_DEFAULT_CANCEL = "c";
    var KEY_DEFAULT_CANCEL_NO_CONFIRM = "alt+c";

    var KEY_DEFAULT_ZOOM_OUT = "-";
    var KEY_DEFAULT_ZOOM_IN = "=";
    var KEY_DEFAULT_PARK = "p";
    var KEY_DEFAULT_STATS_WINDOW = "s";
    var KEY_DEFAULT_TECH_WINDOW = "t";
    var KEY_DEFAULT_ENCY_WINDOW = "e";
    var KEY_DEFAULT_UNEM_WINDOW = "u";
    var KEY_DEFAULT_PAN_UP = "ArrowUp";
    var KEY_DEFAULT_PAN_DOWN = "ArrowDown";
    var KEY_DEFAULT_PAN_LEFT = "ArrowLeft";
    var KEY_DEFAULT_PAN_RIGHT = "ArrowRight";

    var shoreUpdateTurn = false;

    var resourceUpdateTurn = false;

    var serverMaxTradeSize = 500;

    var bulldozerMode = false;

    var allowLighting = true;

    var defaultCompressionSetting = true;

    var totalAvailableVehicles = 0;


    var DEF_MEDICAL_RANGE = 40;
    var DEF_ENTERTAINMENT_RANGE = 60;

    var exportPenalty = 0.1;
    var importPenalty = 0.05;

    var importPriceMod = 2;
    var exportPriceMod = 0.25;

    var gamepadInUse = false;

    var gotItMadePrice = 1000;

    var usingTouch = false;

    var runningHomelessCount = 0;

    var inMultiSelectionMode = false;

    var retainedPaths = {};
    var retainedUsage = {};
    var retainedPathsCounter = 0;

    var shouldUpdateCollissionMap = true;

    var titleShowing = false;

    var hasConsulate = false;
    var hasCapitol = false;

    var freeRefNukeTurn = false;

    var maxSimulants = 2000;
    var simSyncCounter = 0;

    var unsimulatedRunningMoney = 0;
    var unsimulatedHealth = 0;
    var unsimulatedAge = 0;

    var showZoomButtons = false;

    var selectedBuildCategory = null;

    var callForHireFlag = false;
    var callForHousingFlag = false;

    var runningColonistReferenceArray = {};
    var touchPossibleBuildPoints = [];

    var currentActiveTextureMod = null;

    var chainQueue = null;

    var constructionFromSidebar = false;

    var chainBuildMode = true;

    var sidebarModeWidth = 1000;
    
    // Global Hooks
    window.wacMenuOptionSelected = onMenuOptionSelected;
    
    // Layout Elements
    var moneyReadout;
    
    // var variables
    var hoverX = 0;
    var hoverY = 0;

    var desktopMode = false;

    var saveCounterMax = 8000;

    var drawColonists = true;
    var fpsRate = 1;
    var useTextPoppers = true;

    var savedGameListing = [];

    var actualX;
    var actualY;

    var lowCapacityCounter = 2500;
    var lowPowerNagLimit = 4000;
    
    var mailCheckLimit = 15000;
    var mailCheckTimer = 14800;

    var pauseDrawing = false;

    var resourceReadouts = {};

    var idleBuilderIndex = 0;

    var allResourceMode = true;
    var transparencyMode = 0;

    var allowAudio = true;
    var allowMusic = true;

    var zoomLevel = 1;

    var vehicleDefReference = {};
    var buildingDefReference = {};
    var terrainDefReference = {};
    var resourceDefReference = {};
    var occupationDefReference = {};
    var utilityDefReference = {};

    var passableTileRefs = {};

    var previouslyAvailableShelters = 0;
    var previouslyAvailableTourism = 0;
    
    var objectForSell = null;
    var objectForSellType = null;

    var allowParticleEffects = true;
    
    var utilityGridCounter = 0;

    var inHireMode = false;
    
    var gameAssets = {};
    var totalAssets = 0;
    var loadedAssets = 0;

    var medicalCoverageMode = false;
    var medicalCoveragePoints = [];

    var entertainmentCoverageMode = false;
    var entertainmentCoveragePoints = [];

    var selectedBuilding = null;
    var selectedVehicle = [];
    var selectedResource = null;
    var selectedColonist = null;
    var selectedPassable = null;
    var hoverBuilding = null;

    var resourceKillArray = [];
    var colonistKillArray = [];
    var vehicleKillArray = [];

    var pendingBuildX = null;
    var pendingBuildY = null;
    
    var queuedBuildings = null;
    var queuedBuilding = null;
    var queuedBuildingBlocked = false;
    
    var usingMouse = false;
    
    var queuedMove = null;
    var queuedPark = null;
    var hoverPassable = false;

    var collisionReference;
    var flyingCollisionReference;

    var usingSockets = false;
    
    var currentGame;
    
    var killSwitch = false;
    var showListingAfterSave = false;
    
    var currentFileName = "";

    var allowAnimation = true;
    
    var saveCounter = 0;

    var ourCapitolBuilding = null;

    var checkPreviousCounter = 400;

    var checkRenderDistance = true;

    var pathWorker1;
    //var pathWorker2;
    var vehiclePathOrders = {};
    var colonistPathOrders = {};

    var currentModData = null;

    var allowDayNight = "1";
    
    function startApp() {
        webAppCore.startApp(initApp);
    }

    var initAttempts = 0;
    
    function initApp() {

        if(!ColonyGame) {
            initAttempts++;

            if(initAttempts < 5) {
                setTimeout(initApp,500);
            }

            return;
        }

        

        if(webAppCore.getPlatform().platform == "ios" || webAppCore.getPlatform().platform == "android") {
            maxSimulants = 500;
        }

        if(webAppCore.getPlatform().platform == "web") {
            maxSimulants = 1500;
        }

        gooseUpPathWorker();

        webAppCore.setGamepadFunctions(onPadDown,onPadUp);

        setAutosaveTimer();

        webAppCore.setFacebookStatusListener(onFacebookStatusChange);

        webAppCore.setTheme(ColonyGame.meta.theme);
        webAppCore.setTitle(ColonyGame.meta.name);

        var audioSaveOption = webAppCore.getVar("allow-audio","1");
        if(audioSaveOption == "1") {
            allowAudio = true;
        } else {
            allowAudio = false;
        }


        var manualFPSControl = webAppCore.getVar("use-manual-fps","0");

        if(manualFPSControl == "1") {
            monitoringFPS = false;
        } else {
            monitoringFPS = true;
        }


        var lightingSaveOption = webAppCore.getVar("allow-lighting","1");
        if(lightingSaveOption == "1") {
            allowLighting = true;
        } else {
            allowLighting = false;
        }

        var renderDistanceCheckOption = webAppCore.getVar("check-render-distance","1");
        if(renderDistanceCheckOption == "1") {
            checkRenderDistance = true;
        } else {
            checkRenderDistance = false;
        }

        var particleSaveOption = webAppCore.getVar("allow-particles","1");
        if(particleSaveOption == "1") {
            allowParticleEffects = true;
        } else {
            allowParticleEffects = false;
        }

        var animationSaveOption = webAppCore.getVar("allow-animation","1");
        if(animationSaveOption == "1") {
            allowAnimation = true;
        } else {
            allowAnimation = false;
        }

        allowDayNight = webAppCore.getVar("allow-daynight","1");

        
        var musicSaveOption = webAppCore.getVar("allow-music","1");
        if(musicSaveOption == "1") {
            allowMusic = true;
        } else {
            allowMusic = false;
        }

        var textureModOption = webAppCore.getVar("active-texture-mod","0");
        if(textureModOption == "0") {
            currentActiveTextureMod = null;
        } else {
            currentActiveTextureMod = textureModOption;
        }
        
        if(!webAppCore.getIsPremium()) {
            currentActiveTextureMod = null;
        }

        var desktopModeDefault = "0";

        if(webAppCore.getPlatform().platform == "desktop" || (window.innerWidth > sidebarModeWidth && (webAppCore.getPlatform().platform == "web" || webAppCore.getPlatform().platform == "windows"))) {
            desktopModeDefault = "1";
        }

        if(webAppCore.getPlatform().platform == "desktop" || webAppCore.getPlatform().platform == "android" || webAppCore.getPlatform().platform == "windows") {
            defaultCompressionSetting = false;
        }

        if(webAppCore.isTV()) {
            gamepadInUse = true;
        }

        if(webAppCore.getVar("desktop-mode",desktopModeDefault) == "1") {
            desktopMode = true;
        }

        setBodyStyles();

        if(webAppCore.getVar("draw-col-setting","1") == "1") {
            drawColonists = true;
        } else {
            drawColonists = false;
        }

        if(webAppCore.getVar("popper-setting","1") == "1") {
            useTextPoppers = true;
        } else {
            useTextPoppers = false;
        }

        fpsRate = parseInt(webAppCore.getVar("fps-rate-setting","1"));
        
        webAppCore.handlePauseFunction(onPause);
        webAppCore.handleResumeFunction(onResume);
        webAppCore.setOnImageImportListener(onImageImport);

        initResourceDefs();

        linkLayouts();
        setupMenuOptions();

        sizeElements();

        initBuildCategories();
        initUtilityDefs();
        initOccupationDefs();
        
        initBuildingDefs();
        initVehicleDefs();
        initTerrainDefs();
        initResourceReadouts();
        loadPassableTileDefs();
        
        if(currentActiveTextureMod == null) {
            loadAssets();
        } else {
            pendingOpenTextureFileName = currentActiveTextureMod;
            webAppCore.openFile(pendingOpenTextureFileName,onOpenTexturePackForActivation);
        }

        if(ColonyGame.meta.releaseNotesServer != null && !webAppCore.isTV()) {
            if(webAppCore.getVar("release-notes-" + ColonyGame.meta.releaseCode,"0") != "1") {
                fetchReleaseNotes();
            }
        }

    }

    function loadPassableTileDefs() {
        passableTileRefs = {};

        for(var i = 0; i < ColonyGame.buildings.length; i++) {
            if(ColonyGame.buildings[i].passable) {
                passableTileRefs[ColonyGame.buildings[i].name] = ColonyGame.buildings[i];
            }
        }

    }

    function onFacebookStatusChange() {

        setAutosaveTimer();
    }
    
    function onPause() {
        inBackgroundMode = true;

        if(currentGame != null) {
            saveCounter = 0;
            saveGame();
        }
    }
    
    function onResume() {
        inBackgroundMode = false;
    }
    
    function onImageImport() {
        // do nothing
    }

    function isRestrictivePlatform() {
        if(webAppCore.getPlatform().platform == "ios") {
            return true;
        }

        if(webAppCore.getPlatform().platform == "windows") {
            return true;
        }

        if(webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "amazon") {
            return true;
        }

        if(webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "gplay") {
            return true;
        }

        return false;
    }

    var colonyNeverLoaded = false;

    function initOnlineColony() {

        if(!currentGame.colonyId || currentGame.colonyId == 0 || currentGame.colonyId == "0") {
            setTimeout(registerColonyId,100);
        } else {
            webAppCore.showSplash("Syncing Data With Server...");
            colonyNeverLoaded = true;

            setTimeout(checkBlacklist,100);

            setTimeout(checkMyContracts,300);

            if(currentGame.isIndependent && currentGame.charter && currentGame.charter != 0) {
                setTimeout(getChildColonies,500);
            }

            setTimeout(refreshMarketPrices,700);

            setTimeout(function() {
                updateColonyStats(true);
            },900);

            setTimeout(function(){
                if(colonyNeverLoaded) {
                    currentGame = null;
                    webAppCore.clearSplash();
                    showTitle();
                    webAppCore.showAlertWithTitle(getString("connection-error-info"),getString("general-connection-error"));
                }
            },10000);
        }
    }

    function establishSocketConnection() {
        if(ColonyGame.meta.socketServer != null) {
            webAppCore.socketConnect(ColonyGame.meta.socketServer);
            webAppCore.addSocketListener("connect",onSocketConnect);
            webAppCore.addSocketListener("disconnect",onSocketDisconnect);
            webAppCore.addSocketListener("message",onSocketMessage);
        }
    }

    function setBodyStyles() {

        var className = "";

        if(usingTouch) {
            if(desktopMode) {
                className = "desktopMode touchMode";
            } else {
                className = "touchMode";
            }
        } else {
            if(desktopMode) {
                className = "desktopMode";
            } else {
                className = "";
            }
        }

        if(gamepadInUse) {
            className = "gamepadMode";
        }

        if(document.body.className != className) {
            document.body.className = className.trim();

            setTimeout(function() {
                sizeElements();
                Scroll2d.sizeElements();
                setupMenuOptions();
            },100);
            
        }

        
    }
    
    function sizeElements() {
        if(window.innerWidth > sidebarModeWidth && !webAppCore.isTV() && !gamepadInUse) {

            var desktopModeDefault = "0";

            if(webAppCore.getPlatform().platform == "desktop" || webAppCore.getPlatform().platform == "web" || webAppCore.getPlatform().platform == "windows") {
                desktopModeDefault = "1";
            }

            if(webAppCore.getVar("desktop-mode",desktopModeDefault) == "1") {
                desktopMode = true;
            } else {
                desktopMode = false;
            }
        } else {
            desktopMode = false;
        }

        if(currentGame && currentGame.readOnlyMode) {
            desktopMode = false;
        }

        if(desktopMode) {
            document.getElementById("sidebar").style.display = "block";
        }

        setBodyStyles();

        
        setMinWidths();
        
    }

    function setMinWidths() {
		
		if (!moneyReadout) {
            return;
        }
		
        if(window.innerWidth < 1000) {

            if(!moneyReadout.useThisWidth) {
                moneyReadout.useThisWidth = moneyReadout.offsetWidth - 1;
            }
            
            if(moneyReadout.offsetWidth - 1 > moneyReadout.useThisWidth) {
                moneyReadout.useThisWidth = moneyReadout.offsetWidth - 1;
                
            }

            moneyReadout.style.minWidth = moneyReadout.useThisWidth + "px";
        } else {
            moneyReadout.style.minWidth = "initial";
        }
    }

    var padTimeout = null;

    function clearGamepad() {
        padTimeout = null;
        cameFromGamepad = false;
    }

    function startPadTimeout() {
        if(padTimeout != null) {
            clearTimeout(padTimeout);
            padTimeout = null;
        }

        padTimeout = setTimeout(clearGamepad,300);
    }

    var gamepadSelectedSidebarOption = -1;
    var lastSidebarGamepadDirection = 0;
    var gamepadScrollRetrys = 0;

    function handleSidebarGamepadSelection() {

        var tmpItems = document.getElementById("sidebarBuildListing").querySelectorAll(".buildItem");

        var buildItems = [];
        var i;

        for(i = 0; i < tmpItems.length; i++) {
            if(tmpItems[i].style.display != "none") {
                buildItems.push(tmpItems[i]);
            }
        }

        if(gamepadScrollRetrys > buildItems.length) {
            return;
        }


        if(buildItems.length == 0) {
            return;
        }
        
        isCoolingDown = true;

        setTimeout(function() {
            isCoolingDown = false;
        },100);

        if(gamepadSelectedSidebarOption >= buildItems.length) {
            gamepadSelectedSidebarOption = 0;
        }

        if(gamepadSelectedSidebarOption < 0) {
            gamepadSelectedSidebarOption = buildItems.length - 1;
        }

        if(buildItems[gamepadSelectedSidebarOption].cantAffortThis) {
            gamepadScrollRetrys++;
            gamepadSelectedSidebarOption += lastSidebarGamepadDirection;
            handleSidebarGamepadSelection();
            return;
        }

        for(i = 0; i < buildItems.length; i++) {
            if(i == gamepadSelectedSidebarOption) {
                buildItems[i].className = buildItems[i].baseClassSave + " gamepadSelected";
                buildItems[i].scrollIntoView();
            } else {
                buildItems[i].className = buildItems[i].baseClassSave;
            }
        }
    }

    function handleSidebarGamepadSelectionClick() {
        document.getElementById("sidebar").style.display = "none";

        if(gamepadSelectedSidebarOption < 0) {
            return;
        }

        var buildItems = document.getElementById("sidebarBuildListing").querySelectorAll(".buildItem");
        
        if(gamepadSelectedSidebarOption >= buildItems.length) {
            return;
        }

        buildItems[gamepadSelectedSidebarOption].click();

        cooldownGamepad();


    }

    var padReference = {};

    function onPadDown(id,button) {

        if(!gamepadInUse) {
            gamepadInUse = true;
            setBodyStyles();
        }

        if(isCoolingDown || inBackgroundMode) {
            return;
        }

        if(padReference[button] === undefined) {
            padReference[button] = false;
        }

        if(padReference[button]) {
            return;
        }

        padReference[button] = true;

        startPadTimeout();

        cameFromGamepad = true;


        if(tipsWindowOpen) {
            closeTipsPopup();
            return;
        }


        if(statsOpen) {

            if(button == "down") {
                gamepadStatOption++;
                highlightActiveStatSection();
            }

            if(button == "up") {
                gamepadStatOption--;
                highlightActiveStatSection();
            }

            if(button == "b" || button == "lb") {
                closeStatsMenu();
            }
            
            return;
        }


        if(gbtOpen) {

            if(button == "a") {
                engageContractPurchase();
            }
            
            if(button == "down") {
                gamepadGbtOption++;
                highlightNextGbtSidebarOption();
            }

            if(button == "up") {
                gamepadGbtOption--;
                highlightNextGbtSidebarOption();
            }

            if(button == "rup") {
                currentSelectedGamepadContract -= gamepadContractsPerLine;
                highlightSelectedContractGamepad();
            }

            if(button == "rdown") {
                currentSelectedGamepadContract += gamepadContractsPerLine;
                highlightSelectedContractGamepad();
            }

            if(button == "rleft") {
                currentSelectedGamepadContract--;
                highlightSelectedContractGamepad();
            }

            if(button == "rright") {
                currentSelectedGamepadContract++;
                highlightSelectedContractGamepad();
            }

            if(button == "b" || button == "lb") {
                closeGBT();
            }

            return;
        }


        if(document.getElementById("sidebar").style.display == "block") {
            if(button == "b" || button == "y") {
                document.getElementById("sidebar").style.display = "none";
            }

            if(button == "left" || button == "lb") {
                gamepadSelectedSidebarOption--;
                lastSidebarGamepadDirection = -1;
                gamepadScrollRetrys = 0;
                handleSidebarGamepadSelection();
            }

            if(button == "right" || button == "rb") {
                gamepadSelectedSidebarOption++;
                lastSidebarGamepadDirection = 1;
                gamepadScrollRetrys = 0;
                handleSidebarGamepadSelection();
            }

            if(button == "a") {
                handleSidebarGamepadSelectionClick();
            }

            if(button == "up" || button == "down") {
                if(button == "up") {
                    gamepadSelectedBuildCategory++;
                }

                if(button == "down") {
                    gamepadSelectedBuildCategory--;
                }

                if(gamepadSelectedBuildCategory < 0) {
                    gamepadSelectedBuildCategory = allBuildCategories.length - 1;
                }

                if(gamepadSelectedBuildCategory >= allBuildCategories.length) {
                    gamepadSelectedBuildCategory = 0;
                }
                

                selectedBuildCategory = allBuildCategories[gamepadSelectedBuildCategory];
                document.getElementById("gamepadFilterText").innerHTML = selectedBuildCategory;

                drawSidebar();

                gamepadSelectedSidebarOption = 0;
                handleSidebarGamepadSelection();
                lastSidebarGamepadDirection = 0;
            }

            return;
        }


        

        if(document.getElementById("touchBuildConfirm").style.display == "block" || document.getElementById("gamepadBuildConfirm").style.display == "block") {
            if(button == "x") {
                document.getElementById("tbcConfirm").click();
                return;
            }

            if(button == "b" || button == "start" || button == "lb") {
                document.getElementById("tbcCancel").click();
                return;
            }

            
        }



        if(document.getElementById("objectOptions").style.display == "block") {
            objectOptionsGamepadDown(button);
            return;
        }

        if(button == "start" || button == "lb") {
            cooldownGamepad();
            webAppCore.toggleMenu();
            padReference[button] = false;
            return;
        }

        

        if(button == "y") {
            if(document.getElementById("sidebar").style.display == "block") {
                document.getElementById("sidebar").style.display = "none";
            } else {
                document.getElementById("sidebar").style.display = "block";

                lastSidebarGamepadDirection = 0;
                gamepadScrollRetrys = 0;

                if(gamepadSelectedSidebarOption == -1) {
                    gamepadSelectedSidebarOption = 0;
                }

                handleSidebarGamepadSelection();
            }

            return;
        }

        if(button == "rb") {
            allResourceMode = !allResourceMode;
            return;
        }

        if(button == "b") {

            

            if(colonyWindowOpen) {
                closeColonyWindow();
                return;
            }

            if(commonwealthMenuOpen) {
                closeCommonwealthMenu();
                return;
            }

            

            
            if(newObjectOptionsOpen) {
                closeObjectOptionsMenu();
                return;
            }
            

            selectIdleBuilder();
            return;
        }

        if(button == "x") {
            Scroll2d.setZoomLevel(1);
            centerMap();
            return;
        }

        if(button == "rt") {
            if(currentGame.mail.length > 0) {
                showMail();
                cooldownGamepad();
                return;
            }

            if(currentGame.gifts.length > 0) {
                showGifts();
                cooldownGamepad();
                return;
            }
        }

        Scroll2d.gamepadDown(button);
    }

    function onPadUp(id,button) {

        if(!gamepadInUse) {
            gamepadInUse = true;
            setBodyStyles();
        }

        padReference[button] = false;

        if(isCoolingDown || inBackgroundMode) {
            return;
        }

        startPadTimeout();

        if(document.getElementById("objectOptions").style.display == "block") {

            return;
        }

        Scroll2d.gamepadUp(button);
    }

    var gamepadCooldown = null;
    var isCoolingDown = false;

    function cooldownGamepad() {
        isCoolingDown = true;

        if(gamepadCooldown != null) {
            clearTimeout(gamepadCooldown);
            gamepadCooldown = null;
        }

        gamepadCooldown = setTimeout(gamepadIsCool,150);
    } 

    function gamepadIsCool() {
        isCoolingDown = false;
        gamepadCooldown = null;
    }

    function objectOptionsGamepadDown(button) {
        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        var selectionChanged = false;

        if(button == "down" || button == "up" || button == "left" || button == "right") {

            if(button == "down" || button == "right") {
                while(!selectionChanged) {
                    gamepadSelectionButton++;

                    if(gamepadSelectionButton >= buttons.length) {
                        gamepadSelectionButton = 0;
                    }

                    if(buttons[gamepadSelectionButton].style.display == "inline-block") {
                        selectionChanged = true;
                    }
                }
            } else {
                while(!selectionChanged) {
                    gamepadSelectionButton--;

                    if(gamepadSelectionButton < 0) {
                        gamepadSelectionButton = buttons.length - 1;
                    }

                    if(buttons[gamepadSelectionButton].style.display == "inline-block") {
                        selectionChanged = true;
                    }
                }
            }


            highlightSelectedObjectButton();
        }

        if(button == "a") {
            cooldownGamepad();
            executeSelectedGamepadButton();
        }

        if(button == "b" && selectedVehicle.length > 0) {
            selectIdleBuilder();
        }
    }

    function drawLineChart(canvas,data,hardMin,hardMax,color) {


        var chartContext = canvas.getContext("2d");

        var startingPoint = 0;

        var min = 0;
        var max = 100;

        if(data.length > 400) {
            startingPoint = data.length - 400;
        }

        for(i = startingPoint; i < data.length; i++) {
            

            if(min == 0 || data[i] < min) {
                min = data[i];
            }

            if(data[i] > max) {
                max = data[i];
            }
        }

        if(hardMin != null) {
            min = hardMin;
        }

        if(hardMax != null) {
            max = hardMax;
        }

        var scale = 1;

        if((max - min) > 300) {
            scale = 300 / (max - min);
        }

        if((max - min) < 300) {
            scale = 300 / (max - min);
        }

        chartContext.beginPath();

        chartContext.save();

        chartContext.translate(0,300);

        chartContext.clearRect(0,-300,canvas.width,canvas.height);
        
        var drawX = 0;
        var i;

        for(i = startingPoint; i < data.length; i++) {
            
            var y = data[i] - min;
            y *= scale;
            y = y * -1;

            if(i == startingPoint) {
                chartContext.moveTo(drawX,y);
            } else {
                chartContext.lineTo(drawX,y);
            }

            drawX++;
        }

        chartContext.lineWidth = 3;
        chartContext.strokeStyle = color;

        chartContext.stroke();
        chartContext.restore();
    }

    function updateResourceStatDisplay() {
        document.getElementById("resourcesStatSection").innerHTML = "";

        for(var prop in currentGame.resources) {


            if(!currentGame.resources[prop].unlocked) {
                continue;
            }

            if(!currentGame.resources[prop].inflows || !currentGame.resources[prop].outflows) {
                continue;
            }

            var nets = currentGame.resources[prop].inflows.allCurrent - currentGame.resources[prop].outflows.allCurrent;

            var netColor = null;

            if(nets <= 0) {
                netColor = "#F44336";
            }


            var resourceStatCard = document.createElement("div");
            resourceStatCard.className = "resourceStatCard";

            var resourceIcon = document.createElement("img");
            resourceIcon.src = "images/" + getResourceByDefName(prop).icon;
            resourceIcon.className = "resourceStatCardIcon";
            resourceStatCard.appendChild(resourceIcon);

            var resourceName = document.createElement("p");
            resourceName.className = "resourceStatCardName";
            resourceName.innerHTML = prop;
            resourceStatCard.appendChild(resourceName);

            // inflows
            var resourceInflows = document.createElement("p");
            resourceInflows.className = "resourceStatCardFlows";

            var resourceInflowImage = document.createElement("img");
            resourceInflowImage.src = "images/res-trend-up.png";
            resourceInflows.appendChild(resourceInflowImage);

            var resourceInflowCounw = document.createElement("span");
            resourceInflowCounw.innerHTML = numberWithCommas(currentGame.resources[prop].inflows.allCurrent);
            resourceInflows.appendChild(resourceInflowCounw);

            resourceStatCard.appendChild(resourceInflows);

            // outflows
            var resourceOutflows = document.createElement("p");
            resourceOutflows.className = "resourceStatCardFlows";

            var resourceOutflowImage = document.createElement("img");
            resourceOutflowImage.src = "images/res-trend-down.png";
            resourceOutflows.appendChild(resourceOutflowImage);

            var resourceOutflowCounw = document.createElement("span");
            resourceOutflowCounw.innerHTML = numberWithCommas(currentGame.resources[prop].outflows.allCurrent);
            resourceOutflowCounw.style.color = netColor;
            resourceOutflows.appendChild(resourceOutflowCounw);

            resourceStatCard.appendChild(resourceOutflows);

            resourceStatCard.resourceRef = prop;
            resourceStatCard.onclick = function() {
                showChartsForResource(this.resourceRef);
            };

            document.getElementById("resourcesStatSection").appendChild(resourceStatCard);
        }
    }

    function updateEconomicStatDisplay() {

        var currentGDP = currentGame.historicStats.gdp[currentGame.historicStats.gdp.length - 1];

        var currentUnemploymentRate = currentGame.historicStats.unemployment[currentGame.historicStats.unemployment.length - 1];
        var currentUnemploymentColor = "#546E7A";

        if(currentUnemploymentRate > 10) {
            currentUnemploymentColor = "#F44336";
        }

        if(currentUnemploymentRate < 4) {
            currentUnemploymentColor = "#4CAF50";
        }

        drawLineChart(document.getElementById("unemploymentTrendChart"),currentGame.historicStats.unemployment,0,100,currentUnemploymentColor);

        document.getElementById("statUnemploymentCount").innerHTML = currentUnemploymentRate + "%";
        document.getElementById("statUnemploymentCount").style.color = currentUnemploymentColor;

        document.getElementById("statGDPCount").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGDP), + "%";
        document.getElementById("statGDPCount").style.color = "#7CB342";
        drawLineChart(document.getElementById("gdpTrendChart"),currentGame.historicStats.gdp,null,null,"#7CB342");

        document.getElementById("statGdpPerCapita").innerHTML = "Per Capita: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(Math.round(currentGDP / getTotalPopulation()));

        var totalJobs = currentGame.historicStats.jobs[currentGame.historicStats.jobs.length - 1];
        var totalWorkers = currentGame.historicStats.workforce[currentGame.historicStats.workforce.length - 1];

        if(totalWorkers > totalJobs) {
            totalWorkers = totalJobs;
        }

        var notworking = getTotalPopulation() - totalWorkers;

        if(notworking < 0) {
            notworking = 0;
        }

        document.getElementById("statTotalUnemployed").innerHTML = numberWithCommas(notworking);

        var chartItems = {
            "Filled Jobs": totalWorkers,
            "Vacant Jobs": totalJobs - totalWorkers
        };
        var chartColors = ["#4CAF50","#F44336"];

        var myPiechart = new Piechart({
            canvas:document.getElementById("statJobsreportChart"),
            data:chartItems,
            colors:chartColors
        });
        myPiechart.draw();

        document.getElementById("jobsReportFlowBar").style.backgroundColor = "#4CAF50";
        document.getElementById("jobsReportFlowBar").style.width = ((totalWorkers / totalJobs) * 100) + "%";
        document.getElementById("jobsReportFlowAmount").innerHTML = numberWithCommas(totalWorkers) + "/" + numberWithCommas(totalJobs) + " Filled";

        
        document.getElementById("statTotalJobs").innerHTML = numberWithCommas(totalJobs);
        document.getElementById("statJobsreportBreakdown").innerHTML = "";

        var colIndex = 0;

        for(var prop in chartItems) {

            

            var item = document.createElement("p");

            var showpercentage = Math.round((chartItems[prop] / totalJobs) * 100);

            item.innerHTML = prop + ": " + showpercentage + "%";
            item.style.color = chartColors[colIndex];
            document.getElementById("statJobsreportBreakdown").appendChild(item);

            colIndex++;
        }



        var savingsColor = "#009688";

        var avgSavings = currentGame.historicStats.savings[currentGame.historicStats.savings.length - 1];

        if(avgSavings < 15) {
            savingsColor = "#F44336";
        }

        if(avgSavings > (gotItMadePrice / 2)) {
            savingsColor = "#4CAF50";
        }

        var medSavings = currentGame.historicStats.mediansalary[currentGame.historicStats.mediansalary.length - 1];

        document.getElementById("statAverageSavings").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(avgSavings), + "%";
        document.getElementById("statAverageSavings").style.color = savingsColor;
        drawLineChart(document.getElementById("savingsTrendChart"),currentGame.historicStats.savings,null,null,savingsColor);




        document.getElementById("statMedianSavings").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(medSavings), + "%";
        document.getElementById("statMedianSavings").style.color = "#8E24AA";
        drawLineChart(document.getElementById("mediansavingsTrendChart"),currentGame.historicStats.mediansalary,null,null,"#8E24AA");




        document.getElementById("statTotalTourists").innerHTML = numberWithCommas(currentGame.totalTourists);
        document.getElementById("statTotalTouristIncome").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGame.totalTourismIncome), + "%";
        
        if(currentGame.deadTourists > 0) {
            document.getElementById("statTotalTouristDeaths").style.color = "#F44336";
        } else {
            document.getElementById("statTotalTouristDeaths").style.color = null;
        }

        document.getElementById("statTotalTouristDeaths").innerHTML = numberWithCommas(currentGame.deadTourists);
    }

    function updatePopulationStatDisplay() {

        var i;

        var totalPop = getTotalPopulation();

        document.getElementById("statPopulationCount").innerHTML = numberWithCommas(totalPop);

        document.getElementById("statTotalDeaths").innerHTML = numberWithCommas(currentGame.totalDeaths);

        document.getElementById("statTotalImmigration").innerHTML = numberWithCommas(currentGame.totalImmigration);
        document.getElementById("statTotalEmigration").innerHTML = numberWithCommas(currentGame.totalEmigration);

        document.getElementById("statIllegals").innerHTML = numberWithCommas(currentTotalIllegals);
        document.getElementById("statIllegals").style.color = "#F44336";



        // immigration sources 
        var immigrationSourceItemsRaw = {};
        var totalRecentImmigrants = 0;

        for(i = 0; i < currentGame.immigrantSources.length; i++) {
            if(!immigrationSourceItemsRaw[currentGame.immigrantSources[i]]) {
                immigrationSourceItemsRaw[currentGame.immigrantSources[i]] = 0;
            }

            immigrationSourceItemsRaw[currentGame.immigrantSources[i]]++;
            totalRecentImmigrants++;
        }

        var immigrantSourceArray = [];

        

        for(var imsrc in immigrationSourceItemsRaw) {
            immigrantSourceArray.push({
                "source": imsrc,
                "count": immigrationSourceItemsRaw[imsrc]
            });

            
        }

        immigrantSourceArray.sort(sortImmigrantSources);

        document.getElementById("immigrationSourceTable").innerHTML = "";

        for(i = 0; i < immigrantSourceArray.length; i++) {

            if(Math.round((immigrantSourceArray[i].count / totalRecentImmigrants) * 100) == 0) {
                break;
            }

            var contactRef = getForeignContactByName(immigrantSourceArray[i].source);

            var immigrantRow = document.createElement("tr");

            var immigrantSourceName = document.createElement("td");
            immigrantSourceName.className = "immigrationSourceTableSource";

            if(contactRef != null) {
                immigrantSourceName.className += " immigrationSourceTableSourceWithLink";
                immigrantSourceName.onclick = function() {
                    getColonyInfoAndLaunchInfo(this.colrefid);
                };
                immigrantSourceName.colrefid = contactRef.id;
            }

            immigrantSourceName.innerHTML = immigrantSourceArray[i].source;
            immigrantRow.appendChild(immigrantSourceName);

            var immigrantSourceCount = document.createElement("td");
            immigrantSourceCount.innerHTML = Math.round((immigrantSourceArray[i].count / totalRecentImmigrants) * 100) + "%";
            immigrantRow.appendChild(immigrantSourceCount);

            document.getElementById("immigrationSourceTable").appendChild(immigrantRow);
        }

        drawLineChart(document.getElementById("populationTrendChart"),currentGame.historicStats.population,null,null,"#0277BD");

        var chartItems = {};
        var chartColors = [];

        var totalItems = 0;

        var myPiechart;

        if(ColonyGame.races.length <= 1) {
            document.getElementById("statDemographicsSection").style.display = "none";
        } else {
            document.getElementById("statDemographicsSection").style.display = "block";

            for(i = 0; i < ColonyGame.races.length; i++) {
                chartColors.push(ColonyGame.races[i].raceColor);
                chartItems[ColonyGame.races[i].name] = currentGame.populationStats[ColonyGame.races[i].name];
                totalItems += currentGame.populationStats[ColonyGame.races[i].name];
            }
    
            myPiechart = new Piechart({
                canvas:document.getElementById("statPopulationDemoChart"),
                data:chartItems,
                colors:chartColors
            });
            myPiechart.draw();
    
            document.getElementById("statPopDemoBreakdown").innerHTML = "";
    
            for(i = 0; i < ColonyGame.races.length; i++) {
    
                var rawpercent = currentGame.populationStats[ColonyGame.races[i].name] / totalItems;
                var rawNumber = Math.round(totalPop * rawpercent);
    
                var percent = Math.round(rawpercent * 100);
    
                var item = document.createElement("p");
                item.innerHTML = ColonyGame.races[i].name + ": " + numberWithCommas(rawNumber) + " (" + percent + "%)";
                item.style.color = ColonyGame.races[i].raceColor;
                document.getElementById("statPopDemoBreakdown").appendChild(item);
            }
        }

        

        document.getElementById("statPAverageAgeCount").innerHTML = currentGame.historicStats.age[currentGame.historicStats.age.length - 1];

        drawLineChart(document.getElementById("ageTrendChart"),currentGame.historicStats.age,0,120,"#26A69A");

        var totalHomelessRate = currentGame.historicStats.homeless[currentGame.historicStats.homeless.length - 1];
        var homelessColor = "#AD1457";

        if(totalHomelessRate > 4) {
            homelessColor = "#F44336";
        }

        document.getElementById("statHomelessnessCount").innerHTML = totalHomelessRate + "%";
        document.getElementById("statHomelessnessCount").style.color = homelessColor;

        document.getElementById("statTotalHouses").innerHTML = numberWithCommas(currentGame.availableShelters);

        document.getElementById("statTotalHomeless").innerHTML = numberWithCommas(runningHomelessCount);

        drawLineChart(document.getElementById("homelessTrendChart"),currentGame.historicStats.homeless,0,100,homelessColor);



        var totalHealthRate = currentGame.historicStats.health[currentGame.historicStats.health.length - 1];
        var healthColor = "#42A5F5";

        if(totalHealthRate < 85) {
            healthColor = "#F44336";
        }

        document.getElementById("statHealthCount").innerHTML = totalHealthRate + "%";
        document.getElementById("statHealthCount").style.color = healthColor;

        drawLineChart(document.getElementById("healthTrendChart"),currentGame.historicStats.health,0,100,healthColor);

        var totaliqRate = currentGame.historicStats.iq[currentGame.historicStats.iq.length - 1];
        var iqColor = "#FBC02D";

        if(totaliqRate < 90) {
            iqColor = "#F44336";
        }

        document.getElementById("statIQCount").innerHTML = totaliqRate;
        document.getElementById("statIQCount").style.color = iqColor;

        drawLineChart(document.getElementById("iqTrendChart"),currentGame.historicStats.iq,50,150,iqColor);
    }

    var Piechart = function(options){
        this.options = options;
        this.canvas = options.canvas;
        this.ctx = this.canvas.getContext("2d");
        this.colors = options.colors;
    
        this.draw = function(){
            var total_value = 0;
            var color_index = 0;
            for (var categ in this.options.data){
                var val = this.options.data[categ];
                total_value += val;
            }
    
            var start_angle = 0;
            for (categ in this.options.data){
                val = this.options.data[categ];
                var slice_angle = 2 * Math.PI * val / total_value;
    
                drawPieSlice(
                    this.ctx,
                    this.canvas.width/2,
                    this.canvas.height/2,
                    Math.min(this.canvas.width/2,this.canvas.height/2),
                    start_angle,
                    start_angle+slice_angle,
                    this.colors[color_index%this.colors.length]
                );
    
                start_angle += slice_angle;
                color_index++;
            }
    
            //drawing a white circle over the chart
            //to create the doughnut chart
            if (this.options.doughnutHoleSize){
                drawPieSlice(
                    this.ctx,
                    this.canvas.width/2,
                    this.canvas.height/2,
                    this.options.doughnutHoleSize * Math.min(this.canvas.width/2,this.canvas.height/2),
                    0,
                    2 * Math.PI,
                    "#ff0000"
                );
            }
    
        };
    };

    function drawPieSlice(ctx,centerX, centerY, radius, startAngle, endAngle, color ){
        ctx.fillStyle = color;
        ctx.beginPath();
        ctx.moveTo(centerX,centerY);
        ctx.arc(centerX, centerY, radius, startAngle, endAngle);
        ctx.closePath();
        ctx.fill();
    }

    function updateApprovalStatDisplay() {

        var currentapproval = currentGame.historicStats.approval[currentGame.historicStats.approval.length - 1];

        document.getElementById("statApprovalRating").innerHTML = currentapproval + "%";

        document.getElementById("statApprovalRating").style.color = null;
        var chartColor = "#0277BD";

        if(currentapproval > 90) {
            document.getElementById("statApprovalRating").style.color = "#2E7D32";
            chartColor = "#2E7D32";
        }

        if(currentapproval < 50) {
            document.getElementById("statApprovalRating").style.color = "#C62828";
            chartColor = "#C62828";
        }


        drawLineChart(document.getElementById("approvalTrendChart"),currentGame.historicStats.approval,0,100,chartColor);

        var chartItems = {
            "Depression": 0,
            "Homelessness": 0,
            "Poverty": 0,
            "Fatigue": 0,
            "Health": 0,
            "Unemployment": 0
        };

        for(var i = 0; i < currentGame.sadReasons.length; i++) {
            if(currentGame.sadReasons[i] == COL_MOOD_DEPRESSION) {
                chartItems.Depression++;
            }

            if(currentGame.sadReasons[i] == COL_MOOD_HOMELESS) {
                chartItems.Homelessness++;
            }

            if(currentGame.sadReasons[i] == COL_MOOD_POVERTY) {
                chartItems.Poverty++;
            }

            if(currentGame.sadReasons[i] == COL_MOOD_FATIGUE) {
                chartItems.Fatigue++;
            }

            if(currentGame.sadReasons[i] == COL_MOOD_HEALTH) {
                chartItems.Health++;
            }

            if(currentGame.sadReasons[i] == COL_MOOD_UNEMPLOYED) {
                chartItems.Unemployment++;
            }
        }

        var totalItems = currentGame.sadReasons.length;

        var chartColors = ["#283593","#33691E","#880E4F","#F57F17","#B71C1C","#006064"];

        var myPiechart = new Piechart({
            canvas:document.getElementById("statDisapprovalFactorsChart"),
            data:chartItems,
            colors:chartColors
        });
        myPiechart.draw();

        document.getElementById("motherlandpaymentsheading").innerHTML = currentGame.motherland;
        document.getElementById("statMotherlandPaymentsMade").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGame.motherlandTaxesPaid);
        document.getElementById("statMotherlandPaymentsMade").style.color = "#9E9D24";

        document.getElementById("statDisapprovalBreakdown").innerHTML = "";

        if(currentGame.colonies == 0) {
            document.getElementById("chartersIssuedSection").style.display = "none";
            document.getElementById("statForeignCOllections").style.display = "none";
            document.getElementById("statForeignPayroll").style.display = "none";
        } else {
            document.getElementById("chartersIssuedSection").style.display = "block";
            document.getElementById("statForeignCOllections").style.display = "block";
            document.getElementById("statForeignPayroll").style.display = "block";

            document.getElementById("statTotalChartersIssued").innerHTML = numberWithCommas(currentGame.colonies);
            
            document.getElementById("statForeignTaxCollections").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGame.colonialTaxCollected);
            document.getElementById("statForeignTaxCollections").style.color = "#7CB342";
    
            var payrollColor = null;
    
            if(currentGame.foreignPayrollTotals > currentGame.colonialTaxCollected) {
                payrollColor = "#F44336";
            }
    
            document.getElementById("statForeignPayrollPayments").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGame.foreignPayrollTotals);
            document.getElementById("statForeignPayrollPayments").style.color = payrollColor;
        }

        

        var colIndex = 0;

        var firstItem = true;

        for(var prop in chartItems) {

            

            var item = document.createElement("p");

            var showpercentage = Math.round((chartItems[prop] / totalItems) * 100);

            item.innerHTML = prop + ": " + showpercentage + "%";
            item.style.color = chartColors[colIndex];
            document.getElementById("statDisapprovalBreakdown").appendChild(item);

            if(firstItem) {
                firstItem = false;

                document.getElementById("statDisapprovalFactorsDisclaimerExample").innerHTML = showpercentage + "% of your citizens have " + prop;
                document.getElementById("statDisapprovalFactorsDisclaimerExample2").innerHTML = showpercentage + "% of your citizens <strong>who are mad</strong> are upset because of " + prop;
            }

            colIndex++;
        }
    }

    function updateOnlineOfflineStatButtions() {

        document.getElementById("cloudStatOnlineMode").style.display = "none";
        document.getElementById("cloudStatOfflineMode").style.display = "none";

        if(currentGame.cm || gamepadInUse) {
            return;
        }

        if(ColonyGame.meta.colonyServerApi != null) {
            if(currentGame.offlineMode && !currentGame.hasCheated) {
                document.getElementById("cloudStatOnlineMode").style.display = "block";
                document.getElementById("cloudStatOnlineMode").onclick = function() {
                    currentGame.offlineMode = false;
                    registerColonyId();
                    webAppCore.showToast({
                        message: "Online Mode Activated",
                        image:   "images/" + ColonyGame.meta.onlineModeInd
                    });
                    updateOnlineOfflineStatButtions();
                };
            }

            if(!currentGame.offlineMode) {
                document.getElementById("cloudStatOfflineMode").style.display = "block";
                document.getElementById("cloudStatOfflineMode").onclick = function() {
                    webAppCore.showDialog({
                        "title":    getString("offline-mode"),
                        "message":  getString("offline-mode-warning"),
                        "op1": {
                            "text":     getString("general-yes"),
                            "func":     function() {
                                takeColonyOffline();
                                updateOnlineOfflineStatButtions();
                            }
                        },
                        "op2": {
                            "text":     getString("general-no"),
                            "func":     placeholder
                        }
                    });
                };
            }
        }
    }

    function updateCloudAndCompressionDisplays() {
        var compressionStatus = "开";
        var compressionColor = "#4CAF50";

        if(!currentGame.useCompression) {
            compressionStatus = "关";
            compressionColor = "#F44336";
        }

        document.getElementById("statOverviewGameCompression").innerHTML = compressionStatus;
        document.getElementById("statOverviewGameCompression").style.color = compressionColor;

        document.getElementById("compressStatsSection").onclick = function() {
            currentGame.useCompression = !currentGame.useCompression;

            if(!currentGame.useCompression && currentGame.useCloud) {
                webAppCore.deleteFile(currentFileName,cloudSwitchPostDelete);
                webAppCore.showToast("Cloud Sync Disabled");
            }

            updateCloudAndCompressionDisplays();
        };

        if(webAppCore.getFacebookLoginStatus()) {

            document.getElementById("cloudStatsSection").style.display = "block";

            document.getElementById("cloudStatsSection").onclick = function() {
                if(currentGame.useCloud) {
                    webAppCore.deleteFile(currentFileName,cloudSwitchPostDelete);
                } else {
                    currentGame.useCloud = true;
                    saveGame(true);
                }

                if(currentGame.useCloud && !currentGame.useCompression) {
                    currentGame.useCompression = true;
                    webAppCore.showToast("Save Compression Enabled");
                }

                updateCloudAndCompressionDisplays();
            };

            var cloudStatus = "开";

            if(!currentGame.useCloud) {
                cloudStatus = "关";
            }


            document.getElementById("statOverviewGameCloudsync").innerHTML = cloudStatus;
        } else {
            document.getElementById("cloudStatsSection").style.display = "none";
        }
    }

    function updateOverviewStatDisplay() {

        if(currentGame.isIndependent) {
            document.getElementById("statOverviewNamePrefix").innerHTML = "The Nation of";
            document.getElementById("statOverviewColonyDisclaimer").innerHTML = "";
        } else {
            document.getElementById("statOverviewNamePrefix").innerHTML = "";
            document.getElementById("statOverviewColonyDisclaimer").innerHTML = "A Colony of " + currentGame.motherland;
        }

        if(currentGame.cm) {
            document.getElementById("statCreativeDisclaimer").style.display = "block";
            document.getElementById("statCreativeDisclaimer").innerHTML = "创意模式";
        } else {
            document.getElementById("statCreativeDisclaimer").style.display = "none";
        }

        updateCloudAndCompressionDisplays();
        updateOnlineOfflineStatButtions();

        document.getElementById("statOverviewColonyName").innerHTML = currentGame.name;
        document.getElementById("statOverviewColonyName").onclick = function() {
            renameColony();
        };

        if(currentGame.offlineMode) {
            document.getElementById("statoverviewwebsitesection").style.display = "none";
            document.getElementById("statoverviewcolorection").style.display = "none";
            document.getElementById("statOverviewScreenshotSection").style.display = "none";
        } else {
            document.getElementById("statoverviewwebsitesection").style.display = "block";
            document.getElementById("statoverviewcolorection").style.display = "block";
            document.getElementById("statOverviewScreenshotSection").style.display = "block";

            document.getElementById("statOverviewColonialWebsite").innerHTML = ColonyGame.meta.colonyServerBase + currentGame.charter + "/";
            document.getElementById("statoverviewwebsitesection").onclick = function() {
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + currentGame.charter + "/");
            };
            
            document.getElementById("statOverviewColonialColor").innerHTML = currentGame.themeColor;
            document.getElementById("statOverviewColonialColor").style.color = currentGame.themeColor;
            document.getElementById("statoverviewcolorection").onclick = function() {
                webAppCore.pickColor(onColorBack,currentGame.themeColor);
            };

            var sssrc = "url('" + ColonyGame.meta.colonyServerBase.replace("colonies","screenshots") + "/ss-" + currentGame.colonyId + ".jpg')";

            document.getElementById("statOverviewScreenshotSection").style.backgroundImage = sssrc;
            document.getElementById("statOverviewScreenshotSection").onclick = function() {
                document.getElementById("statOverviewScreenshotSection").style.backgroundImage = null;

                Scroll2d.takeScreenshot(onScreenshotForWebsite);
            };
        }

        if(currentGame.isIndependent) {
            document.getElementById("statSectionIndependence").style.display = "block";
            document.getElementById("statOverviewIndependence").innerHTML = dateToReadable(currentGame.independenceDay);
            document.getElementById("statOverviewIndependenceDisclaimer").innerHTML = "From " + currentGame.motherland;

            if(!currentGame.offlineMode) {
                document.getElementById("statCharterSection").style.display = "block";
                document.getElementById("statCharterSection").onclick = function() {
                    shareCharter();
                };
                document.getElementById("statOverviewCharter").innerHTML = currentGame.charter;


                document.getElementById("statCharterPrivacy").style.display = "block";
                document.getElementById("statCharterPrivacy").onclick = function() {
                    currentGame.privateCharter = !currentGame.privateCharter;
                    updateColonyStats();
                    updateOverviewStatDisplay();
                };

                if(currentGame.privateCharter) {
                    document.getElementById("statOverviewCharterPrivacy").innerHTML = getString("general-private");
                    document.getElementById("statOverviewCharterPrivacy").style.color = "#673AB7";
                } else {
                    document.getElementById("statOverviewCharterPrivacy").innerHTML = getString("general-public");
                    document.getElementById("statOverviewCharterPrivacy").style.color = "#2196F3";
                }


            } else {
                document.getElementById("statCharterSection").style.display = "none";
                document.getElementById("statCharterPrivacy").style.display = "none";
            }
        } else {
            document.getElementById("statSectionIndependence").style.display = "none";
            document.getElementById("statCharterSection").style.display = "none";
            document.getElementById("statCharterPrivacy").style.display = "none";
        }

        document.getElementById("statOverviewFounded").innerHTML = dateToReadable(currentGame.creationDate);

        if(currentGame.offlineMode) {
            document.getElementById("statSectionLocation").style.display = "none";
        } else {
            document.getElementById("statSectionLocation").style.display = "block";
            document.getElementById("statColonyLocatoin").innerHTML = "Sector " + currentGame.sX + ":" + currentGame.sY;
            document.getElementById("statColonyLocatoin").onclick = function() {
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase.replace("colonies","map") + currentGame.charter + ".html");
            };
        }

        document.getElementById("statOverviewMapSize").innerHTML = numberWithCommas(currentGame.width) + "x" + numberWithCommas(currentGame.height);
        document.getElementById("statOverviewMapSizeTotal").innerHTML = numberWithCommas(currentGame.width * currentGame.height);
        
        if(gamepadInUse) {
            document.getElementById("cloudStatsSection").style.display = "none";
            document.getElementById("compressStatsSection").style.display = "none";
        } else {
            document.getElementById("cloudStatsSection").style.display = "block";
            document.getElementById("compressStatsSection").style.display = "block";
        }
    }

    function newGameWithoutCharter(prename) {
        var width = ColonyGame.meta.mapWidth;
        var height = ColonyGame.meta.mapHeight;
        var resourceMod = 1;

        var colname;

        if(prename) {
            colname = prename;
        } else {
            colname = document.getElementById("newGameColNameInput").value.trim();

            if(colname.length == 0) {
                colname = ColonyGame.meta.name;
            }
        }

        colname = colname.latinize();

        if(document.getElementById("mapSizeSmall").checked) {
            width = Math.round(width * 0.5);
            height = Math.round(height * 0.5);
            resourceMod = 0.5;
        }

        if(document.getElementById("mapSizeLarge").checked) {
            width = Math.round(width * 1.5);
            height = Math.round(height * 1.5);
            resourceMod = 1.5;
        }

        if(document.getElementById("mapSizeXLarge").checked) {
            width = Math.round(width * 2.25);
            height = Math.round(height * 2.25);
            resourceMod = 2.25;
        }

        if(document.getElementById("mapSizeMega").checked) {
            width = Math.round(width * 3);
            height = Math.round(height * 3);
            resourceMod = 3;
        }

        if(document.getElementById("resourcesScarce").checked) {
            resourceMod = resourceMod * 0.5;
        }

        if(document.getElementById("resourcesAbundant").checked) {
            resourceMod = resourceMod * 1.5;
        }

        if(tmpNewGameCustomMapData != null) {
            width = tmpNewGameCustomMapData.width;
            height = tmpNewGameCustomMapData.height;
        }

        createNewGame(colname,width,height,resourceMod);

        document.getElementById("newGameMenu").style.display = "none";
        document.getElementById("newGameColNameInput").value = "";

        setupMenuOptions();

        showListingAfterSave = false;
    }

    var statsOpen = false;
    var newObjectOptionsOpen = false;

    function closeStatsMenu() {
        document.getElementById("statsScreen").style.display = "none";
        statsOpen = false;
    }

    function closeObjectOptionsMenu() {
        document.getElementById("newObjectOptionsWindow").style.display = "none";
        newObjectOptionsOpen = false;
    }
    
    function linkLayouts() {

        document.getElementById("showFilterItemsAsList").src = "images/" + ColonyGame.meta.indShowBuildList;
        document.getElementById("showFilterItemsAsList").onclick = function() {
            if(currentSidebarListType != null && currentSidebarListingStuff.length > 0) {
                showBuildingConstructionOptions(null,currentSidebarListType,currentSidebarListingStuff);
            }
            hideSidebarIfSmall();
        };

        document.getElementById("btnSaveMapMeta").onclick = function() {
            saveCustomMapMetaData();
            document.getElementById("customMapMetaDataEntry").style.display = "none";

            if(currentFileName == null) {
                currentFileName = cleanFileName(currentGame.mename) + "." + ColonyGame.meta.customMapExtension;
            }
        };

        

        document.getElementById("textBackupInstruction").innerHTML = getString("text-backup-instruction");

        var statButtons = document.querySelectorAll(".statMenuItem");

        for(var i = 0; i < statButtons.length; i++) {
            statButtons[i].addEventListener("click",function() {
                showColonistsMenu(this.dataset.statsection);
            });
        }

        document.getElementById("imgChainBuildToggleDesktop").src = "images/" + ColonyGame.meta.indChainOn;
        document.getElementById("imgChainBuildToggleDesktop").onclick = function() {
            chainBuildMode = !chainBuildMode;

            if(chainBuildMode) {
                document.getElementById("imgChainBuildToggleDesktop").src = "images/" + ColonyGame.meta.indChainOn;
            } else {
                document.getElementById("imgChainBuildToggleDesktop").src = "images/" + ColonyGame.meta.indChainOff;
            }
        };
        
        document.getElementById("objectBuildIcon").src = "images/" + ColonyGame.meta.showBuildSidebarIcon;
        document.getElementById("objectExportIcon").src = "images/" + ColonyGame.meta.indExportGoods;
        document.getElementById("objectImportIcon").src = "images/" + ColonyGame.meta.indImportGoods;
        document.getElementById("objectUpgradeIcon").src = "images/" + ColonyGame.meta.indUpgrade;
        document.getElementById("objectMoveIcon").src = "images/" + ColonyGame.meta.indMove;
        document.getElementById("objectHarvestIcon").src = "images/" + ColonyGame.meta.indHarvest;
        document.getElementById("objectParkIcon").src = "images/" + ColonyGame.meta.indPark;

        document.getElementById("objectStatsIcon").src = "images/" + ColonyGame.meta.indStats;
        document.getElementById("objectStatsIcon").title = getString("general-statistics");

        document.getElementById("objectDismissIcon").src = "images/" + ColonyGame.meta.indDismiss;
        document.getElementById("objectDismissIcon").title = getString("general-dismiss");

        document.getElementById("objectRepairIcon").src = "images/" + ColonyGame.meta.indRepair;
        document.getElementById("objectRepairIcon").title = getString("general-repair");
        

        document.getElementById("objectTradeIcon").src = "images/" + ColonyGame.meta.indTrade;
        document.getElementById("objectTradeIcon").title = getString("general-trade");

        document.getElementById("objectDestroyIcon").src = "images/" + ColonyGame.meta.indDestroy;
        document.getElementById("objectDestroyIcon").title = getString("general-destroy");

        document.getElementById("objectDestructIcon").src = "images/" + ColonyGame.meta.indDestruct;
        document.getElementById("objectDestructIcon").title = getString("general-destruct");


        document.getElementById("objectFlipIcon").src = "images/" + ColonyGame.meta.indFlipBuilding;
        document.getElementById("objectFlipIcon").title = getString("general-flip");

        document.getElementById("objectDeployLoadedIcon").src = "images/" + ColonyGame.meta.indDeployLoaded;
        document.getElementById("objectDeployLoadedIcon").title = getString("general-deploy-loaded");

        document.getElementById("objectMakeCenterIcon").src = "images/" + ColonyGame.meta.indMakeCenter;
        document.getElementById("objectMakeCenterIcon").title = getString("general-make-center");


        document.getElementById("objectCommunicationsIcon").src = "images/" + ColonyGame.meta.mailIndicator;
        document.getElementById("objectCommunicationsIcon").title = getString("comms-general");


        document.getElementById("statIconOverview").src = "images/" + ColonyGame.meta.websiteIndicator;
        document.getElementById("statIconPopulation").src = "images/" + ColonyGame.meta.totalWorkforceInd;
        document.getElementById("statIconGovernment").src = "images/" + ColonyGame.meta.empireIndicator;
        document.getElementById("statIconEconomy").src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
        document.getElementById("statIconResources").src = "images/" + ColonyGame.meta.resourcesInd;

        

        document.getElementById("helpfulTipsDismiss").addEventListener("click",function() {
            closeTipsPopup();
        });

        document.getElementById("statsMenuClose").addEventListener("click",function() {
            closeStatsMenu();
        });

        document.getElementById("tradeMenuClose").addEventListener("click",function() {
            closeGBT();
        });

        document.getElementById("commonwealthClose").addEventListener("click",function() {
            closeCommonwealthMenu();
        });

        document.getElementById("colonyClose").addEventListener("click",function() {
            closeColonyWindow();
        });

        document.getElementById("objectMenuClose").addEventListener("click",function() {
            closeObjectOptionsMenu();
        });

        document.getElementById("leaveExportScreen").addEventListener("click",function() {

            document.getElementById("textBackupScreen").style.display = "none";
            document.getElementById("exportText").innerHTML = "";

            bulldozerMode = false;

            webAppCore.handleBackFunction(null);
            webAppCore.setTitleVisible(true);
            titleShowing = true;
        });


        document.getElementById("objectDiplomacyIcon").title = getString("diplomacy-general");
        document.getElementById("objectDiplomacyIcon").src = "images/" + ColonyGame.meta.diplomacyIndicator;

        
        document.getElementById("objectCommonwealthIcon").title = getString("empire-general");
        document.getElementById("objectCommonwealthIcon").src = "images/" + ColonyGame.meta.empireIndicator;
        document.getElementById("objectCommonwealthIcon").addEventListener("click",function() {
            document.getElementById("objectOptions").style.display = "none";
            showNewCommonwealthMenu();
        });

        document.getElementById("objectPolicyIcon").title = getString("general-policy");
        document.getElementById("objectPolicyIcon").src = "images/" + ColonyGame.meta.indPolicy;
        document.getElementById("objectPolicyIcon").addEventListener("click",function() {
            document.getElementById("objectOptions").style.display = "none";
            showPolicyMenu();
        });


        document.getElementById("btnNoNewGame").addEventListener("click",function() {
            document.getElementById("newGameMenu").style.display = "none";
            showHiders();
            bulldozerMode = false;
            titleShowing = true;
            webAppCore.setTitleVisible(true);
            webAppCore.handleBackFunction(null);
        });

        document.getElementById("filterArea").addEventListener("change",function(e) {
            selectedBuildCategory = e.target.value;
            drawSidebar();
        });

        document.getElementById("btnBewGame").addEventListener("click",function() {

            newGameWithoutCharter();
        });

        document.getElementById("btnZoomIn").src = "images/" + ColonyGame.meta.zoomInIcon;
        document.getElementById("btnZoomIn").addEventListener("click",function() {
            if(zoomLevel < 2.6) {
                zoomLevel += 0.4;
                Scroll2d.setZoomLevel(zoomLevel);
            }
        });

        document.getElementById("btnZoomOut").src = "images/" + ColonyGame.meta.zoomOutIcon;
        document.getElementById("btnZoomOut").addEventListener("click",function() {
            if(zoomLevel > 0.2) {
                zoomLevel -= 0.4;
                Scroll2d.setZoomLevel(zoomLevel);
            }
        });

        var zoomOption = webAppCore.getVar("zoom-buttons","0");
        if(zoomOption == "0") {
            showZoomButtons = false;
            document.getElementById("zoomButtons").style.display = "none";
        } else {
            showZoomButtons = true;
            document.getElementById("zoomButtons").style.display = "inline-block";
        }

        document.getElementById("imMail").src = "images/" + ColonyGame.meta.mailIndicator;
        document.getElementById("imMail").addEventListener("click",function() {
            showMail();
        });
        document.getElementById("imMail").style.display = "none";

        document.getElementById("colonySendGift").src = "images/" + ColonyGame.meta.giftIndicator;
        document.getElementById("colonySendMessage").src = "images/" + ColonyGame.meta.mailIndicator;
        document.getElementById("colonyViewWebsite").src = "images/" + ColonyGame.meta.websiteIndicator;
        document.getElementById("colonyCoinShower").src = "images/" + ColonyGame.meta.moneyShowerInd;
        document.getElementById("colonyNukeCharter").src = "images/" + ColonyGame.meta.rescindInd;
        document.getElementById("colonyTribute").src = "images/" + ColonyGame.meta.taxCollectionInd;
        document.getElementById("colonyDenounce").src = "images/" + ColonyGame.meta.denounceInd;
        document.getElementById("colonyInspect").src = "images/" + ColonyGame.meta.visitInd;
        document.getElementById("colonyEstablishEmbassy").src = "images/" + ColonyGame.meta.diplomacyIndicator;

        document.getElementById("imDiplomacy").src = "images/" + ColonyGame.meta.diplomacyIndicator;
        document.getElementById("imDiplomacy").addEventListener("click",function() {
            showPendingEmbassyRequests();
        });
        document.getElementById("imDiplomacy").style.display = "none";




        document.getElementById("imGift").src = "images/" + ColonyGame.meta.giftIndicator;
        document.getElementById("imGift").addEventListener("click",function() {
            this.style.display = "none";
            showGifts();
        });
        document.getElementById("imGift").style.display = "none";



        document.getElementById("imIdleBuilder").src = "images/" + ColonyGame.meta.findBuilderIcon;
        document.getElementById("imIdleBuilder").addEventListener("click",function() {
            selectIdleBuilder();
        });

        document.getElementById("imBulldozer").src = "images/" + ColonyGame.meta.bulldozerToolIndicator;
        document.getElementById("imBulldozer").addEventListener("click",function() {
            bulldozerMode = !bulldozerMode;
        });

        document.getElementById("imTechTree").src = "images/" + ColonyGame.meta.techWindowIcon;
        document.getElementById("imTechTree").addEventListener("click",function() {
            showTechWindow();
        });

        setCenterMapIcon(); 
        document.getElementById("imCenterMap").addEventListener("click",function() {
            Scroll2d.setZoomLevel(1);
            centerMap();
        });

        document.getElementById("showSidebarToggle").src = "images/" + ColonyGame.meta.showBuildSidebarIcon;
        document.getElementById("showSidebarToggle").addEventListener("click",function() {

            if(currentGame.readOnlyMode) {
                return;
            }

            document.getElementById("sidebar").style.display = "block";
        });

        if(ColonyGame.meta.sidebarBackgroundImage && ColonyGame.meta.sidebarBackgroundImage != null) {
            document.getElementById("sidebar").style.backgroundImage = "url('images/" + ColonyGame.meta.sidebarBackgroundImage + "')";
        }

        document.getElementById("imTransparency").src = "images/" + ColonyGame.meta.transModeIcon;
        document.getElementById("imTransparency").addEventListener("click",function() {

            //console.log(currentGame.monthEndCounter);

            transparencyMode++;

            if(transparencyMode == 3) {
                transparencyMode = 0;
            }

            if(transparencyMode == 2) {
                staticFrame = false;
                Scroll2d.forceSceneChange();
            }
        });

        document.getElementById("hireWorkerCancel").addEventListener("click",function() {
            document.getElementById("hireWorkerConfirm").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            inHireMode = false;
            pendingBuildX = null;
            pendingBuildY = null;

            clearOutBuildMenu();
        },false);

        document.getElementById("btnDismissConstruction").addEventListener("click",function() {
            document.getElementById("constructionMenu").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            inHireMode = false;
            pendingBuildX = null;
            pendingBuildY = null;

            clearOutBuildMenu();
        },false);

        document.getElementById("btnDismissChart").addEventListener("click",function() {
            document.getElementById("chartScreen").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            inHireMode = false;
            pendingBuildX = null;
            pendingBuildY = null;

            clearOutBuildMenu();
            updateResourceStatDisplay();
        },false);
        
        document.getElementById("objectDismissIcon").addEventListener("click",function() {
            document.getElementById("objectOptions").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            inHireMode = false;
            queuedBuilding = null;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;

            clearOutBuildMenu();
        },false);
        
        document.getElementById("tbcCancel").addEventListener("click",function() {

            document.getElementById("gamepadBuildConfirm").style.display = "none";
            document.getElementById("touchBuildConfirm").style.display = "none";
            document.getElementById("desktopBuildConfirm").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            queuedBuildings = null;
            queuedBuilding = null;
            selectedColonist = null;
            inHireMode = false;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;
            touchPossibleBuildPoints = [];

            clearOutBuildMenu();
        },false);

        document.getElementById("tbcDesktopCancel").addEventListener("click",function() {
            
            document.getElementById("gamepadBuildConfirm").style.display = "none";
            document.getElementById("touchBuildConfirm").style.display = "none";
            document.getElementById("desktopBuildConfirm").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            queuedBuildings = null;
            queuedBuilding = null;
            selectedColonist = null;
            inHireMode = false;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;
            touchPossibleBuildPoints = [];

            clearOutBuildMenu();
        },false);
        
        document.getElementById("tbcConfirm").addEventListener("click",function() {

            touchPossibleBuildPoints = [];

            document.getElementById("touchBuildConfirm").style.display = "none";
            document.getElementById("gamepadBuildConfirm").style.display = "none";
            document.getElementById("desktopBuildConfirm").style.display = "none";

            engageBuildingQueue();
            
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            inHireMode = false;
            queuedBuilding = null;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;

            clearOutBuildMenu();
        },false);

        document.getElementById("tbcDesktopConfirm").addEventListener("click",function() {
            
            touchPossibleBuildPoints = [];

            document.getElementById("touchBuildConfirm").style.display = "none";
            document.getElementById("gamepadBuildConfirm").style.display = "none";
            document.getElementById("desktopBuildConfirm").style.display = "none";

            engageBuildingQueue();
            
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            inHireMode = false;
            queuedBuilding = null;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;

            clearOutBuildMenu();
        },false);

        moneyReadout = document.getElementById("moneyReadout");
        moneyReadout.addEventListener("click",function() {
            allResourceMode = !allResourceMode;
        },false);
        
        document.getElementById("imSettings").addEventListener("click",function() {
            clearOutBuildMenu();
            webAppCore.toggleMenu();
        },false);
        
        document.getElementById("objectSelIcon").style.display = "none";
        document.getElementById("objectRename").style.display = "none";
    }
    
    function setupMenuOptions() {

        webAppCore.clearMenu();

        if(titleShowing) {

            if(!webAppCore.isTV()) {
                webAppCore.addMenuOption(getString("side-menu-game-data"),"wacMenuOptionSelected","previewlink",null,"gamedata");
            }

            if(webAppCore.getInterface() != "ios") {
                if (ColonyGame.meta.betaInfo != null) {
                    webAppCore.addMenuOption("测试信息","wacMenuOptionSelected","help",null,"betainfo");
                }
            }

            if(ColonyGame.meta.releaseNotesServer != null) {
                webAppCore.addMenuOption("发行说明","wacMenuOptionSelected","showresults",null,"releasenotes");
            }

            if(webAppCore.isTV() || (webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "amazon")) {
                // dont do it
            } else {
                if(ColonyGame.meta.podcastURL != null && ColonyGame.meta.podcastName != null) {
                    webAppCore.addMenuOption(ColonyGame.meta.podcastName,"wacMenuOptionSelected","microphone",null,"podcast");
                }
            }

            var hasAchievements = false;

            for(var prop in ColonyGame.achievements) {
                if(ColonyGame.achievements[prop] != null) {
                    hasAchievements = true;
                    break;
                }
            }

            if(hasAchievements) {
                webAppCore.addMenuOption("成就","wacMenuOptionSelected","emoji",null,"achievements");
            }

            if(!webAppCore.isTV()) {
            

                if (ColonyGame.meta.feedbackUrl != null) {
                    webAppCore.addMenuOption("Send Feedback","wacMenuOptionSelected","send",null,"feedback");
                }

                if(webAppCore.getPlatform().platform == "android" || webAppCore.getPlatform().platform == "windows") {
                    webAppCore.addMenuOption("改装","wacMenuOptionSelected","personalize",null,"modding");
                } else {
                    webAppCore.addMenuOption("改装","wacMenuOptionSelected","",null,"modding");
                }
            }
        } else {
            
            if(returnToFileName == null) {
                webAppCore.addMenuOption("返回标题","wacMenuOptionSelected","back",null,"saveandquit");
            } else {
                webAppCore.addMenuOption("Return to Colony","wacMenuOptionSelected","back",null,"saveandquit");
            }

            if(currentGame && !currentGame.readOnlyMode) {

                var saveText = "保存殖民地";

                if(currentGame.mem) {
                    saveText = "Save Map";
                }

                webAppCore.addMenuOption(saveText,"wacMenuOptionSelected","save",null,"save");


                if(!currentGame.mem) {
                    if(webAppCore.isTV() || gamepadInUse) {
                        webAppCore.addMenuOption("技术","wacMenuOptionSelected","library","#9C27B0","technology");
                    }
    
    
                    webAppCore.addMenuOption(getString("general-statistics"),"wacMenuOptionSelected","fourbars",null,"colonists");
                }

                
            }

            if(currentGame && currentGame.mem) {
                //editCustomMapMetaData

                webAppCore.addMenuOption("Export","wacMenuOptionSelected","savelocal",null,"export");
                webAppCore.addMenuOption(getString("general-map-meta"),"wacMenuOptionSelected","accounts",null,"mapmeta");
            }

			if(!webAppCore.isTV() && !gamepadInUse && currentGame != null && !currentGame.mem) {
				webAppCore.addMenuOption("截图","wacMenuOptionSelected","camera",null,"picture");
			}
        }

        if (ColonyGame.meta.communityUrl != null && !webAppCore.isTV()) {
            
            if(webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "amazon") {
                // dont do it
            } else {
                webAppCore.addMenuOption("社区","wacMenuOptionSelected","people",null,"community");
            }

        }

        if(!currentGame || (currentGame && !currentGame.mem)) {
            webAppCore.addMenuOption(getString("general-encyclopedia"),"wacMenuOptionSelected","library",null,"encyclopedia");
            
            webAppCore.addMenuOption("引擎设置","wacMenuOptionSelected","settings",null,"settings");
        }

        

        
        
    }

    var tmpExportAfterSave = false;

    function onMenuOptionSelected(name,tag) {

        cooldownGamepad();
        clearOutBuildMenu();

        if(tag == "modding") {
            showModdingMenu();
        }

        if(tag == "export") {
            tmpExportAfterSave = true;
            saveGame(true);
        }

        if(tag == "releasenotes") {
            fetchReleaseNotes();
        }

        if(tag == "mapmeta") {
            editCustomMapMetaData();
        }

        if(tag == "podcast") {
            webAppCore.externalURL(ColonyGame.meta.podcastURL);
        }

        if(tag == "achievements") {
            webAppCore.showAchievements();
        }

        if(tag == "encyclopedia") {
            showEncyclopedia();
        }

        if(tag == "picture") {
            Scroll2d.takeScreenshot(onScreenshotTaken);
        }

        if(tag == "technology") {
            if(currentGame.readOnlyMode) {
                return;
            }

            showTechWindow();
        }

        if(tag == "gamedata") {
            presentGameData();
        }

        if(tag == "colonists") {
            showColonistsMenu();

            if(gamepadInUse) {
                highlightActiveStatSection();
            }
        }

        if(tag == "betainfo") {
            webAppCore.showAlertWithTitle(getString(ColonyGame.meta.betaInfo),"Beta Information");
        }
        
        if(tag == "feedback") {
            webAppCore.externalURL(ColonyGame.meta.feedbackUrl);
        }
        
        if(tag == "community") {
            webAppCore.externalURL(ColonyGame.meta.communityUrl);
        }
        
        if(tag == "new") {
            saveGame(true);
            newGame();
        }
        
        if(tag == "save") {
            saveGame(true);
        }

        if(tag == "saveandquit") {
            showListingAfterSave = true;
            saveGame(true);
        }

        if(tag == "settings") {
            showEngineSettings();
        }

    }

    function standardBack() {

        var somethingOpen = closeSomethingIfOpen();

        if(somethingOpen) {
            hideSidebarIfSmall();
            return;
        }

        showListingAfterSave = true;
        saveGame(true);
    }

    var tmpSSCanvas;

    function onScreenshotTaken(canvas) {
        tmpSSCanvas = canvas;
        document.body.appendChild(tmpSSCanvas);
        webAppCore.sendImage(tmpSSCanvas);

        setTimeout(function() {
            document.body.removeChild(tmpSSCanvas);
        },1000);
    }

    var listingType;

    var tmpListingData = null;

    function showOpenGameListing(listing) {
        tmpListingData = listing;

        setTimeout(produceListingData,500);
    }
    
    function produceListingData() {

        if(tmpListingData == null) {
            return;
        }

        var listing = tmpListingData;

        var menuOptions = [];
        savedGameListing = [];

        var callback;
        var title;

        if(listingType == "load") {
            callback = onSaveGameSelected;
            title = getString("general-load");
        }

        if(listingType == "export") {
            callback = onExportFileSelected;
            title = "Export File";
        }

        if(listingType == "delete") {
            callback = confirmDelete;
            title = "Delete Files";
        }

        if(listingType == "textbackup") {
            callback = onTextBackupFileSelected;
            title = "Text Backup";
        }
        
        for (var i = 0; i < listing.length; i++) {

            savedGameListing.push(listing[i]);

            if(endsWith(listing[i],"." + ColonyGame.meta.fileExtension)) {

                if(listingType == "load") {
                    var displayName = webAppCore.getVar("mc-ref-name-" + listing[i],listing[i]);
                    var displayPopulation = webAppCore.getVar("mc-ref-pop-" + listing[i],0);
                    var displayOnlineMode = webAppCore.getVar("mc-ref-online-" + listing[i],-1);

                    if(displayName == listing[i]) {
                        menuOptions.push({
                            "title": listing[i],
                            "title-color": null,
                            "description": null,
                            "status": ColonyGame.meta.name + " Save",
                            "status-color": null,
                            "icon": null,
                            "tag": listing[i]
                        });
                    } else {

                        var menuData = {
                            "title": displayName,
                            "title-color": null,
                            "description": null,
                            "status": listing[i],
                            "status-color": null,
                            "icon": null,
                            "tag": listing[i],
                            "overflow": [
                                {
                                    pre:    "Population: ",
                                    post:   numberWithCommas(parseInt(displayPopulation)),
                                    color:  null,
                                    icon:   "images/" + ColonyGame.meta.colonistIcon
                                }
                            ]
                        };

                        if(displayOnlineMode != -1) {
                            if(displayOnlineMode == "1") {
                                menuData.overflow.push({
                                    pre:    null,
                                    post:   "在线游戏",
                                    color:  "#4CAF50",
                                    icon:   "images/" + ColonyGame.meta.onlineModeInd
                                });
                            } else {
                                menuData.overflow.push({
                                    pre:    null,
                                    post:   "离线游戏",
                                    color:  "#2196F3",
                                    icon:   "images/" + ColonyGame.meta.offlineModeInd
                                });
                            }
                        }

                        menuOptions.push(menuData);
                    }

                } else {
                    menuOptions.push({
                        "title": listing[i],
                        "title-color": null,
                        "description": null,
                        "status": ColonyGame.meta.name + " Save",
                        "status-color": null,
                        "icon": null,
                        "tag": listing[i]
                    });
                }



                
            }

            if(listingType == "delete") {
                if(endsWith(listing[i],"." + ColonyGame.meta.backupExtension)) {
                    menuOptions.push({
                        "title": listing[i],
                        "title-color": null,
                        "description": null,
                        "status": ColonyGame.meta.name + " Recovery File",
                        "status-color": "#FF9800",
                        "icon": null,
                        "tag": listing[i]
                    });
                }
            }

        }
        
        if(menuOptions.length == 0) {
            webAppCore.showAlertWithTitle("There are no saved games!","No saves");
            return;
        }

        tmpListingData = null;
        
        showList(title,menuOptions,callback,getString("general-nevermind"));
    }
    
    function onSaveGameSelected(tag) {
        openGame(tag);
    }
    
    function endsWith(str, suffix) {

        if(!str || !suffix) {
            return false;
        }

        return str.indexOf(suffix, str.length - suffix.length) !== -1;
    }

    function loadAssets() {
        loadedAssets = 0;
        totalAssets = ColonyGame.tiles.length;
        
        for(var i = 0; i < totalAssets; i++) {
            var asset = new Image();
            asset.tileReference = ColonyGame.tiles[i];
            asset.addEventListener("load",function() {
                assetCheckin(this,false);
            },false);

            if(currentModData == null) {
                asset.src = "images/" + ColonyGame.tiles[i].image;
            } else {
                if(currentModData.overrides[ColonyGame.tiles[i].name]) {
                    asset.src = currentModData.overrides[ColonyGame.tiles[i].name];
                } else {
                    asset.src = "images/" + ColonyGame.tiles[i].image;
                }
            }
            
        }
    }
    
    function assetCheckin(img,flipped) {
        var freshAsset = {};
        freshAsset.tileReference = img.tileReference;
        freshAsset.image = img;

        var assetName = img.tileReference.name;

        if(flipped) {
            assetName = img.tileReference.name + "-flipped";
        }
        
        gameAssets[assetName] = [];

        var sheetSize = freshAsset.tileReference.tileWidth;
        var sheetCount = img.width / sheetSize;

        // tmp fix for win store/edge mess up with wrong size consulate
        if(sheetCount > 0 && sheetCount < 1) {
            sheetCount = 1;
        }

        for(var i = 0; i < sheetCount; i++) {
            var sheetPart = document.createElement("canvas");
            var sheetContext = sheetPart.getContext("2d");
            
            sheetPart.height = img.height;
            sheetPart.width = sheetSize;

            var drawX = 0;

            if(flipped) {
                sheetContext.scale(-1,1);
                drawX = -sheetPart.width;
            }
        
            sheetContext.drawImage(img,(i * sheetSize),0,sheetSize,img.height,drawX,0,sheetSize,img.height);

            var partImage = new Image();
            partImage.src = sheetPart.toDataURL();
            
            var partObject = {};
            partObject.tileReference = img.tileReference;
            partObject.image = partImage;
            
            gameAssets[assetName][i] = partObject;
        }

        if(!flipped && img.tileReference.canFlip) {
            assetCheckin(img,true);
            return;
        }
        
        loadedAssets++;
        
        if(loadedAssets == totalAssets) {
            initScroll2d();
        }
    }

    function initResourceReadouts() {
        resourceReadouts = {};

        moneyReadout.innerHTML = "";

        var i;

        createResourceReadout("population",ColonyGame.meta.colonistIcon);

        createResourceReadout("tourists",ColonyGame.meta.touristIcon);

        for(i = 0; i < ColonyGame.utilities.length; i++) {
            createResourceReadout(ColonyGame.utilities[i].name,ColonyGame.utilities[i].icon);
        }

        for(i = 0; i < ColonyGame.resources.length; i++) {
            createResourceReadout(ColonyGame.resources[i].name,ColonyGame.resources[i].icon);
        }
    }

    function createResourceReadout(name,icon) {
        var resourceHolder = document.createElement("div");

        var trendHolder = document.createElement("img");
        trendHolder.src = "images/res-trend-placeholder.png";
        trendHolder.className = "trendicator";
        resourceHolder.appendChild(trendHolder);

        var iconHolder = document.createElement("img");
        iconHolder.src = "images/" + icon;
        resourceHolder.appendChild(iconHolder);

        var readoutHolder = document.createElement("span");
        resourceHolder.appendChild(readoutHolder);

        resourceReadouts[name] = {
            trend:          trendHolder,
            readout:        readoutHolder,
            holder:         resourceHolder,
            isTrendingDown: false
        };

        resourceHolder.title = name;

        resourceHolder.onmouseover = function(e) {

            if(window.innerWidth < 600) {
                return;
            }

            var hoverText = "";
            var title = this.title;

            if(currentGame.resources[this.title]) {

                hoverText += numberWithCommas(currentGame.resources[this.title].amount);

                if(currentGame.resources[this.title].price && currentGame.resources[this.title].serverId) {
                    var unitPrice = currentGame.resources[this.title].price / 100;
                    var totalValue = Math.round(currentGame.resources[this.title].amount * unitPrice);

                    hoverText += "<br />Est: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalValue);
                }
            } else {
                if(this.title == "population") {
                    title = "Population";

                    hoverText = numberWithCommas(getTotalPopulation());

                    hoverText += "<br />Unemp: " + numberWithCommas(runningUnemployed);
                }
            }

            showHoverPopup(hoverText,e.pageX,e.pageY,title);
        };

        moneyReadout.appendChild(resourceHolder);
    }

    var runningUnemployed = 0;

    function initTerrainDefs() {
        terrainDefReference = {};

        for(var i = 0; i < ColonyGame.terrains.length; i++) {
            terrainDefReference[ColonyGame.terrains[i].name] = ColonyGame.terrains[i];
        }
    }

    function getTerrainDefByName(name) {
        var def = null;
        
        if(terrainDefReference[name]) {
            return terrainDefReference[name];
        }
        
        return def;
    }

    function initOccupationDefs() {
        occupationDefReference = {};

        for(var i = 0; i < ColonyGame.occupations.length; i++) {
            occupationDefReference[ColonyGame.occupations[i].name] = ColonyGame.occupations[i];
        }
    }

    function getOccupationDefByName(name) {
        var def = null;
        
        if(occupationDefReference[name]) {
            return occupationDefReference[name];
        }
        
        return def;
    }

    function initBuildingDefs() {
        buildingDefReference = {};

        for(var i = 0; i < ColonyGame.buildings.length; i++) {
            buildingDefReference[ColonyGame.buildings[i].name] = ColonyGame.buildings[i];
        }
    }

    function getBuildingDefByName(name) {
        if(retainedDef != null && name == retainedDef.name) {
            return retainedDef;
        }

        return buildingDefReference[name];
    }

    function initUtilityDefs() {
        utilityDefReference = {};

        for(var i = 0; i < ColonyGame.utilities.length; i++) {
            utilityDefReference[ColonyGame.utilities[i].name] = ColonyGame.utilities[i];
        }

    }

    function getUtilityByDefName(name) {
        var def = null;
        
        if(utilityDefReference[name]) {
            return utilityDefReference[name];
        }
        
        return def;
    }

    function initResourceDefs() {
        resourceDefReference = {};

        for(var i = 0; i < ColonyGame.resources.length; i++) {
            resourceDefReference[ColonyGame.resources[i].name] = ColonyGame.resources[i];
        }
    }

    function getResourceByDefName(name) {
        var def = null;
        
        if(resourceDefReference[name]) {
            return resourceDefReference[name];
        }
        
        return def;
    }
    
    function initVehicleDefs() {
        vehicleDefReference = {};

        for(var i = 0; i < ColonyGame.vehicles.length; i++) {
            vehicleDefReference[ColonyGame.vehicles[i].name] = ColonyGame.vehicles[i];
        }

    }

    var lastVehicleDef = null;

    function getVehicleDefByName(name) {

        if(lastVehicleDef == null || lastVehicleDef.name != name) {
            lastVehicleDef = vehicleDefReference[name];
        }

        return lastVehicleDef;
    }
    
    function randomIntFromInterval(min,max) {
        return Math.floor(Math.random()*(max-min+1)+min);
    }
    
    function getIdNumber() {
        this.idCounter++;
        return this.idCounter;
    }

    function replaceAll(str, find, replace) {

        if(!str) {
            return "";
        }

        if(str.indexOf(find) < 0) {
            return str;
        }

        return str.replace(new RegExp(escapeRegExp(find), "g"), replace);
    }

    function escapeRegExp(str) {
        return str.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
    }

    function cleanUpGameFile() {
        if(!currentGame) {
            return;
        }
        

        var i;

        for(i = 0; i < currentGame.passableNonUpdatables.length; i++) {
            cleanUpUnneededPassableProperties(currentGame.passableNonUpdatables[i]);
            currentGame.passableNonUpdatables[i].occupiesTiles = null;
            currentGame.passableNonUpdatables[i].miniDef = null;
            currentGame.passableNonUpdatables[i].freeRef = null;
        }

        for(i = 0; i < currentGame.buildings.length; i++) {
            currentGame.buildings[i].occupiesTiles = null;
            currentGame.buildings[i].miniDef = null;
            currentGame.buildings[i].playDef = null;
        }

        for(i = 0; i < currentGame.mapResources.length; i++) {
            currentGame.mapResources[i].miniDef = null;
            currentGame.mapResources[i].freeRef = null;
            currentGame.mapResources[i].playDef = null;
        }

        for(i = 0; i < currentGame.colonists.length; i++) {
            colonistStatCompress(currentGame.colonists[i],"colonists");
            cleanUpUnneededColonistProperties(currentGame.colonists[i]);
        }

        for(i = 0; i < currentGame.tourists.length; i++) {
            colonistStatCompress(currentGame.tourists[i],"tourists");
            cleanUpUnneededColonistProperties(currentGame.tourists[i]);
        }

        for(i = 0; i < currentGame.diplomats.length; i++) {
            colonistStatCompress(currentGame.diplomats[i],"diplomats");
            cleanUpUnneededColonistProperties(currentGame.diplomats[i]);
        }

        for(i = 0; i < currentGame.vehicles.length; i++) {
            currentGame.vehicles[i].mq = [];
            currentGame.vehicles[i].pd = null;
            setAwaitingPath(currentGame.vehicles[i],"vehicle",false);
        }
    }

    function unCleanGameFile() {
        var i;

        for(i = 0; i < currentGame.buildings.length; i++) {
            currentGame.buildings[i] = rebuildBuildingObject(currentGame.buildings[i]);
            setUpMinidefForBuilding(currentGame.buildings[i],false,false);
            reInitBuilding(currentGame.buildings[i]);
        }

        for(i = 0; i < currentGame.colonists.length; i++) {
            currentGame.colonists[i].mq = [];
            setAwaitingPath(currentGame.colonists[i],"colonist",false);
            currentGame.colonists[i] = rebuildColonistObject(currentGame.colonists[i]);
            reninitColonist(currentGame.colonists[i]);
        }

        for(i = 0; i < currentGame.tourists.length; i++) {
            currentGame.tourists[i].mq = [];
            setAwaitingPath(currentGame.tourists[i],"colonist",false);
            currentGame.tourists[i] = rebuildColonistObject(currentGame.tourists[i]);
            reninitColonist(currentGame.tourists[i]);
        }

        for(i = 0; i < currentGame.diplomats.length; i++) {
            currentGame.diplomats[i].mq = [];
            setAwaitingPath(currentGame.diplomats[i],"colonist",false);
            currentGame.diplomats[i] = rebuildColonistObject(currentGame.diplomats[i]);
            reninitColonist(currentGame.diplomats[i]);
        }

        gooseUpColonistReferences();
    }

    var tmpSaveRawData;
    var tmpNonBaseData;

    
    function refreshMarketPrices() {
        showOnlineResources("setprices");
    }

    var saveInProgress = false;

    function showSaveOnBack() {
        document.getElementById("savingDialog").style.display = "block";
        document.getElementById("savingHeader").innerHTML = "Saving " + currentFileName;
        document.getElementById("savingProgressReadout").innerHTML = "Game Save in Progress...";
        webAppCore.handleBackFunction(placeholder);
    }

    function clonePathArray(arr) {
        return JSON.parse(JSON.stringify(arr));
    }

    function saveGame(showDialog) {
        if(!currentGame) {

            if(showListingAfterSave) {

                currentGame = null;
                retainedPaths = {};
                retainedPathsCounter = 0;
                shouldUpdateCollissionMap = true;
                retainedUsage = {};
                showTitle();
            }
            
            showListingAfterSave = false;

            return;
        }

        if(saveInProgress) {
            return;
        }

        if(currentGame.readOnlyMode) {

            if(returnToFileName != null) {
                currentGame = null;
                retainedPaths = {};
                retainedUsage = {};
                retainedPathsCounter = 0;
                shouldUpdateCollissionMap = true;
                openGame(returnToFileName);
                returnToFileName = null;
                pendingForeignColony = null;
                return;
            }

            if(showListingAfterSave) {
                currentGame = null;
                retainedPaths = {};
                retainedUsage = {};
                retainedPathsCounter = 0;
                shouldUpdateCollissionMap = true;
                showTitle();
            } else {
                if(showDialog) {
                    webAppCore.showToast("You cannot save changes to this file.");
                }
            }

            return;
        }

        currentGame.lastSaveTime = Date.now();

        saveInProgress = true;
        webAppCore.handleBackFunction(showSaveOnBack);

        var useExtension = ColonyGame.meta.fileExtension;

        if(currentGame.mem) {
            useExtension = ColonyGame.meta.customMapExtension;
        }

        document.getElementById("autosavingReadout").innerHTML = "正在保存游戏...";
        document.getElementById("autosavingReadout").style.display = "inline-block";
        
        if(!currentFileName || currentFileName.trim().length == 0) {
            currentFileName = "colony." + useExtension;
        }

        currentFileName = currentFileName.replace("." + ColonyGame.meta.backupExtension,"." + useExtension);

        if(showDialog) {
            document.getElementById("savingDialog").style.display = "block";
            document.getElementById("savingHeader").innerHTML = "Saving " + currentFileName;
            document.getElementById("savingProgressReadout").innerHTML = "Cleaning Data";
            webAppCore.handleBackFunction(placeholder);
        }

        if(currentGame.firstSave) {
            checkSaveFileNameForDupes();
        } else {
            setTimeout(savePartTwo,100);
        }

        
    }

    function checkSaveFileNameForDupes() {

        currentGame.firstSave = false;

        webAppCore.openListing(function(list) {

            var namePicked = false;
            var tryCounter = 0;
            var originalFileName = currentFileName;

            var useExtension = ColonyGame.meta.fileExtension;
            
            if(currentGame.mem) {
                useExtension = ColonyGame.meta.customMapExtension;
            }

            while(!namePicked) {

                var washit = false;

                for(var i = 0; i < list.length; i++) {
                    if(list[i] == currentFileName) {
                        currentFileName = originalFileName.replace("." + useExtension,"-" + tryCounter + "." + useExtension);
                        tryCounter++;
                        washit = true;
                        break;
                    }
                    
                }

                if(!washit) {
                    namePicked = true;
                }
            }

            setTimeout(savePartTwo,100);
        });

        
    }

    function saveCustomMapMetaData() {
        currentGame.mename = document.getElementById("customMapMetaNameInput").value.latinize().trim();
        currentGame.meauthor = document.getElementById("customMapMetaAuthorInput").value.latinize().trim();
        currentGame.medescription = document.getElementById("customMapMetaDescriptionInput").value.latinize().trim();
    }

    function saveCustomMapFile() {
        var customMapData = new CustomMap();

        currentGame.merevision++;

        customMapData.terrainData = currentGame.mapResources;
        customMapData.name = currentGame.mename;
        customMapData.revision = currentGame.merevision;
        customMapData.mapType = currentGame.mapType;
        customMapData.height = currentGame.height;
        customMapData.width = currentGame.width;
        customMapData.author = currentGame.meauthor;
        customMapData.url = currentGame.meurl;
        customMapData.description = currentGame.medescription;

        customMapData.gameVersion = ColonyGame.meta.releaseCode;

        customMapData.startX = currentGame.mestartx;
        customMapData.startY = currentGame.mestarty;

        var customMapJson = JSON.stringify(customMapData);

        //console.log(customMapJson);

        document.getElementById("savingProgressReadout").innerHTML = "Compressing Data";

        var worker = new Worker("compression-worker.js");
        worker.addEventListener("message",function(e) {
            if(e.data.status == "complete") {

                webAppCore.saveFile(currentFileName, e.data.data, onSaveComplete, true);

                if(tmpExportAfterSave) {
                    tmpExportAfterSave = false;
                    webAppCore.exportFile(currentFileName,e.data.data,false);
                }
                
            } else {
                console.log(e);
                //saveInProgress = false;

                // in the case of compression failure, just disable compression and move along
                currentGame.useCompression = false;
                currentGame.useCloud = false;

                document.getElementById("savingProgressReadout").innerHTML = "Saving Data";
                webAppCore.saveFile(currentFileName, tmpSaveRawData, finishUncompressedSave, true);
            }
            
        });
        worker.addEventListener("error",function(e) {
        
            onSaveComplete(true);

            if(e.filename) {
                var scrpt = e.filename.substr(e.filename.lastIndexOf('/') + 1);
                webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
            } else {
                webAppCore.logEvent("Game Compression Error","Unknown","Unknown");
            }
        
            
        
            
        });
        worker.postMessage({
            "method":   "compress",
            "data":     customMapJson
        });

        unCleanGameFile();
        killSwitch = false;
        pauseDrawing = false;
    }

    function savePartTwo() {


        


        saveCounter = 0;

        

        killSwitch = true;
        pauseDrawing = true;

        cleanUpGameFile();

        if(currentGame.mem) {
            saveCustomMapFile();
            return;
        }

        webAppCore.storeVar("res-save-" + currentFileName + "-hold","0");

        var resHold = JSON.stringify(currentGame.resources);

        
        if(currentGame.colonyId != 0) {
            webAppCore.storeVar("pnd-trns-" + currentGame.colonyId + "-sve","0");
        }
        

        var ctx = new Checksum("fnv32", 0); // fnv32-0
        ctx.updateStringly(resHold);
        var resourcesCheck = ctx.result.toString(16);

        currentGame.rescs = resourcesCheck;

        tmpNonBaseData = JSON.stringify(currentGame);
        tmpSaveRawData = btoa(tmpNonBaseData);

        var backupOption = webAppCore.getVar("mc-backup-option","1");

        if(backupOption == "1") {
            document.getElementById("savingProgressReadout").innerHTML = "Creating Backup";

            setTimeout(savePartThree,100);
        } else {
            setTimeout(onBackupSaved,100);
        }
    }

    function savePartThree() {
        var backupName = currentFileName.replace("." + ColonyGame.meta.fileExtension,"." + ColonyGame.meta.backupExtension);
        webAppCore.saveFile(backupName, tmpSaveRawData, onBackupSaved, true);
    }

    function finishUncompressedSave() {
        unCleanGameFile();
        killSwitch = false;
        pauseDrawing = false;

        onSaveComplete();
    }

    function onBackupSaved() {

        if(currentGame.useCompression) {
            document.getElementById("savingProgressReadout").innerHTML = "Compressing Data";
        } else {
            document.getElementById("savingProgressReadout").innerHTML = "Saving Data";
            webAppCore.saveFile(currentFileName, tmpSaveRawData, finishUncompressedSave, true);
            return;
        }

        

        var worker = new Worker("compression-worker.js");
        worker.addEventListener("message",function(e) {
            if(e.data.status == "complete") {

                var blockCLoud = false;

                if(currentGame != null) {
                    blockCLoud = !currentGame.useCloud;
                }

                webAppCore.saveFile(currentFileName, e.data.data, onSaveComplete, blockCLoud);
                
            } else {
                console.log(e);
                //saveInProgress = false;

                // in the case of compression failure, just disable compression and move along
                currentGame.useCompression = false;
                currentGame.useCloud = false;

                document.getElementById("savingProgressReadout").innerHTML = "Saving Data";
                webAppCore.saveFile(currentFileName, tmpSaveRawData, finishUncompressedSave, true);
            }
            
        });
        worker.addEventListener("error",function(e) {
        
            onSaveComplete(true);

            if(e.filename) {
                var scrpt = e.filename.substr(e.filename.lastIndexOf('/') + 1);
                webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
            } else {
                webAppCore.logEvent("Game Compression Error","Unknown","Unknown");
            }
        
            
        
            
        });
        worker.postMessage({
            "method":   "compress",
            "data":     tmpNonBaseData
        });

        unCleanGameFile();
        killSwitch = false;
        pauseDrawing = false;
    }
    
    function onSaveComplete(error) {

        saveInProgress = false;

        if(currentGame == null) {
            return;
        }

        webAppCore.handleBackFunction(standardBack);

        
        document.getElementById("savingDialog").style.display = "none";
        document.getElementById("autosavingReadout").innerHTML = "";
        document.getElementById("autosavingReadout").style.display = "none";

        

        tmpSaveRawData = null;
        tmpNonBaseData = null;

        if(!currentGame.mem) {

            var onlineflag = "1";

            if(currentGame.offlineMode) {
                onlineflag = "0";
            }

            webAppCore.storeVar("mc-last-saved-game-name",currentGame.name);
            webAppCore.storeVar("mc-last-saved-game",currentFileName);
            webAppCore.storeVar("mc-ref-name-" + currentFileName,currentGame.name);
            webAppCore.storeVar("mc-ref-pop-" + currentFileName,getTotalPopulation());
            webAppCore.storeVar("mc-ref-online-" + currentFileName,onlineflag);
            webAppCore.storeVar("mc-ref-type-" + currentFileName,currentGame.mapType);
        }

        if(error) {
            webAppCore.showToast("Game compression error.  Please try again or disable compression.");
            showListingAfterSave = false;
            return;
        }


        webAppCore.showToast("游戏已保存: " + currentFileName);

        
        if(showListingAfterSave) {
            currentGame = null;
            retainedPaths = {};
            retainedUsage = {};
            retainedPathsCounter = 0;
            shouldUpdateCollissionMap = true;
            showTitle();
        }
        
        showListingAfterSave = false;

        if(returnToFileName != null && pendingForeignColony != null) {
            if(usingSockets) {
                webAppCore.socketEmit("closeconnection","");
            }
            webAppCore.showSplash("Syncing Data...");
            loadCloudReadOnly(pendingForeignColony);
        }
    }
    
    var isBackupAttempt = false;

    function openGame(filename) {

        if(filename == null) {
            return;
        }

        isBackupAttempt = false;

        if(webAppCore.getFacebookLoginStatus()) {
            webAppCore.showSplash("Syncing Data...");
        } else {
            webAppCore.showSplash("Loading Saved Game...");
        }

        currentFileName = filename;

        if(endsWith(currentFileName, "." + ColonyGame.meta.fileExtension)) {
            webAppCore.openFile(currentFileName, uncompressFile);
        } else {
            webAppCore.openFile(currentFileName, onFileOpened);
        }

    }

    function uncompressFile(content) {

        try {
            var decodedContent = atob(content);
            onFileOpened(decodedContent);
        } catch(e) {
            webAppCore.showSplash("Decompressing Game...");

            var worker = new Worker("compression-worker.js");

            worker.addEventListener("message",function(e) {
                if(e.data.status == "complete") {
                    onFileOpened(e.data.data);
                } else {
                    attemptBackup();
                }
                
            });
            worker.addEventListener("error",function(e) {
                attemptBackup();
                
                var scrpt = e.filename.substr(e.filename.lastIndexOf('/') + 1);
                webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
            });
            worker.postMessage({
                "method":   "decompress",
                "data":     content
            });
        }

        
    }

    function attemptBackup() {
        isBackupAttempt = true;
        var backupName = currentFileName.replace("." + ColonyGame.meta.fileExtension,"." + ColonyGame.meta.backupExtension);
        console.log("restoring backup");
        webAppCore.showSplash("Attempting to restore backup...");
        webAppCore.openFile(backupName, onFileOpened);
    }
    
    function onFileOpened(content) {

        totalAvailableVehicles = 0;

        tmpBuildingRefHolder = {};

        webAppCore.showSplash("Restoring Data...");

        document.getElementById("newGameMenu").style.display = "none";
        showHiders();

        var rawGameData = null;

        var decodedContent;

        if(currentFileName == "shared" || endsWith(currentFileName, "." + ColonyGame.meta.fileExtension) && !isBackupAttempt) {
            decodedContent = content;
        } else {
            try {
                decodedContent = atob(content);
            } catch(ex) {
                console.log(ex);

                webAppCore.logEvent("Error","Open File",ex);

                if(isBackupAttempt) {
                    isBackupAttempt = false;
                    webAppCore.showToast("Error opening saved file!");
                    webAppCore.clearSplash();
                    vehiclePathOrders = {};
                    colonistPathOrders = {};
                    window.focus();

                    showTitle();

                    return;
                } else {
                    attemptBackup();
                    return;
                }
            }
        }

        

        try {
            rawGameData = JSON.parse(decodedContent);
            //console.log(JSON.stringify(rawGameData.colonists[0]));
        } catch(ex) {
            console.log(ex);
            webAppCore.logEvent("Error","Parse File",ex);

            if(isBackupAttempt || remoteCloudLoad) {
                isBackupAttempt = false;
                webAppCore.showToast("Save file corrupted!");
                webAppCore.clearSplash();
                vehiclePathOrders = {};
                colonistPathOrders = {};
                window.focus();

                showTitle();

                return;
            } else {
                attemptBackup();
                return;
            }
        }

        if(rawGameData == null) {
            if(isBackupAttempt) {
                isBackupAttempt = false;
                webAppCore.showToast("Save file corrupted!");
                vehiclePathOrders = {};
                colonistPathOrders = {};
                webAppCore.clearSplash();
                window.focus();

                showTitle();

                return;
            } else {
                attemptBackup();
                return;
            }
        }

        bulldozerMode = false;
        webAppCore.handleBackFunction(standardBack);
        webAppCore.setTitleVisible(false);
        titleShowing = false;
        

        showListingAfterSave = false;

        window.focus(); 

        if(!rawGameData.lastSaveTime) {
            rawGameData.lastSaveTime = 0;
        }

        if(remoteCloudLoad) {
            rawGameData.readOnlyMode = true;
            rawGameData.offlineMode = true;
        }

        if(!rawGameData.rescs) {
            rawGameData.rescs = null;
        }

        var resourceHackingDetected = false;
        
        if(rawGameData.rescs == null) {
            console.log("nothing to check");
        } else {
            var oldResources = JSON.stringify(rawGameData.resources);

            var ctx = new Checksum("fnv32", 0);
            ctx.updateStringly(oldResources);
            var resourcesCheck = ctx.result.toString(16);

            if(rawGameData.rescs != resourcesCheck) {
                resourceHackingDetected = true;
                webAppCore.logEvent("Game File Hack","Detected",rawGameData.rescs + ":" + resourcesCheck);
            }
        }



        if(!rawGameData.offlineMode && rawGameData.colonyId && rawGameData.colonyId != "0") {
            var pndTrnSto = webAppCore.getVar("pnd-trns-" + rawGameData.colonyId + "-sve","0");

            if(pndTrnSto != "0") {
                var modRes = null;

                try {
                    modRes = JSON.parse(pndTrnSto);
                    console.log("modifying resources because of unsaved transactions");
                } catch(ex) {
                    console.log(ex);
                    modRes = null;
                }

                if(modRes != null) {
                    rawGameData.resources = modRes;
                }
            }
        }

        if(rawGameData.sX == undefined) {
            rawGameData.sX = 0;
            rawGameData.sY = 0;
            rawGameData.gX = 0;
            rawGameData.gY = 0;
        }

        if(rawGameData.immigrantSources == undefined) {
            rawGameData.immigrantSources = [];
        }

        if(rawGameData.apiKey == undefined) {
            rawGameData.apiKey = 0;
        }

        if(rawGameData.foreignPayrollTotals == undefined) {
            rawGameData.foreignPayrollTotals = 0;
        }

        if(rawGameData.motherlandTaxesPaid == undefined) {
            rawGameData.motherlandTaxesPaid = 0;
        }

        if(rawGameData.timeOfDay == undefined) {
            rawGameData.timeOfDay = 9;
        }

        if(rawGameData.cm == undefined) {
            rawGameData.cm = false;
        }

        if(rawGameData.totalImmigration == undefined) {
            rawGameData.totalImmigration = 0;
        }

        if(rawGameData.totalEmigration == undefined) {
            rawGameData.totalEmigration = 0;
        }

        if(rawGameData.finishedPassableNonUpdatables == undefined) {
            rawGameData.finishedPassableNonUpdatables = {};
        }

        if(rawGameData.firstSave == undefined) {
            rawGameData.firstSave = false;
        }

        if(rawGameData.foreignContactReference == undefined) {
            rawGameData.foreignContactReference = {};
        }

        if(rawGameData.sadReasons == undefined) {
            rawGameData.sadReasons = [];
        }

        if(rawGameData.diplomats == undefined) {
            rawGameData.diplomats = [];
        }

        if(rawGameData.payrollRate == undefined) {
            rawGameData.payrollRate = 0.25;
        }

        if(rawGameData.virtualAvatars == undefined) {
            rawGameData.virtualAvatars = {
                "-1": {
                    "id": 0,
                    "represents": 0
                },
                "-2": {
                    "id": 0,
                    "represents": 0
                },
                "-3": {
                    "id": 0,
                    "represents": 0
                },
                "-4": {
                    "id": 0,
                    "represents": 0
                },
                "-5": {
                    "id": 0,
                    "represents": 0
                },
                "-6": {
                    "id": 0,
                    "represents": 0
                },
                "-7": {
                    "id": 0,
                    "represents": 0
                },
                "-8": {
                    "id": 0,
                    "represents": 0
                },
                "-9": {
                    "id": 0,
                    "represents": 0
                },
                "-10": {
                    "id": 0,
                    "represents": 0
                }
            };
        }

        if(!rawGameData.virtualAvatars["-6"]) {
            rawGameData.virtualAvatars["-6"] = {
                "id": 0,
                "represents": 0
            };
            rawGameData.virtualAvatars["-7"] = {
                "id": 0,
                "represents": 0
            };
            rawGameData.virtualAvatars["-8"] = {
                "id": 0,
                "represents": 0
            };
            rawGameData.virtualAvatars["-9"] = {
                "id": 0,
                "represents": 0
            };
            rawGameData.virtualAvatars["-10"] = {
                "id": 0,
                "represents": 0
            };
        }

        if(rawGameData.taxLevel == undefined) {
            rawGameData.taxLevel = 100;
        }

        if(rawGameData.salesPitch == undefined) {
            rawGameData.salesPitch = "";
        }

        if(!rawGameData.defaultRace) {
            rawGameData.defaultRace = ColonyGame.meta.tmpDefaultRace;
        }

        if(!rawGameData.mapType) {
            rawGameData.mapType = ColonyGame.meta.tmpDefaultMapType;
        }

        if(rawGameData.disasterCounters == undefined) {
            rawGameData.disasterCounters = {};

            var tmt;

            for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
                if(ColonyGame.mapTypes[i].name == rawGameData.mapType) {
                    tmt = ColonyGame.mapTypes[i];
                    break;
                }
            }

            if(tmt.explosionDisasters != null) {
                for(i = 0; i < tmt.explosionDisasters.length; i++) {
                    rawGameData.disasterCounters[tmt.explosionDisasters[i].name] = randomIntFromInterval(0,tmt.explosionDisasters[i].frequency);
                }
            }
        }

        if(!rawGameData.destroyedBuildings) {
            rawGameData.destroyedBuildings = 0;
        }

        if(!rawGameData.livingWageRate) {
            rawGameData.livingWageRate = 0;
        }

        if(!rawGameData.totalDeaths) {
            rawGameData.totalDeaths = 0;
        }

        if(!rawGameData.totalTourists) {
            rawGameData.totalTourists = 0;
        }

        if(!rawGameData.totalTourismIncome) {
            rawGameData.totalTourismIncome = 0;
        }

        if(!rawGameData.governmentLevel) {
            rawGameData.governmentLevel = 0;
        }

        if(!rawGameData.deadTourists) {
            rawGameData.deadTourists = 0;
        }

        if(!rawGameData.availableTourism) {
            rawGameData.availableTourism = 0;
        }

        if(!rawGameData.rewardCounter) {
            rawGameData.rewardCounter = 0;
        }

        if(rawGameData.autoBudget == undefined) {
            rawGameData.autoBudget = false;
        }

        if(rawGameData.historicStats == undefined) {
            rawGameData.historicStats = {
                "population": [],
                "age": [],
                "savings": [],
                "gdp": [],
                "unemployment": [],
                "jobs": [],
                "health": [],
                "iq": [],
                "homeless": [],
                "approval": [],
                "workforce": [],
                "mediansalary": [],
                "retiredpop": []
            };
        }

        if(rawGameData.populationStats == undefined) {
            rawGameData.populationStats = {};

            for(var r = 0; r < ColonyGame.races.length; r++) {
                rawGameData.populationStats[ColonyGame.races[r].name] = 0;
            }
        }

        if(rawGameData.centerBuildingId == undefined) {
            rawGameData.centerBuildingId = 0;
        }

        if(rawGameData.showRewardOption == undefined) {
            rawGameData.showRewardOption = false;
        }

        if(rawGameData.workerPolicy == undefined) {
            rawGameData.workerPolicy = 1;
        }

        if(rawGameData.paidWindfallTax == undefined) {
            rawGameData.paidWindfallTax = true;
        }

        if(rawGameData.paidWindfallTaxB == undefined) {
            rawGameData.paidWindfallTaxB = false;
        }

        if(rawGameData.paidWindfallTaxC == undefined) {
            rawGameData.paidWindfallTaxC = false;
        }

        if(rawGameData.paidWindfallTaxD == undefined) {
            rawGameData.paidWindfallTaxD = false;
        }

        if(rawGameData.foodRationing == undefined) {
            rawGameData.foodRationing = false;
        }

        if(rawGameData.offlineMode == undefined) {
            rawGameData.offlineMode = false;
        }

        if(rawGameData.readOnlyMode == undefined) {
            rawGameData.readOnlyMode = false;
        }

        if(rawGameData.useCompression == undefined) {
            rawGameData.useCompression = true;
        }

        if(rawGameData.hasCheated == undefined) {
            rawGameData.hasCheated = false;
        }

        if(rawGameData.privateCharter == undefined) {
            rawGameData.privateCharter = false;
        }

        if(!rawGameData.salaries) {
            rawGameData.salaries = {};
        }

        if(!rawGameData.stopImmigration) {
            rawGameData.stopImmigration = false;
        }

        if(!rawGameData.themeColor) {
            rawGameData.themeColor = "#b35900";
        }

        if(rawGameData.useCloud == undefined) {
            if(webAppCore.getFacebookLoginStatus()) {
                rawGameData.useCloud = true;
            } else {
                rawGameData.useCloud = false;
            }
        }

        if(!rawGameData.mail) {
            rawGameData.mail = [];
        }

        if(!rawGameData.colonialTaxCollected) {
            rawGameData.colonialTaxCollected = 0;
        }

        if(!rawGameData.colonies) {
            rawGameData.colonies = 0;
        }

        if(!rawGameData.charter) {
            rawGameData.charter = 0;
        }

        if(!rawGameData.colonyId) {
            rawGameData.colonyId = 0;
        }

        if(!rawGameData.motherlandid) {
            rawGameData.motherlandid = 0;
        }

        if(!rawGameData.creationDate) {
            rawGameData.creationDate = Date.now();
        }

        if(!rawGameData.motherland) {
            rawGameData.motherland = webAppCore.getString(ColonyGame.meta.defaultMotherland);
        }
        
        rawGameData.getId = getIdNumber;

        if(isNaN(rawGameData.width)) {
            rawGameData.width = ColonyGame.meta.mapWidth;
            rawGameData.height = ColonyGame.meta.mapHeight;
        }

        if(!rawGameData.unlockedTechs) {
            rawGameData.unlockedTechs = {};
        }
        
        var i,j;

        for( i = 0; i < ColonyGame.races.length; i++) {
            if(ColonyGame.races[i].name == rawGameData.defaultRace) {
                if(ColonyGame.races[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.races[i].startingTechs.length; j++) {
                        rawGameData.unlockedTechs[ColonyGame.races[i].startingTechs[j]] = true;
                    }
                }
            }
            
        }

        for( i = 0; i < ColonyGame.civilizations.length; i++) {
            if(ColonyGame.civilizations[i].name == rawGameData.civilization) {
                if(ColonyGame.civilizations[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.civilizations[i].startingTechs.length; j++) {
                        rawGameData.unlockedTechs[ColonyGame.civilizations[i].startingTechs[j]] = true;
                    }
                }
            }
            
        }

        for( i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == rawGameData.mapType) {
                if(ColonyGame.mapTypes[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.mapTypes[i].startingTechs.length; j++) {
                        rawGameData.unlockedTechs[ColonyGame.mapTypes[i].startingTechs[j]] = true;
                    }
                }
            }
            
        }

        for(i = 0; i < rawGameData.buildings.length; i++) {



            if(rawGameData.buildings[i].def.name) {
                rawGameData.buildings[i].def = rawGameData.buildings[i].def.name;
            }

            if(rawGameData.buildings[i].genRef) {
                rawGameData.buildings[i].genRef = null;
            }

            
            

            // hard code for name change
            /*
            if(rawGameData.buildings[i].def == "Raw Materials Depot") {
                rawGameData.buildings[i].def = "Ore Refinery";
            }
            */

            if(ColonyGame.meta.name == "Antiquitas") {
                if(rawGameData.buildings[i].def == "Gold Mint") {
                    rawGameData.buildings[i].def = "Monetam";
                }

                if(rawGameData.buildings[i].def == "Water") {
                    rawGameData.buildings[i].def = "Water Pool";
                }
            }

            if(rawGameData.buildings[i].def == "Gold Smelter") {
                rawGameData.buildings[i].def = "Aurum Liquatur";
            }

            if(rawGameData.buildings[i].def == "Atmosphere Condensor") {
                rawGameData.buildings[i].def = "Atmosphere Condenser";
            }

            if(rawGameData.buildings[i].def == "Unholy Mound of Whorship") {
                rawGameData.buildings[i].def = "Unholy Mound of Worship";
            }

            if(rawGameData.buildings[i].def == "Synthetic Crystalline") {
                rawGameData.buildings[i].def = "Synthetic Crystalline Deposit";
            }
            
            rawGameData.buildings[i] = rebuildBuildingObject(rawGameData.buildings[i]);
            setUpMinidefForBuilding(rawGameData.buildings[i],false,false);


            reInitBuilding(rawGameData.buildings[i]);

        }

        // resort buildings into def order
        rawGameData.buildings.sort(sortBuildings);
        
        // restore passable functions
        for(i = 0; i < rawGameData.passableNonUpdatables.length; i++) {

            if(rawGameData.passableNonUpdatables[i].def.name) {
                rawGameData.passableNonUpdatables[i].def = rawGameData.passableNonUpdatables[i].def.name;
            }

            rawGameData.passableNonUpdatables[i] = rebuildBuildingObject(rawGameData.passableNonUpdatables[i]);
            setUpMinidefForBuilding(rawGameData.passableNonUpdatables[i],false,false);

            cleanUpUnneededPassableProperties(rawGameData.passableNonUpdatables[i]);

        }
        
        // restore colonist functions
        if(!rawGameData.colonists) {
            rawGameData.colonists = [];
        }

        if(!rawGameData.tourists) {
            rawGameData.tourists = [];
        }

        for(i = 0; i < rawGameData.colonists.length; i++) {

            rawGameData.colonists[i].mq = [];

            rawGameData.colonists[i] = rebuildColonistObject(rawGameData.colonists[i]);

            reninitColonist(rawGameData.colonists[i]);

        }

        for(i = 0; i < rawGameData.tourists.length; i++) {

            rawGameData.tourists[i].mq = [];

            rawGameData.tourists[i] = rebuildColonistObject(rawGameData.tourists[i]);

            reninitColonist(rawGameData.tourists[i]);

        }

        for(i = 0; i < rawGameData.diplomats.length; i++) {

            rawGameData.diplomats[i].mq = [];

            rawGameData.diplomats[i] = rebuildColonistObject(rawGameData.diplomats[i]);

            reninitColonist(rawGameData.diplomats[i]);

        }

        whackedVehicleKillArray = [];
        
        // restore vehicle functions
        for(i = 0; i < rawGameData.vehicles.length; i++) {


            if(rawGameData.vehicles[i].def.name) {
                rawGameData.vehicles[i].def = rawGameData.vehicles[i].def.name;
            }

            rawGameData.vehicles[i] = rebuildVehicleObject(rawGameData.vehicles[i]);

            rawGameData.vehicles[i].mq = [];

        }

        for(i = 0; i < whackedVehicleKillArray.length; i++) {
            removeFromArray(rawGameData.vehicles,whackedVehicleKillArray[i]);
        }

        whackedVehicleKillArray = null;
        
        // restore terrain resource functions
        for(i = 0; i < rawGameData.mapResources.length; i++) {

            if(rawGameData.mapResources[i].def.name) {
                rawGameData.mapResources[i].def = rawGameData.mapResources[i].def.name;
            }

            rawGameData.mapResources[i] = rebuildMapResourceObject(rawGameData.mapResources[i]);
            setUpMinidefForBuilding(rawGameData.mapResources[i],true,false);

        }

        for(var res in rawGameData.resources) {
            var df = getResourceByDefName(res);

            if(df != null) {
                rawGameData.resources[res].capacity = df.max;
            }
        }

        // reinit resources if new were added
        for(i = 0; i < ColonyGame.resources.length; i++) {

            

            if(!rawGameData.resources[ColonyGame.resources[i].name]) {

                rawGameData.resources[ColonyGame.resources[i].name] = {};
                rawGameData.resources[ColonyGame.resources[i].name].amount = ColonyGame.resources[i].starting;
                rawGameData.resources[ColonyGame.resources[i].name].price = ColonyGame.resources[i].basePrice;
                rawGameData.resources[ColonyGame.resources[i].name].previous = 0;
                rawGameData.resources[ColonyGame.resources[i].name].storageCapacity = 0;
                rawGameData.resources[ColonyGame.resources[i].name].unlocked = false;
                rawGameData.resources[ColonyGame.resources[i].name].serverId = 0;
                rawGameData.resources[ColonyGame.resources[i].name].lastTrade = 0;

                if(ColonyGame.resources[i].catchupAmount > 0) {

                    if(!rawGameData.gifts) {
                        rawGameData.gifts = [];
                    }

                    rawGameData.gifts.push(new Gift("New Resource Catchup","New resource added bonus for existing colonies.",ColonyGame.resources[i].name,ColonyGame.resources[i].catchupAmount));
                }
 
            }

            rawGameData.resources[ColonyGame.resources[i].name].capacity = ColonyGame.resources[i].max;
        }

        if(!rawGameData.gifts) {
            rawGameData.gifts = [];
        }

        if(!rawGameData.mail) {
            rawGameData.mail = [];
        }

        webAppCore.showSplash("Doing Cleanup...");

        runningColonistReferenceArray = {};

        

        currentGame = rawGameData;


        setupMenuOptions();

        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        resourceUpdateTurn = true;
        shoreUpdateTurn = true;
        retainedUsage = {};

        gooseUpColonistReferences();

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;

        if(!currentGame.offlineMode) {
            establishSocketConnection();
        }

        sizeElements();

        setupResourceLedger();

        mailCheckTimer = 14200;

        setMapType();

        if(!currentGame.readOnlyMode && currentGame.mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        if(!currentGame.readOnlyMode && currentGame.gifts.length > 0) {
            document.getElementById("imGift").style.display = "inline-block";
        } else {
            document.getElementById("imGift").style.display = "none";
        }
        
        rawGameData = null;

        if(resourceHackingDetected) {
            blacklistColony();
        }

        Scroll2d.setMapDims(currentGame.width,currentGame.height);

        createCollisionReference();

        updateUtilityGrid();

        Scroll2d.forceSceneChange();
    
        Scroll2d.setZoomLevel(1);

        centerMap();
        setCenterMapIcon();

        
        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        Scroll2d.forceSceneChange();

        createSidebar();
        drawSidebar();

        setWeather();

        remoteCloudLoad = false;

        if(!currentGame.readOnlyMode) {
            webAppCore.storeVar("mc-last-saved-game",currentFileName);
            webAppCore.showToast(currentGame.name);
        }

        sizeElements();
        Scroll2d.sizeElements();
        setupMenuOptions();

        var tax,totalTax;

        // temporary windfall tax to restore order
        if(!currentGame.readOnlyMode && !currentGame.paidWindfallTaxB) {
            currentGame.paidWindfallTaxB = true;

            if(!currentGame.offlineMode && currentGame.resources[ColonyGame.meta.tenderResource].amount > 500000000) {
                tax = currentGame.resources[ColonyGame.meta.tenderResource].amount - 500000000;
                totalTax = Math.round(tax * 0.95);

                modifyResourceAmount(ColonyGame.meta.tenderResource,-totalTax,false,"Tax");

                webAppCore.showDialog({
                    "title":    "Windfall Profits Tax",
                    "message":  "The evil Galactic Emperor is pleased to announce that all colonies in the galaxy are being charged a windfall profits tax!  You owe $" + numberWithCommas(totalTax) + ".  Thank you for supporting the empire.",
                    "op1": {
                        "text":     ":-(",
                        "func":     placeholder
                    }
                });
            }

        }

        if(!currentGame.readOnlyMode && !currentGame.paidWindfallTaxC) {
            currentGame.paidWindfallTaxC = true;

            if(!currentGame.offlineMode && currentGame.resources[ColonyGame.meta.tenderResource].amount > 750000000) {
                tax = currentGame.resources[ColonyGame.meta.tenderResource].amount - 750000000;
                totalTax = Math.round(tax * 0.95);

                modifyResourceAmount(ColonyGame.meta.tenderResource,-totalTax,false,"Tax");

                webAppCore.showDialog({
                    "title":    "Windfall Profits Tax",
                    "message":  "The evil Galactic Emperor is pleased to announce that all colonies in the galaxy are being charged a windfall profits tax!  You owe $" + numberWithCommas(totalTax) + ".  Thank you for supporting the empire.",
                    "op1": {
                        "text":     ":-(",
                        "func":     placeholder
                    }
                });
            }

        }

        if(!currentGame.readOnlyMode && !currentGame.paidWindfallTaxD) {
            currentGame.paidWindfallTaxD = true;

            if(!currentGame.offlineMode && currentGame.resources[ColonyGame.meta.tenderResource].amount > 750000000) {

                if(currentGame.resources[ColonyGame.meta.tenderResource].amount > 10000000000) {
                    totalTax = currentGame.resources[ColonyGame.meta.tenderResource].amount - 10000000000;
                } else {
                    tax = currentGame.resources[ColonyGame.meta.tenderResource].amount - 750000000;
                    totalTax = Math.round(tax * 0.95);
                }

                modifyResourceAmount(ColonyGame.meta.tenderResource,-totalTax,false,"Tax");

                webAppCore.showDialog({
                    "title":    "Windfall Profits Tax",
                    "message":  "The evil Galactic Emperor is pleased to announce that all colonies in the galaxy are being charged a windfall profits tax!  You owe $" + numberWithCommas(totalTax) + ".  Thank you for supporting the empire.",
                    "op1": {
                        "text":     ":-(",
                        "func":     placeholder
                    }
                });
            }

        }

        if(currentGame.readOnlyMode) {
            hideSidebarIfSmall();
        }
        
        initSoundtrack();

        if(!currentGame.readOnlyMode && !currentGame.offlineMode && ColonyGame.meta.colonyServerApi != null) {
            initOnlineColony();
        } else {
            webAppCore.clearSplash();
        }
    }

    var COL_MOOD_DEPRESSION = 1;
    var COL_MOOD_HOMELESS = 2;
    var COL_MOOD_POVERTY = 3;
    var COL_MOOD_FATIGUE = 4;
    var COL_MOOD_HEALTH = 5;
    var COL_MOOD_UNEMPLOYED = 6;

    function addColoniseWoeStat(reason) {
        currentGame.sadReasons.push(reason);

        if(currentGame.sadReasons.length > 5000) {
            currentGame.sadReasons.shift();
        }
    }

    function CustomMap() {
        this.name = null;
        this.revision = 0;

        this.author = null;
        this.url = null;
        this.description = null;

        this.mapType = null;
        this.height = 100;
        this.width = 100;

        this.terrainData = [];

        this.gameVersion = 0;

        this.startX = 50;
        this.startY = 50;
    }
    
    function Game(width,height,options) {

        var i,j;

        this.stage = 0;

        this.workerPolicy = 1;

        this.mapType = options.mapType;
        this.defaultRace = options.defaultRace;
        this.civilization = options.civilization;

        this.firstSave = true;
        this.cm = false;

        this.centerBuildingId = 0;

        this.sX = 0;
        this.sY = 0;
        this.gX = 0;
        this.gY = 0;

        this.livingWageRate = 0;

        this.timeOfDay = 9;

        this.sadReasons = [];

        this.totalDeaths = 0;
        this.deadTourists = 0;
        this.totalTourists = 0;
        this.totalTourismIncome = 0;

        this.disasterCounters = {};

        this.immigrantSources = [];

        this.rewardCounter = 0;
        this.showRewardOption = false;

        this.paidWindfallTaxB = true;
        this.paidWindfallTaxC = true;
        this.paidWindfallTaxD = true;

        this.destroyedBuildings = 0;

        this.autoBudget = false;

        this.governmentLevel = 0;


        this.offlineMode = options.offline;
        this.privateCharter = false;
        this.hasCheated = false;

        this.foodRationing = false;

        this.themeColor = "#b35900";

        this.width = width;
        this.height = height;

        this.totalImmigration = 0;
        this.totalEmigration = 0;

        this.colonialTaxCollected = 0;
        this.colonies = 0;

        this.readOnlyMode = false;

        this.useCloud = false;
        this.useCompression = defaultCompressionSetting;

        this.salaries = {};

        this.lastSaveTime = Date.now();

        this.creationDate = Date.now();
        this.isIndependent = false;
        this.independenceDay = null;
        this.motherland = options.motherland;
        this.motherlandid = options.motherlandid;
        this.colonyId = 0;
        this.stopImmigration = false;
        this.foreignPayrollTotals = 0;
        this.motherlandTaxesPaid = 0;

        if(options.mapEditorDummy) {
            this.mem = true;
            this.mename = "New Map";
            this.meauthor = "";
            this.meurl = "";
            this.medescription = "";
        } else {
            this.mem = false;
            this.mename = null;
            this.meauthor = null;
            this.meurl = null;
            this.medescription = null;
        }

        this.merevision = 0;
        this.mestartx = 50;
        this.mestarty = 50;

        this.apiKey = 0;

        this.rescs = null;

        this.monthEndCounter = 0;
        this.motherlandPendingPayroll = 0;

        this.charter = 0;

        this.disableTax = options.disableTax;

        this.buildings = [];
        this.vehicles = [];
        this.colonists = [];
        this.passableNonUpdatables = [];
        this.mapResources = [];
        this.gifts = [];
        this.mail = [];
        this.tourists = [];
        this.diplomats = [];

        this.finishedPassableNonUpdatables = {};
        
        this.payrollRate = 0.25;
        this.taxLevel = 100;
        this.salesPitch = "";

        this.resources = {};
        this.utilities = {};

        this.foreignContactReference = {};
        this.pendingForeignEmbassies = [];

        this.tradeEmbargo = false;
        this.immigrationEmbargo = false;

        this.virtualAvatars = {
            "-1": {
                "id": 0,
                "represents": 0
            },
            "-2": {
                "id": 0,
                "represents": 0
            },
            "-3": {
                "id": 0,
                "represents": 0
            },
            "-4": {
                "id": 0,
                "represents": 0
            },
            "-5": {
                "id": 0,
                "represents": 0
            },
            "-6": {
                "id": 0,
                "represents": 0
            },
            "-7": {
                "id": 0,
                "represents": 0
            },
            "-8": {
                "id": 0,
                "represents": 0
            },
            "-9": {
                "id": 0,
                "represents": 0
            },
            "-10": {
                "id": 0,
                "represents": 0
            }
        };

        this.historicStats = {
            "population": [],
            "age": [],
            "savings": [],
            "gdp": [],
            "unemployment": [],
            "jobs": [],
            "health": [],
            "iq": [],
            "homeless": [],
            "approval": [],
            "workforce": [],
            "mediansalary": [],
            "retiredpop": []
        };

        this.populationStats = {};

        for(var r = 0; r < ColonyGame.races.length; r++) {
            this.populationStats[ColonyGame.races[r].name] = 0;
        }

        for(i = 0; i < ColonyGame.utilities.length; i++) {
            this.utilities[ColonyGame.utilities[i].name] = {};
            this.utilities[ColonyGame.utilities[i].name].usage = 0;
            this.utilities[ColonyGame.utilities[i].name].capacity = 0;
        }
        
        for(i = 0; i < ColonyGame.resources.length; i++) {
            this.resources[ColonyGame.resources[i].name] = {};
            this.resources[ColonyGame.resources[i].name].amount = ColonyGame.resources[i].starting;
            this.resources[ColonyGame.resources[i].name].capacity = ColonyGame.resources[i].max;
            this.resources[ColonyGame.resources[i].name].price = ColonyGame.resources[i].basePrice;
            this.resources[ColonyGame.resources[i].name].previous = 0;
            this.resources[ColonyGame.resources[i].name].storageCapacity = 0;
            this.resources[ColonyGame.resources[i].name].unlocked = false;
            this.resources[ColonyGame.resources[i].name].serverId = 0;
            this.resources[ColonyGame.resources[i].name].lastTrade = 0;
        }

        this.idCounter = 0;
        this.getId = getIdNumber;

        this.availableShelters = 0;
        this.availableTourism = 0;

        this.name = replaceAll(options.name, "\\", "");

        this.earthTaxCounter = 0;
        this.earthBackTax = 0;
        this.earthAssemblyRelations = 100;

        this.unlockedTechs = {};

        for( i = 0; i < ColonyGame.races.length; i++) {
            if(ColonyGame.races[i].name == this.defaultRace) {
                if(ColonyGame.races[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.races[i].startingTechs.length; j++) {
                        this.unlockedTechs[ColonyGame.races[i].startingTechs[j]] = true;
                    }
                }
            }
            
        }

        for( i = 0; i < ColonyGame.civilizations.length; i++) {
            if(ColonyGame.civilizations[i].name == this.civilization) {
                if(ColonyGame.civilizations[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.civilizations[i].startingTechs.length; j++) {
                        this.unlockedTechs[ColonyGame.civilizations[i].startingTechs[j]] = true;
                    }
                }
            }
            
        }

        for( i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == this.mapType) {
                if(ColonyGame.mapTypes[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.mapTypes[i].startingTechs.length; j++) {
                        this.unlockedTechs[ColonyGame.mapTypes[i].startingTechs[j]] = true;
                    }
                }
            }
            
        }
        
    }
    
    function rebuildMapResourceObject(dummy) {
        var freshResource = new MapResource(getTerrainDefByName(dummy.def),dummy.x,dummy.y,true);

        for(var prop in dummy) {
            freshResource[prop] = dummy[prop];
        }

        return freshResource;
    }
    
    function getResourceByServerId(id) {


        for(var i = 0; i < ColonyGame.resources.length; i++) {
            if(!currentGame.resources[ColonyGame.resources[i].name].serverId) {
                currentGame.resources[ColonyGame.resources[i].name].serverId = 0;
            }

            if(!currentGame.resources[ColonyGame.resources[i].name].lastTrade) {
                currentGame.resources[ColonyGame.resources[i].name].lastTrade = 0;
            }

            if(currentGame.resources[ColonyGame.resources[i].name].serverId == id) {
                return ColonyGame.resources[i];
            }
        }

        return null;
    }
    
    function MapResource(definition,x,y,isRebuild) {

        // properties
        this.dX = x;
        this.dY = y;
        this.def = definition.name;
        if(isRebuild) {
            this.id = 0;
        } else {
            this.id = currentGame.getId();
        }
        this.inventory = definition.capacity;
        this.name = definition.name;
        this.occupiesTiles = [];
        this.x = x;
        this.y = y;

        this.spreadCounter = 0;
        this.spreadMax = 0;

        this.dc = 0;

        //this.do = false;
        this.sf = -1;

        this.ul = false;

        if(definition.capacity == -1) {
            this.ul = true;
            this.inventory = 1;
        }

        this.freeRef = null;
        this.miniDef = null;
        this.playDef = null;

        this.spriteFrame = 0;

        if(definition.spreadRate > 0) {
            this.spreadMax = randomIntFromInterval(1,definition.spreadRate);
        }

        // init
        if(definition.tileWidth > 1) {
            this.dX += (definition.tileWidth - 1);
        }
        
        if(definition.tileHeight > 1) {
            this.dY += (definition.tileHeight - 1);
        }
        
        for(var oX = 0; oX < definition.tileWidth; oX++) {
            for(var oY = 0; oY < definition.tileHeight; oY++) {
                this.occupiesTiles.push({"x":x + oX,"y":y + oY});
            }
        }
    }

    function getHolderLevels(id) {
        var aHolder = Math.floor(id / 10000);
        var bHolder = Math.floor(id / 1000);
        var cHolder = Math.floor(id / 100);

        return {
            "a": aHolder,
            "b": bHolder,
            "c": cHolder
        };
    }

    function createColonistReferenceHolder(id) {

        var holders = getHolderLevels(id);

        if(!runningColonistReferenceArray[holders.a]) {
            runningColonistReferenceArray[holders.a] = {};
        }

        if(!runningColonistReferenceArray[holders.a][holders.b]) {
            runningColonistReferenceArray[holders.a][holders.b] = {};
        }

        if(!runningColonistReferenceArray[holders.a][holders.b][holders.c]) {
            runningColonistReferenceArray[holders.a][holders.b][holders.c] = {};
        }
    }

    function gooseUpColonistReferences() {
        runningColonistReferenceArray = {};
        var i,holders;

        for(i = 0; i < currentGame.tourists.length; i++) {

            createColonistReferenceHolder(currentGame.tourists[i].id);
            holders = getHolderLevels(currentGame.tourists[i].id);

            runningColonistReferenceArray[holders.a][holders.b][holders.c][currentGame.tourists[i].id] = currentGame.tourists[i];
        }

        for(i = 0; i < currentGame.colonists.length; i++) {

            createColonistReferenceHolder(currentGame.colonists[i].id);
            holders = getHolderLevels(currentGame.colonists[i].id);

            runningColonistReferenceArray[holders.a][holders.b][holders.c][currentGame.colonists[i].id] = currentGame.colonists[i];
        }

        for(i = 0; i < currentGame.diplomats.length; i++) {

            createColonistReferenceHolder(currentGame.diplomats[i].id);
            holders = getHolderLevels(currentGame.diplomats[i].id);

            runningColonistReferenceArray[holders.a][holders.b][holders.c][currentGame.diplomats[i].id] = currentGame.diplomats[i];
        }

    }

    function rebuildColonistObject(dummy) {

        var defaultRace = ColonyGame.meta.tmpDefaultRace;

        if(currentGame != null) {
            defaultRace = currentGame.defaultRace;
        }

        var freshColonist = new Colonist(dummy.x,dummy.y,true,defaultRace);

        for(var prop in freshColonist) {
            if(dummy[prop] != undefined) {
                freshColonist[prop] = dummy[prop];
            }
        }

        if(dummy.movementQueue != undefined) {
            freshColonist.mq = dummy.movementQueue;
        }

        if(isNaN(freshColonist.age)) {
            freshColonist.age = randomIntFromInterval(216,360);
        }

        

        return freshColonist;
    }

    function setupNewColonist(colonist) {
        

        colonist.money = randomIntFromInterval(0,100);
        colonist.iQ = randomIntFromInterval(40,110);
        colonist.id = currentGame.getId();
        colonist.breakThreshold = randomIntFromInterval(0,100);
        colonist.age = randomIntFromInterval(216,360);
        colonist.def.tile = getColonistTile(colonist);

        if(!colonist.race) {
            if(currentGame == null) {
                colonist.race = ColonyGame.meta.tmpDefaultRace;
            } else {
                colonist.race = currentGame.defaultRace;
            }
        }

        setColonistName(colonist);

        var holders = getHolderLevels(colonist.id);
        createColonistReferenceHolder(colonist.id);

        runningColonistReferenceArray[holders.a][holders.b][holders.c][colonist.id] = colonist;
    }

    function setColonistName(colonist) {
        var firstNameArray,lastNameArray;

        if(ColonyGame.names[colonist.race]) {
            if(ColonyGame.names[colonist.race].first) {
                firstNameArray = ColonyGame.names[colonist.race].first;
            }

            if(ColonyGame.names[colonist.race].last) {
                lastNameArray = ColonyGame.names[colonist.race].last;
            }

            if(!firstNameArray && !lastNameArray) {
                if(ColonyGame.names[colonist.race].joint) {
                    firstNameArray = ColonyGame.names[colonist.race].joint;
                    lastNameArray = ColonyGame.names[colonist.race].joint;
                }
            }
        } else {
            firstNameArray = ColonyGame.names.first;
            lastNameArray = ColonyGame.names.last;
        }

        var firstName = firstNameArray[randomIntFromInterval(0,firstNameArray.length - 1)];
        var lastName = lastNameArray[randomIntFromInterval(0,lastNameArray.length - 1)];
        colonist.name = firstName + " " + lastName;
    }

    var COL_MASK = {
        "AT_HOME": 1 << 0,
        "AT_WORK": 1 << 1,
        "IS_DIPLOMAT": 1 << 2,
        "IS_SPY": 1 << 3,
        "IS_HEALING": 1 << 4,
        "IS_PROTESTING": 1 << 5,
        "IS_RELAXING": 1 << 6,
        "IS_SIMULATED": 1 << 7,
        "IS_WANDERING": 1 << 8,
        "IS_CRIMINAL": 1 << 9,
        "IS_ILLEGAL": 1 << 10,
        "IS_TOURIST": 1 << 11,
        "IS_LEAVING_COLONY": 1 << 12,
        "IS_AWAITING_PATH": 1 << 13,
        "IS_ENTERING_STARGATE": 1 << 14
    };

    function setAwaitingPath(unit,type,value) {

        unit.a = 0;

        if(type == "colonist") {
            setColonistMask(unit,"IS_AWAITING_PATH",value);

            colonistPathOrders[unit.id] = null;
        } else {
            unit.isAwaitingPath = value;

            vehiclePathOrders[unit.id] = null;
        }
    }

    function getAwaitingPath(unit,type) {
        if(type == "colonist") {
            return getColonistMask(unit,"IS_AWAITING_PATH");
        } else {
            return unit.isAwaitingPath;
        }
    }

    function setColonistMask(colonist,setting,value) {

        if(colonist == null) {
            return;
        }

        if(value) {
            colonist.s |= COL_MASK[setting];
        } else {
            colonist.s &= ~COL_MASK[setting];
        }
    }

    function getColonistMask(colonist,setting) {
        if(colonist.s & COL_MASK[setting]) {
            return true;
        } else {
            return false;
        }
    }
    
    function Colonist(x,y,isRebuild,race) {

        if(isNaN(x) || isNaN(y)) {
            x = 1;
            y = 1;
        }

        // properties
        this.breakCount = 0;
        this.breakThreshold = 0;

        this.consumptionCounter = 0;
        this.dX = x;
        this.dY = y;
        this.def = {};
        this.destinationChanges = 0;
        this.energy = 100;
        this.energyCounter = 0;
        this.faceFrame = 0;

        this.giveUpCount = 0;
        this.happiness = 100;

        this.health = 100;
        this.house = 0;
        this.id = 0;
        this.iQ = 0;

        this.fn = 0;

        this.tc = 0;


        this.job = 0;

        this.lastX = x;
        this.lastY = y;
        this.money = 0;
        this.mq = [];
        this.name = null;
        this.statCompress = null;
        this.stepCount = 0;

        this.tX = x;
        this.tY = y;
        
        this.x = x;
        this.y = y;
        this.age = 0;

        this.venue = 0;

        

        this.race = race;
        
        this.def.tile = null;

        this.s = 0;

        this.a = 0;

    }

    var whackedVehicleKillArray;

    function rebuildVehicleObject(dummy) {
        var def = getVehicleDefByName(dummy.def);

        if(def == null) {
            whackedVehicleKillArray.push(dummy);
            return dummy;
        }

        var freshVehicle = new Vehicle(def,dummy.x,dummy.y,dummy.owner,true);

        var prop;

        for(prop in freshVehicle) {

            if(prop == "constructionQueue" || prop == "constructionCounter" || prop == "constructionPercentage" || prop == "constructionTotal" || prop == "constructionProgress") {
                
                continue;
            }

            if(dummy[prop] != undefined) {
                freshVehicle[prop] = dummy[prop];
            }
        }

        // renamed property fixer 5000
        if(dummy.inHarvestMode != undefined) {
            freshVehicle.iH = dummy.inHarvestMode;
        }

        freshVehicle.workers = [];

        return freshVehicle;
    }
    
    function Vehicle(definition,x,y,owner,isRebuild) {

        // properties
        this.breakCount = 0;
        this.breakThreshold = randomIntFromInterval(0,100);
        this.capacity = definition.capacity;
        this.choppingDestination = null;

        this.dX = x;
        this.dY = y;
        this.def = definition.name;
        this.destinationChanges = 0;
        this.faceFrame = 0;
        this.giveUpCount = 0;
        this.harvests = definition.harvests;
        if(isRebuild) {
            this.id = 0;
        } else {
            this.id = currentGame.getId();
        }
        
        this.inBuildingMode = false;

        this.isCashed = false;
        this.isDepositing = false;
        this.isInjesting = 0;
        this.isSimulated = false;

        this.iH = false;

        this.lastX = x;
        this.lastY = y;
        this.mq = [];
        this.name = definition.name + " #" + this.id;
        this.onChoppingBlock = false;
        this.owner = owner;
        this.pX = null;
        this.pY = null;
        this.stepCount = 0;
        this.storage = 0;
        this.tX = x;
        this.tY = y;
        this.x = x;
        this.y = y;

        this.lv = [];
        this.lc = [];
        this.iv = 0;
        this.it = 0;

        this.tc = 0;
        this.pd = null;
        this.ht = null;

        this.harvestAfterBuilding = false;
        
        this.blacklist = [];
        this.bBlacklist = [];

        this.isAwaitingPath = false;
        this.a = 0;
    }

    function rebuildBuildingObject(dummy) {
        var def = getBuildingDefByName(dummy.def);
        var freshBuilding = new Building(def,dummy.x,dummy.y,dummy.owner,true);

        var prop,i;

        for(prop in dummy) {

            if(prop == "generates" || prop == "generateTime" || prop == "generateAmount") {
                continue;
            }

            if(prop == "constructionQueue" || prop == "constructionCounter" || prop == "constructionPercentage" || prop == "constructionTotal" || prop == "constructionProgress") {

                if(prop == "constructionCounter") {

                    if(dummy.isUnderConstruction || dummy.constructionQueue != null) {
                        freshBuilding.c = new ConstructionItem();

                        freshBuilding.c.c = dummy.constructionCounter;
                        freshBuilding.c.p = dummy.constructionPercentage;
                        freshBuilding.c.t = dummy.constructionTotal;
                        freshBuilding.c.pr = dummy.constructionProgress;

                        if(dummy.constructionQueue != null) {
                            freshBuilding.c.q.push(dummy.constructionQueue.name);
                        }
                    }

                    
                }

                continue;
            }

            var value = dummy[prop];

            if(prop == "x" || prop == "y") {
                value = parseInt(dummy[prop]);
            }

            freshBuilding[prop] = value;
        }

        freshBuilding.workers = [];

        if(dummy.workers != null) {
            for(i = 0; i < dummy.workers.length; i++) {
                var freshWorker = new Employee();
                freshWorker.colonistId = dummy.workers[i].colonistId;
                freshWorker.isAtWork = dummy.workers[i].isAtWork;
                freshBuilding.workers.push(freshWorker);
            }
        }

        return freshBuilding;
    }

    function flipBuilding(building) {
        var def = getBuildingDefByName(building.def);

        if(!def.canFlip) {
            building.flipped = false;
            setUpMinidefForBuilding(building,false,true);
            return;
        }

        //var assetName = def.tile;

        building.flipped = !building.flipped;

        setUpMinidefForBuilding(building,false,true);

    }

    function ConstructionItem() {
        this.c = 0;
        this.p = 0;
        this.pr = null;
        this.q = [];
        this.t = 0;
    }
    
    function Building(definition,x,y,owner,isRebuild) {

        // base properties
        this.acceptsWorkers = definition.acceptsWorkers;
        this.availableHomes = 0;
        this.bedsAvailable = 0;
        this.colGenCounter = 0;
        this.colGenMax = 0;
        this.colGenPercentage = 0;

        this.c = null;

        this.sf = -1;

        this.consumptionCounter = 0;
        this.dX = x;
        this.dY = y;
        this.def = definition.name;
        this.generateAmount = definition.generateAmount;
        this.generateCounter = 0;
        this.generatePercentage = 0;
        this.generateTime = definition.generateTime;
        this.generates = definition.generates;
        this.howManyWorking = 0;

        this.embassyFor = 0;

        this.isBeingRemoved = false;

        if(isRebuild) {
            this.id = 0;
        } else {
            this.id = currentGame.getId();
        }

        this.isUnderConstruction = false;
        this.jobsAvailable = 0;
        this.lowPowerMode = false;
        this.name = definition.name + " #" + this.id;
        this.noConsumptionMode = false;
        this.occupiesTiles = [];
        this.openForEntertainment = false;
        this.openForTourism = false;
        this.owner = owner;
        this.patients = [];
        this.patrons = [];
        this.tourists = [];
        this.requiresWorkers = definition.requiresWorkers;
        this.residents = [];
        this.students = [];
        this.prisoners = [];
        this.smeltCounter = 0;
        this.someoneWorking = false;
        this.workerCheckCounter = 0;
        this.workers = [];
        this.x = x;
        this.y = y;

        this.spriteFrame = 0;

        this.condition = 100;

        this.deactivated = false;

        this.customText = "";


        // init 
        if(definition.requiresFuel != null) {
            this.consumptionCounter = definition.requiresFuel.rate;
        }

        if(definition.tileWidth > 1) {
            this.dX += (definition.tileWidth - 1);
        }
        
        if(definition.tileHeight > 1) {
            this.dY += (definition.tileHeight - 1);
        }

        this.occupiesTiles = getOccupiedTiles(this);

        
        this.flipped = false;

        this.freeRef = null;
        this.miniDef = null;
    }

    function MiniRenderDef(width,height,tile,smeltTime,transModeColor,staticRender,refines,acceptsWorkers,offlineTile,lightEffects) {
        this.width = width;
        this.height = height;
        this.tile = tile;
        this.smeltTime = smeltTime;
        this.transModeColor = transModeColor;
        this.staticRender = staticRender;
        this.refines = refines;
        this.acceptsWorkers = acceptsWorkers;
        this.offlineTile = offlineTile;
        this.lightEffects = lightEffects;
    }

    function Tile(x,y) {
        this.x = x;
        this.y = y;
    }

    function getOccupiedTiles(building) {
        var occupiedTiles = [];
        var def = getBuildingDefByName(building.def);

        if(def == null) {
            console.log(building);
        }

        for(var oX = 0; oX < def.tileWidth; oX++) {
            for(var oY = 0; oY < def.tileHeight; oY++) {
                occupiedTiles.push(new Tile(building.x + oX,building.y + oY));
            }
        }

        return occupiedTiles;
    }

    function sendVehicleToChopShop(vehicle,building) {

        

        if(!getBuildingDefByName(building.def).isChopShop) {
            return;
        }

        var availableSpaces = [];
        var newSpaces = null;
                        
        for(var j = 0; j < building.occupiesTiles.length; j++) {
            newSpaces = getFreeSpaceAroundTile(building.occupiesTiles[j].x,building.occupiesTiles[j].y,1);
            availableSpaces = availableSpaces.concat(newSpaces);
        }

        if(!newSpaces || newSpaces.length == 0) {
            return;
        }

        var destination = availableSpaces[randomIntFromInterval(0,availableSpaces.length - 1)];
        vehicle.onChoppingBlock = true;
        vehicle.dX = destination[0];
        vehicle.dY = destination[1];

        vehicle.choppingDestination = {x: destination[0],y: destination[1]};

        availableSpaces = null;
    }

    function hideSidebarIfSmall() {
        document.getElementById("sidebarCostInfoBox").style.display = "none";

        if(!desktopMode) {
            document.getElementById("sidebar").style.display = "none";
        }
    }
    
    function drawVehicle(vehicle,type) {

        if(currentViewBounds == null) {
            return;
        }

        if(gbtOpen) {
            return;
        }

        if(simulatedTileSize < 12) {
            return;
        }

        if(type == "colonist") {
            if(getColonistMask(vehicle,"AT_WORK") || getColonistMask(vehicle,"AT_HOME") || getColonistMask(vehicle,"IS_SIMULATED") || getColonistMask(vehicle,"IS_HEALING") || getColonistMask(vehicle,"IS_RELAXING")) {
                return;
            }
        }

        if(type == "colonist" && drawColonists == false) {
            return;
        }

        if(vehicle.tc > 0) {
            return;
        }


        if(vehicle.x < currentViewBounds.minX || vehicle.x > currentViewBounds.maxX) {
            if(vehicle.y < currentViewBounds.minY || vehicle.y > currentViewBounds.maxY) {
                if(vehicle != selectedColonist) {
                    return;
                }
            }
        }

        if(type == "vehicle" && vehicle.iv > 0) {
            return;
        }

        var useZ = 1;

        var drawAsset;
        var def = null;
        var i;

        if(vehicle.def.tile != null) {
            drawAsset = vehicle.def.tile;
        } else {
            def = getVehicleDefByName(vehicle.def);

            if(!def) {
                return;
            }

            drawAsset = def.tile;
        }

        if(!drawAsset || !gameAssets[drawAsset]) {
            return;
        }

        
        if(gameAssets[drawAsset][vehicle.faceFrame] === undefined) {

            if(type == "colonist") {
                vehicle.health = 0;
            }

            return;
        }

        if(vehicle == selectedColonist) {

            var healthPercentage = vehicle.health / 100;

            Scroll2d.drawSquare("rgba(0,255,0,.2)",vehicle.x,vehicle.y);
            Scroll2d.drawSprite(gameAssets[drawAsset][vehicle.faceFrame].image,vehicle.x,vehicle.y,vehicle.tX,vehicle.tY,vehicle.stepCount,healthPercentage,"#F44336",1,useZ,1,1);

            if(selectedColonist.mq != null) {
                for(i = 0; i < selectedColonist.mq.length; i++) {
                    Scroll2d.drawSquare("rgba(0,0,255,.1)",selectedColonist.mq[i].x,selectedColonist.mq[i].y,2);
                }
            }

        } else {

            var cv = null;
            var chevColor;

            if(selectedVehicle != null && selectedVehicle.length > 0 && selectedVehicle.indexOf(vehicle) > -1) {
                if(def == null) {
                    def = getVehicleDefByName(vehicle.def);
                }

                if(def.vehicleCarryCapacity > 0) {
                    if(cv == null) {
                        cv = [];
                    }

                    for(i = 0; i < def.vehicleCarryCapacity; i++) {
                        chevColor = "#0D47A1";

                        if(i < vehicle.lv.length) {
                            chevColor = "#2196F3";
                        }

                        cv.push(new Scroll2d.Chevron(chevColor,null));
                    }

                }

                if(def.colonistCarryCapacity > 0) {
                    if(cv == null) {
                        cv = [];
                    }

                    for(i = 0; i < def.colonistCarryCapacity; i++) {
                        chevColor = "#1B5E20";

                        if(i < vehicle.lc.length) {
                            chevColor = "#4CAF50";
                        }

                        cv.push(new Scroll2d.Chevron(chevColor,null));
                    }
                }
            }

            Scroll2d.drawSprite(gameAssets[drawAsset][vehicle.faceFrame].image,vehicle.x,vehicle.y,vehicle.tX,vehicle.tY,vehicle.stepCount,null,null,1,useZ,1,1,cv);
        }

        if(allowLighting && lastColorFilter != null) {
            if(type == "colonist") {
                Scroll2d.drawLight(vehicle.x,vehicle.y,0.5,"#ffffff",vehicle.tX,vehicle.tY,vehicle.stepCount,0.1);
            } else {
                Scroll2d.drawLight(vehicle.x,vehicle.y,1,"#ffffff",vehicle.tX,vehicle.tY,vehicle.stepCount);
            }
            
        }
    }

    function setUpMinidefForBuilding(building,isMapResource,forceRemake) {
        if(forceRemake || building.miniDef == null) {

            var tmpDef;
            
            var refines = null;

            var useLightEffect = null;

            if(isMapResource) {

                if(building.playDef == null) {
                    building.playDef = getTerrainDefByName(building.def);
                }

                tmpDef = building.playDef;
            } else {
                tmpDef = getBuildingDefByName(building.def);
                refines = tmpDef.refines;
            }

            if(tmpDef == null) {
                console.log("null for " + building.def);
                return;
            }

            var smeltTime = null;

            if(tmpDef.smelts != null) {
                smeltTime = tmpDef.smelts.time;
            }

            var useHeight = tmpDef.tileHeight;
            var useWidth = tmpDef.tileWidth;
            var useTile = tmpDef.tile[0];

            if(!isMapResource) {
                if(building.flipped) {
                    useHeight = tmpDef.tileWidth;
                    useWidth = tmpDef.tileHeight;
                    useTile = tmpDef.tile[0] + "-flipped";
                }
            }

            var offlineTile = null;

            if(tmpDef.tile.length > 1) {
                offlineTile = tmpDef.tile[1];

                if(building.flipped) {
                    offlineTile = tmpDef.tile[1] + "-flipped";
                }
            }

            if(tmpDef.lightEffects && tmpDef.lightEffects != null) {
                useLightEffect = tmpDef.lightEffects;
            }

            building.miniDef = new MiniRenderDef(useWidth,useHeight,useTile,smeltTime,tmpDef.transModeColor,tmpDef.canRenderStatic,refines,tmpDef.acceptsWorkers,offlineTile,useLightEffect);
        }
    }

    function drawNewPassable(def,x,y) {
        var useZ = 1;
        var passDef = passableTileRefs[def];
        var alpha = 1.0;
        var aniFrameToUse = 0;
        var tileToUse = passDef.tile[0];

        
        if(queuedBuilding != null) {
            alpha = 0.5;
        }

        if(transparencyMode == 1) {
            alpha = 0.25;
        }

        if(passDef.canRenderStatic && alpha == 1.0) {
            if(staticFrame) {
                //console.log(x + ":" + y);
                Scroll2d.drawStaticTile(gameAssets[tileToUse][0].image,x,y,useZ);
            }
        } else {
            Scroll2d.drawSprite(gameAssets[tileToUse][aniFrameToUse].image,x,y,undefined,undefined,undefined,undefined,undefined,alpha,useZ,passDef.tileWidth,passDef.tileHeight);
        }
    }
    
    function drawBuilding(building,isMapResource,type) {

        if(building.isBeingRemoved) {
            return;
        }

        if(building.occupiesTiles == null) {
            return;
        }

        if(building.miniDef == null) {
            setUpMinidefForBuilding(building,isMapResource,false);
            return;
        }

        if(currentViewBounds == null) {
            return;
        }

        if(building.x < currentViewBounds.minX || building.x > currentViewBounds.maxX) {
            if(building.y < currentViewBounds.minY || building.y > currentViewBounds.maxY) {
                return;
            }
        }
        

        var useZ = 1;
        
        var i;
        var alpha = 1.0;

        

        

        var aniFrameToUse = 0;
        var tileToUse = building.miniDef.tile;

        if(!building.miniDef.staticRender) {
            aniFrameToUse = building.spriteFrame;

            if(aniFrameToUse === undefined) {
                aniFrameToUse = 0;
                building.spriteFrame = 0;
            }
        }

        if(selectedBuilding != null || hoverBuilding != null) {
            if(building == selectedBuilding || building == hoverBuilding) {
                alpha = 0.6;
            }
        }
        
        if(queuedBuilding != null) {
            alpha = 0.5;
        }

        if(building.lowPowerMode) {
            alpha = 0.35;
            aniFrameToUse = 0;

            if(building.miniDef.offlineTile != null) {
                tileToUse = building.miniDef.offlineTile;
            }
        }

        if(building.deactivated) {
            alpha = 0.35;
            aniFrameToUse = 0;

            if(building.miniDef.offlineTile != null) {
                tileToUse = building.miniDef.offlineTile;
            }
        }

        if(building.requiresWorkers && !building.someoneWorking) {
            aniFrameToUse = 0;

            if(building.miniDef.offlineTile != null) {
                tileToUse = building.miniDef.offlineTile;
            }
        }

        if(transparencyMode == 1) {
            alpha = 0.25;
        }

        if(!allowAnimation) {
            aniFrameToUse = 0;
        }

        if(gbtOpen) {
            aniFrameToUse = 0;
        }

        if(type == "resource" && building.sf >= 0 && building.playDef != null && building.playDef.shoreSheet != null) {
            tileToUse = building.playDef.shoreSheet;
            aniFrameToUse = building.sf;
        }


        if(gbtOpen) {
            if(staticFrame) {
                Scroll2d.drawStaticTile(gameAssets[tileToUse][aniFrameToUse].image,building.dX,building.dY,useZ);
            }
            return;
        }

        if(type == "building" && transparencyMode == 2) {

            var squareColor = "rgba(255,0,0,.4)";

            if(building.miniDef.transModeColor != null) {
                var rawcolor = hexToColor(building.miniDef.transModeColor);
                squareColor = "rgba(" + rawcolor.r + "," + rawcolor.g + "," + rawcolor.b + ",.4)";
            }

            for(i = 0; i < building.occupiesTiles.length; i++) {
                Scroll2d.drawSquare(squareColor,building.occupiesTiles[i].x,building.occupiesTiles[i].y,3);
            }

            return;
        }

        if(building.isUnderConstruction) {
            for(i = 0; i < building.occupiesTiles.length; i++) {
                if(building.occupiesTiles[i].x == building.x && building.occupiesTiles[i].y == building.y) {
                    Scroll2d.drawSprite(gameAssets[ColonyGame.meta.constructionTile][0].image,building.occupiesTiles[i].x,building.occupiesTiles[i].y,null,null,null,building.c.p,"#2196F3",1.0,useZ,1,1);
                } else {
                    Scroll2d.drawSprite(gameAssets[ColonyGame.meta.constructionTile][0].image,building.occupiesTiles[i].x,building.occupiesTiles[i].y,undefined,undefined,undefined,undefined,undefined,1.0,useZ,1,1);
                }
            }
        } else {

            if(inHireMode) {
                
                if(building.acceptsWorkers > 0 && building.acceptsWorkers > building.workers.length) {
                    for(i = 0; i < building.occupiesTiles.length; i++) {
                        Scroll2d.drawSquare("rgba(0,255,0,.4)",building.occupiesTiles[i].x,building.occupiesTiles[i].y,2);
                    }
                }

            }

            i = 8;

            if(building.c != null) {

                var cv = null;

                if(building.c.q != null && building.c.q.length > 0) {
                    cv = [];

                    var make = building.c.q.length - 1;

                    while(make > 0) {
                        cv.push(new Scroll2d.Chevron("#2196F3",null));
                        make--;
                    }
                }

                Scroll2d.drawSprite(gameAssets[tileToUse][aniFrameToUse].image,building.x,building.y,null,null,null,building.c.p,"#2196F3",alpha,useZ,building.miniDef.width,building.miniDef.height,cv);
            } else {

                var showMeter = false;
                var generateColor = "#ffffff";
                var generatePercentage = 0;

                if(selectedBuilding != null || hoverBuilding != null) {
                    if(building == selectedBuilding || building == hoverBuilding) {
                        if(building.generates != null) {
                            showMeter = true;
                            generateColor = getResourceByDefName(building.generates).color;
                            generatePercentage = building.generatePercentage;
                        }

                        if(building.colGenPercentage && building.colGenPercentage > 0) {
                            showMeter = true;
                            generatePercentage = building.colGenPercentage;
                            generateColor = "#ffffff";
                        }

                        if(building.miniDef.smeltTime != null) {
                            

                            if(getBuildingDefByName(building.def).smelts.output != null) {
                                showMeter = true;
                                generateColor = getResourceByDefName(getBuildingDefByName(building.def).smelts.output.split("|")[0]).color;
                                generatePercentage = building.smeltCounter / building.miniDef.smeltTime;
                            }

                            
                        }

                        var surroundingFree = getFreeSpacesAroundBuilding(building,1,false);
                        if(surroundingFree) {
                            while(surroundingFree.length > 0) {
                                var square = surroundingFree.shift();
                                Scroll2d.drawSquare("rgba(0,255,0,.1)",square[0],square[1],2);
                            }
                        }
                    }
                }

                if(showMeter) {
                    Scroll2d.drawSprite(gameAssets[tileToUse][aniFrameToUse].image,building.x,building.y,null,null,null,generatePercentage,generateColor,alpha,useZ,building.miniDef.width,building.miniDef.height);
                } else {
                    if(building.miniDef.staticRender && alpha == 1.0) {
                        if(staticFrame) {
                            Scroll2d.drawStaticTile(gameAssets[tileToUse][0].image,building.dX,building.dY,useZ);
                        }
                    } else {

                        Scroll2d.drawSprite(gameAssets[tileToUse][aniFrameToUse].image,building.x,building.y,undefined,undefined,undefined,undefined,undefined,alpha,useZ,building.miniDef.width,building.miniDef.height);


                    }
                }

            }

        }

        if(allowLighting && building.miniDef.lightEffects != null) {
            if(!building.isUnderConstruction && !building.lowPowerMode) {
                for(i = 0; i < building.miniDef.lightEffects.length; i++) {
                    var effect = building.miniDef.lightEffects[i];

                    if(effect.nightonly && lastColorFilter == null) {
                        continue;
                    }

                    var lx = building.x + effect.x;
                    var ly = building.y + effect.y;

                    if(building.flipped) {
                        lx = building.x + effect.y;
                        ly = building.y + effect.x;
                    }

                    Scroll2d.drawLight(lx,ly,effect.r,effect.c,null,null,null,effect.i);
                }
            }
        }
    }
    
    function moveVehicle(x,y,vehicle) {

        vehicle.mq = [];
        
        vehicle.breakCount = vehicle.breakThreshold;

        var def = getVehicleDefByName(vehicle.def);

        if(def.vehicleCarryCapacity == 0) {
            // see if we are moving into another vehicle

            for(var i = 0; i < currentGame.vehicles.length; i++) {
                if(currentGame.vehicles[i].x == x && currentGame.vehicles[i].y == y) {

                    var tDef = getVehicleDefByName(currentGame.vehicles[i].def);

                    if(tDef.vehicleCarryCapacity > 0 && tDef.vehicleCarryCapacity > currentGame.vehicles[i].lv.length) {
                        sendVehicleToVehicle(vehicle,currentGame.vehicles[i]);
                        break;
                    }

                }
            }
        }

        

        vehicle.dX = x;
        vehicle.dY = y;
    }

    var tmpBuildingRef;

    function showPremiumMessage(title) {
        var i;

        if(!title) {
            title = "Premium";
        }

        var premMsg = getString(ColonyGame.messages.premiumNotice);
            
        var totalPremiumItems = 0;

        for(i = 0; i < ColonyGame.buildings.length; i++) {
            if(ColonyGame.buildings[i].requiPremium) {
                totalPremiumItems++;
            }
        }

        for(i = 0; i < ColonyGame.vehicles.length; i++) {
            if(ColonyGame.vehicles[i].requiPremium) {
                totalPremiumItems++;
            }
        }

        for(i = 0; i < ColonyGame.technology.length; i++) {
            if(ColonyGame.technology[i].requiPremium) {
                totalPremiumItems++;
            }
        }

        premMsg = replaceAll(premMsg,"#premiumcount",totalPremiumItems.toString());


        webAppCore.showDialog({
            "title":    title,
            "message":  premMsg,
            "op1": {
                "text":     getString("general-yes"),
                "func":     presentPremiumUpgrade
            },
            "op2": {
                "text":     getString("general-no"),
                "func":     placeholder
            }
        });
    }

    function initConstruction(buildRef) {

        selectedBuilding = null;
        selectedVehicle = [];

        cooldownGamepad();

        if(currentGame == null || buildRef == null) {
            return;
        }

        if(buildRef.requiPremium && !webAppCore.getIsPremium()) {

            
            showPremiumMessage(buildRef.name);

            return;
        }

        var canAfford = true;
        var j;

        for(j = 0; j < buildRef.cost.length; j++) {
            if(buildRef.cost[j].amount > currentGame.resources[buildRef.cost[j].resource].amount) {
                canAfford = false;
            }
        }

        if(currentGame.cm) {
            canAfford = true;
        }

        if(!canAfford) {
            webAppCore.showAlertWithTitle(getString("general-cant-afford"),"Cannot Afford");
            return;
        }

        if(tmpBuildingRef != null) {
            doConstruction(buildRef,tmpBuildingRef);
        } else {
            showBuildConfirm();
            buildingConstruction(buildRef);
        }
    }

    function presentPremiumUpgrade() {
        webAppCore.presentPremium();
    }
    
    function doConstruction(buildRef,building) {

        

        tmpBuildingRef = null;

        if(buildRef.requiPremium && !webAppCore.getIsPremium()) {
            showPremiumMessage(buildRef.name);
            return;
        }

        if(building.c == null) {
            building.c = new ConstructionItem();
        }

        building.c.q.push(buildRef.name);


    }
    
    function buildingConstruction(buildRef) {
        queuedBuilding = buildRef;
    }

    function reninitColonist(colonist) {
        if(colonist.statCompress != null) {
            colonistStatRestore(colonist);
        }

        if(isNaN(colonist.house)) {
            colonist.house = 0;
            setColonistMask(colonist,"AT_HOME",false);
        }


        if(isNaN(colonist.energyCounter)) {
            colonist.energyCounter = 0;
        }

        // new flag fixer 5000
        if(colonist.isAtHome != undefined) {
            setColonistMask(colonist,"AT_HOME",colonist.isAtHome);
        }
        if(colonist.isAtWork != undefined) {
            setColonistMask(colonist,"AT_WORK",colonist.isAtWork);
        }
        if(colonist.isDepositing != undefined) {
            setColonistMask(colonist,"IS_DEPOSITING",colonist.isDepositing);
        }
        if(colonist.isHealing != undefined) {
            setColonistMask(colonist,"IS_HEALING",colonist.isHealing);
        }
        if(colonist.isProtesting != undefined) {
            setColonistMask(colonist,"IS_PROTESTING",colonist.isProtesting);
        }
        if(colonist.isRelaxing != undefined) {
            setColonistMask(colonist,"IS_RELAXING",colonist.isRelaxing);
        }
        if(colonist.isSimulated != undefined) {
            setColonistMask(colonist,"IS_SIMULATED",colonist.isSimulated);
        }
        if(colonist.isWandering != undefined) {
            setColonistMask(colonist,"IS_WANDERING",colonist.isWandering);
        }
        if(colonist.isTourist != undefined) {
            setColonistMask(colonist,"IS_TOURIST",colonist.isTourist);
        }

        colonist.mq = [];
    }

    
    
    function updateColonist(colonist) {

        if(getColonistMask(colonist,"IS_SIMULATED") && !simUpdateCycle) {
            return;
        }

        if(currentGame.readOnlyMode) {
            setColonistMask(colonist,"IS_WANDERING",true);
        }   

        if(!getColonistMask(colonist,"IS_SIMULATED") && (colonist.tX != colonist.x || colonist.tY != colonist.y)) {
            var driveSpeed = 0.5;
            colonist.stepCount += driveSpeed;
            if(colonist.stepCount >= 20) {
                colonist.stepCount = 0;
                colonist.giveUpCount = 0;
                colonist.x = colonist.tX;
                colonist.y = colonist.tY;
            }
        } else {
            if(colonist.dX != colonist.x || colonist.dY != colonist.y) {
                handleUnitMovement(colonist,"colonist");
            } else {
                setAwaitingPath(colonist,"colonist",false);
                if(getColonistMask(colonist,"IS_WANDERING")) {
                    var rX = randomIntFromInterval(1,currentGame.width - 2);
                    var rY = randomIntFromInterval(1,currentGame.height - 2);

                    if(isTilePassable(rX,rY,false)) {
                        colonist.tX = colonist.x;
                        colonist.tY = colonist.y;
                        colonist.dX = rX;
                        colonist.dY = rY;
                        colonist.mq = [];
                    }
                }
            }
        }

        colonist.consumptionCounter++;

        if(colonist.consumptionCounter >= 500) {
            colonist.consumptionCounter = 0;
            handleColonistConsumption(colonist);
        }

        // Handle energy gain/loss
        colonist.energyCounter++;
        if(colonist.energyCounter >= 400) {
            colonist.energyCounter = 0;
            handleColonistEnergy(colonist);
        }

        if(colonist.x == colonist.dX && colonist.y == colonist.dY) {
            handleColonistRioting(colonist);
            handleTourist(colonist);
            handleEntertainment(colonist);
            handleColonistWorkIntro(colonist);
            handleMedical(colonist);
            handleColonistHomeIntro(colonist);
        }

        normalizeColonistStats(colonist);

        if(!getColonistMask(colonist,"AT_WORK") && !getColonistMask(colonist,"AT_HOME") && !getColonistMask(colonist,"IS_RELAXING") && !getColonistMask(colonist,"IS_HEALING")) {
            if(colonist.x == colonist.dX && colonist.y == colonist.dY) {
                if(colonist.health > 75 && colonist.happiness > 75) {
                    if(colonist.job == 0) {
                        setColonistMask(colonist,"IS_WANDERING",true);
                    } else {
                        if(colonist.energy > 75) {
                            setColonistMask(colonist,"IS_WANDERING",false);
                        }
                    }
                    
                }
            }
        }

        colonist = null;
    }

    function normalizeColonistStats(colonist) {
        if(colonist.energy > 100) {
            colonist.energy = 100;
        }

        if(colonist.energy < 0) {
            colonist.energy = 0;
        }

        if(colonist.happiness < 0) {
            colonist.happiness = 0;
        }

        if(colonist.happiness > 100) {
            colonist.happiness = 100;
        }

        

        if(isNaN(colonist.money)) {
            colonist.money = 0;
        }

        if(colonist.money < 0) {
            colonist.money = 0;
        }
    }

    function handleColonistEnergy(colonist) {

        if(currentGame.readOnlyMode) {
            return;
        }

        var modAmount = 1;

        if(getColonistMask(colonist,"IS_SIMULATED")) {
            modAmount = simUpdateMax;
        }

        if(!getColonistMask(colonist,"IS_RELAXING")) {
            colonist.energy -= modAmount;
        }

        if(getColonistMask(colonist,"AT_WORK")) {
            colonist.energy -= modAmount;
        } 
        
        if(getColonistMask(colonist,"AT_HOME")) {
            colonist.energy += (5 * modAmount);
        }

        if(colonist.health < 50) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_HEALTH);
        }

        if(colonist.health < 15) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_HEALTH);
        }

        if(colonist.energy < 40) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_FATIGUE);
        }

        if(colonist.energy < 25) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_FATIGUE);
        }

        if(colonist.energy < 10) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_FATIGUE);
        }

        if(colonist.money < 15) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_POVERTY);
        }

        if(colonist.money == 0) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_POVERTY);
        }

        if(colonist.house == 0) {
            colonist.happiness -= modAmount;
            addColoniseWoeStat(COL_MOOD_HOMELESS);
        }

        if(colonist.job == 0 && colonist.money < gotItMadePrice) {
            var sadPoorChance = randomIntFromInterval(0,5);

            if(sadPoorChance == 2) {
                colonist.happiness -= modAmount;
                addColoniseWoeStat(COL_MOOD_POVERTY);
                addColoniseWoeStat(COL_MOOD_UNEMPLOYED);
            }
        }

        if(colonist.money > (gotItMadePrice / 2)) {
            colonist.happiness += modAmount;
        }

        if(colonist.money > gotItMadePrice) {
            colonist.happiness += modAmount;
        }

        if(colonist.money > gotItMadePrice * 2) {
            colonist.happiness += modAmount;
        }

        if(colonist.health > 95) {
            colonist.happiness += modAmount;
        }

        // 50 yrs
        if(colonist.age > 600) {
            colonist.energy -= randomIntFromInterval(0,(modAmount * 2));
        }

        // 60 yrs
        if(colonist.age > 720) {
            colonist.energy -= randomIntFromInterval(0,(modAmount * 2));
        }

        // 70 yrs
        if(colonist.age > 840) {
            colonist.energy -= randomIntFromInterval(0,(modAmount * 2));
        }

        var topLevel;

        // chance to protest 

        if(!getColonistMask(colonist,"IS_DIPLOMAT") && !getColonistMask(colonist,"IS_TOURIST")) {
            if(colonist.happiness < 20 && !getColonistMask(colonist,"IS_PROTESTING")) {

                topLevel = 120;

                if(colonist.happiness < 5) {
                    topLevel = 30;
                }

                if(colonist.happiness < 1) {
                    topLevel = 5;
                }

                addColoniseWoeStat(COL_MOOD_DEPRESSION);

                var riotChance = randomIntFromInterval(0,topLevel);
                if(riotChance == 2) {
                    setColonistMask(colonist,"IS_PROTESTING",true);

                    // chance to unsimulate 
                    if(getColonistMask(colonist,"IS_SIMULATED")) {
                        riotChance = randomIntFromInterval(0,20);
                        if(riotChance == 2) {
                            setColonistMask(colonist,"IS_SIMULATED",false);
                        }
                    }
                }
            }

            // chance to gtfo on a stargate 
            if(hasStargate) {
                topLevel = 1500;

                if(colonist.happiness < 5) {
                    topLevel -= 500;
                }

                if(colonist.happiness < 1) {
                    topLevel -= 250;
                }

                if(colonist.money < 5) {
                    topLevel -= 250;
                }

                var bailChance = randomIntFromInterval(0,topLevel);

                if(bailChance == 2) {
                    setColonistMask(colonist,"IS_ENTERING_STARGATE",true);
                }
            }
        }
    }

    function handleColonistConsumption(colonist) {
        
        if(currentGame.readOnlyMode) {
            return;
        }

        var modAmount = 1;

        if(getColonistMask(colonist,"IS_SIMULATED")) {
            modAmount = simUpdateMax;
        }

        var hungerAmount = modAmount;

        var shouldEat = true;

        if(currentGame.foodRationing) {
            var chance = randomIntFromInterval(0,10);

            if(chance > 3) {
                shouldEat = false;
            }
        }

        if(shouldEat) {
            if(currentGame.resources[ColonyGame.meta.colonistsEat].amount >= hungerAmount) {

                modifyResourceAmount(ColonyGame.meta.colonistsEat,-hungerAmount,false,"Colonist");
            } else {
                colonist.health -= modAmount;
            }

            if(currentGame.resources[ColonyGame.meta.colonistsDrink].amount >= hungerAmount) {

                modifyResourceAmount(ColonyGame.meta.colonistsDrink,-hungerAmount,false,"Colonist");
            } else {
                colonist.health -= modAmount;
            }
        } else {
            colonist.health -= (modAmount * 2);
        }

        if(!getColonistMask(colonist,"IS_TOURIST") && colonist.energy <= 0) {
            colonist.health -= modAmount;
        }

        // 60yrs
        if(colonist.age > 720) {
            colonist.health -= randomIntFromInterval(0,(modAmount * 2));
        }

        // 70yrs
        if(colonist.age > 840) {
            colonist.health -= randomIntFromInterval(0,(modAmount * 2));
        }

        // 80yrs
        if(colonist.age > 960) {
            colonist.health -= randomIntFromInterval(0,(modAmount * 2));
        }

        if(getColonistMask(colonist,"IS_HEALING")) {
            colonist.health += (5 * modAmount);
        }

        if(colonist.health > 100) {
            colonist.health = 100;
        }

        if(getColonistMask(colonist,"IS_RELAXING")) {
            colonist.happiness += 10;
        }

        if(colonist.happiness > 100) {
            colonist.happiness = 100;
        }

        // slight chance to get a little wiser with age 
        if(colonist.iQ < 200) {
            var wisechance = randomIntFromInterval(0,1000);
            if(wisechance == 5) {
                colonist.iQ++;
            }
        }
    }

    function handleColonistHomeIntro(colonist) {

        if(getColonistMask(colonist,"IS_TOURIST")) {
            return;
        }

        var homeEnergy = 100;
        var homeHealth = 25;
        var goHomeEnergyLevel = 55;

        if(currentGame.workerPolicy == 0) {
            homeEnergy = 100;
            homeHealth = 40;
            goHomeEnergyLevel = 60;
        }

        if(currentGame.workerPolicy == 2) {
            homeEnergy = 75;
            homeHealth = 20;

            if(colonist.job > 0) {
                goHomeEnergyLevel = 40;
            }
        }

        if(currentGame.workerPolicy == 3) {
            homeEnergy = 25;
            homeHealth = 0;

            if(colonist.job > 0) {
                goHomeEnergyLevel = 5;
            }
        }

        if(colonist.house == 0 && openHomesArray != null && openHomesArray.length > 0) {
            findAHouse(colonist);
        }

        if(getColonistMask(colonist,"AT_HOME") && (colonist.energy >= homeEnergy || colonist.health < homeHealth)) {
            setColonistMask(colonist,"AT_HOME",false);

            if(colonist.job > 0) {
                setColonistMask(colonist,"IS_WANDERING",false);
            }
        }

        if(!getColonistMask(colonist,"IS_RELAXING") && !getColonistMask(colonist,"IS_HEALING") && !getColonistMask(colonist,"AT_WORK") && !getColonistMask(colonist,"AT_HOME") && colonist.energy < goHomeEnergyLevel) {
            setColonistMask(colonist,"IS_WANDERING",false);

            if(colonist.x == colonist.dX && colonist.y == colonist.dY) {
                handleColonistHome(colonist);
            }
        }
    }

    function handleColonistWorkIntro(colonist) {

        if(getColonistMask(colonist,"IS_TOURIST")) {
            return;
        }

        var workEnergy = 30;
        var workHealth = 60;
        var goWorkEnergy = 50;
        var goWorkHappiness = 10;

        if(currentGame.workerPolicy == 0) {
            workEnergy = 60;
            workHealth = 80;
            goWorkHappiness = 50;
            goWorkEnergy = 70;
        }

        if(currentGame.workerPolicy == 2) {
            workEnergy = 15;
            workHealth = 30;
            goWorkHappiness = 10;
        }

        if(currentGame.workerPolicy == 3) {
            workEnergy = 0;
            workHealth = 0;
            goWorkEnergy = 0;
            goWorkHappiness = 0;
        }

        if(colonist.job == 0 && openJobsArray != null && openJobsArray.length > 0) {
            findAJob(colonist);
        }

        if(getColonistMask(colonist,"IS_PROTESTING") || (getColonistMask(colonist,"AT_WORK") && (colonist.energy < workEnergy || colonist.health < workHealth))) {
            setColonistMask(colonist,"AT_WORK",false);
            
            if(colonist.house > 0) {
                setColonistMask(colonist,"IS_WANDERING",false);
            }

            if(colonist.job > 0) {
                var building = getBuildingById(colonist.job);

                if(building == null || building.deactivated) {
                    removeWorker(building,colonist,"h");
                    return;
                }

                if(building != null) {
                    for(var i = 0; i < building.workers.length; i++) {
                        if(building.workers[i].colonistId == colonist.id) {
                            building.workers[i].isAtWork = false;
                            return;
                        }
                    }
                }
            }

            return;
        }
        
        if(!getColonistMask(colonist,"IS_RELAXING") && !getColonistMask(colonist,"IS_HEALING") && !getColonistMask(colonist,"AT_WORK") && !getColonistMask(colonist,"AT_HOME") && colonist.energy >= goWorkEnergy && colonist.happiness > goWorkHappiness) {
            setColonistMask(colonist,"IS_WANDERING",false);

            if(colonist.x == colonist.dX && colonist.y == colonist.dY) {
                handleColonistWork(colonist);
            }
        }
    }

    function checkForPathSimulation(unit,type,x2,y2) {
        var sourceVisible = Scroll2d.checkVisibility(unit.x,unit.y);
        var destVisible = Scroll2d.checkVisibility(x2,y2);
        
        if(gbtOpen || inBackgroundMode) {
            sourceVisible = false;
            destVisible = false;
        }

        if(!sourceVisible && !destVisible) {
            var a = unit.x - x2;
            var b = unit.y - y2;
            var distance = Math.sqrt( a*a + b*b );

            var driveSpeed = 0.5;

            if(type == "vehicle") {
                driveSpeed = 2;
            }

            var usetc = Math.round((distance * 20) / driveSpeed);

            unit.tc = usetc;

            return true;
        }

        return false;
    }

    function checkPathThreaded(unit,type,x2,y2) {

        if(isNaN(x2) || isNaN(y2)) {
            return;
        }


        if(checkForPathSimulation(unit,type,x2,y2)) {
            return;
        }

        var useCr = null;

        if(type == "vehicle") {
            vehiclePathOrders[unit.id] = null;

            

            var unitDef = getVehicleDefByName(unit.def);

            if(unitDef.isFlying) {
                useCr = flyingCollisionReference;
            }

            

        } else {
            colonistPathOrders[unit.id] = null;
        }

        setAwaitingPath(unit,type,true);

        var retainedPath = getRetainedPath(unit.x,unit.y,x2,y2);

        if(retainedPath != null) {

            if(type == "vehicle") {
                vehiclePathOrders[unit.id] = retainedPath;
            } else {
                colonistPathOrders[unit.id] = retainedPath;
            }

            return;
        }

        var pathMessage = {
            "method": "checkPath",
            "data": {
                "x1": unit.x,
                "y1": unit.y,
                "x2": x2,
                "y2": y2,
                "type": type,
                "id": unit.id,
                "cr": useCr
            }
        };

        pathWorker1.postMessage(pathMessage);

    }

    function checkPathsThreaded(unit,type,paths) {

        var useCr = null;

        setAwaitingPath(unit,type,true);

        if(type == "vehicle") {
            vehiclePathOrders[unit.id] = null;

            var unitDef = getVehicleDefByName(unit.def);
            
            if(unitDef.isFlying) {
                useCr = flyingCollisionReference;
            }
        } else {
            colonistPathOrders[unit.id] = null;
        }

        var wasretained = false;

        for(var i = 0; i < paths.length; i++) {

            if(checkForPathSimulation(unit,type,paths[i].x,paths[i].y)) {
                return;
            }

            var retainedPath = getRetainedPath(unit.x,unit.y,paths[i].x,paths[i].y);
            
            if(retainedPath != null) {

                if(type == "vehicle") {
                    vehiclePathOrders[unit.id] = retainedPath;
                } else {
                    colonistPathOrders[unit.id] = retainedPath;
                }
    
                break;
            }
        }

        if(wasretained) {
            paths = null;
            return;
        }


        var sendData = [];

        while(paths.length > 0) {

            var dest = paths.shift();

            if(isNaN(dest.x) || isNaN(dest.y)) {
                continue;
            }

            sendData.push({
                "x1": unit.x,
                "y1": unit.y,
                "x2": dest.x,
                "y2": dest.y,
                "type": type,
                "id": unit.id,
                "cr": useCr
            });
        }

        pathWorker1.postMessage({
            "method": "checkPaths",
            "data": sendData
        });

    }

    function handleUnitMovement(unit,type) {


        if(collisionReference == null) {
            return;
        }

        if(type == "vehicle" && unit.iv > 0) {
            return;
        }

        var vdef = null;

        if(unit.x == unit.dX && unit.y == unit.dY) {
            setAwaitingPath(unit,type,false);
            unit.tX = unit.x;
            unit.tY = unit.y;
            unit.tc = 0;

            if(isTilePassable(unit.x,unit.y,false)) {
                unstickUnit(unit);
            }

            return;
        }

        if(type == "colonist" && (getColonistMask(unit,"IS_SIMULATED") || !drawColonists)) {
            setAwaitingPath(unit,type,false);
            unit.x = unit.dX;
            unit.y = unit.dY;
            unit.tX = unit.x;
            unit.tY = unit.y;
            unit.stepCount = 0;
            unit.giveUpCount = 0;
	        unit.tc = 0;
            return;
        }

        if(unit.tc > 0) {

            setAwaitingPath(unit,type,false);

            unit.tc--;

            if(unit.tc <= 0) {
                unit.x = unit.dX;
                unit.y = unit.dY;
                unit.tX = unit.x;
                unit.tY = unit.y;
                unit.stepCount = 0;
                unit.giveUpCount = 0;
		        unit.tc = 0;
            }

            return;
        }

        var hasGivenUp = false;

        if(getAwaitingPath(unit,type)) {

            if(type == "vehicle") {
                if(vehiclePathOrders[unit.id] == null) {

                    unit.a++;


                    if(unit.a < 10) {
                        return;
                    }
                    
                    hasGivenUp = true;
                    setAwaitingPath(unit,type,false);
                    
                } else {

                    unit.mq = vehiclePathOrders[unit.id];
                    vehiclePathOrders[unit.id] = null;

                    if(unit.mq.length > 0) {
                        unit.dX = unit.mq[unit.mq.length - 1].x;
                        unit.dY = unit.mq[unit.mq.length - 1].y;
                    }
                    setAwaitingPath(unit,type,false);

                    if(unit.inBuildingMode) {
                        if(unit.mq.length == 0) {

                            unit.inBuildingMode = false;
                    
                            if(unit.harvestAfterBuilding) {
                                unit.harvestAfterBuilding = false;
                                unit.iH = true;
                            } else {
                                parkVehicle(unit);
                            }
                        }
                    }
                }
            } else {
                if(colonistPathOrders[unit.id] == null) {
                    unit.a++;

                    if(unit.a < 30) {
                        return;
                    }
                    
                    hasGivenUp = true;
                    setAwaitingPath(unit,type,false);

                    //return;
                } else {
                    unit.mq = colonistPathOrders[unit.id];
                    colonistPathOrders[unit.id] = null;

                    if(unit.mq.length > 0) {
                        unit.dX = unit.mq[unit.mq.length - 1].x;
                        unit.dY = unit.mq[unit.mq.length - 1].y;
                    }
                
                    setAwaitingPath(unit,type,false);
                }
            }

        }

        var needsToRebuildPath = false;

        /*
        if(unit.mq.length == 0) {
            needsToRebuildPath = true;
        }
        */

        var flyingUnit = false;

        if(type == "vehicle") {
            vdef = getVehicleDefByName(unit.def);

            if(vdef.isFlying) {
                flyingUnit = true;
            }
        }
        
        if(unit.mq.length > 0) {

            if(!needsToRebuildPath && (unit.mq[unit.mq.length - 1].x != unit.dX || unit.mq[unit.mq.length - 1].y != unit.dY)) {
                needsToRebuildPath = true;
            }

            if(!needsToRebuildPath && !isTilePassable(unit.mq[0].x,unit.mq[0].y,false,flyingUnit)) {

                unit.dX = unit.x;
                unit.dY = unit.y;

                if(type == "vehicle") {

                    unit.giveUpCount++;

                    

                    if(unit.giveUpCount > 4) {
                        unit.inBuildingMode = false;
                        
                        if(unit.ht != null) {
                            unit.blacklist.push(unit.ht);
                        }

                        unit.ht = null;

                        unit.giveUpCount = 0;
                    } else {
                        needsToRebuildPath = true;
                    }

                }

                shouldUpdateCollissionMap = true;

                /*
                shouldUpdateCollissionMap = true;
                needsToRebuildPath = true;
                */
            }
        
        } else {
            needsToRebuildPath = true;
        }

        if(needsToRebuildPath) {
            unit.tX = unit.x;
            unit.tY = unit.y;
            unit.mq = [];
            checkPathThreaded(unit,type,unit.dX,unit.dY);
            
            if(!hasGivenUp) {
                return;
            }
        }
        
        if(getAwaitingPath(unit,type) && !hasGivenUp) {
            return;
        }
        
        //console.log("hrmm");
        
        unstickUnit(unit);
        
        if(unit.mq.length > 0) {

            var destination = unit.mq.shift();
            
            if(unit.breakCount >= unit.breakThreshold || (destination.x != unit.lastX || destination.y != unit.lastY)) {
                unit.tX = destination.x;
                unit.tY = destination.y;
                
                if(unit.tX > unit.x) {
                    unit.faceFrame = 1;
                }
                
                if(unit.tX < unit.x) {
                    unit.faceFrame = 3;
                }
                
                if(unit.tY > unit.y) {
                    unit.faceFrame = 0;
                }
                
                if(unit.tY < unit.y) {
                    unit.faceFrame = 2;
                }
                
                unit.lastX = unit.x;
                unit.lastY = unit.y;
                unit.breakCount = 0;
            } else {
                unit.breakCount++;
            }

            destination = null;

            //cashedNodes.push(destination);

        } else {

            if(isNaN(unit.giveUpCount)) {
                unit.giveUpCount = 0;
            }

            unit.giveUpCount++;

            if(unit.giveUpCount >= 40) {

                if(unit.type == "vehicle") {
                    if(unit.pX != null && unit.pY != null) {
                        if(unit.dX == unit.pX && unit.dY == unit.pY) {
                            unit.pX = null;
                            unit.pY = null;
                        } else {
                            parkVehicle(unit);
                            return;
                        }
                    } 
                }

                var choices = getFreeSpaceAroundTile(unit.dX,unit.dY,2);

                if(choices.length > 0) {
                    var rndPosition = choices[randomIntFromInterval(0,choices.length - 1)];
                    unit.dX = rndPosition[0];
                    unit.dY = rndPosition[1];

                    if(isNaN(unit.destinationChanges)) {
                        unit.destinationChanges = 0;
                    }

                    unit.destinationChanges++;

                    // total abort!
                    if(unit.destinationChanges > 5) {
                        unit.dX = unit.x;
                        unit.dY = unit.y;
                        unit.destinationChanges = 0;
                    }

                } else {
                    unit.dX = unit.x;
                    unit.dY = unit.y;
                }

                unit.giveUpCount = 0;

                
                unit.tX = unit.x;
                unit.tY = unit.y;
                unit.stepCount = 0;
            }
        }

    }

    function unstickUnit(unit) {

        if(isTilePassable(unit.x,unit.y,false)) {
            return false;
        }

        if(isTilePassable(unit.tX,unit.tY,false)) {
            return false;
        }

        // if the unit got stuck somehow, fix him
        var unitFree = false;
        var passRadius = 1;

        while(!unitFree) {
            var choices = getFreeSpaceAroundTile(unit.x,unit.y,passRadius);
            var rndPosition = choices[randomIntFromInterval(0,choices.length - 1)];

            if(!rndPosition) {
                passRadius++;

                if(passRadius > 20) {
                    setColonistMask(unit,"IS_SIMULATED",true);
                    return false;
                }

                continue;
            }

            if(isTilePassable(unit.tX,unit.tY,false)) {
                return false;
            }

            if(!isTilePassable(unit.dX,unit.dY,false)) {
                unit.dX = unit.x;
                unit.dY = unit.y;
                unit.tX = unit.x;
                unit.tY = unit.y;
            } else {
                unit.tX = rndPosition[0];
                unit.tY = rndPosition[1];
            }

            unitFree = true;
        }

        if(!unit.inBuildingMode) {
            parkVehicle(unit);
        }

        return true;
    }

    function handleColonistHome(colonist) {
        var building = getBuildingById(colonist.house);

        if(building == null || building.deactivated) {
            removeResident(building,colonist);
            return;
        }

        if(building == null) {
            colonist.house = 0;
            setColonistMask(colonist,"AT_HOME",false);
            return;
        }

        if(getColonistMask(colonist,"IS_SIMULATED")) {
            colonist.x = building.x;
            colonist.y = building.y;
            colonist.dX = colonist.x;
            colonist.dY = colonist.y;
            colonist.tX = colonist.x;
            colonist.tY = colonist.y;
        } else {
            var distance = sendUnitToBuilding(colonist,building);

            if(distance > 1) {
                return;
            }

            if(distance == -1) {
                removeResident(building,colonist);
                return;
            }
        }

        setColonistMask(colonist,"AT_HOME",true);
    }

    function getForeignContactByName(name) {

        for(var prop in currentGame.foreignContactReference) {
            if(currentGame.foreignContactReference[prop].name == name) {
                return currentGame.foreignContactReference[prop];
            }
        }

        return null;
    }

    function sendUnitToBuilding(unit,building,terrain) {

        if(building == null) {
            console.log("sending unit to null building???");
            return -1;
        }

        var targetParameter = getFreeSpacesAroundBuilding(building,1,false,terrain);

        

        if(targetParameter.length == 0) {
            console.log("there are no target parameters! " + building.name);
            building.deactivated = true;
            return -1;
        }

        var a,b,distance;

        if(getColonistMask(unit,"IS_SIMULATED")) {

            if(targetParameter.length > 0) {
                a = unit.x - building.x;
                b = unit.y - building.y;
                distance = Math.sqrt( a*a + b*b );
                unit.dX = building.x;
                unit.dY = building.y;
                targetParameter = null;
                return Math.round(distance);
            } else {
                return -1;
            }

        } 

        var targetPoints = [];

        for(var i = 0; i < targetParameter.length; i++) {
            a = unit.x - targetParameter[i][0];
            b = unit.y - targetParameter[i][1];
            distance = Math.sqrt( a*a + b*b );

            targetPoints.push({
                "x":    targetParameter[i][0],
                "y":    targetParameter[i][1],
                "d":    Math.round(distance)
            });
        }

        targetParameter = null;

        targetPoints.sort(sortTargetPoints);

        while(targetPoints.length) {
            var target = targetPoints.shift();

            unit.dX = target.x;
            unit.dY = target.y;
            targetPoints = null;
            return target.d;

        }

        targetPoints = null;

        return -1;
    }

    function sortImmigrantSources(a,b) {
        if(a.count > b.count) {
            return -1;
        }

        if(a.count < b.count) {
            return 1;
        }

        return 0;
    }

    function sortBuildings(a,b) {
        if(a.def > b.def) {
            return -1;
        }

        if(a.def < b.def) {
            return 1;
        }

        return 0;
    }
    
    function sortTargetPoints(a,b) {
        if(a.d < b.d) {
            return -1;
        }

        if(a.d > b.d) {
            return 1;
        }

        return 0;
    }

    function handleColonistWork(colonist) {

        if(colonist.job == 0 || getColonistMask(colonist,"AT_WORK")) {
            return;
        }

        if(colonist == selectedColonist && inHireMode) {
            return;
        }

        var workHealth = 50;
        var workHappiness = 30;

        if(currentGame.workerPolicy == 0) {
            workHealth = 65;
            workHappiness = 50;
        }

        if(currentGame.workerPolicy == 2) {
            workHealth = 40;
            workHappiness = 25;
        }

        if(currentGame.workerPolicy == 3) {
            workHealth = 2;
            workHappiness = 0;
        }

        if(colonist.health < workHealth) {
            return;
        }

        if(colonist.happiness < workHappiness) {
            return;
        }

        

        var building = getBuildingById(colonist.job);

        if(building == null) {

            colonist.job = 0;
            setColonistMask(colonist,"AT_WORK",false);
            return;
        }

        var i;
        var iReallyWorkHere = false;
        for(i = 0; i < building.workers.length; i++) {
            if(building.workers[i].colonistId == colonist.id) {
                iReallyWorkHere = true;
                break;
            }
        }

        if(!iReallyWorkHere) {

            // try to re-add them to the job first 
            if(!addWorker(building,colonist)) {

                colonist.job = 0;
                setColonistMask(colonist,"AT_WORK",false);
                return;
            }

        }

        if(building.deactivated) {
            setColonistMask(colonist,"AT_WORK",false);

            removeWorker(building,colonist,"building deactivated");
            return;
        }


        if(colonist.money > gotItMadePrice && colonist.job > 0) {

            setColonistMask(colonist,"AT_WORK",false);

            removeWorker(building,colonist,"a");
            return;
        }

        if(getColonistMask(colonist,"IS_SIMULATED")) {
            colonist.x = building.x;
            colonist.y = building.y;
            colonist.dX = colonist.x;
            colonist.dY = colonist.y;
            colonist.tX = colonist.x;
            colonist.tY = colonist.y;
        } else {
            var distanceFromWork = sendUnitToBuilding(colonist,building);

            if(distanceFromWork > 1) {
                return;
            }

            if(distanceFromWork == -1) {

                removeWorker(building,colonist,"b");
                building = null;
                return;
            }
        }

        // otherwise, we are at work.  so do some work.
        setColonistMask(colonist,"AT_WORK",true);
        colonist.happiness--;
        for(i = 0; i < building.workers.length; i++) {
            if(building.workers[i].colonistId == colonist.id) {
                building.workers[i].isAtWork = true;
                building = null;
                return;
            }
        }

        // if we got to this point, we dont really work here!
        removeWorker(building,colonist,"b");
        setColonistMask(colonist,"AT_WORK",false);
    }

    var tmpBuildingRefHolder = {};

    function getBuildingById(id) {

        if(tmpBuildingRefHolder[id] != null) {
            return tmpBuildingRefHolder[id];
        }

        for(var i = 0; i < currentGame.buildings.length; i++) {
            if(currentGame.buildings[i].id == id) {
                tmpBuildingRefHolder[id] = currentGame.buildings[i];
                return currentGame.buildings[i];
            }
        }

        return null;
    }

    function getColonistById(id) {

        var holders = getHolderLevels(id);

        if(runningColonistReferenceArray[holders.a] === undefined) {
            return null;
        }

        if(runningColonistReferenceArray[holders.a][holders.b] === undefined) {
            return null;
        }

        if(runningColonistReferenceArray[holders.a][holders.b][holders.c] === undefined) {
            return null;
        }

        if(runningColonistReferenceArray[holders.a][holders.b][holders.c][id] != null) {
            var colonist = runningColonistReferenceArray[holders.a][holders.b][holders.c][id];

            if(colonist.name == null) {
                setColonistName(colonist);
            }

            return colonist;
        }

        return null;
    }

    function shuffle(array) {
        var currentIndex = array.length, temporaryValue, randomIndex;

        // While there remain elements to shuffle...
        while (0 !== currentIndex) {

            // Pick a remaining element...
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex -= 1;

            // And swap it with the current element.
            temporaryValue = array[currentIndex];
            array[currentIndex] = array[randomIndex];
            array[randomIndex] = temporaryValue;
        }

        return array;
    }

    function handleVehicleChoppingBloc(vehicle,def) {
        var i;

        if(vehicle.x == vehicle.choppingDestination.x && vehicle.y == vehicle.choppingDestination.y) {
            if(def != null && def.sellValue != null) {
                for(i = 0; i < def.sellValue.length; i++) {

                    modifyResourceAmount(def.sellValue[i].resource,def.sellValue[i].amount,false,"Chop Shop");
                    if(useTextPoppers) {
                        Scroll2d.popText(vehicle.x,vehicle.y,getResourceByDefName(def.sellValue[i].resource).indicator + def.sellValue[i].amount,getResourceByDefName(def.sellValue[i].resource).color);
                    }
                }
            }

            vehicle.isCashed = true;
            return;
        }
    }

    function deployLoadedUnits(vehicle) {

        var dropPoints = getFreeSpaceAroundTile(vehicle.x,vehicle.y,1);

        if(dropPoints.length == 0) {
            webAppCore.showToast("Cannot Deploy Here");
            return false;
        }

        for(var i = 0; i < currentGame.vehicles.length; i++) {
            if(vehicle.lv.indexOf(currentGame.vehicles[i].id) > -1) {
                currentGame.vehicles[i].iv = 0;
                currentGame.vehicles[i].it = 0;

                var dest = dropPoints[randomIntFromInterval(0,dropPoints.length - 1)];

                currentGame.vehicles[i].x = dest[0];
                currentGame.vehicles[i].y = dest[1];
                currentGame.vehicles[i].dX = dest[0];
                currentGame.vehicles[i].dY = dest[1];
                currentGame.vehicles[i].tX = dest[0];
                currentGame.vehicles[i].tY = dest[1];
            }
        }

        vehicle.lv = [];

        return true;
    }

    function sendVehicleToVehicle(vehicle,target) {
        /*
        vehicle.dX = target.x;
        vehicle.dY = target.y;
        */

        vehicle.it = target.id;
        vehicle.iv = 0;
    }

    function handleVehicleLoad(vehicle) {
        for(var i = 0; i < currentGame.vehicles.length; i++) {
            if(currentGame.vehicles[i].id == vehicle.it) {

                var tDef = getVehicleDefByName(currentGame.vehicles[i].def);

                if(tDef.vehicleCarryCapacity > 0 && tDef.vehicleCarryCapacity > currentGame.vehicles[i].lv.length) {
                    currentGame.vehicles[i].lv.push(vehicle.id);
                    vehicle.iv = currentGame.vehicles[i].id;

                    
                }
                
                break;
            }
        }

        vehicle.it = 0;

        closeObjectOptionsMenu();
    }

    function handleVehicleConstruction(vehicle,def) {

        if(getAwaitingPath(vehicle,"vehicle")) {
            return;
        }

        var i;
        var j;
        var availableSpaces;
        var nextTo;

        var canDoThis = false;

        // if we are standing still, see what we need to be doing
        if(vehicle.dX == vehicle.x && vehicle.dY == vehicle.y) {
            
            vehicle.lastX = vehicle.x;
            vehicle.lastY = vehicle.y;
            vehicle.breakCount = 0;

            // first check if we are near a building under construction 
            nextTo = null;



            var availableProjects = [];
            var found = false;
            
            // get construction projects
            for(i = 0; i < constructionProjectsArray.length; i++) {

                if(!constructionProjectsArray[i].isUnderConstruction) {
                    continue;
                }

                found = false;

                for(var l = 0, n = vehicle.bBlacklist.length; l < n; l++) {
                    
                    

                    if(vehicle.bBlacklist[l] === constructionProjectsArray[i].id) {
                        found = true;
                        break;
                    }

                    
                }

                if(found) {
                    continue;
                }

                
                canDoThis = false;

                if(def.produces != null) {
                    for(j = 0; j < def.produces.length; j++) {
                        if(def.produces[j].length > 0 && def.produces[j] == constructionProjectsArray[i].def) {
                            canDoThis = true;
                        }
                    }
                }

                if(!canDoThis) {
                    continue;
                }

                availableProjects.push(constructionProjectsArray[i]);
            }

            var sortedWorksites = sortBuildingsByDistanceFromUnit(availableProjects,vehicle,false,200);
            var pathsToSort = [];

            while(sortedWorksites.length > 0) {
                var worksite = sortedWorksites.shift();

                if(worksite.d == 1) {
                    nextTo = worksite.b;
                    break;
                }

                availableSpaces = shuffle(getFreeSpacesAroundBuilding(worksite.b,1,false,false));


                for(j = 0; j < availableSpaces.length; j++) {

                    pathsToSort.push({
                        "x": availableSpaces[j][0],
                        "y": availableSpaces[j][1]
                    });


                }


            }

            // if we are not by an under construction building, find the nearest one and set destination, otherwise, turn off building mode
            if(nextTo == null) {
                
                if(pathsToSort.length > 0) {

                    vehicle.dX = pathsToSort[0].x;
                    vehicle.dY = pathsToSort[0].y;


                    checkPathsThreaded(vehicle,"vehicle",pathsToSort);
                    

                } else {

                    vehicle.inBuildingMode = false;
                    
                    if(vehicle.harvestAfterBuilding) {
                        vehicle.harvestAfterBuilding = false;
                        vehicle.iH = true;
                    } else {
                        parkVehicle(vehicle);
                    }
                }

                
            } else {
                // negotiate building manuever
                workOnBuildingConstruction(nextTo,vehicle);
            }
        }

        availableSpaces = null;
    }

    function updateVehicle(vehicle) {

        if(!vehicle.inBuildingMode && !vehicle.iH && !vehicle.onChoppingBlock && vehicle.x == vehicle.dX && vehicle.y == vehicle.dY) {
            return;
        }

        if(isNaN(vehicle.owner)) {
            vehicle.owner = 0;
        }

        var def = getVehicleDefByName(vehicle.def);

        if(def == null) {
            return;
        }

        if(vehicle.iv > 0) {
            return;
        }

        

        if(vehicle.onChoppingBlock) {
            handleVehicleChoppingBloc(vehicle,def);
        }

        var driveSpeed = 2;
        

        if(vehicle.iH) {

            if(isNaN(vehicle.capacity)) {
                vehicle.capacity = def.capacity;
                vehicle.harvests = def.harvests;
            }

            handleUnitHarvest(vehicle);
        }
        
        if(vehicle.tX != vehicle.x || vehicle.tY != vehicle.y) {

            if(!def.isFlying) {
                driveSpeed += getDriveSpeedMod(vehicle.x,vehicle.y);
            }

            if(!isTilePassable(vehicle.tX,vehicle.tY,false,def.isFlying)) {
                vehicle.tX = vehicle.x;
                vehicle.tY = vehicle.y;
                vehicle.dX = vehicle.x;
                vehicle.dY = vehicle.y;
                vehicle.stepCount = 0;
                vehicle.giveUpCount = 0;
            } else {
                vehicle.stepCount += driveSpeed;
                if(vehicle.stepCount >= 20) {
                    vehicle.stepCount = 0;
                    vehicle.x = vehicle.tX;
                    vehicle.y = vehicle.tY;
                    vehicle.giveUpCount = 0;
                }
            }

            
        } else {
            handleUnitMovement(vehicle,"vehicle");
        }

        if(vehicle.it > 0 && vehicle.x == vehicle.dX && vehicle.y == vehicle.dY) {
            handleVehicleLoad(vehicle);
            return;
        }

        // handle a vehicle in building mode
        if(vehicle.inBuildingMode) {
            handleVehicleConstruction(vehicle,def);
        }

    }

    function parkVehicle(vehicle) {
        if(vehicle.pX == null || vehicle.pY == null) {
            return;
        }

        if(vehicle.x == vehicle.pX && vehicle.y == vehicle.pY) {
            return;
        }

        vehicle.dX = vehicle.pX;
        vehicle.dY = vehicle.pY;
    }

    function handleUnitHarvest(vehicle) {

        if(!currentGame.resources[vehicle.harvests]) {
            vehicle.iH = false;
            vehicle.ht = null;
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];
            return;
        }

        // if we are standing still, see what we need to be doing
        if(vehicle.dX == vehicle.x && vehicle.dY == vehicle.y) {
            
            vehicle.lastX = vehicle.x;
            vehicle.lastY = vehicle.y;
            vehicle.breakCount = 0;

            // are we collecting resource
            if(vehicle.storage < vehicle.capacity && !vehicle.isDepositing) {
                if(handleHarvestCollection(vehicle)) {
                    return;
                }
            }

            // if we are still here, find a refinery if there is something in storage 
            vehicle.isInjesting = 0;

            if(vehicle.storage > 0) {

                var hasCapacity = false;

                if(currentGame.resources[vehicle.harvests].capacity == null) {
                    hasCapacity = true;
                }

                if(!hasCapacity && currentGame.resources[vehicle.harvests].capacity == 0) {
                    hasCapacity = true;
                }

                if(!hasCapacity && currentGame.resources[vehicle.harvests].capacity == -1 && (currentGame.resources[vehicle.harvests].amount < currentGame.resources[vehicle.harvests].storageCapacity)) {
                    hasCapacity = true;
                }

                if(hasCapacity) {
                    handleHarvestDeposit(vehicle);
                } else {
                    vehicle.isDepositing = false;
                    notifySilosNeeded(vehicle.harvests,true);
                }

                
            } else {
                vehicle.isDepositing = false;
            }

            
        }

    }

    var shoreReferenceChart = {};

    function getSurroundingSameTerrains(terrain) {
        var surrounding = {
            top: null,
            right: null,
            down: null,
            left: null
        };

        var i,l,ty;

        if(terrain) {

            // top check 
            if(shoreReferenceChart[terrain.x]) {
                if(shoreReferenceChart[terrain.x][terrain.y - 1]) {
                    if(shoreReferenceChart[terrain.x][terrain.y - 1] == terrain.def) {
                        surrounding.top = terrain.def;
                    }
                }
            }

            // bottom check 
            if(shoreReferenceChart[terrain.x]) {
                if(shoreReferenceChart[terrain.x][terrain.y + 1]) {
                    if(shoreReferenceChart[terrain.x][terrain.y + 1] == terrain.def) {
                        surrounding.down = terrain.def;
                    }
                }
            }

            // left check 
            if(shoreReferenceChart[terrain.x - 1]) {
                if(shoreReferenceChart[terrain.x - 1][terrain.y]) {
                    if(shoreReferenceChart[terrain.x - 1][terrain.y] == terrain.def) {
                        surrounding.left = terrain.def;
                    }
                }
            }

            // right check 
            if(shoreReferenceChart[terrain.x + 1]) {
                if(shoreReferenceChart[terrain.x + 1][terrain.y]) {
                    if(shoreReferenceChart[terrain.x + 1][terrain.y] == terrain.def) {
                        surrounding.right = terrain.def;
                    }
                }
            }

            // check passable connectors 
            if(surrounding.top == null || surrounding.down == null || surrounding.left == null || surrounding.right == null) {
                if(terrain.playDef != null && terrain.playDef.passableConnectors != null) {
                    for(i = 0, l = terrain.playDef.passableConnectors.length; i < l; i++) {
                        var td = currentGame.finishedPassableNonUpdatables[terrain.playDef.passableConnectors[i]];

                        if(td) {
                            // top and down
                            if(surrounding.top == null || surrounding.down == null) {
                                if(td[terrain.x]) {
                                    for(ty = 0; ty < td[terrain.x].length; ty++) {
                                        if(td[terrain.x][ty] == terrain.y - 1 && surrounding.top == null) {
                                            surrounding.top = terrain.playDef.passableConnectors[i];
                                        }

                                        if(td[terrain.x][ty] == terrain.y + 1 && surrounding.down == null) {
                                            surrounding.down = terrain.playDef.passableConnectors[i];
                                        }
                                    }
                                }
                            }

                            if(surrounding.left == null) {
                                if(td[terrain.x - 1]) {
                                    for(ty = 0; ty < td[terrain.x - 1].length; ty++) {
                                        if(td[terrain.x - 1][ty] == terrain.y) {
                                            surrounding.left = terrain.playDef.passableConnectors[i];
                                        }
                                    }
                                }
                            }

                            if(surrounding.right == null) {
                                if(td[terrain.x + 1]) {
                                    for(ty = 0; ty < td[terrain.x + 1].length; ty++) {
                                        if(td[terrain.x + 1][ty] == terrain.y) {
                                            surrounding.right = terrain.playDef.passableConnectors[i];
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        return surrounding;
    }

    function setTerrainShoreFrame(terrain) {
        if(terrain == null) {
            return;
        }

        terrain.sf = -1;

        if(terrain.playDef == null) {
            return;
        }

        if(terrain.playDef.shoreSheet == null) {
            return;
        }

        if(terrain.playDef.tileWidth > 1 || terrain.playDef.tileHeight > 1) {
            return;
        }

        var surroundingTiles = getSurroundingSameTerrains(terrain);

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = -1;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 0;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = 1;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = 2;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 3;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 4;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 5;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = 6;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 7;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 8;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 9;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 10;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 11;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 12;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 13;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 14;
            return;
        }

        
    }

    function handleHarvestCollection(vehicle) {
        var possibleResources = [];
        var i, j, nextTo, availableSpaces;
        var found = false;

        for(i = 0; i < currentGame.mapResources.length; i++) {
            if(vehicle.isInjesting > 0 && currentGame.mapResources[i].id != vehicle.isInjesting) {
                continue;
            }

            if(currentGame.mapResources[i].inventory <= 0 && !currentGame.mapResources[i].ul) {
                continue;
            }

            found = false;

            for(var l = 0, n = vehicle.blacklist.length; l < n; l++) {
                
                

                if(vehicle.blacklist[l] === currentGame.mapResources[i].id) {
                    found = true;
                    break;
                }

                
            }

            if(found) {
                continue;
            }

            if(currentGame.mapResources[i].playDef == null) {
                currentGame.mapResources[i].playDef = getTerrainDefByName(currentGame.mapResources[i].def);
            }

            if(currentGame.mapResources[i].playDef.provides == null) {
                continue;
            }

            if(currentGame.mapResources[i].playDef.provides != vehicle.harvests) {
                continue;
            }

            possibleResources.push(currentGame.mapResources[i]);
        }

        // there are no resources, stop harvesting 
        if(possibleResources.length == 0) {
            if(vehicle.storage == 0) {
                vehicle.iH = false;
                vehicle.ht = null;
		vehicle.tc = 0;
                parkVehicle(vehicle);
                return true;
            }
        }

        var sortedResources = sortBuildingsByDistanceFromUnit(possibleResources,vehicle,true,200);
        var pathsToSort = [];

        nextTo = null;

        var checkid = 0;

        while(sortedResources.length > 0) {
            var resource = sortedResources.shift();

            if(resource.d == 1) {
                nextTo = resource.b;
                break;
            }

            //vehicle.ht = resource.id;

            availableSpaces = shuffle(getFreeSpacesAroundBuilding(resource.b,1,false,true));

            if(availableSpaces.length > 0) {
                for(j = 0; j < availableSpaces.length; j++) {


                    pathsToSort.push({
                        "x": availableSpaces[j][0],
                        "y": availableSpaces[j][1]
                    });

                }

                checkid = resource.b.id;

            }

            if(pathsToSort.length > 0) {
                break;
            }

        }

        // if we are right next to a resource, do our thing
        if(nextTo == null) {
            vehicle.isInjesting = 0;
        } else {
            

            if(nextTo.inventory > 0 || nextTo.ul) {

                vehicle.isInjesting = nextTo.id;
                vehicle.storage++;

                if(!nextTo.ul) {
                    nextTo.inventory--;

                    if(nextTo.inventory < 0) {
                        nextTo.inventory = 0;
                    }
                }
            }

            
            return true;
        }

        // otherwise, ship off to the closest resource
        if(pathsToSort.length > 0) {

            vehicle.ht = checkid;

            vehicle.dX = pathsToSort[0].x;
            vehicle.dY = pathsToSort[0].y;

            checkPathsThreaded(vehicle,"vehicle",pathsToSort);


            return true;
        }

        return false;
    }

    function handleHarvestDeposit(vehicle) {
        var possibleBuildings = [];
        var i, j, nextTo,availableSpaces;
        var found = false;

        for(i = 0; i < currentGame.buildings.length; i++) {
            if(currentGame.buildings[i].isUnderConstruction) {
                continue;
            }

            if(currentGame.buildings[i].deactivated) {
                continue;
            }

            if(currentGame.buildings[i].lowPowerMode) {
                continue;
            }

            found = false;

            for(var l = 0, n = vehicle.bBlacklist.length; l < n; l++) {
                
                

                if(vehicle.bBlacklist[l] === currentGame.buildings[i].id) {
                    found = true;
                    break;
                }

                
            }

            if(found) {
                continue;
            }

            setUpMinidefForBuilding(currentGame.buildings[i],false,false);

            if(currentGame.buildings[i].miniDef.refines == null) {
                continue;
            }

            var refines = false;

            for(j = 0; j < currentGame.buildings[i].miniDef.refines.length; j++) {
                if(currentGame.buildings[i].miniDef.refines[j].input == vehicle.harvests) {
                    refines = true;
                    break;
                }
            }

            if(refines) {
                possibleBuildings.push(currentGame.buildings[i]);
            }
        }

        // there are no refineries in the world.  just stop harvesting 
        if(possibleBuildings.length == 0) {
            vehicle.iH = false;
            vehicle.ht = null;
            parkVehicle(vehicle);
            notifySilosNeeded(vehicle.harvests,false);
            return;
        }

        var sortedBuildings = sortBuildingsByDistanceFromUnit(possibleBuildings,vehicle,false,200);
        var pathsToSort = [];
        nextTo = null;

        while(sortedBuildings.length > 0) {
            var building = sortedBuildings.shift();

            if(building.d == 1) {
                nextTo = building.b;
                break;
            }

            availableSpaces = shuffle(getFreeSpacesAroundBuilding(building.b,1,false,false));

            for(j = 0; j < availableSpaces.length; j++) {

                pathsToSort.push({
                    "x": availableSpaces[j][0],
                    "y": availableSpaces[j][1]
                });

            }

        }

        // if we are not by a building, we are probably not depositing
        if(nextTo == null) {
            vehicle.isDepositing = false;
        } else {
            vehicle.isDepositing = true;
            vehicle.storage--;
            //var nextToDef = getBuildingDefByName(nextTo.def);

            for(j = 0; j < nextTo.miniDef.refines.length; j++) {
                if(nextTo.miniDef.refines[j].input == vehicle.harvests) {
                    modifyResourceAmount(nextTo.miniDef.refines[j].output,1,false,"Harvesting");
                }
            }
            
            if(vehicle.storage <= 0) {
                vehicle.storage = 0;
                vehicle.isDepositing = false;
            }

            return;
        }

        // otherwise, head off to the refinery (if available) for further instruction
        if(pathsToSort.length > 0) {

            vehicle.dX = pathsToSort[0].x;
            vehicle.dY = pathsToSort[0].y;

            checkPathsThreaded(vehicle,"vehicle",pathsToSort);


            return;
        }

        // at this point, if we are still here then we couldnt find a resource or a refinery.  pout.
        vehicle.iH = false;
        vehicle.ht = null;
        vehicle.blacklist = [];
        vehicle.bBlacklist = [];
        parkVehicle(vehicle);
    }

    function workOnBuildingConstruction(building,vehicle) {

        if(!building.isUnderConstruction) {
            return;
        }

        if(building.c == null) {
            return;
        }

        if(building.c.c < building.c.t) {

            var vehicleInfo = getVehicleDefByName(vehicle.def);

            var vehicleAble = false;

            if(vehicleInfo.produces != null) {
                for(var i = 0; i < vehicleInfo.produces.length; i++) {

                    if(vehicleInfo.produces[i] == building.def) {
                        vehicleAble = true;
                    }
                }
            }

            if(!vehicleAble) {
                return;
            }

            var buildSpeed = 1;

            if(vehicleInfo.buildSpeed && vehicleInfo.buildSpeed > 1) {
                buildSpeed = vehicleInfo.buildSpeed;
            }

            var wasAbleToBuild = false;

            var totalCOnstructionRemaining = 0;

            for(var resource in building.c.pr) {

                if(building.c.pr[resource] > 0) {
                    if(currentGame.resources[resource].amount > 0) {


                        var amountToBuild = buildSpeed;

                        if(amountToBuild > currentGame.resources[resource].amount) {
                            amountToBuild = currentGame.resources[resource].amount;
                        }

                        if(amountToBuild > building.c.pr[resource]) {
                            amountToBuild = building.c.pr[resource];
                        }

                        modifyResourceAmount(resource,-amountToBuild,false,"Construction");
                        building.c.pr[resource] -= amountToBuild;
                        building.c.c += amountToBuild;
                        building.c.p = building.c.c / building.c.t;

                        wasAbleToBuild = true;

                        if(currentGame.resources[resource].amount < 0) {
                            modifyResourceAmount(resource,0,true);
                        }
                    }
                }

                totalCOnstructionRemaining += building.c.pr[resource];

            }

            if(totalCOnstructionRemaining == 0) {
                building.c.c = building.c.t;
            }

            if(!wasAbleToBuild && vehicle.harvestAfterBuilding) {

                vehicle.inBuildingMode = false;
                vehicle.harvestAfterBuilding = false;
                vehicle.iH = true;
            }

        } else {
            building.isUnderConstruction = false;

            building.c = null;

            if(getBuildingDefByName(building.def).firstBuildMessage != null) {
                if(webAppCore.getVar("fbm-" + building.def,"0") == "0") {
                    
                    webAppCore.storeVar("fbm-" + building.def,"1");
                    
                    webAppCore.showDialog({
                        "title":    building.def,
                        "message":  getString(getBuildingDefByName(building.def).firstBuildMessage),
                        "op1": {
                            "text":     getString("general-dismiss"),
                            "func":     placeholder
                        }
                    });
                }
            }

            var bdefuse = getBuildingDefByName(building.def);
            

            if(bdefuse.becomesTerrain) {
                freeRefNukeTurn = true;
                var freshBuilding = new MapResource(getTerrainDefByName(bdefuse.becomesTerrain),building.x,building.y);
                currentGame.mapResources.push(freshBuilding);
                shoreUpdateTurn = true;
                building.isBeingRemoved = true;
                building = null;

            } else {
                if(building.acceptsWorkers > 0) {
                    callForHireFlag = true;
                }

                

                if(bdefuse.providesShelter > 0) {
                    callForHousingFlag = true;
                }

                updateUtilityGrid();

                if(!bdefuse.passable) {
                    drawSidebar();
                }

            }

            shouldUpdateCollissionMap = true;

            
        }
    }

    function updateBuildingCollisionPoints(building,value,flightOk) {
        for(var j = 0; j < building.occupiesTiles.length; j++) {
            modifyCollisionWeight(building.occupiesTiles[j].x,building.occupiesTiles[j].y,value,flightOk);
        }
    }
    
    
    
    function updateVehicleCollisionPoints(vehicle,value) {
        modifyCollisionWeight(vehicle.x,vehicle.y,value);
    }



    function Employee() {
        this.colonistId = 0;
        this.isAtWork = false;
    }

    function addWorker(building,worker) {

        if(!worker) {
            return;
        }

        if(building.workers.length >= building.acceptsWorkers) {
            return false;
        }

        if(building.acceptsWorkers == 0) {
            return false;
        }

        // we already work here?!
        if(worker.job == building.id) {
            removeWorker(building,worker,"add worker same job cleanup");
        }

        if(worker.job != 0) {
            var tmpbldB = getBuildingById(worker.job);
            if(tmpbldB != null) {
                removeWorker(tmpbldB,worker,"add worker different job cleanup");
            }
            tmpbldB = null;
        }

        setColonistMask(worker,"AT_WORK",false);

        var job = new Employee();
        job.colonistId = worker.id;
        building.workers.push(job);

        worker.job = building.id;

        worker.def.tile = getColonistTile(worker);

        if(getColonistMask(worker,"IS_WANDERING")) {
            setColonistMask(worker,"IS_WANDERING",false);
            worker.dX = worker.x;
            worker.dY = worker.y;
            worker.tX = worker.x;
            worker.tY = worker.y;
        }

        if(building.workers.length >= building.acceptsWorkers) {
            removeFromArray(openJobsArray,building);
        }

        return true;
    }

    function removeWorker(building,worker,source) {

        if(worker == null) {
            console.log("null worker from " + source);
            return;
        }

        if(building == null) {
            worker.job = 0;
            setColonistMask(worker,"AT_WORK",false);
            worker.def.tile = getColonistTile(worker);

            return;
        }

        var jobsToTerminate = [];

        for(var i = 0; i < building.workers.length; i++) {
            if(building.workers[i].colonistId == worker.id) {
                jobsToTerminate.push(building.workers[i]);
            }
        }

        while(jobsToTerminate.length > 0) {
            removeFromArray(building.workers,jobsToTerminate.shift());
        }

        worker.job = 0;
        setColonistMask(worker,"AT_WORK",false);

        worker.def.tile = getColonistTile(worker);
    }

    var workingPassableDef = null;

    function updatePassable(passable) {
        if(passable.occupiesTiles == null) {
            passable.occupiesTiles = getOccupiedTiles(passable);
        }

        if(workingPassableDef == null || workingPassableDef.name != passable.def) {
            workingPassableDef = getBuildingDefByName(passable.def);
        }

        if(workingPassableDef.driveSpeedMod != null) {
            updateVehicleCollisionPoints(passable,-(workingPassableDef.driveSpeedMod));
        }
    }

    function updateNewPassable(def,x,y) {
        var driveSpeed = passableTileRefs[def].driveSpeedMod;
        modifyCollisionWeight(x,y,-driveSpeed,true);
    }

    

    function updateMapResource(mapresource) {

        if(mapresource == null) {
            return;
        }

        updateBuildingCollisionPoints(mapresource,150,true);

        if(mapresource.playDef == null) {
            mapresource.playDef = getTerrainDefByName(mapresource.def);
        }

        if(shoreUpdateTurn) {
            if(mapresource.playDef.shoreSheet != null) {
                if(!shoreReferenceChart[mapresource.x]) {
                    shoreReferenceChart[mapresource.x] = {};
                }

                shoreReferenceChart[mapresource.x][mapresource.y] = mapresource.def;
            }
        }

        if(mapresource.miniDef != null) {
            if(spriteChangeTurn && mapresource.sf == -1) {
                mapresource.spriteFrame++;

                if(mapresource.spriteFrame >= gameAssets[mapresource.miniDef.tile].length) {
                    mapresource.spriteFrame = 0;
                }
            }
        }

        if(currentGame.mem) {
            return;
        }

        if(mapresource.playDef.decayRate > 0) {
            mapresource.dc++;

            if(mapresource.dc >= mapresource.playDef.decayRate) {
                mapresource.inventory--;
            }
        }

        
    }

    function updateMapResourceSpreading(mapresource) {

        if(currentGame.mem) {
            return;
        }

        if(isNaN(mapresource.spreadCounter)) {
            
            
            mapresource.spreadCounter = 0;

            if(mapresource.playDef.spreadRate > 0) {
                mapresource.spreadMax = randomIntFromInterval(1,mapresource.playDef.spreadRate);
            } else {
                mapresource.spreadMax = 0;
            }
        }

        

        if(mapresource.spreadMax > 0) {
            mapresource.spreadCounter++;
        }

        if(mapresource.spreadMax > 0 && mapresource.spreadCounter > mapresource.spreadMax) {
            mapresource.spreadCounter = 0;


            if(mapresource.playDef.spreadRate > 0) {
                mapresource.spreadMax = randomIntFromInterval(1,mapresource.playDef.spreadRate);
            } else {
                mapresource.spreadMax = 0;
            }

            var freeSpaces = getFreeSpacesAroundBuilding(mapresource,1,true,true);

            if(freeSpaces != null && freeSpaces.length > 0) {
                var idx = randomIntFromInterval(0,freeSpaces.length - 1);
                var target = freeSpaces[idx];
                freeRefNukeTurn = true;

                if(isTilePassable(target[0],target[1],true)) {
                    var resourceItem = new MapResource(mapresource.playDef,target[0],target[1]);
                    updateBuildingCollisionPoints(resourceItem,150);
                    currentGame.mapResources.push(resourceItem);
                    shoreUpdateTurn = true;
                }
            }

        }
    }

    function reInitBuilding(building) {
        
        var bDef = getBuildingDefByName(building.def);

        if(building.occupiesTiles == null) {
            building.occupiesTiles = getOccupiedTiles(building);
        }

        if(isNaN(building.owner)) {
            building.owner = 0;
        }

        if(bDef.tileWidth > 1) {
            building.dX += (bDef.tileWidth - 1);
        }
        
        if(bDef.tileHeight > 1) {
            building.dY += (bDef.tileHeight - 1);
        }

        if(isNaN(building.acceptsWorkers)) {
            building.acceptsWorkers = bDef.acceptsWorkers;
            building.requiresWorkers = bDef.requiresWorkers;
            building.workers = [];
        }

        if(!building.workers) {
            building.workers = [];
        }

        if(!building.patients) {
            building.patients = [];
        }

        if(!building.patrons) {
            building.patrons = [];
        }

        if(!building.residents) {
            building.residents = [];
        }

        if(isNaN(building.workerCheckCounter)) {
            building.workerCheckCounter = 0;
        }

        if(isNaN(building.colGenCounter)) {
            building.colGenCounter = 0;
        }
        if(isNaN(building.colGenMax)) {
            building.colGenMax = 0;
        }
        if(isNaN(building.colGenPercentage)) {
            building.colGenPercentage = 0;
        }
    }

    function updateBuilding(building) {

        if(building.isBeingRemoved) {
            return;
        }

        building.dX = building.x;
        building.dY = building.y;

        setUpMinidefForBuilding(building);

        var bDef = getBuildingDefByName(building.def);

        if(bDef.becomesTerrain && !building.isBeingRemoved && !building.isUnderConstruction) {
            freeRefNukeTurn = true;
            var freshBuilding = new MapResource(getTerrainDefByName(bDef.becomesTerrain),building.x,building.y);
            currentGame.mapResources.push(freshBuilding);
            shoreUpdateTurn = true;
            building.isBeingRemoved = true;
            building = null;
            return;
        }

        if(!bDef.canFlip) {
            if(building.flipped) {
                flipBuilding(building);
            }
        }

        if(spriteChangeTurn) {
            building.spriteFrame++;

            if(building.spriteFrame >= gameAssets[building.miniDef.tile].length) {
                building.spriteFrame = 0;
            }
        }

        

        if(bDef.unlocksGovLvl && bDef.unlocksGovLvl > currentGame.governmentLevel) {
            currentGame.governmentLevel = bDef.unlocksGovLvl;
        }

        if(bDef.isConsulate) {
            hasConsulate = true;
            ourCapitolBuilding = building;
        }

        if(bDef.isCapitol) {
            hasCapitol = true;
            ourCapitolBuilding = building;
        }

        if(building.workers.length > 0 || building.residents.length > 0) {
            building.workerCheckCounter++;

            if(building.workerCheckCounter >= 700) {
                

                handleBuildingWorkerCleanup(building);
            }

            
        }

        if(bDef.acceptsWorkers > 0 && building.embassyFor == 0) {
            allJobsArray.push(building);
        }
        
        
        

        if(bDef.colGenRate && bDef.colGenRate != null && bDef.colGenRate > 0) {
            handleBuildingColonistGeneration(building);
        }

        if(bDef.passable) {
            updateBuildingCollisionPoints(building,-4);
        } else {
            updateBuildingCollisionPoints(building,150);
        }

        if(currentGame.readOnlyMode) {
            bDef = null;
            return;
        }
        

        building.lowPowerMode = false;

        if(building.isUnderConstruction) {
            building.openForEntertainment = false;
            building.openForTourism = false;
            building.jobsAvailable = 0;
            building.openForMedical = false;
            building.availableHomes = 0;
            bDef = null;
            return;
        }



        building.someoneWorking = false;
        building.howManyWorking = 0;
        building.jobsAvailable = 0;
        building.availableHomes = 0;

        if(bDef.providesShelter > 0) {
            building.availableHomes = bDef.providesShelter - building.residents.length;

            if(building.embassyFor == 0) {
                allHomesArray.push(building);
            }

            if(building.availableHomes < 0) {
                building.availableHomes = 0;
                handleBuildingWorkerCleanup(building);
            }
        }

        if(bDef.acceptsWorkers > 0 && !building.isUnderConstruction) {
            building.jobsAvailable = bDef.acceptsWorkers;

            setBuildingJobsAvailable(building);
        }
        
        if(bDef.requiresUtility != null) {
            handleBuildingUtility(building);
        }

        if(bDef.requiresFuel != null) {
            handleBuildingConsumption(building);
        }
        
        if(!building.lowPowerMode && building.c != null) {
            handleBuildingConstruction(building);
        }

        if(!building.lowPowerMode && building.generates != null) {
            handleBuildingGeneration(building);
        }

        if(!building.lowPowerMode && bDef.smelts != null) {
            handleBuildingSmelting(building);
        }

        if(bDef.takesTourists > 0 || bDef.entertains > 0 || bDef.heals > 0) {
            if(bDef.entertains > 0) {
                building.openForEntertainment = true;
            }

            if(bDef.takesTourists > 0) {
                building.openForTourism = true;
            }

            if(bDef.heals > 0) {
                building.openForMedical = true;
            }

            if(building.isUnderConstruction || building.lowPowerMode || building.noConsumptionMode) {
                building.openForEntertainment = false;
                building.openForMedical = false;
                building.openForTourism = false;
            }

            if(building.openForTourism) {
                if(building.tourists.length >= bDef.takesTourists) {
                    building.openForTourism = false;
                }
            }

            if(building.openForEntertainment) {
                if(building.patrons.length >= bDef.entertains) {
                    building.openForEntertainment = false;
                }
            }

            if(building.openForMedical) {
                if(building.patients.length >= bDef.heals) {
                    building.openForMedical = false;
                } else {
                    medicalCoveragePoints.push({
                        "x": building.x,
                        "y": building.y
                    });
                }
            }

            if(building.openForEntertainment || building.openForMedical) {
                if(bDef.requiresWorkers && !building.someoneWorking) {
                    building.openForEntertainment = false;
                    building.openForMedical = false;
                } else {
                    if(building.openForEntertainment) {
                        entertainmentCoveragePoints.push({
                            "x": building.x,
                            "y": building.y
                        });
                    }
                }
            }
        } else {
            building.openForEntertainment = false;
            building.openForMedical = false;
        }

        if(!currentGame.offlineMode) {
            var damagechance = randomIntFromInterval(1,180000);
            if(damagechance == 2) {
                building.condition--;
            }
        }

        if(!building.lowPowerMode) {
            if(bDef.giftCapacity > giftCapacity) {
                giftCapacity = bDef.giftCapacity;
            }
        }

        if(bDef.isEmbassy) {
            building.jobsAvailable = 0;
            building.availableHomes = 0;
        }

        bDef = null;
    }

    function setBuildingJobsAvailable(building) {

        if(building.deactivated) {
            building.jobsAvailable = 0;
            return;
        }

        for(var i = 0; i < building.workers.length; i++) {
            if(building.workers[i].isAtWork) {
                building.someoneWorking = true;
                building.howManyWorking++;
            }
            building.jobsAvailable--;
        }

        
    }

    function handleBuildingWorkerCleanup(building) {

        building.workerCheckCounter = 0;

        var workerKillArray = [];
        var i;

        for(i = 0; i < building.workers.length; i++) {

            if(building.workers[i] == null) {
                workerKillArray.push(building.workers[i]);
                continue;
            }

            // dont worry about synthetic workers
            if(building.workers[i].colonistId < 0) {
                continue;
            }

            

            var checkWorker = getColonistById(building.workers[i].colonistId);
            

            if(checkWorker == null) {
                workerKillArray.push(building.workers[i]);
            } else {
                if(checkWorker.job == building.id) {

                    setColonistMask(checkWorker,"AT_WORK",building.workers[i].isAtWork);

                } else {
                    workerKillArray.push(building.workers[i]);
                }
            }

            
        }



        while(workerKillArray.length > 0) {
            removeFromArray(building.workers,workerKillArray.shift());
        }

        workerKillArray = null;

        if(!building.miniDef) {
            setUpMinidefForBuilding(building,false);
        }

        if(building.workers.length > building.miniDef.acceptsWorkers) {
            var workersToFire = building.workers.length - building.miniDef.acceptsWorkers;
            while(workersToFire > 0) {
                workersToFire--;

                if(building.workers[workersToFire].colonistId >= 0) {
                    var poorSap = getColonistById(building.workers[workersToFire].colonistId);
                    removeWorker(building,poorSap,"d");
                } else {
                    building.workers.splice(workersToFire,1);
                }
            }
        }

        workerKillArray = [];

        // quick resident check 
        for(i = 0; i < building.residents.length; i++) {
            if(building.residents[i] == null) {
                workerKillArray.push(building.residents[i]);
            }

            if(isNaN(building.residents[i])) {
                workerKillArray.push(building.residents[i]);
            }
        }


        while(workerKillArray.length > 0) {
            removeFromArray(building.residents,workerKillArray.shift());
        }

        while(building.residents.length > getTotalPopulation()) {
            building.residents.shift();
        }

        workerKillArray = [];

        // quick medical check 
        for(i = 0; i < building.patients.length; i++) {

            if(isNaN(building.patients[i])) {
                workerKillArray.push(building.patients[i]);
                continue;
            }

            if(building.patients[i] == null) {
                workerKillArray.push(building.patients[i]);
                continue;
            }

            var col = null;

            if(building.patients[i] > 0) {
                col = getColonistById(building.patients[i]);
            } else {
                var avatarHolder = currentGame.virtualAvatars[building.patients[i]];

                if(avatarHolder && avatarHolder.id != 0) {
                    col = getColonistById(avatarHolder.id);
                }
                
                if(col == null) {
                    workerKillArray.push(building.patients[i]);
                    continue;
                }

                if(!getColonistMask(col,"IS_HEALING")) {
                    workerKillArray.push(building.patients[i]);
                    continue;
                }

                if(getColonistMask(col,"AT_WORK") || getColonistMask(col,"AT_HOME") || getColonistMask(col,"IS_RELAXING") || getColonistMask(col,"IS_PROTESTING")) {
                    setColonistMask(col,"IS_HEALING",false);
                    workerKillArray.push(building.patients[i]);
                    continue;
                }
            }
        }

        while(workerKillArray.length > 0) {
            removeFromArray(building.patients,workerKillArray.shift());
        }

        workerKillArray = null;

        var def = getBuildingDefByName(building.def);

        while(building.patients.length > def.heals) {
            var colid = building.patients.shift();
            setColonistMask(getColonistById(colid),"IS_HEALING",false);
        }

        // disable buildings with no access
        if(def.touristDoorway || def.colGenRate > 0 || def.refines != null || def.isChopShop || def.entertains > 0 || def.providesShelter > 0 || def.acceptsWorkers > 0 || def.heals > 0 || def.educates > 0 || def.takesTourists) {
            var freespace = getFreeSpacesAroundBuilding(building,1,false,false);
            if(freespace.length == 0) {
                building.deactivated = true;
            }
        }
    }

    function handleBuildingUtility(building) {

        if(currentGame.cm) {
            building.lowPowerMode = false;
            return;
        }

        if(building.deactivated || building.condition < 10) {
            building.lowPowerMode = true;
            return;
        }

        var def = getBuildingDefByName(building.def);

        for(var j = 0; j < def.requiresUtility.length; j++) {
                
            if(currentGame.utilities[def.requiresUtility[j].utility].usage > currentGame.utilities[def.requiresUtility[j].utility].capacity) {
                building.lowPowerMode = true;

                if(lowCapacityCounter > lowPowerNagLimit) {
                    lowCapacityCounter = 0;
                    webAppCore.showToast({
                        message: "Low " + getUtilityByDefName(def.requiresUtility[j].utility).name,
                        image:   "images/" + getUtilityByDefName(def.requiresUtility[j].utility).icon
                    });
                }
            }

            
        }
    }

    function handleBuildingConsumption(building) {

        if(currentGame.cm) {
            building.noConsumptionMode = false;
            return;
        }

        if(building.deactivated) {
            return;
        }

        var def = getBuildingDefByName(building.def);

        if(def.requiresFuel == null) {
            return;
        }

        if(isNaN(building.consumptionCounter)) {
            building.consumptionCounter = 0;
            building.noConsumptionMode = false;
        }

        building.consumptionCounter += buildingUpdateCycles;


        var i;

        if(building.consumptionCounter > def.requiresFuel.rate) {

            var fuelRequirements = def.requiresFuel.resource.split(",");

            for(i = 0; i < fuelRequirements.length; i++) {
                if(currentGame.resources[fuelRequirements[i]].amount < 1) {
                    building.noConsumptionMode = true;

                    if(lowCapacityCounter > lowPowerNagLimit) {
                        lowCapacityCounter = 0;
                        webAppCore.showToast({
                            message: getResourceByDefName(fuelRequirements[i]).name + " Depleted",
                            image:   "images/" + getResourceByDefName(fuelRequirements[i]).icon
                        });
                        updateUtilityGrid();
                    }
    
                    return;
                }

                building.consumptionCounter = 0;
                building.noConsumptionMode = false;

                for(i = 0; i < fuelRequirements.length; i++) {
                    modifyResourceAmount(fuelRequirements[i],-1,false,building.def);

                    if(currentGame.resources[fuelRequirements[i]].amount < 0) {
                        
                        modifyResourceAmount(fuelRequirements[i],0,true);
                    }
                }
            }

        }

    }

    function handleBuildingColonistGeneration(building) {

        if(building.deactivated) {
            return;
        }

        if(building.noConsumptionMode) {
            return;
        }

        if(building.isUnderConstruction) {
            return;
        }

        var def = getBuildingDefByName(building.def);

        if(currentGame.stopImmigration && !def.embargoImmune) {
            return;
        }

        if(building.colGenMax == 0) {
            building.colGenCounter = 0;
            building.colGenMax = randomIntFromInterval(1,def.colGenRate);
        }

        if(currentGame.immigrationEmbargo && !def.embargoImmune) {
            return;
        }

        if(def.requiresWorkers && building.howManyWorking == 0) {
            return;
        }

        var count = (building.howManyWorking * buildingUpdateCycles);

        if(building.howManyWorking == 0) {
            count = buildingUpdateCycles;
        }

        building.colGenCounter += count;

        building.colGenPercentage = building.colGenCounter / building.colGenMax;

        if(building.colGenCounter >= building.colGenMax) {
            building.colGenMax = 0;
            building.colGenCounter = 0;

            var bringTourist = false;
            var bringColonist = false;

            if(def.touristDoorway) {
                if(previouslyAvailableTourism > currentGame.tourists.length) {
                    bringTourist = true;
                }

                if(def.isStargate && previouslyAvailableShelters > getTotalPopulation()) {
                    bringColonist = true;
                }
            } else {
                if(previouslyAvailableShelters > getTotalPopulation()) {
                    bringColonist = true;
                }

                if(def.isStargate && previouslyAvailableTourism > currentGame.tourists.length) {
                    bringTourist = true;
                }
            }

            if(bringTourist || bringColonist) {

                var arrivals = 1;
                var availableSpaces = getFreeSpacesAroundBuilding(building,1,false);

                if(availableSpaces.length > 0) {

                    var maxArrivals = 1;

                    if(def.touristDoorway) {
                        maxArrivals = 10;
                    }

                    if(def.isStargate) {
                        maxArrivals = 18;
                    }

                    var approvalRate = currentGame.historicStats.approval[currentGame.historicStats.approval.length - 1] / 100;

                    maxArrivals = Math.ceil(maxArrivals * approvalRate);

                    arrivals = randomIntFromInterval(1,maxArrivals);

                    if(arrivals < 1) {
                        arrivals = 1;
                    }

                    while(arrivals > 0) {

                        var useRace = currentGame.defaultRace;
                        var immagrantSource = currentGame.motherland;

                        var availableRaces = [{
                            "race": useRace,
                            "source": immagrantSource
                        }];
                        

                        var isImmigrant = false;

                        if(!def.embargoImmune) {
                            isImmigrant = true;

                            for(var prop in currentGame.foreignContactReference) {

                                for(var r = 0; r < ColonyGame.races.length; r++) {
                                    if(currentGame.foreignContactReference[prop].race == ColonyGame.races[r].name) {

                                        availableRaces.push({
                                            "race": currentGame.foreignContactReference[prop].race,
                                            "source": currentGame.foreignContactReference[prop].name
                                        });
                                    }
                                }

                                
                            }
                        }

                        var useTarget = availableRaces[randomIntFromInterval(0,availableRaces.length - 1)];

                        useRace = useTarget.race;
                        immagrantSource = useTarget.source;


                        var idx = randomIntFromInterval(0,availableSpaces.length - 1);
                        var target = availableSpaces[idx];

                        var dtx = target[0];
                        var dty = target[1];

                        var freshVehicle;

                        if(isNaN(dtx) || isNaN(dty)) {
                            dtx = building.x;
                            dty = building.y;
                        }

                        if(bringTourist) {
                            freshVehicle = new Colonist(dtx,dty,false,useRace);
                            setupNewColonist(freshVehicle);
                            setColonistMask(freshVehicle,"IS_DIPLOMAT",false);
                            setColonistMask(freshVehicle,"IS_TOURIST",true);
                            freshVehicle.happiness = randomIntFromInterval(30,80);
                            freshVehicle.money = randomIntFromInterval(25,900);
                            freshVehicle.iQ = randomIntFromInterval(40,110);
                            currentGame.tourists.push(freshVehicle);
                            currentGame.totalTourists++;

                            if(ColonyGame.achievements.thousandTourists > 0) {
                                if(currentGame.totalTourists > 1000) {
                                    webAppCore.reportAchievement(ColonyGame.achievements.thousandTourists);
                                }
                            }

                            arrivals--;

                        }
                        
                        if(bringColonist) {

                            if(isImmigrant) {
                                currentGame.totalImmigration++;

                                currentGame.immigrantSources.push(immagrantSource);
                                
                                while(currentGame.immigrantSources.length > 400) {
                                    currentGame.immigrantSources.shift();
                                }
                            }

                            freshVehicle = new Colonist(dtx,dty,false,useRace);
                            setupNewColonist(freshVehicle);
                            setColonistMask(freshVehicle,"IS_DIPLOMAT",false);
                            setColonistMask(freshVehicle,"IS_TOURIST",false);
                            currentGame.colonists.push(freshVehicle);

                            if(currentGame.populationStats[useRace] === undefined) {
                                currentGame.populationStats[useRace] = 0;
                            }

                            currentGame.populationStats[useRace]++;

                            findAJob(freshVehicle);

                            var thepop = getTotalPopulation();

                            if(thepop > previouslyAvailableShelters) {
                                setColonistMask(freshVehicle,"IS_ILLEGAL",true);
                            } else {
                                setColonistMask(freshVehicle,"IS_ILLEGAL",false);
                            }

                            if(thepop < 1000) {
                                webAppCore.showToast({
                                    message: freshVehicle.name + " has joined the colony.",
                                    image:   "images/" + ColonyGame.meta.colonistIcon
                                }); 
                            }

                            if(ColonyGame.achievements.hundredColonists > 0) {
                                if(thepop > 100) {
                                    webAppCore.reportAchievement(ColonyGame.achievements.hundredColonists);
                                }
                            }

                            if(ColonyGame.achievements.thousandColonists > 0) {
                                if(thepop > 1000) {
                                    webAppCore.reportAchievement(ColonyGame.achievements.thousandColonists);
                                }
                            }

                            if(ColonyGame.achievements.tenthousandColonists > 0) {
                                if(thepop > 10000) {
                                    webAppCore.reportAchievement(ColonyGame.achievements.tenthousandColonists);
                                }
                            }

                            arrivals--;
                        }

                        freshVehicle.def.tile = getColonistTile(freshVehicle);

                        
                    }

                }


                availableSpaces = null;
            }
        }
    }

    function handleBuildingConstruction(building) {

        if(building.deactivated) {
            return;
        }

        if(building.c == null) {
            return;
        }

        if(building.c.c < building.c.t && !currentGame.cm) {

            var vd = getVehicleDefByName(building.c.q[0]);
                
            for(var i = 0; i < vd.cost.length; i++) {
                for(var j = 0; j < buildingUpdateCycles; j++) {
                    if(building.c.pr[vd.cost[i].resource] > 0) {
                        if(currentGame.resources[vd.cost[i].resource].amount > 0) {

                            modifyResourceAmount(vd.cost[i].resource,-1,false,"Construction");

                            building.c.pr[vd.cost[i].resource]--;
                            building.c.c++;
                            building.c.p = building.c.c / building.c.t;

                            if(currentGame.resources[vd.cost[i].resource].amount < 0) {
  
                                modifyResourceAmount(vd.cost[i].resource,0,true);
                            }
                        }
                    }
                }
            }

        } else {
            // job is done, build the vehicle or wait for free space

            if(building.c.t > 0) {
                var availableSpaces = getFreeSpacesAroundBuilding(building);

                if(availableSpaces.length > 0) {
                    
                    var idx = randomIntFromInterval(0,availableSpaces.length - 1);
                    var target = availableSpaces[idx];

                    var vd2 = getVehicleDefByName(building.c.q[0]);
                    
                    var freshVehicle = new Vehicle(vd2,target[0],target[1],0);
                    currentGame.vehicles.push(freshVehicle);

                    


                    if(vd2.firstBuildMessage != null) {
                        if(webAppCore.getVar("fbm-" + freshVehicle.def,"0") == "0") {
                            
                            webAppCore.storeVar("fbm-" + freshVehicle.def,"1");
                            
                            webAppCore.showDialog({
                                "title":    freshVehicle.def,
                                "message":  getString(vd2.firstBuildMessage),
                                "op1": {
                                    "text":     getString("general-dismiss"),
                                    "func":     placeholder
                                }
                            });
                        }
                    }

                    
                    
                    unstickUnit(freshVehicle);

                    building.c.q.shift();
                    

                    drawSidebar();
                } else {
                    // cry and wait for something to move
                } 

                availableSpaces = null;
            }

            if(building.c.q.length > 0) {
                building.c.c = 0;
                building.c.p = 0;
                building.c.pr = {};
                building.c.t = 0;

                var vd3 = getVehicleDefByName(building.c.q[0]);

                for(var l = 0; l < vd3.cost.length; l++) {
                    building.c.pr[vd3.cost[l].resource] = vd3.cost[l].amount;
                    building.c.t += vd3.cost[l].amount;
                }
            } else {
                building.c = null;
            }
        }
    }

    function handleBuildingGeneration(building) {

        if(building.deactivated) {
            return;
        }

        if(building.noConsumptionMode) {
            return;
        }

        if(building.generateCounter < building.generateTime) {

            if(!building.requiresWorkers) {
                building.generateCounter+=buildingUpdateCycles;
            }

            for(var i = 0; i < building.howManyWorking; i++) {
                building.generateCounter+=buildingUpdateCycles;
            }

        }

        if(building.generateCounter >= building.generateTime) {

            var genResourceRef = currentGame.resources[building.generates];

            if(genResourceRef.capacity == null || (genResourceRef.capacity == -1 && genResourceRef.amount < genResourceRef.storageCapacity) || (genResourceRef.amount < genResourceRef.capacity)) {
                building.generateCounter = 0;
                modifyResourceAmount(building.generates,building.generateAmount,false,building.def);

                if(useTextPoppers && Scroll2d.checkVisibility(building.x,building.y)) {
                    Scroll2d.popText(building.x,building.y,getResourceByDefName(building.generates).indicator + building.generateAmount,getResourceByDefName(building.generates).color);
                }
            }

            genResourceRef = null;
        }
        
        building.generatePercentage = building.generateCounter / building.generateTime;
    }

    function handleBuildingSmelting(building) {

        if(building.deactivated) {
            return;
        }

        if(building.noConsumptionMode) {
            return;
        }

        var genRate = buildingUpdateCycles;

        var bldDef = getBuildingDefByName(building.def);

        if(isNaN(building.smeltCounter)) {
            building.smeltCounter = 0;
        }

        var i;

        if(building.smeltCounter < bldDef.smelts.time) {

            genRate = buildingUpdateCycles;

            if(building.requiresWorkers) {
                genRate = 0;
            }

            for(i = 0; i < building.howManyWorking; i++) {
                genRate += buildingUpdateCycles;
            }

            building.smeltCounter += genRate;
        }



        if(building.smeltCounter >= bldDef.smelts.time) {

            var smeltItems = bldDef.smelts.input.split(",");

            var canAfford = true;

            for(i = 0; i < smeltItems.length; i++) {
                if(currentGame.resources[smeltItems[i]].amount <= 0) {
                    canAfford = false;
                    break;
                }
            }

            if(!canAfford) {
                building.smeltCounter = bldDef.smelts.time;
            }

            var outputResource = null;

            if(bldDef.smelts.output != null) {
                var outputResourceAll = bldDef.smelts.output.split("|");
                outputResource = outputResourceAll[randomIntFromInterval(0,outputResourceAll.length - 1)];
            }

            // check for capacity
            if(outputResource == null || currentGame.resources[outputResource].capacity == null || currentGame.resources[outputResource].capacity == 0 || (currentGame.resources[outputResource].capacity == -1 && (currentGame.resources[outputResource].storageCapacity > currentGame.resources[outputResource].amount))) {

                for(i = 0; i < smeltItems.length; i++) {

                    if(currentGame.resources[smeltItems[i]].amount < 1) {

                        if(lowCapacityCounter > lowPowerNagLimit) {
                            lowCapacityCounter = 0;
                            webAppCore.showToast({
                                message: getResourceByDefName(smeltItems[i]).name + " Depleted",
                                image:   "images/" + getResourceByDefName(smeltItems[i]).icon
                            });
                            updateUtilityGrid();
                        }
        
                        return;
                    }

                    modifyResourceAmount(smeltItems[i],-1,false,building.def);
                }



                if(outputResource != null) {
                    modifyResourceAmount(outputResource,bldDef.smelts.ratio,false,building.def);
                }

                building.smeltCounter = 0;

                if(outputResource != null && useTextPoppers && Scroll2d.checkVisibility(building.x,building.y)) {
                    Scroll2d.popText(building.x,building.y,getResourceByDefName(outputResource).indicator + "" +  bldDef.smelts.ratio,getResourceByDefName(outputResource).color);
                }

            } else {
                building.smeltCounter = bldDef.smelts.time;

                if(lowCapacityCounter > lowPowerNagLimit) {
                    lowCapacityCounter = 0;
                    webAppCore.showToast({
                        message: "Insufficient Storage",
                        image:   "images/" + getResourceByDefName(outputResource).icon
                    });
                }
            }

        }


    }

    var remoteCloudLoad = false;

    function initScroll2d() {

        Scroll2d.init(document.getElementById("canvasHolder"));
        
        Scroll2d.setIsometric(true);
        Scroll2d.initParticleEngine();
        Scroll2d.setGridSize(ColonyGame.meta.gridSize);
        Scroll2d.setMapDims(ColonyGame.meta.mapWidth,ColonyGame.meta.mapHeight);
        Scroll2d.setDrawFunction(draw);
        Scroll2d.setClickFunction(click);
        Scroll2d.setPaintFunction(paint);
        Scroll2d.setRightClickFunction(rightClick);
        Scroll2d.setHoverFunction(hover);
        Scroll2d.setHoldFunction(hold);
        Scroll2d.setUpdateFunction(update,40);
        Scroll2d.setZoomLevel(zoomLevel);
        Scroll2d.setViewPadding(5);
        Scroll2d.setSelectionFunction(onSelectionDone,onSelectionChange);
        Scroll2d.setFastRenderMode(!checkRenderDistance);
        Scroll2d.setFPSLimiter(fpsRate);
        
        Scroll2d.centerOnCoord(50,50);
        
        var parm = webAppCore.getExternalParm();

        if(parm != "0") {

            if(parm.startsWith(ColonyGame.fileShareUrlPrefix)) {

                parm = parm.replace(ColonyGame.fileShareUrlPrefix,"");

                if(parm.startsWith("view_")) {
                    currentFileName = "shared";
                    remoteCloudLoad = true;
                    var rawishPath = parm.replace("view_","");
                    var cleanishPath = replaceAll(rawishPath,"_","/");
                    webAppCore.showSplash("Syncing Data...");
                    loadCloudReadOnly(cleanishPath);
                    return;
                }
            }

            if(parm.startsWith("loadmap=")) {
                openGame(parm.replace("loadmap=",""));
                return;
            }
 
        }

        showTitle();
    }

    var returnToFileName = null;
    var pendingForeignColony = null;

    function loadCloudReadOnly(path) {
        currentFileName = "shared";
        remoteCloudLoad = true;
        webAppCore.loadSharedCloudFile(path,onCloudShareFileReturn);
    }

    function onCloudShareFileReturn(data) {
        if(data && data != "fail" && data.length > 10) {
            uncompressFile(data);
        } else {
            webAppCore.showToast("Unable To Load Map");
            remoteCloudLoad = false;
            showTitle();
        }
    }

    function showTitle() {

        totalAvailableVehicles = 0;
        colonyNeverLoaded = false;

        returnToFileName = null;
        pendingForeignColony = null;

        if(usingSockets) {
            webAppCore.socketEmit("closeconnection","");
        }

        closeGBT();
        closeStatsMenu();
        closeCommonwealthMenu();
        closeColonyWindow();
        closeObjectOptionsMenu();

        document.getElementById("notificationArea").innerHTML = "";

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;

        runningColonistReferenceArray = {};

        resourceLedger = null;

        saveInProgress = false;

        titleShowing = true;
        
        stopSoundtrack();
        
        setupMenuOptions();

        webAppCore.setTheme(ColonyGame.meta.titleTheme);

        var lastGame = webAppCore.getVar("mc-last-saved-game","0");
        var lastColonyName = webAppCore.getVar("mc-last-saved-game-name","0");

        webAppCore.resetTitle();

        webAppCore.setTitleOptionListener(onTitleOptionSelected);


        

        webAppCore.setTitleBackground(ColonyGame.meta.titleTheme + " url('images/background.jpg') no-repeat fixed center/cover");

        webAppCore.setTitleLogo("images/logo.png");

        webAppCore.setTitleSubtitle("Build v" + ColonyGame.meta.buildVersion);


        if(lastGame != null && lastGame != "0") {
            if(lastColonyName == null || lastColonyName == "0" || lastColonyName.trim().length == 0) {
                webAppCore.addTitleOption(getString("general-contine"),"continue");
            } else {
                webAppCore.addTitleOption(lastColonyName,"continue");
            }
        }

        webAppCore.addTitleOption(getString("general-new"),"new");
        webAppCore.addTitleOption(getString("general-load"),"load");

        if(webAppCore.getPlatform().platform == "web") {
            if(webAppCore.getPlatform().market == "apewebapps") {
                if(ColonyGame.meta.nativeClientURL != null) {
                    webAppCore.addTitleOption(getString("general-native-client"),"native");
                }
            }
        }

        webAppCore.addTitleOption(getString("general-options"),"options");

        bulldozerMode = false;

        webAppCore.setTitleVisible(true);
        webAppCore.handleBackFunction(null);

        webAppCore.clearSplash();
        vehiclePathOrders = {};
        colonistPathOrders = {};
        
    }

    function downloadNativeClient() {
        webAppCore.externalURL(ColonyGame.meta.nativeClientURL);
    }

    function onTitleOptionSelected(tag) {

        if(tag == "native") {
            webAppCore.showDialog({
                "title":    getString("general-native-client"),
                "message":  getString("native-client-description"),
                "op1": {
                    "text":     getString("general-yes"),
                    "func":     downloadNativeClient
                },
                "op2": {
                    "text":     getString("general-no"),
                    "func":     placeholder
                }
            });
        }

        if(tag == "continue") {
            webAppCore.showSplash("Loading Data...");
            titleShowing = false;
            bulldozerMode = false;
            webAppCore.setTitleVisible(false);
            webAppCore.handleBackFunction(standardBack);
            continueToPlayMode();
            showListingAfterSave = false;
        }

        if(tag == "new") {

            newGame();
        }

        if(tag == "options") {
            webAppCore.toggleMenu();
        }

        if(tag == "load") {
            listingType = "load";
            webAppCore.openListing(showOpenGameListing);
        }
    }

    function continueToPlayMode() {
        var lastGame = webAppCore.getVar("mc-last-saved-game","0");

        if(lastGame == "0") {
            newGame();
        } else {
            openGame(lastGame);
        }
    }

    function showHiders() {
        var hiders = document.querySelectorAll(".newGameHide");

        for(var i = 0; i < hiders.length; i++) {
            hiders[i].style.display = "block";
        }
    }
    
    function newGame() {

        var i;

        var menuOptions = [];

        var offlineName = "离线游戏";

        if(ColonyGame.meta.colonyServerApi == null) {
            offlineName = "Regular Game";
        }

        menuOptions.push({
            "title":        offlineName,
            "description":  getString("offline-game-desc"),
            "icon":         "images/" + ColonyGame.meta.offlineModeInd,
            "status":       null,
            "status-color":  null,
            "overflow":     null,
            "tag":          "homeworld"
        });

        if(ColonyGame.meta.colonyServerApi != null) {

            menuOptions.push({
                "title":        "在线游戏",
                "description":  getString("new-charter-desc"),
                "icon":         "images/" + ColonyGame.meta.onlineModeInd,
                "status":       getString("new-charter-req-online"),
                "status-color":  "#26C6DA",
                "overflow":     null,
                "tag":          "charter"
            });

        }

        var creativeStatus = null;
        var creativeColor = null;

        if(!webAppCore.getIsPremium()) {
            creativeStatus = "Requires Premium";
            creativeColor = "#FFC107";
        }

        menuOptions.push({
            "title":        "创意模式",
            "description":  getString("creative-mode-desc"),
            "icon":         "images/" + ColonyGame.meta.showBuildSidebarIcon,
            "status":       creativeStatus,
            "status-color":  creativeColor,
            "overflow":     null,
            "tag":          "creative"
        });
        


        if(menuOptions.length == 1) {

            newCivSelected(menuOptions[0].tag);

            return;
        }


        showList("新游戏",menuOptions,onNewGameTypeSelected,getString("general-dismiss"));


        webAppCore.clearSplash();
        vehiclePathOrders = {};
        colonistPathOrders = {};
    }

    var creativeFlag = false;

    function onNewGameTypeSelected(tag) {
        if(tag == null) {
            return;
        }

        if(tag == "charter") {
            creativeFlag = false;
            setTimeout(showCharterMenu,750);
            return;
        }

        if(tag == "homeworld") {
            creativeFlag = false;
            setTimeout(showHomeworldSelection,750);
            return;
        }

        if(tag == "creative") {

            if(!webAppCore.getIsPremium()) {
                showPremiumMessage();
                showTitle();
                return;
            }

            creativeFlag = true;
            setTimeout(showHomeworldSelection,750);
            return;
        }
    }

    function showHomeworldSelection() {
        var i;
        
        var menuOptions = [];

        for(i = 0; i < ColonyGame.civilizations.length; i++) {
            menuOptions.push({
                "title":        ColonyGame.civilizations[i].name,
                "description":  getString(ColonyGame.civilizations[i].description),
                "icon":         "images/" + ColonyGame.civilizations[i].icon,
                "overflow":     null,
                "tag":          ColonyGame.civilizations[i]
            });
        }


        


        if(menuOptions.length == 1) {

            newCivSelected(menuOptions[0].tag);

            return;
        }


        showList("选择世界",menuOptions,newCivSelected,getString("general-dismiss"));
    }

    var tmpNewCiv;
    var tmpNewMapType;
    var tmpNewMotherlandName;
    var tmpNewMotherlandId;

    function newCivSelected(tag) {

        if(tag == null) {
            return;
        }

        if(tag == "charter") {
            setTimeout(showCharterMenu,750);
            return;
        }

        tmpNewCiv = tag;

        tmpNewMotherlandName = tmpNewCiv.name;
        tmpNewMotherlandId = 0;

        pauseThenShowMapChoices();
    }

    function pauseThenShowMapChoices() {
        
        setTimeout(showMapTypeChoices,750);
    }

    function showCharterMenu() {
        var data = [];

        data.push({
            "key":      "f",
            "value":    23
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onRandomCharterListBack);
    }

    function onRandomCharterListBack(result) {
        if(result == null || result.trim().length == 0) {
            return;
        }

        var charters = null;
        var i;

        try {
            charters = JSON.parse(result);
        } catch(ex) {
            console.log(ex);
            console.log(result);
            pauseThenShowCharterInput();
            return;
        }

        if(charters == null) {
            pauseThenShowCharterInput();
            return;
        }

        if(!charters.charters || charters.charters.length == 0) {
            pauseThenShowCharterInput();
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title":        "Custom Charter Code",
            "description":  "If you already know what charter code you want to use, select this option to input your code.",
            "icon":         "images/" + ColonyGame.meta.charterIndicator,
            "status":       null,
            "status-color":  null,
            "overflow":     null,
            "tag":          "custom"
        });

        for(i = 0; i < charters.charters.length; i++) {

            var cost = null;

            var taxString = "Normal";
            var taxColor = "#2196F3";

            if(charters.charters[i].taxes < 80) {
                taxString = "Below Normal";
                taxColor = "#00BCD4";
            }

            if(charters.charters[i].taxes < 50) {
                taxString = "Low";
                taxColor = "#26A69A";
            }

            if(charters.charters[i].taxes < 20) {
                taxString = "Very Low";
                taxColor = "#4CAF50";
            }

            if(charters.charters[i].taxes == 0) {
                taxString = "No Taxes";
            }

            if(charters.charters[i].taxes > 120) {
                taxString = "Above Normal";
                taxColor = "#3F51B5";
            }

            if(charters.charters[i].taxes > 150) {
                taxString = "High";
                taxColor = "#C2185B";
            }

            if(charters.charters[i].taxes > 180) {
                taxString = "Very High";
                taxColor = "#F44336";
            }

            if(charters.charters[i].taxes > 200) {
                taxString = "Extreme";
            }

            cost = [
                {
                    pre:    "Population: ",
                    post:   numberWithCommas(charters.charters[i].population),
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.colonistIcon
                },
                {
                    pre:    getString("empire-general") + " Population: ",
                    post:   numberWithCommas(charters.charters[i].cwpopulation),
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.empireIndicator
                },
                {
                    pre:    "GDP: ",
                    post:   numberWithCommas(charters.charters[i].totalgdp),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                },
                {
                    pre:    "Civilization: ",
                    post:   charters.charters[i].civilization,
                    color:  null,
                    icon:   "images/" + getCivilizationByName(charters.charters[i].civilization).icon
                },
                {
                    pre:    "RRR: ",
                    post:   charters.charters[i].rrr,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.indRRR
                },
                {
                    pre:    "Location: ",
                    post:   "Sector " + charters.charters[i].sector + "; " + charters.charters[i].location,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.dimensionIndicator
                },
                {
                    pre:    "Payroll Assistance Rate: ",
                    post:   charters.charters[i].payroll + "%",
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.polLaborInd
                },
                {
                    pre:    "Taxation: ",
                    post:   taxString,
                    color:  taxColor,
                    icon:   "images/" + ColonyGame.meta.taxCollectionInd
                }
            ];

            var salesPitch = null;

            if(charters.charters[i].info != "0" && charters.charters[i].info.trim().length > 0) {
                salesPitch = charters.charters[i].info;
            }

            menuOptions.push({
                "title":        charters.charters[i].name,
                "description":  salesPitch,
                "icon":         "images/" + getPlanetDefByName(charters.charters[i].maptype).icon,
                "status":       null,
                "status-color": null,
                "overflow":     cost,
                "tag":          charters.charters[i]
            });
        }

        showList("Select Charter",menuOptions,charterSelected,getString("general-dismiss"));
    }

    function charterSelected(tag) {

        if(tag == null) {
            return;
        }

        if(tag == "custom") {
            pauseThenShowCharterInput();
            return;
        }

        tmpNewCiv = {
            "name": tag.civilization,
            "race": tag.race
        };

        tmpNewMotherlandName = tag.name;
        tmpNewMotherlandId = tag.id;

        setTimeout(confirmUseCharter,750);
        
    }

    function confirmUseCharter() {
        webAppCore.showDialog({
            "title":    getString("general-charter"),
            "message":  getString("charter-warning"),
            "op1": {
                "text":     getString("general-yes"),
                "func":     pauseThenShowMapChoices
            },
            "op2": {
                "text":     getString("general-no"),
                "func":     pauseThenNewGame
            }
        });
    }

    function pauseThenNewGame() {
        setTimeout(newGame,750);
    }

    function pauseThenShowCharterInput() {

        console.log("pausing first");

        setTimeout(showCustomCharterInput,750);
    }

    function showCustomCharterInput() {

        var dialogOptions = {
            "title":    "Custom Charter Code",
            "message":  "If you already know what charter code you want to use, input your code below.",
            func: onCharterCodeInput
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onCharterCodeInput(input) {

        if(input == null || input.length == 0) {
            return;
        }

        var charter = input.trim();

        if(charter.length == 0) {
            newGameWithoutCharter();
            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    3
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "c",
            "value":    charter
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onCharterReturn);
    }

    function showMapTypeChoices() {
        tmpNewGameCustomMapData = null;

        if(tmpNewCiv == null) {
            return;
        }

        var choices,i,j;

        for(i = 0; i < ColonyGame.civilizations.length; i++) {
            if(ColonyGame.civilizations[i].name == tmpNewCiv.name) {
                choices = ColonyGame.civilizations[i].availableMaps;
                break;
            }
        }

        if(choices == null) {
            return;
        }

        if(choices.length == 1 && tmpNewMotherlandId == 0) {
            onMapTypeSelected(choices[0]);
            return;
        }

        var menuOptions = [];

        for(i = 0; i < choices.length; i++) {

            for(j = 0; j < ColonyGame.mapTypes.length; j++) {
                if(ColonyGame.mapTypes[j].name == choices[i]) {
                    menuOptions.push({
                        "title":        ColonyGame.mapTypes[j].name,
                        "description":  getString(ColonyGame.mapTypes[j].description),
                        "icon":         "images/" + ColonyGame.mapTypes[j].icon,
                        "status":       "难度: " + ColonyGame.mapTypes[j].difficulty,
                        "overflow":     null,
                        "tag":          ColonyGame.mapTypes[j].name
                    });
                }
            }

            
        }

        // for offline games, allow custom maps
        if(tmpNewMotherlandId == 0) {
            menuOptions.push({
                "title":        getString("general-custom-map"),
                "description":  getString("general-custom-map-desc"),
                "icon":         null,
                "status":       "Requires Premium",
                "status-color": "#FFC107",
                "overflow":     null,
                "tag":          "custommap"
            });
        }

        showList("Select Map Type",menuOptions,onMapTypeSelected,getString("general-dismiss"));
    }

    function tvDeviceMapNameReturn(data) {
        
        if(data == null || data.trim().length == 0) {


            showHiders();
            titleShowing = true;
            bulldozerMode = false;
            webAppCore.setTitleVisible(true);
            webAppCore.handleBackFunction(null);

            webAppCore.showToast("Invalid Name");

            return;
            
        }

        vehiclePathOrders = {};
        colonistPathOrders = {};

        bulldozerMode = false;
        titleShowing = false;
        webAppCore.setTitleVisible(false);
        webAppCore.handleBackFunction(standardBack);

        showListingAfterSave = false;

        Scroll2d.forceSceneChange();


        newGameWithoutCharter(data.trim());

    }

    var tmpNewGameCustomMapData = null;
    
    function newGameCustomMapSelected(mapdata) {

        webAppCore.clearSplash();

        if(!mapdata) {
            return;
        }

        webAppCore.clearSplash();
        setupMenuOptions();
        window.focus();

        tmpNewGameCustomMapData = mapdata;

        var dialogOptions = {
            title: getString("new-game"),
            message: getString("new-game-col-name"),
            func: tvDeviceMapNameReturn
        };

        webAppCore.inputBox(dialogOptions);
        
    }

    function onMapTypeSelected(type) {

        if(type == "custommap") {

            if(!webAppCore.getIsPremium()) {
                showPremiumMessage();
                return;
            }

            loadCustomMap(newGameCustomMapSelected,"general-custom-map");
            return;
        }

        if(!type) {
            
            showHiders();
            titleShowing = true;
            bulldozerMode = false;
            webAppCore.setTitleVisible(true);
            webAppCore.handleBackFunction(null);


            return;
        }


        tmpNewMapType = type;


        if(webAppCore.isTV()) {

            webAppCore.clearSplash();
            setupMenuOptions();
            window.focus();

            var dialogOptions = {
                title: getString("new-game"),
                message: getString("new-game-col-name"),
                func: tvDeviceMapNameReturn
            };

            webAppCore.inputBox(dialogOptions);

            return;
        }


        var hiders = document.querySelectorAll(".newGameHide");

        var i;

        for(i = 0; i < hiders.length; i++) {
            hiders[i].style.display = "none";
        }

        webAppCore.setTheme("#000000");

        document.getElementById("newGameMenu").style.display = "block";

        if(window.innerWidth < 600) {
            document.getElementById("mapSizeSmall").checked = true;
            document.getElementById("mapSizeMedium").checked = false;
        } else {
            document.getElementById("mapSizeSmall").checked = false;
            document.getElementById("mapSizeMedium").checked = true;
        }

        document.getElementById("btnNoNewGame").style.display = "block";

        webAppCore.clearSplash();
        setupMenuOptions();
        window.focus();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        titleShowing = false;
        bulldozerMode = false;
        webAppCore.setTitleVisible(false);
        webAppCore.handleBackFunction(standardBack);

        showListingAfterSave = false;

        Scroll2d.forceSceneChange();
    }

    function onCharterReturn(result) {

        if(result != null || result.trim().length > 0) {
            try {
                var charterInfo = JSON.parse(result);

                tmpNewCiv = {
                    "name": charterInfo.civilization,
                    "race": charterInfo.race
                };

                tmpNewMotherlandName = charterInfo.colonyname;
                tmpNewMotherlandId = charterInfo.colonyid;

            } catch(ex) {
                console.log(ex);
                console.log(result);
                webAppCore.showToast("Invalid Charter!");
                pauseThenNewGame();
                return;
            }
        }

        setTimeout(confirmUseCharter,750);

    }

    var isCreatingNewOnlineGame = false;

    function createNewGame(name,width,height,resourceLevel) {

        var civDef = getCivilizationByName(tmpNewCiv.name);

        showHiders();

        webAppCore.setTheme(ColonyGame.meta.theme);

        webAppCore.storeVar("has-warned-has-played","1");

        tmpBuildingRefHolder = {};

        buildingUpdateCycle = true;

        var offline = false;

        if(tmpNewMotherlandId == 0) {
            offline = true;
        }

        runningColonistReferenceArray = {};

        if(tmpNewGameCustomMapData != null) {
            tmpNewMapType = tmpNewGameCustomMapData.mapType;
        }

        currentGame = new Game(width,height,{
            "name":         name,
            "disableTax":   false,
            "motherland":   tmpNewMotherlandName,
            "motherlandid": tmpNewMotherlandId,
            "mapType":      tmpNewMapType,
            "defaultRace":  tmpNewCiv.race,
            "civilization": civDef.name,
            "offline":      offline
        });

        if(creativeFlag) {
            creativeFlag = false;
            currentGame.cm = true;
            currentGame.offlineMode = true;
            currentGame.hasCheated = true;
        }

        if(tmpNewGameCustomMapData != null) {
            currentGame.offlineMode = true;
            currentGame.hasCheated = true;
        }

        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        retainedUsage = {};

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;
        resourceUpdateTurn = true;
        shoreUpdateTurn = true;

        if(!currentGame.offlineMode) {
            isCreatingNewOnlineGame = true;

            establishSocketConnection();
            registerColonyId();
            
        }

        setupResourceLedger();

        setMapType();

        Scroll2d.setMapDims(width,height);

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedColonist = null;
        selectedPassable = null;

        pendingBuildX = null;
        pendingBuildY = null;
        queuedBuildings = undefined;
        queuedBuilding = null;
        queuedBuildingBlocked = false;
        
        createCollisionReference();
        
        var i,j;
        var firstBuilding = null;
        var buildingX = Math.floor(currentGame.width / 2);
        var buildingY = Math.floor(currentGame.height / 2);

        if(tmpNewGameCustomMapData != null) {
            buildingX = tmpNewGameCustomMapData.startX;
            buildingY = tmpNewGameCustomMapData.startY;
        }
    
        Scroll2d.setZoomLevel(1);
        Scroll2d.centerOnCoord(buildingX,buildingY);

        var buildingDef,rndX,rndY,randomBuilding;
        
        
        if(civDef.startingBuilding != null) {
            buildingDef = getBuildingDefByName(civDef.startingBuilding);
            
            firstBuilding = new Building(buildingDef,buildingX,buildingY,0);

            updateBuildingCollisionPoints(firstBuilding,150);

            freeRefNukeTurn = true;

            currentGame.buildings.push(firstBuilding);
            shouldUpdateCollissionMap = true;

            currentGame.centerBuildingId = firstBuilding.id;
        }

        if(workingMapType.explosionDisasters != null) {
            for(i = 0; i < workingMapType.explosionDisasters.length; i++) {
                currentGame.disasterCounters[workingMapType.explosionDisasters[i].name] = randomIntFromInterval(0,workingMapType.explosionDisasters[i].frequency);
            }
        }


        // random starting buildings 
        for(i = 0; i < workingMapType.startingBuildings.length; i++) {



            buildingDef = getBuildingDefByName(workingMapType.startingBuildings[i]);

            rndX = randomIntFromInterval(2,currentGame.width - 2);
            rndY = randomIntFromInterval(2,currentGame.height - 2);
            
            randomBuilding = new Building(buildingDef,rndX,rndY,0);

            if(buildingDef.canFlip) {
                if(randomIntFromInterval(0,1) == 1) {
                    randomBuilding.flipped = true;
                }
            }

            updateBuildingCollisionPoints(randomBuilding,150);

            freeRefNukeTurn = true;

            currentGame.buildings.push(randomBuilding);
            shouldUpdateCollissionMap = true;

        }

        // first see if this map has a river 
        if(workingMapType.riverTile != null && tmpNewGameCustomMapData == null) {
            createRiver(workingMapType.riverTile,workingMapType.riverPosition);
        }

        if(tmpNewGameCustomMapData == null) {
            // setup terrains
            for(i = 0; i < workingMapType.terrainFeatures.length; i++) {

                var terrainCount = Math.ceil(workingMapType.terrainFeatures[i].abundance * resourceLevel);
                var terrainDef = getTerrainDefByName(workingMapType.terrainFeatures[i].name);

                for(j = 0; j < terrainCount; j++) {
                        
                    rndX = randomIntFromInterval(2,currentGame.width - 2);
                    rndY = randomIntFromInterval(2,currentGame.height - 2);

                    if(!checkForGeneralBlockage(terrainDef,rndX,rndY)) {
                        var resourceItem = new MapResource(terrainDef,rndX,rndY);
                        freeRefNukeTurn = true;
                        updateBuildingCollisionPoints(resourceItem,150);
                        currentGame.mapResources.push(resourceItem);
                        shoreUpdateTurn = true;
                    } 
                }
            }
        } else {
            insertCustomMapTerrainIntoGame(currentGame,tmpNewGameCustomMapData);
        }

        // setup map resource level mods
        for(i = 0; i < workingMapType.startingResourceModifiers.length; i++) {

            modifyResourceAmount(workingMapType.startingResourceModifiers[i].name,workingMapType.startingResourceModifiers[i].modifier,false,"Initial");

            if(currentGame.resources[workingMapType.startingResourceModifiers[i].name].amount < 0) {
                modifyResourceAmount(workingMapType.startingResourceModifiers[i].name,0,true,"Initial");
            }
        }

        // goose up starting colonists 
        for(i = 0; i < civDef.startingColonists; i++) {
            var freedom = getFreeSpaceAroundTile(buildingX,buildingY,3);

            if(freedom.length > 0) {
                var newColonist = new Colonist(freedom[0][0],freedom[0][1],false,currentGame.defaultRace);
                setupNewColonist(newColonist);
    
                newColonist.def.tile = getColonistTile(newColonist);
    
                currentGame.colonists.push(newColonist);
            }
            
            
        }

        // goose up starting vehicles
        for(i = 0; i < civDef.startingVehicles.length; i++) {
            var freedomV = getFreeSpaceAroundTile(buildingX,buildingY,3);

            if(freedomV.length > 0) {
                var vDef = getVehicleDefByName(civDef.startingVehicles[i]);
                
                if(vDef.requiresTech != null) {
    
                    var notAvailable = false;
    
                    for(j = 0; j < vDef.requiresTech.length; j++) {
    
    
                        var techParts = vDef.requiresTech[j].split("|");
    
                        var hasThisOne = false;
    
                        for(var k = 0; k < techParts.length; k++) {
                            if(currentGame.unlockedTechs[techParts[k]]) {
                                hasThisOne = true;
                            }
                        }
    
                        if(!hasThisOne) {
                            notAvailable = true;
                        }
    
                    }
    
                    if(notAvailable) {
                        continue;
                    }
                }
                
                var useIndex = randomIntFromInterval(0,freedomV.length - 1);
    
                var freshVehicle = new Vehicle(vDef,freedomV[useIndex][0],freedomV[useIndex][1],0);
                currentGame.vehicles.push(freshVehicle);
            }

            

        }
        
        if(!currentGame.offlineMode) {
            setTimeout(refreshMarketPrices,600);
        }
        

        createCollisionReference();
        
        updateUtilityGrid();

        gooseUpColonistReferences();
        
        Scroll2d.forceSceneChange();

        Scroll2d.setZoomLevel(1);

        //centerMap();

        Scroll2d.centerOnCoord(buildingX,buildingY);

        setCenterMapIcon();

        webAppCore.clearSplash();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        currentFileName = cleanFileName(name) + "." + ColonyGame.meta.fileExtension;

        var welcomeMessageToUse = civDef.welcomeMessage;

        if(tmpNewGameCustomMapData == null) {
            if(getPlanetDefByName(tmpNewMapType).welcomeOverride != null) {
                welcomeMessageToUse = getPlanetDefByName(tmpNewMapType).welcomeOverride;
            }
    
            webAppCore.showAlertWithTitle(getString(welcomeMessageToUse),name);
            
        } else {
            webAppCore.showAlertWithTitle(tmpNewGameCustomMapData.description,tmpNewGameCustomMapData.name);
        }
        

        saveGame();

        createSidebar();
        drawSidebar();

        setupMenuOptions();
        
        initSoundtrack();

        Scroll2d.forceSceneChange();

        setWeather();

        tmpNewGameCustomMapData = null;
    }

    var mapfilter = null;
    var mapFilterStrength = 0;

    function setWeather() {

        if(!currentGame) {
            mapfilter = null;
            Scroll2d.setColorFilter(null);
            return;
        }

        var planetdef = getPlanetDefByName(currentGame.mapType);

        if(planetdef == null) {
            Scroll2d.setSnowing(false);
            Scroll2d.setEmbers(false);
            Scroll2d.setColorFilter(null);
            mapfilter = null;
        } else {

            if(planetdef.weatherEffect && allowParticleEffects) {
                if(planetdef.weatherEffect == "snowing") {
                    Scroll2d.setSnowing(true);
                } else {
                    Scroll2d.setSnowing(false);
                }

                if(planetdef.weatherEffect == "embers") {
                    Scroll2d.setEmbers(true);
                } else {
                    Scroll2d.setEmbers(false);
                }
                
            } else {
                Scroll2d.setSnowing(false);
                Scroll2d.setEmbers(false);
            }

            if(planetdef.colorEffect) {
                mapfilter = planetdef.colorEffect;
                mapFilterStrength = planetdef.colorStrength;
                Scroll2d.setColorFilter(planetdef.colorEffect,planetdef.colorStrength);
            } else {
                mapfilter = null;
                Scroll2d.setColorFilter(null);
            }

            
        }
    }

    function performAnnex() {
        var currentTiles = currentGame.width * currentGame.height;
        var newTiles = (currentGame.width + 20) * (currentGame.height + 20);

        var difference = newTiles - currentTiles;

        var canAfford = true;
        var i;

        for(i = 0; i < ColonyGame.meta.annexTileCost.length; i++) {
            if((difference * ColonyGame.meta.annexTileCost[i].amount) > currentGame.resources[ColonyGame.meta.annexTileCost[i].resource].amount) {
                canAfford = false;
            }
        }

        if(!canAfford) {
            webAppCore.showToast(getString("general-cant-afford"));
            return;
        }

        for(i = 0; i < ColonyGame.meta.annexTileCost.length; i++) {
            modifyResourceAmount(ColonyGame.meta.annexTileCost[i].resource,-(ColonyGame.meta.annexTileCost[i].amount * difference),false,"Land");
        }

        currentGame.height += 20;
        currentGame.width += 20;

        Scroll2d.setMapDims(currentGame.width,currentGame.height);
        createCollisionReference();

        // setup terrains
        for(i = 0; i < workingMapType.terrainFeatures.length; i++) {

            var terrainCount = Math.ceil(workingMapType.terrainFeatures[i].abundance * .2);
            var terrainDef = getTerrainDefByName(workingMapType.terrainFeatures[i].name);

            for(var j = 0; j < terrainCount; j++) {

                var halfChance = randomIntFromInterval(0,1);
                var rndX,rndY;

                if(halfChance == 0) {
                    rndX = randomIntFromInterval(0,currentGame.width - 2);
                    rndY = randomIntFromInterval(currentGame.height - 18,currentGame.height - 2);
                } else {
                    rndX = randomIntFromInterval(currentGame.width - 18,currentGame.width - 2);
                    rndY = randomIntFromInterval(0,currentGame.height - 18);
                }

                if(!checkForGeneralBlockage(terrainDef,rndX,rndY)) {
                    var resourceItem = new MapResource(terrainDef,rndX,rndY);
                    freeRefNukeTurn = true;
                    updateBuildingCollisionPoints(resourceItem,150);
                    currentGame.mapResources.push(resourceItem);
                    shoreUpdateTurn = true;
                } 
            }
        }

        
        
    }

    function getPlanetDefByName(name) {
        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(name == ColonyGame.mapTypes[i].name) {
                return ColonyGame.mapTypes[i];
            }
        }

        return null;
    }

    function getCivilizationByName(name) {
        for(var i = 0; i < ColonyGame.civilizations.length; i++) {
            if(name == ColonyGame.civilizations[i].name) {
                return ColonyGame.civilizations[i];
            }
        }

        return null;
    }
    
    function cleanFileName(name) {
        var clean = name.replace(/([^a-z0-9]+)/gi, "-");
        return clean.toLowerCase();
    }
    
    function createUtilityGridIfNonexistant() {
        if(!currentGame.utilities) {
            currentGame.utilities = {};
        }
        
        for(var i = 0; i < ColonyGame.utilities.length; i++) {
            if(!currentGame.utilities[ColonyGame.utilities[i].name]) {
                currentGame.utilities[ColonyGame.utilities[i].name] = {};
                currentGame.utilities[ColonyGame.utilities[i].name].usage = 0;
                currentGame.utilities[ColonyGame.utilities[i].name].capacity = 0;
            }
        }
        
        
    }
    
    function updateUtilityGrid() {
        
        var i,j,utr;
        
        createUtilityGridIfNonexistant();

        for(var prop in currentGame.utilities) {
            currentGame.utilities[prop].usage = 0;
            currentGame.utilities[prop].capacity = 0;
        }



        for(var res in currentGame.resources) {
            if(currentGame.resources[res].capacity == -1) {
                currentGame.resources[res].storageCapacity = 0;
            }
        }


        for(i = 0; i < currentGame.buildings.length; i++) {

            var bdl = currentGame.buildings[i];

            if(bdl.isBeingRemoved) {
                continue;
            }

            if(bdl.deactivated) {
                continue;
            }

            if(bdl.isUnderConstruction) {
                continue;
            }

            var workingDef = getBuildingDefByName(bdl.def);

            if(workingDef == null) {
                continue;
            }

            if(workingDef.providesUtility != null && !bdl.noConsumptionMode) {   
                for(j = 0; j < workingDef.providesUtility.length; j++) {
                    utr = workingDef.providesUtility[j];
                    currentGame.utilities[utr.utility].capacity += utr.amount;
                }
            }
            
            if(workingDef.requiresUtility != null) {
                for(j = 0; j < workingDef.requiresUtility.length; j++) {
                    utr = workingDef.requiresUtility[j];
                    currentGame.utilities[utr.utility].usage += utr.amount;
                }
            }

            if(workingDef.stores != null) {
                for(j = 0; j < workingDef.stores.length; j++) {
                    utr = workingDef.stores[j];
                    currentGame.resources[utr.resource].storageCapacity += utr.amount;
                }
            }
        }
    }

    var constructionProjectsArray;
    var openVenuesArray;
    var openJobsArray;
    var openMedicalArray;
    var openHomesArray;
    var openSpaceportArray;
    var openTourismArray;
    var openStargateArray;

    var simUpdateCycle = false;
    var simUpdateMax = 5;
    var simUpdateTicker = simUpdateMax;

    var buildingUpdateCycle = false;
    var buildingUpdateCycles = 8;
    var buildingUpdateTicker = buildingUpdateCycles;

    var tmpUsingTouch;

    var resourceLedger;

    var earthTaxTurn = false;
    var earthTaxAmount = 0;
    var payrollTurn = false;
    var pendingSalary = 0;
    var hasStargate = false;

    function updateBuildings() {

        ticksPerMinuteCounter++;

        var i,j,len;

        var killArray = [];
        var passableKills = [];
        medicalCoveragePoints = [];


        allHomesArray = [];
        allJobsArray = [];

        spriteChangeCounter++;

        if(spriteChangeCounter >= 1) {
            spriteChangeCounter = 0;
            spriteChangeTurn = true;
        } else {
            spriteChangeTurn = false;
        }

        var bdef = null;

        var fullHousing = 0;
        var tmpAvailShelter = 0;


        for(i = 0, len = currentGame.buildings.length; i < len; i++) {

            if(currentGame.buildings[i].isBeingRemoved) {
                shouldUpdateCollissionMap = true;
            }

            if(currentGame.buildings[i] == null) {
                killArray.push(currentGame.buildings[i]);
                continue;
            }

            bdef = getBuildingDefByName(currentGame.buildings[i].def);

            if(currentGame.buildings[i].condition <= 0 || currentGame.buildings[i].isBeingRemoved) {
                killArray.push(currentGame.buildings[i]);

                if(currentGame.buildings[i].isBeingRemoved && currentGame.buildings[i].isUnderConstruction) {
                    for(var c = 0; c < bdef.cost.length; c++) {
                        var toreimburse = bdef.cost[c].amount - currentGame.buildings[i].c.pr[bdef.cost[c].resource];

                        if(toreimburse > 0) {
                            modifyResourceAmount(bdef.cost[c].resource,toreimburse);
                        }
                    }
                }

                continue;
            }

            if(freeRefNukeTurn) {
                currentGame.buildings[i].freeRef = null;
            }

            if(!currentGame.buildings[i].deactivated && !currentGame.buildings[i].isUnderConstruction && currentGame.buildings[i].embassyFor == 0) {
                currentGame.availableShelters += bdef.providesShelter;
                currentGame.availableTourism += bdef.takesTourists;
            }

            updateBuilding(currentGame.buildings[i]);

            if(currentGame.buildings[i].embassyFor == 0 && !currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated) {
                

                if(currentGame.buildings[i].residents.length > bdef.providesShelter) {
                    handleBuildingWorkerCleanup(currentGame.buildings[i]);
                }

                tmpAvailShelter += bdef.providesShelter;
                fullHousing += currentGame.buildings[i].residents.length;
            }

            if(currentGame.buildings[i].isUnderConstruction) {
                constructionProjectsArray.push(currentGame.buildings[i]);
            }

            if(currentGame.buildings[i].embassyFor == 0 && !currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && currentGame.buildings[i].openForEntertainment) {
                openVenuesArray.push(currentGame.buildings[i]);
            }

            if(!currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && bdef.touristDoorway) {
                openSpaceportArray.push(currentGame.buildings[i]);
            }

            if(!currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && bdef.isStargate) {
                openStargateArray.push(currentGame.buildings[i]);
                hasStargate = true;
            }

            if(!currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && currentGame.buildings[i].openForTourism) {
                openTourismArray.push(currentGame.buildings[i]);
            }
            

            if(currentGame.buildings[i].embassyFor == 0 && !currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && currentGame.buildings[i].jobsAvailable > 0) {
                openJobsArray.push(currentGame.buildings[i]);
            }

            if(currentGame.buildings[i].embassyFor == 0 && !currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && currentGame.buildings[i].openForMedical) {
                openMedicalArray.push(currentGame.buildings[i]);
            }

            if(currentGame.buildings[i].embassyFor == 0 && !currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && currentGame.buildings[i].availableHomes > 0) {
                openHomesArray.push(currentGame.buildings[i]);
            }

            if(currentGame.buildings[i].embassyFor == 0 && !currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated && earthTaxTurn && bdef.earthTaxValue) {
                earthTaxAmount += bdef.earthTaxValue;
            }

            if(payrollTurn && bdef.acceptsWorkers) {

                var salary = 1;

                if(currentGame.salaries.Unskilled != null) {
                    salary = currentGame.salaries.Unskilled;
                }

                if(bdef.occupation != null) {

                    if(currentGame.salaries[bdef.occupation] != null) {
                        salary = currentGame.salaries[bdef.occupation];
                    } else {
                        salary = getOccupationDefByName(bdef.occupation).salary;
                    }
                }

                for(j = 0; j < currentGame.buildings[i].workers.length; j++) {
                    pendingSalary += salary;
                }
            }
        }

        runningHomelessCount = getTotalPopulation() - fullHousing;

        if(runningHomelessCount < 0) {
            runningHomelessCount = 0;
        }

        

        bdef = null;

        // under construction passables
        for(i = 0, len = currentGame.passableNonUpdatables.length; i < len; i++) {

            if(currentGame.passableNonUpdatables[i].isBeingRemoved) {
                passableKills.push(currentGame.passableNonUpdatables[i]);
                continue;
            }

            if(freeRefNukeTurn) {
                currentGame.passableNonUpdatables[i].freeRef = null;
            }

            updatePassable(currentGame.passableNonUpdatables[i]);

            if(currentGame.passableNonUpdatables[i].isUnderConstruction) {
                constructionProjectsArray.push(currentGame.passableNonUpdatables[i]);
            } else {
                passableKills.push(currentGame.passableNonUpdatables[i]);

                if(!currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def]) {
                    currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def] = {};
                }

                if(!currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def][currentGame.passableNonUpdatables[i].x]) {
                    currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def][currentGame.passableNonUpdatables[i].x] = [];
                }

                currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def][currentGame.passableNonUpdatables[i].x].push(currentGame.passableNonUpdatables[i].y);

                shouldUpdateCollissionMap = true;
            }
        }

        // new, complete passables 
        for(var passdef in currentGame.finishedPassableNonUpdatables) {
            var td = currentGame.finishedPassableNonUpdatables[passdef];
            for(var passX in td) {
                var tx = td[passX];
                for(var ty = 0; ty < tx.length; ty++) {
                    var passY = tx[ty];
                    updateNewPassable(passdef,passX,passY);
                }
            }
        }

        shoreReferenceChart = {};

        for(i = 0, len = currentGame.mapResources.length; i < len; i++) {

            if(freeRefNukeTurn) {
                currentGame.mapResources[i].freeRef = null;
            }

            updateMapResource(currentGame.mapResources[i]);

            
            

            if(currentGame.mapResources[i].inventory <= 0) {

                if(currentGame.mapResources[i].playDef != null && currentGame.mapResources[i].playDef.capacity != null && currentGame.mapResources[i].playDef.capacity != -1) {
                    resourceKillArray.push(currentGame.mapResources[i]);
                }

                
            }
        }

        if(shoreUpdateTurn) {


            for(i = 0, len = currentGame.mapResources.length; i < len; i++) {
                setTerrainShoreFrame(currentGame.mapResources[i]);
            }

            shoreReferenceChart = {};
            
            shoreUpdateTurn = false;
        }

        

        // go through second time to deal with spreading
        for(i = 0, len = currentGame.mapResources.length; i < len; i++) {
            updateMapResourceSpreading(currentGame.mapResources[i]);

        }

        


        while(passableKills.length > 0) {
            removeFromArray(currentGame.passableNonUpdatables,passableKills.shift());
        }


        while(killArray.length > 0) {
            var kill = killArray.shift();

            if(kill.condition <= 0) {
                currentGame.destroyedBuildings++;

                for(j = 0; j < kill.occupiesTiles.length; j++) {
                    if(allowParticleEffects) {
                        Scroll2d.playParticleEffect("explosion",kill.occupiesTiles[j].x,kill.occupiesTiles[j].y);
                    }

                    if(allowAudio && ColonyGame.sounds.explosion != null) {
                        webAppCore.playSoundEffect(ColonyGame.sounds.explosion);
                    }
                }
            }

            while(kill.workers.length > 0) {
                if(kill.workers[0].colonistId < 0) {
                    kill.workers.shift();
                } else {

                    var theworker = getColonistById(kill.workers[0].colonistId);

                    if(kill == null || theworker == null) {
                        kill.workers.shift();
                    } else {
                        removeWorker(kill,theworker,"destroy-building");
                    }

                    
                }
            }

            while(kill.residents.length > 0) {
                if(kill.residents[0] < 0) {
                    kill.residents.shift();
                } else {

                    var theResident = getColonistById(kill.residents[0]);

                    if(kill == null || theResident == null) {
                        kill.residents.shift();
                    } else {
                        removeResident(kill,theResident);
                    }

                    
                }
            }

            removeFromArray(currentGame.buildings,kill);
        }

        freeRefNukeTurn = false;

    }

    function updateTickers() {

        simUpdateMax = 5;

        var pop = currentGame.colonists.length;

        if(pop > 8000) {
            simUpdateMax = 6;

            if(pop > 16000) {
                simUpdateMax = 7;

                if(pop > 32000) {
                    simUpdateMax = 8;

                    if(pop > 64000) {
                        simUpdateMax = 9;

                        if(pop > 128000) {
                            simUpdateMax = 10;

                            if(pop > 256000) {
                                simUpdateMax = 11;

                                if(pop > 512000) {
                                    simUpdateMax = 12;
                                }
                            }
                        }
                    }
                }
            }
        }

        earthTaxTurn = false;
        earthTaxAmount = 0;
        payrollTurn = false;
        pendingSalary = 0;

        gotItMadePrice = 0;

        var i;

        for(i = 0; i < ColonyGame.meta.retirementRequirements.length; i++) {

            var res = ColonyGame.meta.retirementRequirements[i].resource;
            var amt = ColonyGame.meta.retirementRequirements[i].amount;

            gotItMadePrice += (currentGame.resources[res].price * amt);
        }


        simUpdateTicker++;

        if(simUpdateTicker >= simUpdateMax) {
            simUpdateCycle = true;
            simUpdateTicker = 0;
            reconcileResources();
        } else {
            simUpdateCycle = false;
        }
        
        buildingUpdateTicker++;
        if(buildingUpdateTicker >= buildingUpdateCycles) {
            buildingUpdateCycle = true;
            buildingUpdateTicker = 0;
            hasConsulate = false;
            hasCapitol = false;
            ourCapitolBuilding = null;
        } else {
            buildingUpdateCycle = false;
        }

        
        if(!saveInProgress) {
            currentGame.earthTaxCounter++;
            currentGame.monthEndCounter++;
            currentGame.rewardCounter++;
            mailCheckTimer++;
        }

        if(currentGame.earthTaxCounter >= 50000) {
            earthTaxTurn = true;
            currentGame.earthTaxCounter = 0;
            buildingUpdateCycle = true;
            buildingUpdateTicker = 0;
        }

        if(currentGame.monthEndCounter >= 65000) {
            payrollTurn = true;
            currentGame.monthEndCounter = 0;
            buildingUpdateCycle = true;
            buildingUpdateTicker = 0;
        }

        if(currentGame.rewardCounter >= 210000) {
            if(!currentGame.showRewardOption) {
                currentGame.showRewardOption = true;
                currentGame.mail.push(new MailMessage(getString("general-gift-giver"),0,getString("general-gift-message"),dateToReadable(Date.now()),"-1",null,null));
            }

            if(currentGame.rewardCounter > 500000) {
                currentGame.rewardCounter = 0;
                currentGame.showRewardOption = false;
            }
        }

        if(mailCheckTimer == Math.round(mailCheckLimit / 2)) {
            getPendingEmbassyRequests();
        }

        if(mailCheckTimer >= mailCheckLimit) {
            mailCheckTimer = 0;
            checkMail();
        }



        retainedPathsCounter++;

        if(retainedPathsCounter >= 8500) {
            cleanRetainedPaths();
            shouldUpdateCollissionMap = true;
            retainedPathsCounter = 0;
        }
        

        lowCapacityCounter++;

        utilityGridCounter++;
    }

    var lastZoomLevel = 0;
    var simulatedTileSize = 0;

    var riotingWarned = false;
    var anarchyWarned = false;
    var famineWarned = false;
    var noWaterWarned = false;
    var giftCapacity = 0;

    var currentViewBounds;

    var inBackgroundMode = false;
    var backgroundUpdateCounter = 0;

    var spriteChangeCounter = 0;
    var spriteChangeTurn = false;

    var allHomesArray = [];
    var allJobsArray = [];

    var globalconsumptioncounter = 0;
    var currentTotalIllegals = 0;

    var minWidthSetTimer = 5;

    var lastBorderColor = null;
    var lastColorFilter = null;

    var timeOfDayCounter = 0;

    var monitoringFPS = true;
    var monitorFPSCount = 0;

    var contractPostTimeout = 0;
    var ticksPerMinuteCounter = 0;

    var tpmChecker = 0;

    var currentTicksPerMinute = 200;

    var lastTimestamp = 0;

    function update(timestamp) {

        
        if(lastTimestamp == 0) {
            lastTimestamp = timestamp;
        }
        

        if(!currentGame) {
            return;
        }
        
        if(killSwitch) {
            return;
        }

        if(inBackgroundMode) {
            backgroundUpdateCounter++;

            if(backgroundUpdateCounter < 10) {
                return;
            }

            backgroundUpdateCounter = 0;
        }

        if(lastTimestamp > 0) {
            tpmChecker += (timestamp - lastTimestamp);
            
            if(tpmChecker >= 60000) {
                currentTicksPerMinute = ticksPerMinuteCounter;
                ticksPerMinuteCounter = 0;
                tpmChecker = 0;
            }
        }

        lastTimestamp = timestamp;

        if(monitoringFPS && fpsRate < 4 && !inBackgroundMode) {
            monitorFPSCount++;

            if(monitorFPSCount > 200) {

                monitorFPSCount = 0;

                var fps = Scroll2d.getFPS();

                if(fps < 50) {
                    incrementFPS();
                }

            }
        }

        if(silosNeededCooldown > 0) {
            silosNeededCooldown--;
        }

        if(silosNeededCooldown < 0) {
            silosNeededCooldown = 0;
        }

        if(contractPostTimeout > 0) {
            contractPostTimeout--;
        }

        if(contractPostTimeout < 0) {
            contractPostTimeout = 0;
        }

        if(!currentGame.mem) {
            for(var disaster in currentGame.disasterCounters) {
                currentGame.disasterCounters[disaster]--;
    
                if(currentGame.disasterCounters[disaster] <= 0) {
                    playDisaster(disaster);
                }
            }
        }
        

        var useColorFilter = null;
        var useBorderColor = null;
        var useStrength = 0.2;

        timeOfDayCounter++;

        if(timeOfDayCounter >= 1000) {
            currentGame.timeOfDay++;

            if(currentGame.timeOfDay > 24) {
                currentGame.timeOfDay = 0;
            }

            timeOfDayCounter = 0;
        }

        if(statsOpen && gamepadInUse) {
            if(padReference.rup) {
                document.getElementById("statsMain").scrollTop -= 45;
            }

            if(padReference.rdown) {
                document.getElementById("statsMain").scrollTop += 45;
            }
        }

        if(allowDayNight == "0") {
            currentGame.timeOfDay = 12;
        }

        if(allowDayNight == "2") {
            currentGame.timeOfDay = 0;
        }

        if(bulldozerMode) {
            useColorFilter = "#ff0000";
            useBorderColor = "#ff0000";
        } else {
            useColorFilter = mapfilter;
            useBorderColor = null;
            useStrength = mapFilterStrength;

            if(mapfilter == null) {
                if(currentGame.timeOfDay >= 21 || currentGame.timeOfDay <= 5) {
                    useColorFilter = "#000000";
                    useStrength = 0.8;
                }

                if(currentGame.timeOfDay == 20 || currentGame.timeOfDay == 6) {
                    useColorFilter = "#442a01";
                    useStrength = 0.7;
                }

                if(currentGame.timeOfDay == 19 || currentGame.timeOfDay == 7) {
                    useColorFilter = "#5e3c07";
                    useStrength = 0.5;
                }

                if(currentGame.timeOfDay == 18 || currentGame.timeOfDay == 8) {
                    useColorFilter = "#a57b3a";
                    useStrength = 0.3;
                }
            }
        }

        if(!allowLighting) {
            useColorFilter = null;
        }

        if(useColorFilter != lastColorFilter) {
            Scroll2d.setColorFilter(useColorFilter,useStrength);
            lastColorFilter = useColorFilter;
        }

        if(useBorderColor != lastBorderColor) {
            Scroll2d.setBorderColor(useBorderColor);
            lastBorderColor = useBorderColor;
        }

        if(selectedBuilding == null) {
            medicalCoverageMode = false;
            entertainmentCoverageMode = false;
        }

        minWidthSetTimer++;

        if(minWidthSetTimer >= 100) {
            setMinWidths();
            minWidthSetTimer = 0;
        }

        currentViewBounds = Scroll2d.getViewBounds();

        if(currentGame.offlineMode) {
            exportPenalty = 0.05;
            importPenalty = 0.02;
            importPriceMod = 1.10;
            exportPriceMod = 0.90;
        } else {
            exportPenalty = 0.75;
            importPenalty = 0.50;
            importPriceMod = 2;
            exportPriceMod = 0.25;
        }

        var curZoom = Scroll2d.getZoomLevel();

        if(curZoom != lastZoomLevel) {
            lastZoomLevel = curZoom;
            simulatedTileSize = ColonyGame.meta.gridSize * lastZoomLevel;
            staticFrame = false; 
        }

        tmpUsingTouch = Scroll2d.getUsingTouch();

        if(tmpUsingTouch != usingTouch) {
            usingTouch = tmpUsingTouch;

            setBodyStyles();

        }

        if(isNaN(currentGame.earthTaxCounter)) {
            currentGame.earthTaxCounter = 0;
        }

        if(isNaN(currentGame.stage)) {
            currentGame.stage = 0;
        }

        if(isNaN(currentGame.monthEndCounter)) {
            currentGame.monthEndCounter = 0;
        }

        updateTickers();

        resourceKillArray = [];
        colonistKillArray = [];
        vehicleKillArray = [];

        updateTicker();

        if(buildingUpdateCycle) {
            openVenuesArray = [];
            openJobsArray = [];
            openMedicalArray = [];
            openHomesArray = [];
            openSpaceportArray = [];
            openStargateArray = [];
            openTourismArray = [];
            constructionProjectsArray = [];

            resetCollisionReference();
            previouslyAvailableShelters = currentGame.availableShelters;
            currentGame.availableShelters = 0;
            previouslyAvailableTourism = currentGame.availableTourism;
            currentGame.availableTourism = 0;
            giftCapacity = 0;

            hasStargate = false;
        }

        var i;

        if(utilityGridCounter >= 1600) {
            updateUtilityGrid();
            utilityGridCounter = 0;
        }

        if(buildingUpdateCycle) {
            updateBuildings();
        }

        if(shouldUpdateCollissionMap) {
            updateCollisionMap();
        }

        for(i = 0; i < currentGame.vehicles.length; i++) {
            updateVehicle(currentGame.vehicles[i]);
            if(currentGame.vehicles[i].isCashed) {
                vehicleKillArray.push(currentGame.vehicles[i]);
            }
        }

        if(selectedBuilding != null) {
            updateCostRemainingArea();
        }

        // regular colonists
        var colSimCount = getSimulationAmountForArray(currentGame.colonists);
        var simCols = 0;
        var unsimCols = 0;

        var riotCount = 0;

        runningUnemployed = 0;
        
        unsimulatedRunningMoney = 0;
        unsimulatedAge = 0;
        unsimulatedHealth = 0;
        currentTotalIllegals = 0;

        var len;
        
        for(i = 0, len = currentGame.colonists.length; i < len; i++) {

            setColonistMask(currentGame.colonists[i],"IS_DIPLOMAT",false);

            updateColonist(currentGame.colonists[i]);

            if(getColonistMask(currentGame.colonists[i],"IS_ILLEGAL")) {
                currentTotalIllegals++;
            }

            if(payrollTurn) {
                currentGame.colonists[i].age++;
            }

            unsimulatedAge += currentGame.colonists[i].age;
            unsimulatedHealth += currentGame.colonists[i].health;

            unsimulatedRunningMoney += currentGame.colonists[i].money;

            if(currentGame.colonists[i].job == 0 && currentGame.colonists[i].money < gotItMadePrice) {
                runningUnemployed++;
            }

            if(currentGame.colonists[i].health <= 0 || getColonistMask(currentGame.colonists[i],"IS_LEAVING_COLONY") || getColonistMask(currentGame.colonists[i],"IS_ENTERING_STARGATE")) {
                colonistKillArray.push(currentGame.colonists[i]);

                if(getColonistMask(currentGame.colonists[i],"IS_ENTERING_STARGATE")) {
                    putColonistIntoStargate(currentGame.colonists[i]);
                } else {
                    if(!getColonistMask(currentGame.colonists[i],"IS_LEAVING_COLONY")) {
                        currentGame.totalDeaths++;
                    }
                }

                

                
            } else {
                if(getColonistMask(currentGame.colonists[i],"IS_SIMULATED")) {
                    simCols++;
                } else {
                    unsimCols++;
                }
            }

            if(getColonistMask(currentGame.colonists[i],"IS_PROTESTING")) {
                riotCount++;
            }
        }


        // tender the virtuals 
        globalconsumptioncounter++;

        if(globalconsumptioncounter >= 500) {
            globalconsumptioncounter = 0;

            var virtcol = getVirtualPopulation();

            var foodNeeded = virtcol;
            var waterNeeded = virtcol;

            if(foodNeeded > currentGame.resources[ColonyGame.meta.colonistsEat].amount) {
                foodNeeded = currentGame.resources[ColonyGame.meta.colonistsEat].amount;
            }

            if(waterNeeded > currentGame.resources[ColonyGame.meta.colonistsDrink].amount) {
                waterNeeded = currentGame.resources[ColonyGame.meta.colonistsDrink].amount;
            }

            if(currentGame.foodRationing) {
                foodNeeded = Math.round(foodNeeded * 0.3);
                waterNeeded = Math.round(foodNeeded * 0.3);
            }

            modifyResourceAmount(ColonyGame.meta.colonistsEat,-foodNeeded,false,"Colonist");
            modifyResourceAmount(ColonyGame.meta.colonistsDrink,-waterNeeded,false,"Colonist");
        }

        if(riotCount < getTotalPopulation() * 0.05) {
            riotingWarned = false;
            anarchyWarned = false;
        }

        if(riotCount > getTotalPopulation() * 0.15) {
            if(!riotingWarned) {
                riotingWarned = true;

                if(!currentGame.offlineMode) {
                    postMessageToAllChannels("Mass rioting in " + currentGame.name + "!","#F44336");
                }
            }
        }

        if(riotCount > getTotalPopulation() * 0.5) {
            if(!anarchyWarned) {
                riotingWarned = true;
                anarchyWarned = true;

                if(!currentGame.offlineMode) {
                    postMessageToAllChannels(currentGame.name + " has fallen under total anarchy!","#F44336");
                }
            }
        }

        if(callForHireFlag) {
            sendOutCallForHire();
        }

        if(callForHousingFlag) {
            sendOutCallForResidents();
        }

        runVirtualSyncCycle();

        callForHireFlag = false;
        callForHousingFlag = false;

        
        
        var gotOne,randomColonist;

        if(simCols < colSimCount) {

            gotOne = false;

            randomColonist = currentGame.colonists[randomIntFromInterval(0,currentGame.colonists.length - 1)];
            if(randomColonist.health > 0 && !getColonistMask(randomColonist,"IS_SIMULATED") && (getColonistMask(randomColonist,"AT_WORK") || getColonistMask(randomColonist,"AT_HOME"))) {
                gotOne = true;
                setColonistMask(randomColonist,"IS_SIMULATED",true);
            }

            if(!gotOne && unsimCols > 250 && randomColonist.health > 0) {
                setColonistMask(randomColonist,"IS_SIMULATED",true);
            }
        }

        if(unsimCols > 450) {
            throwSimParty();
        }

        if(currentGame.colonists.length > maxSimulants) {
            randomColonist = currentGame.colonists[randomIntFromInterval(0,currentGame.colonists.length - 1)];
            virtualizeColonist(randomColonist);
        }

        

        // tourists
        simCols = 0;
        unsimCols = 0;
        
        for(i = 0, len = currentGame.tourists.length; i < len; i++) {

            setColonistMask(currentGame.tourists[i],"IS_DIPLOMAT",false);

            updateColonist(currentGame.tourists[i]);

            if(payrollTurn) {
                currentGame.tourists[i].age++;
            }

            if(currentGame.tourists[i].health <= 0) {
                colonistKillArray.push(currentGame.tourists[i]);
            } else {
                if(getColonistMask(currentGame.tourists[i],"IS_SIMULATED")) {
                    simCols++;
                } else {
                    unsimCols++;
                }
            }

            if(currentGame.tourists[i].isGoingHome) {
                colonistKillArray.push(currentGame.tourists[i]);
            }
        }

        if(unsimCols > 40) {

            gotOne = false;

            randomColonist = currentGame.tourists[randomIntFromInterval(0,currentGame.tourists.length - 1)];
            if(randomColonist.health > 0 && !getColonistMask(randomColonist,"IS_SIMULATED")) {
                gotOne = true;
                setColonistMask(randomColonist,"IS_SIMULATED",true);
            }
        }

        // diplomats
        simCols = 0;
        unsimCols = 0;
        
        for(i = 0, len = currentGame.diplomats.length; i < len; i++) {

            updateColonist(currentGame.diplomats[i]);

            if(payrollTurn) {
                currentGame.diplomats[i].age++;
            }

            if(currentGame.diplomats[i].health <= 0 || getColonistMask(currentGame.diplomats[i],"IS_LEAVING_COLONY")) {
                colonistKillArray.push(currentGame.diplomats[i]);
            } else {
                if(getColonistMask(currentGame.diplomats[i],"IS_SIMULATED")) {
                    simCols++;
                } else {
                    unsimCols++;
                }
            }

        }

        if(unsimCols > 20) {

            gotOne = false;

            randomColonist = currentGame.diplomats[randomIntFromInterval(0,currentGame.diplomats.length - 1)];
            if(randomColonist.health > 0 && !getColonistMask(randomColonist,"IS_SIMULATED")) {
                gotOne = true;
                setColonistMask(randomColonist,"IS_SIMULATED",true);
            }
        }


        createUtilityGridIfNonexistant();

        var showDisplay = "block";
        if(desktopMode) {
            showDisplay = "inline-block";
        }

        updateUtilityDisplays(showDisplay);

        if(workerCleanupRequired) {
            conductWorkerCleanup();
        }

        doResourceStatTickStuff();
        
        updateResourceStuff(showDisplay);

        // population readout 
        var popReadout = numberWithCommas(getTotalPopulation()) + "/" + numberWithCommas(currentGame.availableShelters);
        var tourReadout = numberWithCommas(currentGame.tourists.length) + "/" + numberWithCommas(currentGame.availableTourism);

        if(resourceReadouts.population.readout.innerHTML != popReadout) {
            resourceReadouts.population.readout.innerHTML = popReadout;
        }

        // tourist readout
        if(currentGame.availableTourism == 0) {
            if(resourceReadouts.tourists.holder.style.display != "none") {
                resourceReadouts.tourists.holder.style.display = "none";
            }
        } else {
            if(resourceReadouts.tourists.holder.style.display != showDisplay) {
                resourceReadouts.tourists.holder.style.display = showDisplay;
            }

            if(resourceReadouts.tourists.readout.innerHTML != tourReadout) {
                resourceReadouts.tourists.readout.innerHTML = numberWithCommas(currentGame.tourists.length) + "/" + numberWithCommas(currentGame.availableTourism);
            }
        }
        
        if(webAppCore.isTV() || gamepadInUse) {
            if(resourceReadouts.population.trend.src != "images/hud-gamepad-rb.png") {
                resourceReadouts.population.trend.src = "images/hud-gamepad-rb.png";
            }
        } else {
            if(allResourceMode) {
                if(resourceReadouts.population.trend.src != "images/res-contract.png") {
                    resourceReadouts.population.trend.src = "images/res-contract.png";
                }
            } else {
                if(resourceReadouts.population.trend.src != "images/res-expand.png") {
                    resourceReadouts.population.trend.src = "images/res-expand.png";
                }
            }
        }

        

        for(i = 0, len = resourceKillArray.length; i < len; i++) {
            removeFromArray(currentGame.mapResources,resourceKillArray[i],"resourceKillArray");

            if(resourceKillArray[i].inventory <= 0 && resourceKillArray[i].playDef != null && resourceKillArray[i].playDef.decaysTo != null) {
                
                var randChance = randomIntFromInterval(0,100);

                if(randChance <= resourceKillArray[i].playDef.decaysTo.chance) {
                    var newRes = getTerrainDefByName(resourceKillArray[i].playDef.decaysTo.terrain);
                    var resourceItem = new MapResource(newRes,resourceKillArray[i].x,resourceKillArray[i].y);
                    freeRefNukeTurn = true;
                    updateBuildingCollisionPoints(resourceItem,150);
                    currentGame.mapResources.push(resourceItem);
                    shoreUpdateTurn = true;
                }
                
                
            }
        }

        for(i = 0, len = vehicleKillArray.length; i < len; i++) {
            removeFromArray(currentGame.vehicles,vehicleKillArray[i],"vehicleKillArray");
        }



        while(colonistKillArray.length > 0) {
            var deadguy = colonistKillArray.shift();

            if(getColonistMask(deadguy,"IS_HEALING")) {
                removeColonistFromMedicalFacility(deadguy);
            }

            if(getColonistMask(deadguy,"IS_RELAXING")) {
                handleRelaxedColonist(deadguy);
            }

            if(getColonistMask(deadguy,"IS_TOURIST")) {
                if(!deadguy.isGoingHome) {
                    webAppCore.showToast({
                        message: "A tourist has died!",
                        image:   "images/" + ColonyGame.meta.colonistIcon
                    });
                    currentGame.deadTourists++;
                }

                removeFromArray(currentGame.tourists,deadguy,"currentGame.tourists");
            } else {

                if(getColonistMask(deadguy,"IS_DIPLOMAT")) {
                    if(!getColonistMask(deadguy,"IS_LEAVING_COLONY")) {
                        webAppCore.showToast({
                            message: "A foreign diplomat has died!",
                            image:   "images/" + ColonyGame.meta.colonistIcon
                        });
                    }

                    // do something here to alert diplomat's home country, at some point

                    if(deadguy.job > 0) {
                        removeWorker(getBuildingById(deadguy.job),deadguy,"col-death");
                    }

                    if(deadguy.house > 0) {
                        removeResident(getBuildingById(deadguy.house),deadguy);
                    }

                    removeFromArray(currentGame.diplomats,deadguy,"currentGame.diplomats");
                } else {

                    if(getTotalPopulation() < 5000 && !getColonistMask(currentGame.colonists[i],"IS_LEAVING_COLONY")) {
                        webAppCore.showToast({
                            message: deadguy.name + " has died.",
                            image:   "images/" + ColonyGame.meta.colonistIcon
                        });
                    }

                    if(deadguy.job > 0) {
                        removeWorker(getBuildingById(deadguy.job),deadguy,"col-death");
                    }

                    if(deadguy.house > 0) {
                        removeResident(getBuildingById(deadguy.house),deadguy);
                    }

                    if(currentGame.populationStats[deadguy.race] === undefined) {
                        currentGame.populationStats[deadguy.race] = 0;
                    }

                    currentGame.populationStats[deadguy.race]--;

                    if(currentGame.populationStats[deadguy.race] < 0) {
                        currentGame.populationStats[deadguy.race] = 0;
                    }

                    if(!removeFromArray(currentGame.colonists,deadguy,"currentGame.colonists")) {
                        if(!removeFromArray(currentGame.tourists,deadguy,"currentGame.tourists")) {
                            if(!removeFromArray(currentGame.diplomats,deadguy,"currentGame.diplomats")) {
                                //console.log("couldnt remove a colonist!");
                            }
                        }
                    }
                }

                
            }

            var holders = getHolderLevels(deadguy.id);

            delete runningColonistReferenceArray[holders.a][holders.b][holders.c][deadguy.id];

            deadguy = null;
        }

        resourceKillArray = null;
        colonistKillArray = null;
        vehicleKillArray = null;
        
        
        if(saveInProgress) {
            saveCounter = 0;
        } else {
            saveCounter++;
        }
        
        if(saveCounterMax > -1) {
            if(saveCounter >= saveCounterMax) {
                updateColonyStats();
                saveCounter = 0;
                saveGame();
            }
        }

        if(earthTaxAmount > 0) {
            
            if(isNaN(currentGame.earthAssemblyRelations)) {
                currentGame.earthAssemblyRelations = 100;
            }

            if(isNaN(currentGame.earthBackTax)) {
                currentGame.earthBackTax = 0;
            }

            if(currentGame.isIndependent) {
                if(currentGame.earthAssemblyRelations < 100) {
                    currentGame.earthAssemblyRelations++;
                }
            } else {
                pendingEarthTax = earthTaxAmount + currentGame.earthBackTax;

                if(currentGame.autoBudget && pendingEarthTax < currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                    payTax();
                } else {
                    var taxMessage = getString("tax-window-content") + "\n\n" + getString("tax-window-owed-header") + " " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(pendingEarthTax);

                    webAppCore.showDialog({
                        "title":    getString("tax-window-header"),
                        "message":  taxMessage,
                        "op1": {
                            "text":     getString("tax-window-pay"),
                            "func":     payTax
                        },
                        "op2": {
                            "text":     getString("tax-window-reject"),
                            "func":     rejectTax
                        }
                    });
                }

                
            }

        }

        if(payrollTurn && pendingSalary > 0) {
            var livingWageTotalCost = currentGame.livingWageRate * getTotalPopulation();
            pendingSalary += livingWageTotalCost;
            announcePayroll(pendingSalary);
        }

        pauseDrawing = false;
    }

    function updateResourceStuff(showDisplay) {

        var resourceUpdateTurn = false;

        checkPreviousCounter++;

        if(checkPreviousCounter >= 500) {
            checkPreviousCounter = 0;
            resourceUpdateTurn = true;
        }

        

        for(var i = 0, len = ColonyGame.resources.length; i < len; i++) {

            var useColor = resourceReadouts[ColonyGame.resources[i].name].readout.style.color;
            var useDisplay = resourceReadouts[ColonyGame.resources[i].name].holder.style.display;
            var useInnerhtml = resourceReadouts[ColonyGame.resources[i].name].readout.innerHTML;
            var useTrend = resourceReadouts[ColonyGame.resources[i].name].trend.src;

            if(currentGame.readOnlyMode) {
                if(useDisplay != "none") {
                    resourceReadouts[ColonyGame.resources[i].name].holder.style.display = "none";
                }

                continue;
            }

            if(!currentGame.resources[ColonyGame.resources[i].name]) {
                currentGame.resources[ColonyGame.resources[i].name] = {};
                currentGame.resources[ColonyGame.resources[i].name].amount = 0;
                currentGame.resources[ColonyGame.resources[i].name].previous = 0;
                currentGame.resources[ColonyGame.resources[i].name].capacity = ColonyGame.resources[i].max;
                currentGame.resources[ColonyGame.resources[i].name].price = ColonyGame.resources[i].basePrice;
                currentGame.resources[ColonyGame.resources[i].name].storageCapacity = 0;
                currentGame.resources[ColonyGame.resources[i].name].unlocked = false;
                currentGame.resources[ColonyGame.resources[i].name].serverId = 0;
                currentGame.resources[ColonyGame.resources[i].name].lastTrade = 0;
            }

            if(currentGame.resources[ColonyGame.resources[i].name].amount > 0) {
                currentGame.resources[ColonyGame.resources[i].name].unlocked = true;
            }

            if(!currentGame.resources[ColonyGame.resources[i].name].inflows) {
                currentGame.resources[ColonyGame.resources[i].name].inflows = {};
                currentGame.resources[ColonyGame.resources[i].name].inflows.allCurrent = 0;
                currentGame.resources[ColonyGame.resources[i].name].inflows.allTime = 0;
            }

            if(!currentGame.resources[ColonyGame.resources[i].name].outflows) {
                currentGame.resources[ColonyGame.resources[i].name].outflows = {};
                currentGame.resources[ColonyGame.resources[i].name].outflows.allCurrent = 0;
                currentGame.resources[ColonyGame.resources[i].name].outflows.allTime = 0;
            }

            if(currentGame.resources[ColonyGame.resources[i].name].amount < 0) {
                modifyResourceAmount(ColonyGame.resources[i].name,0,true);
            }

            if(isNaN(currentGame.resources[ColonyGame.resources[i].name].price)) {
                currentGame.resources[ColonyGame.resources[i].name].price = ColonyGame.resources[i].basePrice;
            }

            if(isNaN(currentGame.resources[ColonyGame.resources[i].name].amount)) {
                modifyResourceAmount(ColonyGame.resources[i].name,0,true);
            }

            if(ColonyGame.resources[i].name == ColonyGame.meta.colonistsEat) {
                if(currentGame.resources[ColonyGame.resources[i].name].amount == 0) {
                    if(!famineWarned) {
                        famineWarned = true;

                        if(!currentGame.offlineMode) {
                            postMessageToAllChannels("Starvation in " + currentGame.name + "!","#F44336");
                        }
                    }
                }

                if(currentGame.resources[ColonyGame.resources[i].name].amount > (currentGame.resources[ColonyGame.resources[i].name].storageCapacity * .25)) {
                    famineWarned = false;
                }
            }

            // resource decay 
            if(!currentGame.offlineMode) {
				if(currentGame.resources[ColonyGame.resources[i].name].capacity == -1 && currentGame.resources[ColonyGame.resources[i].name].amount > currentGame.resources[ColonyGame.resources[i].name].storageCapacity) {
					var capacityDifference = currentGame.resources[ColonyGame.resources[i].name].amount - currentGame.resources[ColonyGame.resources[i].name].storageCapacity;
					if(capacityDifference > 2) {
                        capacityDifference = 2;
                        
                        if(currentGame.resources[ColonyGame.resources[i].name].amount < 100000) {
                            capacityDifference = 1;
                        }

                        if(currentGame.resources[ColonyGame.resources[i].name].amount < 10000) {
                            capacityDifference = 0;
                        }

					}

					if(capacityDifference < 0) {
						capacityDifference = 0;
					}
				
					if(capacityDifference > 0) {
						modifyResourceAmount(ColonyGame.resources[i].name,-capacityDifference,false,"Decay");
					}
				}
            }

            if(ColonyGame.resources[i].name == ColonyGame.meta.colonistsDrink) {
                if(currentGame.resources[ColonyGame.resources[i].name].amount == 0) {
                    if(!noWaterWarned) {
                        noWaterWarned = true;

                        if(!currentGame.offlineMode) {
                            postMessageToAllChannels(currentGame.name + " needs " + ColonyGame.resources[i].name + "!","#F44336");
                        }
                    }
                }

                if(currentGame.resources[ColonyGame.resources[i].name].amount > (currentGame.resources[ColonyGame.resources[i].name].storageCapacity * .25)) {
                    noWaterWarned = false;
                }
            }

            useInnerhtml = numberWithCommas(currentGame.resources[ColonyGame.resources[i].name].amount);

            if(currentGame.resources[ColonyGame.resources[i].name].capacity == -1) {
                useInnerhtml += "/" + numberWithCommas(currentGame.resources[ColonyGame.resources[i].name].storageCapacity);
            }

            if(!desktopMode) {
                useColor = ColonyGame.resources[i].color;
            }

            if(allResourceMode) {
                useDisplay = showDisplay;
            } else {
                if(ColonyGame.resources[i].isEssential) {
                    useDisplay = showDisplay;
                } else {
                    if(resourceReadouts[ColonyGame.resources[i].name].isTrendingDown) {
                        useDisplay = showDisplay;
                    } else {
                        useDisplay = "none";
                    }
                }
            }

            if(!currentGame.resources[ColonyGame.resources[i].name].unlocked) {
                useDisplay = "none";
            }

            if(resourceUpdateTurn) {
                if(isNaN(currentGame.resources[ColonyGame.resources[i].name].previous)) {
                    currentGame.resources[ColonyGame.resources[i].name].previous = 0;
                } else {
                    var diff = currentGame.resources[ColonyGame.resources[i].name].amount - currentGame.resources[ColonyGame.resources[i].name].previous;
                    if(diff > 0) {
                        useTrend = "images/res-trend-up.png";
                        resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = false;

                        if(desktopMode) {
                            useColor = "#4CAF50";
                        }
                    }

                    if(diff < 0) {
                        useTrend = "images/res-trend-down.png";
                        resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = true;

                        if(desktopMode) {
                            useColor = "#F44336";
                        }
                    }

                    if(diff == 0) {
                        useTrend = "images/res-trend-placeholder.png";
                        resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = false;

                        if(desktopMode) {
                            useColor = "#ffffff";
                        }
                    }

                    currentGame.resources[ColonyGame.resources[i].name].previous = currentGame.resources[ColonyGame.resources[i].name].amount;

                    if(ColonyGame.resources[i].max == -1) {
                        if(currentGame.resources[ColonyGame.resources[i].name].amount >= currentGame.resources[ColonyGame.resources[i].name].storageCapacity) {

                            useTrend = "images/res-trend-max.png";
                            resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = false;

                            if(desktopMode) {
                                useColor = "#FFA726";
                            }
                        }
                    }

                    

                    if(ColonyGame.resources[i].name == ColonyGame.meta.gameStageResource) {

                        var justStage = 0;

                        for(var j = 0; j < ColonyGame.meta.gameStages.length; j++) {
                            if(currentGame.resources[ColonyGame.resources[i].name].amount >= ColonyGame.meta.gameStages[j].threshold) {
                                justStage = j;
                            }
                        }

                        if(justStage > currentGame.stage) {
                            advanceToStage(justStage);
                        }
                    }
                }

                var priceChange = randomIntFromInterval(0,2);
                priceChange--;
                currentGame.resources[ColonyGame.resources[i].name].price += priceChange;

                var priceSwingChange = randomIntFromInterval(0,20);
                if(priceSwingChange == 5) {
                    priceChange = randomIntFromInterval(0,40);
                    priceChange -= 16;
                    currentGame.resources[ColonyGame.resources[i].name].price += priceChange;
                }

                if(currentGame.resources[ColonyGame.resources[i].name].price < 1) {
                    currentGame.resources[ColonyGame.resources[i].name].price = 1;
                }

                
            }

            if(resourceReadouts[ColonyGame.resources[i].name].readout.style.color != useColor) {
                resourceReadouts[ColonyGame.resources[i].name].readout.style.color = useColor;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].holder.style.display != useDisplay) {
                resourceReadouts[ColonyGame.resources[i].name].holder.style.display = useDisplay;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].readout.innerHTML != useInnerhtml) {
                resourceReadouts[ColonyGame.resources[i].name].readout.innerHTML = useInnerhtml;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].trend.src != useTrend) {
                resourceReadouts[ColonyGame.resources[i].name].trend.src = useTrend;
            }


        }

        if(resourceUpdateTurn) {
            drawSidebar();
        }

        
    }

    function updateUtilityDisplays(showDisplay) {
        for(var i = 0; i < ColonyGame.utilities.length; i++) {

            var useDisplay = resourceReadouts[ColonyGame.utilities[i].name].holder.style.display;
            var useColor = resourceReadouts[ColonyGame.utilities[i].name].readout.style.color;
            var useInnerhtml = resourceReadouts[ColonyGame.utilities[i].name].readout.innerHTML;

            if(currentGame.readOnlyMode) {
                if(useDisplay != "none") {
                    resourceReadouts[ColonyGame.utilities[i].name].holder.style.display = "none";
                }

                continue;
            }



            useInnerhtml = numberWithCommas(currentGame.utilities[ColonyGame.utilities[i].name].usage) + "/" + numberWithCommas(currentGame.utilities[ColonyGame.utilities[i].name].capacity);
            
            if(currentGame.utilities[ColonyGame.utilities[i].name].usage >= currentGame.utilities[ColonyGame.utilities[i].name].capacity) {
                useColor = "#F44336";
            } else {
                useColor = ColonyGame.utilities[i].color;
            }

            if(allResourceMode) {
                useDisplay = showDisplay;
            } else {
                if(ColonyGame.resources[i].isEssential) {
                    useDisplay = showDisplay;
                } else {
                    if(currentGame.utilities[ColonyGame.utilities[i].name].usage >= currentGame.utilities[ColonyGame.utilities[i].name].capacity) {
                        useDisplay = showDisplay;
                    } else {
                        useDisplay = "none";
                    }
                }
            }

            if(resourceReadouts[ColonyGame.utilities[i].name].holder.style.display != useDisplay) {
                resourceReadouts[ColonyGame.utilities[i].name].holder.style.display = useDisplay;
            }

            if(resourceReadouts[ColonyGame.utilities[i].name].readout.style.color != useColor) {
                resourceReadouts[ColonyGame.utilities[i].name].readout.style.color = useColor;
            }

            if(resourceReadouts[ColonyGame.utilities[i].name].readout.innerHTML != useInnerhtml) {
                resourceReadouts[ColonyGame.utilities[i].name].readout.innerHTML = useInnerhtml;
            }

        }
    }

    var resourceStatTickCounter = 2000;

    function doResourceStatTickStuff() {
        resourceStatTickCounter++;

        var res2;

        if(resourceStatTickCounter >= 2000) {
            resourceStatTickCounter = 0;


            for(var res in currentGame.resources) {

                if (!currentGame.resources[res].trend) {
                    currentGame.resources[res].trend = [];
                }

                currentGame.resources[res].trend.push(currentGame.resources[res].amount);

                currentGame.resources[res].historic = {};
                currentGame.resources[res].historic.inflows = {};
                currentGame.resources[res].historic.outflows = {};

                if(currentGame.resources[res].inflows && currentGame.resources[res].inflows.current) {

                    currentGame.resources[res].inflows.allCurrent = 0;

                    for(res2 in currentGame.resources[res].inflows.current) {

                        if(!currentGame.resources[res].historic.inflows[res2]) {
                            currentGame.resources[res].historic.inflows[res2] = 0;
                        }

                        currentGame.resources[res].historic.inflows[res2] += currentGame.resources[res].inflows.current[res2];
                    }
                }

                if(currentGame.resources[res].outflows && currentGame.resources[res].outflows.current) {

                    currentGame.resources[res].outflows.allCurrent = 0;

                    for(res2 in currentGame.resources[res].outflows.current) {

                        if(!currentGame.resources[res].historic.outflows[res2]) {
                            currentGame.resources[res].historic.outflows[res2] = 0;
                        }

                        currentGame.resources[res].historic.outflows[res2] += currentGame.resources[res].outflows.current[res2];
                    }
                }

                if (!currentGame.resources[res].inflows) {
                    currentGame.resources[res].inflows = {};
                }

                if (!currentGame.resources[res].outflows) {
                    currentGame.resources[res].outflows = {};
                }

                currentGame.resources[res].inflows.current = {};
                currentGame.resources[res].outflows.current = {};
            }

            updateHistoricStatistics();
        }
    }

    function updateHistoricStatistics() {

        var totalGDP = currentGame.resources[ColonyGame.meta.tenderResource].amount;

        var totalColonists = getTotalPopulation();
        var unemployed = 0;
        var retired = 0;
        var i,def;

        var totalJobs = 0;
        var totalWorkforce = 0;


        var totalApproval = 0;
        var actualApproval = 0;

        var occupiedHouses = 0;


        var totalHealth = 0;

        var totalAge = 0;
        var totalSavings = 0;



        var oldestColonist = 0;
        var richestColonist = 0;


        var totalIQ = 0;

        var smartestIQ = 0;

        var realColonists = currentGame.colonists.length;
        var virtualColonists = getVirtualPopulation();

        var allSalaries = [];
        var allAges = [];

        for(i = 0; i < realColonists; i++) {

            totalApproval += 100;
            actualApproval += parseInt(currentGame.colonists[i].happiness);


            if(currentGame.colonists[i].job == 0) {
                if(currentGame.colonists[i].money > gotItMadePrice) {
                    retired++;
                }
            }

            if(isNaN(currentGame.colonists[i].iQ)) {
                currentGame.colonists[i].iQ = randomIntFromInterval(40,110);
            }

            totalIQ += currentGame.colonists[i].iQ;

            if(currentGame.colonists[i].iQ > smartestIQ) {
                smartestIQ = currentGame.colonists[i].iQ;

            }


            totalHealth += currentGame.colonists[i].health;

            totalGDP += currentGame.colonists[i].money;
            totalSavings += currentGame.colonists[i].money;

            allSalaries.push(currentGame.colonists[i].money);

            if(isNaN(currentGame.colonists[i].age)) {
                currentGame.colonists[i].age = randomIntFromInterval(216,360);
                totalAge += Math.floor(currentGame.colonists[i].age / 12);
            } else {
                totalAge += Math.floor(currentGame.colonists[i].age / 12);
                

                if(currentGame.colonists[i].age > oldestColonist) {
                    oldestColonist = currentGame.colonists[i].age;
                }

                if(currentGame.colonists[i].money > richestColonist) {
                    richestColonist = currentGame.colonists[i].money;

                }

            }

            allAges.push(Math.floor(currentGame.colonists[i].age / 12));

            
        }

        var medianmoney = getMedian(allSalaries);

        totalSavings += (medianmoney * virtualColonists);

        var unemprate = runningUnemployed / totalColonists;

        var approvalRating = Math.round((actualApproval / totalApproval) * 100);

        for(var res in currentGame.resources) {
            if(res != ColonyGame.meta.tenderResource) {
                var unitPrice = Math.round(currentGame.resources[res].price / 100);
                var totalValue = unitPrice * currentGame.resources[res].amount;
                totalGDP += totalValue;
            }
        }


        var averageHealth = Math.round(totalHealth / realColonists);


        for(i = 0; i < currentGame.buildings.length; i++) {

            def = getBuildingDefByName(currentGame.buildings[i].def);


            if(!def.isEmbassy && !currentGame.buildings[i].isUnderConstruction && def.acceptsWorkers && !currentGame.buildings[i].deactivated) {
                totalJobs += def.acceptsWorkers;

                if(currentGame.buildings[i].workers.length > def.acceptsWorkers) {
                    handleBuildingWorkerCleanup(currentGame.buildings[i]);
                }

                totalWorkforce += currentGame.buildings[i].workers.length;
            }

            if(!def.isEmbassy && !currentGame.buildings[i].isUnderConstruction && def.providesShelter && !currentGame.buildings[i].deactivated) {
                occupiedHouses += currentGame.buildings[i].residents.length;
            }

        }

        if(totalWorkforce > totalJobs) {
            totalWorkforce = totalJobs;
        }

        unemployed = ((totalColonists - retired) - totalWorkforce);

        if(unemployed < 0) {
            unemployed = 0;
        }

        var unemployedPercent = Math.round((unemployed / (totalColonists - retired)) * 100);

        var totalHomeless = runningHomelessCount;

        if(totalHomeless < 0) {
            totalHomeless = 0;
        }

        if(totalHomeless > totalColonists) {
            totalHomeless = totalColonists;
        }

        var homelessPercent = Math.round((totalHomeless / totalColonists) * 100);


        
        var medianAge = getMedian(allAges);

        totalAge += (medianAge * virtualColonists);
        

        var averageAge = Math.round(totalAge / totalColonists);



        var averageSavings = Math.round(totalSavings / totalColonists);
        var averageIQ = Math.round(totalIQ / realColonists);

        currentGame.historicStats.population.push(totalColonists);
        currentGame.historicStats.age.push(averageAge);
        currentGame.historicStats.savings.push(averageSavings);
        currentGame.historicStats.gdp.push(totalGDP);
        currentGame.historicStats.unemployment.push(unemployedPercent);
        currentGame.historicStats.jobs.push(totalJobs);
        
        currentGame.historicStats.health.push(averageHealth);
        currentGame.historicStats.iq.push(averageIQ);
        currentGame.historicStats.homeless.push(homelessPercent);

        if(getTotalPopulation() == 0) {
            approvalRating = 100;
        }

        currentGame.historicStats.approval.push(approvalRating);

        if(currentGame.historicStats.workforce == undefined) {
            currentGame.historicStats.workforce = [];
        }

        if(currentGame.historicStats.mediansalary == undefined) {
            currentGame.historicStats.mediansalary = [];
        }

        if(currentGame.historicStats.retiredpop == undefined) {
            currentGame.historicStats.retiredpop = [];
        }

        currentGame.historicStats.mediansalary.push(Math.round(medianmoney));
        currentGame.historicStats.retiredpop.push(retired);
        currentGame.historicStats.workforce.push(totalWorkforce);

        // clear out the oldest disapproval stat, in case a bunch of really old ones are building up
        currentGame.sadReasons.shift();

        for(var stat in currentGame.historicStats) {
            if(Array.isArray(currentGame.historicStats[stat])) {
                while(currentGame.historicStats[stat].length > 1000) {
                    currentGame.historicStats[stat].shift();
                }
            }
        }
    }

    function announcePayroll(salary) {

        if(currentGame.autoBudget && salary < currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            payPayroll();
            return;
        }


        var totalSalary = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(salary);

        var taxMessage = getString("payroll-notice").replace("#payrollcost",totalSalary);

        if(!currentGame.isIndependent) {

            var motherlandPortion = Math.round(salary * currentGame.payrollRate);
            var motherlandPortionString =  getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(motherlandPortion);

            var addition = getString("payroll-motherland").replace("#motheroffset",motherlandPortionString);
            taxMessage = taxMessage + "\n\n" + addition;
        }

        webAppCore.showDialog({
            "title":    getString("general-payroll"),
            "message":  taxMessage,
            "op1": {
                "text":     getString("tax-window-pay"),
                "func":     payPayroll
            },
            "op2": {
                "text":     getString("tax-window-reject"),
                "func":     rejectPayroll
            }
        });
    }

    function rejectPayroll() {
        webAppCore.showDialog({
            "title":    getString("general-payroll"),
            "message":  getString("payroll-reject"),
            "op1": {
                "text":     getString("tax-window-pay"),
                "func":     payPayroll
            },
            "op2": {
                "text":     getString("general-dismiss"),
                "func":     rejectPayrollFinal
            }
        });
    }

    function rejectPayrollFinal() {

        if(currentGame == null) {
            return;
        }

        currentGame.monthEndCounter = 30000;

        for(var i = 0; i < currentGame.colonists.length; i++) {
            if(currentGame.colonists[i].job > 0) {
                currentGame.colonists[i].happiness -= 45;

                if(currentGame.colonists[i].happiness < 0) {
                    currentGame.colonists[i].happiness = 0;
                }
            }
        }

        if(!currentGame.offlineMode && usingSockets) {
            postMessageToAllChannels(currentGame.name + " is not paying workers!","#F44336");
        }
    }

    function payPayroll() {

        if(currentGame == null) {
            return;
        }

        var totalPaid = 0;
        var missedPayments = 0;

        var i,tmpbld;

        var totalsalary = 0;

        for(i = 0; i < currentGame.colonists.length; i++) {

            // first do living wage
            if(currentGame.livingWageRate > 0){
                if(currentGame.resources[ColonyGame.meta.tenderResource].amount > currentGame.livingWageRate) {
                    currentGame.colonists[i].money += currentGame.livingWageRate;
                    modifyResourceAmount(ColonyGame.meta.tenderResource,-currentGame.livingWageRate,false,"Welfare");
                    totalPaid += currentGame.livingWageRate;
                } else {
                    missedPayments += currentGame.livingWageRate;
                    currentGame.colonists[i].happiness -= 20;
                    if(currentGame.colonists[i].happiness < 0) {
                        currentGame.colonists[i].happiness = 0;
                    }
                }
            }

            // then do salary 
            if(currentGame.colonists[i].job != 0) {
                tmpbld = getBuildingById(currentGame.colonists[i].job);

                if(tmpbld == null) {
                    currentGame.colonists[i].job = 0;
                } else {
                    var def = getBuildingDefByName(tmpbld.def);

                    var salary = 1;

                    if(currentGame.salaries.Unskilled != null) {
                        salary = currentGame.salaries.Unskilled;
                    }

                    if(def.occupation != null) {
                        if(currentGame.salaries[def.occupation] != null) {
                            salary = currentGame.salaries[def.occupation];
                        } else {
                            salary = getOccupationDefByName(def.occupation).salary;
                        }
                    }

                    totalsalary += salary;

                    if(salary > 0 && currentGame.resources[ColonyGame.meta.tenderResource].amount > salary) {
                        currentGame.colonists[i].money += salary;
                        modifyResourceAmount(ColonyGame.meta.tenderResource,-salary,false,"Wages");
                        totalPaid += salary;
                    } else {
                        missedPayments += salary;
                        currentGame.colonists[i].happiness -= 20;
                        if(currentGame.colonists[i].happiness < 0) {
                            currentGame.colonists[i].happiness = 0;
                        }
                    }
                }
            }
        }

        // you gotta pay for the virtual guys too 
        var virtcol = getVirtualPopulation();
        var virtsalary = Math.round(totalsalary / currentGame.colonists.length);

        while(virtcol > 0) {
            
            // first do living wage
            if(currentGame.livingWageRate > 0){
                if(currentGame.resources[ColonyGame.meta.tenderResource].amount > currentGame.livingWageRate) {
                    modifyResourceAmount(ColonyGame.meta.tenderResource,-currentGame.livingWageRate,false,"Welfare");
                    totalPaid += currentGame.livingWageRate;
                } else {
                    missedPayments += currentGame.livingWageRate;
                }
            }

            // then do salary 
            if(virtsalary > 0) {
                if(currentGame.resources[ColonyGame.meta.tenderResource].amount > virtsalary) {
                    modifyResourceAmount(ColonyGame.meta.tenderResource,-virtsalary,false,"Wages");
                    totalPaid += virtsalary;
                } else {
                    missedPayments += virtsalary;
                }
            }

            virtcol--;
        }

        if(missedPayments > 0) {
            webAppCore.showDialog({
                "title":    getString("general-payroll"),
                "message":  getString("payroll-insufficient"),
                "op1": {
                    "text":     getString("general-dismiss"),
                    "func":     placeholder
                }
            });
        } else {
            webAppCore.showToast("You paid " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPaid) + " in payroll costs!");
        }

        if(!currentGame.isIndependent) {
            var motherlandAmount = Math.round(totalPaid * currentGame.payrollRate);

            if(motherlandAmount > 0) {
                if(currentGame.motherlandid == 0 || currentGame.offlineMode) {
                    currentGame.gifts.push(new Gift(getString("general-payroll"),getString("payroll-motherland-collect"),ColonyGame.meta.tenderResource,motherlandAmount));
                    webAppCore.showToast("New gifts available!");
                    document.getElementById("imGift").style.display = "inline-block";
                } else {
                    sendForMotherlandPayrollPayment(motherlandAmount);
                }
            }
        }

    }

    var pendingEarthTax;

    function payTax() {

        if(currentGame == null) {
            return;
        }

        currentGame.earthBackTax = 0;
        currentGame.earthAssemblyRelations += 2;

        if(currentGame.earthAssemblyRelations > 100) {
            currentGame.earthAssemblyRelations = 100;
        }

        if(pendingEarthTax > currentGame.resources[ColonyGame.meta.tenderResource].amount) {

            currentGame.motherlandTaxesPaid += currentGame.resources[ColonyGame.meta.tenderResource].amount;

            sendTaxPayment(currentGame.resources[ColonyGame.meta.tenderResource].amount);

            var difference = pendingEarthTax - currentGame.resources[ColonyGame.meta.tenderResource].amount;
            modifyResourceAmount(ColonyGame.meta.tenderResource,0,true,"Tax");

            currentGame.earthBackTax = difference;
            currentGame.earthAssemblyRelations -= 4;

            if(currentGame.earthAssemblyRelations < 0) {
                currentGame.earthAssemblyRelations = 0;
            }

            webAppCore.showDialog({
                "title":    getString("tax-window-header"),
                "message":  getString("tax-payment-insufficient")
            });

        } else {

            currentGame.motherlandTaxesPaid += pendingEarthTax;

            sendTaxPayment(pendingEarthTax);


            modifyResourceAmount(ColonyGame.meta.tenderResource,-pendingEarthTax,false,"Tax");

            if(currentGame.earthAssemblyRelations >= 75 && currentGame.tradeEmbargo) {

                currentGame.tradeEmbargo = false;

                webAppCore.showDialog({
                    "title":    getString("tax-window-header"),
                    "message":  getString("tax-window-lift-embargo")
                });
                
                return;
            }

            if(currentGame.earthAssemblyRelations >= 50 && currentGame.immigrationEmbargo) {
                currentGame.immigrationEmbargo = false;

                webAppCore.showDialog({
                    "title":    getString("tax-window-header"),
                    "message":  getString("tax-window-img-lift")
                });

                return;
            }

            if(currentGame.autoBudget) {
                webAppCore.showToast("Paid " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(pendingEarthTax) + " in taxes.");
            } else {
                webAppCore.showDialog({
                    "title":    getString("tax-window-header"),
                    "message":  getString("tax-payment-thankyou")
                });
            }
        }
    }

    function rejectTax() {

        if(currentGame == null) {
            return;
        }

        currentGame.earthBackTax = pendingEarthTax;
        currentGame.earthAssemblyRelations -= 6;

        if(currentGame.earthAssemblyRelations < 0) {
            currentGame.earthAssemblyRelations = 0;
        }

        if(currentGame.earthAssemblyRelations < 75 && !currentGame.tradeEmbargo) {
            currentGame.tradeEmbargo = true;

            webAppCore.showDialog({
                "title":    getString("tax-window-header"),
                "message":  getString("tax-window-trade-embargo")
            });

            return;
        }

        if(currentGame.earthAssemblyRelations < 50 && !currentGame.immigrationEmbargo) {
            currentGame.immigrationEmbargo = true;

            webAppCore.showDialog({
                "title":    getString("tax-window-header"),
                "message":  getString("tax-window-img-embargo")
            });

            return;
        }

        webAppCore.showDialog({
            "title":    getString("tax-window-header"),
            "message":  getString("tax-window-reject-response")
        });
    }

    var workingMapType = null;

    function setMapType() {
        if(currentGame == null) {
            return;
        }

        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == currentGame.mapType) {
                workingMapType = ColonyGame.mapTypes[i];
            }
        }
    }

    var staticFrame = false;

    var pendingDeployment = null;
    
    function draw() {
        
        if(!currentGame) {
            return;
        }

        if(killSwitch || pauseDrawing || inBackgroundMode) {
            return;
        }

        if(currentViewBounds == null) {
            return;
        }

        staticFrame = !staticFrame;

        var i;
        // var a,b,c;
        
        if(workingMapType != null) {
            for(var x = currentViewBounds.minX; x <= currentViewBounds.maxX; x++) {
                for(var y = currentViewBounds.minY; y <= currentViewBounds.maxY; y++) {
                    Scroll2d.drawStaticTile(gameAssets[workingMapType.groundTile[currentGame.stage]][0].image,x,y,0);

                }
            }
        }


        for(i = 0; i < currentGame.passableNonUpdatables.length; i++) {

            if(currentGame.passableNonUpdatables.x < currentViewBounds.minX || currentGame.passableNonUpdatables.x > currentViewBounds.maxX) {
                if(currentGame.passableNonUpdatables.y < currentViewBounds.minY || currentGame.passableNonUpdatables.y > currentViewBounds.maxY) {
                    continue;
                }
            }

            drawBuilding(currentGame.passableNonUpdatables[i],false,"passable");
        }

        // finished passable items 
        for(var passdef in currentGame.finishedPassableNonUpdatables) {
            var td = currentGame.finishedPassableNonUpdatables[passdef];
            for(var passX in td) {
                var tx = td[passX];
                for(var ty = 0; ty < tx.length; ty++) {
                    var passY = tx[ty];
                    drawNewPassable(passdef,parseInt(passX),parseInt(passY));
                }
            }
        }
        
        for(i = 0; i < currentGame.mapResources.length; i++) {


            if(currentGame.mapResources.x < currentViewBounds.minX || currentGame.mapResources.x > currentViewBounds.maxX) {
                if(currentGame.mapResources.y < currentViewBounds.minY || currentGame.mapResources.y > currentViewBounds.maxY) {
                    continue;
                }
            }

            drawBuilding(currentGame.mapResources[i],true,"resource");
        }
        
        if(simulatedTileSize > 40) {
            for(i = 0; i < currentGame.colonists.length; i++) {
                drawVehicle(currentGame.colonists[i],"colonist");
            }

            for(i = 0; i < currentGame.tourists.length; i++) {
                drawVehicle(currentGame.tourists[i],"colonist");
            }

            for(i = 0; i < currentGame.diplomats.length; i++) {
                drawVehicle(currentGame.diplomats[i],"colonist");
            }
        }

        if(queuedBuildings != null && queuedBuildings.length > 0 && queuedBuilding != null) {
            for(i = 0; i < queuedBuildings.length; i++) {
                drawPendingBuilding(queuedBuildings[i].x,queuedBuildings[i].y,"rgba(0,0,255,.4)",true);
            }
        }

        if(touchPossibleBuildPoints != null && queuedBuilding != null) {
            for(i = 0; i < touchPossibleBuildPoints.length; i++) {
                Scroll2d.drawSquare("rgba(0,255,0,.2)",touchPossibleBuildPoints[i].x,touchPossibleBuildPoints[i].y,2);
            }
        }

        if(chainQueue!= null && queuedBuilding != null) {
            for(i = 0; i < chainQueue.length; i++) {
                Scroll2d.drawSquare("rgba(0,0,255,.2)",chainQueue[i].x,chainQueue[i].y,2);
            }
        }

        if(currentGame.mem && ColonyGame.meta.mapEditorStartFlagAsset != null) {
            Scroll2d.drawSprite(gameAssets[ColonyGame.meta.mapEditorStartFlagAsset][0].image,currentGame.mestartx,currentGame.mestarty,x,y,0,null,null,1,10);
        }
        
        if(usingMouse) {

            var hoverColor = "rgba(0,0,0,.4)";

            if(inMultiSelectionMode) {
                hoverColor = "rgba(0,255,0,.4)";
            } else {
                if(hoverPassable) {
                    if(queuedMove != null || queuedPark != null) {
                        hoverColor = "rgba(255,255,255,.4)";
                    } else {
                        hoverColor = "rgba(0,0,0,.4)";
                    }
                    
                } else {
                    hoverColor = "rgba(255,0,0,.4)";
                }
            }

            if(bulldozerMode) {
                hoverColor = "rgba(255,0,0,.6)";
            }

            Scroll2d.drawSquare(hoverColor,hoverX,hoverY,2);
        }
        
        if(selectedVehicle.length > 0) {
            for(i = 0; i < selectedVehicle.length; i++) {
                

                if(selectedVehicle[i].x != selectedVehicle[i].dX || selectedVehicle[i].y != selectedVehicle[i].dY) {
                    Scroll2d.drawLine("#00ff00",selectedVehicle[i].x,selectedVehicle[i].y,selectedVehicle[i].dX,selectedVehicle[i].dY,1);
                }

                if(selectedVehicle[i].pd != null) {
                    for(var oX = 0; oX < selectedVehicle[i].pd.tileWidth; oX++) {
                        for(var oY = 0; oY < selectedVehicle[i].pd.tileHeight; oY++) {
                            var useX = selectedVehicle[i].x + oX;
                            var useY = selectedVehicle[i].y + oY;

                            if(isTilePassable(useX,useY,true,false)) {
                                Scroll2d.drawSquare("rgba(0,255,0,.6)",useX,useY,2);
                            } else {
                                Scroll2d.drawSquare("rgba(255,0,0,.6)",useX,useY,2);
                            }
                        }
                    }
                } else {
                    Scroll2d.drawSquare("rgba(0,0,255,.6)",selectedVehicle[i].x,selectedVehicle[i].y,2);
                }
            }
        }
        
        if (selectedBuilding != null) {

            if(selectedBuilding.occupiesTiles != null) {
                for(i = 0; i < selectedBuilding.occupiesTiles.length; i++) {
                    Scroll2d.drawSquare("rgba(0,0,255,.6)",selectedBuilding.occupiesTiles[i].x,selectedBuilding.occupiesTiles[i].y,2);
                }
            }

        }
        
        if(queuedBuilding != null && pendingBuildX != null && pendingBuildY != null) {
            drawPendingBuilding(pendingBuildX,pendingBuildY,"rgba(0,255,0,.6)",false);
        } else {
            if(queuedBuilding != null) {
                drawPendingBuilding(hoverX,hoverY,"rgba(0,255,0,.6)",false);
            }
        }


        for(i = 0; i < currentGame.buildings.length; i++) {

            if(currentGame.buildings.x < currentViewBounds.minX || currentGame.buildings.x > currentViewBounds.maxX) {
                if(currentGame.buildings.y < currentViewBounds.minY || currentGame.buildings.y > currentViewBounds.maxY) {
                    continue;
                }
            }

            drawBuilding(currentGame.buildings[i],false,"building");
        }
        
        for(i = 0; i < currentGame.vehicles.length; i++) {
            drawVehicle(currentGame.vehicles[i],"vehicle");
        }
    }
    
    function drawPendingBuilding(x,y,color,emphasizeBase) {

        if(queuedBuilding == null) {
            return;
        }

        var drawBase = false;

        if(emphasizeBase) {
            drawBase = emphasizeBase;
        }

        if(queuedBuilding.tileWidth == 1 && queuedBuilding.tileHeight == 1) {
            drawBase = false;
        }

        for(var qX = 0; qX < queuedBuilding.tileWidth; qX++) {
            for(var qY = 0; qY < queuedBuilding.tileHeight; qY++) {

                var useColor = color;

                if(drawBase && qX == 0 && qY == 0) {
                    useColor = "rgba(255,0,0,.8)";
                }

                if(queuedBuildingBlocked) {
                    Scroll2d.drawSquare("rgba(255,0,0,.6)",x + qX,y + qY,2);
                } else {
                    Scroll2d.drawSquare(useColor,x + qX,y + qY,2);
                }
                
            }
        }
    }
    
    function engageBuildingQueue() {
        if(!queuedBuildings || queuedBuildings == null || queuedBuildings.length == 0) {
            return;
        }

        var firstBuilding = null;
        constructionFromSidebar = false;

        for(var i = 0; i < queuedBuildings.length; i++) {
            var freshBuilding;

            freshBuilding = new Building(queuedBuildings[i].building,queuedBuildings[i].x,queuedBuildings[i].y,0);

            if(queuedBuildings[i].building.isEmbassy) {
                freshBuilding.embassyFor = parseInt(pendingEmbassyMission.foreigncolony);
                freshBuilding.name = pendingEmbassyMission.colonyname + " Embassy";
                currentGame.buildings.push(freshBuilding);
                updateBuildingCollisionPoints(freshBuilding,150);


                var diplomatsToMake = queuedBuildings[i].building.acceptsWorkers;

                while(diplomatsToMake > 0) {

                    var freeSpaces = getFreeSpacesAroundBuilding(freshBuilding);
                    
                    var dest = {
                        "x": freshBuilding.x,
                        "y": freshBuilding.y
                    };

                    if(freeSpaces.length > 0) {
                        var freeSpace = freeSpaces[randomIntFromInterval(0,freeSpaces.length - 1)];

                        dest = {
                            "x": freeSpace[0],
                            "y": freeSpace[1]
                        };
                    }

                    var freshDiplomat = new Colonist(dest.x,dest.y,false,pendingEmbassyMission.race);

                    setupNewColonist(freshDiplomat);
                    setColonistMask(freshDiplomat,"IS_DIPLOMAT",true);

                    addWorker(freshBuilding,freshDiplomat);
                    addResident(freshBuilding,freshDiplomat);

                    freshDiplomat.fn = parseInt(pendingEmbassyMission.foreigncolony);

                    currentGame.diplomats.push(freshDiplomat);

                    diplomatsToMake--;
                }

                alertEmbassyBuilt(pendingEmbassyMission);

                pendingEmbassyMission = null;

                
            } else {
                if(currentGame.cm) {
                    if(getBuildingDefByName(freshBuilding.def).becomesTerrain) {
                        freeRefNukeTurn = true;
                        var fresherBuilding = new MapResource(getTerrainDefByName(getBuildingDefByName(freshBuilding.def).becomesTerrain),freshBuilding.x,freshBuilding.y);
                        currentGame.mapResources.push(fresherBuilding);
                        shouldUpdateCollissionMap = true;
                        //queuedBuildings = null;
                        firstBuilding = null;
                        queuedBuilding = null;
                        selectedVehicle = [];
                        shoreUpdateTurn = true;
                        //clearOutBuildMenu();
                        continue;
        
                    }
                } else {
                    freshBuilding.isUnderConstruction = true;
                }

                constructionProjectsArray.push(freshBuilding);

                var isNonUpdatable = false;

                if(queuedBuildings[i].building.passable) {
                    if(queuedBuildings[i].building.tileWidth == 1 && queuedBuildings[i].building.tileHeight == 1) {
                        if(queuedBuildings[i].building.requiresFuel == null && queuedBuildings[i].building.stores == null) {
                            if(queuedBuildings[i].building.generates == null) {
                                if(queuedBuildings[i].building.smelts == null) {
                                    if(queuedBuildings[i].building.produces == null) {
                                        isNonUpdatable = true;
                                    }
                                }
                            }
                        }
                    }
                }

                freeRefNukeTurn = true;
                
                if(isNonUpdatable) {

                    currentGame.passableNonUpdatables.push(freshBuilding);

                } else {

                    currentGame.buildings.push(freshBuilding);
                    updateUtilityGrid();

                    updateBuildingCollisionPoints(freshBuilding,150);
                }

                freshBuilding.c = new ConstructionItem();
                
                
                freshBuilding.c.c = 0;
                freshBuilding.c.p = 0;
                freshBuilding.c.t = 0;
                freshBuilding.c.pr = {};
                
                if(!currentGame.cm) {
                    for(var k = 0; k < queuedBuildings[i].building.cost.length; k++) {
                        freshBuilding.c.pr[queuedBuildings[i].building.cost[k].resource] = queuedBuildings[i].building.cost[k].amount;
                        freshBuilding.c.t += queuedBuildings[i].building.cost[k].amount;
                    }
                }

                if(i == 0) {
                    firstBuilding = freshBuilding;
                }
            }

            
        }

        shouldUpdateCollissionMap = true;

        if(selectedVehicle.length > 0) {
            for(i = 0; i < selectedVehicle.length; i++) {
                sendVehicleToConstructionSite(selectedVehicle[i],firstBuilding);
            }
        }

        if(firstBuilding != null) {
            callNearbyBuilders(firstBuilding.x,firstBuilding.y,0);
        }


        queuedBuildings = null;
        firstBuilding = null;
        queuedBuilding = null;
        selectedVehicle = [];

        clearOutBuildMenu();
    }

    function sendVehicleToConstructionSite(vehicle,site,forHarvest) {

        if(vehicle == null || site == null) {
            return;
        }

        var availableSpaces = [];
                
        for(var j = 0; j < site.occupiesTiles.length; j++) {
            var newSpaces = getFreeSpaceAroundTile(site.occupiesTiles[j].x,site.occupiesTiles[j].y,1);
            availableSpaces = availableSpaces.concat(newSpaces);
        }
        

        if(availableSpaces.length > 0) {
            
            var idx = randomIntFromInterval(0,availableSpaces.length - 1);
            var target = availableSpaces[idx];

            vehicle.dX = target[0];
            vehicle.dY = target[1];

            if(forHarvest) {
                vehicle.inBuildingMode = false;
                vehicle.iH = true;
            } else {
                vehicle.inBuildingMode = true;
                vehicle.iH = false;
                vehicle.ht = null;
            }

            

            vehicle.blacklist = [];
            vehicle.bBlacklist = [];
        }

        availableSpaces = null;
    }
    
    function startBuilding(x,y) {

        var blocked = checkForGeneralBlockage(queuedBuilding,x,y);

        var i;
        
        if(queuedBuildingBlocked || blocked) {


            var killBuilding = null;

            for(i = 0; i < queuedBuildings.length; i++) {
                if(queuedBuildings[i].x == x && queuedBuildings[i].y == y) {
                    killBuilding = queuedBuildings[i];
                    break;
                }
            }

            if(killBuilding != null) {
                removeFromArray(queuedBuildings,killBuilding);
                return;
            }

            webAppCore.showToast("Location Blocked");

            if(usingMouse && queuedBuildings.length == 0) {
                queuedBuilding = null;
                selectedVehicle = [];
                clearOutBuildMenu();
            }

            

            return;
        }

        pendingBuildX = x;
        pendingBuildY = y;
        
        showBuildConfirm();

        cqX = x;
        cqY = y;

        if(!queuedBuildings || queuedBuildings == null || queuedBuilding.isEmbassy) {
            queuedBuildings = [];
        }

        var removeItem = null;

        for(i = 0; i < queuedBuildings.length; i++) {
            if(queuedBuildings[i].x == x && queuedBuildings[i].y == y) {
                removeItem = queuedBuildings[i];
                continue;
            }
        }

        if(removeItem != null) {
            removeFromArray(queuedBuildings,removeItem);
            return;
        }
        
        pendingBuildX = null;
        pendingBuildY = null;

        queuedBuildings.push({
            x: x,
            y: y,
            building: queuedBuilding
        });

    }

    var cqX;
    var cqY;

    function onSelectionChange() {
        inMultiSelectionMode = true;
    }

    function onSelectionDone(topLeft,topRight,bottomLeft,bottomRight) {

        inMultiSelectionMode = false;

        selectedVehicle = [];

        for(var i = 0; i < currentGame.vehicles.length; i++) {

            var coord = { "x": currentGame.vehicles[i].x, "y": currentGame.vehicles[i].y };

            var selected = false;

            if(ptInTriangle(coord, topLeft,topRight,bottomRight)) {
                selected = true;
            } else {
                if(ptInTriangle(coord, topLeft,bottomLeft,bottomRight)) {
                    selected = true;
                }
            }

            if(selected) {
                selectedVehicle.push(currentGame.vehicles[i]);
            }

        }

        if(selectedVehicle.length > 0) {
            drawSidebar();
            showOptionsForObject(selectedVehicle,"vehicle");
        }
    }

    function ptInTriangle(p, p0, p1, p2) {
        var dX = p.x-p2.x;
        var dY = p.y-p2.y;
        var dX21 = p2.x-p1.x;
        var dY12 = p1.y-p2.y;
        var D = dY12*(p0.x-p2.x) + dX21*(p0.y-p2.y);
        var s = dY12*dX + dX21*dY;
        var t = (p2.y-p0.y)*dX + (p0.x-p2.x)*dY;
        if (D<0) return s<=0 && t<=0 && s+t>=D;
        return s>=0 && t>=0 && s+t<=D;
    }

    function closeGBT() {
        if(usingSockets) {
            webAppCore.socketEmit("leaveroom","trades");
        }

        
        document.getElementById("gbtNewsData").innerHTML = "";

        tickerItems = [];

        showingLive = false;

        document.getElementById("galBT").style.display = "none";
        gbtOpen = false;

        
        staticFrame = false;
        Scroll2d.forceSceneChange();
    }

    function closeCommonwealthMenu() {
        document.getElementById("commonwealthWindow").style.display = "none";
        commonwealthMenuOpen = false;

        staticFrame = false;
        Scroll2d.forceSceneChange();
    }

    function extendTouchPointsFromPosition(x,y) {
        touchPossibleBuildPoints = [];


        if(queuedBuilding == null || !chainQueue) {
            return;
        }

        var cX,cY,keepGoing,i;

        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cY--;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }


        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cY++;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }


        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cX--;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }


        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cX++;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }
    }

    function queueSelectedVehicleForMove() {
        queuedMove = selectedVehicle;
        
        for(var i = 0; i < selectedVehicle.length; i++) {
            selectedVehicle[i].iH = false;
            selectedVehicle[i].ht = null;
            selectedVehicle[i].inBuildingMode = false;
            selectedVehicle[i].blacklist = [];
            selectedVehicle[i].bBlacklist = [];
            setAwaitingPath(selectedVehicle[i],"vehicle",false);
        }
    }

    function rightClick(x,y,aX,aY,type) {

        var saveSelected = null;

        if(selectedVehicle.length > 0) {
            saveSelected = selectedVehicle;
            queueSelectedVehicleForMove();
            //document.getElementById("objectOptions").style.display = "none";
        }

        click(x,y,aX,aY,type);

        queuedMove = null;

        if(saveSelected != null) {

            selectedVehicle = saveSelected;
            showOptionsForObject(saveSelected,"vehicle",true);
        }
    }
    
    var lastPaintX = 0;
    var lastPaintY = 0;

    function paint(x,y) {

        if(x == lastPaintX && y == lastPaintY) {
            return;
        }

        lastPaintX = x;
        lastPaintY = y;

        if(currentGame == null) {
            return;
        }

        if(!currentGame.mem || bulldozerMode || selectedMapEditorTool == null) {
            return;
        }

        click(x,y);
    }
    
    function click(x,y,aX,aY,type) {

        var somethingWasOpen = closeSomethingIfOpen();
        
        hideSidebarIfSmall();

        if(somethingWasOpen) {
            selectedBuilding = null;
            drawSidebar();
            return;
        }

        cooldownGamepad();

        var i;

        actualX = aX;
        actualY = aY;

        if(currentGame == null) {
            return;
        }


        if(currentGame.mem) {
            Scroll2d.alertPainting();
        }

        if(currentGame.mem && !bulldozerMode && mapEditorPlacingStartFlag) {
            if(!isTilePassable(x,y,false,true)) {
                return;
            }

            currentGame.mestartx = x;
            currentGame.mestarty = y;

            return;
        }


        if(currentGame.mem && !bulldozerMode && selectedMapEditorTool != null) {

            if(!isTilePassable(x,y,false,true)) {
                return;
            }

            

            destroyAtTile(x,y,selectedMapEditorTool.tileWidth,selectedMapEditorTool.tileHeight,false);

            var resourceItem = new MapResource(selectedMapEditorTool,x,y);
            freeRefNukeTurn = true;
            updateBuildingCollisionPoints(resourceItem,150);
            currentGame.mapResources.push(resourceItem);
            shoreUpdateTurn = true;

            return;
        }

        var tmpChopVehicles = null;
        
        if(queuedMove != null || queuedPark != null) {
            if(isTilePassable(x,y)) {


                if(queuedMove != null) {
                    if(Array.isArray(queuedMove)) {
                        var choices = getFreeSpaceAroundTile(x,y,2,true);
                        
                        if(choices.length > 0) {
                            for(i = 0; i < queuedMove.length; i++) {
                                if(i == 0) {
                                    moveVehicle(x,y,queuedMove[i]);
                                } else {
                                    var rndPos = choices[randomIntFromInterval(0,choices.length - 1)];
                                    moveVehicle(rndPos[0],rndPos[1],queuedMove[i]);
                                }
                            }
                        }
                    } else {
                        moveVehicle(x,y,queuedMove);
                    }

                    queuedMove = null;
                    
                }



                if(queuedPark != null) {
                    for(i = 0; i < selectedVehicle.length; i++) {
                        selectedVehicle[i].pX = x;
                        selectedVehicle[i].pY = y;
                        parkVehicle(selectedVehicle[i]);
                    }
                    webAppCore.showToast(getString("general-park-confirm"));

                }

                for(i = 0; i < selectedVehicle.length; i++) {
                    selectedVehicle[i].iH = false;

                    selectedVehicle[i].inBuildingMode = false;

                    selectedVehicle[i].blacklist = [];
                    selectedVehicle[i].bBlacklist = [];
                }

                queuedPark = null;
                queuedMove = null;
                selectedVehicle = [];
                selectedColonist = null;
                
                document.getElementById("objectOptions").style.display = "none";
                drawSidebar();
                return;
            }
        }

        if(queuedBuilding != null && (selectedVehicle != null || constructionFromSidebar)) {

            if(!queuedBuildings || queuedBuildings == null || queuedBuildings.isEmbassy) {
                queuedBuildings = [];
                chainQueue = [];
            }

            if(type == "touch") {

                for(i = 0; i < touchPossibleBuildPoints.length; i++) {
                    if(touchPossibleBuildPoints[i].x == x && touchPossibleBuildPoints[i].y == y) {
                        handleChain(x,y);
                        break;
                    }
                }

            }

            if(chainQueue != null && chainQueue.length > 0) {
                for(i = 0; i < chainQueue.length; i++) {
                    startBuilding(chainQueue[i].x,chainQueue[i].y);
                }
            } else {
                startBuilding(x,y);
            }

            if(type == "touch") {
                extendTouchPointsFromPosition(x,y);
            }

            chainQueue = [];
            

            return;

        }

        tmpChopVehicles = selectedVehicle;

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedPassable = null;

        if(!inHireMode) {
            selectedColonist = null;
        }
        
        var j;

        if(!inHireMode) {
            for(i = 0; i < currentGame.vehicles.length; i++) {

                if(currentGame.vehicles[i].iv > 0) {
                    continue;
                }

                if(currentGame.vehicles[i].x == x && currentGame.vehicles[i].y == y) {
                    selectedVehicle.push(currentGame.vehicles[i]);

                    if(bulldozerMode) {
                        destroyVehicle(selectedVehicle);
                        return;
                    }

                    //break;
                }
            }

            if(selectedVehicle.length > 0) {
                if(tmpChopVehicles && tmpChopVehicles.length == 1) {
                    if(selectedVehicle[0] == tmpChopVehicles[0]) {
                        selectedVehicle = [];
                        var typ = tmpChopVehicles[0].def;

                        for(i = 0; i < currentGame.vehicles.length; i++) {
                            if(currentGame.vehicles[i].def == typ) {
                                selectedVehicle.push(currentGame.vehicles[i]);
                            }
                        }

                        drawSidebar();
                        showOptionsForObject(selectedVehicle,"vehicle");
                        return;
                    }
                }

                drawSidebar();
                showOptionsForObject(selectedVehicle,"vehicle");
                return;
            }
        }

        if(inHireMode) {
            console.log(selectedColonist);
        }

        if(!inHireMode) {
            for(i = 0; i < currentGame.colonists.length; i++) {
                if(currentGame.colonists[i].x == x && currentGame.colonists[i].y == y) {
                    if(!getColonistMask(currentGame.colonists[i],"AT_WORK") && !getColonistMask(currentGame.colonists[i],"AT_HOME") && !getColonistMask(currentGame.colonists[i],"IS_SIMULATED") && !getColonistMask(currentGame.colonists[i],"IS_HEALING") && !getColonistMask(currentGame.colonists[i],"IS_RELAXING")) {

                        if(bulldozerMode) {
                            pendingExecution = currentGame.colonists[i];
                            conductExecution();
                        } else {
                            selectedColonist = currentGame.colonists[i];
                            showOptionsForObject(selectedColonist,"colonist");
                        }
                        
                        return;
                    }
                }
            }
        }
        
        for(i = 0; i < currentGame.buildings.length; i++) {
            
            if(currentGame.buildings[i].occupiesTiles) {
                for(j = 0; j < currentGame.buildings[i].occupiesTiles.length; j++) {
                    if(currentGame.buildings[i].occupiesTiles[j].x == x && currentGame.buildings[i].occupiesTiles[j].y == y) {

                        if(bulldozerMode) {
                            if(currentGame.buildings[i].isUnderConstruction) {
                                currentGame.buildings[i].isBeingRemoved = true;
                            } else {
                                currentGame.buildings[i].condition = -1;
                            }
                            
                            return;
                        } else {

                            selectedBuilding = currentGame.buildings[i];

                            if(!selectedBuilding.isUnderConstruction) {
                                if(getBuildingDefByName(selectedBuilding.def).isChopShop && tmpChopVehicles != null && tmpChopVehicles.length > 0) {
                                    document.getElementById("objectOptions").style.display = "none";

                                    for(i = 0; i < tmpChopVehicles.length; i++) {
                                        sendVehicleToChopShop(tmpChopVehicles[i],selectedBuilding);
                                    }

                                    selectedBuilding = null;
                                    return;
                                }
                            }

                            if(selectedBuilding.isUnderConstruction && tmpChopVehicles != null && tmpChopVehicles.length > 0) {
                                document.getElementById("objectOptions").style.display = "none";

                                for(i = 0; i < tmpChopVehicles.length; i++) {
                                    sendVehicleToConstructionSite(tmpChopVehicles[i],selectedBuilding);
                                }

                                selectedBuilding = null;
                                selectedVehicle = [];
                                return;
                            }

                            if(inHireMode) {

                                if(addWorker(selectedBuilding,selectedColonist)) {
                                    selectedColonist.dX = selectedColonist.x;
                                    selectedColonist.dY = selectedColonist.y;
                                    selectedColonist.energyCounter = 98;
                                    inHireMode = false;
                                    selectedColonist = null;
                                    document.getElementById("hireWorkerConfirm").style.display = "none";
                                    clearOutBuildMenu();
                                }
                            } else {
                                drawSidebar();
                                showOptionsForObject(selectedBuilding,"building");
                            }
                            
                            return;
                        }
                    }
                }
            }

  
        }
        
        if(!inHireMode) {


            for(i = 0; i < currentGame.passableNonUpdatables.length; i++) {
                
                if(currentGame.passableNonUpdatables[i].occupiesTiles == null) {
                    continue;
                }

                for(j = 0; j < currentGame.passableNonUpdatables[i].occupiesTiles.length; j++) {
                    if(currentGame.passableNonUpdatables[i].occupiesTiles[j].x == x && currentGame.passableNonUpdatables[i].occupiesTiles[j].y == y) {
                        selectedPassable = currentGame.passableNonUpdatables[i];
                        showOptionsForObject(selectedPassable,"passable");
                        return;
                    }
                }
                
                if(currentGame.passableNonUpdatables[i].x == x && currentGame.passableNonUpdatables[i].y == y) {
                    selectedPassable = currentGame.passableNonUpdatables[i];
                    showOptionsForObject(selectedPassable,"passable");
                    return;
                }
            }




            for(i = 0; i < currentGame.mapResources.length; i++) {

                if(currentGame.mapResources[i].occupiesTiles == null) {
                    continue;
                }
                
                for(j = 0; j < currentGame.mapResources[i].occupiesTiles.length; j++) {
                    if(currentGame.mapResources[i].occupiesTiles[j].x == x && currentGame.mapResources[i].occupiesTiles[j].y == y) {

                        
                        selectedResource = currentGame.mapResources[i];
                        var sentHarvester = false;

                        if(tmpChopVehicles != null && tmpChopVehicles.length > 0) {
                            for(var k = 0; k < tmpChopVehicles.length; k++) {

                                if(currentGame.mapResources[i].playDef.provides == tmpChopVehicles[k].harvests) {
                                    sendVehicleToConstructionSite(tmpChopVehicles[k],selectedResource,true);
                                    sentHarvester = true;
                                }

                                
                            }
                        }

                        if(sentHarvester) {
                            selectedResource = null;
                            selectedVehicle = [];
                            return;
                        }

                        if(bulldozerMode) {
                            destroyResource(selectedResource,true);
                        } else {
                            showOptionsForObject(selectedResource,"resource");
                        }
                        
                        return;
                    }
                }
                
            }
        }

        var killItem = null;
        

        for(var passdef in currentGame.finishedPassableNonUpdatables) {
            var td = currentGame.finishedPassableNonUpdatables[passdef];

            if(td[x]) {
                var tx = td[x];

                for(var ty = 0; ty < tx.length; ty++) {
                    if(parseInt(tx[ty]) == y) {
                        killItem = ty;
                        break;
                    }
                }

                if(killItem != null) {
                    if(bulldozerMode) {
                        tx.splice(ty,1);
                        if(allowParticleEffects) {
                            Scroll2d.playParticleEffect("explosion",x,y);
                        }
                        staticFrame = false;
                        Scroll2d.forceSceneChange();
                        return;
                    } else {
                        showNewObjectOptionsMenu(passdef,"passable",x,y);
                        return;
                    }
                }
            }

        }
        
        
        
        if(selectedVehicle.length == 0 && selectedBuilding == null) {
            clearOutBuildMenu();
            document.getElementById("objectOptions").style.display = "none";
        }

        bulldozerMode = false;
        selectedBuilding = null;
    }
    
    function showBuildConfirm() {
        webAppCore.handleBackFunction(clearOutBuildMenu);

        if(gamepadInUse) {
            document.getElementById("gamepadBuildConfirm").style.display = "block";
            return;
        } else {
            if(window.innerWidth >= 1000 && queuedBuilding != null) {
                showDesktopBuildConfirm();
            } else {
                document.getElementById("touchBuildConfirm").style.display = "block";
            }
            
        }

    }


    function getFreeSpacesAroundBuilding(building,radius,decorationsBlock,isTerrain) {

        

        if(building.occupiesTiles == null) {
            building.occupiesTiles = getOccupiedTiles(building);
        }

        if(!radius) {
            radius = 1;
        }

        if(radius == 1 && building.freeRef != null && !decorationsBlock && building.freeRef.length > 0) {
            return building.freeRef;
        }

        var def;

        if(isTerrain) {

            if(building.playDef == null) {
                building.playDef = getTerrainDefByName(building.def);
            }

            def = building.playDef;
        } else {
            def = getBuildingDefByName(building.def);
        }

        if(def == null) {
            return [];
        }

        var allParameterSpaces = [];
        var freeParameterSpaces = [];

        var i;

        var leftX = building.x - 1;
        var rightX = building.x + def.tileWidth;

        var topY = building.y - 1;
        var bottomY = building.y + def.tileHeight;

        for(i = leftX; i <= rightX; i++) {
            allParameterSpaces.push([i,topY]);
            allParameterSpaces.push([i,bottomY]);
        }

        for(i = topY + 1; i < bottomY; i++) {
            allParameterSpaces.push([leftX,i]);
            allParameterSpaces.push([rightX,i]);
        }

        for(i = 0; i < allParameterSpaces.length; i++) {
            if(isTilePassable(allParameterSpaces[i][0],allParameterSpaces[i][1],decorationsBlock)) {
                freeParameterSpaces.push(allParameterSpaces[i]);
            }
        }

        var killArray = [];

        for(i = 0; i < building.occupiesTiles.length; i++) {
            for(var j = 0; j < freeParameterSpaces.length; j++) {
                if(freeParameterSpaces[j][0] == building.occupiesTiles[i].x && freeParameterSpaces[j][1] == building.occupiesTiles[i].y) {
                    killArray.push(freeParameterSpaces[j]);
                }
            }
        }

        for(i = 0; i < killArray.length; i++) {
            removeFromArray(freeParameterSpaces,killArray[i]);
        }

        allParameterSpaces = null;

        if(radius == 1 && !decorationsBlock) {
            building.freeRef = freeParameterSpaces;
        }

        return freeParameterSpaces;
    }

    function getFreeSpaceAroundTile(x,y,rad,include) {
        var freeTiles = [];
        
        var radius = 1;
        
        if(rad) {
            radius = rad;
        }

        for(var cx = x - radius; cx < x + (radius + 1); cx++) {
            for(var cy = y - radius; cy < y + (radius + 1); cy++) {
                if(cx >=0 && cy >= 0 && cx <= currentGame.width && cy <= currentGame.height) {
                    var passable = isTilePassable(cx,cy,false);

                    if(passable || (include && (include.x == cx && include.y == cy))) {
                        freeTiles.push([cx,cy]);
                    }
                }
            }
        }
        
        return freeTiles;
    }

    function getAllSpacesAroundTile(x,y,rad) {
        var freeTiles = [];
        
        var radius = 1;
        
        if(rad) {
            radius = rad;
        }

        for(var cx = x - radius; cx < x + (radius + 1); cx++) {
            for(var cy = y - radius; cy < y + (radius + 1); cy++) {
                if(cx >=0 && cy >= 0 && cx <= currentGame.width && cy <= currentGame.height) {
                    var a = x - cx;
                    var b = y - cy;
                    var distance = Math.sqrt( a*a + b*b );

                    if(distance < radius) {
                        freeTiles.push([cx,cy]);
                    }
                }
            }
        }
        
        return freeTiles;
    }

    function showBuildingConstructionOptionsNew(object,type,islist) {

        var availableOptions = 0;
        var i,j;
        var menuOptions = [];
        var buildOptionListing;

        var useType = type;

        if(islist) {
            tmpBuildingRef = null;
            buildOptionListing = islist;

            if(type == "building") {
                type = "vehicle";
            } else {
                type = "building";
            }
        } else {
            if(type == "building") {
                buildOptionListing = getBuildingDefByName(object.def).produces;
            }

            if(type == "vehicle") {
                buildOptionListing = getVehicleDefByName(object.def).produces;
            }

            if(type == "building" || type == "resource") {
                tmpBuildingRef = object;
            } else {
                tmpBuildingRef = null;
            }
        }

        for(i = 0; i < buildOptionListing.length; i++) {

            var buildOption;
            var opTyp;
            

            if(islist) {
                opTyp = useType;
                buildOption = buildOptionListing[i];
            } else {
                if(type == "building") {
                    buildOption = getVehicleDefByName(buildOptionListing[i]);
                    opTyp = "vehicle";
                } else {
                    buildOption = getBuildingDefByName(buildOptionListing[i]);
                    opTyp = "building";
                    if(buildOption.isEmbassy) {
                        continue;
                    }
                }
            }

            var canBuild = canIBuildThis(buildOption,opTyp);

            if(!canBuild) {
                continue;
            }

            availableOptions++;

            var cost = [];
            var def;
            var costColor;

            if(buildOption.tileWidth != null && buildOption.tileHeight != null) {
                cost.push({
                    pre:    "Size:",
                    post:   buildOption.tileWidth + "x" + buildOption.tileHeight,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.dimensionIndicator
                });
            }

            if(buildOption.requiresUtility != null) {
                for(j = 0; j < buildOption.requiresUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.requiresUtility[j].utility);

                    costColor = null;

                    if(buildOption.requiresUtility[j].amount + currentGame.utilities[buildOption.requiresUtility[j].utility].usage > currentGame.utilities[buildOption.requiresUtility[j].utility].capacity) {
                        costColor = "#F44336";
                    }

                    cost.push({
                        pre:    "需要:",
                        post:   numberWithCommas(buildOption.requiresUtility[j].amount),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            for(j = 0; j < buildOption.cost.length; j++) {
                
                def = getResourceByDefName(buildOption.cost[j].resource);

                costColor = null;

                if(buildOption.cost[j].amount > currentGame.resources[buildOption.cost[j].resource].amount) {
                    costColor = "#F44336";
                }

                cost.push({
                    pre:    "花费:",
                    post:   def.indicator + numberWithCommas(buildOption.cost[j].amount),
                    color:  costColor,
                    icon:   "images/" + def.icon
                });
            }

            

            if(buildOption.providesUtility != null) {
                for(j = 0; j < buildOption.providesUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.providesUtility[j].utility);

                    costColor = null;

                    cost.push({
                        pre:    "生成:",
                        post:   buildOption.providesUtility[j].amount,
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            if(buildOption.acceptsWorkers != null && buildOption.acceptsWorkers > 0) {
                cost.push({
                    pre:    "工人:",
                    post:   buildOption.acceptsWorkers,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.colonistIcon
                });
            }

            if(buildOption.requiPremium && !webAppCore.getIsPremium()) {
                cost.push({
                    pre:    null,
                    post:   "Premium Content",
                    color:  "#F44336",
                    icon:   "images/" + ColonyGame.meta.giftIndicator
                });
            }

            var img;

            if(buildOption.indicator == null) {
                if(type == "vehicle") {
                    img = gameAssets[buildOption.tile[0]][0].image.src;
                } else {
                    img = gameAssets[buildOption.tile][0].image.src;
                }
                
            } else {
                img = "images/" + buildOption.indicator;
            }

            menuOptions.push({
                "title":        buildOption.name,
                "description":  getString(buildOption.description),
                "icon":         img,
                "overflow":     cost,
                "tag":          buildOption
            });

        }

        if(availableOptions > 0) {
            showList("Build Options",menuOptions,initConstruction,getString("general-dismiss"));
        } else {
            webAppCore.showAlertWithTitle("Nothing to build at this time.","No Build Options");
        }

    }

    var tmpListTitle;
    var tmpListItems;
    var tmpListCallback;
    var tmpListDismiss;

    function showList(title,items,callback,dismiss) {

        var forceNative = false;

        if(webAppCore.getPlatform().platform == "desktop") {
            if(parent.document.fullscreenElement || parent.document.webkitFullscreenElement || parent.document.mozFullScreenElement || parent.document.msFullscreenElement) {
                forceNative = true;
            }
        }

        if(forceNative && !titleShowing) {
            showMockNativeList(title,items,callback);
        } else {
            tmpListTitle = title;
            tmpListItems = items;
            tmpListCallback = callback;
            tmpListDismiss = dismiss;

            setTimeout(function() {
                webAppCore.presentNativeList(tmpListTitle,tmpListItems,tmpListCallback,tmpListDismiss);
            },150);
        }
    }

    function showMockNativeList(title, items,callback) {
        webAppCore.handleBackFunction(clearOutBuildMenu);

        document.getElementById("menuListTitle").innerHTML = title;
        document.getElementById("constructionMenuItems").innerHTML = "";
        

        var i,j;

        for(i = 0; i < items.length; i++) {
            
            var buildOption = items[i];
            
            var buildOptionDiv = document.createElement("div");
            buildOptionDiv.className = "buildOption";

            if(webAppCore.getPlatform().platform == "desktop" || ((webAppCore.getPlatform().platform == "web" || webAppCore.getPlatform().platform == "windows") && window.innerWidth > 500) ) {
                buildOptionDiv.className = "buildOption buildOptionDesktop";
            }

            buildOptionDiv.buildRef = buildOption;
            buildOptionDiv.buildingRef = buildOption.tag;
            buildOptionDiv.callbackref = callback;
            
            if(buildOption.icon) {
                var optionImage = document.createElement("img");
                optionImage.className = "buildOptionImage";
                optionImage.src = buildOption.icon;
                buildOptionDiv.appendChild(optionImage);
            }
            
            if(buildOption.title) {
                var optionNameSpan = document.createElement("span");
                optionNameSpan.innerHTML = buildOption.title;
                if(buildOption["title-color"]) {
                    optionNameSpan.style.color = buildOption["title-color"];
                }
                optionNameSpan.className = "buildOptionName";
                buildOptionDiv.appendChild(optionNameSpan);
            }
            
            if(buildOption.description) {
                var optionDescriptionSpan = document.createElement("span");
                optionDescriptionSpan.innerHTML = buildOption.description;
                optionDescriptionSpan.className = "buildOptionDescription";
                buildOptionDiv.appendChild(optionDescriptionSpan);
            }

            if(buildOption.status) {
                var optionStatusSpan = document.createElement("span");
                optionStatusSpan.innerHTML = buildOption.status;
                if(buildOption["status-color"]) {
                    optionStatusSpan.style.color = buildOption["status-color"];
                }
                optionStatusSpan.className = "buildOptionCost";
                buildOptionDiv.appendChild(optionStatusSpan);
            }

            if(buildOption.overflow) {
                for(j = 0; j < buildOption.overflow.length; j++) {

                    var overflowItem = buildOption.overflow[j];
                    var innerOption = "";

                    if(overflowItem.pre != null) {
                        innerOption += overflowItem.pre;
                    }

                    if(overflowItem.icon != null) {
                        innerOption += " <img src=\"" + overflowItem.icon + "\" /> ";
                    }

                    if(overflowItem.post != null) {
                        innerOption += overflowItem.post;
                    }

                    var optionCostSpan = document.createElement("span");
                    optionCostSpan.innerHTML = innerOption;
                    optionCostSpan.className = "buildOptionCost";
                    if(overflowItem.color != null) {
                        optionCostSpan.style.color = overflowItem.color;
                    }
                    buildOptionDiv.appendChild(optionCostSpan);
                }
            }

            if(callback) {
                buildOptionDiv.addEventListener("click",function() {
                    clearOutBuildMenu();
                    this.callbackref(this.buildingRef);
                },false);
            }
            
            document.getElementById("constructionMenuItems").appendChild(buildOptionDiv);
        }
        
        
        document.getElementById("constructionMenu").style.display = "block";

        document.getElementById("constructionMenuItems").scrollTop = 0;
    }

    function showBuildingConstructionOptions(object,type,islist) {
        
        if(object && object.lowPowerMode) {
            webAppCore.showToast("Low Power");
            return;
        }

        if(!currentGame.unlockedTechs) {
            currentGame.unlockedTechs = {};
        }

        queuedBuildings = [];

        showBuildingConstructionOptionsNew(object,type,islist);
        return;

    }

    function hover(x,y,aX,aY,type) {

        if(gamepadInUse && type != "gamepad") {
            gamepadInUse = false;
            setBodyStyles();
        }

        window.focus();

        document.getElementById("sidebarCostInfoBox").style.display == "none";

        actualX = aX;
        actualY = aY;

        if(currentViewBounds == null) {
            return;
        }

        if(currentGame == null) {
            return;
        }
        
        if(x < 0 || x > currentGame.width) {
            return;
        }
        
        if(y < 0 || y > currentGame.height) {
            return;
        }
        
        usingMouse = true;

        if(x == hoverX && y == hoverY) {
            return;
        }

        document.getElementById("popupTooltip").style.display = "none";

        hoverX = x;
        hoverY = y;

        var newHoverBuilding = null;


        if(!inMultiSelectionMode && selectedBuilding == null && queuedBuilding == null && selectedVehicle.length == 0) {
            for(var i = 0; i < currentGame.buildings.length; i++) {

                if(currentGame.buildings[i].x < currentViewBounds.minX || currentGame.buildings[i].x > currentViewBounds.maxX) {
                    continue;
                }

                if(currentGame.buildings[i].y < currentViewBounds.minY || currentGame.buildings[i].y > currentViewBounds.maxY) {
                    continue;
                }
                
                if(currentGame.buildings[i].occupiesTiles != null) {
                    for(var j = 0; j < currentGame.buildings[i].occupiesTiles.length; j++) {
                        if(currentGame.buildings[i].occupiesTiles[j].x == x && currentGame.buildings[i].occupiesTiles[j].y == y) {
                            newHoverBuilding = currentGame.buildings[i];
                            break;
                        }

                        if(newHoverBuilding != null) {
                            break;
                        }
                    }
                }
            }
        }

        if(newHoverBuilding != hoverBuilding) {
            hoverBuilding = newHoverBuilding;

            

            if(hoverBuilding == null || !desktopMode) {
                document.getElementById("bottomHoverReadout").innerHTML = "";
                document.getElementById("bottomHoverReadout").style.display = "none";
                document.getElementById("popupTooltip").style.display = "none";
            } else {
                document.getElementById("bottomHoverReadout").innerHTML = hoverBuilding.name;
                document.getElementById("bottomHoverReadout").style.display = "inline-block";

                if(hoverBuilding.customText.trim().length > 0) {
                    showHoverPopup(hoverBuilding.customText.trim());
                }
            }
        }
        
        hoverPassable = isTilePassable(hoverX,hoverY);
        
        if(queuedBuilding) {
            checkForQueueBlockage(hoverX,hoverY);

            handleChain(x,y);
        }
    }

    function handleChain(x,y) {

        if(!chainBuildMode) {
            return;
        }

        if(collisionReference != null && cqX != null && cqY != null) {

            var i;
            chainQueue = [];

            if(x == cqX) {
                if(y < cqY) {
                    for(i = cqY - 1; i >= y; i--) {
                        chainQueue.push({"x":x,"y":i});
                    }
                }

                if(y > cqY) {
                    for(i = cqY + 1; i <= y; i++) {
                        chainQueue.push({"x":x,"y":i});
                    }
                }
            }

            if(y == cqY) {
                if(x < cqX) {
                    for(i = cqX - 1; i >= x; i--) {
                        chainQueue.push({"x":i,"y":y});
                    }
                }

                if(x > cqX) {
                    for(i = cqX + 1; i <= x; i++) {
                        chainQueue.push({"x":i,"y":y});
                    }
                }
            }

            for(i = 0; i < chainQueue.length; i++) {
                if(!isTilePassable(chainQueue[i].x,chainQueue[i].y,true)) {
                    chainQueue = [];
                }
            }
        } else {
            chainQueue = [];
        }
    }
    
    function checkForQueueBlockage(x,y) {
        queuedBuildingBlocked = checkForGeneralBlockage(queuedBuilding,x,y);

    }
    
    function checkForGeneralBlockage(building,x,y) {


        var qX,qY;

        if(building && building != null) {
            for(qX = 0; qX < building.tileWidth; qX++) {
                for(qY = 0; qY < building.tileHeight; qY++) {
                    if(!isTilePassable(x + qX,y + qY,true)) {
                        return true;
                    }

                    if(queuedBuildings != null) {
                        for(var i = 0; i < queuedBuildings.length; i++) {
                            for(var qXq = 0; qXq < building.tileWidth; qXq++) {
                                for(var qYq = 0; qYq < building.tileHeight; qYq++) {
                                    var blockedX = queuedBuildings[i].x + qXq;
                                    var blockedY = queuedBuildings[i].y + qYq;

                                    if(((x + qX) == blockedX) && ((y + qY) == blockedY)) {
                                        return true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        return false;
    }
    
    function hold() {
        
    }
    
    function isTilePassable(x,y,decorationsBlock,isFlying) {

        if(x < 0 || y < 0) {
            return false;
        }

        if(x >= collisionReference.length || y >= collisionReference[0].length) {
            return false;
        }

        var checkRef = collisionReference;

        if(isFlying) {
            checkRef = flyingCollisionReference;
        }
        
        var passable = true;
        
        var i;
        var j;
        
        if(decorationsBlock) {
            for(i = 0; i < currentGame.passableNonUpdatables.length; i++) {
                if(currentGame.passableNonUpdatables[i].occupiesTiles != null) {
                    for(j = 0; j < currentGame.passableNonUpdatables[i].occupiesTiles.length; j++) {

                        if(currentGame.passableNonUpdatables[i].occupiesTiles[j].x == x && currentGame.passableNonUpdatables[i].occupiesTiles[j].y == y) {
                            return false;
                        }
                    }
                }
            }

            // new, complete passables 
            for(var passdef in currentGame.finishedPassableNonUpdatables) {
                var td = currentGame.finishedPassableNonUpdatables[passdef];

                if(td[x]) {
                    var tx = td[x];

                    for(var ty = 0; ty < tx.length; ty++) {
                        if(parseInt(tx[ty]) == y) {
                            return false;
                        }
                    }
                }


            }
        }

        if(checkRef[x] == null || checkRef[x][y] >= 15 || (decorationsBlock && checkRef[x][y] == 1)) {
            return false;
        }

        return passable;
    }

    function createCollisionReference() {
        collisionReference = [];
        flyingCollisionReference = [];

        for(var x = 0; x <= currentGame.width; x++) {
            collisionReference[x] = new Array(currentGame.height);
            flyingCollisionReference[x] = new Array(currentGame.height);
        }

        resetCollisionReference();
    }

    function resetCollisionReference() {
        for(var x = 0; x <= currentGame.width; x++) {
            for(var y = 0; y <= currentGame.height; y++) {
                collisionReference[x][y] = 5;
                flyingCollisionReference[x][y] = 5;
            }
        }
    }

    function modifyCollisionWeight(x,y,weight,flightOk) {

        if(!buildingUpdateCycle) {
            return;
        }

        if(collisionReference == null || collisionReference[x] == null) {
            return;
        }

        collisionReference[x][y] += weight;

        if(!flightOk) {
            flyingCollisionReference[x][y] += weight;
        }

        if(collisionReference[x][y] < 1) {
            collisionReference[x][y] = 1;   
        }

        /*
        if(collisionReference[x][y] >= 15) {
            collisionReference[x][y] = 0;
        }
        */

        if(flyingCollisionReference[x][y] < 1) {
            flyingCollisionReference[x][y] = 1;   
        }

        /*
        if(flyingCollisionReference[x][y] >= 15) {
            flyingCollisionReference[x][y] = 0;
        }
        */
    }
    
    function updateCollisionMap() {

        pathWorker1.postMessage({
            "method": "updateCollisionMap",
            "data": collisionReference
        });

        shouldUpdateCollissionMap = false;

    }

    var gamepadSelectionButton = 0;
    var cameFromGamepad = false;

    function resetObjectOptions() {

        gamepadSelectionButton = 0;

        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        for(var i = 0; i < buttons.length; i++) {
            buttons[i].isGamepadSelectionButton = false;
            buttons[i].style.backgroundColor = null;
        }
    }

    function highlightSelectedObjectButton() {
        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        for(var i = 0; i < buttons.length; i++) {
            if(i == gamepadSelectionButton) {
                buttons[i].isGamepadSelectionButton = true;
                buttons[i].style.backgroundColor = "rgba(255,255,255,.5)";
                document.getElementById("objectGamepadHint").innerHTML = buttons[i].title;
                document.getElementById("objectGamepadHint").style.display = "block";
            } else {
                buttons[i].isGamepadSelectionButton = false;
                buttons[i].style.backgroundColor = null;
            }
            
        }
    }

    function executeSelectedGamepadButton() {
        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        buttons[gamepadSelectionButton].click();
    }

    function updateCostRemainingArea() {

        if(selectedBuilding == null) {
            return;
        }

        if(document.getElementById("objectOptions").style.display == "none") {
            return;
        }

        document.getElementById("costRemainingArea").innerHTML = "";

        if(!selectedBuilding.isUnderConstruction) {
            return;
        }

        if(selectedBuilding.c == null) {
            return;
        }

        for(var prop in selectedBuilding.c.pr) {
            

            if(selectedBuilding.c.pr[prop] > 0) {
                var cItem = document.createElement("div");

                var cImg = document.createElement("img");
                cImg.src = "images/" + getResourceByDefName(prop).icon;
                cItem.appendChild(cImg);

                var cSpan = document.createElement("span");
                cSpan.innerHTML = selectedBuilding.c.pr[prop];
                cItem.appendChild(cSpan);

                document.getElementById("costRemainingArea").appendChild(cItem);
            }

            
        }

    }

    function showHoverPopup(text,customX,customY,title,color) {

        var x = actualX;

        if(customX) {
            x = customX;
        }

        var y = actualY;

        if(customY) {
            y = customY;
        }

        if(!text || text.trim().length == 0) {
            document.getElementById("popupTooltip").style.display = "none";
            return;
        }

        if(!cameFromGamepad && usingMouse) {

            document.getElementById("popupTooltip").style.display = "block";

            var rightOffset = 0;

            if(desktopMode) {
                rightOffset = 220;
            }

            if(x > (window.innerWidth - rightOffset) / 2) {
                document.getElementById("popupTooltip").style.right = (((window.innerWidth - rightOffset) - x) + 16) + "px";
                document.getElementById("popupTooltip").style.left =  "initial";
            } else {
                document.getElementById("popupTooltip").style.left = (x + 16) + "px";
                document.getElementById("popupTooltip").style.right =  "initial";
            }

            if(y > window.innerHeight / 2) {
                document.getElementById("popupTooltip").style.bottom = ((window.innerHeight - y) + 16) + "px";
                document.getElementById("popupTooltip").style.top = "initial";
            } else {
                document.getElementById("popupTooltip").style.top = (y + 16) + "px";
                document.getElementById("popupTooltip").style.bottom = "initial";
            }

            document.getElementById("popupTooltip").innerHTML = "";

            if(title) {
                document.getElementById("popupTooltip").innerHTML += "<strong>" + title + "</strong><br />";
            }

            document.getElementById("popupTooltip").innerHTML += text;

            if(color) {
                document.getElementById("popupTooltip").style.color = color;
            } else {
                document.getElementById("popupTooltip").style.color = "#ffffff";
            }
        }
    }
    
    function showOptionsForObject(object,type,isRCReshow) {

        if(object == null || currentGame == null) {
            return;
        }

        if(currentGame.readOnlyMode) {
            return;
        }

        var tipsToShow = [];

        if(type == "colonist") {
            if(object.name == null || object.name == "NaN") {
                setColonistName(object);
            }
        }

        if(type == "building") {
            handleBuildingWorkerCleanup(object);
        }        


        var isMultiSelection = false;

        if(object == selectedVehicle) {
            if(selectedVehicle.length > 1) {
                isMultiSelection = true;
            }
            object = selectedVehicle[0];
        }

        var rightOffset = 0;

        if(desktopMode) {
            rightOffset = 220;
        }

        if(!cameFromGamepad && selectedVehicle.length <= 1 && usingMouse && (window.innerWidth - rightOffset) >= 640 && type == "building") {

            if(actualX > (window.innerWidth - rightOffset) / 2) {
                document.getElementById("objectOptions").style.right = (((window.innerWidth - rightOffset) - actualX) + 32) + "px";
                document.getElementById("objectOptions").style.left =  "initial";
            } else {
                document.getElementById("objectOptions").style.left = (actualX + 32) + "px";
                document.getElementById("objectOptions").style.right =  "initial";
            }

            if(actualY > window.innerHeight / 2) {
                document.getElementById("objectOptions").style.bottom = ((window.innerHeight - actualY) + 32) + "px";
                document.getElementById("objectOptions").style.top = "initial";
            } else {
                document.getElementById("objectOptions").style.top = (actualY + 32) + "px";
                document.getElementById("objectOptions").style.bottom = "initial";
            }
        } else {
            document.getElementById("objectOptions").style.top = "initial";
            document.getElementById("objectOptions").style.right =  "initial";
            document.getElementById("objectOptions").style.bottom = "12px";
            document.getElementById("objectOptions").style.left = "12px";
        }

        document.getElementById("objectDismissIcon").title = getString("general-dismiss");
        appendShortcutTitleToButton(document.getElementById("objectDismissIcon"),"KEY_CLEAR",KEY_DEFAULT_CLEAR);
        document.getElementById("objectDismissIcon").style.display = "inline-block";

        tipsToShow.push({
            icon: "images/" + ColonyGame.meta.indDismiss,
            tip: "object-options-dismiss-tip"
        });

        if(isMultiSelection) {
            document.getElementById("objectName").innerHTML = getString("general-multiple") + " (x" + selectedVehicle.length + ")";
        } else {
            document.getElementById("objectName").innerHTML = object.name;
        }
        objectGamepadHint
        //document.getElementById("objectType").innerHTML = "";
        document.getElementById("costRemainingArea").innerHTML = "";
        document.getElementById("objectExtra").innerHTML = "";
        //document.getElementById("objectConsumption").innerHTML = "";
        document.getElementById("objectCondition").innerHTML = "";
        document.getElementById("objectGamepadHint").style.display = "none";
        document.getElementById("objectExtra").style.color = null;
        document.getElementById("objectHire").style.display = "none";
        document.getElementById("objectImportIcon").style.display = "none";
        document.getElementById("objectExportIcon").style.display = "none";
        document.getElementById("objectUpgradeIcon").style.display = "none";
        document.getElementById("objectParkIcon").style.display = "none";
        document.getElementById("objectStatsIcon").style.display = "none";
        document.getElementById("objectPolicyIcon").style.display = "none";
        document.getElementById("objectDiplomacyIcon").style.display = "none";
        document.getElementById("objectCommunicationsIcon").style.display = "none";
        
        document.getElementById("objectDestructIcon").style.display = "none";
        document.getElementById("objectExecute").style.display = "none";
        document.getElementById("objectConscript").style.display = "none";
        document.getElementById("objectDestroyIcon").style.display = "none";
        document.getElementById("objectHarvestIcon").style.display = "none";
        document.getElementById("objectActivationIcon").style.display = "none";
        //document.getElementById("objectUpgradeAll").style.display = "none";
        //document.getElementById("objectActivationAll").style.display = "none";
        document.getElementById("objectRename").style.display = "none";
        document.getElementById("objectFlipIcon").style.display = "none";
        document.getElementById("objectSetText").style.display = "none";
        document.getElementById("objectRepairIcon").style.display = "none";
        document.getElementById("objectCommonwealthIcon").style.display = "none";
        document.getElementById("objectMakeCenterIcon").style.display = "none";
        document.getElementById("objectDeployLoadedIcon").style.display = "none";

        document.getElementById("objectTradeIcon").style.display = "none";
        
        document.getElementById("objectDeployIcon").style.display = "none";

        var soundToPlay = null;

        soundToPlay = ColonyGame.sounds.defaultSelectSound;

        document.getElementById("objectOptions").style.display = "block";

        webAppCore.handleBackFunction(clearOutBuildMenu);
        
        if(type == "vehicle" || type == "building") {
            if(object.owner != 0) {
                return;
            }
        }

        if(!gamepadInUse) {
            if(type == "passable" || type == "building" || type == "vehicle" || type == "colonist") {
                document.getElementById("objectStatsIcon").style.display = "inline-block";
                document.getElementById("objectStatsIcon").onclick = function() {
                    closeObjectOptionsAndClear();
                    //showColonistStats(object);

                    showNewObjectOptionsMenu(object,type,object.x,object.y);
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indStats,
                    tip: "object-options-stats-tip"
                });
            }
        }
        
        if(type == "building" || object.c != null || (type == "passable" && object.isUnderConstruction)) {

            var muhDef = getBuildingDefByName(object.def);

            if(!object.isUnderConstruction) {

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indActivateBld,
                    tip: "object-options-activation-tip"
                });

                document.getElementById("objectActivationIcon").style.display = "inline-block";
                if(object.deactivated) {
                    document.getElementById("objectActivationIcon").src = "images/" + ColonyGame.meta.indActivateBld;
                    document.getElementById("objectActivationIcon").title = getString("general-activate");
                } else {
                    document.getElementById("objectActivationIcon").src = "images/" + ColonyGame.meta.indDeactivateBld;
                    document.getElementById("objectActivationIcon").title = getString("general-deactivate");



                    if(muhDef.packsTo != null) {
                        

                        var packsToDef = getVehicleDefByName(muhDef.packsTo);

                        if(packsToDef != null) {
                            document.getElementById("objectDeployIcon").style.display = "inline-block";

                            document.getElementById("objectDeployIcon").src = "images/" + packsToDef.indicator;
                            document.getElementById("objectDeployIcon").title = "Pack to " +  packsToDef.name;

                            document.getElementById("objectDeployIcon").onclick = function() {
                                document.getElementById("objectOptions").style.display = "none";
                                packBuilding(object);
                            };
                        }
                    }



                }

                document.getElementById("objectActivationIcon").onclick = function() {
                    document.getElementById("objectOptions").style.display = "none";
                    object.deactivated = !object.deactivated;
                    updateUtilityGrid();
                };
            }



            document.getElementById("objectHarvestIcon").style.display = "none";
            document.getElementById("objectMoveIcon").style.display = "none";
            document.getElementById("objectParkIcon").style.display = "none";

            var alsoHasWorkers = false;
            

            if(object.acceptsWorkers > 0) {

                alsoHasWorkers = true;

                if(!object.workers) {
                    object.workers = [];
                }

                var working = 0;

                for(var i = 0; i < object.workers.length; i++) {
                    if(object.workers[i].isAtWork) {
                        working++;
                    }
                }

                var occ = "Unskilled";
                var occupationDef = getOccupationDefByName(muhDef.occupation);
                var occImage = "images/" + ColonyGame.meta.colonistIcon;

                if(occupationDef != null) {

                    occ = occupationDef.name;

                    if(occupationDef.indicator != null) {
                        occImage = "images/" + occupationDef.indicator;
                    }
                }

                addObjectReadoutBar(document.getElementById("objectExtra"),occImage,object.workers.length,working,"#0D47A1","#1E88E5","#D32F2F",object.acceptsWorkers,"工人 (" + occ + ")");

                document.getElementById("objectExtra").style.display = "block";

            }

            

            if(muhDef.isCommsHubBldg && !currentGame.offlineMode) {
                document.getElementById("objectCommunicationsIcon").style.display = "inline-block";
                document.getElementById("objectCommunicationsIcon").onclick = function() {
                    closeObjectOptionsAndClear();
                    showCommunicationsMenu();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.mailIndicator,
                    tip: "object-options-comms-tip"
                });
            }

            if(!object.isUnderConstruction) {
                document.getElementById("objectMakeCenterIcon").style.display = "inline-block";
                document.getElementById("objectMakeCenterIcon").onclick = function() {
                    currentGame.centerBuildingId = object.id;
                    setCenterMapIcon();
                    centerMap();
                    webAppCore.showToast("Center Set");
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indMakeCenter,
                    tip: "object-options-mkcenter-tip"
                });
            }

            if(muhDef.isSign) {

                if(object.customText && object.customText != null && object.customText.trim().length > 0) {
                    if(allowAudio) {
                        webAppCore.say(object.customText);
                    }
                }

                document.getElementById("objectSetText").style.display = "block";
                document.getElementById("objectSetText").onclick = function() {
                    closeObjectOptionsAndClear();

                    setBuildingText(object);
                };
            }

            if(muhDef.canFlip) {
                document.getElementById("objectFlipIcon").style.display = "inline-block";
                document.getElementById("objectFlipIcon").onclick = function() {
                    closeObjectOptionsAndClear();

                    if(webAppCore.getIsPremium()) {
                        flipBuilding(object);
                    } else {
                        showPremiumMessage();
                    }
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indFlipBuilding,
                    tip: "object-options-flip-tip"
                });
            }

            if(muhDef.selectionSound != null) {
                if(muhDef.selectionSound instanceof Array) {
                    soundToPlay = muhDef.selectionSound[randomIntFromInterval(0,muhDef.selectionSound.length - 1)];
                } else {
                    soundToPlay = muhDef.selectionSound;
                }
            }

            
            if(muhDef.isCapitol || muhDef.isConsulate || muhDef.isEmbassy) {
                if(muhDef.isCapitol || muhDef.isConsulate) {
                    if(!currentGame.offlineMode) {
                        document.getElementById("objectCommonwealthIcon").style.display = "inline-block";

                        tipsToShow.push({
                            icon: "images/" + ColonyGame.meta.empireIndicator,
                            tip: "object-options-empire-tip"
                        });
                    }
                    document.getElementById("objectPolicyIcon").style.display = "inline-block";

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indPolicy,
                        tip: "object-options-policy-tip"
                    });
                }

                if((muhDef.isCapitol || muhDef.isEmbassy) && !currentGame.offlineMode) {
                    document.getElementById("objectDiplomacyIcon").style.display = "inline-block";

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.diplomacyIndicator,
                        tip: "object-options-diplomacy-tip"
                    });

                    if(muhDef.isCapitol) {
                        document.getElementById("objectDiplomacyIcon").onclick = function() {
                            closeObjectOptionsAndClear();
                            showDiplomacyMenu();
                        };
                    } else {
                        document.getElementById("objectDiplomacyIcon").onclick = function() {
                            closeObjectOptionsAndClear();
                            contactEmbassyFor(object.embassyFor);
                        };
                    }
                }
            }

            if(muhDef.heals > 0) {

                medicalCoverageMode = true;


                


                if(alsoHasWorkers) {
                    //document.getElementById("objectExtra").innerHTML += "<br />";
                } else {

                    alsoHasWorkers = true;
                }

                if(object.patients) {

                    addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.medicalIcon,object.patients.length,null,"#7B1FA2",null,"#4A148C",muhDef.heals,"Patients");

                }

            }

            var patronsCleaned = false;

            if(muhDef.entertains > 0) {

                if(!muhDef.heals) {
                    entertainmentCoverageMode = true;
                }

                if(alsoHasWorkers) {
                    //document.getElementById("objectExtra").innerHTML += "<br />";
                } else {

                    alsoHasWorkers = true;

                }

                if(object.patrons) {

                    cleanPatronsForObject(object);
                    patronsCleaned = true;


                    addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.indRetired,object.patrons.length,null,"#0097A7",null,"#006064",muhDef.entertains,"Guests");

                }

            }


            if(muhDef.takesTourists > 0) {
                if(alsoHasWorkers) {

                } else {

                    alsoHasWorkers = true;

                }

                if(object.tourists) {

                    if(!patronsCleaned) {
                        cleanPatronsForObject(object);
                    }

                    addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.touristIcon,object.tourists.length,null,"#303F9F",null,"#1A237E",muhDef.takesTourists,"Tourists");

                }

            }

            if(muhDef.providesShelter > 0) {
                addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.colonistIcon,object.residents.length,null,"#388E3C",null,"#1B5E20",muhDef.providesShelter,"Residents");
            }

            if(object.deactivated) {
            }

            var j;

            if(object.isUnderConstruction) {
                if(cancelIsDown) {
                    document.getElementById("objectOptions").style.display = "none";
                    object.isBeingRemoved = true;
                } else {
                    document.getElementById("objectCancel").style.display = "block";
                    document.getElementById("objectCancel").onclick = function() {
                        closeObjectOptionsAndClear();

                        if(type == "building") {
                            object.isBeingRemoved = true;
                        }

                        if(type == "passable") {
                            object.isBeingRemoved = true;
                        }
                    };

                    document.getElementById("objectCancel").innerHTML = getString("general-cancel");
                    appendShortcutToButton(document.getElementById("objectCancel"),"KEY_CANCEL",KEY_DEFAULT_CANCEL);
                }
            } else {
                document.getElementById("objectCancel").style.display = "none";
            }

        } else {
            if(type == "vehicle") {
                document.getElementById("objectCancel").style.display = "none";

                document.getElementById("objectMoveIcon").style.display = "inline-block";
                document.getElementById("objectMoveIcon").onclick = function() {
                    queueSelectedVehicleForMove();
                    document.getElementById("objectOptions").style.display = "none";
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indMove,
                    tip: "object-options-move-tip"
                });

                document.getElementById("objectMoveIcon").title = getString("general-move");
                appendShortcutTitleToButton(document.getElementById("objectMoveIcon"),"KEY_MOVE",KEY_DEFAULT_MOVE);

                var vDef = getVehicleDefByName(object.def);

                if(object.lv.length > 0) {
                    document.getElementById("objectDeployLoadedIcon").style.display = "inline-block";

                    document.getElementById("objectDeployLoadedIcon").onclick = function() {
                        document.getElementById("objectOptions").style.display = "none";

                        deployLoadedUnits(object);

                    };
                }

                if(vDef.deploysTo != null) {



                    var deploysToDef = getBuildingDefByName(vDef.deploysTo);

                    object.pd = deploysToDef;

                    document.getElementById("objectDeployIcon").style.display = "inline-block";
                    
                    document.getElementById("objectDeployIcon").src = gameAssets[deploysToDef.tile][0].image.src;
                    document.getElementById("objectDeployIcon").title = "Deploy " +  deploysToDef.name;

                    document.getElementById("objectDeployIcon").onclick = function() {
                        document.getElementById("objectOptions").style.display = "none";

                        deployBuilding(object);

                    };
                }
                
                if(vDef == null || vDef.harvests == null) {
                    document.getElementById("objectHarvestIcon").style.display = "none";
                } else {
                    document.getElementById("objectHarvestIcon").style.display = "inline-block";
                    document.getElementById("objectHarvestIcon").onclick = function() {
                        for(var i = 0; i < selectedVehicle.length; i++) {

                            selectedVehicle[i].blacklist = [];
                            selectedVehicle[i].bBlacklist = [];

                            selectedVehicle[i].iH = true;
                            selectedVehicle[i].harvestAfterBuilding = false;
                            selectedVehicle[i].inBuildingMode = false;
                        }
                        closeObjectOptionsAndClear();
                        selectedVehicle = [];
                        drawSidebar();
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indHarvest,
                        tip: "object-options-harvest-tip"
                    });

                    document.getElementById("objectHarvestIcon").title = getString("general-harvest");
                    appendShortcutTitleToButton(document.getElementById("objectHarvestIcon"),"KEY_HARVEST",KEY_DEFAULT_HARVEST);

                }

                document.getElementById("objectParkIcon").title = getString("general-park-unit");
                appendShortcutTitleToButton(document.getElementById("objectParkIcon"),"KEY_PARK",KEY_DEFAULT_PARK);

                document.getElementById("objectParkIcon").style.display = "inline-block";
                document.getElementById("objectParkIcon").onclick = function() {

                    queuedPark = object;
   
                    document.getElementById("objectOptions").style.display = "none";
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indPark,
                    tip: "object-options-park-tip"
                });
            }
            
            if(type == "resource") {
                document.getElementById("objectCancel").style.display = "none";
                document.getElementById("objectParkIcon").style.display = "none";
                document.getElementById("objectMoveIcon").style.display = "none";
                document.getElementById("objectExtra").innerHTML = object.inventory;

                if(object.ul) {
                    document.getElementById("objectExtra").innerHTML = "Infinite";
                }

                document.getElementById("objectExtra").style.color = null;
                document.getElementById("objectExtra").style.display = "block";
            }

            if(type == "passable") {
                document.getElementById("objectHarvestIcon").style.display = "none";

                if(!object.isUnderConstruction) {
                    document.getElementById("objectCancel").style.display = "none";
                }

                document.getElementById("objectParkIcon").style.display = "none";
                document.getElementById("objectMoveIcon").style.display = "none";
                document.getElementById("objectExtra").style.display = "none";
            }

            

            if(type == "colonist") {

                document.getElementById("objectRename").style.display = "block";
                document.getElementById("objectRename").onclick = function() {
                    document.getElementById("objectOptions").style.display = "none";
                    selectedColonist = null;
                    renameColonist(object);
                };



                document.getElementById("objectHarvestIcon").style.display = "none";
                document.getElementById("objectMoveIcon").style.display = "inline-block";
                document.getElementById("objectCancel").style.display = "none";

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indMove,
                    tip: "object-options-move-tip"
                });

                document.getElementById("objectMoveIcon").title = getString("general-move");
                appendShortcutTitleToButton(document.getElementById("objectMoveIcon"),"KEY_MOVE",KEY_DEFAULT_MOVE);

                document.getElementById("objectExecute").style.display = "block";
                document.getElementById("objectExecute").onclick = function() {
                    closeObjectOptionsAndClear();
                    selectedColonist = null;
                    executeColonist(object);
                    
                    
                };

                // transform a colonist into a vehicle
                if(ColonyGame.meta.allowConscription) {
                    document.getElementById("objectConscript").style.display = "block";
                    document.getElementById("objectConscript").onclick = function() {
                        closeObjectOptionsAndClear();
                        selectedColonist = null;
                        enslaveColonist(object);
                    };
                }

                

                document.getElementById("objectMoveIcon").onclick = function() {
                    queuedMove = object;
                    //object.iH = false;
                    setColonistMask(object,"IS_WANDERING",false);
                    setAwaitingPath(object,"colonist",false);

                    document.getElementById("objectOptions").style.display = "none";
                };

                document.getElementById("objectHire").style.display = "block";
                document.getElementById("objectHire").onclick = function() {
                    selectedColonist = object;
                    inHireMode = true;
                    closeObjectOptionsAndClear();
                    document.getElementById("hireWorkerConfirm").style.display = "block";
                };

                if(object.job > 0) {
                    document.getElementById("objectHire").innerHTML = getString("hire-button-change-job");

                } else {
                    document.getElementById("objectHire").innerHTML = getString("hire-button-hire");
                }

                if(getColonistMask(object,"IS_WANDERING") || object.x != object.dX || object.y != object.dY) {
                    document.getElementById("objectParkIcon").style.display = "none";
                }
            }

            if(type == "colonist" || type == "vehicle") {
                document.getElementById("objectExtra").style.color = null;
                document.getElementById("objectExtra").style.display = "block";
                document.getElementById("objectExtra").innerHTML = "Idle";

                if(object.x != object.dX || object.y != object.dY) {
                    document.getElementById("objectExtra").innerHTML = "Moving";
                }

                if(type == "vehicle" && object.iH) {
                    document.getElementById("objectExtra").innerHTML = "Harvesting";
                }

                if(object.inBuildingMode) {
                    document.getElementById("objectExtra").innerHTML = "Building";
                }

                if(type == "colonist" && getColonistMask(object,"IS_WANDERING")) {
                    document.getElementById("objectExtra").innerHTML = "Wandering";
                }

                if(type == "colonist" && getColonistMask(object,"AT_WORK")) {
                    document.getElementById("objectExtra").innerHTML = "Working";
                }

                if(type == "colonist" && getColonistMask(object,"AT_HOME")) {
                    document.getElementById("objectExtra").innerHTML = "Sleeping";
                }

                if(type == "colonist" && getColonistMask(object,"IS_PROTESTING")) {
                    document.getElementById("objectExtra").innerHTML = "Protesting";
                }
            }

            
        }

        var canBuildStuff = false;

        if(type == "building") {
            if(getBuildingDefByName(object.def).produces!= null && getBuildingDefByName(object.def).produces.length > 0 && !object.isUnderConstruction) {
                canBuildStuff = true;
            }

            if(!object.isUnderConstruction && object.condition < 100) {

                document.getElementById("objectCondition").style.display = "block";
                document.getElementById("objectCondition").innerHTML = "Condition: " + object.condition + "%";
                document.getElementById("objectCondition").style.color = "#ffffff";

                if(object.condition < 100) {

                    document.getElementById("objectRepairIcon").style.display = "inline-block";
                    document.getElementById("objectRepairIcon").onclick = function() {
                        showRepairBuilding(object,true);
                        closeObjectOptionsAndClear();
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indRepair,
                        tip: "object-options-repair-tip"
                    });

                    if(object.condition < 10) {
                        document.getElementById("objectCondition").style.color = "#F44336";
                    }
                }
            } else {
                document.getElementById("objectCondition").style.display = "none";
            }
        }

        if(type == "resource") {

            if(!getTerrainDefByName(object.def).indestructable) {
                document.getElementById("objectDestroyIcon").style.display = "inline-block";
                document.getElementById("objectDestroyIcon").onclick = function() {
                    destroyResource(object);
                    closeObjectOptionsAndClear();
                };
    
                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indDestroy,
                    tip: "object-options-destroy-tip"
                });
            }

            
        }

        if(type == "vehicle") {
            
            var vd = getVehicleDefByName(object.def);

            if(vd != null && vd.selectionSound != null) {
                if(vd.selectionSound instanceof Array) {
                    soundToPlay = vd.selectionSound[randomIntFromInterval(0,vd.selectionSound.length - 1)];
                } else {
                    soundToPlay = vd.selectionSound;
                }
            }
            
            if(vd != null && vd.produces != null && vd.produces.length > 0) {
                canBuildStuff = true;
            }

            document.getElementById("objectDestructIcon").style.display = "inline-block";
            document.getElementById("objectDestructIcon").onclick = function() {
                destroyVehicle(selectedVehicle);
                closeObjectOptionsAndClear();
            };

            tipsToShow.push({
                icon: "images/" + ColonyGame.meta.indDestroy,
                tip: "object-options-destroy-tip"
            });
        }
        
        if(canBuildStuff && !object.isUnderConstruction) {
            document.getElementById("objectBuildIcon").style.display = "inline-block";
            document.getElementById("objectBuildIcon").onclick = function() {
                showBuildingConstructionOptions(object,type);
                closeObjectOptionsAndClear();
            };

            tipsToShow.push({
                icon: "images/" + ColonyGame.meta.showBuildSidebarIcon,
                tip: "object-options-build-tip"
            });

            document.getElementById("objectBuildIcon").title = getString("general-build");
            appendShortcutTitleToButton(document.getElementById("objectBuildIcon"),"KEY_BUILD",KEY_DEFAULT_BUILD);
        } else {
            document.getElementById("objectBuildIcon").style.display = "none";
        }

        if((type == "building" || type == "passable") && !object.isUnderConstruction) {

            if(altsdown) {
                document.getElementById("objectOptions").style.display = "none";
                objectForSell = object;
                objectForSellType = type;
                doSale();
            } else {
                document.getElementById("objectSelIcon").style.display = "inline-block";
                document.getElementById("objectSelIcon").onclick = function() {
                    showSellForObject(object,type);
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indSell,
                    tip: "object-options-sell-tip"
                });

                if(getBuildingDefByName(object.def).sellValue == null) {
                    document.getElementById("objectSelIcon").title = getString("object-remove");
                    document.getElementById("objectSelIcon").src = "images/" + ColonyGame.meta.bulldozerToolIndicator;
                } else {
                    document.getElementById("objectSelIcon").title = getString("object-sell");
                    document.getElementById("objectSelIcon").src = "images/" + ColonyGame.meta.indSell;
                }

                appendShortcutTitleToButton(document.getElementById("objectSelIcon"),"KEY_SELL",KEY_DEFAULT_SELL);
            }

            var upgradeOption = isUpgradeAvailableForStructure(object);
            if(upgradeOption != null) {

                if(altudown) {
                    conductUpgrade(object,upgradeOption,type);
                } else {
                    document.getElementById("objectUpgradeIcon").style.display = "inline-block";
                    document.getElementById("objectUpgradeIcon").onclick = function() {
                        document.getElementById("objectOptions").style.display = "none";
                        conductUpgrade(object,upgradeOption,type);
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indUpgrade,
                        tip: "object-options-upgrade-tip"
                    });
                    
                    document.getElementById("objectUpgradeIcon").title = getString("general-upgrade");
                    appendShortcutTitleToButton(document.getElementById("objectUpgradeIcon"),"KEY_UPGRADE",KEY_DEFAULT_UPGRADE);
                }
            }
        } else {
            document.getElementById("objectSelIcon").style.display = "none";
        }

        if(type == "building" && !object.isUnderConstruction && !object.deactivated) {
            if(getBuildingDefByName(object.def).canImport != null && !currentGame.tradeEmbargo) {
                document.getElementById("objectImportIcon").style.display = "inline-block";
                document.getElementById("objectImportIcon").onclick = function() {
                    showImportMenu(object);
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indImportGoods,
                    tip: "object-options-import-tip"
                });

                document.getElementById("objectImportIcon").title = getString("general-import");
                appendShortcutTitleToButton(document.getElementById("objectImportIcon"),"KEY_IMPORT",KEY_DEFAULT_IMPORT);
            }

            if(getBuildingDefByName(object.def).canExport != null && !currentGame.tradeEmbargo) {
                document.getElementById("objectExportIcon").style.display = "inline-block";
                document.getElementById("objectExportIcon").onclick = function() {
                    showExportMenu(object);
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indExportGoods,
                    tip: "object-options-export-tip"
                });

                document.getElementById("objectExportIcon").title = getString("general-export");
                appendShortcutTitleToButton(document.getElementById("objectExportIcon"),"KEY_EXPORT",KEY_DEFAULT_EXPORT);
            }

            if(!currentGame.offlineMode) {
                if(getBuildingDefByName(object.def).onlineTradeDepot) {

                    document.getElementById("objectTradeIcon").style.display = "inline-block";
                    document.getElementById("objectTradeIcon").onclick = function() {
                        selectedBuilding = object;
                        closeObjectOptionsAndClear();

                        if(object.lowPowerMode) {
                            webAppCore.showToast("Low Power");
                            return;
                        }

                        showNewTradeMenu(object.name);
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indTrade,
                        tip: "object-options-trade-tip"
                    });
                }
            }
        }

        if(allowAudio && soundToPlay != null && !isRCReshow) {
            webAppCore.playSoundEffect(soundToPlay);
        }

        resetObjectOptions();

        if(cameFromGamepad) {
            highlightSelectedObjectButton();
        }

        showTipsPopup(tipsToShow);
    }

    var tipsWindowOpen = false;

    function closeTipsPopup() {
        document.getElementById("helpfulTipsMenu").style.display = "none";
        tipsWindowOpen = false;
    }

    function showTipsPopup(tipsToShow) {
        var finalTipsToShow = [];
        var i;

        for(i = 0; i < tipsToShow.length; i++) {
            if(webAppCore.getVar(tipsToShow[i].tip,"0") == "1") {
                continue;
            }

            webAppCore.storeVar(tipsToShow[i].tip,"1");
            finalTipsToShow.push(tipsToShow[i]);
        }

        if(finalTipsToShow.length == 0) {
            return;
        }

        tipsWindowOpen = true;

        document.getElementById("helpfulTipsListing").innerHTML = "";

        for(i = 0; i < finalTipsToShow.length; i++) {
            var tipItem = document.createElement("div");
            tipItem.className = "helpfulTipItem";

            var tipIcon = document.createElement("img");
            tipIcon.className = "helpfulTipIcon";
            tipIcon.src = finalTipsToShow[i].icon;
            tipItem.appendChild(tipIcon);

            var tipText = document.createElement("p");
            tipText.className = "helpfulTipText";
            tipText.innerHTML = getString(finalTipsToShow[i].tip);
            tipItem.appendChild(tipText);

            document.getElementById("helpfulTipsListing").appendChild(tipItem);
        }

        if(gamepadInUse) {
            document.getElementById("helpfulTipsDismissGamepad").style.display = "block";
            document.getElementById("helpfulTipsDismiss").style.display = "none";
        } else {
            document.getElementById("helpfulTipsDismiss").style.display = "block";
            document.getElementById("helpfulTipsDismissGamepad").style.display = "none";
        }

        document.getElementById("helpfulTipsMenu").style.display = "block";
    }
    
    function getDriveSpeedMod(x,y) {
        
        // new passables 
        for(var passdef in currentGame.finishedPassableNonUpdatables) {
            var td = currentGame.finishedPassableNonUpdatables[passdef];
            
            if(td[x]) {
                
                var tx = td[x];
                
                for(var ty = 0; ty < tx.length; ty++) {
                    var passY = tx[ty];
                    
                    if(passY == y) {
                        return passableTileRefs[passdef].driveSpeedMod;
                    }

                }
            }

        }

        for(var i = 0; i < currentGame.passableNonUpdatables.length; i++) {
            if(currentGame.passableNonUpdatables[i].x == x &&  currentGame.passableNonUpdatables[i].y == y) {
                if(currentGame.passableNonUpdatables[i].isUnderConstruction || getBuildingDefByName(currentGame.passableNonUpdatables[i].def).driveSpeedMod == null) {
                    return 0;
                }  else {
                    return getBuildingDefByName(currentGame.passableNonUpdatables[i].def).driveSpeedMod;
                }
            }
        }
        
        return 0;
    }

    function getBuildingMarketValue(building,useCost) {
        var buildingMarketValue = 0;
        var priceModifier = 1;

        var def = getBuildingDefByName(building.def);

        var arrayToUse = def.sellValue;

        if(useCost || arrayToUse == null) {
            arrayToUse = def.cost;

            if(!useCost) {
                priceModifier = .35;
            }
        } 

        if(arrayToUse == null || arrayToUse.length == 0) {
            return 0;
        }

        for(var i = 0; i < arrayToUse.length; i++) {
            var resource = arrayToUse[i].resource;
            var amount = arrayToUse[i].amount;

            var currentUnitPrice = Math.round(currentGame.resources[resource].price / 100);
            var resourceValue = amount * currentUnitPrice;

            buildingMarketValue += resourceValue;
        }

        buildingMarketValue *= priceModifier;

        if(!useCost) {
            if(building.condition < 100) {
                var conditionPercent = building.condition / 100;
                buildingMarketValue *= conditionPercent;
            }
        }

        return buildingMarketValue;
    }

    function getBuildingRepairCost(building) {

        if(building.condition == 100) {
            return 0;
        }

        var buildingValue = getBuildingMarketValue(building,true);
        var totalUpkeepValue = Math.ceil(buildingValue * 0.75);
        var damagePercent = (100 - building.condition) / 100;

        var repairCost = Math.ceil(totalUpkeepValue * damagePercent);

        return repairCost;
    }

    var pendingRepairJob = null;

    function repairAllBuildings() {
        var totalRepairCosts = 0;
        var i;

        for(i = 0; i < currentGame.buildings.length; i++) {
            totalRepairCosts += getBuildingRepairCost(currentGame.buildings[i]);
        }

        if(totalRepairCosts > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            webAppCore.showToast(getString("general-cant-afford"));
            return;
        }

        for(i = 0; i < currentGame.buildings.length; i++) {
            showRepairBuilding(currentGame.buildings[i],false);
        }
    }

    function showRepairBuilding(building,askFirst) {
        pendingRepairJob = building;

        if(askFirst) {
            var repairCosts = getBuildingRepairCost(building);

            var repairMessage;

            if(repairCosts > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                repairMessage = "This building costs " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(repairCosts) + " to repair.  " + getString("general-cant-afford");
                webAppCore.showToast(repairMessage);
            } else {
                repairMessage = "Repair this building for " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(repairCosts) + "?";

                webAppCore.showDialog({
                    "title":    getString("general-repair"),
                    "message":  repairMessage,
                    "op1": {
                        "text":     getString("general-yes"),
                        "func":     completeBuildingRepair
                    },
                    "op2": {
                        "text":     getString("general-no"),
                        "func":     placeholder
                    }
                });
            }
        } else {
            completeBuildingRepair();
        }
    }

    function completeBuildingRepair() {

        if(pendingRepairJob == null) {
            return;
        }

        var repairCosts = getBuildingRepairCost(pendingRepairJob);
        
        if(repairCosts > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            return;
        }

        modifyResourceAmount(ColonyGame.meta.tenderResource,-repairCosts,false,"Repairs");
        pendingRepairJob.condition = 100;

        pendingRepairJob = null;
    }

    function showSellForObject(object,type) {
        objectForSell = object;
        objectForSellType = type;
        
        var theDef;

        if(type == "building" || type == "passable") {
            theDef = getBuildingDefByName(object.def);
        }

        if(type == "vehicle") {
            theDef = getVehicleDefByName(object.def);
        }

        if(!theDef || theDef == null) {
            return;
        }

        if(theDef.sellValue == null) {
            doSale(theDef);
            return;
        }

        var sellWarning = "Sell " + object.name + " for";

        for(var i = 0; i < theDef.sellValue.length; i++) {
            if(i == 0) {
                sellWarning += " ";
            } else {
                sellWarning += ", ";
            }
            
            sellWarning += getResourceByDefName(theDef.sellValue[i].resource).indicator + theDef.sellValue[i].amount;
        }
        
        sellWarning += "?";
        
        if(theDef.sellWarning != null) {
            sellWarning += "  ";
            sellWarning += getString(theDef.sellWarning);
        }

        webAppCore.showDialog({
            "title":    object.name,
            "message":  sellWarning,
            "op1": {
                "text":     "Sell",
                "func":     doSale
            },
            "op2": {
                "text":     "Keep",
                "func":     placeholder
            }
        });
    }
    
    function placeholder() {
        //whatevs
    }
    
    function doSale() {

        if(objectForSell == null || objectForSellType == null) {
            return;
        }

        var theDef;

        if(objectForSellType == "building" || objectForSellType == "passable") {
            theDef = getBuildingDefByName(objectForSell.def);
        }

        if(objectForSellType == "vehicle") {
            theDef = getVehicleDefByName(objectForSell.def);
        }

        if(!theDef || theDef == null) {
            return;
        }

        var i;
        
        if(theDef.sellValue != null) {
            for(i = 0; i < theDef.sellValue.length; i++) {

                modifyResourceAmount(theDef.sellValue[i].resource,theDef.sellValue[i].amount,false,"Sale");
            }
        }

        if(objectForSellType == "passable") {
            objectForSell.isBeingRemoved = true;
            updateUtilityGrid();
            staticFrame = false;
            Scroll2d.forceSceneChange();
        }
        
        if(objectForSellType == "building") {
            if(objectForSell.workers && objectForSell.workers != null && objectForSell.workers.length > 0) {


                while(objectForSell.workers.length > 0) {
                    if(objectForSell.workers[0].colonistId < 0) {
                        objectForSell.workers.shift();
                    } else {
                        var colonist = getColonistById(objectForSell.workers[0].colonistId);

                        if(colonist == null) {
                            objectForSell.workers.shift();
                        } else {
                            removeWorker(objectForSell,colonist,"f");
                        }
                        
                    }
                }

            }

            if(objectForSell.residents && objectForSell.residents != null && objectForSell.residents.length > 0) {

                while(objectForSell.residents.length > 0) {
                    if(objectForSell.residents[0] < 0) {
                        objectForSell.residents.shift();
                    } else {
                        var homeowner = getColonistById(objectForSell.residents[0]);

                        if(homeowner == null) {
                            objectForSell.residents.shift();
                        } else {
                            removeResident(objectForSell,getColonistById(objectForSell.residents[0]));
                        }
                        
                    }
                }

            }


            objectForSell.isBeingRemoved = true;

            updateUtilityGrid();
            staticFrame = false;
            Scroll2d.forceSceneChange();

            if(theDef.isEmbassy) {
                alertSoldEmbassy(objectForSell.embassyFor);
            }
        }
        
        if(objectForSellType == "vehicle") {
            removeFromArray(currentGame.vehicles,objectForSell);
        }
        
        objectForSell = null;
        objectForSellType = null;
    }
    
    function removeFromArray(arr, item, showarray) {

        if(arr == null || item == null) {
            if(showarray !== undefined) {
                console.log("COULDNT remove from: " + showarray);
            }
            return;
        }

        var wasRemoved = false;

        for(var i = arr.length; i--;) {
            if(arr[i] === item) {
                arr.splice(i, 1);
                wasRemoved = true;
            }
        }

        return wasRemoved;
    }


    function showUnemployedColonists() {
        var unemployed = [];

        if(currentGame == null) {
            return;
        }

        for(var i = 0; i < currentGame.colonists.length; i++) {
            if(currentGame.colonists[i].job == 0) {
                if(currentGame.colonists[i].money < gotItMadePrice) {
                    unemployed.push(currentGame.colonists[i]);
                }
            }
        }

        if(unemployed.length > 0) {
            presentColonistList(unemployed,"Unemployed Colonists");
        } else {
            webAppCore.showToast("No unemployment!");
        }
    }


    function cleanPatronsForObject(object) {
        var i;


        object.patrons = [];
        object.tourists = [];

        for(i = 0; i < currentGame.colonists.length; i++) {
            if(getColonistMask(currentGame.colonists[i],"IS_RELAXING") && currentGame.colonists[i].venue == object.id) {
                object.patrons.push(currentGame.colonists[i].id);
            }
        }

        for(i = 0; i < currentGame.tourists.length; i++) {
            if(getColonistMask(currentGame.tourists[i],"IS_RELAXING") && currentGame.tourists[i].venue == object.id) {
                object.tourists.push(currentGame.tourists[i].id);
            }
        }

    }
    

    function showTouristsForObject(object) {

        var unemployed = [];

        for(var i = 0; i < currentGame.tourists.length; i++) {
            if(object.tourists.indexOf(currentGame.tourists[i].id) > -1) {
                unemployed.push(currentGame.tourists[i]);
            }
        }


        if(unemployed.length > 0) {
            presentColonistList(unemployed,object.name + " Guests");
        }
    }

    function showPatronsForObject(object) {

        var killList = [];
        var i,k;

        for(i = 0; i < object.patrons.length; i++) {
            if(object.patrons[i] < 0) {
                killList.push(object.patrons[i]);
            }
        }

        for(k = 0; k < killList.length; k++) {
            removeFromArray(object.patrons,killList[k]);
        }

        for(k = 0; k < killList.length; k++) {
            unvirtualizeColonist(killList[k],object.x,object.y,null,null,object.id,null);
        }

        killList = [];

        var unemployed = [];

        for(i = 0; i < currentGame.colonists.length; i++) {
            if(object.patrons.indexOf(currentGame.colonists[i].id) > -1) {
                unemployed.push(currentGame.colonists[i]);
            }
        }


        if(unemployed.length > 0) {
            presentColonistList(unemployed,object.name + " Guests");
        }
    }

    function showPatientsForObject(object) {
        var unemployed = [];
        var killList = [];
        var i,k;



        for(i = 0; i < object.patients.length; i++) {
            if(object.patients[i] < 0) {
                killList.push(object.patients[i]);
            }
        }

        for(k = 0; k < killList.length; k++) {
            removeFromArray(object.patients,killList[k]);
        }

        for(k = 0; k < killList.length; k++) {
            unvirtualizeColonist(killList[k],object.x,object.y,null,null,null,object.id);
        }

        killList = [];



        for(i = 0; i < currentGame.colonists.length; i++) {
            if(object.patients.indexOf(currentGame.colonists[i].id) > -1) {
                unemployed.push(currentGame.colonists[i]);
            }
        }

        if(unemployed.length != object.patients.length) {
            for(i = 0; i < object.patients.length; i++) {
                var exists = false;

                for(var j = 0; j < unemployed.length; j++) {
                    if(unemployed[j].id == object.patients[i]) {
                        exists = true;
                        break;
                    }
                }

                if(!exists) {
                    killList.push(object.patients[i]);
                }
            }
        }


        var nukes = 0;

        for(k = 0; k < killList.length; k++) {
            removeFromArray(object.patients,killList[k]);
            nukes++;
        }

        if(nukes > 0) {
            console.log("nuked " + nukes);
        }

        if(unemployed.length > 0) {
            presentColonistList(unemployed,object.name + " Patients");
        }
    }

    function showResidentsForBuilding(building) {
        var unemployed = [];
        var killList = [];
        var i,k;

        // first unvirtualize all residents 
        for(i = 0; i < building.residents.length; i++) {
            if(building.residents[i] < 0) {
                killList.push(building.residents[i]);
            }
        }

        for(k = 0; k < killList.length; k++) {
            removeFromArray(building.residents,killList[k]);
        }

        for(k = 0; k < killList.length; k++) {
            unvirtualizeColonist(killList[k],building.x,building.y,building.id,null,null,null);
        }
        
        killList = [];


        for(i = 0; i < building.residents.length; i++) {

            var colonist = getColonistById(building.residents[i]);


            if(colonist == null) {
                killList.push(building.residents[i]);
            } else {
                unemployed.push(colonist);
            }
        }

        for(k = 0; k < killList.length; k++) {
            removeFromArray(building.residents,killList[k]);
        }

        if(unemployed.length > 0) {
            presentColonistList(unemployed,building.name + " Residents");
        }
    }

    function showWorkersForBuilding(building) {
        var unemployed = [];
        var killList = [];

        var i,k;

        document.getElementById("statObjectWorkersListing").innerHTML = "";


        // first unvirtualize all workers 
        for(i = 0; i < building.workers.length; i++) {

            if(building.workers[i].colonistId < 0) {
                killList.push(building.workers[i]);
            }
        }

        for(k = 0; k < killList.length; k++) {
            removeFromArray(building.workers,killList[k]);
        }

        for(k = 0; k < killList.length; k++) {
            unvirtualizeColonist(killList[k].colonistId,building.x,building.y,null,building.id,null,null,killList[k].isAtWork);
        }



        killList = [];

        for(i = 0; i < building.workers.length; i++) {

            var colonist = getColonistById(building.workers[i].colonistId);


            if(colonist == null) {
                killList.push(building.workers[i]);
            } else {
                unemployed.push(colonist);

                building.workers[i].isAtWork = getColonistMask(colonist,"AT_WORK");

            }
        }

        for(k = 0; k < killList.length; k++) {
            removeFromArray(building.workers,killList[k]);
        }

        var muhDef = getBuildingDefByName(building.def);

        var occ = "Unskilled";
        var occupationDef = getOccupationDefByName(muhDef.occupation);
        var occImage = "images/" + ColonyGame.meta.colonistIcon;

        if(occupationDef != null) {

            occ = occupationDef.name;

            if(occupationDef.indicator != null) {
                occImage = "images/" + occupationDef.indicator;
            }
        }

        for(i = 0; i < unemployed.length; i++) {
            var workerCard = document.createElement("div");
            workerCard.className = "workerCard";


            var workerCardImage = document.createElement("img");
            workerCardImage.className = "workerCardImage";
            workerCardImage.src = occImage;
            workerCard.appendChild(workerCardImage);


            var workerCardName = document.createElement("p");
            workerCardName.className = "workerCardName";
            workerCardName.innerHTML = unemployed[i].name;
            workerCard.appendChild(workerCardName);

            var workerCardStatus = document.createElement("p");
            workerCardStatus.className = "workerCardStatus";

            if(getColonistMask(unemployed[i],"AT_WORK")) {
                workerCardStatus.innerHTML = "On Duty";
                workerCardStatus.style.color = "#1E88E5";
            } else {
                if(getColonistMask(unemployed[i],"IS_PROTESTING")) {
                    workerCardStatus.innerHTML = "Protesting";
                    workerCardStatus.style.color = "#F44336";
                } else {
                    workerCardStatus.innerHTML = "Off Duty";
                    workerCardStatus.style.color = "#0D47A1";
                }
                
            }

            workerCard.appendChild(workerCardStatus);

            var workerCardEnergy = document.createElement("p");
            workerCardEnergy.className = "workerCardEnergy";
            workerCardEnergy.innerHTML = "Energy: " + unemployed[i].energy + "%";

            if(unemployed[i].energy < 20) {
                workerCardEnergy.style.color = "#F44336";
            }

            workerCard.appendChild(workerCardEnergy);

            var axeWorker = document.createElement("button");
            axeWorker.className = "dismiss";
            axeWorker.innerHTML = "Fire";
            axeWorker.workerRef = unemployed[i];
            axeWorker.onclick = function() {
                webAppCore.showToast(this.workerRef.name + " has been walked out the door.");
                removeWorker(building,this.workerRef);
                showWorkersForBuilding(building);
            };
            workerCard.appendChild(axeWorker);

            document.getElementById("statObjectWorkersListing").appendChild(workerCard);
        }

        /*
        if(unemployed.length > 0) {
            presentColonistList(unemployed,building.name + " Employees");
        }
        */

        killList = [];
    }

    function presentGameData() {

        document.getElementById("newGameMenu").style.display = "none";

        var menuOptions = [];

        var dialogTitle = "Game Data";

        menuOptions.push({
            "title":        "Backup Game File",
            "status":       "Export a save to filesystem",
            "tag":          "export"
        });

        menuOptions.push({
            "title":        "Restore a Game File (*." + ColonyGame.meta.fileExtension + ")",
            "status":       "Import a backed up game",
            "tag":          "importnew"
        });

        menuOptions.push({
            "title":        "Delete Files",
            "status":       "Delete single or multiple game files",
            "status-color": null,
            "tag":          "delete"
        });

        if(webAppCore.getPlatform().platform == "web") {
            menuOptions.push({
                "title":        "Text Backup",
                "status":       "Copy game data in raw text format for manual backup.",
                "overflow": [
                    {
                        "pre":  null,
                        "post": "Expert",
                        "color":"#F44336"
                    }
                ],
                "tag":          "textbackup"
            });

        }


        menuOptions.push({
            "title":        "Restore a Recovery File (*." + ColonyGame.meta.backupExtension + ")",
            "status":       "For emergency situations",
            "status-color":  "#FF9800",
            "tag":          "importmcb"
        });

        

        showList(dialogTitle,menuOptions,onGameDataOptionSelected,getString("general-dismiss"));
    }

    function onGameDataOptionSelected(tag) {

        if(tag == null) {
            return;
        }

        if(tag == "new") {
            saveGame(true);
            newGame();
        }

        if(tag == "delete") {
            listingType = "delete";
            webAppCore.openListing(showOpenGameListing);
        }

        if(tag == "load") {
            setTimeout(function() {
                showListingAfterSave = true;
                saveGame(true);
            },1500);
        }

        if(tag == "export") {
            listingType = "export";
            webAppCore.openListing(showOpenGameListing);
        }

        if(tag == "textbackup") {
            listingType = "textbackup";
            webAppCore.openListing(showOpenGameListing);
        }

        if(tag == "importmcb") {
            webAppCore.importFile(ColonyGame.meta.backupExtension,onGameFileImport);
        }

        if(tag == "importnew") {
            webAppCore.importFile(ColonyGame.meta.fileExtension,onGameFileImportNew);
        }
    }

    var pendingExportFile;

    function onTextBackupFileSelected(file) {
        webAppCore.openFile(file, completeTextBackup);
    }

    function onExportFileSelected(file) {
        pendingExportFile = file;
        webAppCore.openFile(pendingExportFile, completeExport);
    }

    function completeExport(data) {
        if(pendingExportFile == null) {
            return;
        }

        webAppCore.exportFile(pendingExportFile,data,false);
    }

    function completeTextBackup(data) {

        if(data == null || data.length == 0) {
            webAppCore.showToast("Error");
            return;
        }

        bulldozerMode = false;
        webAppCore.handleBackFunction(standardBack);
        webAppCore.setTitleVisible(false);
        titleShowing = false;

        document.getElementById("textBackupScreen").style.display = "block";
        document.getElementById("exportText").innerHTML = data;
    }

    var pendingDeleteFile;

    function confirmDelete(file) {

        if(!file) {
            return;
        }

        pendingDeleteFile = file;

        webAppCore.showDialog({
            "title":    getString("header-delete-colony"),
            "message":  "Delete " + pendingDeleteFile,
            "op1": {
                "text":     "Delete",
                "func":     deleteGameFile
            },
            "op2": {
                "text":     "Cancel",
                "func":     placeholder
            }
        });
    }

    function deleteGameFile() {
        webAppCore.deleteFile(pendingDeleteFile,onGameDeleted);
    }

    function onGameDeleted() {
        webAppCore.showToast("Deleted");
        listingType = "delete";
        webAppCore.openListing(showOpenGameListing);
    }

    function onGameFileImportNew(name,content) {
        console.log("importing " + name);
        currentFileName = name;

        uncompressFile(content);

    }

    function onGameFileImport(name,content) {
        console.log("importing " + name);
        currentFileName = name;
        onFileOpened(content);
        saveGame();
    }

    function presentColonistList(list,title) {

        if(!title || title == null) {
            title = "Colonists";
        }

        var menuOptions = [];

        for(var i = 0; i < list.length; i++) {
            var job = getBuildingById(list[i].job);
            var jobColor = null;
            

            if(job == null && list[i].money < gotItMadePrice) {
                job = "Unemployed";
                jobColor = "#F44336";
            } else {

                var jobName = "Retired";

                if(job == null) {
                    job = "Retired";
                } else {
                    jobName = job.name;
                    job = "Off duty";
                }

                if(getColonistMask(list[i],"AT_HOME")) {
                    job = "Sleeping";
                    jobColor = "#3F51B5";
                }

                if(getColonistMask(list[i],"AT_WORK")) {
                    job = "Working at " + jobName;
                    jobColor = "#388E3C";
                }

                if(getColonistMask(list[i],"IS_HEALING")) {
                    job = "Healing";
                    jobColor = "#1E88E5";
                }

                if(getColonistMask(list[i],"IS_RELAXING")) {
                    job = "Relaxing";
                    jobColor = "#1E88E5";
                }

                if(getColonistMask(list[i],"IS_PROTESTING")) {
                    job = "Protesting";
                    jobColor = "#F44336";
                }
            }

            menuOptions.push({
                "title":        list[i].name,
                "status":       job,
                "status-color": jobColor,
                "tag":          list[i]
            });
        }

        showList(title,menuOptions,onColonistSelected,"Nevermind");
    }

    function onColonistSelected(tag) {

        if(tag == null) {
            return;
        }

        if(getColonistMask(tag,"IS_SIMULATED")) {
            setColonistMask(tag,"IS_SIMULATED",false);
        }

        Scroll2d.setZoomLevel(1);
        Scroll2d.centerOnCoord(tag.x,tag.y);
        
        selectedColonist = tag;
        showOptionsForObject(selectedColonist,"colonist");
    }

    var retainedDef;

    function handleRelaxedColonist(colonist) {
        setColonistMask(colonist,"IS_RELAXING",false);
        var def;

        var evalArray;

        var avatarId = getAvatarIdForColonist(colonist);

        var killarray = [];

        for(var i = 0; i < currentGame.buildings.length; i++) {

            killarray = [];

            if(getColonistMask(colonist,"IS_TOURIST")) {
                evalArray = currentGame.buildings[i].tourists;
            } else {
                evalArray = currentGame.buildings[i].patrons;
            }

            if(evalArray == null || evalArray.length == 0) {
                continue;
            }

            def = getBuildingDefByName(currentGame.buildings[i].def);

            if(getColonistMask(colonist,"IS_TOURIST")) {
                if(def.takesTourists == 0) {
                    continue;
                }
            } else {
                if(def.entertains == 0) {
                    continue;
                }
            }

            for(var j = 0; j < evalArray.length; j++) {
                if(evalArray[j] == colonist.id || evalArray[j] == avatarId) {
                    killarray.push(evalArray[j]);

                    if(avatarId == 0) {
                        break;
                    }
                }

                
            }

            if(killarray.length > 0) {
                while(killarray.length > 0) {
                    removeFromArray(evalArray,killarray.shift());
                }
                
                
                if(avatarId == 0) {
                    break;
                }
            }
        }
    }

    function handleColonistRioting(colonist) {
        if(getColonistMask(colonist,"IS_TOURIST") || getColonistMask(colonist,"IS_DIPLOMAT")) {
            return;
        }

        if(colonist.happiness > 20) {
            setColonistMask(colonist,"IS_PROTESTING",false);
            return;
        }

        if(colonist.health < 5) {
            setColonistMask(colonist,"IS_PROTESTING",false);
            return;
        }

        if(!hasCapitol && !hasConsulate) {
            setColonistMask(colonist,"IS_PROTESTING",false);
            return;
        }

        if(ourCapitolBuilding == null) {
            return;
        }

        if(colonist.x != colonist.dX && colonist.y != colonist.dY) {
            return;
        }

        var giveUpChance = randomIntFromInterval(0,300);
        if(giveUpChance == 2) {
            setColonistMask(colonist,"IS_PROTESTING",false);
            return;
        }

        var randomSpaces = getFreeSpacesAroundBuilding(ourCapitolBuilding);

        if(randomSpaces.length == 0) {
            setColonistMask(colonist,"IS_PROTESTING",false);
            return;
        }
        
        var randomTarget = randomSpaces[randomIntFromInterval(0,randomSpaces.length - 1)];

        colonist.dX = randomTarget[0];
        colonist.dY = randomTarget[1];
    }

    function handleEntertainment(colonist) {

        if(getColonistMask(colonist,"IS_TOURIST")) {
            return;
        }

        if(getColonistMask(colonist,"AT_WORK") || getColonistMask(colonist,"AT_HOME") || getColonistMask(colonist,"IS_HEALING") || getColonistMask(colonist,"IS_PROTESTING")) {
            setColonistMask(colonist,"IS_RELAXING",false);
            return;
        }

        if(getColonistMask(colonist,"IS_RELAXING")) {
            if(colonist.happiness >= 100) {
                handleRelaxedColonist(colonist);
            }

            if(colonist.venue == 0) {
                setColonistMask(colonist,"IS_RELAXING",false);
            }

            return;
        }

        if(currentGame.workerPolicy == 3 && colonist.job > 0) {
            return;
        }

        var entertainmentHealth = 60;
        var entertainmentHappiness = 75;

        if(currentGame.workerPolicy == 0) {
            entertainmentHappiness = 90;
        }

        if(currentGame.workerPolicy == 2) {
            entertainmentHappiness = 50;
        }

        if(openMedicalArray == null || openMedicalArray.length == 0) {
            entertainmentHealth = 0;
        }

        if(colonist.health < entertainmentHealth) {
            return;
        }

        if(colonist.happiness > entertainmentHappiness) {
            return;
        }

        if(colonist.x != colonist.dX && colonist.y != colonist.dY) {
            return;
        }

        if(openVenuesArray == null) {
            return;
        }

        if(openVenuesArray.length == 0) {
            if(colonist.happiness <= 10) {
                //console.log("no open venues!");
                setColonistMask(colonist,"IS_WANDERING",true);
            }
            return;
        }

        findARelaxationVenue(colonist);

    }

    function findARelaxationVenue(colonist) {

        if(colonist == null) {
            return 0;
        }

        if(colonist.x != colonist.dX || colonist.y != colonist.dY) {
            return 0;
        }

        var destinationArray;

        var maxOccupancy = 0;

        if(getColonistMask(colonist,"IS_TOURIST")) {
            destinationArray = openTourismArray;
        } else {
            destinationArray = openVenuesArray;
        }

        if(destinationArray.length == 0) {
            return -1;
        }

        var sortedDoctors = sortBuildingsByDistanceFromUnit(destinationArray,colonist,false,DEF_ENTERTAINMENT_RANGE);

        var ourDoc = null;
        var charges;

        var workingDef = null;

        if(sortedDoctors.length == 0) {
            var randomPlace = destinationArray[randomIntFromInterval(0,destinationArray.length - 1)];
            sendUnitToBuilding(colonist,randomPlace);
            destinationArray = null;
            colonist.happiness-=5;
            return 0;
        }

        while(sortedDoctors.length > 0) {
            var doc = sortedDoctors.shift();

            workingDef = getBuildingDefByName(doc.b.def);

            charges = workingDef.entertainmentCost;

            if(charges > 0 && charges > colonist.money) {
                continue;
            }

            if(doc.d == 1) {
                ourDoc = doc.b;
                break;
            }

            var distance = sendUnitToBuilding(colonist,doc.b);

            if(distance == -1) {
                continue;
            }

            if(distance == 1) {
                ourDoc = doc.b;
            }

            break;
        }

        sortedDoctors = null;

        // we are not at the location
        if(ourDoc == null) {
            return 0;
        }

        if(getColonistMask(colonist,"IS_TOURIST")) {
            maxOccupancy = workingDef.takesTourists;
        } else {
            maxOccupancy = workingDef.entertains;
        }

        var patronArray;

        if(getColonistMask(colonist,"IS_TOURIST")) {
            patronArray = ourDoc.tourists;
        } else {
            patronArray = ourDoc.patrons;
        }

        // we are at the location 
        charges = workingDef.entertainmentCost;

        if(charges > 0) {
            colonist.money -= charges;

            if(getColonistMask(colonist,"IS_TOURIST")) {
                currentGame.totalTourismIncome += charges;
            }

            if(colonist.money < 0) {
                colonist.money = 0;
            }

            if(useTextPoppers) {
                Scroll2d.popText(ourDoc.x,ourDoc.y,getResourceByDefName(ColonyGame.meta.tenderResource).indicator + charges,getResourceByDefName(ColonyGame.meta.tenderResource));
            }


            modifyResourceAmount(ColonyGame.meta.tenderResource,charges,false,workingDef.name);
        }

        setColonistMask(colonist,"IS_RELAXING",true);
        colonist.venue = ourDoc.id;


        patronArray.push(colonist.id);

        if(patronArray.length >= maxOccupancy) {
            removeFromArray(destinationArray,ourDoc);

        }

        // if this venue has an educational value, chance to make the colonist smarter 
        if(colonist.iQ < workingDef.providesIQ) {
            var smartchance = randomIntFromInterval(0,15);
            if(smartchance == 5) {
                colonist.iQ++;
            }
        }

        sortedDoctors = null;
    }

    function SortedBuildingItem(building,distance) {
        this.b = building;
        this.d = distance;
    }

    function sortBuildingsByDistanceFromUnit(buildingArray,unit,isTerrain,range) {

        if(buildingArray == null || unit == null) {
            return [];
        }

        var sortedBuildings = [];
        var internalBlacklist = [];

        var maxDistance = 120;

        if(range) {
            maxDistance = range;
        }
        
        var useRange = 10;
        
        if(maxDistance < useRange) {
            useRange = maxDistance;
        }
        
        var minNumberToSort = Math.ceil(buildingArray.length * .2);

        if(minNumberToSort > 40) {
            minNumberToSort = 40;
        }

        //var n;

        var found = false;
        
        while(sortedBuildings.length < minNumberToSort && useRange <= maxDistance) {
            for(var i = 0; i < buildingArray.length; i++) {

                found = false;

                for(var l = 0, n = internalBlacklist.length; l < n; l++) {

                    if(internalBlacklist[l] === buildingArray[i].id) {
                        found = true;
                        break;
                    }

                }

                if(found) {
                    continue;
                }
                
                var a = unit.x - buildingArray[i].x;
                var b = unit.y - buildingArray[i].y;
                var distance = Math.sqrt( a*a + b*b );

                if(distance > useRange) {
                    continue;
                }

                var openSpots = getFreeSpacesAroundBuilding(buildingArray[i],1,false,isTerrain);
                
                if(openSpots.length == 0) {
                    internalBlacklist.push(buildingArray[i].id);
                    continue;
                }

                for(var j = 0; j < openSpots.length; j++) {
                    if(unit.x == openSpots[j][0] && unit.y == openSpots[j][1]) {
                        distance = 1;
                        break;
                    }
                }

                sortedBuildings.push(new SortedBuildingItem(buildingArray[i],Math.round(distance)));
                internalBlacklist.push(buildingArray[i].id);

            }
            
            useRange += 10;
        }

        sortedBuildings.sort(sortTargetPoints);

        return sortedBuildings;
    }

    function handleTourist(colonist) {
        if(!getColonistMask(colonist,"IS_TOURIST")) {
            return;
        }

        if(getColonistMask(colonist,"IS_RELAXING")) {
            if(colonist.happiness >= 100) {
                handleRelaxedColonist(colonist);
            }

            if(colonist.venue == 0) {
                setColonistMask(colonist,"IS_RELAXING",false);
            }

            return;
        }

        if(colonist.happiness > 80 || colonist.money < 10) {
            findASpaceport(colonist);
            return;
        }

        findARelaxationVenue(colonist);

        if(colonist.x == colonist.dX && colonist.y == colonist.dY) {
            setColonistMask(colonist,"IS_WANDERING",true);
        }
    }

    function findASpaceport(colonist) {
        if(colonist == null) {
            return;
        }

        if(colonist.x != colonist.dX || colonist.y != colonist.dY) {
            return;
        }

        var sortedDoctors = sortBuildingsByDistanceFromUnit(openSpaceportArray,colonist);

        var ourDoc = null;

        while(sortedDoctors.length > 0) {
            var doc = sortedDoctors.shift();

            if(doc.d == 1) {
                ourDoc = doc.b;
                break;
            }

            var distance = sendUnitToBuilding(colonist,doc.b);

            if(distance == -1) {
                continue;
            }

            if(distance == 1) {
                ourDoc = doc.b;
            }

            break;
        }

        sortedDoctors = null;

        // we are not at the location
        if(ourDoc == null) {
            return;
        }

        colonist.isGoingHome = true;
    }

    function removeColonistFromMedicalFacility(colonist) {

        if(colonist == null) {
            return;
        }

        var i,j,def;

        colonist.vanue = 0;
        setColonistMask(colonist,"IS_HEALING",false);

        var avatarId = getAvatarIdForColonist(colonist);

        var killarray = [];

        for(i = 0; i < currentGame.buildings.length; i++) {

            killarray = [];

            if(currentGame.buildings[i].patients == null || currentGame.buildings[i].patients.length == 0) {
                continue;
            }

            def = getBuildingDefByName(currentGame.buildings[i].def);

            if(def.heals == 0) {
                continue;
            } 

            for(j = 0; j < currentGame.buildings[i].patients.length; j++) {
                if(currentGame.buildings[i].patients[j] == colonist.id) {
                    killarray.push(currentGame.buildings[i].patients[j]);

                    if(avatarId == 0) {
                        break;
                    }
                }
            }

            if(killarray.length > 0) {
                while(killarray.length > 0) {
                    removeFromArray(currentGame.buildings[i].patients,killarray.shift());
                }
                
                
                if(avatarId == 0) {
                    break;
                }
            }
        }
    }

    function handleMedical(colonist) {

        if(colonist == null) {
            return 0;
        }

        if(getColonistMask(colonist,"AT_WORK") || getColonistMask(colonist,"AT_HOME") || getColonistMask(colonist,"IS_RELAXING") || getColonistMask(colonist,"IS_PROTESTING")) {
            
            if(getColonistMask(colonist,"IS_HEALING")) {
                removeColonistFromMedicalFacility(colonist);
            }
            
            setColonistMask(colonist,"IS_HEALING",false);

            return 0;
        }

        

        if(getColonistMask(colonist,"IS_HEALING")) {

            if(colonist.health >=100) {
                removeColonistFromMedicalFacility(colonist);
            }

            return 1;
        }

        if(colonist.x != colonist.dX || colonist.y != colonist.dY) {
            return 0;
        }

        if(openMedicalArray == null) {
            return 0;
        }

        if(openMedicalArray.length == 0) {
            return -1;
        }

        if(currentGame.workerPolicy == 3 && colonist.job > 0 && !getColonistMask(colonist,"IS_TOURIST")) {
            return 0;
        }

        var healthLevel = 90;

        if(currentGame.workerPolicy == 0) {
            healthLevel = 95;
        }

        if(getColonistMask(colonist,"IS_TOURIST") || currentGame.workerPolicy == 2) {
            healthLevel = 70;
        }

        if(currentGame.workerPolicy == 3) {
            healthLevel = 50;
        }

        if(colonist.health > healthLevel) {
            return 0;
        }

        

        var sortedDoctors = sortBuildingsByDistanceFromUnit(openMedicalArray,colonist,false,DEF_MEDICAL_RANGE);

        var ourDoc = null;

        if(sortedDoctors.length == 0) {
            var randomMedical = openMedicalArray[randomIntFromInterval(0,openMedicalArray.length - 1)];
            sendUnitToBuilding(colonist,randomMedical);
            colonist.happiness-=5;
            return -1;
        }

        while(sortedDoctors.length > 0) {
            var doc = sortedDoctors.shift();

            if(doc.d == 1) {
                ourDoc = doc.b;
                break;
            }

            var distance = sendUnitToBuilding(colonist,doc.b);

            if(distance == -1) {
                continue;
            }

            if(distance == 1) {
                ourDoc = doc.b;
            }

            break;
        }

        // we are not at the location
        if(ourDoc == null) {
            return 0;
        }

        setColonistMask(colonist,"IS_HEALING",true);
        colonist.venue = ourDoc.id;
        ourDoc.patients.push(colonist.id);

        if(ourDoc.patients.length >= getBuildingDefByName(ourDoc.def).heals) {
            removeFromArray(openMedicalArray,ourDoc);
        }

        sortedDoctors = null;

        return 0;
    }

    function findAHouse(colonist) {

        if(colonist == null) {
            return;
        }

        if(colonist.house > 0) {
            return;
        }

        if (openHomesArray == null || openHomesArray.length == 0) {
            return;
        }

        var sortedHomes = null;

        if(colonist.job == 0) {
            sortedHomes = sortBuildingsByDistanceFromUnit(openHomesArray,colonist,false,currentGame.width);
        } else {
            var job = getBuildingById(colonist.job);
            sortedHomes = sortBuildingsByDistanceFromUnit(openHomesArray,job,false,currentGame.width);
        }

        while(sortedHomes.length > 0) {
            var thisHome = sortedHomes.shift();

            if(addResident(thisHome.b,colonist)) {
                return;
            }
            
        }

        setColonistMask(colonist,"IS_SIMULATED",true);

    }

    function addResident(house,colonist) {

        if(!house) {
            return false;
        }

        if(!colonist) {
            return false;
        }

        var bDef = getBuildingDefByName(house.def);

        

        var freeSpace = getFreeSpacesAroundBuilding(house,1,false,false);
        if(freeSpace.length == 0) {
            house.deactivated = true;
            return false;
        }

        if(house.residents.length >= bDef.providesShelter) {
            return false;
        }

        if(colonist.house > 0) {
            return;
        }

        colonist.house = house.id;
        house.residents.push(colonist.id);

        if(house.residents.length >= bDef.providesShelter) {
            removeFromArray(openHomesArray,house);
        }

        return true;
    }

    function removeResident(house,colonist) {

        if(colonist == null) {
            return;
        }

        colonist.house = 0;

        if(house != null) {
            removeFromArray(house.residents,colonist.id);
        }
    }

    function shuffleArray(array) {

        if (array == null) {
            return [];
        }

        for (var i = array.length - 1; i > 0; i--) {
            var j = Math.floor(Math.random() * (i + 1));
            var temp = array[i];
            array[i] = array[j];
            array[j] = temp;
        }
        return array;
    }

    function findAJob(colonist) {

        if(colonist.job > 0) {
            return;
        }

        if(colonist.money > gotItMadePrice) {
            return;
        }

        var availableJobs = [];

        if (openJobsArray == null || openJobsArray.length == 0) {
            return;
        }

        if(!getColonistMask(colonist,"IS_SIMULATED")) {
            var freeSpacesAroundColonist = null;

            if(getColonistMask(colonist,"AT_HOME")) {
                var colonistHouse = getBuildingById(colonist.house);
                if(colonistHouse != null) {
                    freeSpacesAroundColonist = getFreeSpacesAroundBuilding(colonistHouse);
                }
            }

            if(freeSpacesAroundColonist == null) {
                freeSpacesAroundColonist = getFreeSpaceAroundTile(colonist.x,colonist.y,4,true);
            }

            if(freeSpacesAroundColonist == null || freeSpacesAroundColonist.length == 0) {
                setColonistMask(colonist,"IS_SIMULATED",true);
                return;
            }
        }

        availableJobs = shuffleArray(openJobsArray);

        while(availableJobs.length > 0) {

            var randomJob = availableJobs.shift();

            if(addWorker(randomJob,colonist)) {
                return;
            }
        }

        setColonistMask(colonist,"IS_SIMULATED",true);

    }

    function sendOutCallForHire() {
        for(var i = 0; i < currentGame.colonists.length; i++) {
            if(currentGame.colonists[i].job == 0) {
                findAJob(currentGame.colonists[i]);
            }
        }
    }

    function sendOutCallForResidents() {
        for(var i = 0; i < currentGame.colonists.length; i++) {
            if(currentGame.colonists[i].house == 0) {
                findAHouse(currentGame.colonists[i]);
            }
        }
    }

    function showTechWindowNew() {

        if(currentGame.readOnlyMode) {
            return;
        }

        var availableTechs = 0;

        var j;

        var menuOptions = [];

        for(var i = 0; i < ColonyGame.technology.length; i++) {
            if(!currentGame.unlockedTechs[ColonyGame.technology[i].name]) {

                if(ColonyGame.technology[i].requiresTech != null) {

                    var hasRequirements = true;

                    for(j = 0; j < ColonyGame.technology[i].requiresTech.length; j++) {

                        var techParts = ColonyGame.technology[i].requiresTech[j].split("|");

                        var hasThisOne = false;

                        for(var k = 0; k < techParts.length; k++) {
                            if(currentGame.unlockedTechs[techParts[k]]) {
                                hasThisOne = true;
                            }
                        }

                        if(!hasThisOne) {
                            hasRequirements = false;
                        }


                    }

                    if(ColonyGame.technology[i].reqIndependence && !currentGame.isIndependent) {
                        hasRequirements = false;
                    }

                    if(!hasRequirements) {
                        continue;
                    }
                }
                
                if(ColonyGame.technology[i].requiresStage > currentGame.stage) {
                    continue;
                }

                availableTechs++;

                var cost = [];

                for(j = 0; j < ColonyGame.technology[i].cost.length; j++) {
                    var def = getResourceByDefName(ColonyGame.technology[i].cost[j].resource);

                    var costColor = null;

                    if(ColonyGame.technology[i].cost[j].amount > currentGame.resources[ColonyGame.technology[i].cost[j].resource].amount) {
                        costColor = "#F44336";
                    }

                    cost.push({
                        pre:    "花费:",
                        post:   def.indicator + numberWithCommas(ColonyGame.technology[i].cost[j].amount),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });

                    
                }

                for(var k = 0; k < ColonyGame.buildings.length; k++) {
                    
                    if(ColonyGame.buildings[k].requiresTech == null || ColonyGame.buildings[k].requiresTech.length == 0) {
                        continue;
                    }

                    var thisUnlocks = false;
                    var thisNeededBy = false;

                    var bTechs = ColonyGame.buildings[k].requiresTech;

                    var techsNeeded = 0;
                    var needsThis = false;

                    for(var l = 0; l < bTechs.length; l++) {
                        if(currentGame.unlockedTechs[bTechs[l]]) {
                            continue;
                        }

                        techsNeeded++;

                        if(bTechs[l] == ColonyGame.technology[i].name) {
                            needsThis = true;
                        }
                    }

                    if(needsThis) {

                        var bldImg;
                        
                        if(ColonyGame.buildings[k].indicator == null) {
                            bldImg = gameAssets[ColonyGame.buildings[k].tile[0]][0].image.src;
                        } else {
                            bldImg = "images/" + ColonyGame.buildings[k].indicator;
                        }

                        if(techsNeeded == 1) {
                            cost.push({
                                pre:    "解锁:",
                                post:   ColonyGame.buildings[k].name,
                                color:  "#43A047",
                                icon:   bldImg
                            });
                        } else {
                            cost.push({
                                pre:    "需要:",
                                post:   ColonyGame.buildings[k].name,
                                color:  "#00796B",
                                icon:   bldImg
                            });
                        }
                    }
                }

                menuOptions.push({
                    "title":        ColonyGame.technology[i].name,
                    "description":  getString(ColonyGame.technology[i].description),
                    "icon":         "images/" + ColonyGame.technology[i].icon,
                    "overflow":     cost,
                    "tag":          ColonyGame.technology[i]
                });
            }
        }

        if(availableTechs > 0) {
            showList("技术",menuOptions,unlockTech,getString("general-dismiss"));
        } else {
            webAppCore.showAlertWithTitle("目前没有可用的技术.","No 技术");
        }
    }

    function showTechWindow() {
        if(!currentGame.unlockedTechs) {
            currentGame.unlockedTechs = {};
        }

        showTechWindowNew();
        return;
    }

    function unlockTech(tech) {

        cooldownGamepad();

        if(currentGame == null || tech == null) {
            return;
        }

        // double check that we can afford 
        var canAfford = true;
        var j;

        for(j = 0; j < tech.cost.length; j++) {
            if(tech.cost[j].amount > currentGame.resources[tech.cost[j].resource].amount) {
                canAfford = false;
            }
        }

        if(!canAfford) {
            webAppCore.showAlertWithTitle(getString("general-cant-afford"),"Cannot Afford");
            return;
        }

        for(j = 0; j < tech.cost.length; j++) {

            modifyResourceAmount(tech.cost[j].resource,-tech.cost[j].amount,false,"Research");
        }

        webAppCore.showToast({
            "message":      "Unlocked " + tech.name,
            "image":        "images/" + tech.icon
        });

        currentGame.unlockedTechs[tech.name] = true;


        drawSidebar();
    }

    function clearOutBuildMenu() {
        document.getElementById("constructionMenuItems").innerHTML = "";
        document.getElementById("constructionMenu").style.display = "none";
        document.getElementById("objectOptions").style.display = "none";
        document.getElementById("touchBuildConfirm").style.display = "none";
        document.getElementById("gamepadBuildConfirm").style.display = "none";

        touchPossibleBuildPoints = [];

        idleBuilderIndex = 0;

        chainQueue = null;
        cqX = null;
        cqY = null;

        drawSidebar();

        webAppCore.handleBackFunction(standardBack);
    }

    function selectIdleBuilder() {

        if(!currentGame) {
            return;
        }

        var availableBuilders = [];

        for(var i = 0; i < currentGame.vehicles.length; i++) {
            if(!currentGame.vehicles[i].inBuildingMode && !currentGame.vehicles[i].iH) {
                availableBuilders.push(currentGame.vehicles[i]);
            }
        }

        if(availableBuilders.length == 0) {
            webAppCore.showToast("No idle builders");
            return;
        }

        if(idleBuilderIndex > availableBuilders.length - 1) {
            idleBuilderIndex = 0;
        }

        selectedVehicle = [];
        selectedVehicle.push(availableBuilders[idleBuilderIndex]);
        
        Scroll2d.setZoomLevel(1);
        Scroll2d.centerOnCoord(selectedVehicle[0].x,selectedVehicle[0].y);
        
        drawSidebar();

        showOptionsForObject(selectedVehicle[0],"vehicle");

        idleBuilderIndex++;
    }

    function colonistStatCompress(colonist,source) {


        if(colonist.health === undefined) {
            console.log("undefined health from: " + source);
        }


        var harvestMode = "0";
        var depositing = "0";
        var wandering = "0";

        var atHome = "0";
        var atWork = "0";

        var isHealing = "0";
        var isProtesting = "0";
        var isRelaxing = "0";
        var simulated = "0";
        var tryingToGo = "0";
        var tourist = "0";


        var lastName = "0";
        var firstName = "0";


        colonist.statCompress = "";
        colonist.statCompress += "0,";
        colonist.statCompress += colonist.health + ",";
        colonist.statCompress += colonist.job + ",";
        colonist.statCompress += colonist.money + ",";
        colonist.statCompress += colonist.happiness + ",";
        colonist.statCompress += colonist.energy + ",";
        colonist.statCompress += colonist.house + ",";
        colonist.statCompress += colonist.breakCount + ",";
        colonist.statCompress += colonist.breakThreshold + ",";
        colonist.statCompress += colonist.consumptionCounter + ",";
        colonist.statCompress += harvestMode + ",";
        colonist.statCompress += depositing + ",";
        colonist.statCompress += wandering + ",";
        colonist.statCompress += colonist.age + ",";
        colonist.statCompress += colonist.venue + ",";
        colonist.statCompress += colonist.iQ + ",";

        colonist.statCompress += atHome + ",";
        colonist.statCompress += atWork + ",";
        colonist.statCompress += "0,";
        colonist.statCompress += isHealing + ",";
        colonist.statCompress += isProtesting + ",";
        colonist.statCompress += isRelaxing + ",";
        colonist.statCompress += simulated + ",";
        colonist.statCompress += tryingToGo + ",";
        colonist.statCompress += tourist + ",";

        colonist.statCompress += firstName + ",";
        colonist.statCompress += lastName + ",";

        colonist.statCompress += colonist.dX + ",";
        colonist.statCompress += colonist.dY + ",";
        colonist.statCompress += colonist.lastX + ",";
        colonist.statCompress += colonist.lastY + ",";
        colonist.statCompress += colonist.tX + ",";
        colonist.statCompress += colonist.tY + ",";
        colonist.statCompress += colonist.x + ",";
        colonist.statCompress += colonist.y + ",";

        colonist.statCompress += colonist.destinationChanges + ",";
        colonist.statCompress += colonist.energyCounter + ",";
        colonist.statCompress += colonist.faceFrame + ",";
        colonist.statCompress += colonist.giveUpCount + ",";
        colonist.statCompress += colonist.stepCount + ",";
        colonist.statCompress += "0";
    }

    var workerCleanupRequired = false;

    function colonistStatRestore(colonist) {

        if(colonist.statCompress == null) {
            return;
        }

        var colStats = colonist.statCompress.split(",");

        colonist.health = parseInt(colStats[1]);
        colonist.job = parseInt(colStats[2]);
        colonist.money = parseInt(colStats[3]);
        colonist.happiness = parseInt(colStats[4]);
        colonist.energy = parseInt(colStats[5]);
        colonist.house = parseInt(colStats[6]);
        colonist.breakCount = parseInt(colStats[7]);
        colonist.breakThreshold = parseInt(colStats[8]);
        colonist.consumptionCounter = parseInt(colStats[9]);


        if(colStats[12] == "1") {
            setColonistMask(colonist,"IS_WANDERING",true);
        }

        if(isNaN(colonist.health)) {

            colonist.health = 0;

            workerCleanupRequired = true;

            return;
        }

        if(colStats.length > 13) {
            colonist.age = parseInt(colStats[13]);
        }

        if(isNaN(colonist.age)) {
            colonist.age = randomIntFromInterval(216,360);
        }

        if(colStats.length > 14) {
            colonist.venue = parseInt(colStats[14]);
        }

        if(isNaN(colonist.venue)) {
            colonist.venue = 0;
        }

        if(colStats.length > 15) {
            colonist.iQ = parseInt(colStats[15]);
        }

        if(isNaN(colonist.iQ) || colonist.iQ < 40) {
            colonist.iQ = randomIntFromInterval(40,110);
        }

        if(colStats.length > 16 && colStats[16] == "1") {
            setColonistMask(colonist,"AT_HOME",true);
        }

        if(colStats.length > 17 && colStats[17] == "1") {
            setColonistMask(colonist,"AT_WORK",true);
        }


        if(colStats.length > 19 && colStats[19] == "1") {
            setColonistMask(colonist,"IS_HEALING",true);
        }

        if(colStats.length > 20 && colStats[20] == "1") {
            setColonistMask(colonist,"IS_PROTESTING",true);
        }
        

        if(colStats.length > 21 && colStats[21] == "1") {
            setColonistMask(colonist,"IS_RELAXING",true);
        }

        if(colStats.length > 22 && colStats[22] == "1") {
            setColonistMask(colonist,"IS_SIMULATED",true);
        }


        if(colStats.length > 24 && colStats[24] == "1") {
            setColonistMask(colonist,"IS_TOURIST",true);
        }

        var firstName = "0";
        var lastName = "0";
        
        if(colStats.length > 25) {
            firstName = colStats[25];
        }

        if(colStats.length > 26) {
            lastName = colStats[26];
        }
        

        
        if(firstName != "0" && lastName != "0") {
            colonist.name = firstName + " " + lastName;
        }

        if(colonist.name == "NaN") {
            setColonistName(colonist);
        }
        

        if(colStats.length > 27) {
            colonist.dX = parseInt(colStats[27]);
        }

        if(colStats.length > 28) {
            colonist.dY = parseInt(colStats[28]);
        }

        if(colStats.length > 29) {
            colonist.lastX = parseInt(colStats[29]);
        }

        if(colStats.length > 30) {
            colonist.lastY = parseInt(colStats[30]);
        }

        if(colStats.length > 31) {
            colonist.tX = parseInt(colStats[31]);
        }

        if(colStats.length > 32) {
            colonist.tY = parseInt(colStats[32]);
        }

        if(colStats.length > 33) {
            colonist.x = parseInt(colStats[33]);
        }

        if(colStats.length > 34) {
            colonist.y = parseInt(colStats[34]);
        }


        if(colStats.length > 35) {
            colonist.destinationChanges = parseInt(colStats[35]);
        }

        if(colStats.length > 36) {
            colonist.energyCounter = parseInt(colStats[36]);
        }

        if(colStats.length > 37) {
            colonist.faceFrame = parseInt(colStats[37]);
        }

        if(colStats.length > 38) {
            colonist.giveUpCount = parseInt(colStats[38]);
        }

        if(colStats.length > 39) {
            colonist.stepCount = parseInt(colStats[39]);
        }

        colonist.statCompress = null;
    }

    function getMedian(args) {
        if (!args.length) {return 0};
        var numbers = args.slice(0).sort((a,b) => a - b);
        var middle = Math.floor(numbers.length / 2);
        var isEven = numbers.length % 2 === 0;
        return isEven ? (numbers[middle] + numbers[middle - 1]) / 2 : numbers[middle];
      }

    function conductWorkerCleanup() {

        webAppCore.logEvent("Game Issue","Worker Cleanup","Required");

        var i;

        for(i = 0; i < currentGame.buildings.length; i++) {

            if(currentGame.buildings[i].embassyFor != 0) {
                continue;
            }

            currentGame.buildings[i].workers = [];
            currentGame.buildings[i].residents = [];
            currentGame.buildings[i].patrons = [];
            currentGame.buildings[i].patients = [];
        }

        for(i = 0; i < currentGame.colonists.length; i++) {

            currentGame.colonists[i].job = 0;
            currentGame.colonists[i].house = 0;

            setColonistMask(currentGame.colonists[i],"AT_HOME",false);

            setColonistMask(currentGame.colonists[i],"AT_WORK",false);
            setColonistMask(currentGame.colonists[i],"IS_RELAXING",false);


            setColonistMask(currentGame.colonists[i],"IS_HEALING",true);
        }

        for(i = 0; i < currentGame.colonists.length; i++) {
            findAJob(currentGame.colonists[i]);
            findAHouse(currentGame.colonists[i]);
        }

        workerCleanupRequired = false;
    }

    function cleanUpUnneededColonistProperties(colonist) {

        delete colonist.targetPoints;
        delete colonist.iH;
        delete colonist.isDepositing;
        delete colonist.isWandering;
        delete colonist.food;
        delete colonist.health;
        delete colonist.job;
        delete colonist.money;
        delete colonist.happiness;
        delete colonist.energy;
        delete colonist.house;
        delete colonist.breakCount;
        delete colonist.breakThreshold;
        delete colonist.consumptionCounter;
        delete colonist.age;
        delete colonist.venue;
        delete colonist.iQ;

        delete colonist.isAtHome;
        delete colonist.isAtWork;
        delete colonist.isColonist;
        delete colonist.isHealing;
        delete colonist.isProtesting;
        delete colonist.isRelaxing;
        delete colonist.isSimulated;
        delete colonist.tryingToGoToWork;
        delete colonist.isTourist;

        delete colonist.mq;
        delete colonist.movementQueue;

        delete colonist.lastName;
        delete colonist.firstName;

        delete colonist.dX;
        delete colonist.dY;
        delete colonist.lastX;
        delete colonist.lastY;
        delete colonist.tX;
        delete colonist.tY;
        delete colonist.x;
        delete colonist.y;

        delete colonist.destinationChanges;
        delete colonist.energyCounter;
        delete colonist.faceFrame;
        delete colonist.giveUpCount;
        delete colonist.stepCount;
        delete colonist.storage;
    }

    function cleanUpUnneededPassableProperties() {
        // should have passable parm
    }

    function showImportMenu(building) {

        if(currentGame == null) {
            return;
        }

        pendingImportExportItem = building;

        clearOutBuildMenu();

        var def = getBuildingDefByName(building.def);

        tmpTradeCapacity = def.tradeCapacity;

        if(tmpTradeCapacity == 0) {
            tmpTradeCapacity = 100;
        }

        if(def.canImport == null) {
            webAppCore.showAlertWithTitle("There is nothing to import!","No Options");
            return;
        }

        var menuOptions = [];
        
        for (var i = 0; i < def.canImport.length; i++) {

            var statusColor = null;

            var unitPriace = (parseInt(currentGame.resources[def.canImport[i]].price) / 100.0) * tmpTradeCapacity;

            var importPrice = Math.round(unitPriace * importPriceMod);
            var transactionFee = Math.ceil(importPrice * importPenalty);

            var net = importPrice + transactionFee;


            if(net > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                statusColor = "#F44336";
            }

            var resName = def.canImport[i];

            var optionItem = {
                "title": resName,
                "title-color": null,
                "description": null,
                "status": "Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(importPrice) + " per " + numberWithCommas(tmpTradeCapacity) ,
                "status-color": statusColor,
                "overflow": [
                    {
                        "pre":      "Transaction Fee (" + (importPenalty * 100) + "%):",
                        "post":     numberWithCommas(parseInt(transactionFee)),
                        "color":    "#FFB300",
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        "pre":      "Total:",
                        "post":     numberWithCommas(parseInt(net)),
                        "color":    statusColor,
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(resName).icon,
                "tag": resName
            };

            if(!isThereResourceCapacity(resName,tmpTradeCapacity)) {
                optionItem.overflow.push({
                    "pre":      null,
                    "post":     "Storage Full",
                    "color":    "#FFB300",
                    "icon":     "images/res-trend-max.png"
                });
            }

            menuOptions.push(optionItem);
        }
        
        if(menuOptions.length == 0) {
            webAppCore.showAlertWithTitle("There is nothing to import!","No Options");
            return;
        }
        
        showList("Import Goods",menuOptions,onImportDelected,"Nevermind");
    }

    function isThereResourceCapacity(resName,tryingToAdd) {
        var hascapacity = false;

        var modifier = 0;

        if(tryingToAdd) {
            modifier = parseInt(tryingToAdd);
        }

        if(currentGame.resources[resName].capacity == null || currentGame.resources[resName].capacity == 0 || (currentGame.resources[resName].capacity == -1 && (currentGame.resources[resName].storageCapacity > (currentGame.resources[resName].amount + modifier)))) {
            hascapacity = true;
        }

        return hascapacity;
    }

    function onImportDelected(good) {

        if(good == null || currentGame == null) {
            return;
        }

        var unitPriace = (parseInt(currentGame.resources[good].price) / 100.0) * tmpTradeCapacity;

        var importPrice = Math.round(unitPriace * importPriceMod);
        var transactionFee = Math.ceil(importPrice * importPenalty);
        var total = importPrice + transactionFee;


        if(total > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            webAppCore.showAlertWithTitle(getString("general-cant-afford"),"Insufficient Funds");
            return;
        }

        if(!isThereResourceCapacity(good)) {
            webAppCore.showAlertWithTitle("You do not have enough storage to make this transaction.","Storage Full");
            return;
        }

        


        modifyResourceAmount(good,tmpTradeCapacity,false,"Trade");
        modifyResourceAmount(ColonyGame.meta.tenderResource,-total,false,"Trade");


        var priceGain = Math.round(currentGame.resources[good].price * 0.006);
        currentGame.resources[good].price += priceGain;

        webAppCore.showToast({
            message: "Purchased " + tmpTradeCapacity + " " + good,
            image:   "images/" + getResourceByDefName(good).icon
        }); 

        if(pendingImportExportItem != null) {
            showImportMenu(pendingImportExportItem);
        }
    }

    var pendingImportExportItem = null;

    var tmpTradeCapacity = 100;

    function showExportMenu(building) {

        pendingImportExportItem = building;

        clearOutBuildMenu();

        var def = getBuildingDefByName(building.def);

        tmpTradeCapacity = def.tradeCapacity;

        if(tmpTradeCapacity == 0) {
            tmpTradeCapacity = 100;
        }

        if(def.canExport == null) {
            webAppCore.showAlertWithTitle("There is nothing to export!","No Options");
            return;
        }

        var menuOptions = [];

        
        
        for (var i = 0; i < def.canExport.length; i++) {

            var statusColor = null;

            if(currentGame.resources[def.canExport[i]].amount < tmpTradeCapacity) {
                statusColor = "#F44336";
            }

            var unitPriace = (parseInt(currentGame.resources[def.canExport[i]].price) / 100.0) * tmpTradeCapacity;

            var exportPrice = Math.round(unitPriace * exportPriceMod);
            var transactionFee = Math.ceil(exportPrice * exportPenalty);

            var net = exportPrice - transactionFee;

            menuOptions.push({
                "title": def.canExport[i],
                "title-color": null,
                "description": null,
                "status": "Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(exportPrice) + " per " + numberWithCommas(tmpTradeCapacity) ,
                "status-color": statusColor,
                "overflow": [
                    {
                        "pre":      "Transaction Fee (" + (exportPenalty * 100) + "%):",
                        "post":     numberWithCommas(parseInt(transactionFee)),
                        "color":    "#FFB300",
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        "pre":      "Net:",
                        "post":     numberWithCommas(parseInt(net)),
                        "color":    null,
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(def.canExport[i]).icon,
                "tag": def.canExport[i]
            });
        }
        
        if(menuOptions.length == 0) {
            webAppCore.showAlertWithTitle("There is nothing to export!","No Options");
            return;
        }
        
        showList("Export Goods",menuOptions,onExportGoodSelected,"Nevermind");
    }

    function onExportGoodSelected(good) {

        if(good == null || currentGame == null) {
            return;
        }

        if(currentGame.resources[good].amount < tmpTradeCapacity) {
            webAppCore.showAlertWithTitle("Trades must be conducted in " + tmpTradeCapacity + " unit lots!","Insufficient Resource");
            return;
        }

        var unitPriace = (parseInt(currentGame.resources[good].price) / 100.0) * tmpTradeCapacity;

        var exportPrice = Math.round(unitPriace * exportPriceMod);
        var transactionFee = Math.ceil(exportPrice * exportPenalty);
        var total = exportPrice + transactionFee;

        modifyResourceAmount(good,-tmpTradeCapacity,false,"Trade");
        modifyResourceAmount(ColonyGame.meta.tenderResource,total,false,"Trade");

        var priceLoss = Math.round(currentGame.resources[good].price * 0.008);
        currentGame.resources[good].price -= priceLoss;

        if(currentGame.resources[good].price < 1) {
            currentGame.resources[good].price = 1;
        }

        webAppCore.showToast({
            message: "Sold " + tmpTradeCapacity + " " + good,
            image:   "images/" + getResourceByDefName(good).icon
        });

        if(pendingImportExportItem != null) {
            showExportMenu(pendingImportExportItem);
        }
    }

    function getRaceByName(name) {
        for(var i = 0; i < ColonyGame.races.length; i++) {
            if(ColonyGame.races[i].name == name) {
                return ColonyGame.races[i];
            }
        }

        return null;
    }

    function getColonistTile(colonist) {

        var raceCard = getRaceByName(colonist.race);

        if(raceCard == null) {
            colonist.race = currentGame.defaultRace;
            raceCard = getRaceByName(colonist.race);
        }

        if(raceCard == null) {
            colonist.race = ColonyGame.races[0].name;
            raceCard = getRaceByName(colonist.race);
        }

        var tile = raceCard.defaultSprites[currentGame.stage][randomIntFromInterval(0,raceCard.defaultSprites[currentGame.stage].length - 1)];

        if(getColonistMask(colonist,"IS_TOURIST")) {
            tile = raceCard.touristSprites[currentGame.stage][randomIntFromInterval(0,raceCard.touristSprites[currentGame.stage].length - 1)];
        }

        // check if there is a special tile for colonist job 
        if(colonist.job > 0) {
            var jobBuilding = getBuildingById(colonist.job);

            if(jobBuilding == null) {
                console.log("zeroing out job from colonist tile null building");
                colonist.job = 0;
            } else {
                var jobDef = getBuildingDefByName(jobBuilding.def);
                
                if(jobDef.occupation != null) {
                    var occupationDef = getOccupationDefByName(jobDef.occupation);

                    if(occupationDef != null && occupationDef.tiles != null && occupationDef.tiles[colonist.race] != null &&  occupationDef.tiles[colonist.race][currentGame.stage]) {
                        tile = occupationDef.tiles[colonist.race][currentGame.stage][randomIntFromInterval(0,occupationDef.tiles[colonist.race][currentGame.stage].length - 1)];
                    }
                }
            }
        }

        return tile;
    }

    function advanceToStage(stage) {
        var stageInfo = ColonyGame.meta.gameStages[stage];

        if(currentGame.resources[ColonyGame.meta.gameStageResource].amount < stageInfo.threshold) {
            return;
        }

        currentGame.stage = stage;

        if(stageInfo.message != null) {
            webAppCore.showAlert(getString(stageInfo.message));
        }

        for(var i = 0; i < currentGame.colonists.length; i++) {
            currentGame.colonists[i].def.tile = getColonistTile(currentGame.colonists[i]);
        }
    }

    function getSimulationAmountForArray(array) {
        var count = array.length;
        

        if(count < 50) {
            return 0;
        }

        var simAmount = 0;

        if(count >= 50) {
            simAmount = Math.round(count * 0.05);
        }

        if(count >= 100) {
            simAmount = Math.round(count * 0.1);
        }

        if(count >= 150) {
            simAmount = Math.round(count * 0.15);
        }

        if(count >= 200) {
            simAmount = Math.round(count * 0.2);
        }

        if(count >= 400) {
            simAmount = count - 200;
        }

        

        return simAmount;
    }

    function cleanRetainedPaths() {
        var killas = [];

        for(var prop in retainedPaths) {
            if(!retainedUsage[prop] || retainedUsage[prop] <= 0) {
                killas.push(prop);
            } else {
                retainedUsage[prop]--;

                if(retainedUsage[prop] <= 0) {
                    killas.push(prop);
                }
            }
        }

        while(killas.length > 0) {
            var kill = killas.shift();

            delete retainedPaths[kill];
            delete retainedUsage[kill];
        }
    }

    function isUpgradeAvailableForStructure(structur) {

        var i;
        var def = getBuildingDefByName(structur.def);

        var upgradeCost = {};

        if(def.canUpgradeTo == null) {
            return null;
        }

        var newStructureDef = getBuildingDefByName(def.canUpgradeTo);

        if(newStructureDef.requiresStage > currentGame.stage) {
            return null;
        }

        if(newStructureDef.requiPremium) {
            if(!webAppCore.getIsPremium()) {
                return null;
            }
        }

        if(newStructureDef.requiresTech != null) {
            for(i = 0; i < newStructureDef.requiresTech.length; i++) {


                var techParts = newStructureDef.requiresTech[i].split("|");

                var hasThisOne = false;

                for(var k = 0; k < techParts.length; k++) {
                    if(currentGame.unlockedTechs[techParts[k]]) {
                        hasThisOne = true;
                    }
                }

                if(!hasThisOne) {
                    return null;
                }

            }
        }

        for(i = 0; i < newStructureDef.cost.length; i++) {
            var cst = newStructureDef.cost[i].amount;

            for(var j = 0; j < def.cost.length; j++) {
                if(def.cost[j].resource == newStructureDef.cost[i].resource) {
                    cst -= def.cost[j].amount;
                }
            }

            if(cst < 0) {
                cst = 0;
            }

            if(currentGame.resources[newStructureDef.cost[i].resource].amount < cst) {
                return null;
            }

            upgradeCost[newStructureDef.cost[i].resource] = cst;
        }

        return {
            "structure":    newStructureDef,
            "cost":         upgradeCost
        };

    }

    function conductUpgrade(frm,to,type) {

        var arrayToUse = currentGame.buildings;

        if(type == "passable") {
            arrayToUse = currentGame.passableNonUpdatables;
        }

        frm.isBeingRemoved = true;

        if(type == "building") {
            if(frm.workers && frm.workers != null && frm.workers.length > 0) {

                while(frm.workers.length > 0) {
                    if(frm.workers[0].colonistId < 0) {
                        frm.workers.shift();
                    } else {

                        var theworker = getColonistById(frm.workers[0].colonistId);

                        if(theworker == null) {
                            frm.workers.shift();
                        } else {
                            removeWorker(frm,theworker,"g");
                        }

                        
                    }  
                }

                while(frm.residents.length > 0) {
                    if(frm.residents[0] < 0) {
                        frm.residents.shift();
                    } else {
                        var theresident = getColonistById(frm.residents[0]);

                        if(theresident == null) {
                            frm.residents.shift();
                        } else {
                            removeResident(frm,theresident);
                        }
                        
                    }
                    
                }

            }

        }

        conductBuildingUpgradeEngage(to,frm.x,frm.y,type,arrayToUse);

    }

    function showEngineSettings() {
        var menuOptions = [];


        /*
        *   Colonist Option
        */

        var colCurrent = "关";
        var colColor = "#E53935";

        if(drawColonists) {
            colCurrent = "开";
            colColor = "#43A047";
        }

        menuOptions.push({
            "title": "渲染殖民者",
            "title-color": null,
            "description": null,
            "status": colCurrent,
            "status-color": colColor,
            "icon": "images/" + ColonyGame.meta.colonistIcon,
            "tag": "drawcol"
        });



        /*
        *   Text Poppers Option
        */

        var textPopperCurrent = "关";
        var textPopperColor = "#E53935";

        if(useTextPoppers) {
            textPopperCurrent = "开";
            textPopperColor = "#43A047";
        }

        menuOptions.push({
            "title": "刷新资源文本",
            "title-color": null,
            "description": null,
            "status": textPopperCurrent,
            "status-color": textPopperColor,
            "icon": "images/" + ColonyGame.meta.setPopperIndicator,
            "tag": "poppers"
        });



        /*
        *   Animations Option
        */

        var animationsCurrent = "Off";
        var animationsColor = "#E53935";

        if(allowAnimation) {
            animationsCurrent = "On";
            animationsColor = "#43A047";
        }

        menuOptions.push({
            "title": "建筑动画",
            "title-color": null,
            "description": null,
            "status": animationsCurrent,
            "status-color": animationsColor,
            "icon": "images/" + ColonyGame.meta.indAnimationSetting,
            "tag": "animations"
        });


        /*
        *   Lighting Option
        */

        var lightingCurrent = "关";
        var lightingColor = "#E53935";

        if(allowLighting) {
            lightingCurrent = "开";
            lightingColor = "#43A047";
        }

        menuOptions.push({
            "title": "灯光效果",
            "title-color": null,
            "description": null,
            "status": lightingCurrent,
            "status-color": lightingColor,
            "icon": "images/" + ColonyGame.meta.indLightingSetting,
            "tag": "lighting"
        });


        /*
        *   Day/Night Option
        */

        var daynightCurrent = "一直白天";
        var daynightColor = "#FFCA28";

        if(allowDayNight == "1") {
            daynightCurrent = "正常";
            daynightColor = "#43A047";
        }

        if(allowDayNight == "2") {
            daynightCurrent = "一直晚上";
            daynightColor = "#283593";
        }

        menuOptions.push({
            "title": "日/夜循环",
            "title-color": null,
            "description": null,
            "status": daynightCurrent,
            "status-color": daynightColor,
            "icon": "images/" + ColonyGame.meta.indDaynightSetting,
            "tag": "daynight"
        });






        /*
        *   Particle Effects Option
        */

        var particleCurrent = "关";
        var particleColor = "#E53935";

        if(allowParticleEffects) {
            particleCurrent = "开";
            particleColor = "#43A047";
        }

        menuOptions.push({
            "title": "粒子效应",
            "title-color": null,
            "description": null,
            "status": particleCurrent,
            "status-color": particleColor,
            "icon": "images/" + ColonyGame.meta.indParticlesSetting,
            "tag": "particleeffects"
        });


        /*
        *   Render Distance Check
        */

        var renderCheckCurrent = "关";
        var renderCheckColor = "#E53935";

        if(checkRenderDistance) {
            renderCheckCurrent = "开";
            renderCheckColor = "#43A047";
        }
        menuOptions.push({
            "title": getString("check-render-distance"),
            "title-color": null,
            "description": getString("check-render-dist-desc"),
            "status": renderCheckCurrent,
            "status-color": renderCheckColor,
            "icon": "images/ind-rendercheck.png",
            "tag": "renderdistcheck"
        });


        /*
        *   FPS Option
        */
        var fpsCapCurrent = "无";
        var fpxCapColor = "#43A047";

        if(fpsRate == 2) {
            fpsCapCurrent = "小";
            fpxCapColor = "#7CB342";
        }

        if(fpsRate == 3) {
            fpsCapCurrent = "中";
            fpxCapColor = "#FDD835";
        }

        if(fpsRate == 4) {
            fpsCapCurrent = "高";
            fpxCapColor = "#FB8C00";
        }

        if(fpsRate == 5) {
            fpsCapCurrent = "极限";
            fpxCapColor = "#E53935";
        }

        menuOptions.push({
            "title": "渲染FPS",
            "title-color": null,
            "description": "渲染FPS会使游戏看起来更加的不流畅，但是会增加模拟速度和降低功耗。",
            "status": fpsCapCurrent,
            "status-color": fpxCapColor,
            "icon": "images/" + ColonyGame.meta.setFpsIndicator,
            "tag": "fps"
        });

        if(!webAppCore.isTV()) {

            if(webAppCore.getPlatform().platform != "ios") {
                menuOptions.push({
                    "title": getString("engine-keyboard"),
                    "title-color": null,
                    "description": getString("engine-keyboard-meta"),
                    "status": null,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.keyboardIndicator,
                    "tag": "keyboard"
                });
            }

            if(window.innerWidth > sidebarModeWidth) {

                var sidebarOption = "Disabled";

                if(desktopMode) {
                    sidebarOption = "Enabled";
                }


                menuOptions.push({
                    "title": getString("engine-sidebar"),
                    "title-color": null,
                    "description": null,
                    "status": sidebarOption,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.sidebarIndicator,
                    "tag": "sidebar"
                });
            }

            var zoomButtonsCurrent = "关";

            if(showZoomButtons) {
                zoomButtonsCurrent = "开";
            }

            menuOptions.push({
                "title": getString("engine-zoom-buttons"),
                "title-color": null,
                "description": null,
                "status": zoomButtonsCurrent,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.zoomInIcon,
                "tag": "zoombuttons"
            });
        }

        var soundEffects = "关";

        if(allowAudio) {
            soundEffects = "开";
        }

        menuOptions.push({
            "title": getString("general-sound-xf"),
            "title-color": null,
            "description": null,
            "status": soundEffects,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.soundIndicator,
            "tag": "soundxf"
        });


        if(ColonyGame.soundtrack.length > 0) {
            var musicoption = "关";
            
            if(allowMusic) {
                musicoption = "开";
            }
    
            menuOptions.push({
                "title": "Music",
                "title-color": null,
                "description": null,
                "status": musicoption,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.soundIndicator,
                "tag": "musicsetting"
            });
        }



        var autosaveOption = getString("autosave-freq-normal");
        var autosaveColor = null;

        var currentSetting = webAppCore.getVar("mc-autosave-freq","1");

        if(currentSetting == "0") {
            autosaveOption = getString("autosave-freq-often");
            autosaveColor = "#F44336";
        }

        if(currentSetting == "2") {
            autosaveOption = getString("autosave-freq-rare");
        }

        if(currentSetting == "3") {
            autosaveOption = getString("autosave-freq-never");
            autosaveColor = "#F44336";
        }

        menuOptions.push({
            "title": getString("autosave-freq"),
            "title-color": null,
            "description": getString("autosave-freq-desc"),
            "status": autosaveOption,
            "status-color": autosaveColor,
            "icon": "images/" + ColonyGame.meta.autosaveInd,
            "tag": "autosave"
        });

        var backupOption = webAppCore.getVar("mc-backup-option","1");
        var backupStatus = "开";
        var backupColor = "#4CAF50";
        var backupIcon = ColonyGame.meta.backupOnInd;

        if(backupOption == "0") {
            backupStatus = "关";
            backupColor = "#F44336";
            backupIcon = ColonyGame.meta.backupOffInd;
        }

        menuOptions.push({
            "title": getString("backupOption"),
            "title-color": null,
            "description": getString("backupOptionDesc"),
            "status": backupStatus,
            "status-color": backupColor,
            "icon": "images/" + backupIcon,
            "tag": "backup"
        });

        showList("引擎设置",menuOptions,onEngineSettingSelected,getString("general-dismiss"));

    }

    function onEngineSettingSelected(tag) {

        if(!tag || tag == null) {
            return;
        }

        if(tag == "renderdistcheck") {
            checkRenderDistance = !checkRenderDistance;

            if(checkRenderDistance) {
                webAppCore.storeVar("check-render-distance","1");
            } else {
                webAppCore.storeVar("check-render-distance","0");
            }

            Scroll2d.setFastRenderMode(!checkRenderDistance);
        }

        if(tag == "backup") {
            var backupOption = webAppCore.getVar("mc-backup-option","1");

            if(backupOption == "0") {
                webAppCore.storeVar("mc-backup-option","1");
            } else {
                webAppCore.storeVar("mc-backup-option","0");
            }

            showEngineSettings();
        }

        if(tag == "daynight") {

            if(allowDayNight == "0") {
                allowDayNight = "1";
                webAppCore.storeVar("allow-daynight",allowDayNight);
                showEngineSettings();
                return;
            }

            if(allowDayNight == "1") {
                allowDayNight = "2";
                webAppCore.storeVar("allow-daynight",allowDayNight);
                showEngineSettings();
                return;
            }

            if(allowDayNight == "2") {
                allowDayNight = "0";
                webAppCore.storeVar("allow-daynight",allowDayNight);
                showEngineSettings();
                return;
            }

            
        }

        if(tag == "lighting") {

            allowLighting = !allowLighting;

            if(allowLighting) {
                webAppCore.storeVar("allow-lighting","1");
            } else {
                webAppCore.storeVar("allow-lighting","0");
            }

            showEngineSettings();
        }

        if(tag == "particleeffects") {
            
            allowParticleEffects = !allowParticleEffects;

            if(allowParticleEffects) {
                webAppCore.storeVar("allow-particles","1");
            } else {
                webAppCore.storeVar("allow-particles","0");
            }

            setWeather();
            showEngineSettings();
        }


        if(tag == "animations") {
            
            allowAnimation = !allowAnimation;

            if(allowAnimation) {
                webAppCore.storeVar("allow-animation","1");
            } else {
                webAppCore.storeVar("allow-animation","0");
            }

            showEngineSettings();
        }


        if(tag == "autosave") {
            showAutosaveOptions();
        }

        if(tag == "musicsetting") {
            var musicSetting;
            allowMusic = !allowMusic;

            if(allowMusic) {
                musicSetting = "1";
                initSoundtrack();
            } else {
                musicSetting = "0";
                stopSoundtrack();
            }
            webAppCore.storeVar("allow-music",musicSetting);

            showEngineSettings();
        }

        if(tag == "soundxf") {
            var soundSetting;
            allowAudio = !allowAudio;

            if(allowAudio) {
                soundSetting = "1";
            } else {
                soundSetting = "0";
            }
            webAppCore.storeVar("allow-audio",soundSetting);

            showEngineSettings();
        }

        if(tag == "zoombuttons") {
            showZoomButtons = !showZoomButtons;

            if(showZoomButtons) {
                webAppCore.storeVar("zoom-buttons","1");
                document.getElementById("zoomButtons").style.display = "inline-block";
            } else {
                webAppCore.storeVar("zoom-buttons","0");
                document.getElementById("zoomButtons").style.display = "none";
            }

            showEngineSettings();
        }

        if(tag == "sidebar") {
            desktopMode = !desktopMode;

            if(desktopMode) {
                webAppCore.storeVar("desktop-mode","1");
            } else {
                webAppCore.storeVar("desktop-mode","0");
            }
            
            sizeElements();
            Scroll2d.sizeElements();
            Scroll2d.forceSceneChange();
            showEngineSettings();
        }

        if(tag == "keyboard") {
            showKeyboardEditor();
        }

        if(tag == "drawcol") {
            drawColonists = !drawColonists;

            if(drawColonists) {
                webAppCore.storeVar("draw-col-setting","1");
            } else {
                webAppCore.storeVar("draw-col-setting","0");
            }

            showEngineSettings();
        }

        if(tag == "fps") {

            incrementFPS();

            monitoringFPS = false;

            showEngineSettings();
        }

        if(tag == "poppers") {
            useTextPoppers = !useTextPoppers;

            if(useTextPoppers) {
                webAppCore.storeVar("popper-setting","1");
            } else {
                webAppCore.storeVar("popper-setting","0");
            }

            showEngineSettings();
        }
    }

    function showAutosaveOptions() {

        var menuOptions = [];

        menuOptions.push({
            "title": getString("autosave-freq-often"),
            "title-color": null,
            "description": getString("autosave-often-warn"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "0"
        });

        menuOptions.push({
            "title": getString("autosave-freq-normal"),
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "1"
        });

        menuOptions.push({
            "title": getString("autosave-freq-rare"),
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "2"
        });

        menuOptions.push({
            "title": getString("autosave-freq-never"),
            "title-color": null,
            "description": getString("autosave-never-warn"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "3"
        });

        showList(getString("autosave-freq"),menuOptions,onSetAutosaveFreq,getString("general-dismiss"));
    }

    function incrementFPS() {
        fpsRate++;
        
        if(fpsRate == 6) {
            fpsRate = 1;
        }

        webAppCore.storeVar("fps-rate-setting",fpsRate.toString());
        webAppCore.storeVar("use-manual-fps","1");

        Scroll2d.setFPSLimiter(fpsRate);
    }

    function onSetAutosaveFreq(tag) {
        webAppCore.storeVar("mc-autosave-freq",tag);
        setAutosaveTimer();
        showEngineSettings();
    }

    function setAutosaveTimer() {
        var currentSetting = webAppCore.getVar("mc-autosave-freq","1");

        if(currentSetting == "0") {
            saveCounterMax = 6000;
        }

        if(currentSetting == "1") {
            saveCounterMax = 10000;
        }

        if(currentSetting == "2") {
            saveCounterMax = 30000;
        }

        if(currentSetting == "3") {
            saveCounterMax = -1;
        } else {
            if(webAppCore.getFacebookLoginStatus()) {
                saveCounterMax += 5000;
            }
        }

    }

    function hexToColor(hex) {

        var result;

        if (hex.length == 6 || hex.length == 7) {
            result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                a: 255,
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16)
            } : null;
        }

        if (hex.length == 8 || hex.length == 9) {
            result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                a: parseInt(result[1], 16),
                r: parseInt(result[2], 16),
                g: parseInt(result[3], 16),
                b: parseInt(result[4], 16)
            } : null;
        }

        return {
            a: 255,
            r: 0,
            g: 0,
            b: 0
        };
    }

    function dateToReadable(dte) {
        var monthNames = [
            "January", "February", "March",
            "April", "May", "June", "July",
            "August", "September", "October",
            "November", "December"
        ];

        var date = new Date(dte);
        var day = date.getDate();
        var monthIndex = date.getMonth();
        var year = date.getFullYear();

        return monthNames[monthIndex] + " " + day + ", " + year;
    }

    function numberWithCommas(x) {

        if(!x) {
            x = 0;
        }

        x = parseFloat(x);

        var formattedNumber = x.toFixed(2).replace(/[.,]00$/, "");

        return formattedNumber.replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }


    var gamepadStatOption = 0;

    function showColonistsMenu(section) {
        if(currentGame == null) {
            return;
        }

        if(statsOpen && !section) {
            closeStatsMenu();
            return;
        }

        

        if(!section) {
            gamepadStatOption = 0;
            section = "overview";
        }

        //console.log(currentGame.colonists.length);

        setTimeout(checkMyContracts,2500);
        setTimeout(recieveTaxCollections,4500);


        document.getElementById("statsScreen").style.display = "block";        

        statsOpen = true;

        document.getElementById("statsMain").scrollTop = 0;

        var statSections = document.querySelectorAll(".statSection");

        for(var i = 0; i < statSections.length; i++) {
            if(statSections[i].dataset.statsection == section) {
                statSections[i].style.display = "block";
            } else {
                statSections[i].style.display = "none";
            }
        }


        if(section == "overview") {
            updateOverviewStatDisplay();
        }

        if(section == "government") {
            updateApprovalStatDisplay();
        }

        if(section == "resources") {
            //showResourcesScreen();
            updateResourceStatDisplay();
        }

        if(section == "population") {
            updatePopulationStatDisplay();
        }

        if(section == "economy") {
            updateEconomicStatDisplay();
        }

        updateColonyStats();

        /*
        if(gamepadInUse) {
            highlightActiveStatSection();
        }
        */
    }

    function highlightActiveStatSection() {
        var statItems = document.getElementById("statsSidebar").querySelectorAll(".statMenuItem");

        if(gamepadStatOption < 0) {
            gamepadStatOption = statItems.length - 1;
        }

        if(gamepadStatOption >= statItems.length) {
            gamepadStatOption = 0;
        }

        for(var i = 0; i < statItems.length; i++) {
            if(i == gamepadStatOption) {
                statItems[i].className = "gabBTSidebarItem statMenuItem gamepadSelected";

                showColonistsMenu(statItems[i].dataset.statsection);
            } else {
                statItems[i].className = "gabBTSidebarItem statMenuItem";
            }
        }
    }

    function cloudSwitchPostDelete() {
        currentGame.useCloud = false;
        saveGame(true);
    }

    function askForIndependence() {
        if(currentGame.isIndependent) {
            webAppCore.showAlertWithTitle(getString("independence-final"),getString("independence-general"));
        } else {
            var baseIndependenceCost = ColonyGame.meta.baseIndependenceCost;
            var relationsPenalty = baseIndependenceCost.amount - (baseIndependenceCost.amount * (currentGame.earthAssemblyRelations / 100));
            var totalIndependenceCost = baseIndependenceCost.amount + relationsPenalty;

            var costString = getResourceByDefName(baseIndependenceCost.resource).indicator + totalIndependenceCost;

            if(currentGame.earthBackTax > 0) {
                costString = costString + " " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + currentGame.earthBackTax;
            }

            if(totalIndependenceCost > currentGame.resources[baseIndependenceCost.resource].amount || currentGame.resources[ColonyGame.meta.tenderResource].amount < currentGame.earthBackTax) {
                webAppCore.showAlertWithTitle(getString("indepence-noafford"),getString("independence-general"));
            } else {
                var taxMessage = getString("independence-ask");
                taxMessage = replaceAll(taxMessage,"#cost",costString);

                webAppCore.showDialog({
                    "title":    getString("independence-general"),
                    "message":  taxMessage,
                    "op1": {
                        "text":     getString("independence-declare"),
                        "func":     declareIndependence
                    },
                    "op2": {
                        "text":     getString("general-nevermind"),
                        "func":     placeholder
                    }
                });
            }
        }
    }
    

    function shareCharter() {
        webAppCore.nativeShare(getString("charter-share"));
    }

    function declareIndependence() {
        if(currentGame.isIndependent) {
            return;
        }

        var baseIndependenceCost = ColonyGame.meta.baseIndependenceCost;
        var relationsPenalty = baseIndependenceCost.amount - (baseIndependenceCost.amount * (currentGame.earthAssemblyRelations / 100));
        var totalIndependenceCost = baseIndependenceCost.amount + relationsPenalty;

        if(totalIndependenceCost > currentGame.resources[baseIndependenceCost.resource].amount || currentGame.resources[ColonyGame.meta.tenderResource].amount < currentGame.earthBackTax) {
            webAppCore.showAlertWithTitle(getString("indepence-noafford"),getString("independence-general"));
            return;
        }


        modifyResourceAmount(baseIndependenceCost.resource,-totalIndependenceCost,false,"Independence");

        if(currentGame.earthBackTax > 0) {

            modifyResourceAmount(ColonyGame.meta.tenderResource,-currentGame.earthBackTax,false,"Independence");
            currentGame.earthBackTax = 0;
        }

        currentGame.isIndependent = true;
        currentGame.tradeEmbargo = false;
        currentGame.immigrationEmbargo = false;

        currentGame.independenceDay = Date.now();
        webAppCore.showAlertWithTitle(getString("independence-final"),getString("independence-general"));

        if(ColonyGame.achievements.gainIndependence > 0) {
            webAppCore.reportAchievement(ColonyGame.achievements.gainIndependence);
        }

        getColonyInfoFromServer();
    }

    function throwSimParty() {

        var unsimulated = [];

        for(var i = 0; i < currentGame.colonists.length; i++) {
            updateColonist(currentGame.colonists[i]);

            if(currentGame.colonists[i].health > 0) {
                if(!getColonistMask(currentGame.colonists[i],"IS_SIMULATED")) {
                    unsimulated.push(currentGame.colonists[i]);
                }
            }
        }

        var total = unsimulated.length;

        if(total > 250) {
            total = 250;
        }

        while(total > 0) {
            var candidate = unsimulated[randomIntFromInterval(0,unsimulated.length - 1)];
            removeFromArray(unsimulated,candidate);
            setColonistMask(candidate,"IS_SIMULATED",true);
            total --;
        }

        unsimulated = null;

    }

    var altsdown = false;
    var altudown = false;
    var cancelIsDown = false;

    function buildKeyComparer(e) {
        var negotiateKey = "";

        if(e.altKey && e.key != "Alt") {
            negotiateKey += "alt+";
        }

        if(e.ctrlKey && e.key != "Control") {
            negotiateKey += "ctrl+";
        }

        if(e.shiftKey && e.key != "Shift") {
            negotiateKey += "shift+";
        }

        if(e.metaKey && e.key != "Meta") {
            negotiateKey += "meta+";
        }

        negotiateKey += e.key;

        return negotiateKey;
    }

    function onKeydown(e) {

        if(titleShowing || document.getElementById("customMapMetaDataEntry").style.display == "block" || document.getElementById("newGameMenu").style.display == "block" || document.getElementById("resourceContractMenu").style.display == "block") {
            return;
        }

        e.preventDefault();

        var key = buildKeyComparer(e);

        if(keyboardEditMode) {
            if(desktopMode) {
                document.getElementById("bottomHoverReadout").style.display = "inline-block";
                document.getElementById("bottomHoverReadout").innerHTML = key;
            }
            return;
        }

        if(key == webAppCore.getVar("KEY_PAN_UP",KEY_DEFAULT_PAN_UP)) {
            Scroll2d.startPan("up");
        }

        if(key == webAppCore.getVar("KEY_PAN_DOWN",KEY_DEFAULT_PAN_DOWN)) {
            Scroll2d.startPan("down");
        }

        if(key == webAppCore.getVar("KEY_PAN_LEFT",KEY_DEFAULT_PAN_LEFT)) {
            Scroll2d.startPan("left");
        }

        if(key == webAppCore.getVar("KEY_PAN_RIGHT",KEY_DEFAULT_PAN_RIGHT)) {
            Scroll2d.startPan("right");
        }

        if(key == webAppCore.getVar("KEY_ZOOM_OUT",KEY_DEFAULT_ZOOM_OUT)) {
            Scroll2d.doZoom(false);
        }

        if(key == webAppCore.getVar("KEY_ZOOM_IN",KEY_DEFAULT_ZOOM_IN)) {
            Scroll2d.doZoom(true);
        }

        if(key == webAppCore.getVar("KEY_CLEAR",KEY_DEFAULT_CLEAR)) {
            closeCommonwealthMenu();
            closeGBT();
            closeStatsMenu();
            hideSidebarIfSmall();
            closeColonyWindow();
            clearOutBuildMenu();
        }

        if(key == webAppCore.getVar("KEY_IDLE",KEY_DEFAULT_IDLE)) {
            selectIdleBuilder();
        }

        if(key == webAppCore.getVar("KEY_SELL_NO_CONFIRM",KEY_DEFAULT_SELL_NO_CONFIRM)) {
            altsdown = true;
        }

        if(key == webAppCore.getVar("KEY_UPGRADE_NO_CONFIRM",KEY_DEFAULT_UPGRADE_NO_CONFIRM)) {
            altudown = true;
        }

        if(key == webAppCore.getVar("KEY_CANCEL_NO_CONFIRM",KEY_DEFAULT_CANCEL_NO_CONFIRM)) {
            cancelIsDown = true;
        }

        // object options 
        if(document.getElementById("objectOptions").style.display == "block") {

            if(key == webAppCore.getVar("KEY_MOVE",KEY_DEFAULT_MOVE)) {
                if(document.getElementById("objectMoveIcon").style.display == "inline-block") {
                    document.getElementById("objectMoveIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_PARK",KEY_DEFAULT_PARK)) {
                if(document.getElementById("objectParkIcon").style.display == "inline-block") {
                    document.getElementById("objectParkIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_HARVEST",KEY_DEFAULT_HARVEST)) {
                if(document.getElementById("objectHarvestIcon").style.display == "inline-block") {
                    document.getElementById("objectHarvestIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_BUILD",KEY_DEFAULT_BUILD)) {
                if(document.getElementById("objectBuildIcon").style.display == "inline-block") {
                    document.getElementById("objectBuildIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_EXPORT",KEY_DEFAULT_EXPORT)) {
                if(document.getElementById("objectExportIcon").style.display == "inline-block") {
                    document.getElementById("objectExportIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_IMPORT",KEY_DEFAULT_IMPORT)) {
                if(document.getElementById("objectImportIcon").style.display == "block") {
                    document.getElementById("objectImportIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_SELL",KEY_DEFAULT_SELL)) {
                if(document.getElementById("objectSelIcon").style.display == "inline-block") {
                    document.getElementById("objectSelIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_UPGRADE",KEY_DEFAULT_UPGRADE)) {
                if(document.getElementById("objectUpgradeIcon").style.display == "block") {
                    document.getElementById("objectUpgradeIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_CANCEL",KEY_DEFAULT_CANCEL)) {
                if(document.getElementById("objectCancel").style.display == "block") {
                    document.getElementById("objectCancel").click();
                }
            }
        } else {
            // these commands only work when object options is NOT open
            if(key == webAppCore.getVar("KEY_STATS_WINDOW",KEY_DEFAULT_STATS_WINDOW)) {
                showColonistsMenu();
            }

            if(key == webAppCore.getVar("KEY_TECH_WINDOW",KEY_DEFAULT_TECH_WINDOW)) {
                showTechWindow();
            }

            if(key == webAppCore.getVar("KEY_ENCY_WINDOW",KEY_DEFAULT_ENCY_WINDOW)) {
                showEncyclopedia();
            }

            if(key == webAppCore.getVar("KEY_UNEM_WINDOW",KEY_DEFAULT_UNEM_WINDOW)) {
                showUnemployedColonists();
            }
        }
    }

    function onKeyup(e) {

        if(titleShowing || document.getElementById("customMapMetaDataEntry").style.display == "block" || document.getElementById("newGameMenu").style.display == "block" || document.getElementById("resourceContractMenu").style.display == "block") {
            return;
        }

        altsdown = false;
        altudown = false;
        cancelIsDown = false;

        e.preventDefault();

        var key = buildKeyComparer(e);

        if(keyboardEditMode) {

            document.getElementById("bottomHoverReadout").innerHTML = "";

            if(pendingEditKey != null) {
                webAppCore.storeVar(pendingEditKey,key);
            }

            cancelKeyboardEdit();
            showKeyboardEditor();

            return;
        }


        if(key == webAppCore.getVar("KEY_PAN_UP",KEY_DEFAULT_PAN_UP)) {
            Scroll2d.endPan("up");
        }

        if(key == webAppCore.getVar("KEY_PAN_DOWN",KEY_DEFAULT_PAN_DOWN)) {
            Scroll2d.endPan("down");
        }

        if(key == webAppCore.getVar("KEY_PAN_LEFT",KEY_DEFAULT_PAN_LEFT)) {
            Scroll2d.endPan("left");
        }

        if(key == webAppCore.getVar("KEY_PAN_RIGHT",KEY_DEFAULT_PAN_RIGHT)) {
            Scroll2d.endPan("right");
        }
    }

    function showKeyboardEditor() {

        var menuOptions = [];

        menuOptions.push({
            "title": getString("keyboard-clear-menus"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_CLEAR",KEY_DEFAULT_CLEAR),
            "status-color": null,
            "icon": null,
            "tag": "KEY_CLEAR"
        });

        menuOptions.push({
            "title": getString("keyboard-idle-unit"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_IDLE",KEY_DEFAULT_IDLE),
            "status-color": null,
            "icon": null,
            "tag": "KEY_IDLE"
        });

        menuOptions.push({
            "title": getString("keyboard-open-stats"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_STATS_WINDOW",KEY_DEFAULT_STATS_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_STATS_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-open-tech"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_TECH_WINDOW",KEY_DEFAULT_TECH_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_TECH_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-open-encyclopedia"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_ENCY_WINDOW",KEY_DEFAULT_ENCY_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_ENCY_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-open-unemployment"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_UNEM_WINDOW",KEY_DEFAULT_UNEM_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_UNEM_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-zoom-in"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_ZOOM_IN",KEY_DEFAULT_ZOOM_IN),
            "status-color": null,
            "icon": null,
            "tag": "KEY_ZOOM_IN"
        });

        menuOptions.push({
            "title": getString("keyboard-zoom-out"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_ZOOM_OUT",KEY_DEFAULT_ZOOM_OUT),
            "status-color": null,
            "icon": null,
            "tag": "KEY_ZOOM_OUT"
        });

        menuOptions.push({
            "title": getString("keyboard-sell-noconf"),
            "title-color": null,
            "description": getString("hold-and-click-tip"),
            "status": webAppCore.getVar("KEY_SELL_NO_CONFIRM",KEY_DEFAULT_SELL_NO_CONFIRM),
            "status-color": null,
            "icon": null,
            "tag": "KEY_SELL_NO_CONFIRM"
        });

        menuOptions.push({
            "title": getString("keyboard-upgrade-noconf"),
            "title-color": null,
            "description": getString("hold-and-click-tip"),
            "status": webAppCore.getVar("KEY_UPGRADE_NO_CONFIRM",KEY_DEFAULT_UPGRADE_NO_CONFIRM),
            "status-color": null,
            "icon": null,
            "tag": "KEY_UPGRADE_NO_CONFIRM"
        });

        menuOptions.push({
            "title": getString("keyboard-cancel-nocon"),
            "title-color": null,
            "description": getString("hold-and-click-tip"),
            "status": webAppCore.getVar("KEY_CANCEL_NO_CONFIRM",KEY_DEFAULT_CANCEL_NO_CONFIRM),
            "status-color": null,
            "icon": null,
            "tag": "KEY_CANCEL_NO_CONFIRM"
        });

        menuOptions.push({
            "title": getString("keyboard-move-unit"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_MOVE",KEY_DEFAULT_MOVE),
            "status-color": null,
            "icon": null,
            "tag": "KEY_MOVE"
        });

        menuOptions.push({
            "title": getString("keyboard-harvest-mode"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_HARVEST",KEY_DEFAULT_HARVEST),
            "status-color": null,
            "icon": null,
            "tag": "KEY_HARVEST"
        });

        menuOptions.push({
            "title": getString("keyboard-show-build"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_BUILD",KEY_DEFAULT_BUILD),
            "status-color": null,
            "icon": null,
            "tag": "KEY_BUILD"
        });

        menuOptions.push({
            "title": getString("keyboard-show-export"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_EXPORT",KEY_DEFAULT_EXPORT),
            "status-color": null,
            "icon": null,
            "tag": "KEY_EXPORT"
        });

        menuOptions.push({
            "title": getString("keyboard-show-import"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_IMPORT",KEY_DEFAULT_IMPORT),
            "status-color": null,
            "icon": null,
            "tag": "KEY_IMPORT"
        });

        menuOptions.push({
            "title": getString("keyboard-sell"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_SELL",KEY_DEFAULT_SELL),
            "status-color": null,
            "icon": null,
            "tag": "KEY_SELL"
        });

        menuOptions.push({
            "title": getString("keyboard-upgrade"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_UPGRADE",KEY_DEFAULT_UPGRADE),
            "status-color": null,
            "icon": null,
            "tag": "KEY_UPGRADE"
        });

        menuOptions.push({
            "title": getString("keyboard-park"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_PARK",KEY_DEFAULT_PARK),
            "status-color": null,
            "icon": null,
            "tag": "KEY_PARK"
        });

        menuOptions.push({
            "title": getString("keyboard-cancel"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_CANCEL",KEY_DEFAULT_CANCEL),
            "status-color": null,
            "icon": null,
            "tag": "KEY_CANCEL"
        });

        menuOptions.push({
            "title": getString("keyboard-defaults"),
            "title-color": null,
            "description": null,
            "status": getString("keyboard-defaults-warn"),
            "status-color": "#F44336",
            "icon": null,
            "tag": "defaults"
        });

        showList(getString("engine-keyboard"),menuOptions,onKeyboardEditSelected,getString("general-dismiss"));
    }

    var keyboardEditMode = false;
    var pendingEditKey = null;

    function onKeyboardEditSelected(tag) {

        if(!tag) {
            return;
        }

        if(tag == "defaults") {

            webAppCore.storeVar("KEY_CLEAR",KEY_DEFAULT_CLEAR);
            webAppCore.storeVar("KEY_IDLE",KEY_DEFAULT_IDLE);
            webAppCore.storeVar("KEY_SELL_NO_CONFIRM",KEY_DEFAULT_SELL_NO_CONFIRM);
            webAppCore.storeVar("KEY_UPGRADE_NO_CONFIRM",KEY_DEFAULT_UPGRADE_NO_CONFIRM);
            webAppCore.storeVar("KEY_MOVE",KEY_DEFAULT_MOVE);
            webAppCore.storeVar("KEY_HARVEST",KEY_DEFAULT_HARVEST);
            webAppCore.storeVar("KEY_BUILD",KEY_DEFAULT_BUILD);
            webAppCore.storeVar("KEY_EXPORT",KEY_DEFAULT_EXPORT);
            webAppCore.storeVar("KEY_IMPORT",KEY_DEFAULT_IMPORT);
            webAppCore.storeVar("KEY_SELL",KEY_DEFAULT_SELL);
            webAppCore.storeVar("KEY_UPGRADE",KEY_DEFAULT_UPGRADE);

            webAppCore.storeVar("KEY_CANCEL",KEY_DEFAULT_CANCEL);
            webAppCore.storeVar("KEY_CANCEL_NO_CONFIRM",KEY_DEFAULT_CANCEL_NO_CONFIRM);

            showKeyboardEditor();

            return;
        }

        keyboardEditMode = true;
        pendingEditKey = tag;

        webAppCore.showToast({
            message: "Choose Key For " + tag,
            image:   "images/" + ColonyGame.meta.keyboardIndicator,
            action: {
                "title": getString("general-cancel"),
                "func": cancelKeyboardEdit
            }
        });
    }

    function cancelKeyboardEdit() {
        keyboardEditMode = false;
        pendingEditKey = null;
        showKeyboardEditor();
    }

    function appendShortcutTitleToButton(btn,sc,def) {
        
        if(!usingMouse || webAppCore.isTV() || gamepadInUse) {
            return;
        }



        var current = btn.title;

        var appendor = webAppCore.getVar(sc,def);

        appendor = appendor.toUpperCase();

        if(appendor == "ESCAPE") {
            appendor = "Esc";
        }

        current += (" (" + appendor + ")");

        btn.title = current;
    }

    function appendShortcutToButton(btn,sc,def) {

        if(!usingMouse || webAppCore.isTV() || gamepadInUse) {
            return;
        }



        var current = btn.innerHTML;

        var appendor = webAppCore.getVar(sc,def);

        appendor = appendor.toUpperCase();

        if(appendor == "ESCAPE") {
            appendor = "Esc";
        }

        current += (" (" + appendor + ")");

        btn.innerHTML = current;
    }

    function callNearbyBuilders(x,y,radius,forHarvest,forceHarvesters) {
        //harvestAfterBuilding = false;
        var buildersCalled = 0;
        
        for(var i = 0; i < currentGame.vehicles.length; i++) {

            if(currentGame.vehicles[i].inBuildingMode) {
                buildersCalled++;
                continue;
            }

            if(!currentGame.vehicles[i].inBuildingMode) {
                
                if(currentGame.vehicles[i].iH && !forceHarvesters) {
                    continue;
                }

                var isAvailable = true;

                if(radius > 0) {
                    var a = x - currentGame.vehicles[i].x;
                    var b = y - currentGame.vehicles[i].y;
                    var distance = Math.round(Math.sqrt( a*a + b*b ));

                    if(distance > radius) {
                        isAvailable = false;
                    }
                }

                if(isAvailable) {
                    if(forHarvest) {
                        //currentGame.vehicles[i].inHarvestMode = true;
                    } else {
                        currentGame.vehicles[i].inBuildingMode = true;
                        buildersCalled++;
                        
                        if(currentGame.vehicles[i].iH) {
                            currentGame.vehicles[i].iH = false;
                            currentGame.vehicles[i].harvestAfterBuilding = true;
                        }
                    }
                    
                }
            }
        }
        
        if(buildersCalled == 0 && !forceHarvesters) {
            callNearbyBuilders(x,y,radius,forHarvest,true);
        }
    }

    function changeMapEditorMapType() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            
            menuOptions.push({
                "title":        ColonyGame.mapTypes[i].name,
                "description":  getString(ColonyGame.mapTypes[i].description),
                "icon":         "images/" + ColonyGame.mapTypes[i].icon,
                "status":       null,
                "overflow":     null,
                "tag":          ColonyGame.mapTypes[i].name
            });
        }

        showList("Select Map Type",menuOptions,onMapEditorTypeChange,getString("general-dismiss"));
    }

    function onMapEditorTypeChange(type) {
        if(!type) {
            return;
        }

        currentGame.mapType = type;

        setMapType();
        setWeather();
        createMapEditorSideber();
    }



    var tmpCustomMapLoadedCallback = null;
    var tmpCustomMapLoadTitle = null;

    function loadCustomMap(callback,title) {
        tmpCustomMapLoadedCallback = callback;
        tmpCustomMapLoadTitle = getString(title);

        webAppCore.openListing(onCustomMapListingLoaded);
    }

    function insertCustomMapTerrainIntoGame(game,mapData) {
        game.mapResources = [];

        // restore terrain resource functions
        for(var i = 0; i < mapData.terrainData.length; i++) {
            
            if(mapData.terrainData[i].def.name) {
                mapData.terrainData[i].def = mapData.terrainData[i].def.name;
            }

            game.mapResources[i] = rebuildMapResourceObject(mapData.terrainData[i]);
            setUpMinidefForBuilding(game.mapResources[i],true,false);

        }

        game.mapType = mapData.mapType;
        game.height = mapData.height;
        game.width = mapData.width;

        game.mename = mapData.name;
        game.merevision = mapData.revision;
        game.meauthor = mapData.author;
        game.meurl = mapData.url;
        game.medescription = mapData.description;
        game.mestartx = mapData.startX;
        game.mestarty = mapData.startY;
    }

    var tmpSelectedCustomMapFilename = null;

    function onCustomMapListingLoaded(data) {

        if(tmpCustomMapLoadedCallback == null) {
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title": getString("general-import-map"),
            "description": getString("general-import-map-desc"),
            "tag": "importmap"
        });
        
        for(var i = 0; i < data.length; i++) {
            if(endsWith(data[i],"." + ColonyGame.meta.customMapExtension)) {
                menuOptions.push({
                    "title": data[i],
                    "tag": data[i]
                });
            }
        }


        

        if(menuOptions.length == 0) {
            webAppCore.showToast("No installed maps!");
        } else {
            webAppCore.presentNativeList(tmpCustomMapLoadTitle,menuOptions,function(tag) {

                if(!tag) {
                    return;
                }

                if(!webAppCore.getIsPremium()) {
                    showPremiumMessage(getString("general-custom-map"));
                    return;
                }

                if(tag == "importmap") {
                    webAppCore.importFile(ColonyGame.meta.customMapExtension,onCustomMapImport);
                    return;
                }

                tmpSelectedCustomMapFilename = tag;
                webAppCore.openFile(tag,onCustomMapOpened);
            },webAppCore.getString("general-dismiss"));
        }
    }

    function onCustomMapImport(name,content) {
        if(!webAppCore.getIsPremium()) {
            showPremiumMessage(getString("general-custom-map"));
            return;
        }

        if(!name || !content) {
            return;
        }

        tmpSelectedCustomMapFilename = name;
        onCustomMapOpened(content);
    }

    function onCustomMapOpened(data) {

        

        webAppCore.showSplash("Decompressing Data...");
        
        var worker = new Worker("compression-worker.js");

        worker.addEventListener("message",function(e) {
            if(e.data.status == "complete") {
                
                if(tmpCustomMapLoadedCallback == null) {
                    return;
                }

                var mapJson = JSON.parse(e.data.data);

                tmpCustomMapLoadedCallback(mapJson);
            }
            
        });
        worker.addEventListener("error",function(e) {
            var scrpt = e.filename.substr(e.filename.lastIndexOf('/') + 1);
            webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
        });
        worker.postMessage({
            "method":   "decompress",
            "data":     data
        });
    }

    var selectedMapEditorTool = null;

    var mapEditorPlacingStartFlag = false;

    function createMapEditorSideber() {
        document.getElementById("sidebarBuildListing").innerHTML = "";

        var buildItem,label,img;

        // map type option 
        buildItem = document.createElement("div");
        buildItem.className = "buildItem";
        buildItem.buildType = "terrain";

        buildItem.style.backgroundImage = "url('images/" + workingMapType.icon + "')";
        //buildItem.ref = ColonyGame.terrains[i];

        buildItem.onclick = function() {
            changeMapEditorMapType();
            mapEditorPlacingStartFlag = false;
        }


        label = document.createElement("p");
        label.innerHTML = appreviateTitle(workingMapType.name);
        label.className = "sidebarBuildLabel";
        buildItem.appendChild(label);


        document.getElementById("sidebarBuildListing").appendChild(buildItem);




        // start location flag
        buildItem = document.createElement("div");
        buildItem.className = "buildItem";
        buildItem.buildType = "terrain";

        img = gameAssets[ColonyGame.meta.mapEditorStartFlagAsset][0].image.src;

        buildItem.style.backgroundImage = "url('" + img + "')";
        //buildItem.ref = ColonyGame.terrains[i];

        buildItem.onclick = function() {
            mapEditorPlacingStartFlag = true;
        }


        label = document.createElement("p");
        label.innerHTML = "Start Location";
        label.className = "sidebarBuildLabel";
        buildItem.appendChild(label);


        document.getElementById("sidebarBuildListing").appendChild(buildItem);




        for(var i = 0; i < ColonyGame.terrains.length; i++) {
            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "terrain";

            img = gameAssets[ColonyGame.terrains[i].tile[0]][0].image.src;

            buildItem.style.backgroundImage = "url('" + img + "')";
            buildItem.ref = ColonyGame.terrains[i];

            buildItem.onclick = function() {
                mapEditorPlacingStartFlag = false;
                selectedMapEditorTool = this.ref;
                bulldozerMode = false;
            }


            label = document.createElement("p");
            label.innerHTML = appreviateTitle(ColonyGame.terrains[i].name);
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);


            document.getElementById("sidebarBuildListing").appendChild(buildItem);
        }
    }

    function createSidebar() {

        if(currentGame.mem) {
            createMapEditorSideber();
            return;
        }

        var i,j,hasOption,buildItem,label;

        document.getElementById("sidebarBuildListing").innerHTML = "";

        // buildings
        for(i = 0; i < ColonyGame.buildings.length; i++) {

            if(ColonyGame.buildings[i].cost == null) {
                continue;
            }

            if(ColonyGame.buildings[i].isEmbassy) {
                continue;
            }

            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "building";

            var img;

            img = gameAssets[ColonyGame.buildings[i].tile[0]][0].image.src;

            buildItem.style.backgroundImage = "url('" + img + "')";
            buildItem.ref = ColonyGame.buildings[i];

            buildItem.onclick = function() {
                
                if(!canIAffordThis(this.ref.cost)) {
                    this.cantAffortThis = true;
                    this.style.backgroundColor = "rgba(255, 0, 0, 0.3)";
                    return;
                }

                bulldozerMode = false;

                if(queuedBuildings != null && queuedBuildings.length > 0) {
                    engageBuildingQueue();
                }

                hideSidebarIfSmall();

                tmpBuildingRef = null;
                constructionFromSidebar = true;
                initConstruction(this.ref);
            };

            label = document.createElement("p");
            label.innerHTML = appreviateTitle(ColonyGame.buildings[i].name);
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);

            buildItem.baseClassSave = buildItem.className;

            buildItem.onmouseover = function(e) {
                showInfoboxForSidebarItem(this.ref,e.y,this);
            };

            buildItem.onmouseout = function() {
                hideInfobox();
            };

            document.getElementById("sidebarBuildListing").appendChild(buildItem);
        }

        // vehicles
        for(i = 0; i < ColonyGame.vehicles.length; i++) {

            if(ColonyGame.vehicles[i].cost == null) {
                continue;
            }

            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "vehicle";
            

            var vehimg = gameAssets[ColonyGame.vehicles[i].tile][0].image.src;

            buildItem.style.backgroundImage = "url('" + vehimg + "')";


            buildItem.ref = ColonyGame.vehicles[i];


            buildItem.onclick = function() {

                var freeBuildings = getAvailableBuildingsForVehicleConstruction(this.ref);
                
                if(freeBuildings.length == 0 || !canIAffordThis(this.ref.cost)) {
                    buildItem.cantAffortThis = true;
                    buildItem.style.backgroundColor = "rgba(255, 0, 0, 0.3)";
                    return;
                }   
                
                bulldozerMode = false;

                var buildingToUse = null;

                if(selectedBuilding != null) {
                    var bdef = getBuildingDefByName(selectedBuilding.def);

                    if(bdef != null && bdef.produces != null) {
                        for(var j = 0; j < bdef.produces.length; j++) {
                            if(bdef.produces[j] == this.ref.name) {
                                buildingToUse = selectedBuilding;
                                break;
                            }
                        }
                    }
                }

                if(buildingToUse == null) {
                    var allFreeBuildings = getAvailableBuildingsForVehicleConstruction(this.ref);
                    
                    if(allFreeBuildings.length > 0) {
                        buildingToUse = (allFreeBuildings[randomIntFromInterval(0,allFreeBuildings.length - 1)]);
                    }
                }

                

                if(buildingToUse != null) {
                    doConstruction(this.ref,buildingToUse);
                }
                
                drawSidebar();
            };

            label = document.createElement("p");
            label.innerHTML = appreviateTitle(ColonyGame.vehicles[i].name);
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);

            buildItem.onmouseover = function(e) {
                showInfoboxForSidebarItem(this.ref,e.y,this);
            };

            buildItem.onmouseout = function() {
                hideInfobox();
            };

            buildItem.baseClassSave = buildItem.className;
            

            document.getElementById("sidebarBuildListing").appendChild(buildItem);
        }

    }

    var currentSidebarListType = null;
    var currentSidebarListingStuff = [];

    function drawSidebar() {

        if(currentGame == null) {
            return;
        }

        if(currentGame.mem) {
            return;
        }

        currentSidebarListType = null;
        currentSidebarListingStuff = [];

        if(selectedBuildCategory == null) {
            selectedBuildCategory = "All Buildings";
        }

        var hasOption,j,i;
        var currentAvailableVehicles = 0;

        var addedItems = 0;

        var selBulRef = null;
        var selVehRef = null;

        if(selectedBuilding != null) {
            selBulRef = getBuildingDefByName(selectedBuilding.def);
        }

        if(selBulRef != null) {
            if(selBulRef.produces == null || selBulRef.produces.length == 0) {
                selBulRef = null;
            }
        }

        if(selBulRef == null) {
            if(selectedVehicle.length > 0) {
                selVehRef = getVehicleDefByName(selectedVehicle[0].def);
            }
        }

        if(selVehRef != null) {
            if(selVehRef.produces == null || selVehRef.produces.length == 0) {
                selVehRef = null;
            }
        }

        var buildOptions = document.getElementById("sidebarBuildListing").querySelectorAll(".buildItem");

        for(i = 0; i < buildOptions.length; i++) {

            var opt = buildOptions[i];

            if(!canIBuildThis(opt.ref,opt.buildType)) {
                if(opt.style.display != "none") {
                    opt.style.display = "none";
                }

                continue;
            }

            hasOption = false;

            if(selectedBuilding != null && selBulRef != null) {
                for(j = 0; j < selBulRef.produces.length; j++) {
                    if(selBulRef.produces[j] == opt.ref.name) {
                        hasOption = true;
                        break;
                    }
                }
            } else {
                if(selectedVehicle.length > 0 != null && selVehRef != null) {
                    for(j = 0; j < selVehRef.produces.length; j++) {
                        if(selVehRef.produces[j] == opt.ref.name) {
                            hasOption = true;
                            break;
                        }
                    }
                } else {
                    for(j = 0; j < opt.ref.buildCategories.length; j++) {
                        if(opt.ref.buildCategories[j] == selectedBuildCategory) {
                            hasOption = true;
                            break;
                        }
                    }
                }
            }


            if(!hasOption) {

                if(opt.style.display != "none") {
                    opt.style.display = "none";
                }

                continue;
            }

            currentSidebarListingStuff.push(opt.ref);

            if(addedItems == 0) {
                currentSidebarListType = buildOptions[i].buildType;
            }

            addedItems++;

            if(opt.style.display != "inline-block") {
                opt.style.display = "inline-block";
            }

            if(!canIAffordThis(opt.ref.cost)) {
                opt.cantAffortThis = true;
                opt.style.backgroundColor = "rgba(255, 0, 0, 0.3)";
            } else {
                opt.style.backgroundColor = null;
            }

            if(opt.ref.requiPremium && !webAppCore.getIsPremium()) {
                opt.className = "buildItem premiumLocked";
            } else {
                opt.className = "buildItem";
            }

            if(opt.buildType == "vehicle") {
                currentAvailableVehicles++;
            }

            
            
        }

        if(totalAvailableVehicles > 0 && currentAvailableVehicles > totalAvailableVehicles) {
            webAppCore.showToast("New Units Available!");
        }


        totalAvailableVehicles = currentAvailableVehicles;
   
    }

    function showInfoboxForSidebarItem(buildOption,y,sender) {

        if(currentGame == null) {
            return;
        }

        if(!buildOption || !sender) {
            document.getElementById("sidebarCostInfoBox").style.display == "none";
            return;
        }

        if(canIAffordThis(buildOption.cost)) {
            sender.cantAffortThis = false;
            sender.style.backgroundColor = null;
        }

        if(document.getElementById("sidebarCostInfoBox").style.display == "none") {
            
            document.getElementById("sidebarCostInfoBox").style.display = "block";
            document.getElementById("sidebarObjectName").innerHTML = buildOption.name;
            document.getElementById("sidebarObjectDescribtion").innerHTML = getString(buildOption.description);

            document.getElementById("infoBoxCostArea").innerHTML = "";

            var cost = [];
            var costColor,j,def;

            if(buildOption.tileWidth != null && buildOption.tileHeight != null) {
                cost.push({
                    pre:    "Size:",
                    post:   buildOption.tileWidth + "x" + buildOption.tileHeight,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.dimensionIndicator
                });
            }

            if(buildOption.requiresUtility != null) {
                for(j = 0; j < buildOption.requiresUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.requiresUtility[j].utility);

                    costColor = null;

                    if(buildOption.requiresUtility[j].amount + currentGame.utilities[buildOption.requiresUtility[j].utility].usage > currentGame.utilities[buildOption.requiresUtility[j].utility].capacity) {
                        costColor = "#F44336";
                    }

                    cost.push({
                        pre:    "需要:",
                        post:   numberWithCommas(buildOption.requiresUtility[j].amount),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            if(buildOption.acceptsWorkers > 0) {
                costColor = null;

                var occ = "Unskilled";
                var occupationDef = getOccupationDefByName(buildOption.occupation);
                var occImage = "images/" + ColonyGame.meta.colonistIcon;

                if(occupationDef != null) {
                    if(occupationDef.indicator != null) {
                        occImage = "images/" + occupationDef.indicator;
                    }
                }

                cost.push({
                    pre:    "工人:",
                    post:   numberWithCommas(buildOption.acceptsWorkers),
                    color:  costColor,
                    icon:   occImage
                });
            }

            for(j = 0; j < buildOption.cost.length; j++) {
                
                def = getResourceByDefName(buildOption.cost[j].resource);

                costColor = null;

                var costString = def.indicator + numberWithCommas(buildOption.cost[j].amount);

                if(buildOption.cost[j].amount > currentGame.resources[buildOption.cost[j].resource].amount) {
                    costColor = "#F44336";

                    var cDiff = buildOption.cost[j].amount - currentGame.resources[buildOption.cost[j].resource].amount;

                    costString += (" (-" + numberWithCommas(cDiff) + ")" );
                }

                cost.push({
                    pre:    "花费:",
                    post:   costString,
                    color:  costColor,
                    icon:   "images/" + def.icon
                });
            }

            if(buildOption.providesUtility != null) {
                for(j = 0; j < buildOption.providesUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.providesUtility[j].utility);

                    costColor = null;

                    cost.push({
                        pre:    "生成:",
                        post:   numberWithCommas(buildOption.providesUtility[j].amount),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            for(j = 0; j < cost.length; j++) {
                    
                var overflowItem = cost[j];
                
                var optionCostSpan = document.createElement("span");
                optionCostSpan.innerHTML = overflowItem.pre + " <img src=\"" + overflowItem.icon + "\" /> " + overflowItem.post;
                optionCostSpan.className = "infoboxOptionCost";
                if(overflowItem.color != null) {
                    optionCostSpan.style.color = overflowItem.color;
                }
                document.getElementById("infoBoxCostArea").appendChild(optionCostSpan);
            }
        }

        positionInfobox(y);
    }

    function positionInfobox(y) {
        if(y > window.innerHeight / 2) {
            document.getElementById("sidebarCostInfoBox").style.top = "initial";
            document.getElementById("sidebarCostInfoBox").style.bottom = (window.innerHeight - y) + "px";
        } else {
            document.getElementById("sidebarCostInfoBox").style.top = y + "px";
            document.getElementById("sidebarCostInfoBox").style.bottom = "initial";
        }
    }

    function hideInfobox() {
        document.getElementById("sidebarCostInfoBox").style.display = "none";
    }

    function canIAffordThis(cost) {

        if(!currentGame) {
            return false;
        }

        if(currentGame.cm) {
            return true;
        }

        for(var j = 0; j < cost.length; j++) {

            if(cost[j].amount > currentGame.resources[cost[j].resource].amount) {
                return false;
            }
        }

        return true;
    }

    function getAvailableBuildingsForVehicleConstruction(vehicle) {

        var avail = [];

        for(var i = 0; i < currentGame.buildings.length; i++) {

            var def = getBuildingDefByName(currentGame.buildings[i].def);

            if(def.produces == null) {
                continue;
            }

            for(var j = 0; j < def.produces.length; j++) {
                if(def.produces[j] == vehicle.name) {
                    avail.push(currentGame.buildings[i]);
                }
            }
        }

        return avail;
    }

    function canIBuildThis(object,type) {

        if(currentGame == null) {
            return false;
        }

        if(currentGame.cm) {
            return true;
        }

        if(object.requiresStage > currentGame.stage) {
            return false;
        }

        if(object.reqIndependence && !currentGame.isIndependent) {
            return false;
        }


        if(object.isConsulate) {

            if(currentGame.isIndependent) {
                return false;
            }

        }

        var i,j,def;

        

        

        if(!currentGame.unlockedTechs) {
            currentGame.unlockedTechs = {};
        }

        if(object.requiresTech != null) {


            for(j = 0; j < object.requiresTech.length; j++) {

                var techParts = object.requiresTech[j].split("|");

                var hasThisOne = false;

                for(var k = 0; k < techParts.length; k++) {
                    if(currentGame.unlockedTechs[techParts[k]]) {
                        hasThisOne = true;
                    }
                }

                if(!hasThisOne) {
                    return false;
                }

            }
        }

        if(object.cost != null) {
            for(j = 0; j < object.cost.length; j++) {
                if(!currentGame.resources[object.cost[j].resource].unlocked) {
                    return false;
                }
            }
        }

        // see if we have a vehicle available
        if(type == "building") {

            if(object.isEmbassy) {
                return true;
            }

            if(object.buildLimit > 0) {
                var existingStructures = 0;
    
                for(i = 0; i < currentGame.buildings.length; i++) {
                    if(currentGame.buildings[i].def == object.name) {
                        existingStructures++;

                        if(existingStructures >= object.buildLimit) {
                            break;
                        }
                    }
                }

                if(existingStructures >= object.buildLimit) {
                    return false;
                }
            }

            for(i = 0; i < currentGame.vehicles.length; i++) {

                def = getVehicleDefByName(currentGame.vehicles[i].def);

                if(def == null) {
                    continue;
                }

                if(def.produces == null) {
                    continue;
                }

                

                for(j = 0; j < def.produces.length; j++) {
                    if(def.produces[j] == object.name) {
                        return true;
                    }
                }
            }

            
        }

        // see if a building is available 
        if(type == "vehicle") {
            for(i = 0; i < currentGame.buildings.length; i++) {
                def = getBuildingDefByName(currentGame.buildings[i].def);

                if(def.produces == null) {
                    continue;
                }

                

                for(j = 0; j < def.produces.length; j++) {
                    if(def.produces[j] == object.name) {
                        return true;
                    }
                }
            }
        }
        

        return false;
    }

    function appreviateTitle(title) {

        title = title.replace("Advanced","Adv.");
        title = title.replace("Small","Sm.");
        title = title.replace("Generator","Gen.");
        title = title.replace("Independence","Ind.");
        title = title.replace("Colonial","Col.");

        return title;
    }

    var allBuildCategories;
    var gamepadSelectedBuildCategory = 0;

    function initBuildCategories() {
        document.getElementById("filterArea").innerHTML = "";

        var categories = [];
        var i,j;

        for(i = 0; i < ColonyGame.buildings.length; i++) {
            for(j = 0; j < ColonyGame.buildings[i].buildCategories.length; j++) {
                categories.push(ColonyGame.buildings[i].buildCategories[j]);
            }
        }

        for(i = 0; i < ColonyGame.vehicles.length; i++) {
            for(j = 0; j < ColonyGame.vehicles[i].buildCategories.length; j++) {
                categories.push(ColonyGame.vehicles[i].buildCategories[j]);
            }
        }

        allBuildCategories = categories.reduce(function(a,b){
            if (a.indexOf(b) < 0 ) a.push(b);
            return a;
        },[]);

        for(i = 0; i < allBuildCategories.length; i++) {
            var cat = document.createElement("option");
            cat.value = allBuildCategories[i];
            cat.innerHTML = allBuildCategories[i];
            document.getElementById("filterArea").appendChild(cat);
        }

        selectedBuildCategory = allBuildCategories[0];

        document.getElementById("gamepadFilterText").innerHTML = allBuildCategories[0];
        gamepadSelectedBuildCategory = 0;
    }

    function showGifts() {
        if(currentGame.gifts == null || currentGame.gifts.length == 0) {
            webAppCore.showToast("No gifts available!");
            return;
        }

        var menuOptions = [];

        if(currentGame.gifts.length > 1) {
            menuOptions.push({
                "title": getString("general-collect-all"),
                "title-color": null,
                "description": getString("general-collect-all-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.giftIndicator,
                "tag": "collectall"
            });
        }

        for(var i = 0; i < currentGame.gifts.length; i++) {

            var giftDesc = null;

            if(currentGame.gifts[i].message != null) {
                giftDesc = currentGame.gifts[i].message;
            }

            var giftStatus = numberWithCommas(currentGame.gifts[i].amount) + " " + currentGame.gifts[i].resource;

            menuOptions.push({
                "title": currentGame.gifts[i].name,
                "title-color": null,
                "description": giftDesc,
                "status": giftStatus,
                "status-color": null,
                "icon": "images/" + getResourceByDefName(currentGame.gifts[i].resource).icon,
                "tag": currentGame.gifts[i]
            });
        }

        if(menuOptions.length == 0) {
            return;
        }

        showList("Gifts",menuOptions,onGiftSelected,"Nevermind");
    }

    function onGiftSelected(gift) {

        if(!currentGame) {
            return;
        }

        if(!gift) {
            if(currentGame.gifts.length > 0) {
                document.getElementById("imGift").style.display = "inline-block";
            }

            return;
        }

        if(gift == "collectall") {

            while(currentGame.gifts.length > 0) {
                var mygift = currentGame.gifts.shift();
                modifyResourceAmount(mygift.resource,parseInt(mygift.amount),false,"Gift");
            }

            webAppCore.showToast("Gifts Redeemed");
        } else {
            removeFromArray(currentGame.gifts,gift);
            modifyResourceAmount(gift.resource,parseInt(gift.amount),false,"Gift");
            webAppCore.showToast("Gift Redeemed");
        }

        if(allowAudio && ColonyGame.sounds.contractBuy != null) {
            webAppCore.playSoundEffect(ColonyGame.sounds.contractBuy);
        }
        

        setTimeout(showGiftIfNeeded,200);

    }

    function showGiftIfNeeded() {
        if(!currentGame) {
            return;
        }

        if(currentGame.gifts.length == 0) {
            document.getElementById("imGift").style.display = "none";
        } else {
            showGifts();
        }
    }

    function Gift(name,message,resource,amount) {
        this.name = name;
        this.message = message;
        this.resource = resource;
        this.amount = amount;
    }

    function getString(string) {

        var baseString = webAppCore.getString(string);

        if(!baseString || baseString.trim().length == 0) {
            console.log("missing string: " + string);
        }

        if(!currentGame) {
            return baseString;
        }

        baseString = replaceAll(baseString,"#motherland",currentGame.motherland);

        if(currentGame.independenceDay == null) {
            baseString = replaceAll(baseString,"#independenceday","(n/a)");
        } else {
            baseString = replaceAll(baseString,"#independenceday",dateToReadable(currentGame.independenceDay));
        }

        if(currentGame.charter && currentGame.charter != 0) {
            baseString = replaceAll(baseString,"#charterid",currentGame.charter);
        }

        if(currentGame.name && currentGame.name != 0) {
            baseString = replaceAll(baseString,"#cityname",currentGame.name);
        }

        return baseString;
    }


    function recieveTaxCollections() {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(!currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,6,onTaxesCollected);
    }

    function onTaxesCollected(result) {

        if(result != null || result.trim().length > 0) {
            try {
                var taxCollections = JSON.parse(result);
                var totalTaxes = parseInt(taxCollections.taxes);

                if(!isNaN(totalTaxes) && totalTaxes > 0) {
                    if(!currentGame.gifts) {
                        currentGame.gifts = [];
                    }

                    if(isNaN(currentGame.colonialTaxCollected)) {
                        currentGame.colonialTaxCollected = 0;
                    }

                    currentGame.colonialTaxCollected += totalTaxes;

                    if(currentGame.autoBudget) {
                        modifyResourceAmount(ColonyGame.meta.tenderResource,totalTaxes,false,"Commonwealth");

                        webAppCore.showToast({
                            "message":      getString("empire-general") + " Tax Collection: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalTaxes),
                            "image":        "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                        });

                        if(allowAudio && ColonyGame.sounds.contractBuy != null) {
                            webAppCore.playSoundEffect(ColonyGame.sounds.contractBuy);
                        }

                    } else {
                        currentGame.gifts.push(new Gift(getString("tax-collection-header"),getString("tax-collection-message"),ColonyGame.meta.tenderResource,totalTaxes));
                        webAppCore.showToast("New gifts available!");
                        document.getElementById("imGift").style.display = "inline-block";
                    }

                    
                }
            } catch(ex) {
                console.log(ex);
            }
        }
    }

    function getChildColonies() {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(!currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,4,onChildCountReturn);
    }

    function onChildCountReturn(result) {
        if(result == null || result.trim().length == 0) {
            return;
        }

        if(!currentGame || currentGame == null) {
            return;
        }

        currentGame.colonies = parseInt(result);

        if(currentGame.colonies > 0) {
            recieveTaxCollections();
        }
    }

    function registerColonyId() {

        if(!currentGame || currentGame == null) {
            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    32
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "n",
            "value":    currentGame.name
        });

        var useMotherland = currentGame.motherlandid;

        if(useMotherland == 0 || useMotherland == "0") {
            var civDef = getCivilizationByName(currentGame.civilization);
            useMotherland = civDef.serverHomeworld;
        }

        data.push({
            "key":      "p",
            "value":    useMotherland
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onColonyRegistered);
    }

    function onColonyRegistered(result) {
        if(result == null || result.trim().length == 0) {
            return;
        }

        if(!currentGame || currentGame == null) {
            return;
        }

        try {
            var regInfo = JSON.parse(result);

            console.log(regInfo);

            currentGame.colonyId = regInfo.id;
            currentGame.apiKey = regInfo.guid;
            currentGame.charter = regInfo.charter;

        } catch(ex) {
            console.log(ex);
            console.log(result);

            takeColonyOffline();

            return;
        }

        saveGame();

        getColonyInfoFromServer();
    }

    function sendTaxPayment(amount) {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(currentGame.motherlandid == 0 || currentGame.offlineMode) {
            return;
        }

        var data = [];

        data.push({
            "key":      "mid",
            "value":    currentGame.motherlandid
        });

        data.push({
            "key":      "a",
            "value":    amount
        });

        postSecuredCallToApi(data,40,placeholder);
    }
    
    function updateResourcePrices(resources) {

        for(var i = 0; i < resources.resources.length; i++) {
            var gamePrice = getResourceByDefName(resources.resources[i].name).basePrice;

            var totalPrice = (gamePrice * 9) + parseInt(resources.resources[i].detailed.rolling);

            var averageAmount = Math.round(totalPrice / 10);

            var lastGamePrice = currentGame.resources[resources.resources[i].name].price;

            var newGamePrice =  Math.round((lastGamePrice + averageAmount) / 2);

            if(newGamePrice > parseInt(resources.resources[i].detailed.emergency)) {
                newGamePrice =  parseInt(resources.resources[i].detailed.emergency);
            }


            currentGame.resources[resources.resources[i].name].price = newGamePrice;
            currentGame.resources[resources.resources[i].name].serverId = resources.resources[i].id;
            currentGame.resources[resources.resources[i].name].lastTrade = parseInt(resources.resources[i].detailed.last);

            if(showingLive) {
                updateLivePrice(resources.resources[i].id,parseInt(resources.resources[i].detailed.last));
            }
        }

        serverMaxTradeSize = parseInt(resources.maxtrade);
    }

    var commonwealthMenuOpen = false;

    function showNewCommonwealthMenu() {
        if(!currentGame || currentGame == null) {
            return;
        }

        var commonwealthLeader = currentGame.motherlandid;

        if(currentGame.isIndependent) {
            commonwealthLeader = currentGame.colonyId;
        }

        if(!commonwealthLeader || commonwealthLeader == 0) {
            return;
        }

        document.getElementById("commonwealthWindow").style.display = "block";
        commonwealthMenuOpen = true;

        var data = [];

        data.push({
            "key":      "cid",
            "value":    commonwealthLeader
        });

        postSecuredCallToApi(data,39,parseCommonwealthLeaderData);

        
    }

    var pendingLoadColonyIdFromServer = 0;

    function getColonyInfoAndLaunchInfo(id) {

        pendingLoadColonyIdFromServer = id;

        var data = [];

        data.push({
            "key":      "cid",
            "value":    id
        });

        postSecuredCallToApi(data,39,parseColonyInfoAndLaunchIn);
    }

    function parseColonyInfoAndLaunchIn(result) {

        if(result != null || result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    if(pendingLoadColonyIdFromServer != 0) {
                        delete currentGame.foreignContactReference[pendingLoadColonyIdFromServer];
                    }
                    pendingLoadColonyIdFromServer = 0;
                    return;
                }

                launchColonyInfoScreen(colonyInfo);

            } catch(ex) {
                console.log(ex);
            }
        }

        pendingLoadColonyIdFromServer = 0;
    }

    function parseCommonwealthLeaderData(result) {
        if(result != null || result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    return;
                }

                document.getElementById("commonwealthIcon").src = "images/" + ColonyGame.meta.empireIndicator;
                document.getElementById("commonwealthName").innerHTML = getString("empire-general") + " of " + colonyInfo.colonyname;

                document.getElementById("commonwealthListing").innerHTML = "";

                addColonyCardToListing(colonyInfo);

                var commonwealthLeader = currentGame.motherlandid;
                
                if(currentGame.isIndependent) {
                    commonwealthLeader = currentGame.colonyId;
                }

                var data = [];

                data.push({
                    "key":      "cid",
                    "value":    commonwealthLeader
                });

                postSecuredCallToApi(data,30,parseNewCommonwealthListing);

            } catch(ex) {
                console.log(ex);
            }
        }
    }

    function commonwealthPongFrom(id) {
        if(!commonwealthMenuOpen) {
            return;
        }

        var commonwealthCards = document.getElementById("commonwealthListing").querySelectorAll(".colonyCard");

        for(var i = 0; i < commonwealthCards.length; i++) {
            if(commonwealthCards[i].colonyRef.colonyid == id) {
                commonwealthCards[i].querySelector(".colonyCardActive").innerHTML = "Online";
                commonwealthCards[i].className += " online";
                commonwealthCards[i].colonyOnline = true;
                break;
            }
        }
    }

    var commonwealthOnlineColonies = 0;

    function parseNewCommonwealthListing(result) {
        if(result != null || result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result);

                if(colonyInfo == null) {
                    return;
                }

                for(var i = 0; i < colonyInfo.length; i++) {
                    addColonyCardToListing(colonyInfo[i]);
                }

                commonwealthOnlineColonies = 0;

                postInGameMessageToCommonwealth("onlineping");

            } catch(ex) {
                console.log(ex);
            }
        }
    }

    function addColonyCardToListing(colonyInfo,fromDiplomatic) {
        if(colonyInfo.colonyid == currentGame.colonyId) {
            return;
        }

        var colonyCard = document.createElement("div");
        colonyCard.className = "colonyCard";
        colonyCard.colonyRef = colonyInfo;
        colonyCard.colonyOnline = false;

        if(fromDiplomatic) {
            colonyCard.diplomaticCard = fromDiplomatic;
        } else {
            colonyCard.diplomaticCard = false;
        }

        if(colonyInfo.relations < 80) {
            colonyCard.className = "colonyCard badrelations";
        }

        var colonyIcon = document.createElement("img");
        colonyIcon.draggable = false;
        colonyIcon.className = "colonyCardIcon";
        var hasIcon = false;

        if(colonyInfo.isindependent == "1" && !fromDiplomatic) {
            hasIcon = true;
            colonyIcon.src = "images/" + ColonyGame.meta.empireIndicator;
        } else {

            for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
                if(ColonyGame.mapTypes[i].name == colonyInfo.maptype) {
                    colonyIcon.src = "images/" + ColonyGame.mapTypes[i].icon;

                    hasIcon = true;
                }
            }
        }

        if(!hasIcon) {
            colonyIcon.src = "images/" + ColonyGame.meta.charterIndicator;
        }
        
        colonyCard.appendChild(colonyIcon);

        var colonyName = document.createElement("span");
        colonyName.className = "colonyCardName";
        colonyName.innerHTML = colonyInfo.colonyname;
        colonyCard.appendChild(colonyName);

        var colonyActive = document.createElement("span");
        colonyActive.className = "colonyCardActive";
        colonyActive.innerHTML = "Last Active: " + colonyInfo.lastactive;
        colonyCard.appendChild(colonyActive);

        colonyCard.onclick = function() {
            launchColonyInfoScreen(this.colonyRef,this.diplomaticCard,this.colonyOnline);
        };

        document.getElementById("commonwealthListing").appendChild(colonyCard);
    }

    function closeColonyWindow() {
        colonyWindowOpen = false;
        tmpNegoiationColony = null;
        document.getElementById("colonyWindow").style.display = "none";
    }

    var colonyWindowOpen = false;

    function launchColonyInfoScreen(colonyInfo,fromDiplomatic,isOnline) {

        tmpNegoiationColony = {"id":colonyInfo.colonyid,"name":colonyInfo.colonyname,"charter":colonyInfo.charter,"population":colonyInfo.population};

        colonyWindowOpen = true;

        var hasIcon = false;

        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == colonyInfo.maptype) {
                document.getElementById("colonyIcon").src = "images/" + ColonyGame.mapTypes[i].icon;

                hasIcon = true;
            }
        }

        if(!hasIcon) {
            document.getElementById("colonyIcon").src = "images/" + ColonyGame.meta.charterIndicator;
        }

        postInGameMessageToColony("checkvitals",null,colonyInfo.colonyid);

        document.getElementById("colonyWindow").style.display = "block";

        document.getElementById("colonyCoinShower").style.display = "none";

        document.getElementById("colonyEstablishEmbassy").style.display = "none";
        document.getElementById("colonyContactAmbassador").style.display = "none";
        

        document.getElementById("colonyViewWebsite").onclick = function() {
            webAppCore.externalURL(ColonyGame.meta.colonyServerBase + colonyInfo.charter + "/");
        };

        document.getElementById("colonySendMessage").onclick = function() {
            tmpHoldingMessage = null;
            sendACustomMessage(colonyInfo.colonyid);
        };

        if(currentGame.isIndependent && colonyInfo.isindependent == "0") {
            document.getElementById("colonyTribute").style.display = "initial";
            document.getElementById("colonyTribute").onclick = function() {
                var dialogOptions = {
                    title: "Demand Tribute",
                    message: "What percent of their " + ColonyGame.meta.tenderResource + " do you want " + tmpNegoiationColony.name + " to pay you?",
                    func: demandTribute
                };

                webAppCore.inputBox(dialogOptions);
            };
        } else {
            document.getElementById("colonyTribute").style.display = "none";
        }

        if(fromDiplomatic && colonyInfo.buildingid) {

            var embassyDef = getBuildingDefByName(colonyInfo.buildingid);

            var img;

            if(embassyDef.indicator == null) {
                img = gameAssets[embassyDef.tile[0]][0].image.src;
            } else {
                img = "images/" + embassyDef.indicator;
            }

            document.getElementById("colonyContactAmbassador").style.display = "initial";
            document.getElementById("colonyContactAmbassador").src = img;
            document.getElementById("colonyContactAmbassador").onclick = function() {
                //lookupNewEMbassyTarget(colonyInfo.charter);
            };
        }

        if(currentGame.isIndependent && colonyInfo.isindependent == "1" && !fromDiplomatic) {
            document.getElementById("colonyEstablishEmbassy").style.display = "initial";
            document.getElementById("colonyEstablishEmbassy").onclick = function() {
                lookupNewEMbassyTarget(colonyInfo.charter);
            };
        }

        if(currentGame.isIndependent && colonyInfo.isindependent == "0") {
            document.getElementById("colonyNukeCharter").style.display = "initial";
            document.getElementById("colonyNukeCharter").onclick = function() {
                webAppCore.showDialog({
                    "title":    "Rescind Charter",
                    "message":  "Are you sure you want to kick " + tmpNegoiationColony.name + " out of the Commonwealth?  This cannot be undone.",
                    "op1": {
                        "text":     "Rescind Charter",
                        "func":     rescindCharter
                    },
                    "op2": {
                        "text":     getString("general-nevermind"),
                        "func":     placeholder
                    }
                });
            };
        } else {
            document.getElementById("colonyNukeCharter").style.display = "none";
        }

        if(giftCapacity > 0) {
            document.getElementById("colonySendGift").style.display = "initial";
            document.getElementById("colonySendGift").onclick = function() {
                tmpHoldingMessage = null;
                showOnlineResources("send");
            };
        } else {
            document.getElementById("colonySendGift").style.display = "none";
        }

        if(commonwealthOnlineColonies > 0) {
            document.getElementById("colonyDenounce").style.display = "initial";
            document.getElementById("colonyDenounce").onclick = function() {
                postMessageToAllChannels(currentGame.name + " denounces " + tmpNegoiationColony.name + "!");
                webAppCore.showToast("You publicly denounce " + tmpNegoiationColony.name + "!");
            };
        } else {
            document.getElementById("colonyDenounce").style.display = "none";
        }

        if(colonyInfo.cloudlocation == "0") {
            document.getElementById("colonyInspect").style.display = "none";
        } else {
            document.getElementById("colonyInspect").style.display = "initial";
            document.getElementById("colonyInspect").onclick = function() {
                console.log(colonyInfo.cloudlocation);

                closeColonyWindow();
                closeCommonwealthMenu();

                returnToFileName = currentFileName;
                pendingForeignColony = replaceAll(colonyInfo.cloudlocation,"_","/");

                saveGame(true);
            };
        }

        document.getElementById("colonyName").innerHTML = colonyInfo.colonyname + " (" + colonyInfo.race + ")";

        if(colonyInfo.screenshot == "0") {
            document.getElementById("colonyScreenshot").style.display = "none";
        } else {
            document.getElementById("colonyScreenshot").style.display = "block";
            document.getElementById("colonyScreenshot").style.backgroundImage = "url('" + ColonyGame.meta.colonyServerBase.replace("/colonies","/screenshots") + colonyInfo.screenshot + "')";
        }

        

        document.getElementById("concernsListing").innerHTML = "";
        document.getElementById("colonyConcernsHeader").style.display = "none";

        document.getElementById("colonyFounded").innerHTML = "Founded: " + colonyInfo.founded;

        if(colonyInfo.isindependent == "0") {
            document.getElementById("colonyIndependence").style.display = "none";
        } else {
            document.getElementById("colonyIndependence").style.display = "block";
            document.getElementById("colonyIndependence").innerHTML = "Independence Day: " + colonyInfo.independent;
        }

        document.getElementById("colonyLastActive").innerHTML = "Last Active: " + colonyInfo.lastactive;
        document.getElementById("colonyPopulation").innerHTML = "Population: " + numberWithCommas(colonyInfo.population);
        document.getElementById("colonyGDP").innerHTML = "GDP: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(colonyInfo.totalgdp);
        document.getElementById("colonyUnemployment").innerHTML = "Unemployment Rate: " + colonyInfo.unemployment + "%";
        document.getElementById("colonyRelations").innerHTML = "Commonwealth Relations: " + colonyInfo.relations + "%";
        document.getElementById("colonyLocation").innerHTML = "Location: Sector " + colonyInfo.sectorx + ":" + colonyInfo.sectory + " - Grid " + colonyInfo.gridx + ":" + colonyInfo.gridy;
        
        if(isRestrictivePlatform() || colonyInfo.lastplatform == "Unknown") {
            document.getElementById("colonyPlaysOnSection").style.display = "none";
        } else {

            document.getElementById("colonyPlaysOnSection").style.display = "block";

            var showPlatform = colonyInfo.lastplatform;
            var showColor = "#000000";

            if(colonyInfo.lastplatform == "android" || colonyInfo.lastplatform == "android.gplay" || colonyInfo.lastplatform == "android.apemarket" || colonyInfo.lastplatform == "android.opera") {
                showPlatform = "Android";
                showColor = "#7CB342";
            }

            if(colonyInfo.lastplatform == "android.amazon") {
                showPlatform = "Kindle Fire";
                showColor = "#FFB300";
            }

            if(colonyInfo.lastplatform == "ios" || colonyInfo.lastplatform == "ios.appstore") {
                showPlatform = "iOS";
                showColor = "#424242";
            }

            if(colonyInfo.lastplatform == "windows" || colonyInfo.lastplatform == "windows.windowsstore") {
                showPlatform = "Windows 10";
                showColor = "#1976D2";
            }

            if(colonyInfo.lastplatform == "web" || colonyInfo.lastplatform == "web.apewebapps") {
                showPlatform = "Ape Web Apps";
                showColor = "#FF9800";
            }

            if(colonyInfo.lastplatform == "web.facebook") {
                showPlatform = "Facebook";
                showColor = "#3B5998";
            }

            if(colonyInfo.lastplatform == "web.chrome") {
                showPlatform = "Chrome";
                showColor = "#F44336";
            }

            if(colonyInfo.lastplatform == "desktop" || colonyInfo.lastplatform == "desktop.apemarket") {
                showPlatform = "Desktop";
                showColor = "#8E24AA";
            }

            if(colonyInfo.lastplatform == "desktop.windows") {
                showPlatform = "Windows";
                showColor = "#2196F3";
            }

            if(colonyInfo.lastplatform == "desktop.mac") {
                showPlatform = "macOS";
                showColor = "#7E57C2";
            }

            if(colonyInfo.lastplatform == "desktop.linux") {
                showPlatform = "Linux";
                showColor = "#FDD835";
            }

            document.getElementById("colonyPlaysOn").innerHTML = showPlatform;
            document.getElementById("colonyPlaysOn").style.color = showColor;
        }
    }

    var gamepadGbtOption = 0;
    
    function showNewTradeMenu(title) {

        if(currentTimeoutForSidebar != null) {
            clearTimeout(currentTimeoutForSidebar);
            currentTimeoutForSidebar = null;
        }

        if(usingSockets) {
            webAppCore.socketEmit("joinroom","trades");
        }

        document.getElementById("galBT").style.display = "block";
        gbtOpen = true;

        showLivePrices();

        tickerItems = [];

        document.getElementById("tradeMenuName").innerHTML = title;

        initSidebarPopulation();

    }

    function initSidebarPopulation() {
        var data = [];
        postSecuredCallToApi(data,9,populateGBTSidebar);
    }

    var tickerItems = [];

    function updateTicker() {

        if(!gbtOpen) {
            return;
        }

        var showingTickers = document.getElementById("gbtNewsData").querySelectorAll("span");

        var lastItem = null;
        var readyForNewItem = true;

        var tickerSpeed = 4;

        if(window.innerWidth < 800) {
            tickerSpeed = 3;
        }

        if(window.innerWidth < 500) {
            tickerSpeed = 2;
        }

        for(var i = 0; i < showingTickers.length; i++) {
            showingTickers[i].style.left = (parseInt(showingTickers[i].style.left.replace("px","")) - tickerSpeed) + "px";
            lastItem = showingTickers[i];

            if(parseInt(showingTickers[i].style.left.replace("px","")) < -showingTickers[i].offsetWidth) {
                document.getElementById("gbtNewsData").removeChild(showingTickers[i]);
                lastItem = null;
            }

            
        }

        if(lastItem != null) {

            var lastItemLeft = parseInt(lastItem.style.left.replace("px",""));
            var ticketWidth = document.getElementById("gabBTTicker").offsetWidth;
            var lastItemWidth = lastItem.clientWidth;

            if(lastItemLeft > (ticketWidth - lastItemWidth)) {
                readyForNewItem = false;
            }
        }

        if(readyForNewItem && tickerItems.length > 0) {
            var nextItem = tickerItems.shift();
            nextItem.style.left = document.getElementById("gabBTTicker").offsetWidth + "px";
            document.getElementById("gbtNewsData").appendChild(nextItem);
        }
    }

    function addItemToNewsTicker(text,color,callback,onTop,opacity) {

        if(!gbtOpen) {
            return;
        }

        var tickerItem = document.createElement("span");
        tickerItem.innerHTML = text;

        if(color) {
            tickerItem.style.color = color;
        }

        if(callback) {
            tickerItem.onclick = callback;
        }

        if(opacity) {
            tickerItem.style.opacity = opacity;
        }

        if(onTop) {
            tickerItems.unshift(tickerItem);
        } else {
            tickerItems.push(tickerItem);
        }

    }

    function highlightNextGbtSidebarOption() {
        var sidebarOptions = document.getElementById("gabBTSidebar").querySelectorAll(".gabBTSidebarItem");

        if(sidebarOptions.length == 0) {
            return;
        }

        if(gamepadGbtOption < 0) {
            gamepadGbtOption = sidebarOptions.length - 1;
        }

        if(gamepadGbtOption >= sidebarOptions.length) {
            gamepadGbtOption = 0;
        }

        for(var i = 0; i < sidebarOptions.length; i++) {

            if(i == gamepadGbtOption) {
                sidebarOptions[i].className = "gabBTSidebarItem gabBTSidebarItemSelected";
                sidebarOptions[i].scrollIntoView();
                sidebarOptions[i].click();
            } else {
                sidebarOptions[i].className = "gabBTSidebarItem";
            }
        }
    }
    
    function populateGBTSidebar(result) {
        var resources;

        if(currentGame == null) {
            return;
        }

        if(result != null || result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                console.log(ex);
                return;
            }
        }

        if(resources == null) {
            return;
        }

        document.getElementById("gabBTSidebar").innerHTML = "";
        var newItem;

        newItem = createSidebarItem("images/" + ColonyGame.meta.resourcesInd,getString("general-live-prices"),"liveprices");
        document.getElementById("gabBTSidebar").appendChild(newItem);

        for(var i = 0; i < resources.resources.length; i++) {

            var resource = resources.resources[i];

            newItem = createSidebarItem("images/" + getResourceByDefName(resource.name).icon,resource.name,resource);
            document.getElementById("gabBTSidebar").appendChild(newItem);

            var tickerText = resource.name + ". Last Price: " + numberWithCommas(parseInt(resource.detailed.last)) + ". Range: " + numberWithCommas(parseInt(resource.detailed.min)) + "-" + numberWithCommas(parseInt(resource.detailed.max)) + ". Average: " + numberWithCommas(parseInt(resource.detailed.rolling));

            addItemToNewsTicker(tickerText);
        }

        
        
        updateResourcePrices(resources);

        currentTimeoutForSidebar = setTimeout(repopulareSidebarIfNeeded,95000);

        if(gamepadInUse) {
            highlightNextGbtSidebarOption();
        }
    }

    function createSidebarItem(icon,name,reference) {
        var resItem = document.createElement("div");
        resItem.className = "gabBTSidebarItem";

        var resImage = document.createElement("img");
        resImage.src = icon;
        resImage.className = "gabBTSidebarItemIcon";
        resItem.appendChild(resImage);
        
        var resName = document.createElement("span");
        resName.innerHTML = name;
        resName.className = "gabBTSidebarItemName";
        resItem.appendChild(resName);

        resItem.resRef = reference;
        
        resItem.onclick = function() {
            populateNewGbtResources(this.resRef);
        };

        return resItem;
    }

    var currentTimeoutForSidebar = null;

    var gbtOpen = false;

    function repopulareSidebarIfNeeded() {
        currentTimeoutForSidebar = null;

        if(gbtOpen) {
            initSidebarPopulation();
        }
    }

    var showingLive = false;

    function updateLivePrice(serverid,price) {

        var gameitem = getResourceByServerId(serverid);

        currentGame.resources[gameitem.name].lastTrade = parseInt(price);

        if(!showingLive) {
            return;
        }

        var priceItems = document.getElementById("gabBTMain").querySelectorAll(".livePriceCard");

        for(var i = 0; i < priceItems.length; i++) {
            if(priceItems[i].serverId == serverid) {
                var priceColor = "initial";
                var indicatorSource = "images/res-trend-placeholder.png";

                if(price > priceItems[i].price) {
                    priceColor = "#33691E";
                    indicatorSource = "images/res-trend-up.png";
                }

                if(price < priceItems[i].price) {
                    priceColor = "#B71C1C";
                    indicatorSource = "images/res-trend-down.png";
                }

                priceItems[i].querySelector(".livePricePrice").innerHTML = numberWithCommas(price);
                priceItems[i].querySelector(".livePricePrice").style.color = priceColor;
                priceItems[i].querySelector(".livePriceIndicator").src = indicatorSource;

                priceItems[i].price = price;
            }
        }
    }

    function showLivePrices() {

        document.getElementById("gabBTMain").innerHTML = "";

        for(var i = 0; i < ColonyGame.resources.length; i++) {
            if(currentGame.resources[ColonyGame.resources[i].name].serverId && currentGame.resources[ColonyGame.resources[i].name].serverId != 0) {
                var livePriceCard = document.createElement("div");

                livePriceCard.className = "livePriceCard";
                livePriceCard.serverId = currentGame.resources[ColonyGame.resources[i].name].serverId;
                livePriceCard.price = parseInt(currentGame.resources[ColonyGame.resources[i].name].lastTrade);

                var livePriceImage = document.createElement("img");
                livePriceImage.src = "images/" + ColonyGame.resources[i].icon;
                livePriceImage.className = "livePriceImage";
                livePriceCard.appendChild(livePriceImage);

                var livePriceName = document.createElement("span");
                livePriceName.className = "livePriceName";
                livePriceName.innerHTML = ColonyGame.resources[i].name;
                livePriceCard.appendChild(livePriceName);

                var livePriceIndicator = document.createElement("img");
                livePriceIndicator.className = "livePriceIndicator";
                livePriceIndicator.src = "images/res-trend-placeholder.png";
                livePriceCard.appendChild(livePriceIndicator);

                var livePricePrice = document.createElement("span");
                livePricePrice.className = "livePricePrice";
                livePricePrice.innerHTML = numberWithCommas(parseInt(currentGame.resources[ColonyGame.resources[i].name].lastTrade));
                livePriceCard.appendChild(livePricePrice);

                livePriceCard.resourceReference = ColonyGame.resources[i];

                livePriceCard.onclick = function() {
                    populateNewGbtResources({
                        "id": currentGame.resources[this.resourceReference.name].serverId,
                        "name": this.resourceReference.name,
                        "price": currentGame.resources[this.resourceReference.name].price,
                        "detailed": {
                            "last": currentGame.resources[this.resourceReference.name].lastTrade
                        }
                    });
                };

                document.getElementById("gabBTMain").appendChild(livePriceCard);
            }
        }

        showingLive = true;
    }
    
    function populateNewGbtResources(resource) {
        
        if(resource == "commonwealth") {
            console.log("show trades from commonwealth");
            return;
        }

        if(resource == "liveprices") {
            showLivePrices();
            return;
        }


        pendingTradeResource = resource;

        var data = [];

        data.push({
            "key":      "r",
            "value":    pendingTradeResource.id
        });

        postSecuredCallToApi(data,29,parseNewGbtContracts);
    }

    var currentSelectedGamepadContract = 0;
    var gamepadContractsPerLine = 0;
    
    function parseNewGbtContracts(result) {
        if(currentGame == null) {
            return;
        }
        
        showingLive = false;

        document.getElementById("gabBTMain").innerHTML = "";


        var resources;

        currentSelectedGamepadContract = 0;

        
        if(result != null || result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                console.log(result);
                console.log(ex);
                webAppCore.showToast(getString("no-contracts"));

                return;
            }
        }
        
        if(resources == null || pendingTradeResource == null) {
            webAppCore.showToast(getString("no-contracts"));

            return;
        }

        if(!gamepadInUse) {
            // new sale button

            if(currentGame.resources[pendingTradeResource.name].amount > 100) {

                var btnNewSale = document.createElement("div");
                btnNewSale.className = "gabBTContractItem";
                btnNewSale.resourceRef = pendingTradeResource;

                var newSaleeHeader = document.createElement("span");
                newSaleeHeader.innerHTML = "SELL";
                newSaleeHeader.className = "contractHeader";
                btnNewSale.appendChild(newSaleeHeader);
                
                
                var newSaleIcon = document.createElement("img");
                newSaleIcon.className = "gabBTContractItemImage";
                newSaleIcon.src = "images/" + getResourceByDefName(pendingTradeResource.name).icon;
                


                btnNewSale.onclick = function() {
                    onSellSelectedResourceType(this.resourceRef,0);
                };
                
                btnNewSale.appendChild(newSaleIcon);

                var newSaleDescriipoion = document.createElement("span");
                newSaleDescriipoion.innerHTML = "Post a new " + pendingTradeResource.name + " trade to the market.  Choose quantity and price, and see if anybody buys.";
                newSaleDescriipoion.className = "contractPrice";
                
                btnNewSale.appendChild(newSaleDescriipoion);

                btnNewSale.defaultClass = btnNewSale.className;

                document.getElementById("gabBTMain").appendChild(btnNewSale);
            }


            // new offer button 
            var btnNewOffer = document.createElement("div");
            btnNewOffer.className = "gabBTContractItem";
            btnNewOffer.resourceRef = pendingTradeResource;

            var newOfferHeader = document.createElement("span");
            newOfferHeader.innerHTML = "REQUEST";
            newOfferHeader.className = "contractHeader";
            btnNewOffer.appendChild(newOfferHeader);
            
            
            var newOfferIcon = document.createElement("img");
            newOfferIcon.className = "gabBTContractItemImage";
            newOfferIcon.src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
            

            btnNewOffer.appendChild(newOfferIcon);

            var newOfferDescriptoin = document.createElement("span");
            newOfferDescriptoin.innerHTML = "Offer to buy " + pendingTradeResource.name + " at a given price.  Choose quantity and see if anybody sells to you.";
            newOfferDescriptoin.className = "contractPrice";
            
            btnNewOffer.appendChild(newOfferDescriptoin);

            btnNewOffer.onclick = function() {
                onSellSelectedResourceType(this.resourceRef,1);
            };

            btnNewOffer.defaultClass = btnNewOffer.className;


            document.getElementById("gabBTMain").appendChild(btnNewOffer);

        }


        var currentGoodDeals = 0;

        var maxTradeSize = serverMaxTradeSize;
        
        if(maxTradeSize > giftCapacity) {
            maxTradeSize = giftCapacity;
        }


        for(var i = 0; i < resources.contracts.length; i++) {
            var contract = resources.contracts[i];


            if(contract.quantity > maxTradeSize) {
                continue;
            }


            var unitPrice = parseInt(contract.price) / parseInt(contract.quantity);
            var hundredPrice = Math.round(unitPrice * 100);

            var priceColor = null;
            var hundredColor = null;

            

            if(contract.isoffer == "1") {
                if(contract.quantity > currentGame.resources[pendingTradeResource.name].amount) {
                    priceColor = "#F44336";
                }

                if(hundredPrice < parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#F44336";
                }

                if(hundredPrice > parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#4CAF50";
                }
            } else {
                if(contract.price > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                    priceColor = "#F44336";
                }

                if(hundredPrice > parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#F44336";
                }

                if(hundredPrice < parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#4CAF50";
                }
            }
            
            
            
            var contractItem = document.createElement("div");
            contractItem.className = "gabBTContractItem";

            if(priceColor != null || contract.sellerid == currentGame.colonyId) {
                contractItem.className = "gabBTContractItem noafford";
                contractItem.canBuy = false;
            } else {
                contractItem.canBuy = true;
            }

            contractItem.contractRef = contract;
            contractItem.badDeal = false;

            if(contract.isoffer == "0") {
                if(hundredPrice > (currentGame.resources[pendingTradeResource.name].price * 6)) {
                    contractItem.className += " baddeal";
                    contractItem.badDeal = true;
                }
            } else {
                if(hundredPrice < (currentGame.resources[pendingTradeResource.name].price / 6)) {
                    contractItem.className += " baddeal";
                    contractItem.badDeal = true;
                }
            }

            

            var contractHeader = document.createElement("span");
            contractHeader.innerHTML = "YOU GET";
            contractHeader.className = "contractHeader";
            contractItem.appendChild(contractHeader);
            
            
            var contractIcon = document.createElement("img");
            contractIcon.className = "gabBTContractItemImage";
            
            if(contract.isoffer == "1") {
                contractIcon.src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
            } else {
                contractIcon.src = "images/" + getResourceByDefName(pendingTradeResource.name).icon;
            }
            
            contractItem.appendChild(contractIcon);

            var contractQuantity = document.createElement("span");


            if(contract.isoffer == "1") {
                contractQuantity.innerHTML = numberWithCommas(parseInt(contract.price));
            } else {
                contractQuantity.innerHTML = numberWithCommas(parseInt(contract.quantity));
            }
            
            contractQuantity.className = "contractQuantity";
            contractItem.appendChild(contractQuantity);


            var priceHeader = document.createElement("span");
            priceHeader.innerHTML = "YOU PAY";
            priceHeader.className = "priceHeader";
            contractItem.appendChild(priceHeader);


            var priceIcon = document.createElement("img");
            priceIcon.className = "gabBTContractItemImage";
            
            if(contract.isoffer == "1") {
                priceIcon.src = "images/" + getResourceByDefName(pendingTradeResource.name).icon;
            } else {
                priceIcon.src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
            }
            
            contractItem.appendChild(priceIcon);

            var contractPrice = document.createElement("span");

            if(contract.isoffer == "1") {
                contractPrice.innerHTML = numberWithCommas(parseInt(contract.quantity));
            } else {
                contractPrice.innerHTML = numberWithCommas(parseInt(contract.price));
            }

            
            contractPrice.className = "contractPrice";
            contractPrice.style.color = priceColor;
            contractItem.appendChild(contractPrice);


            var hundoPrico = document.createElement("span");
            hundoPrico.innerHTML = numberWithCommas(parseInt(hundredPrice)) + " per 100";
            hundoPrico.className = "hundredPrice";
            hundoPrico.style.color = hundredColor;
            contractItem.appendChild(hundoPrico);

            var offeredBy = document.createElement("span");
            offeredBy.innerHTML = "Offered By";
            offeredBy.className = "offeredBy";
            offeredBy.charterRef = contract.sellercharter;
            contractItem.appendChild(offeredBy);

            offeredBy.onclick = function(e) {
                e.stopPropagation();
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + this.charterRef + "/");
            };

            var offeredByName = document.createElement("span");
            offeredByName.innerHTML = contract.sellername;
            offeredByName.className = "offeredByName";
            offeredByName.charterRef = contract.sellercharter;
            contractItem.appendChild(offeredByName);

            offeredByName.onclick = function(e) {
                e.stopPropagation();
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + this.charterRef + "/");
            };


            contractItem.onclick = function() {

                if(this.badDeal) {
                    showBadDealAlert(this);
                    return;
                }

                purchaseNewGBTContract(this);
            };

            contractItem.defaultClass = contractItem.className;

            if(contractItem.canBuy && i > 0) {

                var putIndex = 2;

                if(contractItem.badDeal) {
                    putIndex += currentGoodDeals;
                } else {
                    currentGoodDeals++;
                }

                document.getElementById("gabBTMain").insertBefore(contractItem,document.getElementById("gabBTMain").children[putIndex]);
            } else {
                document.getElementById("gabBTMain").appendChild(contractItem);
            }

        }
        
        document.getElementById("gabBTMain").scrollTop = 0;

        if(gamepadInUse) {
            highlightSelectedContractGamepad();
        }
    }

    function engageContractPurchase() {
        var totalContracts = document.getElementById("gabBTMain").querySelectorAll(".gabBTContractItem");
        
        if(totalContracts.length == 0) {
            return;
        }

        if(currentSelectedGamepadContract < 0) {
            return;
        }

        if(currentSelectedGamepadContract >= totalContracts.length) {
            return;
        }

        totalContracts[currentSelectedGamepadContract].click();
    }


    function highlightSelectedContractGamepad() {

        gamepadContractsPerLine = 0;


        var totalContracts = document.getElementById("gabBTMain").querySelectorAll(".gabBTContractItem");

        if(totalContracts.length == 0) {
            return;
        }

        if(currentSelectedGamepadContract < 0) {
            currentSelectedGamepadContract = totalContracts.length - 1;
        }

        if(currentSelectedGamepadContract >= totalContracts.length) {
            currentSelectedGamepadContract = 0;
        }


        var topLine = totalContracts[0].getBoundingClientRect().top

        for(var i = 0; i < totalContracts.length; i++) {


            if(totalContracts[i].getBoundingClientRect().top == topLine) {
                gamepadContractsPerLine++;
            }


            if(i == currentSelectedGamepadContract) {
                totalContracts[i].className = totalContracts[i].defaultClass + " gabBTContractItemSelectedGamepad";
                totalContracts[i].scrollIntoView();
            } else {
                totalContracts[i].className = totalContracts[i].defaultClass;
            }

        }

        console.log(gamepadContractsPerLine);
    }


    function showOnlineResources(method) {
        var data = [];

        var callback = onBuyResource;

        if(method == "sell") {
            callback = onSellResource;
        }

        if(method == "send") {
            callback = onSendResource;
        }

        if(method == "request") {
            callback = onRequestResource;
        }

        if(method == "offers") {
            callback = onSeeOffers;
        }

        if(method == "newoffer") {
            callback = onOfferResource;
        }

        if(method == "setprices") {
            callback = setGameResourcePrices;
        }
        
        postSecuredCallToApi(data,9,callback);
    }

    function onOfferResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"newoffer");
    }

    function onSeeOffers(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"offers");
    }

    function onRequestResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"request");
    }

    function onBuyResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"buy");
    }

    function onSellResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"sell");
    }

    function onSendResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"send");
    }

    function setGameResourcePrices(result) {

        if(currentGame == null) {
            return;
        }

        var resources;

        if(result != null || result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                console.log(ex);
                return;
            }
        }

        if(resources == null || resources.resources == null) {
            return;
        }

        updateResourcePrices(resources);
    }

    function showTradeListing(result,method) {
        var resources;

        if(result != null || result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                console.log(ex);
                return;
            }
        }

        if(resources == null) {
            return;
        }

        var menuOptions = [];

        if(method == "send" || method == "request") {
            menuOptions.push({
                "title": ColonyGame.meta.tenderResource,
                "title-color": null,
                "description": null,
                "status": "You Have: " + numberWithCommas(currentGame.resources[ColonyGame.meta.tenderResource].amount),
                "status-color": null,
                "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
                "tag": "money"
            });
        }

        for(var i = 0; i < resources.resources.length; i++) {

            if(method == "send") {
                if(currentGame.resources[resources.resources[i].name].amount == 0) {
                    continue;
                }
            }

            if(resources.resources[i].price == 0) {
                resources.resources[i].price = currentGame.resources[resources.resources[i].name].price;
            }

            var status = "Last Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(resources.resources[i].price) + " per 100";
            var statusColor = null;

            if(method == "send" || method == "request") {
                status = "You Have: " + numberWithCommas(currentGame.resources[resources.resources[i].name].amount);
            }

            menuOptions.push({
                "title": resources.resources[i].name,
                "title-color": null,
                "description": null,
                "status": status,
                "status-color": statusColor,
                "icon": "images/" + getResourceByDefName(resources.resources[i].name).icon,
                "tag": resources.resources[i]
            });
        }

        var callback = onBuySelectedResourceType;

        if(method == "sell") {
            callback = doResourceContract;
        }

        if(method == "newoffer") {
            callback = doOfferContract;
        }

        if(method == "send") {
            callback = onSendResourceType;
        }

        if(method == "request") {
            callback = onRequestResourceType;
        }

        /*
        if(method == "offers") {
            callback = onOffersSelectedResourceType;
        }
        */

        showList(getString("select-resource"),menuOptions,callback,getString("general-nevermind"));
        
    }

    var pendingTradeResource = null;

    
    function tmpSaveResources() {

        if(currentGame.colonyId != 0) {
            var resHold = JSON.stringify(currentGame.resources);
            webAppCore.storeVar("pnd-trns-" + currentGame.colonyId + "-sve",resHold);
        }

    }
    
    function onOffersSelectedResourceType(resource) {
        pendingTradeResource = resource;

        var data = [];

        data.push({
            "key":      "r",
            "value":    pendingTradeResource.id
        });

        postSecuredCallToApi(data,22,showResourcesOnOffer);
    }

    function onBuySelectedResourceType(resource) {
        pendingTradeResource = resource;

        var data = [];

        data.push({
            "key":      "r",
            "value":    pendingTradeResource.id
        });

        postSecuredCallToApi(data,10,showResourcesForSale);
    }

    function showResourcesOnOffer(result) {

        if(currentGame == null) {
            return;
        }

        var resources;

        if(result != null || result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                console.log(ex);
                webAppCore.showToast(getString("no-contracts"));
                return;
            }
        }

        if(resources == null || pendingTradeResource == null) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        if(resources.contracts.length == 0) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < resources.contracts.length; i++) {
            var contract = resources.contracts[i];

            var unitPrice = parseInt(contract.price) / parseInt(contract.quantity);
            var hundredPrice = Math.round(unitPrice * 100);

            var priceColor = null;

            if(contract.quantity > currentGame.resources[pendingTradeResource.name].amount) {
                priceColor = "#F44336";
            }

            menuOptions.push({
                "title": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt(contract.price)),
                "title-color": null,
                "description": "Per 100: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(hundredPrice),
                "status": null,
                "status-color": null,
                "overflow": [
                    {
                        "pre":      "Total Price:",
                        "post":     numberWithCommas(parseInt(contract.quantity)),
                        "color":    priceColor,
                        "icon":     "images/" + getResourceByDefName(pendingTradeResource.name).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
                "tag": contract
            });
        }

        showList(getString("available-contracts"),menuOptions,purchaseOffer,getString("general-nevermind"));
    }

    function showResourcesForSale(result) {
        var resources;

        if(result != null || result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                console.log(ex);
                webAppCore.showToast(getString("no-contracts"));
                return;
            }
        }

        if(resources == null || pendingTradeResource == null) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        if(resources.contracts.length == 0) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < resources.contracts.length; i++) {
            var contract = resources.contracts[i];

            var unitPrice = parseInt(contract.price) / parseInt(contract.quantity);
            var hundredPrice = Math.round(unitPrice * 100);

            var priceColor = null;

            if(contract.price > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                priceColor = "#F44336";
            }

            menuOptions.push({
                "title": numberWithCommas(parseInt(contract.quantity)) + " " + pendingTradeResource.name,
                "title-color": null,
                "description": "Per 100: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(hundredPrice),
                "status": "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt(contract.price)),
                "status-color": priceColor,
                "icon": "images/" + getResourceByDefName(pendingTradeResource.name).icon,
                "tag": contract
            });
        }

        showList(getString("available-contracts"),menuOptions,purchaseContract,getString("general-nevermind"));
    }

    var pendingContract = null;

    function purchaseOffer(contract) {
        if(contract.quantity > currentGame.resources[pendingTradeResource.name].amount) {
            webAppCore.showToast("Insufficient " + pendingTradeResource.name + "!");
            return;
        }

        pendingContract = contract;

        var data = [];

        data.push({
            "key":      "a",
            "value":    pendingContract.id
        });

        data.push({
            "key":      "c",
            "value":    "1"
        });

        postSecuredCallToApi(data,41,onOfferPurchaseResult);
    }

    var pendingBadDealCard = null;

    function showBadDealAlert(tradeCard) {
        pendingBadDealCard = tradeCard;

        if(currentGame == null) {
            return;
        }

        webAppCore.showDialog({
            "title":    getString("general-bad-trade-header"),
            "message":  getString("general-bad-trade-notice"),
            "op1": {
                "text":     getString("general-yes"),
                "func":     continueWithStupidTrade
            },
            "op2": {
                "text":     getString("general-no"),
                "func":     placeholder
            }
        });
    }

    function continueWithStupidTrade() {
        if(pendingBadDealCard == null) {
            return;
        }

        var disapproval = randomIntFromInterval(0,3);
        doGlobalMoodModification(-disapproval);

        purchaseNewGBTContract(pendingBadDealCard);

        pendingBadDealCard = null;
    }

    var tickerTradeConfirmation = false;

    function tickerTradeConfirmGo() {
        purchaseNewGBTContract(pendingContract);
    }

    function purchaseNewGBTContract(tradeCard) {
        if(currentGame == null) {
            return;
        }

        if(contractPostTimeout > 0) {
            webAppCore.showAlertWithTitle(getString("general-trade-too-recent"),getString("general-trade-authority"));
            return;
        }
        

        pendingTradeResource = getResourceByServerId(tradeCard.contractRef.resourceid);

        if(tradeCard.contractRef.sellerid == currentGame.colonyId) {
            webAppCore.showToast("You cannot purchase your own contract.");
            return;
        }

        if(tradeCard.contractRef.isoffer == "1") {
            if(parseInt(tradeCard.contractRef.quantity) > currentGame.resources[pendingTradeResource.name].amount) {
                webAppCore.showToast("You do not have enough " + pendingTradeResource.name + " to fill this contract.");
                return;
            }
        } else {
            if(parseInt(tradeCard.contractRef.price) > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                webAppCore.showToast("You do not have enough " + ColonyGame.meta.tenderResource + " to buy this contract.");
                return;
            }

            if(!isThereResourceCapacity(pendingTradeResource.name,parseInt(tradeCard.contractRef.quantity))) {
                webAppCore.showAlertWithTitle("You do not have enough storage to buy this contract.","Storage Full");
                return;
            }
        }


        pendingContract = tradeCard;

        if(pendingContract.fromTicker && !tickerTradeConfirmation) {
            var hasConfirmedOption = webAppCore.getVar("knows-about-ticker-trades","0");

            if(hasConfirmedOption == "1") {
                tickerTradeConfirmation = true;
            } else {
                webAppCore.storeVar("knows-about-ticker-trades","1");

                webAppCore.showDialog({
                    "title":    getString("general-ticker-warn-head"),
                    "message":  getString("general-ticker-warn-info"),
                    "op1": {
                        "text":     getString("general-trade"),
                        "func":     tickerTradeConfirmGo
                    },
                    "op2": {
                        "text":     getString("general-cancel"),
                        "func":     placeholder
                    }
                });

                return;
            }
        }


        var data = [];

        data.push({
            "key":      "a",
            "value":    pendingContract.contractRef.id
        });

        data.push({
            "key":      "c",
            "value":    pendingContract.contractRef.isoffer
        });

        postSecuredCallToApi(data,41,onNewGBTContractPurchase);
    }

    function onNewGBTContractPurchase(result) {

        if(!pendingContract.fromTicker) {
            pendingContract.style.display = "none";
        }

        if(result == null || result.trim().length == 0) {
            webAppCore.showToast("This contract is no longer available.");

            if(!pendingContract.fromTicker) {
                populateNewGbtResources(pendingTradeResource);
            }
            return;
        }

        var resultdata = null;
        
        try {
            resultdata = JSON.parse(result);
        } catch(ex) {
            console.log(ex);
            console.log(result);
            return;
        }

        contractPostTimeout = 50;

        if(pendingContract.contractRef.isoffer == "1") {
            modifyResourceAmount(pendingTradeResource.name,-(parseInt(pendingContract.contractRef.quantity)),false,"Trade");
            modifyResourceAmount(ColonyGame.meta.tenderResource,parseInt(pendingContract.contractRef.price),false,"Trade");
        } else {
            modifyResourceAmount(pendingTradeResource.name,parseInt(pendingContract.contractRef.quantity),false,"Trade");
            modifyResourceAmount(ColonyGame.meta.tenderResource,-(parseInt(pendingContract.contractRef.price)),false,"Trade");
        }

        webAppCore.showToast("Contract Purchased.");

        if(allowAudio && ColonyGame.sounds.contractBuy != null) {
            webAppCore.playSoundEffect(ColonyGame.sounds.contractBuy);
        }

        if(ColonyGame.achievements.onlineTrade > 0) {
            webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
        }

        checkMyContracts();
        tmpSaveResources();

    }

    function purchaseContract(contract) {

        if(currentGame == null) {
            return;
        }

        if(contract.price > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            webAppCore.showToast("Insufficient Funds!");
            return;
        }

        pendingContract = contract;

        var data = [];

        data.push({
            "key":      "a",
            "value":    pendingContract.id
        });

        postSecuredCallToApi(data,41,onContractPurchaseResult);
    }

    function onOfferPurchaseResult(result) {
        console.log(result);

        if(result == null || result.trim().length == 0) {
            webAppCore.showToast("This contract is no longer available.");
            return;
        }

        var resultdata = null;

        try {
            resultdata = JSON.parse(result);
        } catch(ex) {
            console.log(ex);
            console.log(result);
            return;
        }

        

        console.log(resultdata);

        modifyResourceAmount(pendingTradeResource.name,-(parseInt(pendingContract.quantity)),false,"Trade");
        modifyResourceAmount(ColonyGame.meta.tenderResource,parseInt(pendingContract.price),false,"Trade");

        webAppCore.showToast("Contract Purchased.");

        if(ColonyGame.achievements.onlineTrade > 0) {
            webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
        }

        checkMyContracts();
        
        onOffersSelectedResourceType(pendingTradeResource);

        tmpSaveResources();
    }

    function onContractPurchaseResult(result) {
        console.log(result);

        if(result == null || result.trim().length == 0) {
            webAppCore.showToast("This contract is no longer available.");
            return;
        }

        var resultdata = null;
        
        try {
            resultdata = JSON.parse(result);
        } catch(ex) {
            console.log(ex);
            console.log(result);
            return;
        }

        

        console.log(resultdata);

        modifyResourceAmount(pendingTradeResource.name,parseInt(pendingContract.quantity),false,"Trade");
        modifyResourceAmount(ColonyGame.meta.tenderResource,-(parseInt(pendingContract.price)),false,"Trade");

        webAppCore.showToast("Contract Purchased.");

        if(ColonyGame.achievements.onlineTrade > 0) {
            webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
        }

        checkMyContracts();
        
        onBuySelectedResourceType(pendingTradeResource);

        tmpSaveResources();
    }

    function doResourceContract(resource) {
        onSellSelectedResourceType(resource,0);
    }

    function doOfferContract(resource) {
        onSellSelectedResourceType(resource,1);
    }

    var tmpAdditionalMax = 0;

    function onSellSelectedResourceType(resource,type) {


        tmpAdditionalMax = serverMaxTradeSize;

        if(type == 0) {
            document.getElementById("contractSubheading").innerHTML = getString("sell-amount");
        }

        if(type == 1) {
            document.getElementById("contractSubheading").innerHTML = getString("buy-amount");


            if(currentGame.resources[resource.name].capacity == -1) {
                tmpAdditionalMax = currentGame.resources[resource.name].storageCapacity - currentGame.resources[resource.name].amount;

                if(tmpAdditionalMax < 100) {
                    tmpAdditionalMax = 100;
                }
            }
        }

        pendingTradeResource = resource;

        document.getElementById("resourceContractTransactionCost").innerHTML = "";
        document.getElementById("resourceContractTransactionCost").style.color = null;

        if(ColonyGame.meta.transactionCostResource != null) {
            var theTimes = parseInt(document.getElementById("resourceContractQuantity").value) / 10;

            if(theTimes < 100) {
                theTimes = 100;
            }

            document.getElementById("resourceContractTransactionCost").innerHTML = "Transaction Fee: " + numberWithCommas(theTimes) + " " + ColonyGame.meta.transactionCostResource;

            if(theTimes > currentGame.resources[ColonyGame.meta.transactionCostResource].amount) {
                document.getElementById("resourceContractTransactionCost").style.color = "#F44336";
            } else {
                document.getElementById("resourceContractTransactionCost").style.color = null;
            }
        }

        document.getElementById("resourceContractMenu").style.display = "block";
        document.getElementById("multiplesNotice").style.color = "#ffffff";
        document.getElementById("resourceContractHeader").innerHTML = "New " + pendingTradeResource.name + " Contract";

        document.getElementById("resourceContractQuantity").onchange = function() {

            var maxTradeSize = serverMaxTradeSize;
            
            if(maxTradeSize > giftCapacity) {
                maxTradeSize = giftCapacity;
            }


            if(maxTradeSize > tmpAdditionalMax) {
                maxTradeSize = tmpAdditionalMax;
            }
            

            var tradeQuantity = parseInt(document.getElementById("resourceContractQuantity").value);

            if(tradeQuantity < 100) {
                tradeQuantity = 100;
                document.getElementById("resourceContractQuantity").value = 100;
            }

            if(tradeQuantity > maxTradeSize) {
                tradeQuantity = maxTradeSize;
                document.getElementById("resourceContractQuantity").value = maxTradeSize;
            }

            var remainder = tradeQuantity % 100;
            if(remainder == 0) {
                document.getElementById("multiplesNotice").style.color = "#ffffff";


                var unitPrice = document.getElementById("resourceContractPrice").value / 100;
                var totalPrice = Math.round(unitPrice * tradeQuantity);

                if(ColonyGame.meta.transactionCostResource != null) {
                    var theTimes = tradeQuantity / 10;

                    if(theTimes < 100) {
                        theTimes = 100;
                    }

                    document.getElementById("resourceContractTransactionCost").innerHTML = "Transaction Fee: " + numberWithCommas(theTimes) + " " + ColonyGame.meta.transactionCostResource;

                    if(theTimes > currentGame.resources[ColonyGame.meta.transactionCostResource].amount) {
                        document.getElementById("resourceContractTransactionCost").style.color = "#F44336";
                    } else {
                        document.getElementById("resourceContractTransactionCost").style.color = null;
                    }
                }

                document.getElementById("resourceContractPer100").innerHTML = "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPrice);

                
            } else {
                document.getElementById("multiplesNotice").style.color = "#F44336";
            }
        };
        
        document.getElementById("resourceContractPrice").onchange = function() {
            var unitPrice = document.getElementById("resourceContractPrice").value / 100;
            var totalPrice = Math.round(unitPrice * document.getElementById("resourceContractQuantity").value);

            

            document.getElementById("resourceContractPer100").innerHTML = "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPrice);
        };

        document.getElementById("btnResourceContractSumbit").onclick = function() {

            if(contractPostTimeout > 0) {
                
                webAppCore.showAlertWithTitle(getString("general-trade-too-recent"),getString("general-trade-authority"));

                return;
            }


            if(isNaN(document.getElementById("resourceContractPrice").value)) {
                return;
            }

            if(isNaN(document.getElementById("resourceContractQuantity").value)) {
                return;
            }

            var remainder = document.getElementById("resourceContractQuantity").value % 100;

            if(remainder != 0) {
                return;
            }

            if(document.getElementById("resourceContractPrice").value <= 0) {
                return;
            }

            if(document.getElementById("resourceContractQuantity").value <= 0) {
                return;
            }

            var maxTradeSize = serverMaxTradeSize;

            if(maxTradeSize > giftCapacity) {
                maxTradeSize = giftCapacity;
            }

            var tradeQuantity = parseInt(document.getElementById("resourceContractQuantity").value);

            if(tradeQuantity < 1) {
                webAppCore.showToast("Invalid Trade!");
                return;
            }

            if(tradeQuantity > maxTradeSize) {
                var errorcode = getString("general-trade-too-big");
                errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(maxTradeSize));
                webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                return;
            }

            var theTimes = 0;

            if(ColonyGame.meta.transactionCostResource != null) {

                theTimes = tradeQuantity / 10;

                if(theTimes < 100) {
                    theTimes = 100;
                }

                if(theTimes > currentGame.resources[ColonyGame.meta.transactionCostResource].amount) {
                    webAppCore.showToast("Not enough " + ColonyGame.meta.transactionCostResource + "!");
                    return;
                }
            }

            var unitPrice = document.getElementById("resourceContractPrice").value / 100;
            var totalPrice = Math.round(unitPrice * document.getElementById("resourceContractQuantity").value);

            if(type == 0) {
                if(currentGame.resources[pendingTradeResource.name].amount < tradeQuantity) {
                    webAppCore.showToast("Not enough resource!");
                    return;
                }
            } else {
                if(currentGame.resources[ColonyGame.meta.tenderResource].amount < totalPrice) {
                    webAppCore.showToast("Not enough money!");
                    return;
                }
            }
            

            if(theTimes > 0) {
                modifyResourceAmount(ColonyGame.meta.transactionCostResource,-theTimes,false,"Trade");
            }

            if(type == 0) {
                modifyResourceAmount(pendingTradeResource.name,-tradeQuantity,false,"Trade");

            } else {
                modifyResourceAmount(ColonyGame.meta.tenderResource,-totalPrice,false,"Trade");

            }

            contractPostTimeout = 75;

            var data = [];

            data.push({
                "key":      "r",
                "value":    pendingTradeResource.id
            });

            data.push({
                "key":      "q",
                "value":    document.getElementById("resourceContractQuantity").value
            });

            data.push({
                "key":      "p",
                "value":    totalPrice
            });

            data.push({
                "key":      "c",
                "value":    type
            });

            postSecuredCallToApi(data,11,onGBTTradePosted);

            webAppCore.showToast("Trade Submitted");

            if(ColonyGame.achievements.onlineTrade > 0) {
                webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
            }

            document.getElementById("resourceContractMenu").style.display = "none";

            tmpSaveResources();

        };

        document.getElementById("btnResourceContractDismiss").onclick = function() {
            document.getElementById("resourceContractMenu").style.display = "none";
        };

        document.getElementById("resourceContractQuantity").value = 100;
        document.getElementById("resourceContractPrice").value = pendingTradeResource.price;

        document.getElementById("resourceContractPer100").innerHTML = "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(pendingTradeResource.price);
    }

    function onGBTTradePosted(result) {

        if(result != null && result.trim().length > 0) {
            try {
                var resultData = JSON.parse(result);

                var errorcode;

                if(resultData.result && resultData.result == "fail") {
                    if(resultData.reason && resultData.reason == "toobig") {
                        errorcode = getString("general-trade-too-big");
                        errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(parseInt(resultData.max)));
                        webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                        serverMaxTradeSize = parseInt(resultData.max);
                    }

                    if(resultData.reason && resultData.reason == "pricegouge") {
                        errorcode = getString("general-trade-gouging");
                        errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(parseInt(resultData.max)));
                        webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                    }

                    if(resultData.reason && resultData.reason == "undercut") {
                        errorcode = getString("general-trade-undercut");
                        errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(parseInt(resultData.max)));
                        webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                    }
                }


            } catch(ex) {
                console.log(ex);
                return;
            }
        }

        populateNewGbtResources(pendingTradeResource);
        checkMyContracts();
    }

    function checkMyContracts() {

        if(currentGame == null || !currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,14,onContractReturn);
    }

    function onContractReturn(result) {

        if(currentGame == null) {
            return;
        }

        var contracts;
       

        if(result != null && result.trim().length > 0) {
            try {
                contracts = JSON.parse(result);
            } catch(ex) {
                return;
            }
        }

        if(!contracts.contracts) {
            return;
        }

        if(!currentGame.gifts) {
            currentGame.gifts = [];
        }
        

        for(var i = 0; i < contracts.contracts.length; i++) {
            var contract = contracts.contracts[i];

            if(contract.type == 0) {
                if(contract.sold == "1") {
                    currentGame.gifts.push(new Gift("Sold Contract","Your " + contract.resource + " contract sold!",ColonyGame.meta.tenderResource,parseInt(contract.price)));
                } else {
                    currentGame.gifts.push(new Gift("Expired Contract","Your " + contract.resource + " contract did not sell.",contract.resource,parseInt(contract.quantity)));
                }
            }

            if(contract.type == 1) {
                if(contract.sold == "1") {
                    currentGame.gifts.push(new Gift("Sold Offer","Your " + contract.resource + " offer sold!",contract.resource,parseInt(contract.quantity)));
                } else {
                    currentGame.gifts.push(new Gift("Expired Offer","Your " + contract.resource + " offer did not sell.",ColonyGame.meta.tenderResource,parseInt(contract.price)));
                }
            }
        }

        if(currentGame.gifts.length > 0) {
            webAppCore.showToast("New gifts available!");
            document.getElementById("imGift").style.display = "inline-block";
        }
    }

    function showEncyclopedia() {
        var menuOptions = [];

        menuOptions.push({
            "title": getString("resources-header"),
            "title-color": null,
            "description": getString("enc-resources-desc"),
            "status": "可用资源: " + numberWithCommas(ColonyGame.resources.length),
            "status-color": null,
            "icon": "images/" + ColonyGame.resources[randomIntFromInterval(0,ColonyGame.resources.length - 1)].icon,
            "tag": "resources"
        });

        menuOptions.push({
            "title": getString("enc-tech-header"),
            "title-color": null,
            "description": getString("enc-tech-desc"),
            "status":"可用技术: " + numberWithCommas(ColonyGame.technology.length),
            "status-color": null,
            "icon": "images/" + ColonyGame.technology[randomIntFromInterval(0,ColonyGame.technology.length - 1)].icon,
            "tag": "techs"
        });

        var bld = ColonyGame.buildings[randomIntFromInterval(0,ColonyGame.buildings.length - 1)];

        var img;
        
        if(bld.indicator == null) {
            img = gameAssets[bld.tile[0]][0].image.src;
        } else {
            img = "images/" + bld.indicator;
        }

        menuOptions.push({
            "title": getString("general-buildings"),
            "title-color": null,
            "description": getString("enc-buildings-desc"),
            "status": "可用的结构: " + numberWithCommas(ColonyGame.buildings.length),
            "status-color": null,
            "icon": img,
            "tag": "buildings"
        });

        menuOptions.push({
            "title": getString("general-vehicles"),
            "title-color": null,
            "description": getString("enc-vehicles-desc"),
            "status": "可用的 " + getString("general-vehicles") + ": " + numberWithCommas(ColonyGame.vehicles.length),
            "status-color": null,
            "icon": "images/" + ColonyGame.vehicles[randomIntFromInterval(0,ColonyGame.vehicles.length - 1)].indicator,
            "tag": "vehicles"
        });

        if(!webAppCore.isTV() && ColonyGame.meta.videoTutorialsIndicator != null && ColonyGame.videoTutorials.length > 0) {
            menuOptions.push({
                "title": getString("general-vidtut-header"),
                "title-color": null,
                "description": getString("general-vidtut-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.videoTutorialsIndicator,
                "tag": "videotutorials"
            });
        }


        if(!webAppCore.isTV()) {

            if(ColonyGame.meta.extraReferenceUrl != null) {
                menuOptions.push({
                    "title": ColonyGame.meta.extraReferenceName,
                    "title-color": null,
                    "description": ColonyGame.meta.extraReferenceDisclaimer,
                    "status": ColonyGame.meta.extraReferenceUrl,
                    "status-color": "#1976D2",
                    "icon": "images/" + ColonyGame.meta.extraReferenceIcon,
                    "tag": "extrareference"
                });
            }


            if(ColonyGame.meta.referenceLink != null) {
                menuOptions.push({
                    "title": getString("enc-online-header"),
                    "title-color": null,
                    "description": getString("enc-online-desc"),
                    "status": ColonyGame.meta.referenceLink,
                    "status-color": "#1976D2",
                    "icon": "images/" + ColonyGame.meta.websiteIndicator,
                    "tag": "reference"
                });
            }

            

            menuOptions.push({
                "title": getString("enc-print-header"),
                "title-color": null,
                "description": getString("enc-print-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.printInd,
                "tag": "print"
            });
        }

        showList(getString("general-encyclopedia"),menuOptions,onEncyclopediaOptionSelected,getString("general-dismiss"));
    }

    var tmpEncTag;

    function onEncyclopediaOptionSelected(tag) {
        tmpEncTag = tag;
        setTimeout(onEncyclopediaOptionSelectedTimeout,75);
    }

    function onEncyclopediaOptionSelectedTimeout() {

        if(tmpEncTag == "videotutorials") {
            loadVideoTutorials();
        }

        if(tmpEncTag == "print") {
            generatePrintoutEncyclopedia();
        }

        if(tmpEncTag == "reference") {
            webAppCore.externalURL(ColonyGame.meta.referenceLink);
        }

        if(tmpEncTag == "extrareference") {
            webAppCore.externalURL(ColonyGame.meta.extraReferenceUrl);
        }

        

        if(tmpEncTag == "techs") {
            showTechEncyclopedia();
        }

        if(tmpEncTag == "resources") {
            showResource();
        }

        if(tmpEncTag == "buildings") {
            showBuildingsEncyclopedia();
        }

        if(tmpEncTag == "vehicles") {
            showVehiclesEncyclopedia();
        }
    }

    var getKeyClearAfter = false;

    function getKeyThenUpdateStats(clearSplashAfter) {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(currentGame.offlineMode) {
            return;
        }

        if(currentGame.colonyId == 0) {
            return;
        }

        if(!clearSplashAfter) {
            clearSplashAfter = false;
        }

        getKeyClearAfter = clearSplashAfter;

        var data = [];

        data.push({
            "key":      "f",
            "value":    33
        });

        data.push({
            "key":      "i",
            "value":    currentGame.colonyId
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, setApiKeyThenUpdate);
    }

    function setApiKeyThenUpdate(result) {
        if(result != null && result.trim().length > 0) {
            currentGame.apiKey = result;
            console.log(result);
            updateColonyStats(getKeyClearAfter);
        }
    }

    var updateStatsClearAfter = false;

    function updateColonyStats(clearSplashAfter) {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(currentGame.offlineMode) {
            return;
        }

        if(currentGame.colonyId == 0) {
            return;
        }

        if(!clearSplashAfter) {
            clearSplashAfter = false;
        }

        if(currentGame.apiKey == 0) {
            getKeyThenUpdateStats(clearSplashAfter);
            return;
        }

        updateStatsClearAfter = clearSplashAfter;

        var i;

        var totalGDP = currentGame.historicStats.gdp[currentGame.historicStats.gdp.length - 1];

        var gdpPercapita = Math.round(totalGDP / getTotalPopulation());

        var unemployedPercent = currentGame.historicStats.unemployment[currentGame.historicStats.unemployment.length - 1];

        var indOpt = "0";

        var charterOption = "1";

        if(currentGame.privateCharter) {
            charterOption = "0";
        }

        if(currentGame.isIndependent) {
            indOpt = "1";
        }

        var data = [];

        data.push({
            "key":      "gdp",
            "value":    totalGDP
        });

        data.push({
            "key":      "percap",
            "value":    gdpPercapita
        });

        data.push({
            "key":      "pop",
            "value":    getTotalPopulation()
        });

        data.push({
            "key":      "isInd",
            "value":    indOpt
        });

        data.push({
            "key":      "unem",
            "value":    unemployedPercent
        });

        data.push({
            "key":      "stage",
            "value":    currentGame.stage
        });

        data.push({
            "key":      "relations",
            "value":    currentGame.earthAssemblyRelations
        });

        data.push({
            "key":      "founding",
            "value":    dateToReadable(currentGame.creationDate)
        });

        if(currentGame.isIndependent) {
            data.push({
                "key":      "independence",
                "value":    dateToReadable(currentGame.independenceDay)
            });
        } else {
            data.push({
                "key":      "independence",
                "value":    "0"
            });
        }

        data.push({
            "key":      "color",
            "value":    currentGame.themeColor
        });

        data.push({
            "key":      "colname",
            "value":    replaceAll(currentGame.name, "'", "")
        });

        if(webAppCore.getPlatform().platform == "desktop") {
            data.push({
                "key":      "platform",
                "value":    webAppCore.getPlatform().platform + "." + webAppCore.getPlatform().os
            });
        } else {
            data.push({
                "key":      "platform",
                "value":    webAppCore.getPlatform().platform + "." + webAppCore.getPlatform().market
            });
        }
        

        if(currentGame.civilization === undefined) {
            currentGame.civilization = ColonyGame.civilizations[0].name;
        }

        data.push({
            "key":      "civ",
            "value":    currentGame.civilization
        });

        data.push({
            "key":      "race",
            "value":    currentGame.defaultRace
        });

        data.push({
            "key":      "map",
            "value":    currentGame.mapType
        });

        data.push({
            "key":      "pc",
            "value":    charterOption
        });

        data.push({
            "key":      "pay",
            "value":    Math.round(currentGame.payrollRate * 100)
        });

        data.push({
            "key":      "tl",
            "value":    currentGame.taxLevel
        });


        var resObj = {};

        for(var prop in currentGame.resources) {
            resObj[prop] = currentGame.resources[prop].amount;
        }

        var resHold = btoa(JSON.stringify(resObj));

        data.push({
            "key":      "svres",
            "value":    resHold
        });

        var cloudSaveLocation = "0";

        if(currentGame.useCloud && currentFileName) {
            cloudSaveLocation = replaceAll(webAppCore.buildCloudSharePathForFile(currentFileName),"/","_") + "/";
        }

        data.push({
            "key":      "cp",
            "value":    cloudSaveLocation
        });

        data.push({
            "key":      "sp",
            "value":    currentGame.salesPitch
        });

        postSecuredCallToApi(data,15,getParentIfNeeded);
    }

    function getParentIfNeeded(retdat) {

        console.log(retdat);

        if(currentGame == null || currentGame.isIndependent || currentGame.motherlandid == 0 || currentGame.offlineMode) {

            if(updateStatsClearAfter) {
                updateStatsClearAfter = false;

                if(currentGame != null) {
                    webAppCore.clearSplash();
                }

                colonyNeverLoaded = false;
            }

            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    24
        });

        data.push({
            "key":      "i",
            "value":    currentGame.motherlandid
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, setNeededParentStats);
    }

    function setNeededParentStats(result) {

        if(currentGame == null) {
            colonyNeverLoaded = false;
            return;
        }

        if(updateStatsClearAfter) {
            updateStatsClearAfter = false;
            colonyNeverLoaded = false;
            webAppCore.clearSplash();
        }

        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    return;
                }

                var payRateWhole = parseInt(colonyInfo.payrolllevel);
                currentGame.payrollRate = payRateWhole / 100;

                var taxRateWhole = parseInt(colonyInfo.taxlevel);
                currentGame.taxLevel = taxRateWhole;

            } catch(ex) {
                console.log(ex);
            }
        }
    }

    function showWebsiteEditor() {
        var menuOptions = [];

        menuOptions.push({
            "title": "View Website",
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "view"
        });

        menuOptions.push({
            "title": "Share Link",
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "share"
        });

        menuOptions.push({
            "title": "Change Theme",
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "theme"
        });

        menuOptions.push({
            "title": "Upload Screenshot",
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "screenshot"
        });

        showList(getString("colonial-website"),menuOptions,onWebsiteOptionSelected,getString("general-dismiss"));
    }

    function onWebsiteOptionSelected(tag) {

        if(currentGame == null) {
            return;
        }

        if(tag == "theme") {
            webAppCore.pickColor(onColorBack,currentGame.themeColor);
        }

        if(tag == "view") {
            webAppCore.externalURL(ColonyGame.meta.colonyServerBase + currentGame.charter + "/");
        }

        if(tag == "share") {
            webAppCore.nativeShare("Check out my colony: " + ColonyGame.meta.colonyServerBase  + currentGame.charter + "/");
        }

        if(tag == "screenshot") {
            Scroll2d.takeScreenshot(onScreenshotForWebsite);
        }
    }

    function onScreenshotForWebsite(canvas) {
        var imgData = canvas.toDataURL("image/jpeg",0.75);
        var sendData = imgData.replace("data:image/jpeg;base64,","");

        if(currentGame == null || !currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "img",
            "value":    sendData
        });


        postSecuredCallToApi(data,16,onScreenshotUploadBack);

    }

    function onScreenshotUploadBack() {

        webAppCore.showToast("Screenshot Saved");

        var sssrc = "url('" + ColonyGame.meta.colonyServerBase.replace("colonies","screenshots") + "/ss-" + currentGame.colonyId + ".jpg?z=" + randomIntFromInterval(0,5000) + "')";
        document.getElementById("statOverviewScreenshotSection").style.backgroundImage = sssrc;


    }

    function onColorBack(color) {

        if(color == null) {
            return;
        }

        document.getElementById("statOverviewColonialColor").style.color = color;

        currentGame.themeColor = color;

        updateColonyStats();

        webAppCore.showToast("Theme Updated");

    }

    var pendingTextBuilding = null;

    function setBuildingText(building) {
        pendingTextBuilding = building;

        var dialogOptions = {
            title: building.name,
            message: "Current: " + building.customText,
            func: onBuildingTextBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onBuildingTextBack(text) {
        if(text == null) {
            return;
        }

        if(pendingTextBuilding == null) {
            return;
        }

        pendingTextBuilding.customText = text.trim().latinize();
        pendingTextBuilding = null;

        if(allowAudio) {
            webAppCore.say(text);
        }
    }

    function renameColony() {

        var dialogOptions = {
            title: getString("rename-colony"),
            message: getString("rename-desc"),
            func: onRenameBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onRenameBack(result) {
        if(result == null || result.trim().length == 0) {
            return;
        }

        var oldName = currentGame.name;
        var newName = result.trim().latinize();
        newName = replaceAll(newName, "\\", "");

        if(oldName == newName) {
            return;
        }

        currentGame.name = newName;

        postMessageToAllChannels(oldName + " was renamed to " + newName);

        document.getElementById("statOverviewColonyName").innerHTML = currentGame.name;

        updateColonyStats();
    }

    function showTechEncyclopedia() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.technology.length; i++) {

            var cost = [];
            var j;

            for(j = 0; j < ColonyGame.technology[i].cost.length; j++) {
                cost.push({
                    pre:    "花费:",
                    post:   numberWithCommas(ColonyGame.technology[i].cost[j].amount),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.technology[i].cost[j].resource).icon
                });
            }

            if(ColonyGame.technology[i].requiresTech != null) {
                for(j = 0; j < ColonyGame.technology[i].requiresTech.length; j++) {
                    cost.push({
                        pre:    "Requires ",
                        post:   replaceAll(ColonyGame.technology[i].requiresTech[j],"|"," or "),
                        color:  null,
                        icon:   null
                    });
                }
            }

            if(ColonyGame.technology[i].requiresStage < 99) {
                if(ColonyGame.meta.gameStages[ColonyGame.technology[i].requiresStage].threshold > 0) {
                    cost.push({
                        pre:    "需要 ",
                        post:   numberWithCommas(ColonyGame.meta.gameStages[ColonyGame.technology[i].requiresStage].threshold),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.gameStageResource).icon
                    });
                }
            }

            if(ColonyGame.technology[i].reqIndependence) {
                cost.push({
                    pre:    "Requires Independence",
                    post:   null,
                    color:  null,
                    icon:   null
                });
            }

            menuOptions.push({
                "title": ColonyGame.technology[i].name,
                "title-color": null,
                "description": getString(ColonyGame.technology[i].description),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.technology[i].icon,
                "overflow": cost,
                "tag": null
            });
        }

        showList("技术",menuOptions,showEncyclopedia,getString("general-dismiss"));
    }

    function showResource() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.resources.length; i++) {
            var res = ColonyGame.resources[i];
            var cost = [];
            var j;

            for(j = 0; j < ColonyGame.terrains.length; j++) {
                if(ColonyGame.terrains[j].provides == res.name) {
                    cost.push({
                        pre:    "来自",
                        post:   ColonyGame.terrains[j].name,
                        color:  null,
                        icon:   "images/" + ColonyGame.terrains[j].icon
                    });
                }
            }


            for(j = 0; j < ColonyGame.buildings.length; j++) {

                var img;
                
                img = gameAssets[ColonyGame.buildings[j].tile[0]][0].image.src;


                if(ColonyGame.buildings[j].generates == res.name) {
                    
                    cost.push({
                        pre:    "来自",
                        post:   ColonyGame.buildings[j].name,
                        color:  null,
                        icon:   img
                    });
                }

                if(ColonyGame.buildings[j].smelts != null && ColonyGame.buildings[j].smelts.output == res.name) {
                    cost.push({
                        pre:    "来自",
                        post:   ColonyGame.buildings[j].name,
                        color:  null,
                        icon:   img
                    });
                }
            }

            menuOptions.push({
                "title": res.name,
                "title-color": null,
                "description": null,
                "status": res.indicator,
                "status-color": res.color,
                "icon": "images/" + res.icon,
                "overflow": cost,
                "tag": null
            });
        }

        showList("资源",menuOptions,showEncyclopedia,getString("general-dismiss"));
    }

    function showBuildingsEncyclopedia() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.buildings.length; i++) {
            var res = ColonyGame.buildings[i];
            var cost = [];
            var j;

            if(res.cost != null) {
                for(j = 0; j < res.cost.length; j++) {
                    cost.push({
                        pre:    "花费:",
                        post:   numberWithCommas(res.cost[j].amount),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(res.cost[j].resource).icon
                    });
                }
            }

            if(res.requiresTech != null) {
                for(j = 0; j < res.requiresTech.length; j++) {
                    cost.push({
                        pre:    "Requires: ",
                        post:   replaceAll(res.requiresTech[j],"|"," or "),
                        color:  null,
                        icon:   null
                    });
                }
            }

            if(ColonyGame.meta.gameStages[res.requiresStage].threshold > 0) {
                cost.push({
                    pre:    "需要:",
                    post:   numberWithCommas(ColonyGame.meta.gameStages[res.requiresStage].threshold),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.meta.gameStageResource).icon
                });
            }

            if(res.reqIndependence) {
                cost.push({
                    pre:    "Requires Independence",
                    post:   null,
                    color:  null,
                    icon:   null
                });
            }

            if(res.produces != null) {
                for(j = 0; j < res.produces.length; j++) {
                    cost.push({
                        pre:    "可以建造:",
                        post:   res.produces[j],
                        color:  null,
                        icon:   "images/" + getVehicleDefByName(res.produces[j]).indicator
                    });
                }
            }

            if(res.stores != null) {
                for(j = 0; j < res.stores.length; j++) {
                    cost.push({
                        pre:    "商店:",
                        post:   numberWithCommas(res.stores[j].amount),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(res.stores[j].resource).icon
                    });
                }
            }

            if(res.refines != null) {
                for(j = 0; j < res.refines.length; j++) {
                    cost.push({
                        pre:    "提炼:",
                        post:   res.refines[j].input,
                        color:  null,
                        icon:   "images/" + getResourceByDefName(res.refines[j].input).icon
                    });
                }
            }

            if(res.requiresUtility != null) {
                for(j = 0; j < res.requiresUtility.length; j++) {
                    cost.push({
                        pre:    "需要:",
                        post:   numberWithCommas(res.requiresUtility[j].amount),
                        color:  null,
                        icon:   "images/" + getUtilityByDefName(res.requiresUtility[j].utility).icon
                    });
                }
            }

            if(res.providesUtility != null) {
                for(j = 0; j < res.providesUtility.length; j++) {
                    cost.push({
                        pre:    "生成:",
                        post:   numberWithCommas(res.providesUtility[j].amount),
                        color:  null,
                        icon:   "images/" + getUtilityByDefName(res.providesUtility[j].utility).icon
                    });
                }
            }

            if(res.acceptsWorkers > 0) {
                cost.push({
                    pre:    "工人:",
                    post:   numberWithCommas(res.acceptsWorkers),
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.colonistIcon
                });
            }

            for(j = 0; j < ColonyGame.vehicles.length; j++) {
                if(ColonyGame.vehicles[j].produces != null && ColonyGame.vehicles[j].produces.indexOf(res.name) > -1) {
                    cost.push({
                        pre:    "建造工具:",
                        post:   ColonyGame.vehicles[j].name,
                        color:  null,
                        icon:   "images/" + ColonyGame.vehicles[j].indicator
                    });
                }
            }

            var img;

            if(res.indicator == null) {
                img = gameAssets[res.tile[0]][0].image.src;
            } else {
                img = "images/" + res.indicator;
            }

            menuOptions.push({
                "title": res.name,
                "title-color": null,
                "description": getString(res.description),
                "status": null,
                "status-color": null,
                "icon": img,
                "overflow": cost,
                "tag": null
            });
        }

        showList("建筑",menuOptions,showEncyclopedia,getString("general-dismiss"));
    }

    function showVehiclesEncyclopedia() {
        var menuOptions = [];

        var j;

        for(var i = 0; i < ColonyGame.vehicles.length; i++) {
            var res = ColonyGame.vehicles[i];
            var cost = [];

            
            if(res.cost != null) {
                for(j = 0; j < res.cost.length; j++) {
                    cost.push({
                        pre:    "花费:",
                        post:   numberWithCommas(res.cost[j].amount),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(res.cost[j].resource).icon
                    });
                }
            }

            if(res.requiresTech != null) {
                for(j = 0; j < res.requiresTech.length; j++) {
                    cost.push({
                        pre:    "需要: ",
                        post:   replaceAll(res.requiresTech[j],"|"," or "),
                        color:  null,
                        icon:   null
                    });
                }
            }

            if(ColonyGame.meta.gameStages[res.requiresStage].threshold > 0) {
                cost.push({
                    pre:    "需要:",
                    post:   numberWithCommas(ColonyGame.meta.gameStages[res.requiresStage].threshold),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.meta.gameStageResource).icon
                });
            }

            if(res.produces != null) {
                for(j = 0; j < res.produces.length; j++) {
                    cost.push({
                        pre:    "可以建造",
                        post:   res.produces[j],
                        color:  null,
                        icon:   gameAssets[getBuildingDefByName(res.produces[j]).tile[0]][0].image.src
                    });
                }
            }

            if(res.harvests != null) {
                cost.push({
                    pre:    "Can Harvest:",
                    post:   res.harvests,
                    color:  null,
                    icon:   "images/" + getResourceByDefName(res.harvests).icon
                });
            }

            menuOptions.push({
                "title": res.name,
                "title-color": null,
                "description": getString(res.description),
                "status": null,
                "status-color": null,
                "icon": "images/" + res.indicator,
                "overflow": cost,
                "tag": null
            });
        }

        showList("Vehicles",menuOptions,showEncyclopedia,getString("general-dismiss"));
    }

    function showMail() {

        if(currentGame.readOnlyMode) {
            return;
        }

        tmpHoldingMessage = null;

        if(currentGame.mail == null || currentGame.mail.length == 0) {
            webAppCore.showToast("No mail!");
            document.getElementById("imMail").style.display = "none";
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < currentGame.mail.length; i++) {

            var read = "Unread";
            var unreadColor = "";

            if(currentGame.mail[i].read) {
                read = "Read";
                unreadColor = null;
            }

            var mailImage = "images/" + ColonyGame.meta.mailIndicator;

            if(currentGame.mail[i].code == "7" || currentGame.mail[i].code == "8") {
                mailImage = "images/" + ColonyGame.meta.empireIndicator;
            }

            menuOptions.push({
                "title": "From: " + currentGame.mail[i].from,
                "title-color": null,
                "description": currentGame.mail[i].time,
                "status": read,
                "status-color": unreadColor,
                "icon": mailImage,
                "tag": currentGame.mail[i]
            });
        }

        if(menuOptions.length == 0) {
            return;
        }

        showList("Inbox",menuOptions,onMailMessageOpened,"Nevermind");
    }

    function checkMail() {

        if(currentGame == null || !currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        if(currentGame.readOnlyMode) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,18,onMailReturn);

    }

    function MailMessage(from,fromid,message,time,code,resource,amount) {
        this.from = from;
        this.fromid = fromid;
        this.message = message;
        this.time = time;
        this.code = code;
        this.resource = resource;
        this.amount = amount;
        this.read = false;
        this.reported = false;
    }

    function reopenMailIfAny() {

        if(currentGame == null) {
            return;
        }

        if(currentGame.mail.length > 0) {
            showMail();
        }
    }

    function onMailReturn(result) {

        if(currentGame == null) {
            return;
        }

        if(currentGame.readOnlyMode) {
            return;
        }

        var contracts;
       

        if(result != null && result.trim().length > 0) {
            try {
                contracts = JSON.parse(result);
            } catch(ex) {
                console.log(ex);
                console.log(result);
                return;
            }
        }

        if(!contracts.mail) {
            return;
        }

        if(!currentGame.mail) {
            currentGame.mail = [];
        }

        var payrollGroup = {};

        for(var i = 0; i < contracts.mail.length; i++) {
            var message = contracts.mail[i];

            message.message = message.message.trim().latinize();

            // regular mail or annex request
            if(message.code == "0" || message.code == "6" || message.code == "7" || message.code == "8") {
                currentGame.mail.push(new MailMessage(message.from,message.fromid,message.message,message.time,message.code,message.resource,message.amount));

                if(message.code == "8") {
                    completeParentSwitch(message);
                }
            }

            // this is a contract sale 
            if(message.code == "1") {
                currentGame.gifts.push(new Gift("Sold Contract","Your " + message.resource + " contract sold!",ColonyGame.meta.tenderResource,parseInt(message.amount)));
            }

            // payroll obligation inform
            if(message.code == "2" || message.code == "5") {
                if(message.code == "2") {
                    if(!payrollGroup[message.fromid]) {
                        payrollGroup[message.fromid] = {
                            "from": message.from,
                            "fromid": message.fromid,
                            "message": message.message,
                            "time": message.time,
                            "code": message.code,
                            "resource": message.resource,
                            "amount": 0
                        };
                    }

                    payrollGroup[message.fromid].amount += parseInt(message.amount);
                } else {
                    currentGame.mail.push(new MailMessage(message.from,message.fromid,message.message,message.time,message.code,message.resource,message.amount));
                }
            }

            // payroll reciept
            if(message.code == "3") {
                currentGame.gifts.push(new Gift("Payroll Assistance from " + message.from,message.message,ColonyGame.meta.tenderResource,parseInt(message.amount)));
            }

            // gift reciept
            if(message.code == "4") {
                if(message.resource == "NULL" || message.resource == "") {
                    message.resource = ColonyGame.meta.tenderResource;
                }
                currentGame.gifts.push(new Gift("Gift from " + message.from,message.message,message.resource,parseInt(message.amount)));
            }
        }

        var totalAutoPaid = 0;

        for(var payee in payrollGroup) {

            if(currentGame.autoBudget && parseInt(payrollGroup[payee].amount) < currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                modifyResourceAmount(ColonyGame.meta.tenderResource,-parseInt(payrollGroup[payee].amount),false,"Commonwealth");
                sendMessage(payrollGroup[payee].fromid,3,parseInt(payrollGroup[payee].amount),"Shared payroll payment from " + currentGame.name + ".",placeholder);
                totalAutoPaid += parseInt(payrollGroup[payee].amount);
                currentGame.foreignPayrollTotals += parseInt(payrollGroup[payee].amount);
            } else {
                currentGame.mail.push(new MailMessage(payrollGroup[payee].from,payrollGroup[payee].fromid,payrollGroup[payee].message,payrollGroup[payee].time,payrollGroup[payee].code,payrollGroup[payee].resource,payrollGroup[payee].amount));
            }

            
        }

        if(totalAutoPaid > 0) {
            webAppCore.showToast("You paid " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalAutoPaid) + " in shared payroll obligations!");
        }

        if(currentGame.gifts.length > 0) {
            webAppCore.showToast("New gifts available!");
            document.getElementById("imGift").style.display = "inline-block";
        }

        if(currentGame.mail.length > 0) {
            webAppCore.showToast({
                "message":      "New Mail!",
                "image":        "images/" + ColonyGame.meta.mailIndicator,
                "action": {
                    "title":    "Inbox",
                    "func":     showMail
                }
            });
            document.getElementById("imMail").style.display = "inline-block";
        }
    }

    var tmpHoldingMessage;

    function showStandardMessage(message) {

        tmpHoldingMessage = message;

        var menuOptions = [];

        menuOptions.push({
            "title": message.time,
            "title-color": null,
            "description": message.message,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": null
        });

        menuOptions.push({
            "title": getString("general-delete"),
            "title-color": "#F44336",
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "delete"
        });

        if(message.code == "0" && message.fromid && message.fromid != "0") {
            menuOptions.push({
                "title": "Send Message",
                "title-color": null,
                "description": null,
                "status": null,
                "status-color": null,
                "icon": null,
                "tag": "reply"
            });
        }

        if(message.code == "0" && message.fromid && message.fromid != "0" && giftCapacity > 0) {
            menuOptions.push({
                "title": "Send Gift",
                "title-color": null,
                "description": null,
                "status": null,
                "status-color": null,
                "icon": null,
                "tag": "gift"
            });
        }

        if(!message.reported) {
            menuOptions.push({
                "title": "Report Message",
                "title-color": null,
                "description": "Report this inappropriate message to the game moderators.",
                "status": "False reports are also tracked!",
                "status-color": "#F44336",
                "icon": null,
                "tag": "report"
            });
        }

        showList("From: " + message.from,menuOptions,onMailMessageResponse,"Nevermind");
    }

    function onMailMessageResponse(tag) {

        if(tmpHoldingMessage == null) {
            return;
        }

        if(tag == "report") {
            var data = [];
            
            data.push({
                "key":      "rs",
                "value":    tmpHoldingMessage.fromid
            });
    
            data.push({
                "key":      "rm",
                "value":    tmpHoldingMessage.message
            });
    
            data.push({
                "key":      "rt",
                "value":    tmpHoldingMessage.time
            });

            tmpHoldingMessage.reported = true;            

            postSecuredCallToApi(data,43,function() {
                webAppCore.showToast("Message Reported.");
            });
        }

        if(tag == "gift") {
            tmpNegoiationColony = {"id":tmpHoldingMessage.fromid};
            showOnlineResources("send");
        }

        if(tag == "delete") {
            deleteMail();
        }

        if(tag == "reply") {
            sendACustomMessage(tmpHoldingMessage.fromid);
        }
    }

    function openGiftVideo() {

        webAppCore.playRewardedVideo(onRewardedVideoBack);
    }

    function onRewardedVideoBack(status) {
        if(currentGame == null) {
            return;
        }

        

        if(status) {
            currentGame.rewardCounter = 0;
            currentGame.showRewardOption = false;
            deleteMail();

            var randomResource = ColonyGame.resources[randomIntFromInterval(0,ColonyGame.resources.length - 1)];
            var randomAmount = randomIntFromInterval(500,6000);

            currentGame.gifts.push(new Gift(getString("general-gift-giver"),getString("general-reward-complete"),randomResource.name,randomAmount));

            webAppCore.showToast("New gifts available!");
            document.getElementById("imGift").style.display = "inline-block";

        } else {
            webAppCore.showAlertWithTitle(getString("general-gift-not-watched"),getString("general-gift-giver"));
        }
    }

    function rejectGiftVid() {
        deleteMail();
        currentGame.rewardCounter = 0;
        currentGame.showRewardOption = false;
    }

    function onMailMessageOpened(message) {

        if(currentGame == null || !message) {
            return;
        }

        tmpHoldingMessage = message;
        
        // rewarded video offer 
        if(message.code == "-1") {
            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message,
                "op1": {
                    "text":     getString("general-delete"),
                    "func":     rejectGiftVid
                },
                "op2": {
                    "text":     getString("general-watch-gift-vid"),
                    "func":     openGiftVideo
                }
            });
        }

        // standard message
        if(message.code == "0" || message.code == "8") {

            showStandardMessage(message);

        }

        // payroll
        if(message.code == "2") {
            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message + "\n\n" + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(message.amount),
                "op1": {
                    "text":     getString("tax-pay"),
                    "func":     payCommonwealthPayroll
                },
                "op2": {
                    "text":     getString("tax-window-reject"),
                    "func":     rejectCommonwealthPayroll
                }
            });
        }

        // tribute
        if(message.code == "5") {

            tmpTributeAmount = Math.round(currentGame.resources[ColonyGame.meta.tenderResource].amount * (message.amount / 100));

            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message + "\n\n" + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(tmpTributeAmount),
                "op1": {
                    "text":     getString("tax-pay"),
                    "func":     payTribute
                },
                "op2": {
                    "text":     getString("tax-window-reject"),
                    "func":     rejectTribute
                }
            });
        }

        // independence 
        if(message.code == "6") {

            currentGame.isIndependent = true;
            currentGame.tradeEmbargo = false;
            currentGame.immigrationEmbargo = false;

            currentGame.independenceDay = Date.now();

            getColonyInfoFromServer();

            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message,
                "op1": {
                    "text":     getString("general-dismiss"),
                    "func":     reopenMailIfAny
                },
                "op2": {
                    "text":     getString("general-delete"),
                    "func":     deleteMail
                }
            });
        }

        if(message.code == "7") {
            getAnnexRequestInfo(message);
        }
        

        if(currentGame.mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        if(typeof message !== "string") {
            message.read = true;
        }

        
    }

    var tmpTributeAmount = 0;

    function payTribute() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        if(tmpTributeAmount > currentGame.resources[ColonyGame.meta.tenderResource].amount) {

            modifyResourceAmount(ColonyGame.meta.tenderResource,0,true,"Commonwealth");
        } else {

            modifyResourceAmount(ColonyGame.meta.tenderResource,-tmpTributeAmount,false,"Commonwealth");
        }

        currentGame.earthAssemblyRelations += 5;

        if(currentGame.earthAssemblyRelations > 100) {
            currentGame.earthAssemblyRelations = 100;
        }

        removeFromArray(currentGame.mail,tmpHoldingMessage);

        sendMessage(tmpHoldingMessage.fromid,4,tmpTributeAmount,currentGame.name + " has agreed to your demand for " + tmpHoldingMessage.amount + "% tribute.",placeholder);

        if(currentGame.mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        webAppCore.showToast(getString("tax-payment-thankyou"));

        reopenMailIfAny();
    }

    function rejectTribute() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        currentGame.earthBackTax += tmpTributeAmount;

        currentGame.earthAssemblyRelations -= 8;

        if(currentGame.earthAssemblyRelations < 0) {
            currentGame.earthAssemblyRelations = 0;
        }

        removeFromArray(currentGame.mail,tmpHoldingMessage);

        sendMessage(tmpHoldingMessage.fromid,0,0,currentGame.name + " has rejected your demand for " + tmpHoldingMessage.amount + "% tribute.",placeholder);

        if(currentGame.mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        reopenMailIfAny();
    }

    function payCommonwealthPayroll() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        removeFromArray(currentGame.mail,tmpHoldingMessage);

        var amount = parseInt(tmpHoldingMessage.amount);

        if(amount > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            amount = currentGame.resources[ColonyGame.meta.tenderResource].amount;

            modifyResourceAmount(ColonyGame.meta.tenderResource,0,true,"Commonwealth");
        } else {
            modifyResourceAmount(ColonyGame.meta.tenderResource,-amount,false,"Commonwealth");
        }

        currentGame.foreignPayrollTotals += amount;

        sendMessage(tmpHoldingMessage.fromid,3,amount,"Shared payroll payment from " + currentGame.name + ".",placeholder);

        if(currentGame.mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        reopenMailIfAny();
    }

    function rejectCommonwealthPayroll() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        removeFromArray(currentGame.mail,tmpHoldingMessage);

        sendMessage(tmpHoldingMessage.fromid,0,0,currentGame.name + " has rejected your request for payroll assistance.",placeholder);

        if(currentGame.mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        reopenMailIfAny();
    }

    function deleteMail() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        removeFromArray(currentGame.mail,tmpHoldingMessage);

        if(currentGame.mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        tmpHoldingMessage = null;

        reopenMailIfAny();
    }

    var tmpNegoiationColony = null;

    function demandTribute(amount) {

        if(tmpNegoiationColony == null) {
            return;
        }

        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        var amt = parseInt(amount);

        if(amt < 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt > 100) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        sendMessage(tmpNegoiationColony.id,5,amt,"The " + currentGame.name + " General Assembly demands that you pay " + amt + "% of your " + ColonyGame.meta.tenderResource + " to help fund the Commonwealth." ,placeholder);
    }

    function rescindCharter() {
        if(tmpNegoiationColony == null) {
            return;
        }

        postMessageToAllChannels(tmpNegoiationColony.name + " has been kicked out of the Commonwealth of " + currentGame.name,"#F44336");

        sendMessage(tmpNegoiationColony.id,6,0,"You have been granted independence by the " + currentGame.name + " General Assembly.  Your rights in the Commonwealth of " + currentGame.name + " have been rescinded." ,placeholder);

        closeColonyWindow();
        showNewCommonwealthMenu();
    }

    var tmpResourceTag = null;

    function onRequestResourceType(tag) {
        if(tmpNegoiationColony == null) {
            return;
        }

        var resName = ColonyGame.meta.tenderResource;

        if(tag != "money") {
            resName = tag.name;
        }

        var message = "Times are bad in your chartered colony of " + currentGame.name + ".  The people are requesting a gift of " + resName + " to help them get by.";

        sendMessage(tmpNegoiationColony.id,0,0,message,placeholder);
        
        webAppCore.showToast("Request Sent");
    }

    function onSendResourceType(tag) {

        if(tag == null || tmpNegoiationColony == null || currentGame == null) {
            return;
        }
        
        
        tmpResourceTag = tag;

        var resName = ColonyGame.meta.tenderResource;

        if(tag != "money") {
            resName = tag.name;
        }
        
        if(!currentGame.resources[resName]) {
            return;
        }

        var max = giftCapacity;

        if(max == 0) {
            webAppCore.showToast("Cannot send resources!");
            return;
        }

        var dialogOptions = {
            title: "Send Resource",
            message: "How much " + resName + " do you want to send (Max " + numberWithCommas(max) + ")?  You have " + numberWithCommas(currentGame.resources[resName].amount) + ".",
            func: onInitResourceSend
        };

        webAppCore.inputBox(dialogOptions);

    }

    function onInitResourceSend(amount) {
        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(tmpNegoiationColony == null) {
            return;
        }

        if(tmpResourceTag == null) {
            return;
        }

        var max = giftCapacity;

        if(max == 0) {
            return;
        }

        var resName = ColonyGame.meta.tenderResource;

        if(tmpResourceTag != "money") {
            resName = tmpResourceTag.name;
        }

        var amt = parseInt(amount);

        if(isNaN(amt)) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt > max) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt <= 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt > currentGame.resources[resName].amount) {
            webAppCore.showToast("Invalid amount");
            return;
        }


        modifyResourceAmount(resName,-amt,false,"Commonwealth");

        var message = "A gift from " + currentGame.name + ".";

        if(tmpResourceTag == "money") {
            sendMessage(tmpNegoiationColony.id,4,amt,message,postResourceSend);
        } else {
            sendMessage(tmpNegoiationColony.id,4,amt,message,postResourceSend,tmpResourceTag.id);
        }

        webAppCore.showToast("Resources sent");

        if(tmpHoldingMessage != null) {
            showStandardMessage(tmpHoldingMessage);
        }

        tmpSaveResources();
    }

    function postResourceSend() {
        if(tmpNegoiationColony == null) {
            return;
        }

             
    }

    var negotiatingColonist;

    function renameColonist(colonist) {
        negotiatingColonist = colonist;

        var renameText = "rename-colonist".replace("#colonist",colonist.name);

        var dialogOptions = {
            "title":    getString("general-rename"),
            "message":  renameText,
            func: onNewColonistNameSelected
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onNewColonistNameSelected(name) {
        if(name == null || name.length == 0) {
            webAppCore.showToast("Canceled");
            return;
        }

        if(negotiatingColonist == null) {
            return;
        }


        negotiatingColonist.name = name.trim().latinize();

        showColonistStats(negotiatingColonist);
    }

    function showColonistStats(colonist) {

        negotiatingColonist = colonist;

        var menuOptions = [];

        var jobBuilding = null;
        var houseBuilding = null;

        var jobDef = null;
        var houseDef = null;

        var travelDistance = 0;
        var distanceColor = null;

        if(colonist.job > 0) {
            jobBuilding = getBuildingById(colonist.job);
            jobDef = getBuildingDefByName(jobBuilding.def);
        }

        if(colonist.house > 0) {
            houseBuilding = getBuildingById(colonist.house);

            if(houseBuilding != null) {
                houseDef = getBuildingDefByName(houseBuilding.def);
            } else {
                colonist.house = 0;
            }
        }

        if(jobBuilding != null && houseBuilding != null) {
            var a = jobBuilding.x - houseBuilding.x;
            var b = jobBuilding.y - houseBuilding.y;
            travelDistance = Math.round(Math.sqrt( a*a + b*b ));

            if(travelDistance > 20) {
                distanceColor = "#F44336";
            }
        }

        var salary = 1;

        if(currentGame.salaries.Unskilled != null) {
            salary = currentGame.salaries.Unskilled;
        }

        var occ = "Unskilled";

        if(jobDef != null) {
            
            var occupationDef = getOccupationDefByName(jobDef.occupation);
            if(occupationDef != null) {
                occ = jobDef.occupation;
                salary = occupationDef.salary;

                if(currentGame.salaries[occupationDef.name] != null) {
                    salary = currentGame.salaries[occupationDef.name];
                }
            }

        }

        var img;

        if(jobBuilding != null && jobDef != null) {


            if(jobDef.indicator == null) {
                if(gameAssets[jobDef.tile] !== undefined) {
                    img = gameAssets[jobDef.tile][0].image.src;
                }
            } else {
                img = "images/" + jobDef.indicator;
            }

            menuOptions.push({
                "title": "Occupation",
                "title-color": null,
                "description": occ,
                "status": jobBuilding.name,
                "status-color": null,
                "icon": img,
                "overflow": [
                    {
                        pre:    "Salary: ",
                        post:   salary,
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "tag": null
            });
        } else {

            if(colonist.money > gotItMadePrice) {
                menuOptions.push({
                    "title": "Occupation",
                    "title-color": null,
                    "description": null,
                    "status": "Retired",
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.unemploymentIcon,
                    "tag": null
                });
            } else {
                menuOptions.push({
                    "title": "Occupation",
                    "title-color": null,
                    "description": null,
                    "status": "Unemployed",
                    "status-color": "#F44336",
                    "icon": "images/" + ColonyGame.meta.unemploymentIcon,
                    "tag": null
                });
            }

        }

        if(houseBuilding != null && houseDef != null) {

            if(houseDef.indicator == null) {
                img = gameAssets[houseDef.tile][0].image.src;
            } else {
                img = "images/" + houseDef.indicator;
            }

            menuOptions.push({
                "title": "Home",
                "title-color": null,
                "description": null,
                "status": houseBuilding.name,
                "status-color": null,
                "icon": img,
                "tag": null
            });
        } else {
            menuOptions.push({
                "title": "Home",
                "title-color": null,
                "description": null,
                "status": "Homeless",
                "status-color": "#F44336",
                "icon": "images/" + ColonyGame.meta.unemploymentIcon,
                "tag": null
            });
        }

        if(houseBuilding != null && jobBuilding != null) {
            menuOptions.push({
                "title": "Commute Length",
                "title-color": null,
                "description": null,
                "status": travelDistance,
                "status-color": distanceColor,
                "icon": "images/" + ColonyGame.meta.unemploymentIcon,
                "tag": null
            });
        }

        var healthColor = null;

        if(colonist.health < 70) {
            healthColor = "#F44336";
        }

        menuOptions.push({
            "title": "Health",
            "title-color": null,
            "description": null,
            "status": "Health: " + colonist.health + "%",
            "status-color": healthColor,
            "icon": "images/" + ColonyGame.meta.medicalIcon,
            "overflow": [
                {
                    "pre":      "Energy: " + colonist.energy + "%",
                    "post":     null,
                    "icon":     null,
                    "color":    null
                }
            ],
            "tag": null
        });

        var happinessColor = null;

        if(colonist.happiness < 75) {
            happinessColor = "#F44336";
        }

        menuOptions.push({
            "title": "Happiness",
            "title-color": null,
            "description": null,
            "status": colonist.happiness + "%",
            "status-color": happinessColor,
            "icon": "images/" + ColonyGame.meta.approvalIndicator,
            "tag": null
        });

        menuOptions.push({
            "title": "资金",
            "title-color": null,
            "description": null,
            "status": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(colonist.money),
            "status-color": null,
            "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
            "tag": "money"
        });

        menuOptions.push({
            "title": "Age",
            "title-color": null,
            "description": null,
            "status": Math.floor(colonist.age / 12).toString() + " Years",
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.ageIndicator,
            "tag": "money"
        });

        if(menuOptions.length == 0) {
            return;
        }

        showList(colonist.name,menuOptions,onColonistStatSelected,getString("general-nevermind"));
    }

    function onColonistStatSelected(tag) {
        if(negotiatingColonist == null) {
            return;
        }

        if(tag == "money") {
            showColonistMoneyOptions();
        }
    }

    function showColonistMoneyOptions() {
        if(negotiatingColonist == null) {
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title": "Impose Fine",
            "title-color": null,
            "description": "Force " + negotiatingColonist.name + " to pay a sum of money.",
            "status": null,
            "status-color": null,
            "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
            "tag": "fine"
        });
        
        menuOptions.push({
            "title": "Give Gift",
            "title-color": null,
            "description": "Give " + negotiatingColonist.name + " a monetary gift.",
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.giftIndicator,
            "tag": "gift"
        });

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });


        showList(negotiatingColonist.name + " - 资金",menuOptions,onColonistMoneyOptionSelected,getString("general-nevermind"));
    }

    function onColonistMoneyOptionSelected(tag) {
        if(negotiatingColonist == null) {
            return;
        }

        if(tag == "back") {
            showColonistStats(negotiatingColonist);
        }

        if(tag == "fine") {
            var dialogOptions = {
                title: "Impose Fine",
                message: "How much do you want to fine " + negotiatingColonist.name + " (Between 0 and " + numberWithCommas(negotiatingColonist.money) + ")?",
                func: onFineImposed
            };

            webAppCore.inputBox(dialogOptions);
        }

        if(tag == "gift") {
            var dialogOptionsMore = {
                title: "Give Gift",
                message: "How much do you want to give to " + negotiatingColonist.name + " (Between 0 and " + numberWithCommas(currentGame.resources[ColonyGame.meta.tenderResource].amount) + ")?",
                func: onGiftGiven
            };

            webAppCore.inputBox(dialogOptionsMore);
        }
    }

    function onGiftGiven(amount) {

        if(negotiatingColonist == null) {
            return;
        }

        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            webAppCore.showToast("Invalid Amount");
            return;
        }

        var numAmount = parseInt(amount);

        if(numAmount < 0) {
            showColonistStats(negotiatingColonist);
            return;
        }

        if(numAmount > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            webAppCore.showToast("Invalid Amount");
            showColonistStats(negotiatingColonist);
            return;
        }

        negotiatingColonist.money += numAmount;
        negotiatingColonist.happiness += Math.round(numAmount / 3);


        modifyResourceAmount(ColonyGame.meta.tenderResource,-numAmount,false,"Colonist");

        if(negotiatingColonist.happiness > 100) {
            negotiatingColonist.happiness = 100;
        }

        webAppCore.showToast(negotiatingColonist.name + " has been given $" + amount + ".");
        showColonistStats(negotiatingColonist);
    }

    function onFineImposed(amount) {
        if(negotiatingColonist == null) {
            return;
        }

        if(amount == null || isNaN(amount)) {
            return;
        }

        var numAmount = parseInt(amount);

        if(numAmount < 0) {
            showColonistStats(negotiatingColonist);
            return;
        }

        if(numAmount > negotiatingColonist.money) {
            webAppCore.showToast("Invalid Amount");
            showColonistStats(negotiatingColonist);
            return;
        }

        negotiatingColonist.money -= numAmount;
        negotiatingColonist.happiness -= numAmount;


        modifyResourceAmount(ColonyGame.meta.tenderResource,numAmount,false,"Tax");

        if(negotiatingColonist.happiness < 0) {
            negotiatingColonist.happiness = 0;
        }

        webAppCore.showToast(negotiatingColonist.name + " has been fined $" + amount + " for jaywalking.");
        showColonistStats(negotiatingColonist);
    }

    function showWorkPolicyOptions() {
        var menuOptions = [];

        var isLight = null;
        var isNormal = null;
        var isHard = null;
        var isXtreme = null;

        if(currentGame.workerPolicy == 0) {
            isLight = "Active";
        }

        if(currentGame.workerPolicy == 1) {
            isNormal = "Active";
        }

        if(currentGame.workerPolicy == 2) {
            isHard = "Active";
        }

        if(currentGame.workerPolicy == 3) {
            isXtreme = "Active";
        }

        menuOptions.push({
            "title": getString("work-policy-light"),
            "title-color": null,
            "description": getString("work-policy-light-desc"),
            "status": isLight,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.wPolLightInd,
            "tag": 0
        });

        menuOptions.push({
            "title": getString("work-policy-normal"),
            "title-color": null,
            "description": getString("work-policy-normal-desc"),
            "status": isNormal,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.wPolNormalInd,
            "tag": 1
        });

        menuOptions.push({
            "title": getString("work-policy-hard"),
            "title-color": null,
            "description": getString("work-policy-hard-desc"),
            "status": isHard,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.wPolOTInd,
            "tag": 2
        });

        menuOptions.push({
            "title": getString("work-policy-extreme"),
            "title-color": null,
            "description": getString("work-policy-extreme-desc"),
            "status": isXtreme,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.wPolXtremeInd,
            "tag": 3
        });

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        if(menuOptions.length == 0) {
            return;
        }

        showList(getString("work-policy"),menuOptions,onWorkPolicySelected,getString("general-nevermind"));
    }

    function onWorkPolicySelected(tag) {
        if(tag == "back") {
            showPolicyMenu();
            return;
        }

        if(isNaN(tag)) {
            showPolicyMenu();
            return;
        }

        currentGame.workerPolicy = parseInt(tag);

        showPolicyMenu();
    }

    function showPolicyMenu() {
        var menuOptions = [];
        var i;


        if(currentGame.isIndependent && !currentGame.offlineMode) {
            var edictOption = {
                "title": getString("general-mass-message"),
                "title-color": null,
                "description": getString("general-mass-msg-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.mailIndicator,
                "tag": "edict"
            };

            menuOptions.push(edictOption);

            if(!currentGame.privateCharter) {
                var salesOption = {
                    "title": getString("pol-salespitch-header"),
                    "title-color": null,
                    "description": getString("pol-salespitch-desc"),
                    "status": currentGame.salesPitch,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.empireIndicator,
                    "tag": "salespitch"
                };

                menuOptions.push(salesOption);
            }
        }

        if(currentGame.governmentLevel >= 1) {

            var autobudgetStatus = "关";
            var autobudgetColor = "#F44336";

            if(currentGame.autoBudget) {
                autobudgetStatus = "开";
                autobudgetColor = "#4CAF50";
            }

            menuOptions.push({
                "title": getString("general-autobudget"),
                "title-color": null,
                "description": getString("general-autobudget-desc"),
                "status": autobudgetStatus,
                "status-color": autobudgetColor,
                "icon": "images/" + ColonyGame.meta.autobudgetInd,
                "tag": "autobudget"
            });
        }
        


        if(currentGame.governmentLevel >= 1 && !currentGame.isIndependent) {
            var baseIndependenceCost = ColonyGame.meta.baseIndependenceCost;
            var relationsPenalty = baseIndependenceCost.amount - (baseIndependenceCost.amount * (currentGame.earthAssemblyRelations / 100));
            var totalIndependenceCost = baseIndependenceCost.amount + relationsPenalty;

            var independenceColor = null;

            if(totalIndependenceCost > currentGame.resources[baseIndependenceCost.resource].amount) {
                independenceColor = "#F44336";
            }

            var indOption = {
                "title": getString("general-declare-ind"),
                "title-color": null,
                "description": getString("general-declare-ind-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.empireIndicator,
                "overflow": [
                    {
                        "pre":      "Cost",
                        "post":     numberWithCommas(totalIndependenceCost),
                        "color":    independenceColor,
                        "icon":     "images/" + getResourceByDefName(baseIndependenceCost.resource).icon
                    }
                ],
                "tag": "independence"
            };

            if(currentGame.earthBackTax > 0) {

                var supplementColor = null;

                if(currentGame.resources[ColonyGame.meta.tenderResource].amount < currentGame.earthBackTax) {
                    supplementColor = "#F44336";
                }

                indOption.overflow.push({
                    "pre":      "Cost",
                    "post":     numberWithCommas(currentGame.earthBackTax),
                    "color":    supplementColor,
                    "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                });
            }

            menuOptions.push(indOption);
        }

        var immigrationSetting = "Allowed";
        var immigrationColor = "#4CAF50";

        if(currentGame.stopImmigration) {
            immigrationSetting = "Blocked";
            immigrationColor = "#F44336";
        }
        
        if(currentGame.governmentLevel >= 1) {
            menuOptions.push({
                "title": "Immigration",
                "title-color": null,
                "description": "Whether or not to allow new immigrants to your colony.",
                "status": immigrationSetting,
                "status-color": immigrationColor,
                "icon": "images/" + ColonyGame.meta.podImmigradionInd,
                "tag": "immigration"
            });
        }
        
        if(currentGame.governmentLevel >= 2) {
            menuOptions.push({
                "title": getString("general-labor"),
                "title-color": null,
                "description": getString("labor-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.polLaborInd,
                "tag": "labor"
            });
        }

        if(currentGame.governmentLevel >= 2) {

            var totalRepairCosts = 0;

            for(i = 0; i < currentGame.buildings.length; i++) {
                totalRepairCosts += getBuildingRepairCost(currentGame.buildings[i]);
            }

            var repairCostColor = null;

            if(totalRepairCosts > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                repairCostColor = "#F44336";
            }

            if(!currentGame.offlineMode) {
                menuOptions.push({
                    "title": "Infrastructure Repair",
                    "title-color": null,
                    "description": "Repair all buildings in the colony at once.",
                    "status": null,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.showBuildSidebarIcon,
                    "overflow": [
                        {
                            "pre":  "花费:",
                            "post": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalRepairCosts),
                            color:  repairCostColor,
                            icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                        }
                    ],
                    "tag": "repairs"
                });
            }
        }

        if(currentGame.governmentLevel >= 1) {
            var livingWageTotalCost = currentGame.livingWageRate * getTotalPopulation();

            menuOptions.push({
                "title": getString("livingwage-header"),
                "title-color": null,
                "description": getString("livingwage-desc"),
                "status": null,
                "status-color": null,
                "overflow": [
                    {
                        "pre":  "Current:",
                        "post": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGame.livingWageRate),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        "pre":  "Total:",
                        "post": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(livingWageTotalCost),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
                "tag": "livingwage"
            });
        }


        if(currentGame.governmentLevel >= 2) {
            menuOptions.push({
                "title": getString("firedrill-header"),
                "title-color": null,
                "description": getString("firedrill-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.polFiredrillInd,
                "tag": "firedrill"
            });

            var currentWorkPolicy = "Current: Light";

            if(currentGame.workerPolicy == 1) {
                currentWorkPolicy = "Current: Normal";
            }

            if(currentGame.workerPolicy == 2) {
                currentWorkPolicy = "Current: Overtime";
            }

            if(currentGame.workerPolicy == 3) {
                currentWorkPolicy = "Current: Extreme";
            }
        }

        if(currentGame.governmentLevel >= 2) {
            menuOptions.push({
                "title": getString("work-policy"),
                "title-color": null,
                "description": getString("work-policy-desc"),
                "status": currentWorkPolicy,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.polWorkPolicyInd,
                "tag": "workpolicy"
            });
        }

        if(currentGame.governmentLevel >= 1) {
            menuOptions.push({
                "title": getString("money-shower-header"),
                "title-color": null,
                "description": getString("money-shower-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.moneyShowerInd,
                "tag": "moneyshower"
            });
        }

        if(currentGame.governmentLevel >= 1) {
            menuOptions.push({
                "title": getString("tax-collection-header"),
                "title-color": null,
                "description": getString("tax-collection-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.taxCollectionInd,
                "tag": "taxcollect"
            });
        }

        if(currentGame.governmentLevel >= 3) {
            var curRationsOption = "Disabled";
            var curRationsColor = "#4CAF50";

            if(currentGame.foodRationing) {
                curRationsOption = "Enabled";
                curRationsColor = "#F44336";
            }

            menuOptions.push({
                "title": getString("rationing-header"),
                "title-color": null,
                "description": getString("rationing-desc"),
                "status": curRationsOption,
                "status-color": curRationsColor,
                "icon": "images/" + ColonyGame.meta.rationingInd,
                "tag": "rations"
            });
        }

        if(currentGame.governmentLevel >= 2) {
            menuOptions.push({
                "title": getString("lottery-header"),
                "title-color": null,
                "description": getString("lottery-message"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.lotteryInd,
                "tag": "lottery"
            });
        }

        if(currentGame.governmentLevel >= 4) {
            var currentTiles = currentGame.width * currentGame.height;
            var newTiles = (currentGame.width + 20) * (currentGame.height + 20);

            var difference = newTiles - currentTiles;

            var costs = [];

            for(i = 0; i < ColonyGame.meta.annexTileCost.length; i++) {

                var annexCostColor = null;

                if((difference * ColonyGame.meta.annexTileCost[i].amount) > currentGame.resources[ColonyGame.meta.annexTileCost[i].resource].amount) {
                    annexCostColor = "#F44336";
                }

                costs.push({
                    "pre": "花费:",
                    "post": numberWithCommas(difference * ColonyGame.meta.annexTileCost[i].amount),
                    "icon": "images/" + getResourceByDefName(ColonyGame.meta.annexTileCost[i].resource).icon,
                    "color": annexCostColor
                });
            }

            menuOptions.push({
                "title": getString("general-annex-land"),
                "title-color": null,
                "description": getString("general-annex-desc"),
                "status": "Warning: Increasing map size MAY degrade performance.",
                "status-color": "#F44336",
                "icon": "images/" + ColonyGame.meta.annexInd,
                "tag": "annex",
                "overflow": costs
            });
        }


        if(menuOptions.length == 0) {
            return;
        }

        showList(getString("general-policy"),menuOptions,onPolicyItemSelected,getString("general-nevermind"));
    }

    function onPolicyItemSelected(tag) {

        if(tag == null) {
            return;
        }

        if(tag == "salespitch") {
            setSalesPitch();
        }

        if(tag == "autobudget") {
            currentGame.autoBudget = !currentGame.autoBudget;
            showPolicyMenu();
        }

        if(tag == "edict") {
            sendCommonwealthEdict();
        }

        if(tag == "repairs") {
            repairAllBuildings();
            showPolicyMenu();
        }

        if(tag == "independence") {
            askForIndependence();
        }

        if(tag == "annex") {
            performAnnex();
            showPolicyMenu();
        }

        if(tag == "rations") {
            currentGame.foodRationing = !currentGame.foodRationing;
            showPolicyMenu();
        }

        if(tag == "immigration") {
            currentGame.stopImmigration = !currentGame.stopImmigration;
            showPolicyMenu();
        }

        if(tag == "workpolicy") {
            showWorkPolicyOptions();
        }

        if(tag == "labor") {
            manageLabor();
        }

        if(tag == "livingwage") {
            setTimeout(showLivingWageInput,500);
        }

        if(tag == "firedrill") {
            workerCleanupRequired = true;
            showPolicyMenu();
            webAppCore.showToast("Firedrill Initiated");
        }

        if(tag == "moneyshower") {
            startMoneyShower();
        }

        if(tag == "taxcollect") {
            beginTaxCollection();
        }

        if(tag == "lottery") {
            beginLottery();
        }
    }

    function beginTaxCollection() {
        var estimatedTotal = 0;

        for(var i = 0; i < currentGame.colonists.length; i++) {

            if(currentGame.colonists[i].money == 0) {
                continue;
            }

            var tax = Math.ceil(currentGame.colonists[i].money * .25);
            estimatedTotal += tax;
        }

        var avgTaxPerColonist = estimatedTotal / currentGame.colonists.length;
        var virtualTax = Math.round(avgTaxPerColonist * getVirtualPopulation());


        if(currentGame.historicStats.mediansalary && currentGame.historicStats.mediansalary.length > 0) {
            var mediantax = currentGame.historicStats.mediansalary[currentGame.historicStats.mediansalary.length - 1] * .25;
            virtualTax = Math.round(mediantax * getVirtualPopulation());
        }


        var totalEst = virtualTax + estimatedTotal;

        webAppCore.showDialog({
            "title":    getString("tax-collection-header"),
            "message":  "Impose a one-time 25% tax on the colony?  Estimated income: $" + numberWithCommas(totalEst),
            "op1": {
                "text":     getString("general-yes"),
                "func":     imposeTheTax
            },
            "op2": {
                "text":     getString("general-dismiss"),
                "func":     showPolicyMenu
            }
        });
    }

    function imposeTheTax() {
        var estimatedTotal = 0;

        for(var i = 0; i < currentGame.colonists.length; i++) {

            if(currentGame.colonists[i].money == 0) {
                continue;
            }

            var tax = Math.ceil(currentGame.colonists[i].money * .25);
            estimatedTotal += tax;

            currentGame.colonists[i].money -= tax;

            modifyResourceAmount(ColonyGame.meta.tenderResource,tax,false,"Tax");

            currentGame.colonists[i].happiness -= tax;

            if(currentGame.colonists[i].happiness < 0) {
                currentGame.colonists[i].happiness = 0;
            }
        }

        var avgTaxPerColonist = estimatedTotal / currentGame.colonists.length;
        var virtualTax = Math.round(avgTaxPerColonist * getVirtualPopulation());


        if(currentGame.historicStats.mediansalary && currentGame.historicStats.mediansalary.length > 0) {
            var mediantax = currentGame.historicStats.mediansalary[currentGame.historicStats.mediansalary.length - 1] * .25;
            virtualTax = Math.round(mediantax * getVirtualPopulation());
        }


        var totalEst = virtualTax + estimatedTotal;


        updateHistoricStatistics();
        showPolicyMenu();
        webAppCore.showToast("You have collected " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalEst) + " in taxes!");
    }

    function beginLottery() {
        var dialogOptions = {
            title: getString("lottery-header"),
            message: getString("lottery-instruction"),
            func: runLottery
        };

        webAppCore.inputBox(dialogOptions);
    }

    function runLottery(amount) {
        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            showPolicyMenu();
            return;
        }

        var numAmount = parseInt(amount);

        if(numAmount < 0) {
            showPolicyMenu();
            return;
        }

        if(isNaN(numAmount)) {
            showPolicyMenu();
            return;
        }

        var chanceToBuy;
        var thePot = 0;
        var buyers = [];

        for(var i = 0; i < currentGame.colonists.length; i++) {

            if(currentGame.colonists[i].money < numAmount) {
                continue;
            }            

            chanceToBuy = 95;

            if(numAmount > (currentGame.colonists[i].money * 0.1)) {
                chanceToBuy -= 10;
            }

            if(numAmount > (currentGame.colonists[i].money * 0.2)) {
                chanceToBuy -= 10;
            }

            if(numAmount > (currentGame.colonists[i].money * 0.3)) {
                chanceToBuy -= 10;
            }

            if(numAmount > (currentGame.colonists[i].money * 0.4)) {
                chanceToBuy -= 10;
            }

            if(numAmount > (currentGame.colonists[i].money * 0.5)) {
                chanceToBuy -= 10;
            }

            if(numAmount > (currentGame.colonists[i].money * 0.6)) {
                chanceToBuy -= 10;
            }

            if(numAmount > (currentGame.colonists[i].money * 0.7)) {
                chanceToBuy -= 10;
            }

            if(currentGame.colonists[i].happiness > 80) {
                chanceToBuy -= 20;
            }

            if(currentGame.colonists[i].happiness > 70) {
                chanceToBuy -= 5;
            }

            var buyChance = randomIntFromInterval(0,100);

            if(buyChance < chanceToBuy) {
                currentGame.colonists[i].money -= numAmount;
                thePot += numAmount;
                buyers.push(currentGame.colonists[i]);
            }
        }

        // let the virtual play 
        var virtcol = getVirtualPopulation();
        var virtbuyers = 0;

        if(currentGame.historicStats.mediansalary && currentGame.historicStats.mediansalary.length > 0) {
            if(currentGame.historicStats.mediansalary[currentGame.historicStats.mediansalary.length - 1] > numAmount) {
                while(virtcol > 0) {
                    var buyChanceVirt = randomIntFromInterval(0,100);
        
                    if(buyChanceVirt < 5) {
                        virtbuyers++;
                        thePot += numAmount;
                    }
        
                    virtcol--;
                }
            }
        }

        

        if(buyers.length == 0) {
            webAppCore.showAlertWithTitle(getString("lottery-fail"),getString("lottery-header"));
            //showPolicyMenu();
            return;
        }

        updateHistoricStatistics();

        var theSplit = Math.floor(thePot / 2);
        var theWinner = buyers[randomIntFromInterval(0,buyers.length - 1)];

        modifyResourceAmount(ColonyGame.meta.tenderResource,theSplit,false,"Lottery");
        theWinner.money += theSplit;

        webAppCore.showAlertWithTitle("The lottery was a success.  There were " + (buyers.length + virtbuyers) + " buyers, and the lucky winner was " + theWinner.name + ", who will be going home with " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(theSplit) + ".  The treasury will also get it's " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(theSplit) + " cut.",getString("lottery-header"));
        //showPolicyMenu();
    }

    function startMoneyShower() {

        var maxPossible = Math.floor(currentGame.resources[ColonyGame.meta.tenderResource].amount / getTotalPopulation());

        var dialogOptions = {
            title: getString("money-shower-header"),
            message: "How much free money do you want to give each colonist (Between 0 and " + numberWithCommas(maxPossible) + ")?",
            func: onHelicopterMoney
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onHelicopterMoney(amount) {

        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            showPolicyMenu();
            return;
        }

        var numAmount = parseInt(amount);

        if(numAmount < 0) {
            showPolicyMenu();
            return;
        }

        if(isNaN(numAmount)) {
            return;
        }

        var totalAmount = numAmount * getTotalPopulation();

        if(totalAmount > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
            
            showPolicyMenu();
            webAppCore.showToast(getString("general-cant-afford"));
            return;
        }

        var totalSpend = 0;

        for(var i = 0; i < currentGame.colonists.length; i++) {

            if(currentGame.resources[ColonyGame.meta.tenderResource].amount < numAmount) {
                break;
            }

            currentGame.colonists[i].money += numAmount;

            modifyResourceAmount(ColonyGame.meta.tenderResource,-numAmount,false,"Policy");
            totalSpend += numAmount;

            currentGame.colonists[i].happiness += Math.round(numAmount / 3);

            if(currentGame.colonists[i].happiness > 100) {
                currentGame.colonists[i].happiness = 100;
            }
        }

        // you gotta pay for the virtual guys too 
        var virtcol = getVirtualPopulation();

        while(virtcol > 0) {
            if(currentGame.resources[ColonyGame.meta.tenderResource].amount < numAmount) {
                break;
            }

            modifyResourceAmount(ColonyGame.meta.tenderResource,-numAmount,false,"Policy");
            totalSpend += numAmount;
            virtcol--;
        }

        showPolicyMenu();
        webAppCore.showToast("You have dropped $" + numberWithCommas(totalSpend) + " onto the colony!");
        
    }

    function showLivingWageInput() {
        var dialogOptions = {
            title: getString("livingwage-header"),
            message: getString("livingwage-desc"),
            func: onLivingWageBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onLivingWageBack(salary) {

        

        if(salary == null || salary.length == 0 || isNaN(salary) || parseInt(salary) < 0 || salary.trim().length == 0) {
            webAppCore.showToast("Invalid wage!");
            showPolicyMenu();
            return;
        }

        currentGame.livingWageRate = parseInt(salary);

        showPolicyMenu();

        webAppCore.showToast("Wage set!");
    }

    function sendMessage(to,code,amount,message,callback,resourceId) {
        if(currentGame == null || !currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "m",
            "value":    to
        });

        data.push({
            "key":      "c",
            "value":    code
        });

        data.push({
            "key":      "a",
            "value":    amount
        });

        data.push({
            "key":      "t",
            "value":    message
        });

        if(resourceId) {
            data.push({
                "key":      "r",
                "value":    resourceId
            });
        }

        postSecuredCallToApi(data,19,callback);


        if(usingSockets) {
            postInGameMessageToColony("checkmail",null,to);
        }   
    }

    function sendForMotherlandPayrollPayment(motherlandAmount) {
        if(currentGame == null || !currentGame.colonyId || currentGame.colonyId == 0 || currentGame.motherlandid == 0 || currentGame.offlineMode) {
            return;
        }

        sendMessage(currentGame.motherlandid,2,motherlandAmount,"Your shared payroll responsibility from " + currentGame.name + ".",placeholder);
    }

    

    function manageLabor() {

        var i,bDef;
        var totalSalary = 0;
        var totalWorkers = 0;

        var occupations = {};

        var unskilledSalary = 1;

        if(currentGame.salaries.Unskilled != null) {
            unskilledSalary = currentGame.salaries.Unskilled;
        }

        occupations.unskilled = {
            "name":     "Unskilled",
            "salary":   unskilledSalary,
            "workers":  0,
            "totalPay": 0,
            "icon":     ColonyGame.meta.colonistIcon
        };

        for(i = 0; i < ColonyGame.occupations.length; i++) {

            var salary = ColonyGame.occupations[i].salary;

            if(currentGame.salaries[ColonyGame.occupations[i].name] != null) {
                salary = currentGame.salaries[ColonyGame.occupations[i].name];
            }

            var icn = ColonyGame.meta.colonistIcon;

            if(ColonyGame.occupations[i].indicator != null) {
                icn = ColonyGame.occupations[i].indicator;
            }

            occupations[ColonyGame.occupations[i].name] = {
                "name":     ColonyGame.occupations[i].name,
                "salary":   salary,
                "workers":  0,
                "totalPay": 0,
                "icon":     icn
            };
        }

        for(i = 0; i < currentGame.buildings.length; i++) {
            if(currentGame.buildings[i].workers != null && currentGame.buildings[i].workers.length > 0) {
                bDef = getBuildingDefByName(currentGame.buildings[i].def);

                if(occupations[bDef.occupation] != null) {
                    occupations[bDef.occupation].workers += currentGame.buildings[i].workers.length;
                    occupations[bDef.occupation].totalPay += (currentGame.buildings[i].workers.length * occupations[bDef.occupation].salary);
                    totalSalary += (currentGame.buildings[i].workers.length * occupations[bDef.occupation].salary);
                } else {
                    occupations.unskilled.workers += currentGame.buildings[i].workers.length;
                    occupations.unskilled.totalPay += (currentGame.buildings[i].workers.length * occupations.unskilled.salary);
                    totalSalary += (currentGame.buildings[i].workers.length * occupations.unskilled.salary);
                }

                totalWorkers += currentGame.buildings[i].workers.length;
            }
        }

        var menuOptions = [];

        if(currentGame.isIndependent && !currentGame.offlineMode) {
            menuOptions.push({
                "title": getString("general-online-pay-assis"),
                "title-color": null,
                "description": getString("online-payass-desc"),
                "status": "Current: " + numberWithCommas(Math.round(currentGame.payrollRate * 100)) + "%",
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.empireIndicator,
                "tag":  "payassist"
            });
        }
        
        menuOptions.push({
            "title": "Total Workforce Estimate",
            "title-color": null,
            "description": null,
            "status": "工人: " + numberWithCommas(totalWorkers),
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.totalWorkforceInd,
            "overflow": [
                {
                    pre:    "Total Salary: ",
                    post:   getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalSalary),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                }
            ],
            "tag": "total"
        });
        
        for(var prop in occupations) {
            menuOptions.push({
                "title": occupations[prop].name,
                "title-color": null,
                "description": null,
                "status": "工人: " + numberWithCommas(occupations[prop].workers),
                "status-color": null,
                "icon": "images/" + occupations[prop].icon,
                "overflow": [
                    {
                        pre:    "Occupation Salary: ",
                        post:   getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(occupations[prop].salary),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        pre:    "Total Salary: ",
                        post:   getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(occupations[prop].totalPay),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "tag": occupations[prop].name
            });
        }

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        if(menuOptions.length == 0) {
            return;
        }

        showList(getString("general-labor"),menuOptions,onOccupationSelected,getString("general-nevermind"));
    }

    var pendingOccupationSalary;

    function onOccupationSelected(tag) {

        if(tag == null || tag == "back" || tag == "total") {
            showPolicyMenu();
            return;
        }

        var dialogOptions;

        if(tag == "payassist") {
            dialogOptions = {
                title: getString("general-online-pay-assis"),
                message: getString("online-payass-desc"),
                func: onCommonwealthPayRateBack
            };

            webAppCore.inputBox(dialogOptions);

            return;
        }

        pendingOccupationSalary = tag;

        dialogOptions = {
            title: "Salary",
            message: "Enter a new salary for the " + tag + " occupation.",
            func: onNewSalaryBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onCommonwealthPayRateBack(rate) {
        if(rate == null || rate.length == 0 || isNaN(rate) || parseInt(rate) < 0 || rate.trim().length == 0) {
            webAppCore.showToast("Invalid rate!");
            return;
        }

        rate = rate.replace("%","");

        currentGame.payrollRate = parseInt(rate) / 100;
        updateColonyStats();
        manageLabor();
    }

    function onNewSalaryBack(salary) {
        console.log(salary);
        if(salary == null || salary.length == 0 || isNaN(salary) || parseInt(salary) < 0 || salary.trim().length == 0) {
            webAppCore.showToast("Invalid salary!");
            return;
        }

        currentGame.salaries[pendingOccupationSalary] = parseInt(salary);
        manageLabor();
    }

    var pendingExecution;

    function enslaveColonist(colonist) {
        pendingExecution = colonist;

        webAppCore.showDialog({
            "title":    getString("general-conscript"),
            "message":  getString("conscript-confirm").replace("#colonist",pendingExecution.name),
            "op1": {
                "text":     getString("general-conscript"),
                "func":     conductEnslavment
            },
            "op2": {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            }
        });
    }

    function conductEnslavment() {
        if(!pendingExecution) {
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < ColonyGame.meta.conscriptionOptions.length; i++) {
            var vdef = getVehicleDefByName(ColonyGame.meta.conscriptionOptions[i]);

            menuOptions.push({
                "title":        vdef.name,
                "description":  getString(vdef.description),
                "icon":         "images/" + vdef.indicator,
                "tag":          vdef
            });
        }

        if(menuOptions.length > 0) {
            showList(getString("general-conscript"),menuOptions,finalizeEnslavement,getString("general-dismiss"));
        } else {
            webAppCore.showAlertWithTitle("Nothing to build at this time.","No Build Options");
        }
    }

    function finalizeEnslavement(option) {
        if(!option) {
            pendingExecution = null;
            return;
        }

        if(!pendingExecution) {
            return;
        }

        modifyResourceAmount(ColonyGame.meta.tenderResource,pendingExecution.money,false,"Colonist");

        pendingExecution.money = 0;
        pendingExecution.health = 0;

        doGlobalMoodModification(-45);

        if(usingSockets) {
            postMessageToAllChannels(currentGame.name + " has enslaved " + pendingExecution.name,"#F44336");
        }

        var freshVehicle = new Vehicle(option,pendingExecution.x,pendingExecution.y,0);
        currentGame.vehicles.push(freshVehicle); 
        unstickUnit(freshVehicle);
    }

    function executeColonist(colonist) {
        pendingExecution = colonist;

        webAppCore.showDialog({
            "title":    getString("general-execute"),
            "message":  getString("execute-confirm").replace("#colonist",pendingExecution.name),
            "op1": {
                "text":     getString("general-execute"),
                "func":     conductExecution
            },
            "op2": {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            }
        });
    }

    function conductExecution() {

        if(pendingExecution == null) {
            return;
        }


        modifyResourceAmount(ColonyGame.meta.tenderResource,pendingExecution.money,false,"Colonist");

        pendingExecution.money = 0;
        pendingExecution.health = 0;

        if(allowParticleEffects) {
            Scroll2d.playParticleEffect("bloodexplosion",pendingExecution.x,pendingExecution.y);
        }

        if(allowAudio && ColonyGame.sounds.execution != null) {
            webAppCore.playSoundEffect(ColonyGame.sounds.execution);
        }

        doGlobalMoodModification(-15);

        if(usingSockets) {
            postMessageToAllChannels(currentGame.name + " has executed " + pendingExecution.name,"#F44336");
        }


        pendingExecution = null;
    }

    function doGlobalMoodModification(amount) {
        for(var i = 0; i < currentGame.colonists.length; i++) {
            currentGame.colonists[i].happiness += amount;
            if(currentGame.colonists[i].happiness < 0) {
                currentGame.colonists[i].happiness = 0;
            }
        }
    }

    function checkBlacklist() {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(currentGame.offlineMode) {
            return;
        }

        if(!currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,28,onBlacklistCheck);

    }

    function onBlacklistCheck(result) {

        if(result != null && result.trim().length > 0) {
            if(result.trim() == "blacklist") {
                currentGame.hasCheated = true;
                currentGame.offlineMode = true;
                currentGame.charter = 0;
                currentGame.colonies = 0;
                currentGame.colonyId = 0;
                return;
            }
        }

        getColonyInfoFromServer();
    }

    function getColonyInfoFromServer() {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(!currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,24,onColonyInfoReturned);
    }

    function postInGameMessageToColony(message,color,colonyid) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = currentGame.themeColor;
        }

        var targetRoom = "colony-" + colonyid;

        var sender = currentGame.colonyId;
        var charter = currentGame.charter;

        webAppCore.socketEmit("gamemessage",{
            "destination": targetRoom,
            "msg": {
                "type": "colony",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": currentGame.name
            }
            
        });
    }

    function postMessageToAllChannels(message,color,customSenderId,customCharterId) {
        postToDiplomaticChannel(message,color,customSenderId,customCharterId);
        postInGameMessageToCommonwealth(message,color,customSenderId,customCharterId);
    }

    function postStargateMessage(message,color,customSenderId,customCharterId) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = currentGame.themeColor;
        }

        var sender = currentGame.colonyId;
        var charter = currentGame.charter;

        if(customSenderId) {
            sender = customSenderId;
        }

        if(customCharterId) {
            charter = customCharterId;
        }

        webAppCore.socketEmit("gamemessage",{
            "destination": "global-stargate",
            "msg": {
                "type": "stargate",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": currentGame.name
            }
            
        });
    }

    function postToDiplomaticChannel(message,color,customSenderId,customCharterId) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = currentGame.themeColor;
        }

        var targetRoom = "diplomatic-" + currentGame.colonyId;

        if(targetRoom == 0) {
            return;
        }

        var sender = currentGame.colonyId;
        var charter = currentGame.charter;

        if(customSenderId) {
            sender = customSenderId;
        }

        if(customCharterId) {
            charter = customCharterId;
        }

        webAppCore.socketEmit("gamemessage",{
            "destination": targetRoom,
            "msg": {
                "type": "diplomatic",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": currentGame.name
            }
            
        });
    }

    function postInGameMessageToCommonwealth(message,color,customSenderId,customCharterId) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = currentGame.themeColor;
        }

        var targetRoom = 0;

        if(currentGame.isIndependent) {
            targetRoom = "commonwealth-" + currentGame.colonyId;
        } else {
            if(currentGame.motherlandid != 0) {
                targetRoom =  "commonwealth-" + currentGame.motherlandid;
            }
        }

        if(targetRoom == 0) {
            return;
        }

        var sender = currentGame.colonyId;
        var charter = currentGame.charter;

        if(customSenderId) {
            sender = customSenderId;
        }

        if(customCharterId) {
            charter = customCharterId;
        }

        webAppCore.socketEmit("gamemessage",{
            "destination": targetRoom,
            "msg": {
                "type": "commonwealth",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": currentGame.name
            }
            
        });
    }

    function onColonyInfoReturned(result) {

        if(result != null || result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    return;
                }

                if(colonyInfo.blockonline == "1") {
                    currentGame.offlineMode = true;
                }

                currentGame.sX = colonyInfo.sectorx;
                currentGame.sY = colonyInfo.sectory;
                currentGame.gX = colonyInfo.gridx;
                currentGame.gY = colonyInfo.gridy;

                currentGame.charter = colonyInfo.charter;

                if(currentGame.isIndependent) {
                    setTimeout(getPendingEmbassyRequests,500);
                }

                if(isCreatingNewOnlineGame) {
                    isCreatingNewOnlineGame = false;

                    if(usingSockets) {
                        postInGameMessageToCommonwealth(currentGame.name + " has joined the Commonwealth of " + currentGame.motherland);
                    }
                }

            } catch(ex) {
                console.log(ex);
            }
        }
    }

    function takeColonyOffline() {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(!currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,26,placeholder);

        currentGame.offlineMode = true;
        currentGame.charter = 0;
        currentGame.colonies = 0;
        currentGame.colonyId = 0;
        currentGame.apiKey = 0;

        webAppCore.showToast({
            message: "Online Mode Disabled",
            image:   "images/" + ColonyGame.meta.offlineModeInd
        });

        saveGame();
    }

    var blacklistLogged = false;

    function blacklistColony() {
        if(!currentGame || currentGame == null) {
            return;
        }

        

        if(currentGame.hasCheated) {
            return;
        }


        if(!blacklistLogged) {
            webAppCore.logEvent("Blacklist","Triggered",currentGame.colonyId);
            blacklistLogged = true;
        }

        currentGame.hasCheated = true;

        if(currentGame.offlineMode || !currentGame.colonyId || currentGame.colonyId == 0) {
            saveGame();
            return;
        }

        var data = [];

        postSecuredCallToApi(data,27,placeholder);

        currentGame.offlineMode = true;
        currentGame.charter = 0;
        currentGame.colonies = 0;
        currentGame.colonyId = 0;

        webAppCore.showDialog({
            "title":    getString("general-notice"),
            "message":  getString("blacklist-notice"),
            "op1": {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            }
        });

        saveGame();
        
    }

    function setupResourceLedger() {
        resourceLedger = {};

        for(var prop in currentGame.resources) {
            resourceLedger[prop] = currentGame.resources[prop].amount;
        }
    }

    function modifyResourceAmount(resource,amount,zeroOut,source) {

        if(currentGame == null) {
            return;
        }

        if(resourceLedger == null) {
            setupResourceLedger();
        }

        if(currentGame.resources == null) {
            currentGame.resources = {};
        }

        if((currentGame.resources[resource].amount + amount) < 0) {
            return;
        }

        if(zeroOut) {
            resourceLedger[resource] = 0;
            currentGame.resources[resource].amount = 0;
        } else {
            resourceLedger[resource] += amount;
            currentGame.resources[resource].amount += amount;

            if(source) {
                if(amount > 0) {
                    if(!currentGame.resources[resource].inflows) {
                        currentGame.resources[resource].inflows = {};
                    }

                    if(!currentGame.resources[resource].inflows.current) {
                        currentGame.resources[resource].inflows.current = {};
                    }

                    if(!currentGame.resources[resource].inflows.total) {
                        currentGame.resources[resource].inflows.total = {};
                    }

                    if(!currentGame.resources[resource].inflows.allTime) {
                        currentGame.resources[resource].inflows.allTime = 0;
                    }

                    if(!currentGame.resources[resource].inflows.allCurrent) {
                        currentGame.resources[resource].inflows.allCurrent = 0;
                    }

                    if(!currentGame.resources[resource].inflows.current[source]) {
                        currentGame.resources[resource].inflows.current[source] = 0;
                    }

                    if(!currentGame.resources[resource].inflows.total[source]) {
                        currentGame.resources[resource].inflows.total[source] = 0;
                    }

                    currentGame.resources[resource].inflows.current[source] += amount;
                    currentGame.resources[resource].inflows.total[source] += amount;
                    currentGame.resources[resource].inflows.allTime += amount;
                    currentGame.resources[resource].inflows.allCurrent += amount;
                } else {
                    if(!currentGame.resources[resource].outflows) {
                        currentGame.resources[resource].outflows = {};
                    }

                    if(!currentGame.resources[resource].outflows.current) {
                        currentGame.resources[resource].outflows.current = {};
                    }

                    if(!currentGame.resources[resource].outflows.total) {
                        currentGame.resources[resource].outflows.total = {};
                    }

                    if(!currentGame.resources[resource].outflows.allTime) {
                        currentGame.resources[resource].outflows.allTime = 0;
                    }

                    if(!currentGame.resources[resource].outflows.allCurrent) {
                        currentGame.resources[resource].outflows.allCurrent = 0;
                    }

                    if(!currentGame.resources[resource].outflows.current[source]) {
                        currentGame.resources[resource].outflows.current[source] = 0;
                    }

                    if(!currentGame.resources[resource].outflows.total[source]) {
                        currentGame.resources[resource].outflows.total[source] = 0;
                    }

                    currentGame.resources[resource].outflows.current[source] += -amount;
                    currentGame.resources[resource].outflows.total[source] += -amount;
                    currentGame.resources[resource].outflows.allTime += -amount;
                    currentGame.resources[resource].outflows.allCurrent += -amount;
                }
            }
        }

        if(resource == ColonyGame.meta.tenderResource) {
            if(ColonyGame.meta.tenderResource.amount > 10000) {
                if(ColonyGame.achievements.tenthousandTender > 0) {
                    webAppCore.reportAchievement(ColonyGame.achievements.tenthousandTender);
                }
            }

            if(ColonyGame.meta.tenderResource.amount > 100000) {
                if(ColonyGame.achievements.hundredThousandTender > 0) {
                    webAppCore.reportAchievement(ColonyGame.achievements.hundredThousandTender);
                }
            }

            if(ColonyGame.meta.tenderResource.amount > 1000000) {
                if(ColonyGame.achievements.millionTender > 0) {
                    webAppCore.reportAchievement(ColonyGame.achievements.millionTender);
                }
            }
        }
        
    }

    function reconcileResources() {
        if(currentGame.hasCheated) {
            return;
        }

        if(resourceLedger == null) {
            return;
        }

        for(var prop in currentGame.resources) {
            if(resourceLedger[prop] != currentGame.resources[prop].amount) {
                blacklistColony();
                return;
            }
        }
    }

    function showResourcesScreen() {

        if(currentGame == null) {
            return;
        }

        var menuOptions = [];

        for(var prop in currentGame.resources) {

            if(!currentGame.resources[prop].unlocked) {
                continue;
            }

            if(!currentGame.resources[prop].inflows || !currentGame.resources[prop].outflows) {
                continue;
            }

            var nets = currentGame.resources[prop].inflows.allCurrent - currentGame.resources[prop].outflows.allCurrent;

            var netColor = "#4CAF50";

            if(nets <= 0) {
                netColor = "#F44336";
            }

            menuOptions.push({
                "title": prop,
                "title-color": null,
                "description": null,
                "status": "Select for more details",
                "status-color": null,
                "icon": "images/" + getResourceByDefName(prop).icon,
                "overflow": [
                    {
                        "pre":      "",
                        "post":     "Inflows: " + numberWithCommas(currentGame.resources[prop].inflows.allCurrent),
                        "color":    null,
                        "icon":     null
                    },
                    {
                        "pre":      "",
                        "post":     "Outflows: " + numberWithCommas(currentGame.resources[prop].outflows.allCurrent),
                        "color":    null,
                        "icon":     null
                    },
                    {
                        "pre":      "",
                        "post":     "Net: " + numberWithCommas(nets),
                        "color":    netColor,
                        "icon":     null
                    }
                ],
                "tag": prop
            });
        }

        

        if(menuOptions.length == 0) {
            return;
        }

        showList(getString("resources-header"),menuOptions,showChartsForResource,getString("general-nevermind"));
    }

    function sortFlows(a,b) {
        if(a.amount > b.amount) {
            return -1;
        }

        if(a.amount < b.amount) {
            return 1;
        }

        return 0;
    }

    function showChartsForResource(resource) {

        if(currentGame == null) {
            return;
        }

        if(currentGame.resources[resource] == null || currentGame.resources[resource].historic == null) {
            return;
        }

        var prop,i;

        document.getElementById("chartScreen").style.display = "block";
        document.getElementById("chartScreenTitle").innerHTML = resource;

        document.getElementById("resourceInflows").innerHTML = "";

        var inflowArray = [];

        if(currentGame.resources[resource].historic.inflows != null) {

            for(prop in currentGame.resources[resource].historic.inflows) {
                inflowArray.push({
                    "source":   prop,
                    "amount":   currentGame.resources[resource].historic.inflows[prop]
                });
            }
        }

        var inflowTotal = 0;

        if(inflowArray.length > 0) {

            inflowArray.sort(sortFlows);

            var topValue = inflowArray[0].amount;

            for(i = 0; i < inflowArray.length; i++) {

                inflowTotal += inflowArray[i].amount;

                var percent = Math.round((inflowArray[i].amount / topValue) * 100);

                var inflowItem = document.createElement("div");
                inflowItem.className = "flowItem";

                var inflowName = document.createElement("span");
                inflowName.className = "flowItemName";
                inflowName.innerHTML = inflowArray[i].source;
                inflowItem.appendChild(inflowName);

                var inflowBarHolder = document.createElement("div");
                inflowBarHolder.className = "flowItemBarHolder";

                var inflowBar = document.createElement("div");
                inflowBar.className = "flowItemBar inflowBar";
                inflowBar.style.width = percent + "%";
                inflowBarHolder.appendChild(inflowBar);

                var inflowAmount = document.createElement("span");
                inflowAmount.className = "flowAmount";
                inflowAmount.innerHTML = numberWithCommas(inflowArray[i].amount);
                inflowBarHolder.appendChild(inflowAmount);

                inflowItem.appendChild(inflowBarHolder);

                document.getElementById("resourceInflows").appendChild(inflowItem);
            }
        }

        var inflowTotalSpan = document.createElement("span");
        inflowTotalSpan.innerHTML = "Total Inflows: " + numberWithCommas(inflowTotal);
        inflowTotalSpan.className = "flowTotalItem";
        document.getElementById("resourceInflows").appendChild(inflowTotalSpan);


        document.getElementById("resourceOutflows").innerHTML = "";

        var outflowArray = [];

        if(currentGame.resources[resource].historic.outflows != null) {

            for(prop in currentGame.resources[resource].historic.outflows) {
                outflowArray.push({
                    "source":   prop,
                    "amount":   currentGame.resources[resource].historic.outflows[prop]
                });
            }
        }

        var totalOutflow = 0;

        if(outflowArray.length > 0) {

            outflowArray.sort(sortFlows);
            

            topValue = outflowArray[0].amount;

            

            for(i = 0; i < outflowArray.length; i++) {

                totalOutflow += outflowArray[i].amount;

                var percentb = Math.round((outflowArray[i].amount / topValue) * 100);

                var ofItem = document.createElement("div");
                ofItem.className = "flowItem";

                var ofName = document.createElement("span");
                ofName.className = "flowItemName";
                ofName.innerHTML = outflowArray[i].source;
                ofItem.appendChild(ofName);

                var ofBarHolder = document.createElement("div");
                ofBarHolder.className = "flowItemBarHolder";

                var ofBar = document.createElement("div");
                ofBar.className = "flowItemBar outflowBar";
                ofBar.style.width = percentb + "%";
                ofBarHolder.appendChild(ofBar);

                var ofAmount = document.createElement("span");
                ofAmount.className = "flowAmount";
                ofAmount.innerHTML = numberWithCommas(outflowArray[i].amount);
                ofBarHolder.appendChild(ofAmount);

                ofItem.appendChild(ofBarHolder);

                document.getElementById("resourceOutflows").appendChild(ofItem);
            }

            var ioutflowTotalSpan = document.createElement("span");
            ioutflowTotalSpan.innerHTML = "Total Outflows: " + numberWithCommas(totalOutflow);
            ioutflowTotalSpan.className = "flowTotalItem";
            document.getElementById("resourceOutflows").appendChild(ioutflowTotalSpan);
        }

        var resourceTrendChart = document.getElementById("resourceTrendChart");

        var trendColor = "#689F38";

        if(totalOutflow > inflowTotal) {
            trendColor = "#F44336";
        }

        if(totalOutflow == inflowTotal) {
            trendColor = "#2196F3";
        }

        drawLineChart(resourceTrendChart,currentGame.resources[resource].trend,null,null,trendColor);

    }


    function setSalesPitch() {
        var dialogOptions = {
            title: getString("pol-salespitch-header"),
            message: getString("pol-salespitch-desc"),
            func: onSalesPitchSet
        };

        webAppCore.inputBox(dialogOptions);
    }
    
    function onSalesPitchSet(message) {
        if(message == null) {
            return;
        }

        if(message.trim().length > 100) {
            webAppCore.showToast("Too many characters (" + message.trim().length + ")");
        }

        if(message.trim().length == 0) {
            currentGame.salesPitch = "0";
        } else {
            currentGame.salesPitch = message.trim();
        }

        updateColonyStats();

        showPolicyMenu();
    }

    var tmpNewMsgTo = null;

    function sendCommonwealthEdict() {
        var dialogOptions = {
            title: getString("general-mass-message"),
            message: getString("general-mass-msg-desc"),
            func: onEdictSend
        };

        webAppCore.inputBox(dialogOptions);
        
    }

    function onEdictSend(message) {
        if(message == null || message.trim().length < 2 || message.trim().length > 120) {
            webAppCore.showToast("Invalid message length!");
            return;
        }

        message = replaceAll(message,"\"","");
        message = replaceAll(message,"'","");

        var data = [];

        data.push({
            "key":      "c",
            "value":    currentGame.charter
        });

        data.push({
            "key":      "m",
            "value":    message
        });

        postSecuredCallToApi(data,31,function() {
            webAppCore.showToast("Message Sent");
        });

    }


    function sendACustomMessage(to) {

        tmpNewMsgTo = to;

        var dialogOptions = {
            title: getString("general-send-custom-msg"),
            message: getString("general-send-msg-warn"),
            func: onCWMessageSend
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onCWMessageSend(message) {

        if(message == null || message.trim().length < 2 || message.trim().length > 120) {
            webAppCore.showToast("Invalid message length!");
            return;
        }

        if(tmpNewMsgTo == null || tmpNewMsgTo == 0) {
            return;
        }

        message = replaceAll(message,"\"","");
        message = replaceAll(message,"'","");

        sendMessage(tmpNewMsgTo,0,0,message.trim().latinize(),sendMsgConfirm);

        if(tmpHoldingMessage != null) {
            showStandardMessage(tmpHoldingMessage);
        }
    }

    function sendMsgConfirm() {
        webAppCore.showToast("Message Sent");

        if(tmpNewMsgTo == null) {
            return;
        }

        if(usingSockets) {
            postInGameMessageToColony("checkmail",null,tmpNewMsgTo);
        }  
    }

    function onSocketConnect() {
        usingSockets = true;

        console.log("socket connected");

        if(currentGame != null && currentGame.colonyId != 0) {
            webAppCore.socketEmit("joinroom","colony-" + currentGame.colonyId);
            webAppCore.socketEmit("joinroom","diplomatic-" + currentGame.colonyId);

            postToDiplomaticChannel(currentGame.name + " is online");

            if(currentGame.isIndependent) {
                webAppCore.socketEmit("joinroom","commonwealth-" + currentGame.colonyId);
                postInGameMessageToCommonwealth(currentGame.name + " is online");
            } else {
                if(currentGame.motherlandid != 0) {
                    webAppCore.socketEmit("joinroom","commonwealth-" + currentGame.motherlandid);
                    postInGameMessageToCommonwealth(currentGame.name + " is online");
                }
            }

            // join embassy diplomatic channels 
            for(var i = 0; i < currentGame.buildings.length; i++) {
                var def = getBuildingDefByName(currentGame.buildings[i].def);
                if(def.isEmbassy) {
                    webAppCore.socketEmit("joinroom","diplomatic-" + currentGame.buildings[i].embassyFor);
                }
            }

            // join stargate channel 
            if(hasStargate) {
                webAppCore.socketEmit("joinroom","global-stargate");
                postStargateMessage(currentGame.name + " has entered stargate channel");
            }
        }
    }

    

    function onSocketDisconnect() {
        usingSockets = false;

        console.log("socket disconnected");
    }

    function createNotification(icon,text,color,callback,tag) {
        var notification = document.createElement("div");
        notification.className = "notification";

        if(tag) {
            notification.tag = tag;
        }

        

        var notificationIcon = document.createElement("img");
        notificationIcon.src = icon;
        notificationIcon.className = "notificationIcon";
        notification.appendChild(notificationIcon);

        var notificationText = document.createElement("span");
        notificationText.className = "notificationText";

        if(callback) {
            notificationText.onclick = callback;
        }

        if(color) {
            notificationText.style.color = color;
        }

        notificationText.innerHTML = text;
        notification.appendChild(notificationText);

        var notificationX = document.createElement("span");
        notificationX.className = "notificationX";
        notificationX.innerHTML = "X";
        notificationX.notifRef = notification;
        notificationX.onclick = function() {

            if(this.notifRef.timerRef) {
                clearTimeout(this.notifRef.timerRef);
            }

            if(this.notifRef.parentNode == null) {
                return;
            }

            this.notifRef.parentNode.removeChild(this.notifRef);
        };
        notification.appendChild(notificationX);

        if(text.indexOf(" is online") > 0) {
            notification.timerRef = setTimeout(function() {
                if(notification.parentElement) {
                    notification.parentElement.removeChild(notification);
                }
            },15000);
        }

        return notification;
    }

    function onSocketMessage(message) {

        if(currentGame == null) {
            return;
        }

        var notifyicon = "images/" + ColonyGame.meta.empireIndicator;

        var callback;

        if(message.type == "stargate") {
            

            if(message.message.immigrant) {
                // a 5% chance to take this immigrant 
                var immigrantchance = randomIntFromInterval(0,100);

                if(immigrantchance < 5) {
                    

                    if(openStargateArray.length > 0) {

                        currentGame.immigrantSources.push(message.senderName);

                        currentGame.totalImmigration++;

                        while(currentGame.immigrantSources.length > 400) {
                            currentGame.immigrantSources.shift();
                        }

                        var useStargate = openStargateArray[0];

                        var freshVehicle = new Colonist(useStargate.x,useStargate.y,false,message.message.immigrant.race);
                        setupNewColonist(freshVehicle);

                        freshVehicle.age = parseInt(message.message.immigrant.age);
                        freshVehicle.money = parseInt(message.message.immigrant.money);
                        freshVehicle.name = message.message.immigrant.name;

                        if(freshVehicle.name == "NaN") {
                            setColonistName(object);
                        }

                        if(message.message.immigrant.iq) {
                            freshVehicle.iQ = parseInt(message.message.immigrant.iq);
                            if(freshVehicle.iQ < 40) {
                                freshVehicle.iQ = randomIntFromInterval(40,110);
                            }
                        }

                        setColonistMask(freshVehicle,"IS_DIPLOMAT",false);
                        setColonistMask(freshVehicle,"IS_TOURIST",false);
                        currentGame.colonists.push(freshVehicle);

                        if(currentGame.populationStats[message.message.immigrant.race] === undefined) {
                            currentGame.populationStats[message.message.immigrant.race] = 0;
                        }

                        currentGame.populationStats[message.message.immigrant.race]++;

                        var thepop = getTotalPopulation();

                        if(thepop > currentGame.availableShelters) {
                            setColonistMask(freshVehicle,"IS_ILLEGAL",true);
                        } else {
                            setColonistMask(freshVehicle,"IS_ILLEGAL",false);
                        }
                    }
                }
            }

        }

        if(message.type == "colony") {

            if(message.message == "checkmail") {
                checkMail();
                return;
            }

            if(message.message.aid) {
                if(message.message.aid.info == "aidpackage") {
                    for(var i = 0; i < currentGame.colonists.length; i++) {
                        currentGame.colonists[i].money += 100;
                    }

                    webAppCore.showDialog({
                        "title":    "Humanitarian Aid",
                        "message":  message.message.aid.from + " has dropped " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt((message.message.aid.amount))) + " onto your colony."
                    });
                    
                }
            }

            if(message.message == "checkvitals") {

                var response = {
                    "vitals": {
                        "info": "sendvitals",
                        "anarchy": anarchyWarned,
                        "rioting": riotingWarned,
                        "famine": famineWarned,
                        "dehydration": noWaterWarned,
                        "charter": currentGame.charter
                    }
                };

                postInGameMessageToColony(response,null,message.senderid);
                return;
            }

            if(tmpNegoiationColony != null && message.message.vitals && message.message.vitals.info == "sendvitals") {

                if(message.message.vitals.charter && message.message.vitals.charter == tmpNegoiationColony.charter) {
                    if(message.message.vitals.anarchy || message.message.vitals.rioting) {
                        if(currentGame.resources[ColonyGame.meta.tenderResource].amount > (tmpNegoiationColony.population * 100)) {
                            document.getElementById("colonyCoinShower").style.display = "initial";
                            document.getElementById("colonyCoinShower").onclick = function() {
                                webAppCore.showDialog({
                                    "title":    "Humanitarian Aid",
                                    "message":  tmpNegoiationColony.name + " has fallen into chaos.  Would you like to send a humanitarian aid package worth " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt((tmpNegoiationColony.population * 100))) + "?  The money will go straight to the colonists, not the colony owner.",
                                    "op1": {
                                        "text":     getString("general-yes"),
                                        "func":     function() {
                                            if(tmpNegoiationColony == null) {
                                                return;
                                            }

                                            var response = {
                                                "aid": {
                                                    "info": "aidpackage",
                                                    "resource": anarchyWarned,
                                                    "amount": parseInt(tmpNegoiationColony.population) * 100,
                                                    "from": currentGame.name
                                                }
                                            };

                                            postInGameMessageToColony(response,currentGame.themeColor,tmpNegoiationColony.id);

                                            modifyResourceAmount(ColonyGame.meta.tenderResource,-(parseInt(tmpNegoiationColony.population) * 100),false,"Humanitarian Aid");
                                        }
                                    },
                                    "op2": {
                                        "text":     getString("general-no"),
                                        "func":     placeholder
                                    }
                                });
                            };
                        }
                    }
                }

                return;
            }
        }

        if(message.type == "commonwealth" || message.type == "diplomatic") {

            if(message.type == "diplomatic") {
                notifyicon = "images/" + ColonyGame.meta.diplomacyIndicator;
            }

            if(message.message == "onlineping") {
                if(message.type == "diplomatic") {
                    postToDiplomaticChannel("onlinepong");
                } else {
                    postInGameMessageToCommonwealth("onlinepong");
                }
                
                return;
            }

            if(message.message == "onlinepong") {
                commonwealthOnlineColonies++;
                
                commonwealthPongFrom(message.senderid);
                return;
            }

            callback = function() {
                getColonyInfoAndLaunchInfo(message.senderid);
                this.parentNode.parentNode.removeChild(this.parentNode);
            };

            // on executions, lower colony happiness 
            if(message.message.indexOf(" has executed ") > -1) {
                doGlobalMoodModification(-3);

                if(message.senderName && currentGame.resources[ColonyGame.meta.transactionCostResource].amount >= 5) {
                    callback = function() {
                        

                        var msg = message.senderName + ", a member of our " + getString("empire-general") + ", has publicly executed one of its citizens.  For 5 " + ColonyGame.meta.transactionCostResource + ", you may publicly condemn their action across the Commonwealth.  Your people will approve of your leadership.";

                        webAppCore.showDialog({
                            "title":    getString("general-condemn") + " " + message.senderName,
                            "message":  msg,
                            "op1": {
                                "text":     getString("general-condemn"),
                                "func":     function() {
                                    doGlobalMoodModification(2);

                                    if(message.type == "diplomatic") {
                                        postToDiplomaticChannel(currentGame.name + " condemns " + message.senderName + "'s execution.");
                                    } else {
                                        postInGameMessageToCommonwealth(currentGame.name + " condemns " + message.senderName + "'s execution.");
                                    }

                                    
                                }
                            },
                            "op2": {
                                "text":     getString("general-no"),
                                "func":     placeholder
                            }
                        });

                        this.parentNode.parentNode.removeChild(this.parentNode);
                    };
                }
            }

            var newNotification = createNotification(notifyicon,message.message,message.sendercolor,callback,message);

            document.getElementById("notificationArea").appendChild(newNotification);
        }

        if(message.type == "trade") {

            if(gbtOpen) {

                var resource = getResourceByServerId(message.resource);

                if(resource == null) {
                    return;
                }

                var unitPrice = Math.round(parseInt(message.price) / parseInt(message.amount));
                var hundoPrice = unitPrice * 100;

                var tradeColor = null;

                if(hundoPrice > currentGame.resources[resource.name].lastTrade) {
                    tradeColor = "#33691E";
                }

                if(hundoPrice < currentGame.resources[resource.name].lastTrade) {
                    tradeColor = "#B71C1C";
                }

                if(resource != null) {
                    if(message.action == "purchased") {

                        if(showingLive) {
                            updateLivePrice(message.resource,hundoPrice);
                        }


                        if(hundoPrice > currentGame.resources[resource.name].lastTrade) {
                            tradeColor = "#33691E";
                        }

                        if(hundoPrice < currentGame.resources[resource.name].lastTrade) {
                            tradeColor = "#B71C1C";
                        }


                        addItemToNewsTicker("Sold: " + numberWithCommas(parseInt(message.amount)) + " " + resource.name + " @ " + numberWithCommas(hundoPrice) + " per 100",tradeColor,function() {
                            populateNewGbtResources({
                                "id": message.resource,
                                "name": resource.name,
                                "price": currentGame.resources[resource.name].price,
                                "detailed": {
                                    "last": currentGame.resources[resource.name].lastTrade
                                }
                            });
                        },true);
                    }

                    if(message.action == "posted") {

                        var opacity = 1;
                        callback = undefined;
                        var contractItem;

                        if(message.contract == "1") {
                            if(hundoPrice > currentGame.resources[resource.name].lastTrade) {
                                tradeColor = "#33691E";
                            }

                            if(hundoPrice < currentGame.resources[resource.name].lastTrade) {
                                tradeColor = "#B71C1C";
                            }

                            if(parseInt(message.amount) > currentGame.resources[resource.name].amount) {
                                opacity = .4;
                            }

                            if(!isThereResourceCapacity(resource.name,parseInt(message.amount))) {
                                opacity = .4;
                            }
                            
                            if(opacity == 1) {
                                callback = function() {
                                    contractItem = {
                                        "fromTicker": true,
                                        "resourceName": resource.name,
                                        "contractRef": {
                                            "id": message.id,
                                            "isoffer": message.contract,
                                            "quantity": message.amount,
                                            "price": message.price,
                                            "resourceid": parseInt(message.resource),
                                            "sellerid": parseInt(message.trader)
                                        }
                                    };

                                    purchaseNewGBTContract(contractItem);
                                };
                            }


                            addItemToNewsTicker("Will Buy: " + numberWithCommas(parseInt(message.amount)) + " " + resource.name + " for " + numberWithCommas(parseInt(message.price)) + " @ " + numberWithCommas(hundoPrice) + " per 100",tradeColor,callback,true,opacity);
                        } else {

                            if(hundoPrice > currentGame.resources[resource.name].lastTrade) {
                                tradeColor = "#B71C1C";
                            }

                            if(hundoPrice < currentGame.resources[resource.name].lastTrade) {
                                tradeColor = "#33691E";
                            }

                            

                            if(parseInt(message.price) > currentGame.resources[ColonyGame.meta.tenderResource].amount) {
                                opacity = .4;
                            }

                            if(opacity == 1) {
                                callback = function() {
                                    contractItem = {
                                        "fromTicker": true,
                                        "resourceName": resource.name,
                                        "contractRef": {
                                            "id": message.id,
                                            "isoffer": message.contract,
                                            "quantity": message.amount,
                                            "price": message.price,
                                            "resourceid": parseInt(message.resource),
                                            "sellerid": parseInt(message.trader)
                                        }
                                    };

                                    purchaseNewGBTContract(contractItem);
                                };
                            }

                            addItemToNewsTicker("For Sale: " + numberWithCommas(message.amount) + " " + resource.name + " @ " + numberWithCommas(hundoPrice) + " per 100 for " + numberWithCommas(parseInt(message.price)),tradeColor,callback,true,opacity);
                        }
                        
                    }
                }
                
            }
        }
    }
    
    var musicPlaying = false;
    var musicLineup = [];
    
    function initSoundtrack() {
        if(!allowMusic) {
            return;
        }
        
        if(!ColonyGame.soundtrack || ColonyGame.soundtrack.length == 0) {
            return;
        }
        
        if(musicPlaying) {
            return;
        }
        
        if(titleShowing) {
            return;
        }
        
        musicLineup = [];
        
        playNextSong();
    }
    
    function playNextSong() {
        
        if(titleShowing) {
            musicLineup = [];
            return;
        }
        
        if(!allowMusic) {
            return;
        }
        
        if(musicLineup.length == 0) {
            
            musicLineup = [];
            
            for(var i = 0; i < ColonyGame.soundtrack.length; i++) {
                musicLineup.push({
                    "title":	ColonyGame.soundtrack[i].title,
                    "format":	ColonyGame.soundtrack[i].format,
                    "seconds":	ColonyGame.soundtrack[i].seconds
                });
            }
            
            musicLineup = shuffle(musicLineup);
        }
        
        var songToPlay = musicLineup.shift();

        if(songToPlay.format == "midi") {
            webAppCore.playMidi(songToPlay.title,songToPlay.seconds,false,playNextSong);
        }
        
        if(songToPlay.format == "mp3") {
            // will handle eventually
        }
        
        musicPlaying = true;
    }
    
    function stopSoundtrack() {
        webAppCore.stopMidi();
        musicPlaying = false;
    }

    function getDataUri(url, callback, w,h, img) {

        allPrintImages++;

        var image = new Image();

        image

        image.onload = function () {

            if(!h) {
                h = this.naturalHeight;
                w = this.naturalWidth;
            }

            var canvas = document.createElement("canvas");
            canvas.width = w * 2; 
            canvas.height = h * 2; 

            canvas.getContext("2d").drawImage(this, 0, 0,w * 2,h * 2);

            callback(canvas.toDataURL("image/png"),img);
        };

        image.src = url;
    }

    var allPrintImages = 0;
    var loadedPrintImages = 0;
    var mainPrintHolder;

    function conductPrint() {
        

        if(allPrintImages == loadedPrintImages) {
            webAppCore.printHTML(mainPrintHolder.outerHTML);
            webAppCore.logEvent("Printout Manual","Printed",webAppCore.getPlatform().platform);
        }
    }

    function setPrintSrc(data,image) {

        image.src = data;

        loadedPrintImages++;

        conductPrint();
    }

    function generatePrintoutEncyclopedia() {
        allPrintImages = 0;
        loadedPrintImages = 0;

        var i,j,res;

        mainPrintHolder = document.createElement("div");

        mainPrintHolder.style.fontSize = "0.8em";

        // top section
        var topHeader = document.createElement("div");
        topHeader.style.textAlign = "center";

        var topHeading = document.createElement("h1");
        topHeading.innerHTML = ColonyGame.meta.name + " " + getString("owners-manual-header");
        topHeader.appendChild(topHeading);

        var versionHeading = document.createElement("strong");
        versionHeading.innerHTML = "v" + ColonyGame.meta.buildVersion + " (" + webAppCore.getPlatform().platform + ")";
        topHeader.appendChild(versionHeading);
        mainPrintHolder.appendChild(topHeader);


        // intro section 
        var introParagraph = document.createElement("p");
        introParagraph.innerHTML = getString("owners-manual-intro");
        mainPrintHolder.appendChild(introParagraph);

        // civilizations 
        var civHeader = document.createElement("h2");
        civHeader.style.textAlign = "center";
        civHeader.innerHTML = getString("general-civs");
        mainPrintHolder.appendChild(civHeader);


        for(i = 0; i < ColonyGame.civilizations.length; i++) {

            var civItemHold = document.createElement("div");
            civItemHold.style.borderBottom = "1px solid #ddd";
            civItemHold.style.padding = "8px";

            var civItemTitle = document.createElement("h3");
            
            var civItemIcon = document.createElement("img");
            civItemIcon.style.height = "28px";
            civItemIcon.style.width = "28px";
            civItemIcon.style.marginRight = "12px";
            civItemIcon.style.position = "relative";
            civItemIcon.style.top = "4px";
            civItemTitle.appendChild(civItemIcon);

            getDataUri("images/" + ColonyGame.civilizations[i].icon, setPrintSrc, 28,28,civItemIcon);


            var civItemNameSpan = document.createElement("span");
            civItemNameSpan.innerHTML = ColonyGame.civilizations[i].name;
            civItemTitle.appendChild(civItemNameSpan);

            civItemHold.appendChild(civItemTitle);


            var civItemDesc = document.createElement("p");
            civItemDesc.innerHTML = getString(ColonyGame.civilizations[i].description);
            civItemHold.appendChild(civItemDesc);

            var civItemSpecies = document.createElement("p");
            civItemSpecies.innerHTML = "<strong>Species:</strong> " + ColonyGame.civilizations[i].race;
            civItemHold.appendChild(civItemSpecies);

            var civItemPlanetTypesTitle = document.createElement("h4");
            civItemPlanetTypesTitle.innerHTML = getString("general-maps-available");
            civItemHold.appendChild(civItemPlanetTypesTitle);


            var civMapsList = document.createElement("ul");

            for(j = 0; j < ColonyGame.mapTypes.length; j++) {
                if(ColonyGame.civilizations[i].availableMaps.indexOf(ColonyGame.mapTypes[j].name) > -1) {

                    var mapTypeListItem = document.createElement("li");


                    var mapTypeListIcon = document.createElement("img");
                    mapTypeListIcon.style.height = "24px";
                    mapTypeListIcon.style.width = "24px";
                    mapTypeListIcon.style.marginRight = "12px";
                    mapTypeListIcon.style.position = "relative";
                    mapTypeListIcon.style.top = "4px";
                    mapTypeListItem.appendChild(mapTypeListIcon);

                    getDataUri("images/" + ColonyGame.mapTypes[j].icon, setPrintSrc, 24,24,mapTypeListIcon);


                    var mapTypeListTitle = document.createElement("span");
                    mapTypeListTitle.innerHTML = ColonyGame.mapTypes[j].name;
                    mapTypeListItem.appendChild(mapTypeListTitle);


                    civMapsList.appendChild(mapTypeListItem);

                }
            }

            civItemHold.appendChild(civMapsList);


            var citItemStartingTechsHeading = document.createElement("h4");
            citItemStartingTechsHeading.innerHTML = getString("general-starting-techs");
            civItemHold.appendChild(citItemStartingTechsHeading);


            var civTechsListing = document.createElement("ul");

            for(j = 0; j < ColonyGame.civilizations[i].startingTechs.length; j++) {

                var civStartingTechItem = document.createElement("li");
                civStartingTechItem.innerHTML = ColonyGame.civilizations[i].startingTechs[j];
                civTechsListing.appendChild(civStartingTechItem);
            }

            civItemHold.appendChild(civTechsListing);



            if(ColonyGame.civilizations[i].startingBuilding != null) {

                var vicStartingBuilding = document.createElement("h4");
                vicStartingBuilding.innerHTML = getString("general-starting-building");
                civItemHold.appendChild(vicStartingBuilding);


                var startingBuildingOneItemListLol = document.createElement("ul");

                var startingBuildingOneItemListLolItem = document.createElement("li");
                

                var sBldDef = getBuildingDefByName(ColonyGame.civilizations[i].startingBuilding);

                var startingCivBuildingIcon = document.createElement("img");
                startingCivBuildingIcon.style.height = "24px";
                startingCivBuildingIcon.style.width = "24px";
                startingCivBuildingIcon.style.marginRight = "12px";
                startingCivBuildingIcon.style.position = "relative";
                startingCivBuildingIcon.style.top = "4px";
                startingBuildingOneItemListLolItem.appendChild(startingCivBuildingIcon);


                getDataUri(gameAssets[sBldDef.tile[0]][0].image.src, setPrintSrc, 24,24,startingCivBuildingIcon);


                var startingCivBuildingDName = document.createElement("span");
                startingCivBuildingDName.innerHTML = sBldDef.name;
                startingBuildingOneItemListLolItem.appendChild(startingCivBuildingDName);


                startingBuildingOneItemListLol.appendChild(startingBuildingOneItemListLolItem);

                civItemHold.appendChild(startingBuildingOneItemListLol);

            }


            mainPrintHolder.appendChild(civItemHold);
        }


        // resources section 
        var resTable = document.createElement("table");
        resTable.style.width = "100%";
        resTable.style.marginTop = "12px";

        //  resource header
        var resHeaderArea = document.createElement("thead");
        

        var resCaption = document.createElement("caption");

        var resHeader = document.createElement("h2");
        resHeader.innerHTML = getString("resources-header");
        resCaption.appendChild(resHeader);

        resHeaderArea.appendChild(resCaption);

        var resHeadRow = document.createElement("tr");

        var resHeadName = document.createElement("th");
        resHeadName.style.borderBottom = "1px solid #ddd";
        resHeadName.style.padding = "8px";

        resHeadName.innerHTML = "Resource";
        resHeadRow.appendChild(resHeadName);

        var resHeadIcon = document.createElement("th");
        resHeadIcon.style.borderBottom = "1px solid #ddd";
        resHeadIcon.style.padding = "8px";

        resHeadIcon.innerHTML = "Icon";
        resHeadRow.appendChild(resHeadIcon);

        var resHeadIndicator = document.createElement("th");
        resHeadIndicator.style.borderBottom = "1px solid #ddd";
        resHeadIndicator.style.padding = "8px";

        resHeadIndicator.innerHTML = "Indicator";
        resHeadRow.appendChild(resHeadIndicator);

        var resHeadColor = document.createElement("th");
        resHeadColor.style.borderBottom = "1px solid #ddd";
        resHeadColor.style.padding = "8px";

        resHeadColor.innerHTML = "Color";
        resHeadRow.appendChild(resHeadColor);

        var resHeadSources = document.createElement("th");
        resHeadSources.style.borderBottom = "1px solid #ddd";
        resHeadSources.style.padding = "8px";

        resHeadSources.innerHTML = "Sources";
        resHeadRow.appendChild(resHeadSources);

        resHeaderArea.appendChild(resHeadRow);

        resTable.appendChild(resHeaderArea);


        //  tablebody

        var resBody = document.createElement("tbody");

        for(i = 0; i < ColonyGame.resources.length; i++) {
            res = ColonyGame.resources[i];

            var resMainRow = document.createElement("tr");
            

            var resMainName = document.createElement("td");
            resMainName.style.borderBottom = "1px solid #ddd";
            resMainName.style.padding = "8px";

            resMainName.innerHTML = res.name;
            resMainRow.appendChild(resMainName);

            var resMainIcon = document.createElement("td");
            resMainIcon.style.borderBottom = "1px solid #ddd";
            resMainIcon.style.padding = "8px";
            
            var resourceItemImage = document.createElement("img");
            resourceItemImage.style.height = "24px";
            resourceItemImage.style.width = "24px";
            resMainName.style.borderBottom = "1px solid #ddd";
            resMainIcon.appendChild(resourceItemImage);

            getDataUri("images/" + res.icon, setPrintSrc, 24,24,resourceItemImage);

            resMainRow.appendChild(resMainIcon);

            var resMainIndicator = document.createElement("td");
            resMainIndicator.style.borderBottom = "1px solid #ddd";
            resMainIndicator.style.padding = "8px";

            resMainIndicator.innerHTML = res.indicator;
            resMainRow.appendChild(resMainIndicator);

            var resMainColor = document.createElement("td");
            resMainColor.style.borderBottom = "1px solid #ddd";
            resMainColor.style.padding = "8px";

            var resourceColorPreview = document.createElement("div");
            resourceColorPreview.style.marginRight = "12px";
            resourceColorPreview.style.borderStyle = "solid";
            resourceColorPreview.style.borderWidth = "1px";
            resourceColorPreview.style.borderColor = "#333333";
            resourceColorPreview.style.height = "16px";
            resourceColorPreview.style.width = "16px";
            resourceColorPreview.style.backgroundColor = res.color;
            resourceColorPreview.style.position = "relative";
            resourceColorPreview.style.top = "3px";
            resourceColorPreview.style.display = "inline-block";
            resMainColor.appendChild(resourceColorPreview);

            var resourceItemIdicationSpan = document.createElement("span");
            resourceItemIdicationSpan.innerHTML = res.color;
            resMainColor.appendChild(resourceItemIdicationSpan);

            resMainRow.appendChild(resMainColor);

            var resMainSources = document.createElement("td");
            resMainSources.style.borderBottom = "1px solid #ddd";
            resMainSources.style.padding = "8px";

            var resSourceDiv,resSourceItemImage,resSourceItemName;

            for(j = 0; j < ColonyGame.terrains.length; j++) {
                if(ColonyGame.terrains[j].provides == res.name) {
                    resSourceDiv = document.createElement("div");

                    resSourceItemImage = document.createElement("img");
                    resSourceItemImage.style.marginRight = "6px";
                    resSourceItemImage.style.height = "24px";
                    resSourceItemImage.style.width = "24px";
                    resSourceItemImage.style.position = "relative";
                    resSourceItemImage.style.top = "7px";
                    resSourceDiv.appendChild(resSourceItemImage);

                    getDataUri("images/" + ColonyGame.terrains[j].icon, setPrintSrc, 48,48,resSourceItemImage);

                    resSourceItemName = document.createElement("span");
                    resSourceItemName.innerHTML = ColonyGame.terrains[j].name;
                    resSourceDiv.appendChild(resSourceItemName);

                    resMainSources.appendChild(resSourceDiv);
                }

                
            }

            for(j = 0; j < ColonyGame.buildings.length; j++) {
                if(ColonyGame.buildings[j].generates == res.name || (ColonyGame.buildings[j].smelts != null && ColonyGame.buildings[j].smelts.output == res.name)) {
                    resSourceDiv = document.createElement("div");

                    resSourceItemImage = document.createElement("img");
                    resSourceItemImage.style.marginRight = "6px";
                    resSourceItemImage.style.height = "24px";
                    resSourceItemImage.style.width = "24px";
                    resSourceItemImage.style.position = "relative";
                    resSourceItemImage.style.top = "7px";
                    resSourceDiv.appendChild(resSourceItemImage);

                    var img;

                    if(ColonyGame.buildings[j].indicator == null) {
                        img = gameAssets[ColonyGame.buildings[j].tile[0]][0].image.src;
                    } else {
                        img = "images/" + ColonyGame.buildings[j].indicator;
                    }

                    getDataUri(img, setPrintSrc, 48,48,resSourceItemImage);

                    resSourceItemName = document.createElement("span");
                    resSourceItemName.innerHTML = ColonyGame.buildings[j].name;
                    resSourceDiv.appendChild(resSourceItemName);

                    resMainSources.appendChild(resSourceDiv);
                }
            }
            
            resMainRow.appendChild(resMainSources);


            resBody.appendChild(resMainRow);
        }

        resTable.appendChild(resBody);

        mainPrintHolder.appendChild(resTable);






        // techs section 
        var techTable = document.createElement("table");
        techTable.style.width = "100%";
        techTable.style.marginTop = "60px";

        //  resource header
        var tectHeaderArea = document.createElement("thead");
        

        var techCaption = document.createElement("caption");

        var techHeader = document.createElement("h2");
        techHeader.innerHTML = getString("enc-tech-header");
        techCaption.appendChild(techHeader);

        tectHeaderArea.appendChild(techCaption);

        var techHeadRow = document.createElement("tr");

        var techHeadName = document.createElement("th");
        techHeadName.style.borderBottom = "1px solid #ddd";
        techHeadName.style.padding = "8px";

        techHeadName.innerHTML = "Tech";
        techHeadRow.appendChild(techHeadName);

        var techHeadIcon = document.createElement("th");
        techHeadIcon.style.borderBottom = "1px solid #ddd";
        techHeadIcon.style.padding = "8px";

        techHeadIcon.innerHTML = "Icon";
        techHeadRow.appendChild(techHeadIcon);

        var techHeadIndicator = document.createElement("th");
        techHeadIndicator.style.borderBottom = "1px solid #ddd";
        techHeadIndicator.style.padding = "8px";

        techHeadIndicator.innerHTML = "Info";
        techHeadRow.appendChild(techHeadIndicator);

        var techHeadColor = document.createElement("th");
        techHeadColor.style.borderBottom = "1px solid #ddd";
        techHeadColor.style.padding = "8px";

        techHeadColor.innerHTML = "Cost";
        techHeadRow.appendChild(techHeadColor);

        var techHeadSources = document.createElement("th");
        techHeadSources.style.borderBottom = "1px solid #ddd";
        techHeadSources.style.padding = "8px";

        techHeadSources.innerHTML = "Requirements";
        techHeadRow.appendChild(techHeadSources);

        tectHeaderArea.appendChild(techHeadRow);

        techTable.appendChild(tectHeaderArea);


        for(i = 0; i < ColonyGame.technology.length; i++) {

            var techMainRow = document.createElement("tr");
            

            var techMainName = document.createElement("td");
            techMainName.style.borderBottom = "1px solid #ddd";
            techMainName.style.padding = "8px";

            techMainName.innerHTML = ColonyGame.technology[i].name;
            techMainRow.appendChild(techMainName);

            var techMainIcon = document.createElement("td");
            techMainIcon.style.borderBottom = "1px solid #ddd";
            techMainIcon.style.padding = "8px";
            
            var techIconImageRes = document.createElement("img");
            techIconImageRes.style.height = "24px";
            techIconImageRes.style.width = "24px";
            resMainName.style.borderBottom = "1px solid #ddd";
            techMainIcon.appendChild(techIconImageRes);

            getDataUri("images/" + ColonyGame.technology[i].icon, setPrintSrc, 24,24,techIconImageRes);

            techMainRow.appendChild(techMainIcon);


            var techMainDesc = document.createElement("td");
            techMainDesc.style.borderBottom = "1px solid #ddd";
            techMainDesc.style.padding = "8px";

            techMainDesc.innerHTML = getString(ColonyGame.technology[i].description);
            techMainRow.appendChild(techMainDesc);

            var techMainCosts = document.createElement("td");
            techMainCosts.style.borderBottom = "1px solid #ddd";
            techMainCosts.style.padding = "8px";

            for(j = 0; j < ColonyGame.technology[i].cost.length; j++) {

                var techCostDiv = document.createElement("div");

                var techCostImage = document.createElement("img");
                techCostImage.style.marginRight = "6px";
                techCostImage.style.height = "24px";
                techCostImage.style.width = "24px";
                techCostImage.style.position = "relative";
                techCostImage.style.top = "7px";
                techCostDiv.appendChild(techCostImage);

                getDataUri("images/" + getResourceByDefName(ColonyGame.technology[i].cost[j].resource).icon, setPrintSrc, 48,48,techCostImage);

                var techCostName = document.createElement("span");
                techCostName.innerHTML = numberWithCommas(ColonyGame.technology[i].cost[j].amount);
                techCostDiv.appendChild(techCostName);

                techMainCosts.appendChild(techCostDiv);
            }

            techMainRow.appendChild(techMainCosts);


            var techMainRequirements = document.createElement("td");
            techMainRequirements.style.borderBottom = "1px solid #ddd";
            techMainRequirements.style.padding = "8px";

            var tcreqImage,tcreqDiv,tcreqSpan;

            if(ColonyGame.technology[i].requiresTech != null) {
                for(j = 0; j < ColonyGame.technology[i].requiresTech.length; j++) {

                    tcreqDiv = document.createElement("div");


                    tcreqSpan = document.createElement("span");
                    tcreqSpan.innerHTML = replaceAll(ColonyGame.technology[i].requiresTech[j],"|"," or ");
                    tcreqDiv.appendChild(tcreqSpan);

                    techMainRequirements.appendChild(tcreqDiv);
                }
            }

            if(ColonyGame.meta.gameStageResource != null && ColonyGame.technology[i].requiresStage < 99) {

                tcreqDiv = document.createElement("div");

                
                tcreqImage = document.createElement("img");
                tcreqImage.style.marginRight = "6px";
                tcreqImage.style.height = "24px";
                tcreqImage.style.width = "24px";
                tcreqImage.style.position = "relative";
                tcreqImage.style.top = "7px";
                tcreqDiv.appendChild(tcreqImage);
                

                getDataUri("images/" + getResourceByDefName(ColonyGame.meta.gameStageResource).icon, setPrintSrc, 48,48,tcreqImage);
                

                tcreqSpan = document.createElement("span");
                tcreqSpan.innerHTML = numberWithCommas(ColonyGame.meta.gameStages[ColonyGame.technology[i].requiresStage].threshold);
                tcreqDiv.appendChild(tcreqSpan);

                techMainRequirements.appendChild(tcreqDiv);
                
            }

            techMainRow.appendChild(techMainRequirements);


            techTable.appendChild(techMainRow);
        }



        mainPrintHolder.appendChild(techTable);



        
    }

    function showDiplomacyMenu() {

        if(currentGame.offlineMode) {
            return;
        }

        if(!currentGame || currentGame == null) {
            return;
        }

        document.getElementById("commonwealthWindow").style.display = "block";
        commonwealthMenuOpen = true;

        document.getElementById("commonwealthIcon").src = "images/" + ColonyGame.meta.diplomacyIndicator;
        document.getElementById("commonwealthName").innerHTML = getString("diplomacy-general");

        document.getElementById("commonwealthListing").innerHTML = "";

        var data = [];


        postSecuredCallToApi(data,38,parseForeignOffices);

    }

    function parseForeignOffices(result) {
        if(result != null || result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result);

                if(colonyInfo == null) {
                    return;
                }

                var colonyCard = document.createElement("div");
                colonyCard.className = "colonyCard";
                colonyCard.colonyRef = colonyInfo;

                var colonyIcon = document.createElement("img");
                colonyIcon.draggable = false;
                colonyIcon.className = "colonyCardIcon";
                colonyIcon.src = "images/" + ColonyGame.meta.diplomacyIndicator;
                colonyCard.appendChild(colonyIcon);

                var colonyName = document.createElement("span");
                colonyName.className = "colonyCardName";
                colonyName.innerHTML = getString("new-embassy-header");
                colonyCard.appendChild(colonyName);

                var colonyActive = document.createElement("span");
                colonyActive.className = "colonyCardActive";
                colonyActive.innerHTML = getString("new-embassy-desc-short");
                colonyCard.appendChild(colonyActive);

                colonyCard.onclick = function() {
                    var dialogOptions = {
                        title: getString("new-embassy-header"),
                        message: getString("new-embassy-desc"),
                        func: lookupNewEMbassyTarget
                    };

                    webAppCore.inputBox(dialogOptions);
                };

                document.getElementById("commonwealthListing").appendChild(colonyCard);


                for(var i = 0; i < colonyInfo.length; i++) {
                    addColonyCardToListing(colonyInfo[i],true);
                }

                commonwealthOnlineColonies = 0;

                postToDiplomaticChannel("onlineping");

            } catch(ex) {
                console.log(ex);
            }
        }
    }

    function onDiplomacyItemSelected(tag) {
        if(tag == "newembassy") {
            var dialogOptions = {
                title: getString("new-embassy-header"),
                message: getString("new-embassy-desc"),
                func: lookupNewEMbassyTarget
            };

            webAppCore.inputBox(dialogOptions);
        }
    }

    function lookupNewEMbassyTarget(charter) {
        if(!charter || charter.trim().length == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "c",
            "value":    charter
        });

        postSecuredCallToApi(data,25,onCheckCharterBack);

    }

    var pendingEmbassyTargetId;
    var pendingEmbassyColonyName;

    function onCheckCharterBack(result) {
        var charterInfo = null;

        if(result != null || result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(charterInfo.isindependent == "0") {
            webAppCore.showToast(charterInfo.colonyname + " is not independent!");
            return;
        }

        if(currentGame.foreignContactReference[charterInfo.colonyid] === undefined) {
            currentGame.foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        pendingEmbassyTargetId = charterInfo.colonyid;
        pendingEmbassyColonyName = charterInfo.colonyname;

        var a = parseInt(currentGame.sX) - parseInt(charterInfo.sectorx);
        var b = parseInt(currentGame.sY) - parseInt(charterInfo.sectory);

        var c = Math.round(Math.sqrt( a*a + b*b ));

        c++;

        embassyCostTotal = {};

        var costString = charterInfo.colonyname + " is located " + (c - 1) + " sectors away from us.  A diplomatic mission will cost ";

        for(var i = 0; i < ColonyGame.meta.embassyCostPerSector.length; i++) {
            if(i == 0) {
                costString += " ";
            } else {
                costString += ", ";
            }

            embassyCostTotal[ColonyGame.meta.embassyCostPerSector[i].resource] = ColonyGame.meta.embassyCostPerSector[i].amount * c;
            
            costString += getResourceByDefName(ColonyGame.meta.embassyCostPerSector[i].resource).indicator + numberWithCommas(ColonyGame.meta.embassyCostPerSector[i].amount * c);
        }

        costString += ", in addition to the building costs of the actual embassy.  You will also need to send over a certain number of citizens to staff your embassy, dependent on the type of embassy you build.";


        webAppCore.showDialog({
            "title":    getString("new-embassy-header"),
            "message":  costString,
            "op1": {
                "text":     getString("general-pick-embassy"),
                "func":     selectEmbassyToBuild
            },
            "op2": {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            }
        });
    }

    var embassyCostTotal = {};

    function selectEmbassyToBuild() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.buildings.length; i++) {
            if(!ColonyGame.buildings[i].isEmbassy) {
                continue;
            }

            if(!canIBuildThis(ColonyGame.buildings[i],"building")) {
                continue;
            }

            var tagToUse = ColonyGame.buildings[i];
            var status = null;
            var statusColor = null;

            if(ColonyGame.buildings[i].requiPremium && !webAppCore.getIsPremium()) {
                tagToUse = "premium";
                status = "Premium Content";
                statusColor = "#FFC107";
            }

            var costColor = null;
            var def;

            var costStructure = [];

            if(ColonyGame.buildings[i].acceptsWorkers > getTotalPopulation()) {
                costColor = "#F44336";
                tagToUse = "cantafford";
            }

            costStructure.push({
                pre:    "Staff:",
                post:   numberWithCommas(ColonyGame.buildings[i].acceptsWorkers),
                color:  costColor,
                icon:   "images/" + ColonyGame.meta.colonistIcon
            });

            var j;

            for(j = 0; j < ColonyGame.meta.embassyCostPerSector.length; j++) {
                costColor = null;

                if(embassyCostTotal[ColonyGame.meta.embassyCostPerSector[j].resource] > currentGame.resources[ColonyGame.meta.embassyCostPerSector[j].resource].amount) {
                    costColor = "#F44336";
                    tagToUse = "cantafford";
                }

                def = getResourceByDefName(ColonyGame.meta.embassyCostPerSector[j].resource);

                costStructure.push({
                    pre:    "花费:",
                    post:   def.indicator + numberWithCommas(embassyCostTotal[ColonyGame.meta.embassyCostPerSector[j].resource]),
                    color:  costColor,
                    icon:   "images/" + def.icon
                });
            }

            for(j = 0; j < ColonyGame.buildings[i].cost.length; j++) {
                
                def = getResourceByDefName(ColonyGame.buildings[i].cost[j].resource);

                costColor = null;

                if(ColonyGame.buildings[i].cost[j].amount > currentGame.resources[ColonyGame.buildings[i].cost[j].resource].amount) {
                    costColor = "#F44336";
                    tagToUse = "cantafford";
                }

                costStructure.push({
                    pre:    "花费:",
                    post:   def.indicator + numberWithCommas(ColonyGame.buildings[i].cost[j].amount),
                    color:  costColor,
                    icon:   "images/" + def.icon
                });

                embassyCostTotal[ColonyGame.buildings[i].cost[j].resource] = ColonyGame.buildings[i].cost[j].amount;
            }

            var img;

            if(ColonyGame.buildings[i].indicator == null) {
                img = gameAssets[ColonyGame.buildings[i].tile][0].image.src;
            } else {
                img = "images/" + ColonyGame.buildings[i].indicator;
            }

            menuOptions.push({
                "title": ColonyGame.buildings[i].name,
                "title-color": null,
                "description": getString(ColonyGame.buildings[i].description),
                "status": status,
                "status-color": statusColor,
                "icon": img,
                "overflow": costStructure,
                "tag": tagToUse
            });
        }

        showList(getString("general-pick-embassy"),menuOptions,onEMbassyToBuildSelected,getString("general-nevermind"));
    }

    var pendingEmbassyColonistCount = 0;

    function onEMbassyToBuildSelected(embassy) {

        if(!embassy) {
            return;
        }

        if(embassy == "premium") {
            showPremiumMessage();
            return;
        }

        if(embassy == "cantafford") {
            webAppCore.showToast(getString("general-cant-afford"));
            return;
        }

        if(pendingEmbassyTargetId == null) {
            return;
        }

        pendingEmbassyColonistCount = parseInt(embassy.acceptsWorkers);

        // check with the server if this request is still valid
        var data = [];

        data.push({
            "key":      "t",
            "value":    pendingEmbassyTargetId
        });

        data.push({
            "key":      "b",
            "value":    embassy.name
        });

        postSecuredCallToApi(data,34,onServerEmbassyCheckBack);
    }

    function onServerEmbassyCheckBack(result) {
        

        if(!result || result.trim().length == "") {
            // general error
            webAppCore.showToast("Unable to establish embassy.");
            return;
        }

        if(result.trim() == "ok") {
            // all was good

            for(var cost in embassyCostTotal) {
                modifyResourceAmount(cost,-embassyCostTotal[cost],false,"Diplomacy");
            }

            var totalDiplomats = pendingEmbassyColonistCount;

            while(pendingEmbassyColonistCount > 0) {

                setColonistMask(currentGame.colonists[randomIntFromInterval(0,currentGame.colonists.length - 1)],"IS_LEAVING_COLONY",true);
                

                pendingEmbassyColonistCount--;
            }

            webAppCore.showAlertWithTitle("A diplomatic mission has been dispatched to " + pendingEmbassyColonyName + " with " + totalDiplomats + " diplomats.",getString("diplomacy-general"));

            return;
        }

        // otherwise, a custom error message from the server
        webAppCore.showAlertWithTitle(result.trim(),"Error");
    }

    function getPendingEmbassyRequests() {

        if(currentGame.offlineMode) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,35,onPendingEmbassyRequestsBack);
    }

    function onPendingEmbassyRequestsBack(result) {

        var embassyRequests = null;

        if(currentGame == null) {
            return;
        }

        if(result != null && result.trim().length > 0) {
            try {
                embassyRequests = JSON.parse(result);
            } catch(ex) {
                return;
            }
        }

        if(embassyRequests == null) {
            return;
        }

        currentGame.pendingForeignEmbassies = embassyRequests;

        for(var i = 0; i < currentGame.pendingForeignEmbassies.length; i++) {
            currentGame.foreignContactReference[currentGame.pendingForeignEmbassies[i].foreigncolony] = {
                "id": currentGame.pendingForeignEmbassies[i].foreigncolony,
                "charter": currentGame.pendingForeignEmbassies[i].charter,
                "name": currentGame.pendingForeignEmbassies[i].colonyname,
                "race": currentGame.pendingForeignEmbassies[i].race,
                "maptype": currentGame.pendingForeignEmbassies[i].maptype,
                "sx": currentGame.pendingForeignEmbassies[i].sectorx,
                "sy": currentGame.pendingForeignEmbassies[i].sectory,
                "gx": currentGame.pendingForeignEmbassies[i].gridx,
                "gy": currentGame.pendingForeignEmbassies[i].gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        if(currentGame.pendingForeignEmbassies.length > 0) {
            document.getElementById("imDiplomacy").style.display = "inline-block";
        } else {
            document.getElementById("imDiplomacy").style.display = "none";
        }
    }

    function showPendingEmbassyRequests() {

        if(currentGame.pendingForeignEmbassies.length == 0) {
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < currentGame.pendingForeignEmbassies.length; i++) {

            var building = getBuildingDefByName(currentGame.pendingForeignEmbassies[i].buildingid);

            var img;

            if(building.indicator == null) {
                img = gameAssets[building.tile][0].image.src;
            } else {
                img = "images/" + building.indicator;
            }

            menuOptions.push({
                "title": currentGame.pendingForeignEmbassies[i].colonyname,
                "title-color": null,
                "description": "The government of " + currentGame.pendingForeignEmbassies[i].colonyname + " wishes to establish a diplomatic mission in our colony.",
                "status": "Diplomats: " + building.acceptsWorkers + " (" + currentGame.pendingForeignEmbassies[i].race + ")",
                "status-color": null,
                "icon": img,
                "overflow": null,
                "tag": currentGame.pendingForeignEmbassies[i]
            });
        }   

        showList(getString("general-embassy-requests"),menuOptions,queueUpPendingEmbassyConstruction,getString("general-nevermind"));
    }

    var pendingEmbassyMission;

    function queueUpPendingEmbassyConstruction(embassy) {
        if(!embassy) {
            return;
        }

        pendingEmbassyMission = embassy;

        var building = getBuildingDefByName(embassy.buildingid);

        showBuildConfirm();
        buildingConstruction(building);
    }

    function alertEmbassyBuilt(mission) {

        if(mission == null) {
            return;
        }

        var data = [];

        data.push({
            "key":      "t",
            "value":    mission.foreigncolony
        });

        postSecuredCallToApi(data,36,getPendingEmbassyRequests);
    }

    function alertSoldEmbassy(foreigncolony) {

        for(var i = 0; i < currentGame.diplomats.length; i++) {
            if(currentGame.diplomats[i].fn == parseInt(foreigncolony)) {
                setColonistMask(currentGame.diplomats[i],"IS_LEAVING_COLONY",true);
            }
        }

        var data = [];

        data.push({
            "key":      "t",
            "value":    foreigncolony
        });

        postSecuredCallToApi(data,37,getPendingEmbassyRequests);
    }

    function contactEmbassyFor(embassy) {
        getColonyInfoAndLaunchInfo(embassy);
    }

    function addObjectReadoutBar(holder,icon,currenta,currentb,colora,colorb,background,max,title) {
        
        var readoutText = "";
        
        var readoutHolder = document.createElement("div");
        readoutHolder.className = "objOptReadoutHolder";

        if(title) {
            readoutHolder.title = title;
        }

        var readoutIcon = document.createElement("img");
        readoutIcon.className = "objOptReadouIcon";
        readoutIcon.src = icon;
        readoutHolder.appendChild(readoutIcon);

        var readoutBarHolder = document.createElement("div");
        readoutBarHolder.className = "objObtReadoutBarholder";

        // bar a 
        var barAPercent = Math.round((currenta / max) * 100);

        readoutText = currenta;

        var barA = document.createElement("div");
        barA.className = "objOptReadoutBarA";
        barA.style.backgroundColor = colora;
        barA.style.width = "calc(" + barAPercent + "%";
        readoutBarHolder.appendChild(barA);

        // bar b 
        if(currentb != null) {

            readoutText = currentb + "/" + readoutText;

            var barBPercent = Math.round((currentb / max) * 100);
            
            var barB = document.createElement("div");
            barB.className = "objOptReadoutBarA";
            barB.style.backgroundColor = colorb;
            barB.style.width = "calc(" + barBPercent + "%";
            readoutBarHolder.appendChild(barB);
        }

        if(background) {
            readoutBarHolder.style.backgroundColor = background;
        }

        readoutText = readoutText + "/" + max;

        var readoutTextSpan = document.createElement("span");
        readoutTextSpan.innerHTML = readoutText;
        readoutTextSpan.className = "objOptReadoutText";
        readoutBarHolder.appendChild(readoutTextSpan);

        readoutHolder.appendChild(readoutBarHolder);

        holder.appendChild(readoutHolder);
    }

    function showCommunicationsMenu() {
        if(currentGame.offlineMode) {
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title": getString("general-send-custom-msg"),
            "title-color": null,
            "description": getString("general-send-msg-warn"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.mailIndicator,
            "overflow": null,
            "tag": "sendmail"
        });  


        if(!currentGame.isIndependent) {
            menuOptions.push({
                "title": getString("general-req-annex"),
                "title-color": null,
                "description": getString("req-anenx-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.empireIndicator,
                "overflow": null,
                "tag": "reqannex"
            });  
        }
        

        showList(getString("comms-general"),menuOptions,onCommOptionSelected,getString("general-nevermind"));
    }

    function onCommOptionSelected(tag) {
        if(!tag) {
            return;
        }

        if(tag == "sendmail") {
            sendCommMessage();
        }

        if(tag == "reqannex") {
            enterAnnexCharter();
        }
    }

    function enterAnnexCharter() {
        var dialogOptions = {
            title: getString("general-req-annex"),
            message: getString("req-annex-enter-charter"),
            func: onChangeCharterInput
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onChangeCharterInput(charter) {
        if(!charter || charter.trim().length == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "c",
            "value":    charter
        });

        postSecuredCallToApi(data,25,onCheckCharterBackForAnnex);
    }

    function onCheckCharterBackForAnnex(result) {
        var charterInfo = null;

        if(result != null || result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(charterInfo.isindependent == "0") {
            webAppCore.showToast(charterInfo.colonyname + " is not independent!");
            return;
        }

        if(currentGame.foreignContactReference[charterInfo.colonyid] === undefined) {
            currentGame.foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        var annexMessage = currentGame.name  + " wishes to join our Commonwealth.";

        sendMessage(charterInfo.colonyid,"7",currentGame.earthBackTax,annexMessage,placeholder,null);

        webAppCore.showAlertWithTitle("Your request has been sent to " + charterInfo.colonyname + ".  " + getString("req-annex-final"),getString("general-req-annex"));
    }

    function sendCommMessage() {
        if(currentGame.foreignContactReference === undefined) {
            currentGame.foreignContactReference = {};
        }

        var menuOptions = [];

        menuOptions.push({
            "title": "Charter Code",
            "title-color": null,
            "description": "You can send a message to any colony if you know their charter code.",
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.charterIndicator,
            "overflow": null,
            "tag": "charter"
        }); 

        for(var colony in currentGame.foreignContactReference) {
            if(currentGame.foreignContactReference[colony].charter) {

                var pDef = getPlanetDefByName(currentGame.foreignContactReference[colony].maptype);

                if(pDef == null) {
                    continue;
                }

                menuOptions.push({
                    "title": currentGame.foreignContactReference[colony].name,
                    "title-color": null,
                    "description": currentGame.foreignContactReference[colony].race + ".  Charter: " + currentGame.foreignContactReference[colony].charter,
                    "status": null,
                    "status-color": null,
                    "icon": "images/" + pDef.icon,
                    "overflow": null,
                    "tag": currentGame.foreignContactReference[colony]
                }); 
            }
        }

        showList(getString("general-send-custom-msg"),menuOptions,onMessageTarget,getString("general-nevermind"));
    }

    function onMessageTarget(tag) {
        if(!tag) {
            return;
        }

        if(tag == "charter") {
            var dialogOptions = {
                title: "Charter Code",
                message: "Enter the charter code of a colony you wish to communicate with.",
                func: onMessagingCharterEntered
            };

            webAppCore.inputBox(dialogOptions);
            return;
        }


        sendACustomMessage(tag.id);
    }

    function onMessagingCharterEntered(charter) {
        if(!charter || charter.trim().length == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "c",
            "value":    charter
        });

        postSecuredCallToApi(data,25,onCheckCharterBackForMessaging);
    }

    function closeSomethingIfOpen() {
        var somethingWasOpen = false;
        
        if(gbtOpen) {
            somethingWasOpen = true;
            closeGBT();
        }

        if(tipsWindowOpen) {
            somethingWasOpen = true;
            closeTipsPopup();
        }

        if(commonwealthMenuOpen) {
            somethingWasOpen = true;
            closeCommonwealthMenu();
        }
        
        if(colonyWindowOpen) {
            somethingWasOpen = true;
            closeColonyWindow();
        }

        if(statsOpen) {
            somethingWasOpen = true;
            closeStatsMenu();
        }

        if(selectedBuilding != null) {
            somethingWasOpen = true;
        }

        if(!desktopMode && document.getElementById("sidebar").style.display != "none") {
            somethingWasOpen = true;
        }

        if(document.getElementById("objectOptions").style.display == "block" && selectedVehicle.length == 0 && queuedMove == null) {
            somethingWasOpen = true;
            document.getElementById("objectOptions").style.display = "none";
        }

        if(newObjectOptionsOpen) {
            closeObjectOptionsMenu();
            somethingWasOpen = true;
        }

        return somethingWasOpen;
    }

    function onCheckCharterBackForMessaging(result) {
        var charterInfo = null;

        if(result != null || result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(currentGame.foreignContactReference[charterInfo.colonyid] === undefined) {
            currentGame.foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        sendACustomMessage(charterInfo.colonyid);
    }

    function getAnnexRequestInfo(message) {
        tmpHoldingMessage = message;

        var data = [];

        data.push({
            "key":      "cid",
            "value":    message.fromid
        });

        postSecuredCallToApi(data,39,onAnnexRequestInfoCheck);
    }

    function onAnnexRequestInfoCheck(result) {

        if(tmpHoldingMessage == null) {
            return;
        }

        var charterInfo = null;

        if(result != null || result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(charterInfo.isindependent == "1") {
            deleteMail();
            webAppCore.showToast(charterInfo.colonyname + " is already independent!");
            return;
        }

        if(currentGame.foreignContactReference[charterInfo.colonyid] === undefined) {
            currentGame.foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        pendingEmbassyTargetId = charterInfo.colonyid;
        pendingEmbassyColonyName = charterInfo.colonyname;

        var a = parseInt(currentGame.sX) - parseInt(charterInfo.sectorx);
        var b = parseInt(currentGame.sY) - parseInt(charterInfo.sectory);

        var c = Math.round(Math.sqrt( a*a + b*b ));

        c++;

        embassyCostTotal = {};

        var costString = tmpHoldingMessage.message + "  " + charterInfo.colonyname + " is located " + (c - 1) + " sectors away from us.  Annexing them into our Commonwealth will cost ";

        for(var i = 0; i < ColonyGame.meta.embassyCostPerSector.length; i++) {
            if(i == 0) {
                costString += " ";
            } else {
                costString += ", ";
            }

            embassyCostTotal[ColonyGame.meta.embassyCostPerSector[i].resource] = Math.ceil((ColonyGame.meta.embassyCostPerSector[i].amount * c) / 5);
            
            costString += getResourceByDefName(ColonyGame.meta.embassyCostPerSector[i].resource).indicator + numberWithCommas(ColonyGame.meta.embassyCostPerSector[i].amount * c);
        }

        costString += ".";

        if(parseInt(tmpHoldingMessage.amount) > 0) {

            if(embassyCostTotal[ColonyGame.meta.tenderResource] === undefined) {
                embassyCostTotal[ColonyGame.meta.tenderResource] = 0;
            }

            embassyCostTotal[ColonyGame.meta.tenderResource] += parseInt(tmpHoldingMessage.amount);

            costString += "  In addition, " + charterInfo.colonyname + " currently owes " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt(tmpHoldingMessage.amount)) + " in back taxes, which you will also be required to pay.";
        }

        webAppCore.showDialog({
            "title":    charterInfo.colonyname,
            "message":  costString,
            "op1": {
                "text":     getString("general-annex"),
                "func":     childAnnexYes
            },
            "op2": {
                "text":     getString("tax-window-reject"),
                "func":     childAnnexReject
            }
        });
    }

    var tmpAnexName;

    function childAnnexYes() {
        var canAfford = true;

        for(var cost1 in embassyCostTotal) {
            if(currentGame.resources[cost1].amount < parseInt(embassyCostTotal[cost1])) {
                canAfford = false;
                break;
            }
        }

        if(!canAfford) {
            webAppCore.showToast("You cannot afford to annex " + tmpHoldingMessage.from + " right now");
        }

        for(var cost in embassyCostTotal) {
            modifyResourceAmount(cost,-embassyCostTotal[cost],false,"Diplomacy");
        }

        var annexMessage = "We have been annexed into the Commonwealth of " + currentGame.name;

        tmpAnexName = tmpHoldingMessage.from;

        sendMessage(tmpHoldingMessage.fromid,"8",0,annexMessage,showAnnexCompleteParent,null);

        deleteMail();
    }
    
    function showAnnexCompleteParent() {
        webAppCore.showAlertWithTitle("We have added " + tmpAnexName + " to our Commonwealth.",tmpAnexName);
    }

    function childAnnexReject() {
        tmpNewMsgTo = tmpHoldingMessage.fromid;
        deleteMail();
        onCWMessageSend(currentGame.name + " has rejected your request for annexation.");
    }

    function completeParentSwitch(message) {
        currentGame.motherland = message.from;
        currentGame.motherlandid = message.fromid;
        currentGame.earthBackTax = 0;
    }

    function getRetainedPath(x,y,x2,y2) {
        var retainerName = x.toString();
        retainerName += y.toString();
        retainerName += x2.toString();
        retainerName += y2.toString();

        if(!retainedPaths[retainerName]) {
            return null;
        }

        var blocked = false;

        for(var i = 0; i < retainedPaths[retainerName].length; i++) {
            if(!isTilePassable(retainedPaths[retainerName][i].x,retainedPaths[retainerName][i].y,false)) {
                blocked = true;
                break;
            }
        }

        if(blocked) {
            delete retainedPaths[retainerName];
            delete retainedUsage[retainerName];
            return null;
        }

        if(retainedUsage[retainerName]) {
            retainedUsage[retainerName]++;
        } else {
            retainedUsage[retainerName] = 1;
        }
        
        return clonePathArray(retainedPaths[retainerName]);
    }

    function addPathWorkerListeener(pathWorker) {
        pathWorker.addEventListener("message",function(e) {
            var result = e.data;

            if(result.method == "checkPath") {

                if(result.data.data.length > 0 && result.data.type == "vehicle") {
                    var retainerName = result.data.data[0].x.toString();
                    retainerName += result.data.data[0].y.toString();
                    retainerName += result.data.data[result.data.data.length - 1].x.toString();
                    retainerName += result.data.data[result.data.data.length - 1].y.toString();

                    retainedPaths[retainerName] = clonePathArray(result.data.data);

                    retainedUsage[retainerName] = 0;
                }

                if(result.data.type == "colonist") {
                    colonistPathOrders[result.data.id] = result.data.data;
                } else {
                    vehiclePathOrders[result.data.id] = result.data.data;
                }
            }
        });
        
        pathWorker.addEventListener("error",function(e) {

            var scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);
            webAppCore.logEvent("Path Worker Error",scrpt + ":" + e.lineno,e.message);
        });
    }

    function gooseUpPathWorker() {
        pathWorker1 = new Worker("path-worker.js");

        addPathWorkerListeener(pathWorker1);
    }

    function getTotalPopulation() {

        if(currentGame == null) {
            return 0;
        }

        var base = currentGame.colonists.length;

        base += getVirtualPopulation();

        return base;
    }

    function getVirtualPopulation() {
        var virt = 0;

        for(var prop in currentGame.virtualAvatars) {

            if(currentGame.virtualAvatars[prop].represents < 0) {
                currentGame.virtualAvatars[prop].represents = 0;
            }

            virt += currentGame.virtualAvatars[prop].represents;
        }

        return virt;
    }

    function removeAVirtualWorker(avatarId) {

        var gotOne = false;
        var jobsToTerminate = [];
        var j,i,l;

        for(i = 0,l = allJobsArray.length; i < l; i++) {
            jobsToTerminate = [];
            gotOne = false;

            for(j = 0; j < allJobsArray[i].workers.length; j++) {
                if(allJobsArray[i].workers[j].colonistId == avatarId) {
                    jobsToTerminate.push(allJobsArray[i].workers[j]);
                    break;
                }

                
            }

            while(jobsToTerminate.length > 0) {
                gotOne = true;
                removeFromArray(allJobsArray[i].workers,jobsToTerminate.shift());
            }

            if(gotOne) {
                break;
            }
        }
    }

    function removeAVirtualResident(avatarId) {
        

        var gotOne = false;
        var i,l;

        for(i = 0,l = allHomesArray.length; i < l; i++) {
            gotOne = false;

            if(allHomesArray[i].residents.indexOf(avatarId) > -1) {
                gotOne = true;
            }

            if(gotOne) {
                removeFromArray(allHomesArray[i].residents,avatarId);
                break;
            }
        }
    }

    function unvirtualizeColonist(avatarId,x,y,house,job,entertainment,doctor,atwork) {
        var avatarHolder = currentGame.virtualAvatars[avatarId];

        avatarHolder.represents--;

        if(avatarHolder.represents < 0) {
            avatarHolder = 0;
        }

        var currentpop = getTotalPopulation();

        var i;

        var homelessrate = Math.round((runningHomelessCount / currentpop) * 100);
        var unemprate = Math.round((runningUnemployed / currentpop) * 100);

        var moneyAverage = Math.round(unsimulatedRunningMoney / currentGame.colonists.length);

        if(currentGame.historicStats.mediansalary && currentGame.historicStats.mediansalary.length > 0) {
            moneyAverage = currentGame.historicStats.mediansalary[currentGame.historicStats.mediansalary.length - 1];
        }

        var moneyMax = moneyAverage + Math.round(moneyAverage * .25);
        var moneyMin = moneyAverage - Math.round(moneyAverage * .25);

        if(moneyMin < 0) {
            moneyMin = 0;
        }

        var healthAverage = Math.round(unsimulatedHealth / currentGame.colonists.length);


        if(currentGame.historicStats.health && currentGame.historicStats.health.length > 0) {
            healthAverage = currentGame.historicStats.health[currentGame.historicStats.health.length - 1];
        }


        var healthMax = healthAverage + Math.round(healthAverage * .1);
        var healthMin = healthAverage - Math.round(healthAverage * .1);

        if(healthMin < 1) {
            healthMin = 1;
        }

        var ageAverage = Math.round(unsimulatedAge / currentGame.colonists.length);


        if(currentGame.historicStats.age && currentGame.historicStats.age.length > 0) {
            ageAverage = currentGame.historicStats.age[currentGame.historicStats.age.length - 1];
        }


        var ageMax = ageAverage + Math.round(ageAverage * .1);
        var ageMin = ageAverage - Math.round(ageAverage * .1);

        if(ageMin < 18) {
            ageMin = 18;
        }

        var raceChances = 0;
        var prop;

        for(prop in currentGame.populationStats) {
            raceChances += currentGame.populationStats[prop];
        }

        var selection = randomIntFromInterval(0,raceChances);

        var currentSection = 0;

        var useRace = currentGame.defaultRace;

        for(prop in currentGame.populationStats) {
            if(selection < (currentGame.populationStats[prop] + currentSection)) {
                useRace = prop;
                break;
            }

            currentSection += currentGame.populationStats[prop];
        }

        var colonist = new Colonist(x,y,false,useRace);
        setupNewColonist(colonist);

        if(doctor != null && doctor > 0) {

            var ourDoc = getBuildingById(doctor);

            if(ourDoc != null) {
                setColonistMask(colonist,"IS_HEALING",true);
                colonist.venue = ourDoc.id;
                ourDoc.patients.push(colonist.id);
            }
        }

        if(entertainment != null && entertainment > 0) {
            var ourVenue = getBuildingById(entertainment);

            if(ourVenue != null) {
                setColonistMask(colonist,"IS_RELAXING",true);
                colonist.venue = ourVenue.id;
                ourVenue.patrons.push(colonist.id);
            }
        }

        if(job != null && job > 0) {
            var worksite = getBuildingById(job);

            if(worksite != null) {
                addWorker(worksite,colonist);

                if(!atwork) {
                    atwork = false;
                }
                setColonistMask(colonist,"AT_WORK",atwork);

                var legit = false;

                for(i = 0; i < worksite.workers.length; i++) {
                    if(worksite.workers[i].colonistId == colonist.id) {
                        worksite.workers[i].isAtWork = atwork;
                        worksite = null;
                        legit = true;
                        break;
                    }
                }

                if(!legit) {
                    setColonistMask(colonist,"AT_WORK",false);
                }
            }
        } else {
            var jobChance = randomIntFromInterval(0,100);
            if(jobChance > unemprate) {
                findAJob(colonist);
                allJobsArray.sort(function(a, b){return 0.5 - Math.random();});
                removeAVirtualWorker(avatarId);
            }
        }

        if(house != null && house > 0) {
            var homestead = getBuildingById(house);

            if(homestead != null) {
                addResident(homestead,colonist);
                setColonistMask(colonist,"AT_HOME",true);
            }
        } else {
            var houseChange = randomIntFromInterval(0,100);
            if(houseChange > homelessrate) {
                findAHouse(colonist);
                allHomesArray.sort(function(a, b){return 0.5 - Math.random();});
                removeAVirtualResident(avatarId);
            }
        }

        // give them some stats based on the colony averages 
        colonist.money = randomIntFromInterval(moneyMin,moneyMax);
        colonist.age = (randomIntFromInterval(ageMin,ageMax) * 12);
        colonist.health = randomIntFromInterval(healthMin,healthMax);

        currentGame.colonists.push(colonist);

        return colonist;
    }

    function virtualizeColonist(colonist) {

        if(colonist == null) {
            return;
        }

        // if this colonist is already an avatar, abort 
        for(var prop in currentGame.virtualAvatars) {
            if(currentGame.virtualAvatars[prop].id == colonist.id) {
                return;
            }
        }

        var whichAvatar = randomIntFromInterval(1,10);
        var avatarHolder = currentGame.virtualAvatars["-" + whichAvatar];

        // if there is no avatar, instead make this lucky colonist the avatar! 
        if(avatarHolder.id == 0) {
            avatarHolder.id = colonist.id;
            return;
        }

        // if our avatar has died, make this colonist the new avatar
        var ourAvatar = getColonistById(avatarHolder.id);
        if(ourAvatar == null || ourAvatar.health <= 0) {
            avatarHolder.id = colonist.id;
            return;
        }

        // otherwise, get rid of this colonist and absorb him into the avatar 

        var i;

        if(colonist.job > 0) {
            var worksite = getBuildingById(colonist.job);
            if(worksite != null) {
                for(i = 0; i < worksite.workers.length; i++) {
                    if(worksite.workers[i].colonistId == colonist.id) {
                        worksite.workers[i].colonistId = -whichAvatar;
                    }
                }
            }
        }

        if(colonist.house > 0) {
            var homestead = getBuildingById(colonist.house);
            if(homestead != null) {
                for(i = 0; i < homestead.residents.length; i++) {
                    if(homestead.residents[i] == colonist.id) {
                        homestead.residents[i] = -whichAvatar;
                    }
                }
            }
        }

        if(getColonistMask(colonist,"IS_HEALING")) {
            removeColonistFromMedicalFacility(colonist);
        }

        if(getColonistMask(colonist,"IS_RELAXING")) {
            handleRelaxedColonist(colonist);
        }

        var holders = getHolderLevels(colonist.id);
        delete runningColonistReferenceArray[holders.a][holders.b][holders.c][colonist.id];

        removeFromArray(currentGame.colonists,colonist,"currentGame.colonists");

        colonist = null;

        avatarHolder.represents++;
    }

    function getAvatarIdForColonist(colonist) {
        for(var prop in currentGame.virtualAvatars) {
            if(currentGame.virtualAvatars[prop].id == colonist.id) {
                return prop;
            }
        }

        return 0;
    }

    function runVirtualSyncCycle() {

        simSyncCounter++;

        if(simSyncCounter == 500) {
            runSyncForVirtualbot(-1);
        }

        if(simSyncCounter == 1000) {
            runSyncForVirtualbot(-2);
        }

        if(simSyncCounter == 1500) {
            runSyncForVirtualbot(-3);
        }

        if(simSyncCounter == 2000) {
            runSyncForVirtualbot(-4);
        }

        if(simSyncCounter == 2500) {
            runSyncForVirtualbot(-5);
        }

        if(simSyncCounter == 3000) {
            runSyncForVirtualbot(-6);
        }

        if(simSyncCounter == 3500) {
            runSyncForVirtualbot(-7);
        }

        if(simSyncCounter == 4000) {
            runSyncForVirtualbot(-8);
        }

        if(simSyncCounter == 4500) {
            runSyncForVirtualbot(-9);
        }

        if(simSyncCounter >= 5000) {
            runSyncForVirtualbot(-10);
            simSyncCounter = 0;
        }
    }

    function destroyVehicle(object) {
        for(var i = 0; i < object.length; i++) {

            if(allowParticleEffects) {
                Scroll2d.playParticleEffect("explosion",object[i].x,object[i].y);
            }

            if(allowAudio && ColonyGame.sounds.explosion != null) {
                webAppCore.playSoundEffect(ColonyGame.sounds.explosion);
            }

            removeFromArray(currentGame.vehicles,object[i]);
            
        }

        object = [];
        document.getElementById("objectOptions").style.display = "none";
    }

    function destroyResource(object,fromDozer,explode) {

        var resourcedef = getTerrainDefByName(object.def);

        if(fromDozer && resourcedef.indestructable && !currentGame.mem) {
            return;
        }

        if(explode === "undefined") {
            explode = true;
        }

        if(explode) {

            for(var i = 0; i < object.occupiesTiles.length; i++) {
                if(allowParticleEffects) {
                    Scroll2d.playParticleEffect("explosion",object.occupiesTiles[i].x,object.occupiesTiles[i].y);
                }

                if(allowAudio && ColonyGame.sounds.explosion != null) {
                    webAppCore.playSoundEffect(ColonyGame.sounds.explosion);
                }
            }

        }

        

        if(resourcedef.collectOnDestruction) {
            if(object.inventory > 0) {
                modifyResourceAmount(resourcedef.provides,object.inventory);
            }
        }

        removeFromArray(currentGame.mapResources,object);

        selectedResource = null;
        document.getElementById("objectOptions").style.display = "none";

        shoreUpdateTurn = true;
    }

    function runSyncForVirtualbot(avatarId) {
        var avatarHolder = currentGame.virtualAvatars[avatarId];

        if(!avatarHolder) {
            currentGame.virtualAvatars[avatarId] = {
                "id": 0,
                "represents": 0
            };
            return;
        }

        if(avatarHolder.id == 0) {
            return;
        }

        var ourAvatar = getColonistById(avatarHolder.id);
        
        if(ourAvatar == null || ourAvatar.health <= 0) {

            avatarHolder.id = 0;

            while(avatarHolder.represents > 0) {
                var newCol = unvirtualizeColonist(avatarId,1,1,null,null,null,null);
                setColonistMask(newCol,"IS_SIMULATED",true);
            }

            return;
        }

        var i,j,l,killList,def;
        var currentpop = getTotalPopulation();

        var currentUnemploymentRate = parseInt(currentGame.historicStats.unemployment[currentGame.historicStats.unemployment.length - 1]);

        if(currentUnemploymentRate > 20) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 19) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 18) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 17) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 16) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 15) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 10) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 5) {
            currentUnemploymentRate--;
        }

        if(currentUnemploymentRate > 1) {
            currentUnemploymentRate--;
        }

        var totalJobs = currentGame.historicStats.jobs[currentGame.historicStats.jobs.length - 1];
        var tw = currentGame.historicStats.workforce[currentGame.historicStats.workforce.length - 1];

        if(tw > totalJobs) {
            tw = totalJobs;
        }

        var vacantjobs = totalJobs - tw;

        var totalWorkers = 0;

        var allowedWorkers = parseInt(avatarHolder.represents) - Math.round(parseInt(avatarHolder.represents) * (currentUnemploymentRate * .01));

        if(allowedWorkers < 0) {
            allowedWorkers = 0;
        }

        if(allowedWorkers > avatarHolder.represents) {
            allowedWorkers = avatarHolder.represents;
        }

        killList = [];


        // sync jobs
        var working = getColonistMask(ourAvatar,"AT_WORK");
        if(ourAvatar.job > 0) {

            for(i = 0,l = allJobsArray.length; i < l; i++) {
                for(j = 0; j < allJobsArray[i].workers.length; j++) {
                    if(allJobsArray[i].workers[j].colonistId == avatarId) {
                        totalWorkers++;
                        allJobsArray[i].workers[j].isAtWork = working;
                    }
                }
            }
        } else {

            for(i = 0,l = allJobsArray.length; i < l; i++) {
                for(j = 0; j < allJobsArray[i].workers.length; j++) {
                    if(allJobsArray[i].workers[j].colonistId == avatarId) {
                        killList.push(allJobsArray[i].workers[j]);
                    }
                }

                while(killList.length > 0) {
                    removeFromArray(allJobsArray[i].workers,killList.shift());
                }
            }


            findAJob(ourAvatar);
        }

        if(totalWorkers > allowedWorkers) {

            allJobsArray.sort(function(a, b){return 0.5 - Math.random();});

            while(totalWorkers > allowedWorkers) {
                removeAVirtualWorker(avatarId);
                totalWorkers--;
            }
        } else {
            var neededWorkers = allowedWorkers - totalWorkers;

            if(neededWorkers > vacantjobs) {
                neededWorkers = vacantjobs;
            }

            for(i = 0; i < openJobsArray.length; i++) {

                def = getBuildingDefByName(openJobsArray[i].def);

                if(openJobsArray[i].workers.length >= def.acceptsWorkers) {
                    continue;
                }

                var jobOpeningsHere = def.acceptsWorkers - openJobsArray[i].workers.length;

                var jobsToAddHere = randomIntFromInterval(0,jobOpeningsHere);

                if(jobsToAddHere > neededWorkers) {
                    jobsToAddHere = neededWorkers;
                }

                while(jobsToAddHere > 0) {

                    var freshWorker = new Employee();
                    freshWorker.colonistId = avatarId;
                    freshWorker.isAtWork = working;
                    openJobsArray[i].workers.push(freshWorker);
                    neededWorkers--;

                    jobsToAddHere--;
                }

                

                if(neededWorkers <= 0) {
                    break;
                }
            }
        }

        
        var fullHousing = 0;
        
        for(i = 0; i < currentGame.buildings.length; i++) {
            if(currentGame.buildings[i].embassyFor == 0 && !currentGame.buildings[i].isUnderConstruction && !currentGame.buildings[i].deactivated) {
                fullHousing += currentGame.buildings[i].residents.length;
            }
        }
        

        killList = [];

        var totalHomeowners = 0;

        var homelessrate = runningHomelessCount / currentpop;

        if(homelessrate > 0.2) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.19) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.18) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.17) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.16) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.15) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.1) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.05) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.02) {
            homelessrate -= .02;
        }

        if(homelessrate > 0.01) {
            homelessrate -= .01;
        }

        homelessrate -= .01;

        if(homelessrate < 0) {
            homelessrate = 0;
        }

        var allowedHomeowners = avatarHolder.represents - Math.round(avatarHolder.represents * homelessrate);

        

        var remainingHousing = currentGame.availableShelters - fullHousing;
        
        if(remainingHousing < 0) {
            remainingHousing = 0;
        }

        if(allowedHomeowners < 0) {
            allowedHomeowners = 0;
        }

        // sync housing
        if(ourAvatar.house > 0) {


            for(i = 0,l = allHomesArray.length; i < l; i++) {
                for(j = 0; j < allHomesArray[i].residents.length; j++) {
                    if(allHomesArray[i].residents[j] == avatarId) {
                        totalHomeowners++;
                    }
                }
            }
        } else {

            for(i = 0,l = allHomesArray.length; i < l; i++) {
                for(j = 0; j < allHomesArray[i].residents.length; j++) {
                    if(allHomesArray[i].residents[j] == avatarId) {
                        killList.push(allHomesArray[i].residents[j]);
                    }
                }

                while(killList.length > 0) {
                    removeFromArray(allHomesArray[i].residents,killList.shift());
                }
            }

            findAHouse(ourAvatar);
        }

        if(totalHomeowners > allowedHomeowners) {

            var homeownersToNuke = totalHomeowners - allowedHomeowners;
            
            homeownersToNuke = Math.round(homeownersToNuke * .6);

            allHomesArray.sort(function(a, b){return 0.5 - Math.random();});

            while(homeownersToNuke > 0) {
                removeAVirtualResident(avatarId);
                homeownersToNuke--;
            }
        } else {
            var neededHomeowners = allowedHomeowners - totalHomeowners;

            if(neededHomeowners > remainingHousing) {
                neededHomeowners = remainingHousing;
            }

            if(neededHomeowners > 0) {
                openHomesArray.sort(function(a, b){return 0.5 - Math.random();});

                for(i = 0; i < openHomesArray.length; i++) {

                    def = getBuildingDefByName(openHomesArray[i].def);

                    if(openHomesArray[i].residents.length >= def.providesShelter) {
                        continue;
                    }

                    var houseOpeningsHere = def.providesShelter - openHomesArray[i].residents.length;

                    if(houseOpeningsHere > neededHomeowners) {
                        houseOpeningsHere = neededHomeowners;
                    }

                    var housesToFillHere = randomIntFromInterval(0,houseOpeningsHere);

                    while(housesToFillHere > 0) {

                        if(openHomesArray[i].residents.length >= def.providesShelter) {

                            housesToFillHere = 0;
                            break;
                        }

                        openHomesArray[i].residents.push(avatarId);
                        neededHomeowners--;
                        housesToFillHere--;

                        
                    }

                    

                    if(neededHomeowners <= 0) {
                        break;
                    }
                }
            }
            
        }

        killList = [];

        // sync entertainment and medical 
        for(i = 0,l = currentGame.buildings.length; i < l; i++) {

            var bld = currentGame.buildings[i];

            for(j = 0; j < bld.patrons.length; j++) {
                if(bld.patrons[j] == avatarId) {
                    killList.push(bld.patrons[j]);
                }

                while(killList.length > 0) {
                    removeFromArray(bld.patrons,killList.shift());
                }

                if(bld.patients[j] == avatarId) {
                    killList.push(bld.patients[j]);
                }

                while(killList.length > 0) {
                    removeFromArray(bld.patients,killList.shift());
                }
            }
        }

        var healing = getColonistMask(ourAvatar,"IS_HEALING");
        var relaxing = getColonistMask(ourAvatar,"IS_RELAXING");

        var numToHeal = avatarHolder.represents;
        var numToRelax = avatarHolder.represents;
        //var def;

        if(healing) {
            while(numToHeal > 0) {
                for(i = 0; i < openMedicalArray.length; i++) {
                    def = getBuildingDefByName(openMedicalArray[i].def);

                    if(def.heals > openMedicalArray[i].patients.length) {
                        numToHeal--;
                        openMedicalArray[i].patients.push(avatarId);
                    }
                }

                numToHeal = 0;
                break;
            }
        }

        if(relaxing) {

            var totalCharges = 0;
            var totalRelaxed = 0;

            while(numToRelax > 0) {

                openVenuesArray.sort(function(a, b){return 0.5 - Math.random();});

                for(i = 0; i < openVenuesArray.length; i++) {
                    def = getBuildingDefByName(openVenuesArray[i].def);

                    var charges = def.entertainmentCost;

                    if(charges > ourAvatar.money) {
                        continue;
                    }

                    if(def.entertains > openVenuesArray[i].patrons.length) {

                        var openSpots = def.entertains - openVenuesArray[i].patrons.length;
                        var fillSpots = randomIntFromInterval(0,openSpots);

                        if(fillSpots > numToRelax) {
                            fillSpots = numToRelax;
                        }

                        while(fillSpots > 0) {

                            numToRelax--;
                            totalRelaxed++;
                            openVenuesArray[i].patrons.push(avatarId);
                            
                            totalCharges += charges;
                            modifyResourceAmount(ColonyGame.meta.tenderResource,charges,false,def.name);

                            fillSpots--;

                            if(useTextPoppers) {
                                Scroll2d.popText(openVenuesArray[i].x,openVenuesArray[i].y,getResourceByDefName(ColonyGame.meta.tenderResource).indicator + charges,getResourceByDefName(ColonyGame.meta.tenderResource));
                            }
                        }

                        
                    }
                }

                numToRelax = 0;
                break;
            }

            var averageCharges = Math.round(totalCharges / totalRelaxed);
            ourAvatar.money -= averageCharges;

            if(ourAvatar.money < 0) {
                ourAvatar.money = 0;
            }
        }
    }

    function putColonistIntoStargate(colonist) {
        currentGame.totalEmigration++;

        if(!hasStargate) {
            return;
        }

        var stargateMessage = {
            "immigrant": {
                "name": colonist.name,
                "race": colonist.race,
                "age": colonist.age,
                "money": colonist.money,
                "iq": colonist.iQ
            }
        };

        postStargateMessage(stargateMessage);
    }

    function showModdingMenu() {
        var menuOptions = [];

        menuOptions.push({
            "title":        getString("general-texture-mods"),
            "description":  getString("text-mods-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "texmod"
        });

        menuOptions.push({
            "title":        getString("general-map-editor"),
            "description":  getString("general-map-editor-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "mapedit"
        });

        if(!webAppCore.isTV() && ColonyGame.meta.moddingCommunityUrl != null) {
            menuOptions.push({
                "title":        getString("general-modding-community"),
                "description":  getString("general-mod-comm-desc"),
                "icon":         null,
                "status":       ColonyGame.meta.moddingCommunityUrl,
                "status-color": "#2196F3",
                "overflow":     null,
                "tag":          "modcommunity"
            });
        }

        showList(getString("general-modding"),menuOptions,onModOptionSelected,getString("general-dismiss"));
    }

    function onModOptionSelected(tag) {
        if(!tag) {
            return;
        }

        if(tag == "texmod") {
            showTextureModMenu();
        }

        if(tag == "mapedit") {
            if(!webAppCore.getIsPremium()) {
                showPremiumMessage(getString("general-map-editor"));
                return;
            }

            
            mapEditorMenu();
        }

        if(tag == "modcommunity") {
            webAppCore.externalURL(ColonyGame.meta.moddingCommunityUrl);
        }
    }

    function mapEditorMenu() {
        var menuOptions = [];

        menuOptions.push({
            "title":        getString("general-new-map"),
            "description":  getString("general-new-map-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "newmap"
        });

        menuOptions.push({
            "title":        getString("general-edit-existing"),
            "description":  getString("general-edit-existing-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "exisintgmap"
        });

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        showList(getString("general-map-editor"),menuOptions,onMapEditorOptionChosen,getString("general-dismiss"));
    }

    function onMapEditorOptionChosen(tag) {
        if(!tag) {
            return;
        }

        if(tag == "back") {
            showModdingMenu();
        }

        if(tag == "newmap") {
            startMapEditor();
        }

        if(tag == "exisintgmap") {
            loadCustomMap(onCustomMapOpenedForEditing,"general-edit-existing");
        }
    }

    function onCustomMapOpenedForEditing(mapObject) {

        startMapEditor();

        currentFileName = tmpSelectedCustomMapFilename;

        insertCustomMapTerrainIntoGame(currentGame,mapObject);

        currentGame.firstSave = false;

        Scroll2d.forceSceneChange();
        
        setWeather();

        setMapType();
        createMapEditorSideber();
    }

    function startMapEditor() {
        currentGame = new Game(100,100,{
            "name":         "Map Editor",
            "disableTax":   false,
            "motherland":   "Map Editor",
            "motherlandid": 0,
            "mapType":      ColonyGame.mapTypes[0].name,
            "defaultRace":  ColonyGame.races[0].name,
            "civilization": ColonyGame.civilizations[0].name,
            "offline":      true,
            "mapEditorDummy": true
        });

        currentGame.cm = true;
        currentGame.offlineMode = true;
        currentGame.hasCheated = true;
        

        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        retainedUsage = {};

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;
        resourceUpdateTurn = true;
        shoreUpdateTurn = true;

        if(!currentGame.offlineMode) {
            isCreatingNewOnlineGame = true;

            establishSocketConnection();
            registerColonyId();
            
        }

        setupResourceLedger();

        setMapType();

        Scroll2d.setMapDims(100,100);

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedColonist = null;
        selectedPassable = null;

        pendingBuildX = null;
        pendingBuildY = null;
        queuedBuildings = undefined;
        queuedBuilding = null;
        queuedBuildingBlocked = false;
        
        createCollisionReference();
        
        var i,j;
        var firstBuilding = null;
        var buildingX = Math.floor(currentGame.width / 2);
        var buildingY = Math.floor(currentGame.height / 2);
    
        Scroll2d.setZoomLevel(1);
        Scroll2d.centerOnCoord(buildingX,buildingY);

        webAppCore.setTitleVisible(false);

        createCollisionReference();
        
        updateUtilityGrid();

        gooseUpColonistReferences();
        
        Scroll2d.forceSceneChange();

        Scroll2d.setZoomLevel(1);

        centerMap();
        setCenterMapIcon();

        titleShowing = false;

        setupMenuOptions();

        webAppCore.clearSplash();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        createSidebar();
        drawSidebar();
        
        initSoundtrack();

        Scroll2d.forceSceneChange();

        setWeather();

        currentFileName = null;
        editCustomMapMetaData();
    }

    function showTextureModMenu() {
        var menuOptions = [];
        
        menuOptions.push({
            "title":        getString("general-tex-mod-activate"),
            "description":  getString("tex-mod-activate-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "activate"
        });

        if(currentActiveTextureMod != null) {
            menuOptions.push({
                "title":        getString("general-tex-mod-deactivate"),
                "description":  getString("tex-mod-deactivate-desc"),
                "icon":         null,
                "status":       "Current Mod: " + currentActiveTextureMod,
                "overflow":     [
                    {
                        "post":  webAppCore.getVar("mod-name-ref-" + currentActiveTextureMod,"Custom Texture Mod")
                    },
                    {
                        "post":  "by " + webAppCore.getVar("mod-author-ref-" + currentActiveTextureMod,"unknown")
                    }
                ],
                "tag":          "deactivate"
            });
        }

        menuOptions.push({
            "title":        getString("general-tex-mod-import"),
            "description":  getString("tex-mod-import-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "import"
        });

        if(window.innerWidth > 500 && !webAppCore.isTV()) {
            menuOptions.push({
                "title":        getString("general-tex-mod-create"),
                "description":  getString("tex-mod-editor-desc"),
                "icon":         null,
                "status":       null,
                "overflow":     null,
                "tag":          "create"
            });
        }

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        showList(getString("general-texture-mods"),menuOptions,onTexModOptionSelected,getString("general-dismiss"));
    }

    function onTexModOptionSelected(result) {
        if(!result) {
            return;
        }

        if(result == "back") {
            showModdingMenu();
        }

        if(result == "import") {
            webAppCore.importFile(ColonyGame.meta.graphicsModFileFormat,onTexturePackImport);
        }

        if(result == "activate") {
            webAppCore.openListing(onTextureListingBack);
        }

        if(result == "deactivate") {
            webAppCore.showSplash("Deactivating mod...");
            webAppCore.storeVar("active-texture-mod","0");
            currentActiveTextureMod = null;
            currentModData = null;
            webAppCore.storeVar("mod-name-ref-" + currentActiveTextureMod,"0");
            webAppCore.storeVar("mod-author-ref-" + currentActiveTextureMod,"0"); 
            loadAssets();
        }

        if(result == "create") {
            webAppCore.showSplash("Loading Texture Editor...");
            webAppCore.navigateTo("texteditor.html");
        }
    }

    function onTexturePackImport(name,content) {
        if(!webAppCore.getIsPremium()) {
            showPremiumMessage(getString("general-texture-mods"));
            return;
        }

        try {
            JSON.stringify(content);
            pendingOpenTextureFileName = name;
            webAppCore.saveFile(name,content,function() {
                webAppCore.openFile(pendingOpenTextureFileName,onOpenTexturePackForActivation);
            },true);
        } catch(e) {
            console.log(e);
            webAppCore.showToast("Invalid mod!");
        }
    }

    function onTextureListingBack(data) {
        var menuOptions = [];
        
        for(var i = 0; i < data.length; i++) {
            if(endsWith(data[i],"." + ColonyGame.meta.graphicsModFileFormat)) {
                menuOptions.push({
                    "title": data[i],
                    "tag": data[i]
                });
            }
        }

        if(menuOptions.length == 0) {
            webAppCore.showToast("No installed mods!");
        } else {
            webAppCore.presentNativeList(getString("general-tex-mod-activate"),menuOptions,function(tag) {

                if(!tag) {
                    return;
                }

                if(!webAppCore.getIsPremium()) {
                    showPremiumMessage(getString("general-texture-mods"));
                    return;
                }

                pendingOpenTextureFileName = tag;
                webAppCore.openFile(tag,onOpenTexturePackForActivation);
            },webAppCore.getString("general-dismiss"));
        }
    }

    function onOpenTexturePackForActivation(data) {
        if(pendingOpenTextureFileName == null) {
            return;
        }

        if(!data || data.length == 0) {
            return;
        }

        if(!webAppCore.getIsPremium()) {
            showPremiumMessage(getString("general-texture-mods"));
            return;
        }

        webAppCore.storeVar("active-texture-mod",pendingOpenTextureFileName);
        currentActiveTextureMod = pendingOpenTextureFileName;

        try {
            currentModData = JSON.parse(data);
            webAppCore.storeVar("mod-name-ref-" + currentActiveTextureMod,currentModData.meta.name.trim());
            webAppCore.storeVar("mod-author-ref-" + currentActiveTextureMod,currentModData.meta.author.trim());    
            webAppCore.showSplash("Loading Texture Pack From " + pendingOpenTextureFileName);
        } catch(e) {
            console.log(e);
            currentActiveTextureMod = null;
            webAppCore.storeVar("active-texture-mod","0");
            currentModData = null;
        }

        loadAssets();
    }

    var pendingOpenTextureFileName = null;

    function centerMap() {

        if(currentGame.centerBuildingId == 0) {
            Scroll2d.centerOnCoord(Math.round(currentGame.width / 2),Math.round(currentGame.height / 2));
        } else {
            var centerbuilding = getBuildingById(currentGame.centerBuildingId);

            if(centerbuilding == null) {
                currentGame.centerBuildingId = 0;
                Scroll2d.centerOnCoord(Math.round(currentGame.width / 2),Math.round(currentGame.height / 2));
            } else {
                Scroll2d.centerOnCoord(centerbuilding.x,centerbuilding.y);
            }
        }

        
    }

    function setCenterMapIcon() {
        if(currentGame == null || currentGame.buildings.length == 0) {
            document.getElementById("imCenterMap").src = "images/" + ColonyGame.meta.centerMapIcon;
        } else {

            if(currentGame.centerBuildingId == 0) {
                currentGame.centerBuildingId = currentGame.buildings[0].id;
            }

            var centerbuilding = getBuildingById(currentGame.centerBuildingId);

            if(centerbuilding == null) {
                currentGame.centerBuildingId = 0;
                document.getElementById("imCenterMap").src = "images/" + ColonyGame.meta.centerMapIcon;
            } else {
                var centerDef = getBuildingDefByName(centerbuilding.def);
                var img = gameAssets[centerDef.tile[0]][0].image.src;
                document.getElementById("imCenterMap").src = img;
            }

            
        }
    }

    function loadVideoTutorials() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.videoTutorials.length; i++) {

            var status = ColonyGame.videoTutorials[i].url;
            var statusColor = "#2196F3";

            if(ColonyGame.videoTutorials[i].url.indexOf("https://www.youtube.com") == 0) {
                status = "on YouTube";
                statusColor = "#ff0000";
            }

            menuOptions.push({
                "title": ColonyGame.videoTutorials[i].title,
                "title-color": null,
                "description": "by " + ColonyGame.videoTutorials[i].author,
                "status": status,
                "status-color": statusColor,
                "icon": null,
                "tag": ColonyGame.videoTutorials[i]
            });
        }


        if(ColonyGame.meta.videoTutorialSubmissionUrl != null) {
            menuOptions.push({
                "title": getString("general-vid-sumbit"),
                "title-color": null,
                "description": getString("general-vid-submit-desc"),
                "status": ColonyGame.meta.videoTutorialSubmissionUrl,
                "status-color": "#2196F3",
                "icon": null,
                "tag": {"url": ColonyGame.meta.videoTutorialSubmissionUrl }
            });
        }

        showList(getString("general-vidtut-header"),menuOptions,onVideoTutorialSelected,getString("general-dismiss"));
    }

    function onVideoTutorialSelected(tag) {
        if(!tag) {
            return;
        }

        webAppCore.externalURL(tag.url);
    }

    function showNewObjectOptionsMenu(object,type,newPassableX,newPassableY) {

        if(type == "colonist") {
            showColonistStats(object);
            return;
        }

        document.getElementById("newObjectOptionsWindow").style.display = "block";
        newObjectOptionsOpen = true;

        var prop;

        document.getElementById("newObjectUpgradeOneSection").style.display = "none";
        document.getElementById("newObjectUpgradeAllSection").style.display = "none";
        document.getElementById("newObjectWorkersSection").style.display = "none";
        document.getElementById("newObjectConsumptionSection").style.display = "none";

        document.getElementById("newObjectResidentsSection").style.display = "none";
        document.getElementById("newObjectPatientsSection").style.display = "none";
        document.getElementById("newObjectGuestsSection").style.display = "none";
        document.getElementById("newObjectTouristsSection").style.display = "none";
        document.getElementById("newObjectStudentsSection").style.display = "none";
        document.getElementById("newObjectPrisonersSection").style.display = "none";
        

        document.getElementById("newObjectPassablePropertiesMainStat").innerHTML = "";
        document.getElementById("newObjectUpgradeCostHolder").innerHTML = "";
        document.getElementById("newObjectUpgradeChangesHolder").innerHTML = "";
        document.getElementById("newObjectUpgradeAllCostHolder").innerHTML = "";

        var thisDef = null;
        var totalcount = 0;
        var i,j,l;
        var upgrade = null;
        var colIndex = 0;

        if(type == "passable") {
            thisDef = passableTileRefs[object];
            
            var td = currentGame.finishedPassableNonUpdatables[object];
            for(i in td) {
                totalcount += td[i].length;
            }
        }

        if(type == "building") {
            thisDef = getBuildingDefByName(object.def);
            var blds = currentGame.buildings;

            for(i = 0, l = blds.length; i< l; i++) {
                if(blds[i].def == object.def) {
                    totalcount++;
                }
            }
        }

        if(type == "vehicle") {
            thisDef = getVehicleDefByName(object.def);
            var vhcs = currentGame.vehicles;

            for(i = 0, l = vhcs.length; i< l; i++) {
                if(vhcs[i].def == object.def) {
                    totalcount++;
                }
            }
        }



        document.getElementById("objectwindowName").innerHTML = thisDef.name;
        document.getElementById("newObjectPassablePropertiesName").innerHTML = thisDef.name;
        document.getElementById("newObjectPassablePropertiesMainStat").innerHTML = getString(thisDef.description);

        var useSpeed = 0;

        if(thisDef.driveSpeedMod != null) {
            useSpeed = thisDef.driveSpeedMod;
        }
        
        if(useSpeed > 0) {
            document.getElementById("newObjectPassablePropertiesMainStat").innerHTML += "<br />+" + useSpeed + " Movement Speed";
        }

        document.getElementById("newObjectPassablePropertiesMainCount").innerHTML = "Built: " + numberWithCommas(totalcount);



        if(type == "passable" || type == "building") {

            var useobj = object;

            if(type == "passable") {
                useobj = {"def":object};
            }

            var upgrade = isUpgradeAvailableForStructure(useobj);

            if(upgrade != null) {
                if(!canIBuildThis(upgrade.structure,"building")) {
                    upgrade = null;
                }
            }
        }

        var costColor,upgradeCostItem,upgradeCostImage,upgradeCostCost,upgradeCostName;


        if(upgrade != null) {
            document.getElementById("newPassableUpgradeTo").innerHTML = "to " + upgrade.structure.name;
            
            document.getElementById("newObjectUpgradeOneSection").style.display = "block";
            document.getElementById("newObjectUpgradeAllSection").style.display = "block";

            document.getElementById("newObjectDoUpgradeOldItem").src = gameAssets[thisDef.tile[0]][0].image.src;
            document.getElementById("newObjectDoUpgradeNewItem").src = gameAssets[upgrade.structure.tile[0]][0].image.src;

            var canAfford = true;
            var canAffordAll = true;

            for(prop in upgrade.cost) {

                if(upgrade.cost[prop] <= 0) {
                    continue;
                }

                // single
                costColor = null;

                if(upgrade.cost[prop] > currentGame.resources[prop].amount) {
                    canAfford = false;
                    costColor = "#F44336";
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                upgradeCostImage = document.createElement("img");
                upgradeCostImage.src = "images/" + getResourceByDefName(prop).icon;
                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);

                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = prop + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);

                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(upgrade.cost[prop]);
                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostCost.style.color = costColor;
                upgradeCostItem.appendChild(upgradeCostCost);

                document.getElementById("newObjectUpgradeCostHolder").appendChild(upgradeCostItem);


                // all 
                costColor = null;
                
                if(upgrade.cost[prop] * totalcount > currentGame.resources[prop].amount) {
                    canAffordAll = false;
                    costColor = "#F44336";
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                upgradeCostImage = document.createElement("img");
                upgradeCostImage.src = "images/" + getResourceByDefName(prop).icon;
                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);

                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = prop + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);

                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(upgrade.cost[prop] * totalcount);
                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostCost.style.color = costColor;
                upgradeCostItem.appendChild(upgradeCostCost);

                document.getElementById("newObjectUpgradeAllCostHolder").appendChild(upgradeCostItem);
                
            }

            if(canAfford) {
                document.getElementById("newObjectDoUpgradeEngage").onclick = function() {

                    if(type == "passable") {
                        var killItem = null;
                        
                        for(var ty = 0; ty < td[newPassableX].length; ty++) {
                            if(parseInt(td[newPassableX][ty]) == newPassableY) {
                                killItem = ty;
                                break;
                            }
                        }
    
                        if(killItem != null) {
                            td[newPassableX].splice(ty,1);
                            staticFrame = false;
                            Scroll2d.forceSceneChange();
                        }
    
                        conductBuildingUpgradeEngage(upgrade,parseInt(newPassableX),parseInt(newPassableY),"passable",currentGame.passableNonUpdatables);
                    } else {
                        conductUpgrade(object,upgrade,type);
                    }

                    

                    closeObjectOptionsMenu();
                };

                document.getElementById("newObjectDoUpgradeEngage").enabled = true;
            } else {
                document.getElementById("newObjectDoUpgradeEngage").onclick = null;
                document.getElementById("newObjectDoUpgradeEngage").enabled = false;
            }

            if(canAffordAll) {

                document.getElementById("newObjectDoUpgradeAllEngage").onclick = function() {

                    if(type == "passable") {
                        for(var dieX in td) {
                            while(td[dieX].length > 0) {
                                var dieY = td[dieX].shift();

                                conductBuildingUpgradeEngage(upgrade,parseInt(dieX),parseInt(dieY),"passable",currentGame.passableNonUpdatables);
                                
                            }
                        }
                    } else {
                        var doneUpgrading = false;
                        
                        while(!doneUpgrading) {
                            var useArray = currentGame.buildings;

                            for(var i = 0; i < useArray.length; i++) {
                                if(useArray[i].def == object.def) {
                                    upgrade = isUpgradeAvailableForStructure(useArray[i]);

                                    if(upgrade == null) {
                                        webAppCore.showToast("Insufficient Funds");
                                        doneUpgrading = true;
                                        break;
                                    } else {

                                        conductUpgrade(useArray[i],upgrade,type,true);
                                    }
                                }
                            }

                            doneUpgrading = true;

                        }

                        clearOutBuildMenu();

                        callForHireFlag = true;

                        updateUtilityGrid();
                    }

                    staticFrame = false;
                    Scroll2d.forceSceneChange();

                    closeObjectOptionsMenu();
                };

                

                document.getElementById("newObjectDoUpgradeAllEngage").enabled = true;
            } else {
                document.getElementById("newObjectDoUpgradeAllEngage").onclick = null;
                document.getElementById("newObjectDoUpgradeAllEngage").enabled = false;
            }
        }

        
        var productionCapacity = 1;

        if(currentTicksPerMinute < 20) {
            currentTicksPerMinute = 200;;
        }


        if(type == "building" && thisDef.acceptsWorkers > 0) {
            document.getElementById("newObjectWorkersSection").style.display = "block";
            document.getElementById("statObjectWorkersDataBreakdown").innerHTML = "";
            document.getElementById("statObjectWorkersListing").innerHTML = "";

            
            
            var allJobs = thisDef.acceptsWorkers;

            var offDuty = 0;
            var onDuty = 0;

            for(i = 0, l = object.workers.length; i < l; i++) {
                if(object.workers[i].isAtWork) {
                    onDuty++;
                } else {
                    offDuty++;
                }
            }

            allJobs -= object.workers.length;

            productionCapacity = onDuty / thisDef.acceptsWorkers;

            var chartItems = {
                "Vacant Jobs": allJobs,
                "Off Duty": offDuty,
                "On Duty":  onDuty
            };
            var chartColors = ["#D32F2F","#0D47A1","#1E88E5"];
    
            var myPiechart = new Piechart({
                canvas:document.getElementById("statObjectWorkersData"),
                data:chartItems,
                colors:chartColors
            });
            myPiechart.draw();

            colIndex = 0;

            for(var prop in chartItems) {

                if(chartItems[prop] == 0) {
                    colIndex++;
                    continue;
                }
 
                var item = document.createElement("p");

                item.innerHTML = prop + ": " + numberWithCommas(chartItems[prop]);
                item.style.color = chartColors[colIndex];
                document.getElementById("statObjectWorkersDataBreakdown").appendChild(item);
    
                colIndex++;
            }

            document.getElementById("newObjectShowWorkers").onclick = function() {
                showWorkersForBuilding(object);
            };
        }


        // consumption
        if(type == "building") {

            var consumptionItems = {
                consumption: {},
                production: {}
            };

            document.getElementById("newObjectConsumptionSection").style.display = "block";

            if(object.deactivated) {
                document.getElementById("newObjectActiveIndication").innerHTML = "Deactivated";
                document.getElementById("newObjectActiveIndication").style.color = "#F44336";
            } else {
                document.getElementById("newObjectActiveIndication").innerHTML = "Activated";
                document.getElementById("newObjectActiveIndication").style.color = "#4CAF50";
            }

            document.getElementById("newObjectConsumptionSectionConsumptionDeets").innerHTML = "";
            document.getElementById("newObjectConsumptionSectionProductionDeets").innerHTML = "";


            if(thisDef.requiresUtility != null) {
                for(i = 0; i < thisDef.requiresUtility.length; i++) {

                    

                    var utilcstitem = thisDef.requiresUtility[i];

                    if(!consumptionItems.consumption[utilcstitem.utility]) {
                        consumptionItems.consumption[utilcstitem.utility] = {
                            amount: 0,
                            append: null,
                            type: "util"
                        };
                    }


                    consumptionItems.consumption[utilcstitem.utility].amount += utilcstitem.amount;

                }
            }

            if(thisDef.providesUtility != null) {
                for(i = 0; i < thisDef.providesUtility.length; i++) {
                    

                    var utilcstitem = thisDef.providesUtility[i];

                    if(!consumptionItems.production[utilcstitem.utility]) {
                        consumptionItems.production[utilcstitem.utility] = {
                            amount: 0,
                            append: null,
                            type: "util"
                        };
                    }

                    consumptionItems.production[utilcstitem.utility].amount += utilcstitem.amount;

                }
            }

            if(thisDef.smelts != null) {
                var countsPerTick = buildingUpdateCycles;

                if(object.requiresWorkers) {
                    countsPerTick = 0;
                }

                for(i = 0; i < object.howManyWorking; i++) {
                    countsPerTick += buildingUpdateCycles;
                }

                var ticksUntilSmelt = thisDef.smelts.time / countsPerTick;
                var smeltsPerMinute = currentTicksPerMinute / ticksUntilSmelt;

                var smeltItems = thisDef.smelts.input.split(",");

                for(i = 0; i < smeltItems.length; i++) {

                    if(!consumptionItems.consumption[smeltItems[i]]) {
                        consumptionItems.consumption[smeltItems[i]] = {
                            amount: 0,
                            append: " / minute",
                            type: "res"
                        };
                    }

                    consumptionItems.consumption[smeltItems[i]].amount += smeltsPerMinute;

                }

                if(thisDef.smelts.output != null) {
                    var outputResourceAll = thisDef.smelts.output.split("|");
                    var totalOutputPerMinute = thisDef.smelts.ratio * smeltsPerMinute;
                    var smeltPerItemChance = totalOutputPerMinute / outputResourceAll.length;
                    
                    for(i = 0; i < outputResourceAll.length; i++) {


                        if(!consumptionItems.production[outputResourceAll[i]]) {
                            consumptionItems.production[outputResourceAll[i]] = {
                                amount: 0,
                                append: " / minute",
                                type: "res"
                            };
                        }
    
                        consumptionItems.production[outputResourceAll[i]].amount += smeltPerItemChance;

                    }
                }
            }

            if(thisDef.requiresFuel != null) {
                var ticksUntilConsumption = thisDef.requiresFuel.rate / buildingUpdateCycles;
                var consumptionPerMinute = currentTicksPerMinute / ticksUntilConsumption;

                var fuelRequirements = thisDef.requiresFuel.resource.split(",");

                for(i = 0; i < fuelRequirements.length; i++) {

                    if(!consumptionItems.consumption[fuelRequirements[i]]) {
                        consumptionItems.consumption[fuelRequirements[i]] = {
                            amount: 0,
                            append: " / minute",
                            type: "res"
                        };
                    }

                    consumptionItems.consumption[fuelRequirements[i]].amount += consumptionPerMinute;

                }
            }

            if(object.generates != null) {

                var genCyclesToUse = buildingUpdateCycles;

                if(thisDef.requiresWorkers > 0) {
                    genCyclesToUse = buildingUpdateCycles * object.howManyWorking;
                }

                var ticksUntilConsumption = object.generateCounter / genCyclesToUse;
                var consumptionPerMinute = currentTicksPerMinute / ticksUntilConsumption;

                if(!consumptionItems.production[object.generates]) {
                    consumptionItems.production[object.generates] = {
                        amount: 0,
                        append: " / minute",
                        type: "res"
                    };
                }

                consumptionItems.production[object.generates].amount += consumptionPerMinute;
            }

            for(var ci in consumptionItems.consumption) {

                if(object.deactivated) {
                    consumptionItems.consumption[ci].amount = 0;
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                
    
                upgradeCostImage = document.createElement("img");

                if(consumptionItems.consumption[ci].type == "util") {
                    upgradeCostImage.src = "images/" + getUtilityByDefName(ci).icon;
                } else {
                    upgradeCostImage.src = "images/" + getResourceByDefName(ci).icon;
                }

                
                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);
    
                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = ci + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);
    
                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(consumptionItems.consumption[ci].amount);

                if(consumptionItems.consumption[ci].append != null) {
                    upgradeCostCost.innerHTML += consumptionItems.consumption[ci].append;
                }

                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostItem.appendChild(upgradeCostCost);
    
                document.getElementById("newObjectConsumptionSectionConsumptionDeets").appendChild(upgradeCostItem);
            }

            for(var pi in consumptionItems.production) {

                if(object.deactivated) {
                    consumptionItems.production[pi].amount = 0;
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                
    
                upgradeCostImage = document.createElement("img");
                
                if(consumptionItems.production[pi].type == "util") {
                    upgradeCostImage.src = "images/" + getUtilityByDefName(pi).icon;
                } else {
                    upgradeCostImage.src = "images/" + getResourceByDefName(pi).icon;
                }

                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);
    
                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = pi + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);
    
                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(consumptionItems.production[pi].amount);

                if(consumptionItems.production[pi].append != null) {
                    upgradeCostCost.innerHTML += consumptionItems.production[pi].append;
                }

                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostItem.appendChild(upgradeCostCost);
    
                document.getElementById("newObjectConsumptionSectionProductionDeets").appendChild(upgradeCostItem);
            }


            if(object.deactivated) {
                //document.getElementById("objectActivation").className = null;
                //document.getElementById("objectActivationIcon").src = "images/" + ColonyGame.meta.indActivateBld;
                //document.getElementById("objectActivationIcon").title = getString("general-activate");

                document.getElementById("objectActivationAll").className = null;
                document.getElementById("objectActivationAll").innerHTML = getString("general-activate-all");
            } else {
                //document.getElementById("objectActivation").className = "dismiss";
               // document.getElementById("objectActivationIcon").src = "images/" + ColonyGame.meta.indDeactivateBld;
                //document.getElementById("objectActivationIcon").title = getString("general-deactivate");

                document.getElementById("objectActivationAll").className = "dismiss";
                document.getElementById("objectActivationAll").innerHTML = getString("general-deactivate-all");
            }

            document.getElementById("objectActivationAll").onclick = function() {
                document.getElementById("objectOptions").style.display = "none";
                var setStatus = !object.deactivated;

                for(var i = 0; i < currentGame.buildings.length; i++) {
                    if(currentGame.buildings[i].def == object.def) {
                        currentGame.buildings[i].deactivated = setStatus;
                    }
                }
                
                updateUtilityGrid();

                staticFrame = false;
                Scroll2d.forceSceneChange();

                closeObjectOptionsMenu();
            };
        }
    }

    function conductBuildingUpgradeEngage(to,x,y,type,arrayToUse) {
        var firstBuilding = new Building(to.structure,x,y,0);
        firstBuilding.isUnderConstruction = true;

        constructionProjectsArray.push(firstBuilding);

        arrayToUse.push(firstBuilding);

        if(type == "building") {
            updateUtilityGrid();
            updateBuildingCollisionPoints(firstBuilding,150);
        }

        firstBuilding.c = new ConstructionItem();


        firstBuilding.c.c = 0;
        firstBuilding.c.p = 0;
        firstBuilding.c.t = 0;
        firstBuilding.c.pr = {};

        for(var res in to.cost) {

            firstBuilding.c.pr[res] = to.cost[res];
            firstBuilding.c.t += to.cost[res];

        }

        callNearbyBuilders(firstBuilding.x,firstBuilding.y,0);

        staticFrame = false;
        Scroll2d.forceSceneChange();
    }

    function fetchReleaseNotes() {

        if(ColonyGame.meta.releaseNotesServer == null) {
            return;
        }

        var notesUrl = ColonyGame.meta.releaseNotesServer + ColonyGame.meta.releaseCode + ".php";

        webAppCore.getForResult(notesUrl, null, onReleaseNotes);
    }

    function onReleaseNotes(data) {
        if(!data || data.trim().length == 0 || data.indexOf("###") == -1) {
            return;
        }

        webAppCore.storeVar("release-notes-" + ColonyGame.meta.releaseCode,"1");

        var noteParts = data.trim().split("###");

        var releaseObject = {
            "title":    ColonyGame.meta.name + " v" + ColonyGame.meta.buildVersion,
            "message":  noteParts[0]
        };

        if(webAppCore.isTV()) {
            releaseObject.op1 = {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            };
        } else {

            releaseObject.op1 = {
                "text":     "Release Notes",
                "func":     function() {
                    webAppCore.externalURL(noteParts[1]);
                }
            };

            releaseObject.op2 = {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            };
        }



        webAppCore.showDialog(releaseObject);
    }

    function showDesktopBuildConfirm() {

        if(queuedBuildings == null) {
            return;
        }

        document.getElementById("touchBuildConfirm").style.display = "none";
        document.getElementById("desktopBuildConfirm").style.display = "block";

        document.getElementById("desktopBuildConfirmHeader").innerHTML = queuedBuilding.name;

        var buildCount = queuedBuildings.length + 1;

        if(buildCount > 1) {
            document.getElementById("desktopBuildConfirmHeader").innerHTML += " x" + buildCount;
        }

        document.getElementById("desktopBuildConfirmCosts").innerHTML = "";
        var cost = [];
        var costColor,j,def;

        for(j = 0; j < queuedBuilding.cost.length; j++) {
            
            def = getResourceByDefName(queuedBuilding.cost[j].resource);

            costColor = null;

            if((queuedBuilding.cost[j].amount * buildCount)> currentGame.resources[queuedBuilding.cost[j].resource].amount) {
                costColor = "#F44336";
            }

            cost.push({
                pre:    "花费:",
                post:   def.indicator + numberWithCommas((queuedBuilding.cost[j].amount * buildCount)),
                color:  costColor,
                icon:   "images/" + def.icon
            });
        }


        for(j = 0; j < cost.length; j++) {
            
            var overflowItem = cost[j];
            
            var optionCostSpan = document.createElement("span");
            optionCostSpan.innerHTML = overflowItem.pre + " <img src=\"" + overflowItem.icon + "\" /> " + overflowItem.post;
            optionCostSpan.className = "infoboxOptionCost";
            if(overflowItem.color != null) {
                optionCostSpan.style.color = overflowItem.color;
            }
            document.getElementById("desktopBuildConfirmCosts").appendChild(optionCostSpan);
        }

    }

    function closeObjectOptionsAndClear() {
        selectedBuilding = null;

        if(!inHireMode) {
            selectedColonist = null;
        }

        drawSidebar();

        selectedVehicle = [];
        document.getElementById("objectOptions").style.display = "none";
    }

    var silosNeededCooldown = 0;
    
    function notifySilosNeeded(resource,forCapacity) {

        if(silosNeededCooldown > 0) {
            return;
        }

        silosNeededCooldown = 1500;

        var highestOption = null;
        var refines = false;

        for(var i = 0, len = ColonyGame.buildings.length; i < len; i++) {

            

            

            refines = false;

            if(forCapacity) {

                if(ColonyGame.buildings[i].stores == null) {
                    continue;
                }

                for(var j = 0; j < ColonyGame.buildings[i].stores.length; j++) {
                    if(ColonyGame.buildings[i].stores[j].resource == resource) {
                        refines = true;
                        break;
                    }
                }
            } else {

                if(ColonyGame.buildings[i].refines == null) {
                    continue;
                }

                for(var j = 0; j < ColonyGame.buildings[i].refines.length; j++) {
                    if(ColonyGame.buildings[i].refines[j].input == resource) {
                        refines = true;
                        break;
                    }
                }
            }

            

            if(!refines) {
                continue;
            }

            if(canIBuildThis(ColonyGame.buildings[i],"building")) {
                highestOption = ColonyGame.buildings[i];
            }
        }

        if(highestOption != null) {

            var img = gameAssets[highestOption.tile[0]][0].image.src;

            webAppCore.showToast({
                "message":      highestOption.name + " needed!",
                "image":        img
            });
        }
    }

    function postSecuredCallToApi(data,func,callback) {
        if(currentGame == null || !currentGame.colonyId || currentGame.colonyId == 0) {
            return;
        }

        data.push({
            "key":      "f",
            "value":    func
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "i",
            "value":    currentGame.colonyId
        });

        data.push({
            "key":      "k",
            "value":    currentGame.apiKey
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, callback);
    }

    function createRiver(type,position) {
        var terrainDef = getTerrainDefByName(type);

        var sX = randomIntFromInterval(0,1);
        var sY = randomIntFromInterval(20,currentGame.height - 21);

        if(position != null) {
            if(position == "bottom") {
                sY = randomIntFromInterval(currentGame.height - 25,currentGame.height);
            }

            if(position == "top") {
                sY = randomIntFromInterval(0,25);
            }
        }

        var endX = currentGame.width - 1;
        var direction = 1;
        var wantedDirection = 1;
        
        var i,x,y,j,resourceItem,byWater,isSurrounded,transformChance;
        
        if(sX == 1) {
            sX = currentGame.width - 1;
            endX = 0;
            direction = 3;
            wantedDirection = 3;
        }
        
        var riverPoints = [];
        riverPoints.push({
            "x": sX,
            "y": sY
        });

        var endReached = false;
        
        while(!endReached && riverPoints.length < 500) {
            
            var directionChange = randomIntFromInterval(0,8);
            
            if(directionChange == 1) {
                direction = randomIntFromInterval(0,4);
                
                if(direction == 4) {
                    direction = wantedDirection;
                }
            }
            
            var newPosition = {
                "x": riverPoints[riverPoints.length - 1].x,
                "y": riverPoints[riverPoints.length - 1].y
            };
            
            if(direction == 0 && newPosition.y > 0) {
                newPosition.y--;
            }
            
            if(direction == 1 && newPosition.x < currentGame.width - 1) {
                newPosition.x++;
            }
            
            if(direction == 2 && newPosition.y < currentGame.height - 1) {
                newPosition.y++;
            }
            
            if(direction == 3 && newPosition.x > 0) {
                newPosition.x--;
            }
            
            riverPoints.push(newPosition);
            
            if(newPosition.x == endX) {
                endReached = true;
            }
        }

        for(i = 0; i < riverPoints.length; i++) {

            if(isTilePassable(riverPoints[i].x,riverPoints[i].y,true)) {
                resourceItem = new MapResource(terrainDef,riverPoints[i].x,riverPoints[i].y);
                freeRefNukeTurn = true;
                updateBuildingCollisionPoints(resourceItem,150);
                currentGame.mapResources.push(resourceItem);
                shoreUpdateTurn = true;
            }

            

        }

        for(i = 0; i < 30; i++) {
            for(j = 0; j < currentGame.mapResources.length; j++) {
                if(currentGame.mapResources[j].def == type) {
                    var surrounding = getSurroundingSameTerrains(currentGame.mapResources[j]);

                    transformChance = randomIntFromInterval(1,15);

                    if(transformChance == 2 && surrounding.top == null) {
                        if(isTilePassable(currentGame.mapResources[j].x,currentGame.mapResources[j].y - 1,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x,currentGame.mapResources[j].y - 1);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }

                    if(transformChance == 3 && surrounding.down == null) {
                        if(isTilePassable(currentGame.mapResources[j].x,currentGame.mapResources[j].y + 1,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x,currentGame.mapResources[j].y + 1);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }

                    if(transformChance == 4 && surrounding.left == null) {
                        if(isTilePassable(currentGame.mapResources[j].x - 1,currentGame.mapResources[j].y,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x - 1,currentGame.mapResources[j].y);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }

                    if(transformChance == 5 && surrounding.right == null) {
                        if(isTilePassable(currentGame.mapResources[j].x + 1,currentGame.mapResources[j].y,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x + 1,currentGame.mapResources[j].y);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }
                }
            }
        }
    }

    function packBuilding(building) {
        var muhDef = getBuildingDefByName(building.def);

        if(muhDef.packsTo != null) {
            var packsToDef = getVehicleDefByName(muhDef.packsTo);

            building.isBeingRemoved = true;

            var freshVehicle = new Vehicle(packsToDef,building.x,building.y,0);
            currentGame.vehicles.push(freshVehicle); 


            updateUtilityGrid();

            selectedBuilding = null;
            selectedVehicle = [freshVehicle];
            showOptionsForObject(selectedVehicle,"vehicle",true);
        }
    }

    function deployBuilding(unit) {

        if(!unit) {
            return;
        }

        var vDef = getVehicleDefByName(unit.def);
        var building = getBuildingDefByName(vDef.deploysTo);

        if(!building) {
            return;
        }

        if(unit.lv.length > 0) {
            if(!deployLoadedUnits(unit)) {
                return;
            }
        }

        selectedVehicle = [];

        var spaceClear = true;

        for(var oX = 0; oX < unit.pd.tileWidth; oX++) {
            for(var oY = 0; oY < unit.pd.tileHeight; oY++) {
                var useX = unit.x + oX;
                var useY = unit.y + oY;

                if(!isTilePassable(useX,useY,true,false)) {
                    spaceClear = false;
                }
            }
        }

        if(!spaceClear) {
            webAppCore.showToast("Cannot deploy here.");
            return;
        }

        var freshBuilding = new Building(building,unit.x,unit.y,0);
        currentGame.buildings.push(freshBuilding);
        updateBuildingCollisionPoints(freshBuilding,150);

        removeFromArray(currentGame.vehicles,unit);
        document.getElementById("objectOptions").style.display = "none";

        if(building.acceptsWorkers > 0) {
            callForHireFlag = true;
        }

        selectedBuilding = freshBuilding;


        if(building.providesShelter > 0) {
            callForHousingFlag = true;
        }

        updateUtilityGrid();

        if(!building.passable) {
            drawSidebar();
        }

        showOptionsForObject(freshBuilding,"building",true);
    }

    function destroyAtTile(bx,by,w,h,explode) {

        var i,j,x,y;

        for(x = bx; x < bx + w; x++) {

            for(y = by; y < by + h; y++) {

                // vehicles 
                for(i = 0; i < currentGame.vehicles.length; i++) {
                    if(currentGame.vehicles[i].x == x && currentGame.vehicles[i].y == y) {
                        destroyVehicle(currentGame.vehicles[i]);
                    }
                }

                // colonists 
                for(i = 0; i < currentGame.colonists.length; i++) {
                    if(currentGame.colonists[i].x == x && currentGame.colonists[i].y == y) {
                        currentGame.colonists[i].health = 0;
                    }
                }

                // buildings 
                for(i = 0; i < currentGame.buildings.length; i++) {
                    if(currentGame.buildings[i].condition > 0 && currentGame.buildings[i].occupiesTiles) {
                        for(j = 0; j < currentGame.buildings[i].occupiesTiles.length; j++) {
                            if(currentGame.buildings[i].occupiesTiles[j].x == x && currentGame.buildings[i].occupiesTiles[j].y == y) {
                                currentGame.buildings[i].condition = -1;
                                break;
                            }
                        }
                    }
                }

                var killItem = null;

                // passables 
                for(var passdef in currentGame.finishedPassableNonUpdatables) {
                    var td = currentGame.finishedPassableNonUpdatables[passdef];

                    if(td[x]) {
                        var tx = td[x];

                        for(var ty = 0; ty < tx.length; ty++) {
                            if(parseInt(tx[ty]) == y) {
                                killItem = ty;
                                break;
                            }
                        }

                        if(killItem != null) {
                            tx.splice(ty,1);
                            if(explode && allowParticleEffects) {
                                Scroll2d.playParticleEffect("explosion",x,y);
                            }
                            staticFrame = false;
                            Scroll2d.forceSceneChange();
                        }
                    }

                }

                // resources 
                for(i = 0; i < currentGame.mapResources.length; i++) {
                    
                    if(currentGame.mapResources[i].occupiesTiles == null) {
                        continue;
                    }
                    
                    for(j = 0; j < currentGame.mapResources[i].occupiesTiles.length; j++) {
                        if(currentGame.mapResources[i].occupiesTiles[j].x == x && currentGame.mapResources[i].occupiesTiles[j].y == y) {
                            destroyResource(currentGame.mapResources[i],false,explode);
                            break;
                        }
                    }
                    
                }
            }
        }
    }

    function playDisaster(dName) {

        if(!currentGame) {
            return;
        }

        var i;

        var disaster = null;


        if(workingMapType == null) {
            return;
        }

        for(i = 0; i < workingMapType.explosionDisasters.length; i++) {
            if(workingMapType.explosionDisasters[i].name == dName) {
                disaster = workingMapType.explosionDisasters[i];
                break;
            }
        }


        if(disaster == null) {
            return;
        }

        currentGame.disasterCounters[dName] = randomIntFromInterval(0,disaster.frequency);

        var epicenterX = randomIntFromInterval(2,currentGame.width - 2);
        var epicenterY = randomIntFromInterval(2,currentGame.height - 2);

        var blastRadius = shuffleArray(getAllSpacesAroundTile(epicenterX,epicenterY,disaster.radius));

        var resourceItem;

        for(i = 0; i < disaster.elements.length; i++) {

            if(blastRadius.length == 0) {
                break;
            }

            var newterrain = getTerrainDefByName(disaster.elements[i].terrain);

            if(newterrain == null) {
                continue;
            }

            for(var j = 0; j < disaster.elements[i].abundance; j++) {

                if(blastRadius.length == 0) {
                    break;
                }

                var epicenter = blastRadius.shift();

                destroyAtTile(epicenter[0],epicenter[1],newterrain.tileWidth,newterrain.tileHeight,true);

                resourceItem = new MapResource(newterrain,epicenter[0],epicenter[1]);
                freeRefNukeTurn = true;
                updateBuildingCollisionPoints(resourceItem,150);
                currentGame.mapResources.push(resourceItem);
                shoreUpdateTurn = true;
            }
        }
    }

    function editCustomMapMetaData() {

        document.getElementById("customMapMetaDataEntry").style.display = "block";

        document.getElementById("customMapMetaNameInput").value = currentGame.mename;

        document.getElementById("customMapMetaAuthorInput").value = currentGame.meauthor;
        document.getElementById("customMapMetaDescriptionInput").value = currentGame.medescription;

    }
})();
